#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 3212
#define LARGE_STATE_COUNT 624
#define SYMBOL_COUNT 309
#define ALIAS_COUNT 8
#define TOKEN_COUNT 142
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 38
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  sym_jsx_text = 48,
  sym_jsx_identifier = 49,
  anon_sym_DOT = 50,
  anon_sym_class = 51,
  anon_sym_async = 52,
  anon_sym_function = 53,
  anon_sym_EQ_GT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_QMARK = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_GT_GT = 72,
  anon_sym_GT_GT_GT = 73,
  anon_sym_LT_LT = 74,
  anon_sym_AMP = 75,
  anon_sym_CARET = 76,
  anon_sym_PIPE = 77,
  anon_sym_PLUS = 78,
  anon_sym_DASH = 79,
  anon_sym_PERCENT = 80,
  anon_sym_STAR_STAR = 81,
  anon_sym_LT_EQ = 82,
  anon_sym_EQ_EQ = 83,
  anon_sym_EQ_EQ_EQ = 84,
  anon_sym_BANG_EQ = 85,
  anon_sym_BANG_EQ_EQ = 86,
  anon_sym_GT_EQ = 87,
  anon_sym_instanceof = 88,
  anon_sym_BANG = 89,
  anon_sym_TILDE = 90,
  anon_sym_void = 91,
  anon_sym_delete = 92,
  anon_sym_PLUS_PLUS = 93,
  anon_sym_DASH_DASH = 94,
  anon_sym_DQUOTE = 95,
  aux_sym_string_token1 = 96,
  anon_sym_SQUOTE = 97,
  aux_sym_string_token2 = 98,
  sym_escape_sequence = 99,
  sym_comment = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_DOLLAR_LBRACE = 102,
  anon_sym_SLASH2 = 103,
  sym_regex_pattern = 104,
  sym_regex_flags = 105,
  sym_number = 106,
  anon_sym_target = 107,
  sym_this = 108,
  sym_super = 109,
  sym_true = 110,
  sym_false = 111,
  sym_null = 112,
  sym_undefined = 113,
  anon_sym_AT = 114,
  anon_sym_static = 115,
  anon_sym_abstract = 116,
  anon_sym_get = 117,
  anon_sym_set = 118,
  anon_sym_declare = 119,
  anon_sym_public = 120,
  anon_sym_private = 121,
  anon_sym_protected = 122,
  anon_sym_module = 123,
  anon_sym_any = 124,
  anon_sym_number = 125,
  anon_sym_boolean = 126,
  anon_sym_string = 127,
  anon_sym_symbol = 128,
  anon_sym_require = 129,
  anon_sym_implements = 130,
  anon_sym_global = 131,
  anon_sym_interface = 132,
  anon_sym_extends = 133,
  anon_sym_enum = 134,
  sym_readonly = 135,
  anon_sym_is = 136,
  anon_sym_keyof = 137,
  anon_sym_LBRACE_PIPE = 138,
  anon_sym_PIPE_RBRACE = 139,
  sym__automatic_semicolon = 140,
  sym__template_chars = 141,
  sym_program = 142,
  sym_export_statement = 143,
  sym_export_clause = 144,
  sym__import_export_specifier = 145,
  sym__declaration = 146,
  sym_import = 147,
  sym_import_statement = 148,
  sym_import_clause = 149,
  sym__from_clause = 150,
  sym_namespace_import = 151,
  sym_named_imports = 152,
  sym_expression_statement = 153,
  sym_variable_declaration = 154,
  sym_lexical_declaration = 155,
  sym_variable_declarator = 156,
  sym_statement_block = 157,
  sym_if_statement = 158,
  sym_switch_statement = 159,
  sym_for_statement = 160,
  sym_for_in_statement = 161,
  sym__for_header = 162,
  sym_while_statement = 163,
  sym_do_statement = 164,
  sym_try_statement = 165,
  sym_with_statement = 166,
  sym_break_statement = 167,
  sym_continue_statement = 168,
  sym_debugger_statement = 169,
  sym_return_statement = 170,
  sym_throw_statement = 171,
  sym_empty_statement = 172,
  sym_labeled_statement = 173,
  sym_switch_body = 174,
  sym_switch_case = 175,
  sym_switch_default = 176,
  sym_catch_clause = 177,
  sym_finally_clause = 178,
  sym_parenthesized_expression = 179,
  sym__expression = 180,
  sym_yield_expression = 181,
  sym_object = 182,
  sym_assignment_pattern = 183,
  sym_array = 184,
  sym_jsx_element = 185,
  sym_jsx_fragment = 186,
  sym_jsx_expression = 187,
  sym_jsx_opening_element = 188,
  sym_nested_identifier = 189,
  sym_jsx_namespace_name = 190,
  sym_jsx_closing_element = 191,
  sym_jsx_self_closing_element = 192,
  sym_jsx_attribute = 193,
  sym_class = 194,
  sym_class_declaration = 195,
  sym_class_heritage = 196,
  sym_function = 197,
  sym_function_declaration = 198,
  sym_generator_function = 199,
  sym_generator_function_declaration = 200,
  sym_arrow_function = 201,
  sym__call_signature = 202,
  sym_call_expression = 203,
  sym_new_expression = 204,
  sym_await_expression = 205,
  sym_member_expression = 206,
  sym_subscript_expression = 207,
  sym_assignment_expression = 208,
  sym_augmented_assignment_expression = 209,
  sym__initializer = 210,
  sym_spread_element = 211,
  sym_ternary_expression = 212,
  sym_binary_expression = 213,
  sym_unary_expression = 214,
  sym_update_expression = 215,
  sym_sequence_expression = 216,
  sym_string = 217,
  sym_template_string = 218,
  sym_template_substitution = 219,
  sym_regex = 220,
  sym_meta_property = 221,
  sym_arguments = 222,
  sym_decorator = 223,
  sym_decorator_member_expression = 224,
  sym_decorator_call_expression = 225,
  sym_class_body = 226,
  sym_public_field_definition = 227,
  sym_formal_parameters = 228,
  sym_rest_parameter = 229,
  sym_method_definition = 230,
  sym_pair = 231,
  sym__property_name = 232,
  sym_computed_property_name = 233,
  sym_non_null_expression = 234,
  sym_method_signature = 235,
  sym_abstract_method_signature = 236,
  sym_function_signature = 237,
  sym_as_expression = 238,
  sym_import_require_clause = 239,
  sym_implements_clause = 240,
  sym_ambient_declaration = 241,
  sym_abstract_class_declaration = 242,
  sym_module = 243,
  sym_internal_module = 244,
  sym__module = 245,
  sym_import_alias = 246,
  sym_nested_type_identifier = 247,
  sym_interface_declaration = 248,
  sym_extends_clause = 249,
  sym_enum_declaration = 250,
  sym_enum_body = 251,
  sym_enum_assignment = 252,
  sym_type_alias_declaration = 253,
  sym_accessibility_modifier = 254,
  sym_required_parameter = 255,
  sym_optional_parameter = 256,
  sym__parameter_name = 257,
  sym_type_annotation = 258,
  sym__type = 259,
  sym_constructor_type = 260,
  sym__primary_type = 261,
  sym_generic_type = 262,
  sym_type_predicate = 263,
  sym_type_query = 264,
  sym_index_type_query = 265,
  sym_lookup_type = 266,
  sym_mapped_type_clause = 267,
  sym_literal_type = 268,
  sym__number = 269,
  sym_existential_type = 270,
  sym_flow_maybe_type = 271,
  sym_parenthesized_type = 272,
  sym_predefined_type = 273,
  sym_type_arguments = 274,
  sym_object_type = 275,
  sym_call_signature = 276,
  sym_property_signature = 277,
  sym_type_parameters = 278,
  sym_type_parameter = 279,
  sym_default_type = 280,
  sym_constraint = 281,
  sym_construct_signature = 282,
  sym_index_signature = 283,
  sym_array_type = 284,
  sym_tuple_type = 285,
  sym_union_type = 286,
  sym_intersection_type = 287,
  sym_function_type = 288,
  aux_sym_program_repeat1 = 289,
  aux_sym_export_statement_repeat1 = 290,
  aux_sym_export_clause_repeat1 = 291,
  aux_sym_named_imports_repeat1 = 292,
  aux_sym_variable_declaration_repeat1 = 293,
  aux_sym_switch_body_repeat1 = 294,
  aux_sym_object_repeat1 = 295,
  aux_sym_array_repeat1 = 296,
  aux_sym_jsx_element_repeat1 = 297,
  aux_sym_jsx_opening_element_repeat1 = 298,
  aux_sym_string_repeat1 = 299,
  aux_sym_string_repeat2 = 300,
  aux_sym_template_string_repeat1 = 301,
  aux_sym_class_body_repeat1 = 302,
  aux_sym_formal_parameters_repeat1 = 303,
  aux_sym_implements_clause_repeat1 = 304,
  aux_sym_extends_clause_repeat1 = 305,
  aux_sym_enum_body_repeat1 = 306,
  aux_sym_object_type_repeat1 = 307,
  aux_sym_type_parameters_repeat1 = 308,
  alias_sym_array_pattern = 309,
  alias_sym_export_specifier = 310,
  alias_sym_import_specifier = 311,
  alias_sym_object_pattern = 312,
  alias_sym_property_identifier = 313,
  alias_sym_shorthand_property_identifier = 314,
  alias_sym_statement_identifier = 315,
  alias_sym_type_identifier = 316,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH2,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_enum] = anon_sym_enum,
  [sym_readonly] = sym_readonly,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_clause] = sym_extends_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_type_annotation] = sym_type_annotation,
  [sym__type] = sym__type,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_jsx_opening_element_repeat1] = aux_sym_jsx_opening_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_export_specifier] = alias_sym_export_specifier,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_module = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_return_type = 32,
  field_right = 33,
  field_source = 34,
  field_type = 35,
  field_type_arguments = 36,
  field_type_parameters = 37,
  field_value = 38,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[190] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 1},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 27, .length = 2},
  [28] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 33, .length = 2},
  [32] = {.index = 31, .length = 2},
  [33] = {.index = 33, .length = 2},
  [34] = {.index = 31, .length = 2},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 2},
  [38] = {.index = 39, .length = 3},
  [41] = {.index = 42, .length = 1},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 2},
  [46] = {.index = 51, .length = 1},
  [47] = {.index = 52, .length = 1},
  [48] = {.index = 53, .length = 1},
  [49] = {.index = 54, .length = 1},
  [50] = {.index = 55, .length = 2},
  [52] = {.index = 57, .length = 1},
  [53] = {.index = 58, .length = 2},
  [54] = {.index = 60, .length = 4},
  [55] = {.index = 64, .length = 2},
  [56] = {.index = 64, .length = 2},
  [57] = {.index = 22, .length = 2},
  [58] = {.index = 25, .length = 2},
  [59] = {.index = 27, .length = 2},
  [60] = {.index = 66, .length = 3},
  [61] = {.index = 10, .length = 2},
  [62] = {.index = 55, .length = 2},
  [63] = {.index = 69, .length = 3},
  [64] = {.index = 22, .length = 2},
  [65] = {.index = 22, .length = 2},
  [66] = {.index = 72, .length = 2},
  [67] = {.index = 74, .length = 4},
  [68] = {.index = 78, .length = 3},
  [69] = {.index = 81, .length = 2},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 1},
  [72] = {.index = 85, .length = 1},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 22, .length = 2},
  [75] = {.index = 88, .length = 2},
  [76] = {.index = 90, .length = 5},
  [77] = {.index = 86, .length = 2},
  [78] = {.index = 95, .length = 1},
  [79] = {.index = 96, .length = 3},
  [80] = {.index = 96, .length = 3},
  [81] = {.index = 96, .length = 3},
  [82] = {.index = 99, .length = 2},
  [83] = {.index = 101, .length = 3},
  [87] = {.index = 104, .length = 1},
  [88] = {.index = 105, .length = 3},
  [89] = {.index = 108, .length = 2},
  [90] = {.index = 110, .length = 2},
  [91] = {.index = 112, .length = 2},
  [92] = {.index = 114, .length = 2},
  [93] = {.index = 116, .length = 4},
  [94] = {.index = 120, .length = 2},
  [95] = {.index = 122, .length = 3},
  [96] = {.index = 125, .length = 3},
  [97] = {.index = 128, .length = 2},
  [98] = {.index = 130, .length = 2},
  [99] = {.index = 132, .length = 4},
  [100] = {.index = 130, .length = 2},
  [101] = {.index = 136, .length = 4},
  [102] = {.index = 140, .length = 4},
  [103] = {.index = 144, .length = 5},
  [104] = {.index = 149, .length = 2},
  [105] = {.index = 99, .length = 2},
  [106] = {.index = 151, .length = 3},
  [107] = {.index = 154, .length = 2},
  [108] = {.index = 156, .length = 3},
  [109] = {.index = 159, .length = 2},
  [110] = {.index = 161, .length = 5},
  [111] = {.index = 166, .length = 2},
  [112] = {.index = 168, .length = 1},
  [113] = {.index = 169, .length = 3},
  [114] = {.index = 172, .length = 1},
  [115] = {.index = 173, .length = 1},
  [116] = {.index = 174, .length = 1},
  [117] = {.index = 175, .length = 2},
  [118] = {.index = 177, .length = 3},
  [119] = {.index = 180, .length = 1},
  [120] = {.index = 181, .length = 2},
  [121] = {.index = 183, .length = 2},
  [122] = {.index = 185, .length = 4},
  [123] = {.index = 189, .length = 2},
  [124] = {.index = 191, .length = 2},
  [125] = {.index = 193, .length = 3},
  [126] = {.index = 196, .length = 2},
  [127] = {.index = 198, .length = 4},
  [128] = {.index = 202, .length = 4},
  [129] = {.index = 206, .length = 5},
  [130] = {.index = 211, .length = 2},
  [131] = {.index = 213, .length = 3},
  [132] = {.index = 216, .length = 3},
  [133] = {.index = 219, .length = 2},
  [134] = {.index = 221, .length = 3},
  [135] = {.index = 224, .length = 4},
  [136] = {.index = 228, .length = 3},
  [137] = {.index = 231, .length = 2},
  [138] = {.index = 233, .length = 5},
  [139] = {.index = 238, .length = 3},
  [140] = {.index = 241, .length = 2},
  [141] = {.index = 241, .length = 2},
  [142] = {.index = 243, .length = 3},
  [143] = {.index = 241, .length = 2},
  [144] = {.index = 241, .length = 2},
  [145] = {.index = 246, .length = 2},
  [146] = {.index = 248, .length = 4},
  [147] = {.index = 252, .length = 2},
  [148] = {.index = 254, .length = 2},
  [149] = {.index = 256, .length = 2},
  [150] = {.index = 258, .length = 2},
  [151] = {.index = 260, .length = 3},
  [152] = {.index = 263, .length = 3},
  [153] = {.index = 266, .length = 1},
  [154] = {.index = 267, .length = 5},
  [155] = {.index = 272, .length = 3},
  [157] = {.index = 275, .length = 4},
  [158] = {.index = 279, .length = 5},
  [159] = {.index = 284, .length = 2},
  [160] = {.index = 284, .length = 2},
  [161] = {.index = 284, .length = 2},
  [162] = {.index = 284, .length = 2},
  [163] = {.index = 286, .length = 4},
  [164] = {.index = 290, .length = 2},
  [165] = {.index = 290, .length = 2},
  [166] = {.index = 290, .length = 2},
  [167] = {.index = 292, .length = 4},
  [168] = {.index = 296, .length = 4},
  [169] = {.index = 300, .length = 2},
  [170] = {.index = 302, .length = 2},
  [171] = {.index = 304, .length = 3},
  [172] = {.index = 307, .length = 3},
  [173] = {.index = 310, .length = 2},
  [174] = {.index = 312, .length = 2},
  [175] = {.index = 314, .length = 5},
  [176] = {.index = 319, .length = 5},
  [177] = {.index = 324, .length = 4},
  [178] = {.index = 328, .length = 4},
  [179] = {.index = 332, .length = 3},
  [180] = {.index = 335, .length = 2},
  [181] = {.index = 337, .length = 2},
  [182] = {.index = 339, .length = 3},
  [183] = {.index = 342, .length = 5},
  [184] = {.index = 347, .length = 5},
  [185] = {.index = 352, .length = 4},
  [186] = {.index = 356, .length = 4},
  [187] = {.index = 360, .length = 3},
  [188] = {.index = 363, .length = 5},
  [189] = {.index = 368, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [16] =
    {field_parameters, 0},
    {field_return_type, 1},
  [18] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [20] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_label, 0},
  [25] =
    {field_object, 0},
    {field_property, 2},
  [27] =
    {field_body, 2},
    {field_parameter, 0},
  [29] =
    {field_body, 1},
    {field_name, 0},
  [31] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [33] =
    {field_name, 0},
    {field_type, 1},
  [35] =
    {field_condition, 1},
    {field_consequence, 2},
  [37] =
    {field_body, 2},
    {field_value, 1},
  [39] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [42] =
    {field_value, 1, .inherited = true},
  [43] =
    {field_body, 2},
    {field_condition, 1},
  [45] =
    {field_body, 1},
    {field_handler, 2},
  [47] =
    {field_body, 1},
    {field_finalizer, 2},
  [49] =
    {field_body, 2},
    {field_object, 1},
  [51] =
    {field_label, 1},
  [52] =
    {field_name, 1},
  [53] =
    {field_attribute, 0},
  [54] =
    {field_pattern, 1},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_body, 2},
  [58] =
    {field_body, 2},
    {field_type_parameters, 1},
  [60] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [64] =
    {field_arguments, 2},
    {field_constructor, 1},
  [66] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [69] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [72] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [74] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [78] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [81] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [83] =
    {field_source, 1},
  [84] =
    {field_source, 2, .inherited = true},
  [85] =
    {field_value, 2},
  [86] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [88] =
    {field_key, 0},
    {field_value, 2},
  [90] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [95] =
    {field_value, 1},
  [96] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [99] =
    {field_body, 3},
    {field_name, 2},
  [101] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [104] =
    {field_value, 2, .inherited = true},
  [105] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [108] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [110] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [112] =
    {field_name, 1},
    {field_type_arguments, 2},
  [114] =
    {field_flags, 3},
    {field_pattern, 1},
  [116] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [120] =
    {field_body, 3},
    {field_name, 1},
  [122] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [125] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [128] =
    {field_body, 3},
    {field_type_parameters, 1},
  [130] =
    {field_body, 3},
    {field_parameter, 1},
  [132] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [136] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [140] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [144] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [149] =
    {field_index, 2},
    {field_object, 0},
  [151] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [154] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [156] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [159] =
    {field_alias, 2},
    {field_name, 0},
  [161] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [166] =
    {field_name, 1},
    {field_value, 3},
  [168] =
    {field_source, 3, .inherited = true},
  [169] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [172] =
    {field_decorator, 1, .inherited = true},
  [173] =
    {field_decorator, 2, .inherited = true},
  [174] =
    {field_value, 3, .inherited = true},
  [175] =
    {field_body, 1},
    {field_condition, 3},
  [177] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [180] =
    {field_name, 2},
  [181] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [183] =
    {field_name, 1},
    {field_type, 2},
  [185] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [189] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [191] =
    {field_name, 0},
    {field_type, 2},
  [193] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [196] =
    {field_module, 0},
    {field_name, 2},
  [198] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [202] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [206] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [211] =
    {field_body, 4},
    {field_name, 2},
  [213] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [216] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [219] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [221] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [224] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [228] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [231] =
    {field_alias, 3},
    {field_name, 1},
  [233] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [238] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [241] =
    {field_left, 1},
    {field_right, 3},
  [243] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [246] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [248] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [252] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [254] =
    {field_name, 2},
    {field_type, 3},
  [256] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [258] =
    {field_name, 1},
    {field_type, 3},
  [260] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [263] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [266] =
    {field_name, 3},
  [267] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [272] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [275] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [279] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [284] =
    {field_left, 2},
    {field_right, 4},
  [286] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [290] =
    {field_body, 4},
    {field_parameter, 2},
  [292] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [296] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [300] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [302] =
    {field_name, 2},
    {field_type, 4},
  [304] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [307] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [310] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [312] =
    {field_name, 3},
    {field_type, 4},
  [314] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [319] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [324] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [328] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [332] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [335] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [337] =
    {field_name, 3},
    {field_type, 5},
  [339] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [342] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [347] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [352] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [356] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [360] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [363] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [368] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[190][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [24] = {
    [0] = sym_identifier,
  },
  [25] = {
    [0] = alias_sym_statement_identifier,
  },
  [26] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_object_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [35] = {
    [0] = alias_sym_array_pattern,
  },
  [39] = {
    [1] = alias_sym_object_pattern,
  },
  [40] = {
    [1] = alias_sym_array_pattern,
  },
  [46] = {
    [1] = alias_sym_statement_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [55] = {
    [1] = sym_identifier,
  },
  [58] = {
    [2] = alias_sym_property_identifier,
  },
  [61] = {
    [0] = sym_identifier,
  },
  [64] = {
    [0] = alias_sym_object_pattern,
  },
  [65] = {
    [0] = alias_sym_array_pattern,
  },
  [73] = {
    [1] = alias_sym_export_specifier,
  },
  [74] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [77] = {
    [1] = alias_sym_import_specifier,
  },
  [80] = {
    [0] = alias_sym_object_pattern,
  },
  [81] = {
    [0] = alias_sym_array_pattern,
  },
  [84] = {
    [2] = sym_identifier,
  },
  [85] = {
    [2] = alias_sym_object_pattern,
  },
  [86] = {
    [2] = alias_sym_array_pattern,
  },
  [94] = {
    [1] = alias_sym_type_identifier,
  },
  [95] = {
    [1] = alias_sym_type_identifier,
  },
  [98] = {
    [1] = sym_identifier,
  },
  [105] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [2] = alias_sym_type_identifier,
  },
  [111] = {
    [1] = alias_sym_type_identifier,
  },
  [125] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [2] = alias_sym_type_identifier,
  },
  [130] = {
    [2] = alias_sym_type_identifier,
  },
  [131] = {
    [2] = alias_sym_type_identifier,
  },
  [134] = {
    [2] = alias_sym_type_identifier,
  },
  [135] = {
    [2] = alias_sym_type_identifier,
  },
  [139] = {
    [1] = alias_sym_type_identifier,
  },
  [140] = {
    [1] = sym_identifier,
  },
  [143] = {
    [1] = alias_sym_object_pattern,
  },
  [144] = {
    [1] = alias_sym_array_pattern,
  },
  [155] = {
    [2] = alias_sym_type_identifier,
  },
  [156] = {
    [3] = alias_sym_property_identifier,
  },
  [157] = {
    [2] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = sym_identifier,
  },
  [161] = {
    [2] = alias_sym_object_pattern,
  },
  [162] = {
    [2] = alias_sym_array_pattern,
  },
  [165] = {
    [2] = alias_sym_object_pattern,
  },
  [166] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(181);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(64)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0) ADVANCE(197);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(168);
      if (lookahead != 0) ADVANCE(169);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(164);
      if (lookahead == '\r') ADVANCE(171);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(18)
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0) ADVANCE(162);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(157);
      if (lookahead == '\r') ADVANCE(172);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(28)
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(182);
      if (lookahead != 0) ADVANCE(183);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(197);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(197);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(197);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(68);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(197);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(181);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(46);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(195);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead)) ADVANCE(197);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 20:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(195);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead)) ADVANCE(197);
      END_STATE();
    case 22:
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(178);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(114);
      END_STATE();
    case 28:
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(28)
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 30:
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 31:
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == ']') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(180);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 43:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(188);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(189);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(191);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(197);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(170);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(190);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(173);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 62:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 63:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(183);
      END_STATE();
    case 64:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(64)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0) ADVANCE(197);
      END_STATE();
    case 65:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(65)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(197);
      END_STATE();
    case 66:
      if (eof) ADVANCE(67);
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '#') ADVANCE(13);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(197);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(143);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(146);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(199);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(178);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(94);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(93);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead != 0) ADVANCE(94);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(93);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(25);
      if (lookahead != 0) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(116);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(117);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(117);
      if (lookahead == '}') ADVANCE(200);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(117);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(117);
      if (lookahead == '}') ADVANCE(200);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(200);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(154);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(155);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(167);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(166);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(164);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(157);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(170);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(174);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(178);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(183);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(33);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(44);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(51);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(185);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(185);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 66},
  [2] = {.lex_state = 66},
  [3] = {.lex_state = 66},
  [4] = {.lex_state = 66},
  [5] = {.lex_state = 66},
  [6] = {.lex_state = 66},
  [7] = {.lex_state = 66},
  [8] = {.lex_state = 66},
  [9] = {.lex_state = 66},
  [10] = {.lex_state = 66},
  [11] = {.lex_state = 66},
  [12] = {.lex_state = 66},
  [13] = {.lex_state = 66},
  [14] = {.lex_state = 66},
  [15] = {.lex_state = 66},
  [16] = {.lex_state = 66},
  [17] = {.lex_state = 66},
  [18] = {.lex_state = 66},
  [19] = {.lex_state = 66},
  [20] = {.lex_state = 66},
  [21] = {.lex_state = 66},
  [22] = {.lex_state = 66},
  [23] = {.lex_state = 66},
  [24] = {.lex_state = 66},
  [25] = {.lex_state = 66},
  [26] = {.lex_state = 66},
  [27] = {.lex_state = 66},
  [28] = {.lex_state = 66},
  [29] = {.lex_state = 66},
  [30] = {.lex_state = 66},
  [31] = {.lex_state = 66},
  [32] = {.lex_state = 66},
  [33] = {.lex_state = 66},
  [34] = {.lex_state = 66},
  [35] = {.lex_state = 66},
  [36] = {.lex_state = 66},
  [37] = {.lex_state = 66},
  [38] = {.lex_state = 66},
  [39] = {.lex_state = 66},
  [40] = {.lex_state = 66},
  [41] = {.lex_state = 66},
  [42] = {.lex_state = 66},
  [43] = {.lex_state = 66},
  [44] = {.lex_state = 66},
  [45] = {.lex_state = 66},
  [46] = {.lex_state = 66},
  [47] = {.lex_state = 66},
  [48] = {.lex_state = 66},
  [49] = {.lex_state = 66},
  [50] = {.lex_state = 66},
  [51] = {.lex_state = 66},
  [52] = {.lex_state = 66},
  [53] = {.lex_state = 66},
  [54] = {.lex_state = 66},
  [55] = {.lex_state = 66},
  [56] = {.lex_state = 66},
  [57] = {.lex_state = 6, .external_lex_state = 2},
  [58] = {.lex_state = 6, .external_lex_state = 2},
  [59] = {.lex_state = 6, .external_lex_state = 2},
  [60] = {.lex_state = 6, .external_lex_state = 3},
  [61] = {.lex_state = 6, .external_lex_state = 2},
  [62] = {.lex_state = 6, .external_lex_state = 3},
  [63] = {.lex_state = 6, .external_lex_state = 2},
  [64] = {.lex_state = 6, .external_lex_state = 3},
  [65] = {.lex_state = 6, .external_lex_state = 3},
  [66] = {.lex_state = 6, .external_lex_state = 2},
  [67] = {.lex_state = 6, .external_lex_state = 3},
  [68] = {.lex_state = 6, .external_lex_state = 2},
  [69] = {.lex_state = 6, .external_lex_state = 2},
  [70] = {.lex_state = 6, .external_lex_state = 2},
  [71] = {.lex_state = 6, .external_lex_state = 2},
  [72] = {.lex_state = 6, .external_lex_state = 2},
  [73] = {.lex_state = 6, .external_lex_state = 3},
  [74] = {.lex_state = 6, .external_lex_state = 2},
  [75] = {.lex_state = 7, .external_lex_state = 3},
  [76] = {.lex_state = 6, .external_lex_state = 3},
  [77] = {.lex_state = 6, .external_lex_state = 3},
  [78] = {.lex_state = 6, .external_lex_state = 3},
  [79] = {.lex_state = 6, .external_lex_state = 3},
  [80] = {.lex_state = 6, .external_lex_state = 3},
  [81] = {.lex_state = 6, .external_lex_state = 2},
  [82] = {.lex_state = 6, .external_lex_state = 2},
  [83] = {.lex_state = 6, .external_lex_state = 3},
  [84] = {.lex_state = 7, .external_lex_state = 3},
  [85] = {.lex_state = 6, .external_lex_state = 3},
  [86] = {.lex_state = 6, .external_lex_state = 3},
  [87] = {.lex_state = 6, .external_lex_state = 3},
  [88] = {.lex_state = 7, .external_lex_state = 3},
  [89] = {.lex_state = 6, .external_lex_state = 3},
  [90] = {.lex_state = 6, .external_lex_state = 3},
  [91] = {.lex_state = 14},
  [92] = {.lex_state = 14},
  [93] = {.lex_state = 14},
  [94] = {.lex_state = 14},
  [95] = {.lex_state = 14},
  [96] = {.lex_state = 14},
  [97] = {.lex_state = 14},
  [98] = {.lex_state = 14},
  [99] = {.lex_state = 14},
  [100] = {.lex_state = 14},
  [101] = {.lex_state = 14},
  [102] = {.lex_state = 14},
  [103] = {.lex_state = 14},
  [104] = {.lex_state = 14},
  [105] = {.lex_state = 65, .external_lex_state = 3},
  [106] = {.lex_state = 14},
  [107] = {.lex_state = 14},
  [108] = {.lex_state = 65, .external_lex_state = 2},
  [109] = {.lex_state = 65, .external_lex_state = 3},
  [110] = {.lex_state = 65, .external_lex_state = 3},
  [111] = {.lex_state = 65, .external_lex_state = 2},
  [112] = {.lex_state = 8, .external_lex_state = 3},
  [113] = {.lex_state = 65, .external_lex_state = 2},
  [114] = {.lex_state = 65, .external_lex_state = 2},
  [115] = {.lex_state = 65, .external_lex_state = 2},
  [116] = {.lex_state = 65, .external_lex_state = 2},
  [117] = {.lex_state = 65, .external_lex_state = 2},
  [118] = {.lex_state = 65, .external_lex_state = 2},
  [119] = {.lex_state = 65, .external_lex_state = 2},
  [120] = {.lex_state = 65, .external_lex_state = 2},
  [121] = {.lex_state = 65, .external_lex_state = 2},
  [122] = {.lex_state = 65, .external_lex_state = 2},
  [123] = {.lex_state = 65, .external_lex_state = 2},
  [124] = {.lex_state = 65, .external_lex_state = 2},
  [125] = {.lex_state = 65, .external_lex_state = 2},
  [126] = {.lex_state = 65, .external_lex_state = 2},
  [127] = {.lex_state = 65, .external_lex_state = 2},
  [128] = {.lex_state = 65, .external_lex_state = 2},
  [129] = {.lex_state = 65, .external_lex_state = 2},
  [130] = {.lex_state = 65, .external_lex_state = 2},
  [131] = {.lex_state = 65, .external_lex_state = 2},
  [132] = {.lex_state = 65, .external_lex_state = 2},
  [133] = {.lex_state = 65, .external_lex_state = 2},
  [134] = {.lex_state = 65, .external_lex_state = 2},
  [135] = {.lex_state = 65, .external_lex_state = 2},
  [136] = {.lex_state = 65, .external_lex_state = 2},
  [137] = {.lex_state = 65, .external_lex_state = 2},
  [138] = {.lex_state = 65, .external_lex_state = 2},
  [139] = {.lex_state = 65, .external_lex_state = 2},
  [140] = {.lex_state = 66},
  [141] = {.lex_state = 66},
  [142] = {.lex_state = 66},
  [143] = {.lex_state = 66},
  [144] = {.lex_state = 66},
  [145] = {.lex_state = 66},
  [146] = {.lex_state = 66},
  [147] = {.lex_state = 66},
  [148] = {.lex_state = 66},
  [149] = {.lex_state = 66},
  [150] = {.lex_state = 66},
  [151] = {.lex_state = 66},
  [152] = {.lex_state = 66},
  [153] = {.lex_state = 66},
  [154] = {.lex_state = 66},
  [155] = {.lex_state = 66},
  [156] = {.lex_state = 66},
  [157] = {.lex_state = 66},
  [158] = {.lex_state = 66},
  [159] = {.lex_state = 66},
  [160] = {.lex_state = 66},
  [161] = {.lex_state = 66},
  [162] = {.lex_state = 66},
  [163] = {.lex_state = 66},
  [164] = {.lex_state = 66},
  [165] = {.lex_state = 66},
  [166] = {.lex_state = 66},
  [167] = {.lex_state = 66},
  [168] = {.lex_state = 66},
  [169] = {.lex_state = 66},
  [170] = {.lex_state = 66, .external_lex_state = 4},
  [171] = {.lex_state = 66},
  [172] = {.lex_state = 66},
  [173] = {.lex_state = 66},
  [174] = {.lex_state = 66},
  [175] = {.lex_state = 66},
  [176] = {.lex_state = 66},
  [177] = {.lex_state = 66},
  [178] = {.lex_state = 66},
  [179] = {.lex_state = 66},
  [180] = {.lex_state = 66},
  [181] = {.lex_state = 66},
  [182] = {.lex_state = 66},
  [183] = {.lex_state = 66},
  [184] = {.lex_state = 66},
  [185] = {.lex_state = 66},
  [186] = {.lex_state = 66},
  [187] = {.lex_state = 66},
  [188] = {.lex_state = 66},
  [189] = {.lex_state = 66},
  [190] = {.lex_state = 66},
  [191] = {.lex_state = 66},
  [192] = {.lex_state = 66},
  [193] = {.lex_state = 66},
  [194] = {.lex_state = 66},
  [195] = {.lex_state = 66},
  [196] = {.lex_state = 6, .external_lex_state = 2},
  [197] = {.lex_state = 66},
  [198] = {.lex_state = 66},
  [199] = {.lex_state = 66},
  [200] = {.lex_state = 66},
  [201] = {.lex_state = 66},
  [202] = {.lex_state = 66},
  [203] = {.lex_state = 66},
  [204] = {.lex_state = 66},
  [205] = {.lex_state = 66},
  [206] = {.lex_state = 66},
  [207] = {.lex_state = 66},
  [208] = {.lex_state = 66},
  [209] = {.lex_state = 66},
  [210] = {.lex_state = 66},
  [211] = {.lex_state = 66},
  [212] = {.lex_state = 66},
  [213] = {.lex_state = 66},
  [214] = {.lex_state = 66},
  [215] = {.lex_state = 66},
  [216] = {.lex_state = 66},
  [217] = {.lex_state = 66},
  [218] = {.lex_state = 66},
  [219] = {.lex_state = 66},
  [220] = {.lex_state = 66},
  [221] = {.lex_state = 66},
  [222] = {.lex_state = 66},
  [223] = {.lex_state = 66},
  [224] = {.lex_state = 66},
  [225] = {.lex_state = 66},
  [226] = {.lex_state = 66},
  [227] = {.lex_state = 66},
  [228] = {.lex_state = 66},
  [229] = {.lex_state = 66},
  [230] = {.lex_state = 66},
  [231] = {.lex_state = 66},
  [232] = {.lex_state = 66},
  [233] = {.lex_state = 66},
  [234] = {.lex_state = 66},
  [235] = {.lex_state = 66},
  [236] = {.lex_state = 66},
  [237] = {.lex_state = 66},
  [238] = {.lex_state = 66},
  [239] = {.lex_state = 6, .external_lex_state = 2},
  [240] = {.lex_state = 66},
  [241] = {.lex_state = 66},
  [242] = {.lex_state = 66},
  [243] = {.lex_state = 66},
  [244] = {.lex_state = 66},
  [245] = {.lex_state = 66},
  [246] = {.lex_state = 6, .external_lex_state = 2},
  [247] = {.lex_state = 66},
  [248] = {.lex_state = 66},
  [249] = {.lex_state = 66},
  [250] = {.lex_state = 66},
  [251] = {.lex_state = 66},
  [252] = {.lex_state = 66},
  [253] = {.lex_state = 66},
  [254] = {.lex_state = 66},
  [255] = {.lex_state = 66},
  [256] = {.lex_state = 66},
  [257] = {.lex_state = 66},
  [258] = {.lex_state = 66},
  [259] = {.lex_state = 66},
  [260] = {.lex_state = 66},
  [261] = {.lex_state = 66},
  [262] = {.lex_state = 66},
  [263] = {.lex_state = 66},
  [264] = {.lex_state = 66},
  [265] = {.lex_state = 66},
  [266] = {.lex_state = 66},
  [267] = {.lex_state = 66},
  [268] = {.lex_state = 66},
  [269] = {.lex_state = 66},
  [270] = {.lex_state = 66},
  [271] = {.lex_state = 66},
  [272] = {.lex_state = 66},
  [273] = {.lex_state = 66},
  [274] = {.lex_state = 66},
  [275] = {.lex_state = 66},
  [276] = {.lex_state = 66},
  [277] = {.lex_state = 66},
  [278] = {.lex_state = 66},
  [279] = {.lex_state = 66},
  [280] = {.lex_state = 66},
  [281] = {.lex_state = 66},
  [282] = {.lex_state = 66},
  [283] = {.lex_state = 66},
  [284] = {.lex_state = 66},
  [285] = {.lex_state = 66},
  [286] = {.lex_state = 66},
  [287] = {.lex_state = 66},
  [288] = {.lex_state = 66},
  [289] = {.lex_state = 66},
  [290] = {.lex_state = 66},
  [291] = {.lex_state = 66},
  [292] = {.lex_state = 66},
  [293] = {.lex_state = 66},
  [294] = {.lex_state = 66},
  [295] = {.lex_state = 66},
  [296] = {.lex_state = 66},
  [297] = {.lex_state = 66},
  [298] = {.lex_state = 66},
  [299] = {.lex_state = 66},
  [300] = {.lex_state = 66},
  [301] = {.lex_state = 66},
  [302] = {.lex_state = 66},
  [303] = {.lex_state = 66},
  [304] = {.lex_state = 66},
  [305] = {.lex_state = 66},
  [306] = {.lex_state = 66},
  [307] = {.lex_state = 66},
  [308] = {.lex_state = 66},
  [309] = {.lex_state = 66},
  [310] = {.lex_state = 66},
  [311] = {.lex_state = 66},
  [312] = {.lex_state = 66},
  [313] = {.lex_state = 66},
  [314] = {.lex_state = 66},
  [315] = {.lex_state = 66},
  [316] = {.lex_state = 66},
  [317] = {.lex_state = 66},
  [318] = {.lex_state = 66},
  [319] = {.lex_state = 66},
  [320] = {.lex_state = 66},
  [321] = {.lex_state = 66},
  [322] = {.lex_state = 66},
  [323] = {.lex_state = 66},
  [324] = {.lex_state = 66},
  [325] = {.lex_state = 66},
  [326] = {.lex_state = 66},
  [327] = {.lex_state = 66},
  [328] = {.lex_state = 66},
  [329] = {.lex_state = 66},
  [330] = {.lex_state = 66},
  [331] = {.lex_state = 66},
  [332] = {.lex_state = 66},
  [333] = {.lex_state = 66},
  [334] = {.lex_state = 66},
  [335] = {.lex_state = 66},
  [336] = {.lex_state = 66},
  [337] = {.lex_state = 66},
  [338] = {.lex_state = 66},
  [339] = {.lex_state = 66},
  [340] = {.lex_state = 66},
  [341] = {.lex_state = 66},
  [342] = {.lex_state = 66},
  [343] = {.lex_state = 66},
  [344] = {.lex_state = 66},
  [345] = {.lex_state = 66},
  [346] = {.lex_state = 66},
  [347] = {.lex_state = 66},
  [348] = {.lex_state = 66},
  [349] = {.lex_state = 66},
  [350] = {.lex_state = 66},
  [351] = {.lex_state = 66},
  [352] = {.lex_state = 66},
  [353] = {.lex_state = 66},
  [354] = {.lex_state = 66},
  [355] = {.lex_state = 66},
  [356] = {.lex_state = 66},
  [357] = {.lex_state = 66},
  [358] = {.lex_state = 66},
  [359] = {.lex_state = 66},
  [360] = {.lex_state = 66},
  [361] = {.lex_state = 66},
  [362] = {.lex_state = 66},
  [363] = {.lex_state = 66},
  [364] = {.lex_state = 66},
  [365] = {.lex_state = 66},
  [366] = {.lex_state = 66},
  [367] = {.lex_state = 66},
  [368] = {.lex_state = 66},
  [369] = {.lex_state = 66},
  [370] = {.lex_state = 66},
  [371] = {.lex_state = 66},
  [372] = {.lex_state = 66},
  [373] = {.lex_state = 66},
  [374] = {.lex_state = 66},
  [375] = {.lex_state = 66},
  [376] = {.lex_state = 66},
  [377] = {.lex_state = 66},
  [378] = {.lex_state = 66},
  [379] = {.lex_state = 66},
  [380] = {.lex_state = 66},
  [381] = {.lex_state = 66},
  [382] = {.lex_state = 66},
  [383] = {.lex_state = 66},
  [384] = {.lex_state = 66},
  [385] = {.lex_state = 66},
  [386] = {.lex_state = 66},
  [387] = {.lex_state = 66},
  [388] = {.lex_state = 66},
  [389] = {.lex_state = 66},
  [390] = {.lex_state = 66},
  [391] = {.lex_state = 66},
  [392] = {.lex_state = 66},
  [393] = {.lex_state = 66},
  [394] = {.lex_state = 66},
  [395] = {.lex_state = 66},
  [396] = {.lex_state = 66},
  [397] = {.lex_state = 66},
  [398] = {.lex_state = 66},
  [399] = {.lex_state = 66},
  [400] = {.lex_state = 66},
  [401] = {.lex_state = 66},
  [402] = {.lex_state = 66},
  [403] = {.lex_state = 66},
  [404] = {.lex_state = 66},
  [405] = {.lex_state = 66},
  [406] = {.lex_state = 66},
  [407] = {.lex_state = 66},
  [408] = {.lex_state = 66},
  [409] = {.lex_state = 66},
  [410] = {.lex_state = 66},
  [411] = {.lex_state = 6, .external_lex_state = 2},
  [412] = {.lex_state = 6, .external_lex_state = 2},
  [413] = {.lex_state = 6, .external_lex_state = 2},
  [414] = {.lex_state = 6, .external_lex_state = 2},
  [415] = {.lex_state = 6, .external_lex_state = 2},
  [416] = {.lex_state = 6, .external_lex_state = 2},
  [417] = {.lex_state = 66},
  [418] = {.lex_state = 66},
  [419] = {.lex_state = 6, .external_lex_state = 2},
  [420] = {.lex_state = 6, .external_lex_state = 2},
  [421] = {.lex_state = 6, .external_lex_state = 2},
  [422] = {.lex_state = 66},
  [423] = {.lex_state = 66},
  [424] = {.lex_state = 6, .external_lex_state = 2},
  [425] = {.lex_state = 66},
  [426] = {.lex_state = 66},
  [427] = {.lex_state = 6, .external_lex_state = 2},
  [428] = {.lex_state = 6, .external_lex_state = 2},
  [429] = {.lex_state = 66},
  [430] = {.lex_state = 66},
  [431] = {.lex_state = 66},
  [432] = {.lex_state = 66},
  [433] = {.lex_state = 66},
  [434] = {.lex_state = 66},
  [435] = {.lex_state = 66},
  [436] = {.lex_state = 66},
  [437] = {.lex_state = 66},
  [438] = {.lex_state = 66},
  [439] = {.lex_state = 66},
  [440] = {.lex_state = 66},
  [441] = {.lex_state = 66},
  [442] = {.lex_state = 66},
  [443] = {.lex_state = 66},
  [444] = {.lex_state = 66},
  [445] = {.lex_state = 66},
  [446] = {.lex_state = 66},
  [447] = {.lex_state = 66},
  [448] = {.lex_state = 66},
  [449] = {.lex_state = 66},
  [450] = {.lex_state = 6, .external_lex_state = 2},
  [451] = {.lex_state = 6, .external_lex_state = 2},
  [452] = {.lex_state = 66},
  [453] = {.lex_state = 6, .external_lex_state = 2},
  [454] = {.lex_state = 6, .external_lex_state = 2},
  [455] = {.lex_state = 6, .external_lex_state = 2},
  [456] = {.lex_state = 6, .external_lex_state = 2},
  [457] = {.lex_state = 6, .external_lex_state = 2},
  [458] = {.lex_state = 6, .external_lex_state = 2},
  [459] = {.lex_state = 6, .external_lex_state = 2},
  [460] = {.lex_state = 66},
  [461] = {.lex_state = 66},
  [462] = {.lex_state = 66, .external_lex_state = 4},
  [463] = {.lex_state = 66, .external_lex_state = 4},
  [464] = {.lex_state = 66},
  [465] = {.lex_state = 66},
  [466] = {.lex_state = 66, .external_lex_state = 4},
  [467] = {.lex_state = 66, .external_lex_state = 4},
  [468] = {.lex_state = 6, .external_lex_state = 3},
  [469] = {.lex_state = 15},
  [470] = {.lex_state = 66, .external_lex_state = 4},
  [471] = {.lex_state = 66},
  [472] = {.lex_state = 66, .external_lex_state = 4},
  [473] = {.lex_state = 66},
  [474] = {.lex_state = 66, .external_lex_state = 4},
  [475] = {.lex_state = 15},
  [476] = {.lex_state = 66},
  [477] = {.lex_state = 15},
  [478] = {.lex_state = 66},
  [479] = {.lex_state = 66},
  [480] = {.lex_state = 66, .external_lex_state = 4},
  [481] = {.lex_state = 15},
  [482] = {.lex_state = 15},
  [483] = {.lex_state = 6, .external_lex_state = 2},
  [484] = {.lex_state = 66},
  [485] = {.lex_state = 66},
  [486] = {.lex_state = 66},
  [487] = {.lex_state = 6, .external_lex_state = 3},
  [488] = {.lex_state = 66},
  [489] = {.lex_state = 66},
  [490] = {.lex_state = 66},
  [491] = {.lex_state = 66},
  [492] = {.lex_state = 6, .external_lex_state = 2},
  [493] = {.lex_state = 66},
  [494] = {.lex_state = 6, .external_lex_state = 2},
  [495] = {.lex_state = 6, .external_lex_state = 2},
  [496] = {.lex_state = 66, .external_lex_state = 4},
  [497] = {.lex_state = 6, .external_lex_state = 2},
  [498] = {.lex_state = 6, .external_lex_state = 2},
  [499] = {.lex_state = 66},
  [500] = {.lex_state = 6, .external_lex_state = 2},
  [501] = {.lex_state = 66, .external_lex_state = 4},
  [502] = {.lex_state = 66, .external_lex_state = 4},
  [503] = {.lex_state = 66, .external_lex_state = 4},
  [504] = {.lex_state = 6, .external_lex_state = 2},
  [505] = {.lex_state = 66},
  [506] = {.lex_state = 6, .external_lex_state = 2},
  [507] = {.lex_state = 66, .external_lex_state = 4},
  [508] = {.lex_state = 66, .external_lex_state = 4},
  [509] = {.lex_state = 66},
  [510] = {.lex_state = 6, .external_lex_state = 3},
  [511] = {.lex_state = 66},
  [512] = {.lex_state = 66, .external_lex_state = 4},
  [513] = {.lex_state = 66, .external_lex_state = 4},
  [514] = {.lex_state = 66, .external_lex_state = 4},
  [515] = {.lex_state = 66, .external_lex_state = 4},
  [516] = {.lex_state = 6, .external_lex_state = 3},
  [517] = {.lex_state = 66},
  [518] = {.lex_state = 7, .external_lex_state = 3},
  [519] = {.lex_state = 66},
  [520] = {.lex_state = 66, .external_lex_state = 4},
  [521] = {.lex_state = 66, .external_lex_state = 4},
  [522] = {.lex_state = 66},
  [523] = {.lex_state = 66},
  [524] = {.lex_state = 66},
  [525] = {.lex_state = 66},
  [526] = {.lex_state = 66},
  [527] = {.lex_state = 66},
  [528] = {.lex_state = 6, .external_lex_state = 3},
  [529] = {.lex_state = 66},
  [530] = {.lex_state = 66},
  [531] = {.lex_state = 66},
  [532] = {.lex_state = 66},
  [533] = {.lex_state = 66},
  [534] = {.lex_state = 66},
  [535] = {.lex_state = 66},
  [536] = {.lex_state = 66},
  [537] = {.lex_state = 66},
  [538] = {.lex_state = 66},
  [539] = {.lex_state = 66},
  [540] = {.lex_state = 66},
  [541] = {.lex_state = 66},
  [542] = {.lex_state = 66},
  [543] = {.lex_state = 66},
  [544] = {.lex_state = 66},
  [545] = {.lex_state = 66},
  [546] = {.lex_state = 66},
  [547] = {.lex_state = 66},
  [548] = {.lex_state = 66},
  [549] = {.lex_state = 6, .external_lex_state = 2},
  [550] = {.lex_state = 66},
  [551] = {.lex_state = 6, .external_lex_state = 3},
  [552] = {.lex_state = 66},
  [553] = {.lex_state = 66},
  [554] = {.lex_state = 66},
  [555] = {.lex_state = 66},
  [556] = {.lex_state = 66},
  [557] = {.lex_state = 66},
  [558] = {.lex_state = 66},
  [559] = {.lex_state = 66},
  [560] = {.lex_state = 66},
  [561] = {.lex_state = 66},
  [562] = {.lex_state = 66},
  [563] = {.lex_state = 66},
  [564] = {.lex_state = 66},
  [565] = {.lex_state = 66},
  [566] = {.lex_state = 6, .external_lex_state = 3},
  [567] = {.lex_state = 66},
  [568] = {.lex_state = 6, .external_lex_state = 3},
  [569] = {.lex_state = 66},
  [570] = {.lex_state = 66},
  [571] = {.lex_state = 6, .external_lex_state = 3},
  [572] = {.lex_state = 7, .external_lex_state = 3},
  [573] = {.lex_state = 66},
  [574] = {.lex_state = 66},
  [575] = {.lex_state = 66},
  [576] = {.lex_state = 66},
  [577] = {.lex_state = 66},
  [578] = {.lex_state = 66},
  [579] = {.lex_state = 66},
  [580] = {.lex_state = 66},
  [581] = {.lex_state = 66},
  [582] = {.lex_state = 66},
  [583] = {.lex_state = 6, .external_lex_state = 3},
  [584] = {.lex_state = 66},
  [585] = {.lex_state = 66},
  [586] = {.lex_state = 66},
  [587] = {.lex_state = 66},
  [588] = {.lex_state = 66},
  [589] = {.lex_state = 66},
  [590] = {.lex_state = 66},
  [591] = {.lex_state = 66},
  [592] = {.lex_state = 66},
  [593] = {.lex_state = 66},
  [594] = {.lex_state = 66},
  [595] = {.lex_state = 66},
  [596] = {.lex_state = 6, .external_lex_state = 3},
  [597] = {.lex_state = 66},
  [598] = {.lex_state = 66},
  [599] = {.lex_state = 66},
  [600] = {.lex_state = 66},
  [601] = {.lex_state = 66},
  [602] = {.lex_state = 66},
  [603] = {.lex_state = 66},
  [604] = {.lex_state = 66},
  [605] = {.lex_state = 66},
  [606] = {.lex_state = 66},
  [607] = {.lex_state = 66},
  [608] = {.lex_state = 6, .external_lex_state = 3},
  [609] = {.lex_state = 6, .external_lex_state = 2},
  [610] = {.lex_state = 6, .external_lex_state = 3},
  [611] = {.lex_state = 6, .external_lex_state = 3},
  [612] = {.lex_state = 6, .external_lex_state = 3},
  [613] = {.lex_state = 6, .external_lex_state = 3},
  [614] = {.lex_state = 66},
  [615] = {.lex_state = 66},
  [616] = {.lex_state = 66},
  [617] = {.lex_state = 66},
  [618] = {.lex_state = 66},
  [619] = {.lex_state = 66},
  [620] = {.lex_state = 66},
  [621] = {.lex_state = 66},
  [622] = {.lex_state = 66},
  [623] = {.lex_state = 66},
  [624] = {.lex_state = 6, .external_lex_state = 2},
  [625] = {.lex_state = 6, .external_lex_state = 2},
  [626] = {.lex_state = 6, .external_lex_state = 2},
  [627] = {.lex_state = 6, .external_lex_state = 2},
  [628] = {.lex_state = 6, .external_lex_state = 3},
  [629] = {.lex_state = 6, .external_lex_state = 2},
  [630] = {.lex_state = 6, .external_lex_state = 2},
  [631] = {.lex_state = 6, .external_lex_state = 2},
  [632] = {.lex_state = 6, .external_lex_state = 3},
  [633] = {.lex_state = 6, .external_lex_state = 3},
  [634] = {.lex_state = 6, .external_lex_state = 2},
  [635] = {.lex_state = 66},
  [636] = {.lex_state = 66},
  [637] = {.lex_state = 66},
  [638] = {.lex_state = 66},
  [639] = {.lex_state = 7, .external_lex_state = 3},
  [640] = {.lex_state = 6, .external_lex_state = 2},
  [641] = {.lex_state = 6, .external_lex_state = 2},
  [642] = {.lex_state = 66},
  [643] = {.lex_state = 6, .external_lex_state = 2},
  [644] = {.lex_state = 6, .external_lex_state = 3},
  [645] = {.lex_state = 66},
  [646] = {.lex_state = 6, .external_lex_state = 2},
  [647] = {.lex_state = 6, .external_lex_state = 2},
  [648] = {.lex_state = 6, .external_lex_state = 2},
  [649] = {.lex_state = 6, .external_lex_state = 2},
  [650] = {.lex_state = 66},
  [651] = {.lex_state = 7, .external_lex_state = 3},
  [652] = {.lex_state = 6, .external_lex_state = 2},
  [653] = {.lex_state = 6, .external_lex_state = 3},
  [654] = {.lex_state = 6, .external_lex_state = 3},
  [655] = {.lex_state = 6, .external_lex_state = 3},
  [656] = {.lex_state = 6, .external_lex_state = 3},
  [657] = {.lex_state = 6, .external_lex_state = 3},
  [658] = {.lex_state = 6, .external_lex_state = 3},
  [659] = {.lex_state = 6, .external_lex_state = 2},
  [660] = {.lex_state = 15},
  [661] = {.lex_state = 6, .external_lex_state = 2},
  [662] = {.lex_state = 6, .external_lex_state = 3},
  [663] = {.lex_state = 6, .external_lex_state = 3},
  [664] = {.lex_state = 15},
  [665] = {.lex_state = 6, .external_lex_state = 3},
  [666] = {.lex_state = 66},
  [667] = {.lex_state = 6, .external_lex_state = 3},
  [668] = {.lex_state = 6, .external_lex_state = 3},
  [669] = {.lex_state = 66},
  [670] = {.lex_state = 6, .external_lex_state = 3},
  [671] = {.lex_state = 6, .external_lex_state = 2},
  [672] = {.lex_state = 6, .external_lex_state = 2},
  [673] = {.lex_state = 6, .external_lex_state = 2},
  [674] = {.lex_state = 6, .external_lex_state = 3},
  [675] = {.lex_state = 6, .external_lex_state = 3},
  [676] = {.lex_state = 6, .external_lex_state = 3},
  [677] = {.lex_state = 6, .external_lex_state = 2},
  [678] = {.lex_state = 15},
  [679] = {.lex_state = 15},
  [680] = {.lex_state = 15},
  [681] = {.lex_state = 6, .external_lex_state = 2},
  [682] = {.lex_state = 15},
  [683] = {.lex_state = 15},
  [684] = {.lex_state = 15},
  [685] = {.lex_state = 17},
  [686] = {.lex_state = 6, .external_lex_state = 2},
  [687] = {.lex_state = 15},
  [688] = {.lex_state = 15},
  [689] = {.lex_state = 15},
  [690] = {.lex_state = 15},
  [691] = {.lex_state = 6, .external_lex_state = 3},
  [692] = {.lex_state = 6, .external_lex_state = 2},
  [693] = {.lex_state = 15},
  [694] = {.lex_state = 6, .external_lex_state = 3},
  [695] = {.lex_state = 15},
  [696] = {.lex_state = 6, .external_lex_state = 2},
  [697] = {.lex_state = 6, .external_lex_state = 2},
  [698] = {.lex_state = 6, .external_lex_state = 2},
  [699] = {.lex_state = 15},
  [700] = {.lex_state = 15},
  [701] = {.lex_state = 15},
  [702] = {.lex_state = 6, .external_lex_state = 3},
  [703] = {.lex_state = 6, .external_lex_state = 3},
  [704] = {.lex_state = 15},
  [705] = {.lex_state = 15},
  [706] = {.lex_state = 6, .external_lex_state = 2},
  [707] = {.lex_state = 15},
  [708] = {.lex_state = 15},
  [709] = {.lex_state = 15},
  [710] = {.lex_state = 6, .external_lex_state = 3},
  [711] = {.lex_state = 6, .external_lex_state = 3},
  [712] = {.lex_state = 15},
  [713] = {.lex_state = 15},
  [714] = {.lex_state = 15},
  [715] = {.lex_state = 15},
  [716] = {.lex_state = 15},
  [717] = {.lex_state = 15},
  [718] = {.lex_state = 15},
  [719] = {.lex_state = 15},
  [720] = {.lex_state = 7, .external_lex_state = 3},
  [721] = {.lex_state = 15},
  [722] = {.lex_state = 15},
  [723] = {.lex_state = 6, .external_lex_state = 2},
  [724] = {.lex_state = 15},
  [725] = {.lex_state = 15},
  [726] = {.lex_state = 15},
  [727] = {.lex_state = 15},
  [728] = {.lex_state = 15},
  [729] = {.lex_state = 6, .external_lex_state = 2},
  [730] = {.lex_state = 15},
  [731] = {.lex_state = 15},
  [732] = {.lex_state = 15},
  [733] = {.lex_state = 15},
  [734] = {.lex_state = 6, .external_lex_state = 3},
  [735] = {.lex_state = 15},
  [736] = {.lex_state = 15},
  [737] = {.lex_state = 15},
  [738] = {.lex_state = 15},
  [739] = {.lex_state = 15},
  [740] = {.lex_state = 15},
  [741] = {.lex_state = 15},
  [742] = {.lex_state = 15},
  [743] = {.lex_state = 15},
  [744] = {.lex_state = 15},
  [745] = {.lex_state = 6, .external_lex_state = 3},
  [746] = {.lex_state = 15},
  [747] = {.lex_state = 15},
  [748] = {.lex_state = 15},
  [749] = {.lex_state = 15},
  [750] = {.lex_state = 15},
  [751] = {.lex_state = 6, .external_lex_state = 3},
  [752] = {.lex_state = 15},
  [753] = {.lex_state = 15},
  [754] = {.lex_state = 15},
  [755] = {.lex_state = 15},
  [756] = {.lex_state = 15},
  [757] = {.lex_state = 15},
  [758] = {.lex_state = 15},
  [759] = {.lex_state = 15},
  [760] = {.lex_state = 15},
  [761] = {.lex_state = 15},
  [762] = {.lex_state = 15},
  [763] = {.lex_state = 15},
  [764] = {.lex_state = 15},
  [765] = {.lex_state = 15},
  [766] = {.lex_state = 15},
  [767] = {.lex_state = 15},
  [768] = {.lex_state = 15},
  [769] = {.lex_state = 15},
  [770] = {.lex_state = 15},
  [771] = {.lex_state = 15},
  [772] = {.lex_state = 15},
  [773] = {.lex_state = 15},
  [774] = {.lex_state = 15},
  [775] = {.lex_state = 15},
  [776] = {.lex_state = 15},
  [777] = {.lex_state = 15},
  [778] = {.lex_state = 15},
  [779] = {.lex_state = 6, .external_lex_state = 2},
  [780] = {.lex_state = 15},
  [781] = {.lex_state = 6, .external_lex_state = 2},
  [782] = {.lex_state = 15},
  [783] = {.lex_state = 6, .external_lex_state = 3},
  [784] = {.lex_state = 15},
  [785] = {.lex_state = 15},
  [786] = {.lex_state = 15},
  [787] = {.lex_state = 15},
  [788] = {.lex_state = 15},
  [789] = {.lex_state = 15},
  [790] = {.lex_state = 15},
  [791] = {.lex_state = 6, .external_lex_state = 2},
  [792] = {.lex_state = 15},
  [793] = {.lex_state = 15},
  [794] = {.lex_state = 6, .external_lex_state = 2},
  [795] = {.lex_state = 15},
  [796] = {.lex_state = 15},
  [797] = {.lex_state = 15},
  [798] = {.lex_state = 15},
  [799] = {.lex_state = 15},
  [800] = {.lex_state = 15},
  [801] = {.lex_state = 15},
  [802] = {.lex_state = 6, .external_lex_state = 2},
  [803] = {.lex_state = 15},
  [804] = {.lex_state = 15},
  [805] = {.lex_state = 15},
  [806] = {.lex_state = 6, .external_lex_state = 3},
  [807] = {.lex_state = 15},
  [808] = {.lex_state = 7, .external_lex_state = 3},
  [809] = {.lex_state = 6, .external_lex_state = 3},
  [810] = {.lex_state = 15},
  [811] = {.lex_state = 15},
  [812] = {.lex_state = 15},
  [813] = {.lex_state = 15},
  [814] = {.lex_state = 15},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 15},
  [817] = {.lex_state = 6, .external_lex_state = 2},
  [818] = {.lex_state = 15},
  [819] = {.lex_state = 15},
  [820] = {.lex_state = 6, .external_lex_state = 3},
  [821] = {.lex_state = 15},
  [822] = {.lex_state = 15},
  [823] = {.lex_state = 15},
  [824] = {.lex_state = 7, .external_lex_state = 3},
  [825] = {.lex_state = 6, .external_lex_state = 3},
  [826] = {.lex_state = 6, .external_lex_state = 2},
  [827] = {.lex_state = 6, .external_lex_state = 3},
  [828] = {.lex_state = 6, .external_lex_state = 2},
  [829] = {.lex_state = 6, .external_lex_state = 2},
  [830] = {.lex_state = 6, .external_lex_state = 2},
  [831] = {.lex_state = 6, .external_lex_state = 2},
  [832] = {.lex_state = 6, .external_lex_state = 2},
  [833] = {.lex_state = 6, .external_lex_state = 3},
  [834] = {.lex_state = 6, .external_lex_state = 2},
  [835] = {.lex_state = 6, .external_lex_state = 2},
  [836] = {.lex_state = 6, .external_lex_state = 2},
  [837] = {.lex_state = 6, .external_lex_state = 3},
  [838] = {.lex_state = 6, .external_lex_state = 3},
  [839] = {.lex_state = 6, .external_lex_state = 2},
  [840] = {.lex_state = 6, .external_lex_state = 2},
  [841] = {.lex_state = 6, .external_lex_state = 3},
  [842] = {.lex_state = 6, .external_lex_state = 3},
  [843] = {.lex_state = 6, .external_lex_state = 2},
  [844] = {.lex_state = 6, .external_lex_state = 2},
  [845] = {.lex_state = 6, .external_lex_state = 2},
  [846] = {.lex_state = 6, .external_lex_state = 2},
  [847] = {.lex_state = 6, .external_lex_state = 2},
  [848] = {.lex_state = 6, .external_lex_state = 3},
  [849] = {.lex_state = 6, .external_lex_state = 2},
  [850] = {.lex_state = 6, .external_lex_state = 3},
  [851] = {.lex_state = 6, .external_lex_state = 3},
  [852] = {.lex_state = 7, .external_lex_state = 3},
  [853] = {.lex_state = 6, .external_lex_state = 2},
  [854] = {.lex_state = 6, .external_lex_state = 2},
  [855] = {.lex_state = 6, .external_lex_state = 2},
  [856] = {.lex_state = 6, .external_lex_state = 2},
  [857] = {.lex_state = 6, .external_lex_state = 2},
  [858] = {.lex_state = 7, .external_lex_state = 3},
  [859] = {.lex_state = 7, .external_lex_state = 3},
  [860] = {.lex_state = 6, .external_lex_state = 2},
  [861] = {.lex_state = 6, .external_lex_state = 3},
  [862] = {.lex_state = 6, .external_lex_state = 3},
  [863] = {.lex_state = 7, .external_lex_state = 3},
  [864] = {.lex_state = 6, .external_lex_state = 3},
  [865] = {.lex_state = 6, .external_lex_state = 2},
  [866] = {.lex_state = 6, .external_lex_state = 3},
  [867] = {.lex_state = 6, .external_lex_state = 3},
  [868] = {.lex_state = 6, .external_lex_state = 3},
  [869] = {.lex_state = 6, .external_lex_state = 2},
  [870] = {.lex_state = 6, .external_lex_state = 3},
  [871] = {.lex_state = 6, .external_lex_state = 2},
  [872] = {.lex_state = 6, .external_lex_state = 3},
  [873] = {.lex_state = 6, .external_lex_state = 2},
  [874] = {.lex_state = 6, .external_lex_state = 3},
  [875] = {.lex_state = 6, .external_lex_state = 2},
  [876] = {.lex_state = 7, .external_lex_state = 3},
  [877] = {.lex_state = 6, .external_lex_state = 3},
  [878] = {.lex_state = 6, .external_lex_state = 3},
  [879] = {.lex_state = 6, .external_lex_state = 2},
  [880] = {.lex_state = 7, .external_lex_state = 3},
  [881] = {.lex_state = 6, .external_lex_state = 2},
  [882] = {.lex_state = 6, .external_lex_state = 3},
  [883] = {.lex_state = 6, .external_lex_state = 3},
  [884] = {.lex_state = 6, .external_lex_state = 3},
  [885] = {.lex_state = 6, .external_lex_state = 3},
  [886] = {.lex_state = 6, .external_lex_state = 2},
  [887] = {.lex_state = 7, .external_lex_state = 3},
  [888] = {.lex_state = 6, .external_lex_state = 3},
  [889] = {.lex_state = 6, .external_lex_state = 3},
  [890] = {.lex_state = 6, .external_lex_state = 3},
  [891] = {.lex_state = 6, .external_lex_state = 3},
  [892] = {.lex_state = 6, .external_lex_state = 3},
  [893] = {.lex_state = 7, .external_lex_state = 3},
  [894] = {.lex_state = 6, .external_lex_state = 2},
  [895] = {.lex_state = 7, .external_lex_state = 3},
  [896] = {.lex_state = 7, .external_lex_state = 3},
  [897] = {.lex_state = 6, .external_lex_state = 2},
  [898] = {.lex_state = 7, .external_lex_state = 3},
  [899] = {.lex_state = 7, .external_lex_state = 3},
  [900] = {.lex_state = 6, .external_lex_state = 3},
  [901] = {.lex_state = 6, .external_lex_state = 3},
  [902] = {.lex_state = 7, .external_lex_state = 3},
  [903] = {.lex_state = 6, .external_lex_state = 3},
  [904] = {.lex_state = 6, .external_lex_state = 3},
  [905] = {.lex_state = 6, .external_lex_state = 2},
  [906] = {.lex_state = 6, .external_lex_state = 2},
  [907] = {.lex_state = 7, .external_lex_state = 3},
  [908] = {.lex_state = 7, .external_lex_state = 3},
  [909] = {.lex_state = 6, .external_lex_state = 3},
  [910] = {.lex_state = 7, .external_lex_state = 3},
  [911] = {.lex_state = 7, .external_lex_state = 3},
  [912] = {.lex_state = 6, .external_lex_state = 3},
  [913] = {.lex_state = 66},
  [914] = {.lex_state = 6, .external_lex_state = 3},
  [915] = {.lex_state = 66},
  [916] = {.lex_state = 66, .external_lex_state = 4},
  [917] = {.lex_state = 66, .external_lex_state = 4},
  [918] = {.lex_state = 66},
  [919] = {.lex_state = 6, .external_lex_state = 3},
  [920] = {.lex_state = 6, .external_lex_state = 3},
  [921] = {.lex_state = 66, .external_lex_state = 4},
  [922] = {.lex_state = 6, .external_lex_state = 2},
  [923] = {.lex_state = 66},
  [924] = {.lex_state = 66, .external_lex_state = 4},
  [925] = {.lex_state = 6, .external_lex_state = 3},
  [926] = {.lex_state = 66},
  [927] = {.lex_state = 6, .external_lex_state = 3},
  [928] = {.lex_state = 65, .external_lex_state = 2},
  [929] = {.lex_state = 66, .external_lex_state = 4},
  [930] = {.lex_state = 6, .external_lex_state = 3},
  [931] = {.lex_state = 66, .external_lex_state = 4},
  [932] = {.lex_state = 6, .external_lex_state = 3},
  [933] = {.lex_state = 66},
  [934] = {.lex_state = 66},
  [935] = {.lex_state = 66},
  [936] = {.lex_state = 66},
  [937] = {.lex_state = 66},
  [938] = {.lex_state = 66},
  [939] = {.lex_state = 66},
  [940] = {.lex_state = 66},
  [941] = {.lex_state = 66},
  [942] = {.lex_state = 66},
  [943] = {.lex_state = 66},
  [944] = {.lex_state = 66},
  [945] = {.lex_state = 66},
  [946] = {.lex_state = 66},
  [947] = {.lex_state = 66},
  [948] = {.lex_state = 66},
  [949] = {.lex_state = 66},
  [950] = {.lex_state = 66},
  [951] = {.lex_state = 66},
  [952] = {.lex_state = 66},
  [953] = {.lex_state = 66},
  [954] = {.lex_state = 65, .external_lex_state = 3},
  [955] = {.lex_state = 65, .external_lex_state = 3},
  [956] = {.lex_state = 65, .external_lex_state = 3},
  [957] = {.lex_state = 65, .external_lex_state = 3},
  [958] = {.lex_state = 65, .external_lex_state = 3},
  [959] = {.lex_state = 65, .external_lex_state = 3},
  [960] = {.lex_state = 65, .external_lex_state = 3},
  [961] = {.lex_state = 65, .external_lex_state = 3},
  [962] = {.lex_state = 65, .external_lex_state = 3},
  [963] = {.lex_state = 65, .external_lex_state = 3},
  [964] = {.lex_state = 65, .external_lex_state = 3},
  [965] = {.lex_state = 65, .external_lex_state = 2},
  [966] = {.lex_state = 65, .external_lex_state = 2},
  [967] = {.lex_state = 65, .external_lex_state = 3},
  [968] = {.lex_state = 65, .external_lex_state = 3},
  [969] = {.lex_state = 65, .external_lex_state = 2},
  [970] = {.lex_state = 65, .external_lex_state = 3},
  [971] = {.lex_state = 65, .external_lex_state = 3},
  [972] = {.lex_state = 65, .external_lex_state = 3},
  [973] = {.lex_state = 65, .external_lex_state = 3},
  [974] = {.lex_state = 65, .external_lex_state = 3},
  [975] = {.lex_state = 65, .external_lex_state = 3},
  [976] = {.lex_state = 65, .external_lex_state = 3},
  [977] = {.lex_state = 65, .external_lex_state = 3},
  [978] = {.lex_state = 65, .external_lex_state = 3},
  [979] = {.lex_state = 15},
  [980] = {.lex_state = 15},
  [981] = {.lex_state = 65, .external_lex_state = 3},
  [982] = {.lex_state = 65, .external_lex_state = 2},
  [983] = {.lex_state = 65, .external_lex_state = 3},
  [984] = {.lex_state = 65, .external_lex_state = 3},
  [985] = {.lex_state = 65, .external_lex_state = 3},
  [986] = {.lex_state = 65, .external_lex_state = 3},
  [987] = {.lex_state = 65, .external_lex_state = 3},
  [988] = {.lex_state = 65, .external_lex_state = 3},
  [989] = {.lex_state = 65, .external_lex_state = 3},
  [990] = {.lex_state = 65, .external_lex_state = 3},
  [991] = {.lex_state = 15},
  [992] = {.lex_state = 65, .external_lex_state = 3},
  [993] = {.lex_state = 65, .external_lex_state = 2},
  [994] = {.lex_state = 65, .external_lex_state = 3},
  [995] = {.lex_state = 65, .external_lex_state = 3},
  [996] = {.lex_state = 65, .external_lex_state = 3},
  [997] = {.lex_state = 15},
  [998] = {.lex_state = 15},
  [999] = {.lex_state = 65, .external_lex_state = 3},
  [1000] = {.lex_state = 65, .external_lex_state = 3},
  [1001] = {.lex_state = 65, .external_lex_state = 3},
  [1002] = {.lex_state = 65, .external_lex_state = 3},
  [1003] = {.lex_state = 15},
  [1004] = {.lex_state = 65, .external_lex_state = 3},
  [1005] = {.lex_state = 65, .external_lex_state = 3},
  [1006] = {.lex_state = 65, .external_lex_state = 2},
  [1007] = {.lex_state = 65, .external_lex_state = 3},
  [1008] = {.lex_state = 65, .external_lex_state = 3},
  [1009] = {.lex_state = 65, .external_lex_state = 3},
  [1010] = {.lex_state = 65, .external_lex_state = 3},
  [1011] = {.lex_state = 65, .external_lex_state = 2},
  [1012] = {.lex_state = 65, .external_lex_state = 2},
  [1013] = {.lex_state = 15},
  [1014] = {.lex_state = 65, .external_lex_state = 3},
  [1015] = {.lex_state = 65, .external_lex_state = 3},
  [1016] = {.lex_state = 65, .external_lex_state = 3},
  [1017] = {.lex_state = 65, .external_lex_state = 3},
  [1018] = {.lex_state = 65, .external_lex_state = 2},
  [1019] = {.lex_state = 65, .external_lex_state = 3},
  [1020] = {.lex_state = 65, .external_lex_state = 3},
  [1021] = {.lex_state = 65, .external_lex_state = 3},
  [1022] = {.lex_state = 65, .external_lex_state = 2},
  [1023] = {.lex_state = 8, .external_lex_state = 3},
  [1024] = {.lex_state = 65, .external_lex_state = 3},
  [1025] = {.lex_state = 65, .external_lex_state = 3},
  [1026] = {.lex_state = 65, .external_lex_state = 2},
  [1027] = {.lex_state = 65, .external_lex_state = 3},
  [1028] = {.lex_state = 65, .external_lex_state = 3},
  [1029] = {.lex_state = 66},
  [1030] = {.lex_state = 66},
  [1031] = {.lex_state = 65, .external_lex_state = 3},
  [1032] = {.lex_state = 65, .external_lex_state = 3},
  [1033] = {.lex_state = 65, .external_lex_state = 3},
  [1034] = {.lex_state = 65, .external_lex_state = 3},
  [1035] = {.lex_state = 65, .external_lex_state = 3},
  [1036] = {.lex_state = 65, .external_lex_state = 3},
  [1037] = {.lex_state = 65, .external_lex_state = 3},
  [1038] = {.lex_state = 65, .external_lex_state = 3},
  [1039] = {.lex_state = 65, .external_lex_state = 3},
  [1040] = {.lex_state = 65, .external_lex_state = 3},
  [1041] = {.lex_state = 65, .external_lex_state = 3},
  [1042] = {.lex_state = 65, .external_lex_state = 3},
  [1043] = {.lex_state = 65, .external_lex_state = 3},
  [1044] = {.lex_state = 66},
  [1045] = {.lex_state = 65, .external_lex_state = 3},
  [1046] = {.lex_state = 65, .external_lex_state = 2},
  [1047] = {.lex_state = 65, .external_lex_state = 3},
  [1048] = {.lex_state = 65, .external_lex_state = 3},
  [1049] = {.lex_state = 65, .external_lex_state = 3},
  [1050] = {.lex_state = 65, .external_lex_state = 3},
  [1051] = {.lex_state = 65, .external_lex_state = 3},
  [1052] = {.lex_state = 65, .external_lex_state = 2},
  [1053] = {.lex_state = 65, .external_lex_state = 3},
  [1054] = {.lex_state = 65, .external_lex_state = 3},
  [1055] = {.lex_state = 65, .external_lex_state = 3},
  [1056] = {.lex_state = 65, .external_lex_state = 3},
  [1057] = {.lex_state = 65, .external_lex_state = 3},
  [1058] = {.lex_state = 65, .external_lex_state = 3},
  [1059] = {.lex_state = 65, .external_lex_state = 2},
  [1060] = {.lex_state = 65, .external_lex_state = 3},
  [1061] = {.lex_state = 65, .external_lex_state = 3},
  [1062] = {.lex_state = 65, .external_lex_state = 3},
  [1063] = {.lex_state = 65, .external_lex_state = 3},
  [1064] = {.lex_state = 65, .external_lex_state = 3},
  [1065] = {.lex_state = 65, .external_lex_state = 3},
  [1066] = {.lex_state = 65, .external_lex_state = 2},
  [1067] = {.lex_state = 65, .external_lex_state = 2},
  [1068] = {.lex_state = 65, .external_lex_state = 2},
  [1069] = {.lex_state = 65, .external_lex_state = 2},
  [1070] = {.lex_state = 65, .external_lex_state = 3},
  [1071] = {.lex_state = 65, .external_lex_state = 3},
  [1072] = {.lex_state = 65, .external_lex_state = 3},
  [1073] = {.lex_state = 65, .external_lex_state = 3},
  [1074] = {.lex_state = 65, .external_lex_state = 3},
  [1075] = {.lex_state = 65, .external_lex_state = 2},
  [1076] = {.lex_state = 65, .external_lex_state = 3},
  [1077] = {.lex_state = 65, .external_lex_state = 2},
  [1078] = {.lex_state = 65, .external_lex_state = 3},
  [1079] = {.lex_state = 65, .external_lex_state = 3},
  [1080] = {.lex_state = 65, .external_lex_state = 3},
  [1081] = {.lex_state = 65, .external_lex_state = 3},
  [1082] = {.lex_state = 65, .external_lex_state = 3},
  [1083] = {.lex_state = 65, .external_lex_state = 2},
  [1084] = {.lex_state = 65, .external_lex_state = 3},
  [1085] = {.lex_state = 65, .external_lex_state = 3},
  [1086] = {.lex_state = 65, .external_lex_state = 3},
  [1087] = {.lex_state = 65, .external_lex_state = 3},
  [1088] = {.lex_state = 65, .external_lex_state = 3},
  [1089] = {.lex_state = 65, .external_lex_state = 3},
  [1090] = {.lex_state = 65, .external_lex_state = 3},
  [1091] = {.lex_state = 65, .external_lex_state = 3},
  [1092] = {.lex_state = 65, .external_lex_state = 3},
  [1093] = {.lex_state = 65, .external_lex_state = 3},
  [1094] = {.lex_state = 65, .external_lex_state = 3},
  [1095] = {.lex_state = 65, .external_lex_state = 2},
  [1096] = {.lex_state = 65, .external_lex_state = 2},
  [1097] = {.lex_state = 65, .external_lex_state = 3},
  [1098] = {.lex_state = 65, .external_lex_state = 2},
  [1099] = {.lex_state = 65, .external_lex_state = 2},
  [1100] = {.lex_state = 65, .external_lex_state = 3},
  [1101] = {.lex_state = 65, .external_lex_state = 3},
  [1102] = {.lex_state = 65, .external_lex_state = 3},
  [1103] = {.lex_state = 65, .external_lex_state = 3},
  [1104] = {.lex_state = 65, .external_lex_state = 2},
  [1105] = {.lex_state = 66},
  [1106] = {.lex_state = 65, .external_lex_state = 2},
  [1107] = {.lex_state = 65, .external_lex_state = 2},
  [1108] = {.lex_state = 65, .external_lex_state = 2},
  [1109] = {.lex_state = 65, .external_lex_state = 2},
  [1110] = {.lex_state = 65, .external_lex_state = 2},
  [1111] = {.lex_state = 65, .external_lex_state = 2},
  [1112] = {.lex_state = 65, .external_lex_state = 2},
  [1113] = {.lex_state = 65, .external_lex_state = 2},
  [1114] = {.lex_state = 65, .external_lex_state = 2},
  [1115] = {.lex_state = 65, .external_lex_state = 2},
  [1116] = {.lex_state = 65, .external_lex_state = 2},
  [1117] = {.lex_state = 65, .external_lex_state = 2},
  [1118] = {.lex_state = 65, .external_lex_state = 2},
  [1119] = {.lex_state = 65, .external_lex_state = 2},
  [1120] = {.lex_state = 65, .external_lex_state = 2},
  [1121] = {.lex_state = 65, .external_lex_state = 2},
  [1122] = {.lex_state = 65, .external_lex_state = 2},
  [1123] = {.lex_state = 65, .external_lex_state = 2},
  [1124] = {.lex_state = 65, .external_lex_state = 3},
  [1125] = {.lex_state = 65, .external_lex_state = 3},
  [1126] = {.lex_state = 65, .external_lex_state = 3},
  [1127] = {.lex_state = 65, .external_lex_state = 2},
  [1128] = {.lex_state = 65, .external_lex_state = 2},
  [1129] = {.lex_state = 65, .external_lex_state = 2},
  [1130] = {.lex_state = 65, .external_lex_state = 3},
  [1131] = {.lex_state = 65, .external_lex_state = 3},
  [1132] = {.lex_state = 65, .external_lex_state = 2},
  [1133] = {.lex_state = 65, .external_lex_state = 3},
  [1134] = {.lex_state = 65, .external_lex_state = 3},
  [1135] = {.lex_state = 65, .external_lex_state = 3},
  [1136] = {.lex_state = 65, .external_lex_state = 3},
  [1137] = {.lex_state = 65, .external_lex_state = 3},
  [1138] = {.lex_state = 65, .external_lex_state = 3},
  [1139] = {.lex_state = 65, .external_lex_state = 3},
  [1140] = {.lex_state = 66},
  [1141] = {.lex_state = 65, .external_lex_state = 3},
  [1142] = {.lex_state = 65, .external_lex_state = 3},
  [1143] = {.lex_state = 65, .external_lex_state = 3},
  [1144] = {.lex_state = 65, .external_lex_state = 3},
  [1145] = {.lex_state = 65, .external_lex_state = 3},
  [1146] = {.lex_state = 65, .external_lex_state = 3},
  [1147] = {.lex_state = 65, .external_lex_state = 3},
  [1148] = {.lex_state = 65, .external_lex_state = 3},
  [1149] = {.lex_state = 65, .external_lex_state = 2},
  [1150] = {.lex_state = 65, .external_lex_state = 3},
  [1151] = {.lex_state = 65, .external_lex_state = 3},
  [1152] = {.lex_state = 65, .external_lex_state = 3},
  [1153] = {.lex_state = 65, .external_lex_state = 3},
  [1154] = {.lex_state = 65, .external_lex_state = 3},
  [1155] = {.lex_state = 65, .external_lex_state = 3},
  [1156] = {.lex_state = 65, .external_lex_state = 3},
  [1157] = {.lex_state = 65, .external_lex_state = 2},
  [1158] = {.lex_state = 65, .external_lex_state = 3},
  [1159] = {.lex_state = 65, .external_lex_state = 3},
  [1160] = {.lex_state = 65, .external_lex_state = 3},
  [1161] = {.lex_state = 65, .external_lex_state = 3},
  [1162] = {.lex_state = 65, .external_lex_state = 3},
  [1163] = {.lex_state = 65, .external_lex_state = 2},
  [1164] = {.lex_state = 65, .external_lex_state = 3},
  [1165] = {.lex_state = 65, .external_lex_state = 3},
  [1166] = {.lex_state = 65, .external_lex_state = 3},
  [1167] = {.lex_state = 65, .external_lex_state = 3},
  [1168] = {.lex_state = 65, .external_lex_state = 3},
  [1169] = {.lex_state = 65, .external_lex_state = 3},
  [1170] = {.lex_state = 65, .external_lex_state = 3},
  [1171] = {.lex_state = 65, .external_lex_state = 3},
  [1172] = {.lex_state = 65, .external_lex_state = 3},
  [1173] = {.lex_state = 65, .external_lex_state = 3},
  [1174] = {.lex_state = 65, .external_lex_state = 3},
  [1175] = {.lex_state = 66, .external_lex_state = 4},
  [1176] = {.lex_state = 65, .external_lex_state = 3},
  [1177] = {.lex_state = 65, .external_lex_state = 3},
  [1178] = {.lex_state = 65, .external_lex_state = 3},
  [1179] = {.lex_state = 65, .external_lex_state = 3},
  [1180] = {.lex_state = 65, .external_lex_state = 3},
  [1181] = {.lex_state = 8, .external_lex_state = 3},
  [1182] = {.lex_state = 65, .external_lex_state = 3},
  [1183] = {.lex_state = 65, .external_lex_state = 3},
  [1184] = {.lex_state = 65, .external_lex_state = 3},
  [1185] = {.lex_state = 9, .external_lex_state = 3},
  [1186] = {.lex_state = 65, .external_lex_state = 3},
  [1187] = {.lex_state = 65, .external_lex_state = 3},
  [1188] = {.lex_state = 65, .external_lex_state = 3},
  [1189] = {.lex_state = 65, .external_lex_state = 3},
  [1190] = {.lex_state = 65, .external_lex_state = 3},
  [1191] = {.lex_state = 8, .external_lex_state = 3},
  [1192] = {.lex_state = 66},
  [1193] = {.lex_state = 65, .external_lex_state = 3},
  [1194] = {.lex_state = 65, .external_lex_state = 3},
  [1195] = {.lex_state = 65, .external_lex_state = 3},
  [1196] = {.lex_state = 65, .external_lex_state = 3},
  [1197] = {.lex_state = 65, .external_lex_state = 3},
  [1198] = {.lex_state = 65, .external_lex_state = 2},
  [1199] = {.lex_state = 65, .external_lex_state = 3},
  [1200] = {.lex_state = 66, .external_lex_state = 4},
  [1201] = {.lex_state = 65, .external_lex_state = 3},
  [1202] = {.lex_state = 66, .external_lex_state = 4},
  [1203] = {.lex_state = 66, .external_lex_state = 4},
  [1204] = {.lex_state = 8, .external_lex_state = 3},
  [1205] = {.lex_state = 8, .external_lex_state = 3},
  [1206] = {.lex_state = 65, .external_lex_state = 2},
  [1207] = {.lex_state = 65, .external_lex_state = 3},
  [1208] = {.lex_state = 66},
  [1209] = {.lex_state = 65, .external_lex_state = 3},
  [1210] = {.lex_state = 66},
  [1211] = {.lex_state = 65, .external_lex_state = 3},
  [1212] = {.lex_state = 66},
  [1213] = {.lex_state = 65, .external_lex_state = 3},
  [1214] = {.lex_state = 65, .external_lex_state = 3},
  [1215] = {.lex_state = 65, .external_lex_state = 3},
  [1216] = {.lex_state = 65, .external_lex_state = 2},
  [1217] = {.lex_state = 66},
  [1218] = {.lex_state = 66},
  [1219] = {.lex_state = 65, .external_lex_state = 3},
  [1220] = {.lex_state = 65, .external_lex_state = 3},
  [1221] = {.lex_state = 66},
  [1222] = {.lex_state = 66},
  [1223] = {.lex_state = 65, .external_lex_state = 2},
  [1224] = {.lex_state = 66},
  [1225] = {.lex_state = 8, .external_lex_state = 3},
  [1226] = {.lex_state = 65, .external_lex_state = 3},
  [1227] = {.lex_state = 65, .external_lex_state = 3},
  [1228] = {.lex_state = 65, .external_lex_state = 3},
  [1229] = {.lex_state = 65, .external_lex_state = 3},
  [1230] = {.lex_state = 65, .external_lex_state = 3},
  [1231] = {.lex_state = 65, .external_lex_state = 3},
  [1232] = {.lex_state = 65, .external_lex_state = 3},
  [1233] = {.lex_state = 65, .external_lex_state = 3},
  [1234] = {.lex_state = 65, .external_lex_state = 3},
  [1235] = {.lex_state = 65, .external_lex_state = 3},
  [1236] = {.lex_state = 65, .external_lex_state = 3},
  [1237] = {.lex_state = 66, .external_lex_state = 4},
  [1238] = {.lex_state = 8, .external_lex_state = 3},
  [1239] = {.lex_state = 65, .external_lex_state = 3},
  [1240] = {.lex_state = 65, .external_lex_state = 3},
  [1241] = {.lex_state = 65, .external_lex_state = 3},
  [1242] = {.lex_state = 65, .external_lex_state = 3},
  [1243] = {.lex_state = 8, .external_lex_state = 3},
  [1244] = {.lex_state = 65, .external_lex_state = 3},
  [1245] = {.lex_state = 65, .external_lex_state = 3},
  [1246] = {.lex_state = 65, .external_lex_state = 3},
  [1247] = {.lex_state = 65, .external_lex_state = 3},
  [1248] = {.lex_state = 8, .external_lex_state = 3},
  [1249] = {.lex_state = 8, .external_lex_state = 3},
  [1250] = {.lex_state = 65, .external_lex_state = 2},
  [1251] = {.lex_state = 8, .external_lex_state = 3},
  [1252] = {.lex_state = 8, .external_lex_state = 3},
  [1253] = {.lex_state = 65, .external_lex_state = 2},
  [1254] = {.lex_state = 66, .external_lex_state = 4},
  [1255] = {.lex_state = 66},
  [1256] = {.lex_state = 66},
  [1257] = {.lex_state = 65, .external_lex_state = 2},
  [1258] = {.lex_state = 8, .external_lex_state = 3},
  [1259] = {.lex_state = 8, .external_lex_state = 3},
  [1260] = {.lex_state = 66, .external_lex_state = 4},
  [1261] = {.lex_state = 8, .external_lex_state = 3},
  [1262] = {.lex_state = 66, .external_lex_state = 4},
  [1263] = {.lex_state = 66, .external_lex_state = 4},
  [1264] = {.lex_state = 8, .external_lex_state = 3},
  [1265] = {.lex_state = 8, .external_lex_state = 3},
  [1266] = {.lex_state = 65, .external_lex_state = 2},
  [1267] = {.lex_state = 8, .external_lex_state = 3},
  [1268] = {.lex_state = 8, .external_lex_state = 3},
  [1269] = {.lex_state = 65, .external_lex_state = 3},
  [1270] = {.lex_state = 65, .external_lex_state = 2},
  [1271] = {.lex_state = 65, .external_lex_state = 3},
  [1272] = {.lex_state = 65, .external_lex_state = 3},
  [1273] = {.lex_state = 65, .external_lex_state = 2},
  [1274] = {.lex_state = 8, .external_lex_state = 3},
  [1275] = {.lex_state = 65, .external_lex_state = 2},
  [1276] = {.lex_state = 65, .external_lex_state = 3},
  [1277] = {.lex_state = 65, .external_lex_state = 3},
  [1278] = {.lex_state = 66, .external_lex_state = 4},
  [1279] = {.lex_state = 66, .external_lex_state = 4},
  [1280] = {.lex_state = 65, .external_lex_state = 2},
  [1281] = {.lex_state = 65, .external_lex_state = 2},
  [1282] = {.lex_state = 65, .external_lex_state = 3},
  [1283] = {.lex_state = 8, .external_lex_state = 3},
  [1284] = {.lex_state = 8, .external_lex_state = 3},
  [1285] = {.lex_state = 8, .external_lex_state = 3},
  [1286] = {.lex_state = 65, .external_lex_state = 2},
  [1287] = {.lex_state = 8, .external_lex_state = 3},
  [1288] = {.lex_state = 65, .external_lex_state = 3},
  [1289] = {.lex_state = 66, .external_lex_state = 4},
  [1290] = {.lex_state = 65, .external_lex_state = 2},
  [1291] = {.lex_state = 65, .external_lex_state = 3},
  [1292] = {.lex_state = 65, .external_lex_state = 2},
  [1293] = {.lex_state = 65, .external_lex_state = 2},
  [1294] = {.lex_state = 65, .external_lex_state = 3},
  [1295] = {.lex_state = 65, .external_lex_state = 3},
  [1296] = {.lex_state = 65, .external_lex_state = 2},
  [1297] = {.lex_state = 65, .external_lex_state = 3},
  [1298] = {.lex_state = 65, .external_lex_state = 3},
  [1299] = {.lex_state = 65, .external_lex_state = 3},
  [1300] = {.lex_state = 65, .external_lex_state = 3},
  [1301] = {.lex_state = 66},
  [1302] = {.lex_state = 65, .external_lex_state = 2},
  [1303] = {.lex_state = 8, .external_lex_state = 3},
  [1304] = {.lex_state = 66},
  [1305] = {.lex_state = 8, .external_lex_state = 3},
  [1306] = {.lex_state = 8, .external_lex_state = 3},
  [1307] = {.lex_state = 65, .external_lex_state = 3},
  [1308] = {.lex_state = 8, .external_lex_state = 3},
  [1309] = {.lex_state = 65, .external_lex_state = 3},
  [1310] = {.lex_state = 65, .external_lex_state = 3},
  [1311] = {.lex_state = 8, .external_lex_state = 3},
  [1312] = {.lex_state = 65, .external_lex_state = 2},
  [1313] = {.lex_state = 8, .external_lex_state = 3},
  [1314] = {.lex_state = 65, .external_lex_state = 2},
  [1315] = {.lex_state = 8, .external_lex_state = 3},
  [1316] = {.lex_state = 65, .external_lex_state = 3},
  [1317] = {.lex_state = 66},
  [1318] = {.lex_state = 65, .external_lex_state = 2},
  [1319] = {.lex_state = 65, .external_lex_state = 3},
  [1320] = {.lex_state = 65, .external_lex_state = 2},
  [1321] = {.lex_state = 66, .external_lex_state = 4},
  [1322] = {.lex_state = 8, .external_lex_state = 3},
  [1323] = {.lex_state = 8, .external_lex_state = 3},
  [1324] = {.lex_state = 65, .external_lex_state = 2},
  [1325] = {.lex_state = 65, .external_lex_state = 2},
  [1326] = {.lex_state = 65, .external_lex_state = 2},
  [1327] = {.lex_state = 65, .external_lex_state = 2},
  [1328] = {.lex_state = 65, .external_lex_state = 2},
  [1329] = {.lex_state = 65, .external_lex_state = 2},
  [1330] = {.lex_state = 65, .external_lex_state = 3},
  [1331] = {.lex_state = 65, .external_lex_state = 2},
  [1332] = {.lex_state = 65, .external_lex_state = 3},
  [1333] = {.lex_state = 65, .external_lex_state = 2},
  [1334] = {.lex_state = 65, .external_lex_state = 3},
  [1335] = {.lex_state = 65, .external_lex_state = 2},
  [1336] = {.lex_state = 65, .external_lex_state = 2},
  [1337] = {.lex_state = 65, .external_lex_state = 3},
  [1338] = {.lex_state = 65, .external_lex_state = 3},
  [1339] = {.lex_state = 65, .external_lex_state = 2},
  [1340] = {.lex_state = 65, .external_lex_state = 3},
  [1341] = {.lex_state = 65, .external_lex_state = 2},
  [1342] = {.lex_state = 65, .external_lex_state = 2},
  [1343] = {.lex_state = 65, .external_lex_state = 2},
  [1344] = {.lex_state = 65, .external_lex_state = 3},
  [1345] = {.lex_state = 65, .external_lex_state = 2},
  [1346] = {.lex_state = 65, .external_lex_state = 2},
  [1347] = {.lex_state = 65, .external_lex_state = 2},
  [1348] = {.lex_state = 65, .external_lex_state = 2},
  [1349] = {.lex_state = 65, .external_lex_state = 2},
  [1350] = {.lex_state = 65, .external_lex_state = 2},
  [1351] = {.lex_state = 65, .external_lex_state = 2},
  [1352] = {.lex_state = 65, .external_lex_state = 3},
  [1353] = {.lex_state = 8, .external_lex_state = 3},
  [1354] = {.lex_state = 65, .external_lex_state = 2},
  [1355] = {.lex_state = 65, .external_lex_state = 2},
  [1356] = {.lex_state = 65, .external_lex_state = 2},
  [1357] = {.lex_state = 65, .external_lex_state = 2},
  [1358] = {.lex_state = 65, .external_lex_state = 2},
  [1359] = {.lex_state = 65, .external_lex_state = 2},
  [1360] = {.lex_state = 65, .external_lex_state = 2},
  [1361] = {.lex_state = 65, .external_lex_state = 2},
  [1362] = {.lex_state = 65, .external_lex_state = 2},
  [1363] = {.lex_state = 65, .external_lex_state = 3},
  [1364] = {.lex_state = 65, .external_lex_state = 2},
  [1365] = {.lex_state = 65, .external_lex_state = 2},
  [1366] = {.lex_state = 66, .external_lex_state = 4},
  [1367] = {.lex_state = 65, .external_lex_state = 3},
  [1368] = {.lex_state = 65, .external_lex_state = 2},
  [1369] = {.lex_state = 65, .external_lex_state = 2},
  [1370] = {.lex_state = 65, .external_lex_state = 3},
  [1371] = {.lex_state = 65, .external_lex_state = 2},
  [1372] = {.lex_state = 65, .external_lex_state = 2},
  [1373] = {.lex_state = 65, .external_lex_state = 2},
  [1374] = {.lex_state = 66, .external_lex_state = 4},
  [1375] = {.lex_state = 65, .external_lex_state = 2},
  [1376] = {.lex_state = 65, .external_lex_state = 3},
  [1377] = {.lex_state = 65, .external_lex_state = 3},
  [1378] = {.lex_state = 65, .external_lex_state = 2},
  [1379] = {.lex_state = 65, .external_lex_state = 2},
  [1380] = {.lex_state = 66, .external_lex_state = 4},
  [1381] = {.lex_state = 65, .external_lex_state = 2},
  [1382] = {.lex_state = 65, .external_lex_state = 2},
  [1383] = {.lex_state = 66, .external_lex_state = 4},
  [1384] = {.lex_state = 65, .external_lex_state = 3},
  [1385] = {.lex_state = 66, .external_lex_state = 4},
  [1386] = {.lex_state = 65, .external_lex_state = 2},
  [1387] = {.lex_state = 65, .external_lex_state = 3},
  [1388] = {.lex_state = 65, .external_lex_state = 2},
  [1389] = {.lex_state = 65, .external_lex_state = 2},
  [1390] = {.lex_state = 65, .external_lex_state = 3},
  [1391] = {.lex_state = 66, .external_lex_state = 4},
  [1392] = {.lex_state = 65, .external_lex_state = 3},
  [1393] = {.lex_state = 8, .external_lex_state = 2},
  [1394] = {.lex_state = 65, .external_lex_state = 2},
  [1395] = {.lex_state = 66, .external_lex_state = 4},
  [1396] = {.lex_state = 65, .external_lex_state = 2},
  [1397] = {.lex_state = 65, .external_lex_state = 3},
  [1398] = {.lex_state = 65, .external_lex_state = 2},
  [1399] = {.lex_state = 65, .external_lex_state = 3},
  [1400] = {.lex_state = 65, .external_lex_state = 2},
  [1401] = {.lex_state = 65, .external_lex_state = 2},
  [1402] = {.lex_state = 65, .external_lex_state = 2},
  [1403] = {.lex_state = 66, .external_lex_state = 4},
  [1404] = {.lex_state = 65, .external_lex_state = 3},
  [1405] = {.lex_state = 65, .external_lex_state = 3},
  [1406] = {.lex_state = 8, .external_lex_state = 3},
  [1407] = {.lex_state = 65, .external_lex_state = 3},
  [1408] = {.lex_state = 9, .external_lex_state = 2},
  [1409] = {.lex_state = 65, .external_lex_state = 2},
  [1410] = {.lex_state = 65, .external_lex_state = 3},
  [1411] = {.lex_state = 65, .external_lex_state = 2},
  [1412] = {.lex_state = 65, .external_lex_state = 2},
  [1413] = {.lex_state = 8, .external_lex_state = 3},
  [1414] = {.lex_state = 8, .external_lex_state = 3},
  [1415] = {.lex_state = 8, .external_lex_state = 3},
  [1416] = {.lex_state = 8, .external_lex_state = 3},
  [1417] = {.lex_state = 65, .external_lex_state = 2},
  [1418] = {.lex_state = 65, .external_lex_state = 3},
  [1419] = {.lex_state = 65, .external_lex_state = 2},
  [1420] = {.lex_state = 65, .external_lex_state = 3},
  [1421] = {.lex_state = 65, .external_lex_state = 2},
  [1422] = {.lex_state = 65, .external_lex_state = 2},
  [1423] = {.lex_state = 66, .external_lex_state = 4},
  [1424] = {.lex_state = 66, .external_lex_state = 4},
  [1425] = {.lex_state = 66, .external_lex_state = 4},
  [1426] = {.lex_state = 66, .external_lex_state = 4},
  [1427] = {.lex_state = 66, .external_lex_state = 4},
  [1428] = {.lex_state = 66, .external_lex_state = 4},
  [1429] = {.lex_state = 65, .external_lex_state = 2},
  [1430] = {.lex_state = 65, .external_lex_state = 2},
  [1431] = {.lex_state = 65, .external_lex_state = 2},
  [1432] = {.lex_state = 65, .external_lex_state = 2},
  [1433] = {.lex_state = 65, .external_lex_state = 2},
  [1434] = {.lex_state = 65, .external_lex_state = 2},
  [1435] = {.lex_state = 66, .external_lex_state = 4},
  [1436] = {.lex_state = 65, .external_lex_state = 2},
  [1437] = {.lex_state = 65, .external_lex_state = 2},
  [1438] = {.lex_state = 65, .external_lex_state = 2},
  [1439] = {.lex_state = 65, .external_lex_state = 2},
  [1440] = {.lex_state = 65, .external_lex_state = 2},
  [1441] = {.lex_state = 8, .external_lex_state = 3},
  [1442] = {.lex_state = 8, .external_lex_state = 2},
  [1443] = {.lex_state = 66, .external_lex_state = 4},
  [1444] = {.lex_state = 66, .external_lex_state = 4},
  [1445] = {.lex_state = 8, .external_lex_state = 3},
  [1446] = {.lex_state = 8, .external_lex_state = 3},
  [1447] = {.lex_state = 66, .external_lex_state = 4},
  [1448] = {.lex_state = 8, .external_lex_state = 3},
  [1449] = {.lex_state = 66, .external_lex_state = 4},
  [1450] = {.lex_state = 65, .external_lex_state = 3},
  [1451] = {.lex_state = 65, .external_lex_state = 3},
  [1452] = {.lex_state = 65, .external_lex_state = 2},
  [1453] = {.lex_state = 8, .external_lex_state = 3},
  [1454] = {.lex_state = 66, .external_lex_state = 4},
  [1455] = {.lex_state = 65, .external_lex_state = 2},
  [1456] = {.lex_state = 8, .external_lex_state = 3},
  [1457] = {.lex_state = 65, .external_lex_state = 2},
  [1458] = {.lex_state = 65, .external_lex_state = 2},
  [1459] = {.lex_state = 9, .external_lex_state = 3},
  [1460] = {.lex_state = 66, .external_lex_state = 4},
  [1461] = {.lex_state = 65, .external_lex_state = 2},
  [1462] = {.lex_state = 8, .external_lex_state = 3},
  [1463] = {.lex_state = 65, .external_lex_state = 3},
  [1464] = {.lex_state = 65, .external_lex_state = 3},
  [1465] = {.lex_state = 65, .external_lex_state = 2},
  [1466] = {.lex_state = 65, .external_lex_state = 2},
  [1467] = {.lex_state = 8, .external_lex_state = 2},
  [1468] = {.lex_state = 65, .external_lex_state = 2},
  [1469] = {.lex_state = 65, .external_lex_state = 2},
  [1470] = {.lex_state = 65, .external_lex_state = 2},
  [1471] = {.lex_state = 65, .external_lex_state = 2},
  [1472] = {.lex_state = 65, .external_lex_state = 2},
  [1473] = {.lex_state = 65, .external_lex_state = 3},
  [1474] = {.lex_state = 65, .external_lex_state = 2},
  [1475] = {.lex_state = 66, .external_lex_state = 4},
  [1476] = {.lex_state = 8, .external_lex_state = 3},
  [1477] = {.lex_state = 65, .external_lex_state = 2},
  [1478] = {.lex_state = 65, .external_lex_state = 2},
  [1479] = {.lex_state = 65, .external_lex_state = 2},
  [1480] = {.lex_state = 65, .external_lex_state = 2},
  [1481] = {.lex_state = 65, .external_lex_state = 2},
  [1482] = {.lex_state = 65, .external_lex_state = 3},
  [1483] = {.lex_state = 65, .external_lex_state = 3},
  [1484] = {.lex_state = 65, .external_lex_state = 3},
  [1485] = {.lex_state = 66, .external_lex_state = 4},
  [1486] = {.lex_state = 65, .external_lex_state = 3},
  [1487] = {.lex_state = 65, .external_lex_state = 2},
  [1488] = {.lex_state = 65, .external_lex_state = 2},
  [1489] = {.lex_state = 66, .external_lex_state = 4},
  [1490] = {.lex_state = 65, .external_lex_state = 2},
  [1491] = {.lex_state = 65, .external_lex_state = 2},
  [1492] = {.lex_state = 65, .external_lex_state = 2},
  [1493] = {.lex_state = 65, .external_lex_state = 3},
  [1494] = {.lex_state = 8, .external_lex_state = 3},
  [1495] = {.lex_state = 65, .external_lex_state = 2},
  [1496] = {.lex_state = 65, .external_lex_state = 2},
  [1497] = {.lex_state = 65, .external_lex_state = 3},
  [1498] = {.lex_state = 66, .external_lex_state = 4},
  [1499] = {.lex_state = 65, .external_lex_state = 3},
  [1500] = {.lex_state = 65, .external_lex_state = 2},
  [1501] = {.lex_state = 66, .external_lex_state = 4},
  [1502] = {.lex_state = 65, .external_lex_state = 2},
  [1503] = {.lex_state = 65, .external_lex_state = 2},
  [1504] = {.lex_state = 65, .external_lex_state = 3},
  [1505] = {.lex_state = 65, .external_lex_state = 2},
  [1506] = {.lex_state = 65, .external_lex_state = 3},
  [1507] = {.lex_state = 65, .external_lex_state = 2},
  [1508] = {.lex_state = 65, .external_lex_state = 2},
  [1509] = {.lex_state = 65, .external_lex_state = 3},
  [1510] = {.lex_state = 65, .external_lex_state = 3},
  [1511] = {.lex_state = 65, .external_lex_state = 3},
  [1512] = {.lex_state = 65, .external_lex_state = 2},
  [1513] = {.lex_state = 65, .external_lex_state = 2},
  [1514] = {.lex_state = 65, .external_lex_state = 2},
  [1515] = {.lex_state = 65, .external_lex_state = 2},
  [1516] = {.lex_state = 65, .external_lex_state = 2},
  [1517] = {.lex_state = 65, .external_lex_state = 2},
  [1518] = {.lex_state = 8, .external_lex_state = 3},
  [1519] = {.lex_state = 65, .external_lex_state = 2},
  [1520] = {.lex_state = 65, .external_lex_state = 2},
  [1521] = {.lex_state = 65, .external_lex_state = 2},
  [1522] = {.lex_state = 8, .external_lex_state = 3},
  [1523] = {.lex_state = 65, .external_lex_state = 2},
  [1524] = {.lex_state = 65, .external_lex_state = 3},
  [1525] = {.lex_state = 65, .external_lex_state = 2},
  [1526] = {.lex_state = 65, .external_lex_state = 2},
  [1527] = {.lex_state = 65, .external_lex_state = 2},
  [1528] = {.lex_state = 65, .external_lex_state = 2},
  [1529] = {.lex_state = 65, .external_lex_state = 2},
  [1530] = {.lex_state = 65, .external_lex_state = 2},
  [1531] = {.lex_state = 65, .external_lex_state = 2},
  [1532] = {.lex_state = 65, .external_lex_state = 2},
  [1533] = {.lex_state = 65, .external_lex_state = 2},
  [1534] = {.lex_state = 65, .external_lex_state = 2},
  [1535] = {.lex_state = 65, .external_lex_state = 2},
  [1536] = {.lex_state = 65, .external_lex_state = 2},
  [1537] = {.lex_state = 66, .external_lex_state = 4},
  [1538] = {.lex_state = 11, .external_lex_state = 3},
  [1539] = {.lex_state = 65, .external_lex_state = 3},
  [1540] = {.lex_state = 65, .external_lex_state = 2},
  [1541] = {.lex_state = 65, .external_lex_state = 2},
  [1542] = {.lex_state = 65, .external_lex_state = 2},
  [1543] = {.lex_state = 65, .external_lex_state = 2},
  [1544] = {.lex_state = 65, .external_lex_state = 2},
  [1545] = {.lex_state = 65, .external_lex_state = 2},
  [1546] = {.lex_state = 65, .external_lex_state = 2},
  [1547] = {.lex_state = 66, .external_lex_state = 4},
  [1548] = {.lex_state = 65, .external_lex_state = 2},
  [1549] = {.lex_state = 65, .external_lex_state = 2},
  [1550] = {.lex_state = 65, .external_lex_state = 2},
  [1551] = {.lex_state = 65, .external_lex_state = 3},
  [1552] = {.lex_state = 65, .external_lex_state = 3},
  [1553] = {.lex_state = 66, .external_lex_state = 4},
  [1554] = {.lex_state = 65, .external_lex_state = 2},
  [1555] = {.lex_state = 65, .external_lex_state = 2},
  [1556] = {.lex_state = 65, .external_lex_state = 2},
  [1557] = {.lex_state = 65, .external_lex_state = 2},
  [1558] = {.lex_state = 65, .external_lex_state = 2},
  [1559] = {.lex_state = 66, .external_lex_state = 4},
  [1560] = {.lex_state = 65, .external_lex_state = 3},
  [1561] = {.lex_state = 66, .external_lex_state = 4},
  [1562] = {.lex_state = 66, .external_lex_state = 4},
  [1563] = {.lex_state = 66, .external_lex_state = 4},
  [1564] = {.lex_state = 65, .external_lex_state = 2},
  [1565] = {.lex_state = 65, .external_lex_state = 2},
  [1566] = {.lex_state = 65, .external_lex_state = 2},
  [1567] = {.lex_state = 65, .external_lex_state = 2},
  [1568] = {.lex_state = 65, .external_lex_state = 2},
  [1569] = {.lex_state = 65, .external_lex_state = 2},
  [1570] = {.lex_state = 65, .external_lex_state = 2},
  [1571] = {.lex_state = 65, .external_lex_state = 2},
  [1572] = {.lex_state = 65, .external_lex_state = 2},
  [1573] = {.lex_state = 8, .external_lex_state = 3},
  [1574] = {.lex_state = 8, .external_lex_state = 3},
  [1575] = {.lex_state = 8, .external_lex_state = 3},
  [1576] = {.lex_state = 8, .external_lex_state = 3},
  [1577] = {.lex_state = 66, .external_lex_state = 4},
  [1578] = {.lex_state = 8, .external_lex_state = 3},
  [1579] = {.lex_state = 66, .external_lex_state = 4},
  [1580] = {.lex_state = 8, .external_lex_state = 3},
  [1581] = {.lex_state = 65, .external_lex_state = 3},
  [1582] = {.lex_state = 8, .external_lex_state = 3},
  [1583] = {.lex_state = 8, .external_lex_state = 3},
  [1584] = {.lex_state = 66, .external_lex_state = 4},
  [1585] = {.lex_state = 66},
  [1586] = {.lex_state = 8, .external_lex_state = 3},
  [1587] = {.lex_state = 8, .external_lex_state = 3},
  [1588] = {.lex_state = 66},
  [1589] = {.lex_state = 8, .external_lex_state = 3},
  [1590] = {.lex_state = 66},
  [1591] = {.lex_state = 65, .external_lex_state = 3},
  [1592] = {.lex_state = 8, .external_lex_state = 3},
  [1593] = {.lex_state = 8, .external_lex_state = 3},
  [1594] = {.lex_state = 8, .external_lex_state = 3},
  [1595] = {.lex_state = 8, .external_lex_state = 3},
  [1596] = {.lex_state = 8, .external_lex_state = 3},
  [1597] = {.lex_state = 8, .external_lex_state = 3},
  [1598] = {.lex_state = 65, .external_lex_state = 3},
  [1599] = {.lex_state = 8, .external_lex_state = 3},
  [1600] = {.lex_state = 66, .external_lex_state = 4},
  [1601] = {.lex_state = 8, .external_lex_state = 3},
  [1602] = {.lex_state = 65, .external_lex_state = 3},
  [1603] = {.lex_state = 8, .external_lex_state = 3},
  [1604] = {.lex_state = 8, .external_lex_state = 3},
  [1605] = {.lex_state = 8, .external_lex_state = 3},
  [1606] = {.lex_state = 8, .external_lex_state = 3},
  [1607] = {.lex_state = 8, .external_lex_state = 3},
  [1608] = {.lex_state = 8, .external_lex_state = 3},
  [1609] = {.lex_state = 8, .external_lex_state = 3},
  [1610] = {.lex_state = 66, .external_lex_state = 4},
  [1611] = {.lex_state = 8, .external_lex_state = 3},
  [1612] = {.lex_state = 8, .external_lex_state = 3},
  [1613] = {.lex_state = 8, .external_lex_state = 3},
  [1614] = {.lex_state = 8, .external_lex_state = 3},
  [1615] = {.lex_state = 8, .external_lex_state = 3},
  [1616] = {.lex_state = 8, .external_lex_state = 3},
  [1617] = {.lex_state = 8, .external_lex_state = 3},
  [1618] = {.lex_state = 8, .external_lex_state = 3},
  [1619] = {.lex_state = 8, .external_lex_state = 3},
  [1620] = {.lex_state = 8, .external_lex_state = 3},
  [1621] = {.lex_state = 8, .external_lex_state = 3},
  [1622] = {.lex_state = 8, .external_lex_state = 3},
  [1623] = {.lex_state = 8, .external_lex_state = 3},
  [1624] = {.lex_state = 66, .external_lex_state = 4},
  [1625] = {.lex_state = 65, .external_lex_state = 2},
  [1626] = {.lex_state = 66, .external_lex_state = 4},
  [1627] = {.lex_state = 8, .external_lex_state = 3},
  [1628] = {.lex_state = 8, .external_lex_state = 3},
  [1629] = {.lex_state = 66, .external_lex_state = 4},
  [1630] = {.lex_state = 8, .external_lex_state = 3},
  [1631] = {.lex_state = 8, .external_lex_state = 3},
  [1632] = {.lex_state = 8, .external_lex_state = 3},
  [1633] = {.lex_state = 8, .external_lex_state = 3},
  [1634] = {.lex_state = 8, .external_lex_state = 3},
  [1635] = {.lex_state = 8, .external_lex_state = 3},
  [1636] = {.lex_state = 66, .external_lex_state = 4},
  [1637] = {.lex_state = 8, .external_lex_state = 3},
  [1638] = {.lex_state = 8, .external_lex_state = 3},
  [1639] = {.lex_state = 8, .external_lex_state = 3},
  [1640] = {.lex_state = 8, .external_lex_state = 3},
  [1641] = {.lex_state = 8, .external_lex_state = 3},
  [1642] = {.lex_state = 8, .external_lex_state = 3},
  [1643] = {.lex_state = 8, .external_lex_state = 3},
  [1644] = {.lex_state = 8, .external_lex_state = 3},
  [1645] = {.lex_state = 8, .external_lex_state = 3},
  [1646] = {.lex_state = 8, .external_lex_state = 3},
  [1647] = {.lex_state = 66, .external_lex_state = 4},
  [1648] = {.lex_state = 8, .external_lex_state = 3},
  [1649] = {.lex_state = 8, .external_lex_state = 3},
  [1650] = {.lex_state = 8, .external_lex_state = 3},
  [1651] = {.lex_state = 8, .external_lex_state = 3},
  [1652] = {.lex_state = 65, .external_lex_state = 3},
  [1653] = {.lex_state = 8, .external_lex_state = 3},
  [1654] = {.lex_state = 8, .external_lex_state = 3},
  [1655] = {.lex_state = 8, .external_lex_state = 3},
  [1656] = {.lex_state = 8, .external_lex_state = 3},
  [1657] = {.lex_state = 8, .external_lex_state = 3},
  [1658] = {.lex_state = 8, .external_lex_state = 3},
  [1659] = {.lex_state = 8, .external_lex_state = 3},
  [1660] = {.lex_state = 8, .external_lex_state = 3},
  [1661] = {.lex_state = 8, .external_lex_state = 3},
  [1662] = {.lex_state = 8, .external_lex_state = 3},
  [1663] = {.lex_state = 65, .external_lex_state = 3},
  [1664] = {.lex_state = 8, .external_lex_state = 3},
  [1665] = {.lex_state = 65, .external_lex_state = 2},
  [1666] = {.lex_state = 8, .external_lex_state = 3},
  [1667] = {.lex_state = 66, .external_lex_state = 4},
  [1668] = {.lex_state = 8, .external_lex_state = 3},
  [1669] = {.lex_state = 8, .external_lex_state = 3},
  [1670] = {.lex_state = 8, .external_lex_state = 3},
  [1671] = {.lex_state = 66, .external_lex_state = 4},
  [1672] = {.lex_state = 8, .external_lex_state = 3},
  [1673] = {.lex_state = 8, .external_lex_state = 3},
  [1674] = {.lex_state = 66, .external_lex_state = 4},
  [1675] = {.lex_state = 8, .external_lex_state = 3},
  [1676] = {.lex_state = 66},
  [1677] = {.lex_state = 66},
  [1678] = {.lex_state = 66, .external_lex_state = 4},
  [1679] = {.lex_state = 66},
  [1680] = {.lex_state = 66},
  [1681] = {.lex_state = 66},
  [1682] = {.lex_state = 66},
  [1683] = {.lex_state = 8, .external_lex_state = 3},
  [1684] = {.lex_state = 8, .external_lex_state = 3},
  [1685] = {.lex_state = 8, .external_lex_state = 3},
  [1686] = {.lex_state = 66, .external_lex_state = 4},
  [1687] = {.lex_state = 65, .external_lex_state = 3},
  [1688] = {.lex_state = 66},
  [1689] = {.lex_state = 66},
  [1690] = {.lex_state = 8, .external_lex_state = 3},
  [1691] = {.lex_state = 8, .external_lex_state = 3},
  [1692] = {.lex_state = 8, .external_lex_state = 3},
  [1693] = {.lex_state = 8, .external_lex_state = 3},
  [1694] = {.lex_state = 66},
  [1695] = {.lex_state = 8, .external_lex_state = 3},
  [1696] = {.lex_state = 8, .external_lex_state = 3},
  [1697] = {.lex_state = 8, .external_lex_state = 3},
  [1698] = {.lex_state = 66, .external_lex_state = 4},
  [1699] = {.lex_state = 8, .external_lex_state = 3},
  [1700] = {.lex_state = 66, .external_lex_state = 4},
  [1701] = {.lex_state = 66, .external_lex_state = 4},
  [1702] = {.lex_state = 8, .external_lex_state = 3},
  [1703] = {.lex_state = 8, .external_lex_state = 3},
  [1704] = {.lex_state = 65, .external_lex_state = 3},
  [1705] = {.lex_state = 8, .external_lex_state = 3},
  [1706] = {.lex_state = 8, .external_lex_state = 3},
  [1707] = {.lex_state = 65, .external_lex_state = 2},
  [1708] = {.lex_state = 8, .external_lex_state = 3},
  [1709] = {.lex_state = 65, .external_lex_state = 2},
  [1710] = {.lex_state = 66, .external_lex_state = 4},
  [1711] = {.lex_state = 8, .external_lex_state = 3},
  [1712] = {.lex_state = 8, .external_lex_state = 3},
  [1713] = {.lex_state = 66},
  [1714] = {.lex_state = 8, .external_lex_state = 3},
  [1715] = {.lex_state = 8, .external_lex_state = 3},
  [1716] = {.lex_state = 66},
  [1717] = {.lex_state = 66},
  [1718] = {.lex_state = 66},
  [1719] = {.lex_state = 66},
  [1720] = {.lex_state = 65, .external_lex_state = 3},
  [1721] = {.lex_state = 65, .external_lex_state = 3},
  [1722] = {.lex_state = 66},
  [1723] = {.lex_state = 65, .external_lex_state = 3},
  [1724] = {.lex_state = 65, .external_lex_state = 3},
  [1725] = {.lex_state = 66},
  [1726] = {.lex_state = 66},
  [1727] = {.lex_state = 66, .external_lex_state = 4},
  [1728] = {.lex_state = 66},
  [1729] = {.lex_state = 65, .external_lex_state = 3},
  [1730] = {.lex_state = 66},
  [1731] = {.lex_state = 65, .external_lex_state = 3},
  [1732] = {.lex_state = 66},
  [1733] = {.lex_state = 66},
  [1734] = {.lex_state = 66},
  [1735] = {.lex_state = 65, .external_lex_state = 3},
  [1736] = {.lex_state = 66},
  [1737] = {.lex_state = 66},
  [1738] = {.lex_state = 66},
  [1739] = {.lex_state = 66},
  [1740] = {.lex_state = 66},
  [1741] = {.lex_state = 66},
  [1742] = {.lex_state = 66},
  [1743] = {.lex_state = 66},
  [1744] = {.lex_state = 66},
  [1745] = {.lex_state = 66},
  [1746] = {.lex_state = 66},
  [1747] = {.lex_state = 66},
  [1748] = {.lex_state = 66},
  [1749] = {.lex_state = 66},
  [1750] = {.lex_state = 66},
  [1751] = {.lex_state = 66},
  [1752] = {.lex_state = 66},
  [1753] = {.lex_state = 66},
  [1754] = {.lex_state = 66},
  [1755] = {.lex_state = 66},
  [1756] = {.lex_state = 66},
  [1757] = {.lex_state = 66},
  [1758] = {.lex_state = 66},
  [1759] = {.lex_state = 66},
  [1760] = {.lex_state = 66},
  [1761] = {.lex_state = 66},
  [1762] = {.lex_state = 66},
  [1763] = {.lex_state = 66},
  [1764] = {.lex_state = 66},
  [1765] = {.lex_state = 66},
  [1766] = {.lex_state = 66},
  [1767] = {.lex_state = 66},
  [1768] = {.lex_state = 66},
  [1769] = {.lex_state = 66},
  [1770] = {.lex_state = 66},
  [1771] = {.lex_state = 66},
  [1772] = {.lex_state = 66},
  [1773] = {.lex_state = 66},
  [1774] = {.lex_state = 66},
  [1775] = {.lex_state = 66},
  [1776] = {.lex_state = 66},
  [1777] = {.lex_state = 66},
  [1778] = {.lex_state = 66},
  [1779] = {.lex_state = 66},
  [1780] = {.lex_state = 66},
  [1781] = {.lex_state = 66, .external_lex_state = 4},
  [1782] = {.lex_state = 66},
  [1783] = {.lex_state = 66},
  [1784] = {.lex_state = 66},
  [1785] = {.lex_state = 66, .external_lex_state = 4},
  [1786] = {.lex_state = 66, .external_lex_state = 4},
  [1787] = {.lex_state = 66},
  [1788] = {.lex_state = 66, .external_lex_state = 4},
  [1789] = {.lex_state = 66},
  [1790] = {.lex_state = 66},
  [1791] = {.lex_state = 66, .external_lex_state = 4},
  [1792] = {.lex_state = 66, .external_lex_state = 4},
  [1793] = {.lex_state = 66, .external_lex_state = 4},
  [1794] = {.lex_state = 66},
  [1795] = {.lex_state = 66, .external_lex_state = 4},
  [1796] = {.lex_state = 66, .external_lex_state = 4},
  [1797] = {.lex_state = 66},
  [1798] = {.lex_state = 66, .external_lex_state = 4},
  [1799] = {.lex_state = 66},
  [1800] = {.lex_state = 66, .external_lex_state = 4},
  [1801] = {.lex_state = 66, .external_lex_state = 4},
  [1802] = {.lex_state = 66},
  [1803] = {.lex_state = 66},
  [1804] = {.lex_state = 66},
  [1805] = {.lex_state = 66},
  [1806] = {.lex_state = 66, .external_lex_state = 4},
  [1807] = {.lex_state = 66},
  [1808] = {.lex_state = 66, .external_lex_state = 4},
  [1809] = {.lex_state = 66},
  [1810] = {.lex_state = 66, .external_lex_state = 4},
  [1811] = {.lex_state = 66, .external_lex_state = 4},
  [1812] = {.lex_state = 66, .external_lex_state = 4},
  [1813] = {.lex_state = 66},
  [1814] = {.lex_state = 66},
  [1815] = {.lex_state = 66},
  [1816] = {.lex_state = 66},
  [1817] = {.lex_state = 66},
  [1818] = {.lex_state = 66},
  [1819] = {.lex_state = 66},
  [1820] = {.lex_state = 66},
  [1821] = {.lex_state = 66},
  [1822] = {.lex_state = 66},
  [1823] = {.lex_state = 66},
  [1824] = {.lex_state = 66},
  [1825] = {.lex_state = 66},
  [1826] = {.lex_state = 66},
  [1827] = {.lex_state = 66},
  [1828] = {.lex_state = 66},
  [1829] = {.lex_state = 66},
  [1830] = {.lex_state = 66},
  [1831] = {.lex_state = 66},
  [1832] = {.lex_state = 66},
  [1833] = {.lex_state = 66},
  [1834] = {.lex_state = 66},
  [1835] = {.lex_state = 66},
  [1836] = {.lex_state = 66},
  [1837] = {.lex_state = 66},
  [1838] = {.lex_state = 66},
  [1839] = {.lex_state = 66},
  [1840] = {.lex_state = 66},
  [1841] = {.lex_state = 66},
  [1842] = {.lex_state = 66},
  [1843] = {.lex_state = 66},
  [1844] = {.lex_state = 66},
  [1845] = {.lex_state = 66},
  [1846] = {.lex_state = 66},
  [1847] = {.lex_state = 66},
  [1848] = {.lex_state = 66},
  [1849] = {.lex_state = 66},
  [1850] = {.lex_state = 66},
  [1851] = {.lex_state = 66},
  [1852] = {.lex_state = 66},
  [1853] = {.lex_state = 66},
  [1854] = {.lex_state = 66},
  [1855] = {.lex_state = 66},
  [1856] = {.lex_state = 66},
  [1857] = {.lex_state = 21},
  [1858] = {.lex_state = 21},
  [1859] = {.lex_state = 21},
  [1860] = {.lex_state = 21},
  [1861] = {.lex_state = 21},
  [1862] = {.lex_state = 21},
  [1863] = {.lex_state = 21},
  [1864] = {.lex_state = 66, .external_lex_state = 4},
  [1865] = {.lex_state = 66, .external_lex_state = 4},
  [1866] = {.lex_state = 66},
  [1867] = {.lex_state = 66, .external_lex_state = 4},
  [1868] = {.lex_state = 66, .external_lex_state = 4},
  [1869] = {.lex_state = 21},
  [1870] = {.lex_state = 66, .external_lex_state = 4},
  [1871] = {.lex_state = 66, .external_lex_state = 4},
  [1872] = {.lex_state = 66, .external_lex_state = 4},
  [1873] = {.lex_state = 66, .external_lex_state = 4},
  [1874] = {.lex_state = 66, .external_lex_state = 4},
  [1875] = {.lex_state = 66, .external_lex_state = 4},
  [1876] = {.lex_state = 66, .external_lex_state = 4},
  [1877] = {.lex_state = 66, .external_lex_state = 4},
  [1878] = {.lex_state = 21},
  [1879] = {.lex_state = 21},
  [1880] = {.lex_state = 66, .external_lex_state = 4},
  [1881] = {.lex_state = 66, .external_lex_state = 4},
  [1882] = {.lex_state = 66, .external_lex_state = 4},
  [1883] = {.lex_state = 66, .external_lex_state = 4},
  [1884] = {.lex_state = 66, .external_lex_state = 4},
  [1885] = {.lex_state = 66},
  [1886] = {.lex_state = 66, .external_lex_state = 4},
  [1887] = {.lex_state = 66, .external_lex_state = 4},
  [1888] = {.lex_state = 21},
  [1889] = {.lex_state = 21},
  [1890] = {.lex_state = 66, .external_lex_state = 4},
  [1891] = {.lex_state = 66, .external_lex_state = 4},
  [1892] = {.lex_state = 66, .external_lex_state = 4},
  [1893] = {.lex_state = 66},
  [1894] = {.lex_state = 66, .external_lex_state = 4},
  [1895] = {.lex_state = 66},
  [1896] = {.lex_state = 66, .external_lex_state = 4},
  [1897] = {.lex_state = 66, .external_lex_state = 4},
  [1898] = {.lex_state = 21},
  [1899] = {.lex_state = 66, .external_lex_state = 4},
  [1900] = {.lex_state = 66, .external_lex_state = 4},
  [1901] = {.lex_state = 21},
  [1902] = {.lex_state = 66, .external_lex_state = 4},
  [1903] = {.lex_state = 66, .external_lex_state = 4},
  [1904] = {.lex_state = 66, .external_lex_state = 4},
  [1905] = {.lex_state = 66, .external_lex_state = 4},
  [1906] = {.lex_state = 21},
  [1907] = {.lex_state = 66, .external_lex_state = 4},
  [1908] = {.lex_state = 66, .external_lex_state = 4},
  [1909] = {.lex_state = 66, .external_lex_state = 4},
  [1910] = {.lex_state = 66},
  [1911] = {.lex_state = 66, .external_lex_state = 4},
  [1912] = {.lex_state = 66, .external_lex_state = 4},
  [1913] = {.lex_state = 66},
  [1914] = {.lex_state = 66},
  [1915] = {.lex_state = 66, .external_lex_state = 4},
  [1916] = {.lex_state = 66, .external_lex_state = 4},
  [1917] = {.lex_state = 66, .external_lex_state = 4},
  [1918] = {.lex_state = 66},
  [1919] = {.lex_state = 66},
  [1920] = {.lex_state = 66, .external_lex_state = 4},
  [1921] = {.lex_state = 66, .external_lex_state = 4},
  [1922] = {.lex_state = 66, .external_lex_state = 4},
  [1923] = {.lex_state = 66, .external_lex_state = 4},
  [1924] = {.lex_state = 66},
  [1925] = {.lex_state = 66, .external_lex_state = 4},
  [1926] = {.lex_state = 66},
  [1927] = {.lex_state = 66},
  [1928] = {.lex_state = 66, .external_lex_state = 4},
  [1929] = {.lex_state = 21},
  [1930] = {.lex_state = 66},
  [1931] = {.lex_state = 66, .external_lex_state = 4},
  [1932] = {.lex_state = 66, .external_lex_state = 4},
  [1933] = {.lex_state = 66, .external_lex_state = 4},
  [1934] = {.lex_state = 66, .external_lex_state = 4},
  [1935] = {.lex_state = 66, .external_lex_state = 4},
  [1936] = {.lex_state = 66, .external_lex_state = 4},
  [1937] = {.lex_state = 66, .external_lex_state = 4},
  [1938] = {.lex_state = 66, .external_lex_state = 4},
  [1939] = {.lex_state = 66, .external_lex_state = 4},
  [1940] = {.lex_state = 66, .external_lex_state = 4},
  [1941] = {.lex_state = 66, .external_lex_state = 4},
  [1942] = {.lex_state = 66, .external_lex_state = 4},
  [1943] = {.lex_state = 66, .external_lex_state = 4},
  [1944] = {.lex_state = 66, .external_lex_state = 4},
  [1945] = {.lex_state = 21},
  [1946] = {.lex_state = 66},
  [1947] = {.lex_state = 66, .external_lex_state = 4},
  [1948] = {.lex_state = 66, .external_lex_state = 4},
  [1949] = {.lex_state = 66},
  [1950] = {.lex_state = 66, .external_lex_state = 4},
  [1951] = {.lex_state = 66, .external_lex_state = 4},
  [1952] = {.lex_state = 66, .external_lex_state = 4},
  [1953] = {.lex_state = 66, .external_lex_state = 4},
  [1954] = {.lex_state = 66, .external_lex_state = 4},
  [1955] = {.lex_state = 66},
  [1956] = {.lex_state = 21},
  [1957] = {.lex_state = 66},
  [1958] = {.lex_state = 66, .external_lex_state = 4},
  [1959] = {.lex_state = 66},
  [1960] = {.lex_state = 66},
  [1961] = {.lex_state = 21},
  [1962] = {.lex_state = 66, .external_lex_state = 4},
  [1963] = {.lex_state = 66},
  [1964] = {.lex_state = 66},
  [1965] = {.lex_state = 66, .external_lex_state = 4},
  [1966] = {.lex_state = 66, .external_lex_state = 4},
  [1967] = {.lex_state = 21},
  [1968] = {.lex_state = 66, .external_lex_state = 4},
  [1969] = {.lex_state = 66, .external_lex_state = 4},
  [1970] = {.lex_state = 66, .external_lex_state = 4},
  [1971] = {.lex_state = 66, .external_lex_state = 4},
  [1972] = {.lex_state = 66, .external_lex_state = 4},
  [1973] = {.lex_state = 66},
  [1974] = {.lex_state = 21},
  [1975] = {.lex_state = 29},
  [1976] = {.lex_state = 66},
  [1977] = {.lex_state = 21},
  [1978] = {.lex_state = 66},
  [1979] = {.lex_state = 29},
  [1980] = {.lex_state = 66},
  [1981] = {.lex_state = 21},
  [1982] = {.lex_state = 21},
  [1983] = {.lex_state = 66},
  [1984] = {.lex_state = 66},
  [1985] = {.lex_state = 29},
  [1986] = {.lex_state = 29},
  [1987] = {.lex_state = 29},
  [1988] = {.lex_state = 66},
  [1989] = {.lex_state = 21},
  [1990] = {.lex_state = 66, .external_lex_state = 4},
  [1991] = {.lex_state = 66},
  [1992] = {.lex_state = 66},
  [1993] = {.lex_state = 29},
  [1994] = {.lex_state = 21},
  [1995] = {.lex_state = 66, .external_lex_state = 4},
  [1996] = {.lex_state = 66},
  [1997] = {.lex_state = 66},
  [1998] = {.lex_state = 66},
  [1999] = {.lex_state = 21},
  [2000] = {.lex_state = 29},
  [2001] = {.lex_state = 29},
  [2002] = {.lex_state = 66},
  [2003] = {.lex_state = 29},
  [2004] = {.lex_state = 29},
  [2005] = {.lex_state = 66},
  [2006] = {.lex_state = 21},
  [2007] = {.lex_state = 66},
  [2008] = {.lex_state = 21},
  [2009] = {.lex_state = 66},
  [2010] = {.lex_state = 66, .external_lex_state = 4},
  [2011] = {.lex_state = 66},
  [2012] = {.lex_state = 66},
  [2013] = {.lex_state = 21},
  [2014] = {.lex_state = 21},
  [2015] = {.lex_state = 29},
  [2016] = {.lex_state = 21},
  [2017] = {.lex_state = 66},
  [2018] = {.lex_state = 66, .external_lex_state = 4},
  [2019] = {.lex_state = 66},
  [2020] = {.lex_state = 29},
  [2021] = {.lex_state = 29},
  [2022] = {.lex_state = 29},
  [2023] = {.lex_state = 66},
  [2024] = {.lex_state = 29},
  [2025] = {.lex_state = 29},
  [2026] = {.lex_state = 29},
  [2027] = {.lex_state = 66},
  [2028] = {.lex_state = 66},
  [2029] = {.lex_state = 66},
  [2030] = {.lex_state = 66, .external_lex_state = 4},
  [2031] = {.lex_state = 66},
  [2032] = {.lex_state = 29},
  [2033] = {.lex_state = 29},
  [2034] = {.lex_state = 66, .external_lex_state = 4},
  [2035] = {.lex_state = 21},
  [2036] = {.lex_state = 66},
  [2037] = {.lex_state = 66},
  [2038] = {.lex_state = 66},
  [2039] = {.lex_state = 66},
  [2040] = {.lex_state = 66},
  [2041] = {.lex_state = 66},
  [2042] = {.lex_state = 66},
  [2043] = {.lex_state = 66},
  [2044] = {.lex_state = 66},
  [2045] = {.lex_state = 66, .external_lex_state = 4},
  [2046] = {.lex_state = 66},
  [2047] = {.lex_state = 0, .external_lex_state = 4},
  [2048] = {.lex_state = 66},
  [2049] = {.lex_state = 66},
  [2050] = {.lex_state = 66},
  [2051] = {.lex_state = 0, .external_lex_state = 4},
  [2052] = {.lex_state = 66, .external_lex_state = 4},
  [2053] = {.lex_state = 66},
  [2054] = {.lex_state = 66, .external_lex_state = 4},
  [2055] = {.lex_state = 66},
  [2056] = {.lex_state = 66, .external_lex_state = 4},
  [2057] = {.lex_state = 66},
  [2058] = {.lex_state = 66},
  [2059] = {.lex_state = 66},
  [2060] = {.lex_state = 66},
  [2061] = {.lex_state = 14},
  [2062] = {.lex_state = 66},
  [2063] = {.lex_state = 66},
  [2064] = {.lex_state = 66, .external_lex_state = 4},
  [2065] = {.lex_state = 0, .external_lex_state = 4},
  [2066] = {.lex_state = 66},
  [2067] = {.lex_state = 0, .external_lex_state = 4},
  [2068] = {.lex_state = 0, .external_lex_state = 4},
  [2069] = {.lex_state = 0, .external_lex_state = 4},
  [2070] = {.lex_state = 66, .external_lex_state = 4},
  [2071] = {.lex_state = 66, .external_lex_state = 4},
  [2072] = {.lex_state = 0, .external_lex_state = 4},
  [2073] = {.lex_state = 66, .external_lex_state = 4},
  [2074] = {.lex_state = 0, .external_lex_state = 4},
  [2075] = {.lex_state = 66, .external_lex_state = 4},
  [2076] = {.lex_state = 0},
  [2077] = {.lex_state = 66},
  [2078] = {.lex_state = 66},
  [2079] = {.lex_state = 66},
  [2080] = {.lex_state = 66, .external_lex_state = 4},
  [2081] = {.lex_state = 66, .external_lex_state = 4},
  [2082] = {.lex_state = 66},
  [2083] = {.lex_state = 66},
  [2084] = {.lex_state = 66},
  [2085] = {.lex_state = 66, .external_lex_state = 4},
  [2086] = {.lex_state = 66},
  [2087] = {.lex_state = 66},
  [2088] = {.lex_state = 66},
  [2089] = {.lex_state = 66},
  [2090] = {.lex_state = 66},
  [2091] = {.lex_state = 66},
  [2092] = {.lex_state = 66, .external_lex_state = 4},
  [2093] = {.lex_state = 66, .external_lex_state = 4},
  [2094] = {.lex_state = 66},
  [2095] = {.lex_state = 66},
  [2096] = {.lex_state = 14},
  [2097] = {.lex_state = 66},
  [2098] = {.lex_state = 66, .external_lex_state = 4},
  [2099] = {.lex_state = 66},
  [2100] = {.lex_state = 66},
  [2101] = {.lex_state = 66, .external_lex_state = 4},
  [2102] = {.lex_state = 66},
  [2103] = {.lex_state = 21},
  [2104] = {.lex_state = 66, .external_lex_state = 4},
  [2105] = {.lex_state = 66, .external_lex_state = 4},
  [2106] = {.lex_state = 66},
  [2107] = {.lex_state = 0, .external_lex_state = 4},
  [2108] = {.lex_state = 66},
  [2109] = {.lex_state = 66},
  [2110] = {.lex_state = 66},
  [2111] = {.lex_state = 66, .external_lex_state = 4},
  [2112] = {.lex_state = 66},
  [2113] = {.lex_state = 66},
  [2114] = {.lex_state = 66},
  [2115] = {.lex_state = 19, .external_lex_state = 5},
  [2116] = {.lex_state = 21},
  [2117] = {.lex_state = 0, .external_lex_state = 4},
  [2118] = {.lex_state = 0, .external_lex_state = 4},
  [2119] = {.lex_state = 66},
  [2120] = {.lex_state = 0, .external_lex_state = 4},
  [2121] = {.lex_state = 66},
  [2122] = {.lex_state = 66},
  [2123] = {.lex_state = 0, .external_lex_state = 4},
  [2124] = {.lex_state = 66},
  [2125] = {.lex_state = 0, .external_lex_state = 4},
  [2126] = {.lex_state = 0, .external_lex_state = 4},
  [2127] = {.lex_state = 66},
  [2128] = {.lex_state = 66},
  [2129] = {.lex_state = 66},
  [2130] = {.lex_state = 66},
  [2131] = {.lex_state = 0, .external_lex_state = 4},
  [2132] = {.lex_state = 14},
  [2133] = {.lex_state = 66},
  [2134] = {.lex_state = 66},
  [2135] = {.lex_state = 0, .external_lex_state = 4},
  [2136] = {.lex_state = 0, .external_lex_state = 4},
  [2137] = {.lex_state = 17},
  [2138] = {.lex_state = 0, .external_lex_state = 4},
  [2139] = {.lex_state = 66},
  [2140] = {.lex_state = 0, .external_lex_state = 4},
  [2141] = {.lex_state = 0, .external_lex_state = 4},
  [2142] = {.lex_state = 19, .external_lex_state = 5},
  [2143] = {.lex_state = 66},
  [2144] = {.lex_state = 66},
  [2145] = {.lex_state = 19, .external_lex_state = 5},
  [2146] = {.lex_state = 0},
  [2147] = {.lex_state = 66},
  [2148] = {.lex_state = 66},
  [2149] = {.lex_state = 66},
  [2150] = {.lex_state = 66},
  [2151] = {.lex_state = 66},
  [2152] = {.lex_state = 0, .external_lex_state = 4},
  [2153] = {.lex_state = 0, .external_lex_state = 4},
  [2154] = {.lex_state = 19, .external_lex_state = 5},
  [2155] = {.lex_state = 66},
  [2156] = {.lex_state = 66},
  [2157] = {.lex_state = 17},
  [2158] = {.lex_state = 66},
  [2159] = {.lex_state = 66},
  [2160] = {.lex_state = 66},
  [2161] = {.lex_state = 66},
  [2162] = {.lex_state = 66},
  [2163] = {.lex_state = 0, .external_lex_state = 4},
  [2164] = {.lex_state = 66, .external_lex_state = 4},
  [2165] = {.lex_state = 66},
  [2166] = {.lex_state = 0, .external_lex_state = 4},
  [2167] = {.lex_state = 66},
  [2168] = {.lex_state = 66},
  [2169] = {.lex_state = 66},
  [2170] = {.lex_state = 17},
  [2171] = {.lex_state = 0, .external_lex_state = 4},
  [2172] = {.lex_state = 0, .external_lex_state = 4},
  [2173] = {.lex_state = 66},
  [2174] = {.lex_state = 0, .external_lex_state = 4},
  [2175] = {.lex_state = 0, .external_lex_state = 4},
  [2176] = {.lex_state = 66},
  [2177] = {.lex_state = 21},
  [2178] = {.lex_state = 66},
  [2179] = {.lex_state = 66},
  [2180] = {.lex_state = 66},
  [2181] = {.lex_state = 66},
  [2182] = {.lex_state = 19, .external_lex_state = 5},
  [2183] = {.lex_state = 66},
  [2184] = {.lex_state = 66},
  [2185] = {.lex_state = 0, .external_lex_state = 4},
  [2186] = {.lex_state = 66},
  [2187] = {.lex_state = 66},
  [2188] = {.lex_state = 66},
  [2189] = {.lex_state = 66},
  [2190] = {.lex_state = 19, .external_lex_state = 5},
  [2191] = {.lex_state = 66},
  [2192] = {.lex_state = 66},
  [2193] = {.lex_state = 66, .external_lex_state = 4},
  [2194] = {.lex_state = 66},
  [2195] = {.lex_state = 66},
  [2196] = {.lex_state = 66},
  [2197] = {.lex_state = 66},
  [2198] = {.lex_state = 66},
  [2199] = {.lex_state = 66},
  [2200] = {.lex_state = 19, .external_lex_state = 5},
  [2201] = {.lex_state = 66},
  [2202] = {.lex_state = 66},
  [2203] = {.lex_state = 0, .external_lex_state = 4},
  [2204] = {.lex_state = 66},
  [2205] = {.lex_state = 66},
  [2206] = {.lex_state = 66},
  [2207] = {.lex_state = 66},
  [2208] = {.lex_state = 21},
  [2209] = {.lex_state = 66},
  [2210] = {.lex_state = 0, .external_lex_state = 4},
  [2211] = {.lex_state = 66},
  [2212] = {.lex_state = 0, .external_lex_state = 4},
  [2213] = {.lex_state = 0, .external_lex_state = 4},
  [2214] = {.lex_state = 0, .external_lex_state = 4},
  [2215] = {.lex_state = 0, .external_lex_state = 4},
  [2216] = {.lex_state = 0, .external_lex_state = 4},
  [2217] = {.lex_state = 66},
  [2218] = {.lex_state = 0, .external_lex_state = 4},
  [2219] = {.lex_state = 0, .external_lex_state = 4},
  [2220] = {.lex_state = 0, .external_lex_state = 4},
  [2221] = {.lex_state = 66, .external_lex_state = 4},
  [2222] = {.lex_state = 66},
  [2223] = {.lex_state = 66},
  [2224] = {.lex_state = 66},
  [2225] = {.lex_state = 14},
  [2226] = {.lex_state = 0, .external_lex_state = 4},
  [2227] = {.lex_state = 66},
  [2228] = {.lex_state = 0, .external_lex_state = 4},
  [2229] = {.lex_state = 0, .external_lex_state = 4},
  [2230] = {.lex_state = 0, .external_lex_state = 4},
  [2231] = {.lex_state = 66},
  [2232] = {.lex_state = 66},
  [2233] = {.lex_state = 66},
  [2234] = {.lex_state = 17},
  [2235] = {.lex_state = 0, .external_lex_state = 4},
  [2236] = {.lex_state = 66},
  [2237] = {.lex_state = 0, .external_lex_state = 4},
  [2238] = {.lex_state = 17},
  [2239] = {.lex_state = 66},
  [2240] = {.lex_state = 66},
  [2241] = {.lex_state = 0, .external_lex_state = 4},
  [2242] = {.lex_state = 0, .external_lex_state = 4},
  [2243] = {.lex_state = 66},
  [2244] = {.lex_state = 0, .external_lex_state = 4},
  [2245] = {.lex_state = 0, .external_lex_state = 4},
  [2246] = {.lex_state = 66},
  [2247] = {.lex_state = 0, .external_lex_state = 4},
  [2248] = {.lex_state = 66},
  [2249] = {.lex_state = 0, .external_lex_state = 4},
  [2250] = {.lex_state = 66},
  [2251] = {.lex_state = 0, .external_lex_state = 4},
  [2252] = {.lex_state = 0, .external_lex_state = 4},
  [2253] = {.lex_state = 17},
  [2254] = {.lex_state = 0, .external_lex_state = 4},
  [2255] = {.lex_state = 66},
  [2256] = {.lex_state = 0, .external_lex_state = 4},
  [2257] = {.lex_state = 66, .external_lex_state = 4},
  [2258] = {.lex_state = 66},
  [2259] = {.lex_state = 0, .external_lex_state = 4},
  [2260] = {.lex_state = 21},
  [2261] = {.lex_state = 0, .external_lex_state = 4},
  [2262] = {.lex_state = 66},
  [2263] = {.lex_state = 21},
  [2264] = {.lex_state = 66},
  [2265] = {.lex_state = 17},
  [2266] = {.lex_state = 0, .external_lex_state = 4},
  [2267] = {.lex_state = 7},
  [2268] = {.lex_state = 66},
  [2269] = {.lex_state = 0, .external_lex_state = 4},
  [2270] = {.lex_state = 66},
  [2271] = {.lex_state = 0, .external_lex_state = 4},
  [2272] = {.lex_state = 0, .external_lex_state = 4},
  [2273] = {.lex_state = 66},
  [2274] = {.lex_state = 66, .external_lex_state = 4},
  [2275] = {.lex_state = 66},
  [2276] = {.lex_state = 66, .external_lex_state = 4},
  [2277] = {.lex_state = 17},
  [2278] = {.lex_state = 0, .external_lex_state = 4},
  [2279] = {.lex_state = 0, .external_lex_state = 4},
  [2280] = {.lex_state = 0, .external_lex_state = 4},
  [2281] = {.lex_state = 0, .external_lex_state = 4},
  [2282] = {.lex_state = 66},
  [2283] = {.lex_state = 66},
  [2284] = {.lex_state = 66},
  [2285] = {.lex_state = 0, .external_lex_state = 4},
  [2286] = {.lex_state = 0, .external_lex_state = 4},
  [2287] = {.lex_state = 0, .external_lex_state = 4},
  [2288] = {.lex_state = 0, .external_lex_state = 4},
  [2289] = {.lex_state = 0, .external_lex_state = 4},
  [2290] = {.lex_state = 0, .external_lex_state = 4},
  [2291] = {.lex_state = 17},
  [2292] = {.lex_state = 0, .external_lex_state = 4},
  [2293] = {.lex_state = 66},
  [2294] = {.lex_state = 0, .external_lex_state = 4},
  [2295] = {.lex_state = 66},
  [2296] = {.lex_state = 0},
  [2297] = {.lex_state = 0, .external_lex_state = 4},
  [2298] = {.lex_state = 66},
  [2299] = {.lex_state = 0, .external_lex_state = 4},
  [2300] = {.lex_state = 0, .external_lex_state = 4},
  [2301] = {.lex_state = 66},
  [2302] = {.lex_state = 0, .external_lex_state = 4},
  [2303] = {.lex_state = 0, .external_lex_state = 4},
  [2304] = {.lex_state = 0},
  [2305] = {.lex_state = 0},
  [2306] = {.lex_state = 0},
  [2307] = {.lex_state = 66},
  [2308] = {.lex_state = 0},
  [2309] = {.lex_state = 66},
  [2310] = {.lex_state = 0, .external_lex_state = 4},
  [2311] = {.lex_state = 0, .external_lex_state = 4},
  [2312] = {.lex_state = 14},
  [2313] = {.lex_state = 17},
  [2314] = {.lex_state = 0, .external_lex_state = 4},
  [2315] = {.lex_state = 66},
  [2316] = {.lex_state = 66},
  [2317] = {.lex_state = 17},
  [2318] = {.lex_state = 0, .external_lex_state = 4},
  [2319] = {.lex_state = 17},
  [2320] = {.lex_state = 66, .external_lex_state = 4},
  [2321] = {.lex_state = 66},
  [2322] = {.lex_state = 66},
  [2323] = {.lex_state = 66},
  [2324] = {.lex_state = 0, .external_lex_state = 4},
  [2325] = {.lex_state = 0, .external_lex_state = 4},
  [2326] = {.lex_state = 66},
  [2327] = {.lex_state = 66},
  [2328] = {.lex_state = 66},
  [2329] = {.lex_state = 21},
  [2330] = {.lex_state = 17},
  [2331] = {.lex_state = 0},
  [2332] = {.lex_state = 66},
  [2333] = {.lex_state = 66, .external_lex_state = 4},
  [2334] = {.lex_state = 66},
  [2335] = {.lex_state = 0, .external_lex_state = 4},
  [2336] = {.lex_state = 21},
  [2337] = {.lex_state = 66},
  [2338] = {.lex_state = 0, .external_lex_state = 4},
  [2339] = {.lex_state = 0, .external_lex_state = 4},
  [2340] = {.lex_state = 66},
  [2341] = {.lex_state = 0, .external_lex_state = 4},
  [2342] = {.lex_state = 7},
  [2343] = {.lex_state = 0, .external_lex_state = 4},
  [2344] = {.lex_state = 0, .external_lex_state = 4},
  [2345] = {.lex_state = 66},
  [2346] = {.lex_state = 66},
  [2347] = {.lex_state = 66},
  [2348] = {.lex_state = 66},
  [2349] = {.lex_state = 17},
  [2350] = {.lex_state = 0, .external_lex_state = 4},
  [2351] = {.lex_state = 0, .external_lex_state = 4},
  [2352] = {.lex_state = 0, .external_lex_state = 4},
  [2353] = {.lex_state = 17},
  [2354] = {.lex_state = 66},
  [2355] = {.lex_state = 66},
  [2356] = {.lex_state = 0, .external_lex_state = 4},
  [2357] = {.lex_state = 0, .external_lex_state = 4},
  [2358] = {.lex_state = 0, .external_lex_state = 4},
  [2359] = {.lex_state = 0, .external_lex_state = 4},
  [2360] = {.lex_state = 66},
  [2361] = {.lex_state = 66},
  [2362] = {.lex_state = 0, .external_lex_state = 4},
  [2363] = {.lex_state = 66},
  [2364] = {.lex_state = 0, .external_lex_state = 4},
  [2365] = {.lex_state = 21},
  [2366] = {.lex_state = 66, .external_lex_state = 4},
  [2367] = {.lex_state = 0, .external_lex_state = 4},
  [2368] = {.lex_state = 66},
  [2369] = {.lex_state = 0},
  [2370] = {.lex_state = 0, .external_lex_state = 4},
  [2371] = {.lex_state = 0, .external_lex_state = 4},
  [2372] = {.lex_state = 0, .external_lex_state = 4},
  [2373] = {.lex_state = 66},
  [2374] = {.lex_state = 21},
  [2375] = {.lex_state = 66},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 66},
  [2378] = {.lex_state = 0, .external_lex_state = 4},
  [2379] = {.lex_state = 0, .external_lex_state = 4},
  [2380] = {.lex_state = 0, .external_lex_state = 4},
  [2381] = {.lex_state = 0},
  [2382] = {.lex_state = 66, .external_lex_state = 4},
  [2383] = {.lex_state = 0},
  [2384] = {.lex_state = 0, .external_lex_state = 4},
  [2385] = {.lex_state = 66},
  [2386] = {.lex_state = 0, .external_lex_state = 4},
  [2387] = {.lex_state = 66, .external_lex_state = 4},
  [2388] = {.lex_state = 66},
  [2389] = {.lex_state = 66},
  [2390] = {.lex_state = 0, .external_lex_state = 4},
  [2391] = {.lex_state = 66},
  [2392] = {.lex_state = 66},
  [2393] = {.lex_state = 66},
  [2394] = {.lex_state = 0, .external_lex_state = 4},
  [2395] = {.lex_state = 21},
  [2396] = {.lex_state = 0},
  [2397] = {.lex_state = 0},
  [2398] = {.lex_state = 0},
  [2399] = {.lex_state = 66},
  [2400] = {.lex_state = 66},
  [2401] = {.lex_state = 21},
  [2402] = {.lex_state = 0, .external_lex_state = 4},
  [2403] = {.lex_state = 0, .external_lex_state = 4},
  [2404] = {.lex_state = 66},
  [2405] = {.lex_state = 66},
  [2406] = {.lex_state = 66, .external_lex_state = 4},
  [2407] = {.lex_state = 0, .external_lex_state = 4},
  [2408] = {.lex_state = 0, .external_lex_state = 4},
  [2409] = {.lex_state = 66},
  [2410] = {.lex_state = 0, .external_lex_state = 4},
  [2411] = {.lex_state = 0, .external_lex_state = 4},
  [2412] = {.lex_state = 66},
  [2413] = {.lex_state = 66},
  [2414] = {.lex_state = 66},
  [2415] = {.lex_state = 0},
  [2416] = {.lex_state = 66, .external_lex_state = 4},
  [2417] = {.lex_state = 0, .external_lex_state = 4},
  [2418] = {.lex_state = 66},
  [2419] = {.lex_state = 66},
  [2420] = {.lex_state = 0, .external_lex_state = 4},
  [2421] = {.lex_state = 66},
  [2422] = {.lex_state = 66, .external_lex_state = 4},
  [2423] = {.lex_state = 17},
  [2424] = {.lex_state = 66},
  [2425] = {.lex_state = 0},
  [2426] = {.lex_state = 21},
  [2427] = {.lex_state = 0},
  [2428] = {.lex_state = 0, .external_lex_state = 4},
  [2429] = {.lex_state = 0},
  [2430] = {.lex_state = 17},
  [2431] = {.lex_state = 21},
  [2432] = {.lex_state = 0, .external_lex_state = 4},
  [2433] = {.lex_state = 0},
  [2434] = {.lex_state = 0},
  [2435] = {.lex_state = 0, .external_lex_state = 4},
  [2436] = {.lex_state = 0, .external_lex_state = 4},
  [2437] = {.lex_state = 0},
  [2438] = {.lex_state = 66},
  [2439] = {.lex_state = 0, .external_lex_state = 4},
  [2440] = {.lex_state = 66},
  [2441] = {.lex_state = 0},
  [2442] = {.lex_state = 66},
  [2443] = {.lex_state = 0, .external_lex_state = 4},
  [2444] = {.lex_state = 21},
  [2445] = {.lex_state = 0, .external_lex_state = 4},
  [2446] = {.lex_state = 0},
  [2447] = {.lex_state = 21},
  [2448] = {.lex_state = 21},
  [2449] = {.lex_state = 0, .external_lex_state = 4},
  [2450] = {.lex_state = 66},
  [2451] = {.lex_state = 66, .external_lex_state = 4},
  [2452] = {.lex_state = 1},
  [2453] = {.lex_state = 3},
  [2454] = {.lex_state = 3},
  [2455] = {.lex_state = 3},
  [2456] = {.lex_state = 66},
  [2457] = {.lex_state = 66},
  [2458] = {.lex_state = 17},
  [2459] = {.lex_state = 17},
  [2460] = {.lex_state = 66},
  [2461] = {.lex_state = 66},
  [2462] = {.lex_state = 66},
  [2463] = {.lex_state = 66},
  [2464] = {.lex_state = 1},
  [2465] = {.lex_state = 66, .external_lex_state = 4},
  [2466] = {.lex_state = 3},
  [2467] = {.lex_state = 0},
  [2468] = {.lex_state = 0},
  [2469] = {.lex_state = 0, .external_lex_state = 4},
  [2470] = {.lex_state = 0},
  [2471] = {.lex_state = 1},
  [2472] = {.lex_state = 0, .external_lex_state = 4},
  [2473] = {.lex_state = 3},
  [2474] = {.lex_state = 1},
  [2475] = {.lex_state = 3},
  [2476] = {.lex_state = 0, .external_lex_state = 4},
  [2477] = {.lex_state = 3},
  [2478] = {.lex_state = 0},
  [2479] = {.lex_state = 1},
  [2480] = {.lex_state = 0},
  [2481] = {.lex_state = 3},
  [2482] = {.lex_state = 66},
  [2483] = {.lex_state = 1},
  [2484] = {.lex_state = 66},
  [2485] = {.lex_state = 66},
  [2486] = {.lex_state = 3},
  [2487] = {.lex_state = 0, .external_lex_state = 4},
  [2488] = {.lex_state = 3},
  [2489] = {.lex_state = 1},
  [2490] = {.lex_state = 66, .external_lex_state = 4},
  [2491] = {.lex_state = 66, .external_lex_state = 4},
  [2492] = {.lex_state = 3},
  [2493] = {.lex_state = 1},
  [2494] = {.lex_state = 1},
  [2495] = {.lex_state = 66},
  [2496] = {.lex_state = 0},
  [2497] = {.lex_state = 1},
  [2498] = {.lex_state = 3},
  [2499] = {.lex_state = 66},
  [2500] = {.lex_state = 1},
  [2501] = {.lex_state = 66, .external_lex_state = 4},
  [2502] = {.lex_state = 66, .external_lex_state = 4},
  [2503] = {.lex_state = 0},
  [2504] = {.lex_state = 66},
  [2505] = {.lex_state = 66, .external_lex_state = 4},
  [2506] = {.lex_state = 66},
  [2507] = {.lex_state = 66},
  [2508] = {.lex_state = 66},
  [2509] = {.lex_state = 66},
  [2510] = {.lex_state = 66},
  [2511] = {.lex_state = 17},
  [2512] = {.lex_state = 1},
  [2513] = {.lex_state = 66, .external_lex_state = 4},
  [2514] = {.lex_state = 3},
  [2515] = {.lex_state = 0},
  [2516] = {.lex_state = 1},
  [2517] = {.lex_state = 0},
  [2518] = {.lex_state = 66},
  [2519] = {.lex_state = 66, .external_lex_state = 4},
  [2520] = {.lex_state = 0, .external_lex_state = 4},
  [2521] = {.lex_state = 66, .external_lex_state = 4},
  [2522] = {.lex_state = 66, .external_lex_state = 4},
  [2523] = {.lex_state = 66},
  [2524] = {.lex_state = 0, .external_lex_state = 4},
  [2525] = {.lex_state = 17},
  [2526] = {.lex_state = 66},
  [2527] = {.lex_state = 66},
  [2528] = {.lex_state = 66},
  [2529] = {.lex_state = 66, .external_lex_state = 4},
  [2530] = {.lex_state = 66},
  [2531] = {.lex_state = 66},
  [2532] = {.lex_state = 66},
  [2533] = {.lex_state = 17},
  [2534] = {.lex_state = 19, .external_lex_state = 5},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 66},
  [2538] = {.lex_state = 3},
  [2539] = {.lex_state = 1},
  [2540] = {.lex_state = 66},
  [2541] = {.lex_state = 0},
  [2542] = {.lex_state = 0, .external_lex_state = 4},
  [2543] = {.lex_state = 0, .external_lex_state = 4},
  [2544] = {.lex_state = 66, .external_lex_state = 4},
  [2545] = {.lex_state = 17},
  [2546] = {.lex_state = 66, .external_lex_state = 4},
  [2547] = {.lex_state = 66},
  [2548] = {.lex_state = 0},
  [2549] = {.lex_state = 1},
  [2550] = {.lex_state = 3},
  [2551] = {.lex_state = 66, .external_lex_state = 4},
  [2552] = {.lex_state = 66},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 66},
  [2555] = {.lex_state = 0, .external_lex_state = 4},
  [2556] = {.lex_state = 66},
  [2557] = {.lex_state = 0, .external_lex_state = 4},
  [2558] = {.lex_state = 0, .external_lex_state = 4},
  [2559] = {.lex_state = 0, .external_lex_state = 4},
  [2560] = {.lex_state = 66, .external_lex_state = 4},
  [2561] = {.lex_state = 0, .external_lex_state = 4},
  [2562] = {.lex_state = 0, .external_lex_state = 4},
  [2563] = {.lex_state = 66},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 0, .external_lex_state = 4},
  [2566] = {.lex_state = 66},
  [2567] = {.lex_state = 0, .external_lex_state = 4},
  [2568] = {.lex_state = 0, .external_lex_state = 4},
  [2569] = {.lex_state = 0, .external_lex_state = 4},
  [2570] = {.lex_state = 66},
  [2571] = {.lex_state = 66, .external_lex_state = 4},
  [2572] = {.lex_state = 0, .external_lex_state = 4},
  [2573] = {.lex_state = 66},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 66},
  [2576] = {.lex_state = 0, .external_lex_state = 4},
  [2577] = {.lex_state = 0, .external_lex_state = 4},
  [2578] = {.lex_state = 0, .external_lex_state = 4},
  [2579] = {.lex_state = 0, .external_lex_state = 4},
  [2580] = {.lex_state = 66},
  [2581] = {.lex_state = 0, .external_lex_state = 4},
  [2582] = {.lex_state = 0, .external_lex_state = 4},
  [2583] = {.lex_state = 66},
  [2584] = {.lex_state = 66},
  [2585] = {.lex_state = 0},
  [2586] = {.lex_state = 29},
  [2587] = {.lex_state = 0},
  [2588] = {.lex_state = 66, .external_lex_state = 4},
  [2589] = {.lex_state = 0},
  [2590] = {.lex_state = 66},
  [2591] = {.lex_state = 0},
  [2592] = {.lex_state = 66},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0},
  [2595] = {.lex_state = 66},
  [2596] = {.lex_state = 0},
  [2597] = {.lex_state = 0},
  [2598] = {.lex_state = 7},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 0, .external_lex_state = 4},
  [2601] = {.lex_state = 0, .external_lex_state = 4},
  [2602] = {.lex_state = 0},
  [2603] = {.lex_state = 0},
  [2604] = {.lex_state = 0, .external_lex_state = 4},
  [2605] = {.lex_state = 0},
  [2606] = {.lex_state = 0},
  [2607] = {.lex_state = 29},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 7},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 66},
  [2612] = {.lex_state = 66},
  [2613] = {.lex_state = 66},
  [2614] = {.lex_state = 0},
  [2615] = {.lex_state = 0},
  [2616] = {.lex_state = 66},
  [2617] = {.lex_state = 0},
  [2618] = {.lex_state = 0, .external_lex_state = 4},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 0},
  [2621] = {.lex_state = 66},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 66},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 66},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 66},
  [2628] = {.lex_state = 7},
  [2629] = {.lex_state = 0},
  [2630] = {.lex_state = 66},
  [2631] = {.lex_state = 66},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 66},
  [2634] = {.lex_state = 66},
  [2635] = {.lex_state = 29},
  [2636] = {.lex_state = 0},
  [2637] = {.lex_state = 29},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 0},
  [2641] = {.lex_state = 0},
  [2642] = {.lex_state = 66},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 0},
  [2645] = {.lex_state = 0},
  [2646] = {.lex_state = 0},
  [2647] = {.lex_state = 0},
  [2648] = {.lex_state = 66},
  [2649] = {.lex_state = 0},
  [2650] = {.lex_state = 29},
  [2651] = {.lex_state = 29},
  [2652] = {.lex_state = 66},
  [2653] = {.lex_state = 29},
  [2654] = {.lex_state = 66},
  [2655] = {.lex_state = 29},
  [2656] = {.lex_state = 0},
  [2657] = {.lex_state = 0},
  [2658] = {.lex_state = 0},
  [2659] = {.lex_state = 0},
  [2660] = {.lex_state = 0},
  [2661] = {.lex_state = 66},
  [2662] = {.lex_state = 66},
  [2663] = {.lex_state = 0, .external_lex_state = 4},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 0, .external_lex_state = 4},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 0},
  [2669] = {.lex_state = 0, .external_lex_state = 4},
  [2670] = {.lex_state = 66},
  [2671] = {.lex_state = 0},
  [2672] = {.lex_state = 0},
  [2673] = {.lex_state = 66},
  [2674] = {.lex_state = 0},
  [2675] = {.lex_state = 29},
  [2676] = {.lex_state = 29},
  [2677] = {.lex_state = 0},
  [2678] = {.lex_state = 66},
  [2679] = {.lex_state = 0},
  [2680] = {.lex_state = 66},
  [2681] = {.lex_state = 66},
  [2682] = {.lex_state = 0, .external_lex_state = 4},
  [2683] = {.lex_state = 0, .external_lex_state = 4},
  [2684] = {.lex_state = 0, .external_lex_state = 4},
  [2685] = {.lex_state = 0, .external_lex_state = 4},
  [2686] = {.lex_state = 66},
  [2687] = {.lex_state = 0},
  [2688] = {.lex_state = 0},
  [2689] = {.lex_state = 0},
  [2690] = {.lex_state = 0},
  [2691] = {.lex_state = 0},
  [2692] = {.lex_state = 0},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 66, .external_lex_state = 4},
  [2695] = {.lex_state = 66},
  [2696] = {.lex_state = 66},
  [2697] = {.lex_state = 66},
  [2698] = {.lex_state = 66, .external_lex_state = 4},
  [2699] = {.lex_state = 0},
  [2700] = {.lex_state = 0},
  [2701] = {.lex_state = 29},
  [2702] = {.lex_state = 0},
  [2703] = {.lex_state = 0},
  [2704] = {.lex_state = 0},
  [2705] = {.lex_state = 66},
  [2706] = {.lex_state = 0},
  [2707] = {.lex_state = 0},
  [2708] = {.lex_state = 0},
  [2709] = {.lex_state = 0},
  [2710] = {.lex_state = 0},
  [2711] = {.lex_state = 0},
  [2712] = {.lex_state = 66},
  [2713] = {.lex_state = 0},
  [2714] = {.lex_state = 66, .external_lex_state = 4},
  [2715] = {.lex_state = 66},
  [2716] = {.lex_state = 0},
  [2717] = {.lex_state = 66},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 0},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 0},
  [2723] = {.lex_state = 0},
  [2724] = {.lex_state = 0},
  [2725] = {.lex_state = 66},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 66},
  [2729] = {.lex_state = 66},
  [2730] = {.lex_state = 0, .external_lex_state = 4},
  [2731] = {.lex_state = 0},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 0},
  [2736] = {.lex_state = 0, .external_lex_state = 4},
  [2737] = {.lex_state = 0},
  [2738] = {.lex_state = 66},
  [2739] = {.lex_state = 0, .external_lex_state = 4},
  [2740] = {.lex_state = 66},
  [2741] = {.lex_state = 0},
  [2742] = {.lex_state = 66},
  [2743] = {.lex_state = 66},
  [2744] = {.lex_state = 0},
  [2745] = {.lex_state = 66},
  [2746] = {.lex_state = 0},
  [2747] = {.lex_state = 66},
  [2748] = {.lex_state = 0},
  [2749] = {.lex_state = 66},
  [2750] = {.lex_state = 0, .external_lex_state = 4},
  [2751] = {.lex_state = 66},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 66},
  [2754] = {.lex_state = 0},
  [2755] = {.lex_state = 66},
  [2756] = {.lex_state = 66},
  [2757] = {.lex_state = 66},
  [2758] = {.lex_state = 66},
  [2759] = {.lex_state = 66},
  [2760] = {.lex_state = 66},
  [2761] = {.lex_state = 66},
  [2762] = {.lex_state = 0},
  [2763] = {.lex_state = 66},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 0},
  [2766] = {.lex_state = 0},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 66},
  [2769] = {.lex_state = 0},
  [2770] = {.lex_state = 66},
  [2771] = {.lex_state = 66},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 66},
  [2776] = {.lex_state = 0, .external_lex_state = 4},
  [2777] = {.lex_state = 66},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 66},
  [2780] = {.lex_state = 0, .external_lex_state = 4},
  [2781] = {.lex_state = 66},
  [2782] = {.lex_state = 0},
  [2783] = {.lex_state = 0},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 66},
  [2786] = {.lex_state = 66},
  [2787] = {.lex_state = 66},
  [2788] = {.lex_state = 66},
  [2789] = {.lex_state = 66},
  [2790] = {.lex_state = 66},
  [2791] = {.lex_state = 0},
  [2792] = {.lex_state = 66},
  [2793] = {.lex_state = 0},
  [2794] = {.lex_state = 66},
  [2795] = {.lex_state = 66},
  [2796] = {.lex_state = 66},
  [2797] = {.lex_state = 66},
  [2798] = {.lex_state = 66},
  [2799] = {.lex_state = 66},
  [2800] = {.lex_state = 66},
  [2801] = {.lex_state = 66},
  [2802] = {.lex_state = 66},
  [2803] = {.lex_state = 0, .external_lex_state = 4},
  [2804] = {.lex_state = 66},
  [2805] = {.lex_state = 66},
  [2806] = {.lex_state = 0},
  [2807] = {.lex_state = 0, .external_lex_state = 4},
  [2808] = {.lex_state = 66},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 66},
  [2811] = {.lex_state = 66},
  [2812] = {.lex_state = 66},
  [2813] = {.lex_state = 66},
  [2814] = {.lex_state = 66},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 0},
  [2817] = {.lex_state = 0},
  [2818] = {.lex_state = 0},
  [2819] = {.lex_state = 66},
  [2820] = {.lex_state = 0},
  [2821] = {.lex_state = 66},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 66},
  [2824] = {.lex_state = 66},
  [2825] = {.lex_state = 66},
  [2826] = {.lex_state = 0, .external_lex_state = 4},
  [2827] = {.lex_state = 66},
  [2828] = {.lex_state = 0, .external_lex_state = 4},
  [2829] = {.lex_state = 0},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 66},
  [2833] = {.lex_state = 66},
  [2834] = {.lex_state = 66},
  [2835] = {.lex_state = 66},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 66},
  [2838] = {.lex_state = 17},
  [2839] = {.lex_state = 66},
  [2840] = {.lex_state = 66},
  [2841] = {.lex_state = 66},
  [2842] = {.lex_state = 66},
  [2843] = {.lex_state = 66},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 66},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 66},
  [2848] = {.lex_state = 66},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 66},
  [2851] = {.lex_state = 66},
  [2852] = {.lex_state = 66},
  [2853] = {.lex_state = 66},
  [2854] = {.lex_state = 66},
  [2855] = {.lex_state = 66},
  [2856] = {.lex_state = 66},
  [2857] = {.lex_state = 0},
  [2858] = {.lex_state = 66},
  [2859] = {.lex_state = 66},
  [2860] = {.lex_state = 66},
  [2861] = {.lex_state = 0},
  [2862] = {.lex_state = 66},
  [2863] = {.lex_state = 66},
  [2864] = {.lex_state = 66},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 66},
  [2867] = {.lex_state = 66},
  [2868] = {.lex_state = 66},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 66},
  [2871] = {.lex_state = 66},
  [2872] = {.lex_state = 66},
  [2873] = {.lex_state = 66},
  [2874] = {.lex_state = 66},
  [2875] = {.lex_state = 66},
  [2876] = {.lex_state = 66},
  [2877] = {.lex_state = 66},
  [2878] = {.lex_state = 66},
  [2879] = {.lex_state = 66},
  [2880] = {.lex_state = 0},
  [2881] = {.lex_state = 66},
  [2882] = {.lex_state = 0},
  [2883] = {.lex_state = 0, .external_lex_state = 4},
  [2884] = {.lex_state = 66},
  [2885] = {.lex_state = 0, .external_lex_state = 4},
  [2886] = {.lex_state = 66},
  [2887] = {.lex_state = 0},
  [2888] = {.lex_state = 66},
  [2889] = {.lex_state = 0},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 66},
  [2892] = {.lex_state = 0},
  [2893] = {.lex_state = 66},
  [2894] = {.lex_state = 66},
  [2895] = {.lex_state = 66},
  [2896] = {.lex_state = 0, .external_lex_state = 4},
  [2897] = {.lex_state = 0, .external_lex_state = 4},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 66},
  [2900] = {.lex_state = 66},
  [2901] = {.lex_state = 0},
  [2902] = {.lex_state = 66},
  [2903] = {.lex_state = 0},
  [2904] = {.lex_state = 66},
  [2905] = {.lex_state = 66},
  [2906] = {.lex_state = 66},
  [2907] = {.lex_state = 0},
  [2908] = {.lex_state = 66},
  [2909] = {.lex_state = 66},
  [2910] = {.lex_state = 0},
  [2911] = {.lex_state = 66},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 0},
  [2914] = {.lex_state = 66},
  [2915] = {.lex_state = 66},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 66},
  [2918] = {.lex_state = 66},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 66},
  [2921] = {.lex_state = 66},
  [2922] = {.lex_state = 66},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 66},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 66},
  [2927] = {.lex_state = 0, .external_lex_state = 4},
  [2928] = {.lex_state = 66},
  [2929] = {.lex_state = 66},
  [2930] = {.lex_state = 66},
  [2931] = {.lex_state = 66},
  [2932] = {.lex_state = 0, .external_lex_state = 4},
  [2933] = {.lex_state = 66},
  [2934] = {.lex_state = 66},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 66},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 66},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 66},
  [2942] = {.lex_state = 0},
  [2943] = {.lex_state = 66},
  [2944] = {.lex_state = 66},
  [2945] = {.lex_state = 66},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 0, .external_lex_state = 4},
  [2948] = {.lex_state = 0, .external_lex_state = 4},
  [2949] = {.lex_state = 0},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 66},
  [2952] = {.lex_state = 0},
  [2953] = {.lex_state = 0, .external_lex_state = 4},
  [2954] = {.lex_state = 66},
  [2955] = {.lex_state = 0, .external_lex_state = 4},
  [2956] = {.lex_state = 0, .external_lex_state = 4},
  [2957] = {.lex_state = 66},
  [2958] = {.lex_state = 0},
  [2959] = {.lex_state = 66},
  [2960] = {.lex_state = 66},
  [2961] = {.lex_state = 66},
  [2962] = {.lex_state = 66},
  [2963] = {.lex_state = 66},
  [2964] = {.lex_state = 0},
  [2965] = {.lex_state = 66},
  [2966] = {.lex_state = 0},
  [2967] = {.lex_state = 0, .external_lex_state = 4},
  [2968] = {.lex_state = 66},
  [2969] = {.lex_state = 66},
  [2970] = {.lex_state = 0, .external_lex_state = 4},
  [2971] = {.lex_state = 66},
  [2972] = {.lex_state = 66},
  [2973] = {.lex_state = 66},
  [2974] = {.lex_state = 0},
  [2975] = {.lex_state = 0},
  [2976] = {.lex_state = 66},
  [2977] = {.lex_state = 0},
  [2978] = {.lex_state = 0},
  [2979] = {.lex_state = 15},
  [2980] = {.lex_state = 66},
  [2981] = {.lex_state = 66},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 66},
  [2984] = {.lex_state = 66},
  [2985] = {.lex_state = 0},
  [2986] = {.lex_state = 0},
  [2987] = {.lex_state = 66},
  [2988] = {.lex_state = 0},
  [2989] = {.lex_state = 0},
  [2990] = {.lex_state = 5},
  [2991] = {.lex_state = 0},
  [2992] = {.lex_state = 66},
  [2993] = {.lex_state = 0},
  [2994] = {.lex_state = 66},
  [2995] = {.lex_state = 66},
  [2996] = {.lex_state = 66},
  [2997] = {.lex_state = 66},
  [2998] = {.lex_state = 66},
  [2999] = {.lex_state = 0},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 0},
  [3002] = {.lex_state = 0},
  [3003] = {.lex_state = 0},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 66},
  [3007] = {.lex_state = 66},
  [3008] = {.lex_state = 66},
  [3009] = {.lex_state = 66},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 66},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 0},
  [3016] = {.lex_state = 66},
  [3017] = {.lex_state = 66},
  [3018] = {.lex_state = 66},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 66},
  [3022] = {.lex_state = 66},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 0},
  [3026] = {.lex_state = 0},
  [3027] = {.lex_state = 66},
  [3028] = {.lex_state = 66},
  [3029] = {.lex_state = 66},
  [3030] = {.lex_state = 0},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 0},
  [3034] = {.lex_state = 66},
  [3035] = {.lex_state = 0},
  [3036] = {.lex_state = 66},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 0},
  [3039] = {.lex_state = 66},
  [3040] = {.lex_state = 66},
  [3041] = {.lex_state = 66},
  [3042] = {.lex_state = 5},
  [3043] = {.lex_state = 66},
  [3044] = {.lex_state = 66},
  [3045] = {.lex_state = 66},
  [3046] = {.lex_state = 66},
  [3047] = {.lex_state = 0},
  [3048] = {.lex_state = 66},
  [3049] = {.lex_state = 66},
  [3050] = {.lex_state = 66},
  [3051] = {.lex_state = 66},
  [3052] = {.lex_state = 0},
  [3053] = {.lex_state = 0},
  [3054] = {.lex_state = 66},
  [3055] = {.lex_state = 66},
  [3056] = {.lex_state = 0},
  [3057] = {.lex_state = 0},
  [3058] = {.lex_state = 0},
  [3059] = {.lex_state = 0},
  [3060] = {.lex_state = 66},
  [3061] = {.lex_state = 0},
  [3062] = {.lex_state = 66},
  [3063] = {.lex_state = 66},
  [3064] = {.lex_state = 66},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 0},
  [3067] = {.lex_state = 0},
  [3068] = {.lex_state = 0},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 66},
  [3071] = {.lex_state = 0},
  [3072] = {.lex_state = 66},
  [3073] = {.lex_state = 66},
  [3074] = {.lex_state = 0},
  [3075] = {.lex_state = 0},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 66},
  [3078] = {.lex_state = 0},
  [3079] = {.lex_state = 0},
  [3080] = {.lex_state = 0},
  [3081] = {.lex_state = 66},
  [3082] = {.lex_state = 66},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 0},
  [3085] = {.lex_state = 66},
  [3086] = {.lex_state = 66},
  [3087] = {.lex_state = 0},
  [3088] = {.lex_state = 66},
  [3089] = {.lex_state = 66},
  [3090] = {.lex_state = 0},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 0},
  [3093] = {.lex_state = 66},
  [3094] = {.lex_state = 15},
  [3095] = {.lex_state = 66},
  [3096] = {.lex_state = 15},
  [3097] = {.lex_state = 0},
  [3098] = {.lex_state = 66},
  [3099] = {.lex_state = 15},
  [3100] = {.lex_state = 0},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 0},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 66},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 66},
  [3110] = {.lex_state = 66},
  [3111] = {.lex_state = 0},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 0},
  [3114] = {.lex_state = 0},
  [3115] = {.lex_state = 66},
  [3116] = {.lex_state = 0},
  [3117] = {.lex_state = 66},
  [3118] = {.lex_state = 66},
  [3119] = {.lex_state = 66},
  [3120] = {.lex_state = 66},
  [3121] = {.lex_state = 66},
  [3122] = {.lex_state = 66},
  [3123] = {.lex_state = 66},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 66},
  [3126] = {.lex_state = 0},
  [3127] = {.lex_state = 66},
  [3128] = {.lex_state = 66},
  [3129] = {.lex_state = 66},
  [3130] = {.lex_state = 66},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 66},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 0},
  [3135] = {.lex_state = 0},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 0},
  [3138] = {.lex_state = 0},
  [3139] = {.lex_state = 0},
  [3140] = {.lex_state = 66},
  [3141] = {.lex_state = 0},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 0},
  [3144] = {.lex_state = 0},
  [3145] = {.lex_state = 0},
  [3146] = {.lex_state = 0},
  [3147] = {.lex_state = 66},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 66},
  [3150] = {.lex_state = 66},
  [3151] = {.lex_state = 66},
  [3152] = {.lex_state = 0},
  [3153] = {.lex_state = 66},
  [3154] = {.lex_state = 0},
  [3155] = {.lex_state = 0},
  [3156] = {.lex_state = 66},
  [3157] = {.lex_state = 66},
  [3158] = {.lex_state = 0},
  [3159] = {.lex_state = 0},
  [3160] = {.lex_state = 66},
  [3161] = {.lex_state = 66},
  [3162] = {.lex_state = 66},
  [3163] = {.lex_state = 66},
  [3164] = {.lex_state = 0},
  [3165] = {.lex_state = 66},
  [3166] = {.lex_state = 66},
  [3167] = {.lex_state = 66},
  [3168] = {.lex_state = 0},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 0},
  [3172] = {.lex_state = 5},
  [3173] = {.lex_state = 0},
  [3174] = {.lex_state = 66},
  [3175] = {.lex_state = 0},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 0},
  [3178] = {.lex_state = 66},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 66},
  [3181] = {.lex_state = 0},
  [3182] = {.lex_state = 66},
  [3183] = {.lex_state = 0},
  [3184] = {.lex_state = 66},
  [3185] = {.lex_state = 66},
  [3186] = {.lex_state = 0},
  [3187] = {.lex_state = 66},
  [3188] = {.lex_state = 0},
  [3189] = {.lex_state = 66},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 66},
  [3192] = {.lex_state = 66},
  [3193] = {.lex_state = 0},
  [3194] = {.lex_state = 66},
  [3195] = {.lex_state = 66},
  [3196] = {.lex_state = 66},
  [3197] = {.lex_state = 66},
  [3198] = {.lex_state = 66},
  [3199] = {.lex_state = 66},
  [3200] = {.lex_state = 5},
  [3201] = {.lex_state = 66},
  [3202] = {.lex_state = 66},
  [3203] = {.lex_state = 66},
  [3204] = {.lex_state = 66},
  [3205] = {.lex_state = 66},
  [3206] = {.lex_state = 66},
  [3207] = {.lex_state = 66},
  [3208] = {.lex_state = 66},
  [3209] = {.lex_state = 66},
  [3210] = {.lex_state = 66},
  [3211] = {.lex_state = 66},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3159),
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(12),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [2] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(24),
    [sym_lexical_declaration] = STATE(24),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2668),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(24),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(24),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(24),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2668),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2668),
    [sym_pair] = STATE(2668),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(24),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(24),
    [sym_abstract_class_declaration] = STATE(24),
    [sym_module] = STATE(24),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(24),
    [sym_interface_declaration] = STATE(24),
    [sym_enum_declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(24),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [3] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(18),
    [sym_lexical_declaration] = STATE(18),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(18),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(18),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(18),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2606),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(18),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(18),
    [sym_abstract_class_declaration] = STATE(18),
    [sym_module] = STATE(18),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(18),
    [sym_interface_declaration] = STATE(18),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias_declaration] = STATE(18),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_type] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(159),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(163),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_module] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(171),
    [anon_sym_number] = ACTIONS(171),
    [anon_sym_boolean] = ACTIONS(171),
    [anon_sym_string] = ACTIONS(171),
    [anon_sym_symbol] = ACTIONS(171),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(173),
  },
  [4] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2606),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(175),
    [anon_sym_type] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(159),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(163),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_module] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(171),
    [anon_sym_number] = ACTIONS(171),
    [anon_sym_boolean] = ACTIONS(171),
    [anon_sym_string] = ACTIONS(171),
    [anon_sym_symbol] = ACTIONS(171),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(173),
  },
  [5] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2656),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2656),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2656),
    [sym_pair] = STATE(2656),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(15),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_export] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_type] = ACTIONS(185),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(187),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(189),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(191),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(193),
    [anon_sym_set] = ACTIONS(193),
    [anon_sym_declare] = ACTIONS(195),
    [anon_sym_public] = ACTIONS(197),
    [anon_sym_private] = ACTIONS(197),
    [anon_sym_protected] = ACTIONS(197),
    [anon_sym_module] = ACTIONS(199),
    [anon_sym_any] = ACTIONS(201),
    [anon_sym_number] = ACTIONS(201),
    [anon_sym_boolean] = ACTIONS(201),
    [anon_sym_string] = ACTIONS(201),
    [anon_sym_symbol] = ACTIONS(201),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(203),
  },
  [6] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2606),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(205),
    [anon_sym_type] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(159),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(163),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_module] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(171),
    [anon_sym_number] = ACTIONS(171),
    [anon_sym_boolean] = ACTIONS(171),
    [anon_sym_string] = ACTIONS(171),
    [anon_sym_symbol] = ACTIONS(171),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(173),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_export] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_namespace] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(226),
    [anon_sym_import] = ACTIONS(229),
    [anon_sym_var] = ACTIONS(232),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(244),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_await] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(256),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_break] = ACTIONS(268),
    [anon_sym_continue] = ACTIONS(271),
    [anon_sym_debugger] = ACTIONS(274),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_BANG] = ACTIONS(313),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_void] = ACTIONS(316),
    [anon_sym_delete] = ACTIONS(226),
    [anon_sym_PLUS_PLUS] = ACTIONS(319),
    [anon_sym_DASH_DASH] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_SQUOTE] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [sym_number] = ACTIONS(331),
    [sym_this] = ACTIONS(334),
    [sym_super] = ACTIONS(337),
    [sym_true] = ACTIONS(334),
    [sym_false] = ACTIONS(334),
    [sym_null] = ACTIONS(334),
    [sym_undefined] = ACTIONS(334),
    [anon_sym_AT] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(346),
    [anon_sym_get] = ACTIONS(343),
    [anon_sym_set] = ACTIONS(343),
    [anon_sym_declare] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(343),
    [anon_sym_private] = ACTIONS(343),
    [anon_sym_protected] = ACTIONS(343),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_any] = ACTIONS(343),
    [anon_sym_number] = ACTIONS(343),
    [anon_sym_boolean] = ACTIONS(343),
    [anon_sym_string] = ACTIONS(343),
    [anon_sym_symbol] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(355),
    [anon_sym_enum] = ACTIONS(358),
    [sym_readonly] = ACTIONS(343),
  },
  [8] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(9),
    [sym_lexical_declaration] = STATE(9),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(9),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(9),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(9),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(9),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(9),
    [sym_abstract_class_declaration] = STATE(9),
    [sym_module] = STATE(9),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(9),
    [sym_interface_declaration] = STATE(9),
    [sym_enum_declaration] = STATE(9),
    [sym_type_alias_declaration] = STATE(9),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [10] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(11),
    [sym_lexical_declaration] = STATE(11),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(11),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(11),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(11),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(11),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(11),
    [sym_abstract_class_declaration] = STATE(11),
    [sym_module] = STATE(11),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(11),
    [sym_interface_declaration] = STATE(11),
    [sym_enum_declaration] = STATE(11),
    [sym_type_alias_declaration] = STATE(11),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [11] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [13] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(15),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [14] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(20),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [15] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [16] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [17] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(25),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [18] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [19] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(21),
    [sym_lexical_declaration] = STATE(21),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(21),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(21),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(21),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(21),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(21),
    [sym_abstract_class_declaration] = STATE(21),
    [sym_module] = STATE(21),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(21),
    [sym_interface_declaration] = STATE(21),
    [sym_enum_declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(21),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [21] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [22] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(18),
    [sym_lexical_declaration] = STATE(18),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(18),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(18),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(18),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(18),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(18),
    [sym_abstract_class_declaration] = STATE(18),
    [sym_module] = STATE(18),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(18),
    [sym_interface_declaration] = STATE(18),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias_declaration] = STATE(18),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [23] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(24),
    [sym_lexical_declaration] = STATE(24),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(24),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(24),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(24),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(24),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(24),
    [sym_abstract_class_declaration] = STATE(24),
    [sym_module] = STATE(24),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(24),
    [sym_interface_declaration] = STATE(24),
    [sym_enum_declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(24),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [24] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(401),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [26] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [27] = {
    [sym_export_statement] = STATE(28),
    [sym__declaration] = STATE(28),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(28),
    [sym_lexical_declaration] = STATE(28),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(28),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(28),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(28),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(28),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(28),
    [sym_abstract_class_declaration] = STATE(28),
    [sym_module] = STATE(28),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(28),
    [sym_interface_declaration] = STATE(28),
    [sym_enum_declaration] = STATE(28),
    [sym_type_alias_declaration] = STATE(28),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [28] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [29] = {
    [sym_export_statement] = STATE(556),
    [sym__declaration] = STATE(556),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(556),
    [sym_expression_statement] = STATE(556),
    [sym_variable_declaration] = STATE(556),
    [sym_lexical_declaration] = STATE(556),
    [sym_statement_block] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_for_in_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_do_statement] = STATE(556),
    [sym_try_statement] = STATE(556),
    [sym_with_statement] = STATE(556),
    [sym_break_statement] = STATE(556),
    [sym_continue_statement] = STATE(556),
    [sym_debugger_statement] = STATE(556),
    [sym_return_statement] = STATE(556),
    [sym_throw_statement] = STATE(556),
    [sym_empty_statement] = STATE(556),
    [sym_labeled_statement] = STATE(556),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(556),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(556),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(556),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(556),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(556),
    [sym_abstract_class_declaration] = STATE(556),
    [sym_module] = STATE(556),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(556),
    [sym_interface_declaration] = STATE(556),
    [sym_enum_declaration] = STATE(556),
    [sym_type_alias_declaration] = STATE(556),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [30] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(560),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [31] = {
    [sym_export_statement] = STATE(525),
    [sym__declaration] = STATE(525),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(525),
    [sym_expression_statement] = STATE(525),
    [sym_variable_declaration] = STATE(525),
    [sym_lexical_declaration] = STATE(525),
    [sym_statement_block] = STATE(525),
    [sym_if_statement] = STATE(525),
    [sym_switch_statement] = STATE(525),
    [sym_for_statement] = STATE(525),
    [sym_for_in_statement] = STATE(525),
    [sym_while_statement] = STATE(525),
    [sym_do_statement] = STATE(525),
    [sym_try_statement] = STATE(525),
    [sym_with_statement] = STATE(525),
    [sym_break_statement] = STATE(525),
    [sym_continue_statement] = STATE(525),
    [sym_debugger_statement] = STATE(525),
    [sym_return_statement] = STATE(525),
    [sym_throw_statement] = STATE(525),
    [sym_empty_statement] = STATE(525),
    [sym_labeled_statement] = STATE(525),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(525),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(525),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(525),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(525),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(525),
    [sym_abstract_class_declaration] = STATE(525),
    [sym_module] = STATE(525),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(525),
    [sym_interface_declaration] = STATE(525),
    [sym_enum_declaration] = STATE(525),
    [sym_type_alias_declaration] = STATE(525),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [32] = {
    [sym_export_statement] = STATE(606),
    [sym__declaration] = STATE(606),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(606),
    [sym_expression_statement] = STATE(606),
    [sym_variable_declaration] = STATE(606),
    [sym_lexical_declaration] = STATE(606),
    [sym_statement_block] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_switch_statement] = STATE(606),
    [sym_for_statement] = STATE(606),
    [sym_for_in_statement] = STATE(606),
    [sym_while_statement] = STATE(606),
    [sym_do_statement] = STATE(606),
    [sym_try_statement] = STATE(606),
    [sym_with_statement] = STATE(606),
    [sym_break_statement] = STATE(606),
    [sym_continue_statement] = STATE(606),
    [sym_debugger_statement] = STATE(606),
    [sym_return_statement] = STATE(606),
    [sym_throw_statement] = STATE(606),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(606),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(606),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(606),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(606),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(606),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(606),
    [sym_abstract_class_declaration] = STATE(606),
    [sym_module] = STATE(606),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(606),
    [sym_interface_declaration] = STATE(606),
    [sym_enum_declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(606),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [33] = {
    [sym_export_statement] = STATE(602),
    [sym__declaration] = STATE(602),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(602),
    [sym_expression_statement] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_statement_block] = STATE(602),
    [sym_if_statement] = STATE(602),
    [sym_switch_statement] = STATE(602),
    [sym_for_statement] = STATE(602),
    [sym_for_in_statement] = STATE(602),
    [sym_while_statement] = STATE(602),
    [sym_do_statement] = STATE(602),
    [sym_try_statement] = STATE(602),
    [sym_with_statement] = STATE(602),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(602),
    [sym_debugger_statement] = STATE(602),
    [sym_return_statement] = STATE(602),
    [sym_throw_statement] = STATE(602),
    [sym_empty_statement] = STATE(602),
    [sym_labeled_statement] = STATE(602),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(602),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(602),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(602),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [34] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(560),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [35] = {
    [sym_export_statement] = STATE(525),
    [sym__declaration] = STATE(525),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(525),
    [sym_expression_statement] = STATE(525),
    [sym_variable_declaration] = STATE(525),
    [sym_lexical_declaration] = STATE(525),
    [sym_statement_block] = STATE(525),
    [sym_if_statement] = STATE(525),
    [sym_switch_statement] = STATE(525),
    [sym_for_statement] = STATE(525),
    [sym_for_in_statement] = STATE(525),
    [sym_while_statement] = STATE(525),
    [sym_do_statement] = STATE(525),
    [sym_try_statement] = STATE(525),
    [sym_with_statement] = STATE(525),
    [sym_break_statement] = STATE(525),
    [sym_continue_statement] = STATE(525),
    [sym_debugger_statement] = STATE(525),
    [sym_return_statement] = STATE(525),
    [sym_throw_statement] = STATE(525),
    [sym_empty_statement] = STATE(525),
    [sym_labeled_statement] = STATE(525),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(525),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(525),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(525),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(525),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(525),
    [sym_abstract_class_declaration] = STATE(525),
    [sym_module] = STATE(525),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(525),
    [sym_interface_declaration] = STATE(525),
    [sym_enum_declaration] = STATE(525),
    [sym_type_alias_declaration] = STATE(525),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [36] = {
    [sym_export_statement] = STATE(602),
    [sym__declaration] = STATE(602),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(602),
    [sym_expression_statement] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_statement_block] = STATE(602),
    [sym_if_statement] = STATE(602),
    [sym_switch_statement] = STATE(602),
    [sym_for_statement] = STATE(602),
    [sym_for_in_statement] = STATE(602),
    [sym_while_statement] = STATE(602),
    [sym_do_statement] = STATE(602),
    [sym_try_statement] = STATE(602),
    [sym_with_statement] = STATE(602),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(602),
    [sym_debugger_statement] = STATE(602),
    [sym_return_statement] = STATE(602),
    [sym_throw_statement] = STATE(602),
    [sym_empty_statement] = STATE(602),
    [sym_labeled_statement] = STATE(602),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(602),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(602),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(602),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [37] = {
    [sym_export_statement] = STATE(2827),
    [sym__declaration] = STATE(2827),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(2827),
    [sym_expression_statement] = STATE(2827),
    [sym_variable_declaration] = STATE(2827),
    [sym_lexical_declaration] = STATE(2827),
    [sym_statement_block] = STATE(2827),
    [sym_if_statement] = STATE(2827),
    [sym_switch_statement] = STATE(2827),
    [sym_for_statement] = STATE(2827),
    [sym_for_in_statement] = STATE(2827),
    [sym_while_statement] = STATE(2827),
    [sym_do_statement] = STATE(2827),
    [sym_try_statement] = STATE(2827),
    [sym_with_statement] = STATE(2827),
    [sym_break_statement] = STATE(2827),
    [sym_continue_statement] = STATE(2827),
    [sym_debugger_statement] = STATE(2827),
    [sym_return_statement] = STATE(2827),
    [sym_throw_statement] = STATE(2827),
    [sym_empty_statement] = STATE(2827),
    [sym_labeled_statement] = STATE(2827),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(2827),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(2827),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(2827),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(2827),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(2827),
    [sym_abstract_class_declaration] = STATE(2827),
    [sym_module] = STATE(2827),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(2827),
    [sym_interface_declaration] = STATE(2827),
    [sym_enum_declaration] = STATE(2827),
    [sym_type_alias_declaration] = STATE(2827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [38] = {
    [sym_export_statement] = STATE(2800),
    [sym__declaration] = STATE(2800),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(2800),
    [sym_expression_statement] = STATE(2800),
    [sym_variable_declaration] = STATE(2800),
    [sym_lexical_declaration] = STATE(2800),
    [sym_statement_block] = STATE(2800),
    [sym_if_statement] = STATE(2800),
    [sym_switch_statement] = STATE(2800),
    [sym_for_statement] = STATE(2800),
    [sym_for_in_statement] = STATE(2800),
    [sym_while_statement] = STATE(2800),
    [sym_do_statement] = STATE(2800),
    [sym_try_statement] = STATE(2800),
    [sym_with_statement] = STATE(2800),
    [sym_break_statement] = STATE(2800),
    [sym_continue_statement] = STATE(2800),
    [sym_debugger_statement] = STATE(2800),
    [sym_return_statement] = STATE(2800),
    [sym_throw_statement] = STATE(2800),
    [sym_empty_statement] = STATE(2800),
    [sym_labeled_statement] = STATE(2800),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(2800),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(2800),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(2800),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(2800),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(2800),
    [sym_abstract_class_declaration] = STATE(2800),
    [sym_module] = STATE(2800),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(2800),
    [sym_interface_declaration] = STATE(2800),
    [sym_enum_declaration] = STATE(2800),
    [sym_type_alias_declaration] = STATE(2800),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [39] = {
    [sym_export_statement] = STATE(580),
    [sym__declaration] = STATE(580),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(580),
    [sym_expression_statement] = STATE(580),
    [sym_variable_declaration] = STATE(580),
    [sym_lexical_declaration] = STATE(580),
    [sym_statement_block] = STATE(580),
    [sym_if_statement] = STATE(580),
    [sym_switch_statement] = STATE(580),
    [sym_for_statement] = STATE(580),
    [sym_for_in_statement] = STATE(580),
    [sym_while_statement] = STATE(580),
    [sym_do_statement] = STATE(580),
    [sym_try_statement] = STATE(580),
    [sym_with_statement] = STATE(580),
    [sym_break_statement] = STATE(580),
    [sym_continue_statement] = STATE(580),
    [sym_debugger_statement] = STATE(580),
    [sym_return_statement] = STATE(580),
    [sym_throw_statement] = STATE(580),
    [sym_empty_statement] = STATE(580),
    [sym_labeled_statement] = STATE(580),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(580),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(580),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(580),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(580),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(580),
    [sym_abstract_class_declaration] = STATE(580),
    [sym_module] = STATE(580),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(580),
    [sym_interface_declaration] = STATE(580),
    [sym_enum_declaration] = STATE(580),
    [sym_type_alias_declaration] = STATE(580),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [40] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(593),
    [sym_lexical_declaration] = STATE(593),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(593),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(593),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(593),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(593),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(593),
    [sym_abstract_class_declaration] = STATE(593),
    [sym_module] = STATE(593),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(593),
    [sym_interface_declaration] = STATE(593),
    [sym_enum_declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(593),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [41] = {
    [sym_export_statement] = STATE(569),
    [sym__declaration] = STATE(569),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_variable_declaration] = STATE(569),
    [sym_lexical_declaration] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_debugger_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(569),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(569),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(569),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(569),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(569),
    [sym_abstract_class_declaration] = STATE(569),
    [sym_module] = STATE(569),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(569),
    [sym_interface_declaration] = STATE(569),
    [sym_enum_declaration] = STATE(569),
    [sym_type_alias_declaration] = STATE(569),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [42] = {
    [sym_export_statement] = STATE(556),
    [sym__declaration] = STATE(556),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(556),
    [sym_expression_statement] = STATE(556),
    [sym_variable_declaration] = STATE(556),
    [sym_lexical_declaration] = STATE(556),
    [sym_statement_block] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_for_in_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_do_statement] = STATE(556),
    [sym_try_statement] = STATE(556),
    [sym_with_statement] = STATE(556),
    [sym_break_statement] = STATE(556),
    [sym_continue_statement] = STATE(556),
    [sym_debugger_statement] = STATE(556),
    [sym_return_statement] = STATE(556),
    [sym_throw_statement] = STATE(556),
    [sym_empty_statement] = STATE(556),
    [sym_labeled_statement] = STATE(556),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(556),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(556),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(556),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(556),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(556),
    [sym_abstract_class_declaration] = STATE(556),
    [sym_module] = STATE(556),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(556),
    [sym_interface_declaration] = STATE(556),
    [sym_enum_declaration] = STATE(556),
    [sym_type_alias_declaration] = STATE(556),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [43] = {
    [sym_export_statement] = STATE(606),
    [sym__declaration] = STATE(606),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(606),
    [sym_expression_statement] = STATE(606),
    [sym_variable_declaration] = STATE(606),
    [sym_lexical_declaration] = STATE(606),
    [sym_statement_block] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_switch_statement] = STATE(606),
    [sym_for_statement] = STATE(606),
    [sym_for_in_statement] = STATE(606),
    [sym_while_statement] = STATE(606),
    [sym_do_statement] = STATE(606),
    [sym_try_statement] = STATE(606),
    [sym_with_statement] = STATE(606),
    [sym_break_statement] = STATE(606),
    [sym_continue_statement] = STATE(606),
    [sym_debugger_statement] = STATE(606),
    [sym_return_statement] = STATE(606),
    [sym_throw_statement] = STATE(606),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(606),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(606),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(606),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(606),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(606),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(606),
    [sym_abstract_class_declaration] = STATE(606),
    [sym_module] = STATE(606),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(606),
    [sym_interface_declaration] = STATE(606),
    [sym_enum_declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(606),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [44] = {
    [sym_export_statement] = STATE(525),
    [sym__declaration] = STATE(525),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(525),
    [sym_expression_statement] = STATE(525),
    [sym_variable_declaration] = STATE(525),
    [sym_lexical_declaration] = STATE(525),
    [sym_statement_block] = STATE(525),
    [sym_if_statement] = STATE(525),
    [sym_switch_statement] = STATE(525),
    [sym_for_statement] = STATE(525),
    [sym_for_in_statement] = STATE(525),
    [sym_while_statement] = STATE(525),
    [sym_do_statement] = STATE(525),
    [sym_try_statement] = STATE(525),
    [sym_with_statement] = STATE(525),
    [sym_break_statement] = STATE(525),
    [sym_continue_statement] = STATE(525),
    [sym_debugger_statement] = STATE(525),
    [sym_return_statement] = STATE(525),
    [sym_throw_statement] = STATE(525),
    [sym_empty_statement] = STATE(525),
    [sym_labeled_statement] = STATE(525),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(525),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(525),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(525),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(525),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(525),
    [sym_abstract_class_declaration] = STATE(525),
    [sym_module] = STATE(525),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(525),
    [sym_interface_declaration] = STATE(525),
    [sym_enum_declaration] = STATE(525),
    [sym_type_alias_declaration] = STATE(525),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [45] = {
    [sym_export_statement] = STATE(569),
    [sym__declaration] = STATE(569),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_variable_declaration] = STATE(569),
    [sym_lexical_declaration] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_debugger_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(569),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(569),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(569),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(569),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(569),
    [sym_abstract_class_declaration] = STATE(569),
    [sym_module] = STATE(569),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(569),
    [sym_interface_declaration] = STATE(569),
    [sym_enum_declaration] = STATE(569),
    [sym_type_alias_declaration] = STATE(569),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [46] = {
    [sym_export_statement] = STATE(556),
    [sym__declaration] = STATE(556),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(556),
    [sym_expression_statement] = STATE(556),
    [sym_variable_declaration] = STATE(556),
    [sym_lexical_declaration] = STATE(556),
    [sym_statement_block] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_for_in_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_do_statement] = STATE(556),
    [sym_try_statement] = STATE(556),
    [sym_with_statement] = STATE(556),
    [sym_break_statement] = STATE(556),
    [sym_continue_statement] = STATE(556),
    [sym_debugger_statement] = STATE(556),
    [sym_return_statement] = STATE(556),
    [sym_throw_statement] = STATE(556),
    [sym_empty_statement] = STATE(556),
    [sym_labeled_statement] = STATE(556),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(556),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(556),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(556),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(556),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(556),
    [sym_abstract_class_declaration] = STATE(556),
    [sym_module] = STATE(556),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(556),
    [sym_interface_declaration] = STATE(556),
    [sym_enum_declaration] = STATE(556),
    [sym_type_alias_declaration] = STATE(556),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [47] = {
    [sym_export_statement] = STATE(569),
    [sym__declaration] = STATE(569),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_variable_declaration] = STATE(569),
    [sym_lexical_declaration] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_debugger_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(569),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(569),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(569),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(569),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(569),
    [sym_abstract_class_declaration] = STATE(569),
    [sym_module] = STATE(569),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(569),
    [sym_interface_declaration] = STATE(569),
    [sym_enum_declaration] = STATE(569),
    [sym_type_alias_declaration] = STATE(569),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [48] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(542),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [49] = {
    [sym_export_statement] = STATE(606),
    [sym__declaration] = STATE(606),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(606),
    [sym_expression_statement] = STATE(606),
    [sym_variable_declaration] = STATE(606),
    [sym_lexical_declaration] = STATE(606),
    [sym_statement_block] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_switch_statement] = STATE(606),
    [sym_for_statement] = STATE(606),
    [sym_for_in_statement] = STATE(606),
    [sym_while_statement] = STATE(606),
    [sym_do_statement] = STATE(606),
    [sym_try_statement] = STATE(606),
    [sym_with_statement] = STATE(606),
    [sym_break_statement] = STATE(606),
    [sym_continue_statement] = STATE(606),
    [sym_debugger_statement] = STATE(606),
    [sym_return_statement] = STATE(606),
    [sym_throw_statement] = STATE(606),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(606),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(606),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(606),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(606),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(606),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(606),
    [sym_abstract_class_declaration] = STATE(606),
    [sym_module] = STATE(606),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(606),
    [sym_interface_declaration] = STATE(606),
    [sym_enum_declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(606),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [50] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(560),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [51] = {
    [sym_export_statement] = STATE(602),
    [sym__declaration] = STATE(602),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(602),
    [sym_expression_statement] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_statement_block] = STATE(602),
    [sym_if_statement] = STATE(602),
    [sym_switch_statement] = STATE(602),
    [sym_for_statement] = STATE(602),
    [sym_for_in_statement] = STATE(602),
    [sym_while_statement] = STATE(602),
    [sym_do_statement] = STATE(602),
    [sym_try_statement] = STATE(602),
    [sym_with_statement] = STATE(602),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(602),
    [sym_debugger_statement] = STATE(602),
    [sym_return_statement] = STATE(602),
    [sym_throw_statement] = STATE(602),
    [sym_empty_statement] = STATE(602),
    [sym_labeled_statement] = STATE(602),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(602),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(602),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(602),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [52] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(593),
    [sym_lexical_declaration] = STATE(593),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(593),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(593),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(593),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(593),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(593),
    [sym_abstract_class_declaration] = STATE(593),
    [sym_module] = STATE(593),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(593),
    [sym_interface_declaration] = STATE(593),
    [sym_enum_declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(593),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [53] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(542),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [54] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(593),
    [sym_lexical_declaration] = STATE(593),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(593),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(593),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(593),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(593),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(593),
    [sym_abstract_class_declaration] = STATE(593),
    [sym_module] = STATE(593),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(593),
    [sym_interface_declaration] = STATE(593),
    [sym_enum_declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(593),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [55] = {
    [sym_export_statement] = STATE(3006),
    [sym__declaration] = STATE(3006),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(3006),
    [sym_expression_statement] = STATE(3006),
    [sym_variable_declaration] = STATE(3006),
    [sym_lexical_declaration] = STATE(3006),
    [sym_statement_block] = STATE(3006),
    [sym_if_statement] = STATE(3006),
    [sym_switch_statement] = STATE(3006),
    [sym_for_statement] = STATE(3006),
    [sym_for_in_statement] = STATE(3006),
    [sym_while_statement] = STATE(3006),
    [sym_do_statement] = STATE(3006),
    [sym_try_statement] = STATE(3006),
    [sym_with_statement] = STATE(3006),
    [sym_break_statement] = STATE(3006),
    [sym_continue_statement] = STATE(3006),
    [sym_debugger_statement] = STATE(3006),
    [sym_return_statement] = STATE(3006),
    [sym_throw_statement] = STATE(3006),
    [sym_empty_statement] = STATE(3006),
    [sym_labeled_statement] = STATE(3006),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(3006),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(3006),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(3006),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(3006),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(3006),
    [sym_abstract_class_declaration] = STATE(3006),
    [sym_module] = STATE(3006),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(3006),
    [sym_interface_declaration] = STATE(3006),
    [sym_enum_declaration] = STATE(3006),
    [sym_type_alias_declaration] = STATE(3006),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [56] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(542),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [57] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [58] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [59] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [60] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1033),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [61] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1534),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [62] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [63] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_PIPE_RBRACE] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(617),
  },
  [64] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [65] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1033),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [66] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [67] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [68] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [69] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [70] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [71] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [72] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [73] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [74] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1534),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [75] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1589),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
  },
  [76] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(654),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [77] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [78] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [79] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [80] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1033),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [anon_sym_implements] = ACTIONS(521),
    [sym_readonly] = ACTIONS(519),
  },
  [81] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [82] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [83] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [84] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [85] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [86] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(756),
  },
  [87] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(756),
  },
  [88] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [89] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [90] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(790),
    [anon_sym_of] = ACTIONS(793),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [91] = {
    [sym_import] = STATE(1043),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1043),
    [sym_jsx_fragment] = STATE(1043),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1043),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_sequence_expression] = STATE(2978),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(837),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [92] = {
    [sym_import] = STATE(1031),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1031),
    [sym_yield_expression] = STATE(1031),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1031),
    [sym_jsx_fragment] = STATE(1031),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1031),
    [sym_class] = STATE(1031),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1031),
    [sym_arrow_function] = STATE(1031),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1031),
    [sym_new_expression] = STATE(1031),
    [sym_await_expression] = STATE(1031),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1031),
    [sym_augmented_assignment_expression] = STATE(1031),
    [sym_ternary_expression] = STATE(1031),
    [sym_binary_expression] = STATE(1031),
    [sym_unary_expression] = STATE(1031),
    [sym_update_expression] = STATE(1031),
    [sym_sequence_expression] = STATE(2977),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1031),
    [sym_regex] = STATE(1031),
    [sym_meta_property] = STATE(1031),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1031),
    [sym_as_expression] = STATE(1031),
    [sym_internal_module] = STATE(1031),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [93] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_sequence_expression] = STATE(3013),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(851),
    [sym_undefined] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [94] = {
    [sym_import] = STATE(1043),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1043),
    [sym_jsx_fragment] = STATE(1043),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1043),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_sequence_expression] = STATE(2978),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2580),
    [sym_constructor_type] = STATE(2580),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2580),
    [sym_intersection_type] = STATE(2580),
    [sym_function_type] = STATE(2580),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(837),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [95] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1219),
    [sym_jsx_fragment] = STATE(1219),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1219),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2659),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2657),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [96] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1220),
    [sym_jsx_fragment] = STATE(1220),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2664),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2665),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(879),
    [sym_undefined] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [97] = {
    [sym_import] = STATE(1207),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1207),
    [sym_jsx_fragment] = STATE(1207),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1207),
    [sym_class] = STATE(1207),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1207),
    [sym_arrow_function] = STATE(1207),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1207),
    [sym_new_expression] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(883),
    [sym_undefined] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [98] = {
    [sym_import] = STATE(1269),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1269),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1269),
    [sym_jsx_fragment] = STATE(1269),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1269),
    [sym_class] = STATE(1269),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1269),
    [sym_arrow_function] = STATE(1269),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1269),
    [sym_new_expression] = STATE(1269),
    [sym_await_expression] = STATE(1269),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1269),
    [sym_augmented_assignment_expression] = STATE(1269),
    [sym_spread_element] = STATE(2646),
    [sym_ternary_expression] = STATE(1269),
    [sym_binary_expression] = STATE(1269),
    [sym_unary_expression] = STATE(1269),
    [sym_update_expression] = STATE(1269),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1269),
    [sym_regex] = STATE(1269),
    [sym_meta_property] = STATE(1269),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1269),
    [sym_as_expression] = STATE(1269),
    [sym_internal_module] = STATE(1269),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2647),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(887),
    [sym_undefined] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [99] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1219),
    [sym_jsx_fragment] = STATE(1219),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1219),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2659),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2295),
    [sym_constructor_type] = STATE(2295),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2295),
    [sym_intersection_type] = STATE(2295),
    [sym_function_type] = STATE(2295),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2657),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [100] = {
    [sym_import] = STATE(983),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(983),
    [sym_arrow_function] = STATE(983),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(983),
    [sym_new_expression] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_string] = STATE(1045),
    [sym_template_string] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(899),
    [sym_this] = ACTIONS(901),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(903),
    [sym_false] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(907),
    [anon_sym_number] = ACTIONS(907),
    [anon_sym_boolean] = ACTIONS(907),
    [anon_sym_string] = ACTIONS(907),
    [anon_sym_symbol] = ACTIONS(907),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [101] = {
    [sym_import] = STATE(1106),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1106),
    [sym_yield_expression] = STATE(1106),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1106),
    [sym_jsx_fragment] = STATE(1106),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1106),
    [sym_class] = STATE(1106),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1106),
    [sym_arrow_function] = STATE(1106),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1106),
    [sym_new_expression] = STATE(1106),
    [sym_await_expression] = STATE(1106),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1106),
    [sym_augmented_assignment_expression] = STATE(1106),
    [sym_ternary_expression] = STATE(1106),
    [sym_binary_expression] = STATE(1106),
    [sym_unary_expression] = STATE(1106),
    [sym_update_expression] = STATE(1106),
    [sym_string] = STATE(1488),
    [sym_template_string] = STATE(1106),
    [sym_regex] = STATE(1106),
    [sym_meta_property] = STATE(1106),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1106),
    [sym_as_expression] = STATE(1106),
    [sym_internal_module] = STATE(1106),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(909),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(923),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(925),
    [sym_this] = ACTIONS(927),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(929),
    [sym_false] = ACTIONS(929),
    [sym_null] = ACTIONS(931),
    [sym_undefined] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
    [sym_readonly] = ACTIONS(469),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [102] = {
    [sym_import] = STATE(1239),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1239),
    [sym_jsx_fragment] = STATE(1239),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1239),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1451),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(937),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(943),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(945),
    [sym_this] = ACTIONS(947),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(949),
    [sym_false] = ACTIONS(949),
    [sym_null] = ACTIONS(951),
    [sym_undefined] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(953),
    [anon_sym_number] = ACTIONS(953),
    [anon_sym_boolean] = ACTIONS(953),
    [anon_sym_string] = ACTIONS(953),
    [anon_sym_symbol] = ACTIONS(953),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [103] = {
    [sym_import] = STATE(1363),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1363),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1363),
    [sym_jsx_fragment] = STATE(1363),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(2982),
    [sym_jsx_self_closing_element] = STATE(1363),
    [sym_class] = STATE(1363),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1363),
    [sym_arrow_function] = STATE(1363),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1363),
    [sym_new_expression] = STATE(1363),
    [sym_await_expression] = STATE(1363),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1363),
    [sym_augmented_assignment_expression] = STATE(1363),
    [sym_ternary_expression] = STATE(1363),
    [sym_binary_expression] = STATE(1363),
    [sym_unary_expression] = STATE(1363),
    [sym_update_expression] = STATE(1363),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1363),
    [sym_regex] = STATE(1363),
    [sym_meta_property] = STATE(1363),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2746),
    [sym_non_null_expression] = STATE(1363),
    [sym_as_expression] = STATE(1363),
    [sym_internal_module] = STATE(1363),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2010),
    [sym_constructor_type] = STATE(2010),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2846),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2010),
    [sym_intersection_type] = STATE(2010),
    [sym_function_type] = STATE(2010),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(955),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(961),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(963),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(979),
    [sym_this] = ACTIONS(981),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(987),
    [anon_sym_number] = ACTIONS(987),
    [anon_sym_boolean] = ACTIONS(987),
    [anon_sym_string] = ACTIONS(987),
    [anon_sym_symbol] = ACTIONS(987),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [104] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1258),
    [sym_jsx_fragment] = STATE(1258),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1258),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1603),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1011),
    [sym_this] = ACTIONS(1013),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1015),
    [sym_false] = ACTIONS(1015),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(1019),
    [anon_sym_number] = ACTIONS(1019),
    [anon_sym_boolean] = ACTIONS(1019),
    [anon_sym_string] = ACTIONS(1019),
    [anon_sym_symbol] = ACTIONS(1019),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [105] = {
    [sym_import] = STATE(1008),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1008),
    [sym_yield_expression] = STATE(1008),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1008),
    [sym_jsx_fragment] = STATE(1008),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1008),
    [sym_class] = STATE(1008),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1008),
    [sym_arrow_function] = STATE(1008),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1008),
    [sym_new_expression] = STATE(1008),
    [sym_await_expression] = STATE(1008),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1008),
    [sym_augmented_assignment_expression] = STATE(1008),
    [sym_ternary_expression] = STATE(1008),
    [sym_binary_expression] = STATE(1008),
    [sym_unary_expression] = STATE(1008),
    [sym_update_expression] = STATE(1008),
    [sym_string] = STATE(1008),
    [sym_template_string] = STATE(1008),
    [sym_regex] = STATE(1008),
    [sym_meta_property] = STATE(1008),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1008),
    [sym_as_expression] = STATE(1008),
    [sym_internal_module] = STATE(1008),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(1021),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_COLON] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_null] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [106] = {
    [sym_import] = STATE(1177),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1177),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1177),
    [sym_jsx_fragment] = STATE(1177),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1177),
    [sym_class] = STATE(1177),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1177),
    [sym_arrow_function] = STATE(1177),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(1177),
    [sym_ternary_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_update_expression] = STATE(1177),
    [sym_string] = STATE(1045),
    [sym_template_string] = STATE(1177),
    [sym_regex] = STATE(1177),
    [sym_meta_property] = STATE(1177),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1177),
    [sym_as_expression] = STATE(1177),
    [sym_internal_module] = STATE(1177),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(1039),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(899),
    [sym_this] = ACTIONS(901),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(903),
    [sym_false] = ACTIONS(903),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(1043),
    [anon_sym_number] = ACTIONS(1043),
    [anon_sym_boolean] = ACTIONS(1043),
    [anon_sym_string] = ACTIONS(1043),
    [anon_sym_symbol] = ACTIONS(1043),
    [sym_readonly] = ACTIONS(756),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [107] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1364),
    [sym_jsx_fragment] = STATE(1364),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1364),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1625),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(1047),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1055),
    [sym_this] = ACTIONS(1057),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [sym_readonly] = ACTIONS(664),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [108] = {
    [sym_import] = STATE(1119),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1119),
    [sym_yield_expression] = STATE(1119),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1119),
    [sym_jsx_fragment] = STATE(1119),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1119),
    [sym_class] = STATE(1119),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1119),
    [sym_arrow_function] = STATE(1119),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1119),
    [sym_new_expression] = STATE(1119),
    [sym_await_expression] = STATE(1119),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1119),
    [sym_augmented_assignment_expression] = STATE(1119),
    [sym_ternary_expression] = STATE(1119),
    [sym_binary_expression] = STATE(1119),
    [sym_unary_expression] = STATE(1119),
    [sym_update_expression] = STATE(1119),
    [sym_string] = STATE(1119),
    [sym_template_string] = STATE(1119),
    [sym_regex] = STATE(1119),
    [sym_meta_property] = STATE(1119),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1119),
    [sym_as_expression] = STATE(1119),
    [sym_internal_module] = STATE(1119),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1067),
    [sym_this] = ACTIONS(1069),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(1069),
    [sym_undefined] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(1025),
  },
  [109] = {
    [sym_import] = STATE(1276),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1276),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1276),
    [sym_jsx_fragment] = STATE(1276),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1276),
    [sym_class] = STATE(1276),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1276),
    [sym_arrow_function] = STATE(1276),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1276),
    [sym_new_expression] = STATE(1276),
    [sym_await_expression] = STATE(1276),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1276),
    [sym_augmented_assignment_expression] = STATE(1276),
    [sym_ternary_expression] = STATE(1276),
    [sym_binary_expression] = STATE(1276),
    [sym_unary_expression] = STATE(1276),
    [sym_update_expression] = STATE(1276),
    [sym_string] = STATE(1276),
    [sym_template_string] = STATE(1276),
    [sym_regex] = STATE(1276),
    [sym_meta_property] = STATE(1276),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1276),
    [sym_as_expression] = STATE(1276),
    [sym_internal_module] = STATE(1276),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_COLON] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [110] = {
    [sym_import] = STATE(1294),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1294),
    [sym_jsx_fragment] = STATE(1294),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1294),
    [sym_class] = STATE(1294),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1294),
    [sym_arrow_function] = STATE(1294),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1294),
    [sym_new_expression] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_string] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1079),
    [sym_this] = ACTIONS(1081),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1081),
    [sym_false] = ACTIONS(1081),
    [sym_null] = ACTIONS(1081),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_implements] = ACTIONS(1023),
    [sym_readonly] = ACTIONS(756),
  },
  [111] = {
    [sym_import] = STATE(1358),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1358),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1358),
    [sym_jsx_fragment] = STATE(1358),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1358),
    [sym_class] = STATE(1358),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1358),
    [sym_arrow_function] = STATE(1358),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1358),
    [sym_new_expression] = STATE(1358),
    [sym_await_expression] = STATE(1358),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1358),
    [sym_augmented_assignment_expression] = STATE(1358),
    [sym_ternary_expression] = STATE(1358),
    [sym_binary_expression] = STATE(1358),
    [sym_unary_expression] = STATE(1358),
    [sym_update_expression] = STATE(1358),
    [sym_string] = STATE(1358),
    [sym_template_string] = STATE(1358),
    [sym_regex] = STATE(1358),
    [sym_meta_property] = STATE(1358),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1358),
    [sym_as_expression] = STATE(1358),
    [sym_internal_module] = STATE(1358),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1085),
    [sym_this] = ACTIONS(1087),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1087),
    [sym_false] = ACTIONS(1087),
    [sym_null] = ACTIONS(1087),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
    [sym__automatic_semicolon] = ACTIONS(1025),
  },
  [112] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1315),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1315),
    [sym_jsx_fragment] = STATE(1315),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1315),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1315),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1315),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1315),
    [sym_augmented_assignment_expression] = STATE(1315),
    [sym_ternary_expression] = STATE(1315),
    [sym_binary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1315),
    [sym_update_expression] = STATE(1315),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1315),
    [sym_as_expression] = STATE(1315),
    [sym_internal_module] = STATE(1315),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1091),
    [sym_this] = ACTIONS(1093),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1093),
    [sym_false] = ACTIONS(1093),
    [sym_null] = ACTIONS(1093),
    [sym_undefined] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
  },
  [113] = {
    [sym_statement_block] = STATE(126),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1101),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [114] = {
    [sym_statement_block] = STATE(126),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(1117),
    [anon_sym_namespace] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1115),
    [anon_sym_typeof] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_var] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1115),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_do] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_debugger] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_throw] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_case] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(1117),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_LT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_STAR_STAR] = ACTIONS(1119),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_instanceof] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1115),
    [anon_sym_delete] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_number] = ACTIONS(1113),
    [sym_this] = ACTIONS(1115),
    [sym_super] = ACTIONS(1115),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_undefined] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1115),
    [anon_sym_abstract] = ACTIONS(1115),
    [anon_sym_get] = ACTIONS(1115),
    [anon_sym_set] = ACTIONS(1115),
    [anon_sym_declare] = ACTIONS(1115),
    [anon_sym_public] = ACTIONS(1115),
    [anon_sym_private] = ACTIONS(1115),
    [anon_sym_protected] = ACTIONS(1115),
    [anon_sym_module] = ACTIONS(1115),
    [anon_sym_any] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_boolean] = ACTIONS(1115),
    [anon_sym_string] = ACTIONS(1115),
    [anon_sym_symbol] = ACTIONS(1115),
    [anon_sym_interface] = ACTIONS(1115),
    [anon_sym_enum] = ACTIONS(1115),
    [sym_readonly] = ACTIONS(1115),
    [sym__automatic_semicolon] = ACTIONS(1121),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1123),
    [sym_identifier] = ACTIONS(1125),
    [anon_sym_export] = ACTIONS(1125),
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_type] = ACTIONS(1125),
    [anon_sym_typeof] = ACTIONS(1125),
    [anon_sym_import] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(1125),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_const] = ACTIONS(1125),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1125),
    [anon_sym_switch] = ACTIONS(1125),
    [anon_sym_for] = ACTIONS(1125),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_await] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_with] = ACTIONS(1125),
    [anon_sym_break] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1125),
    [anon_sym_debugger] = ACTIONS(1125),
    [anon_sym_return] = ACTIONS(1125),
    [anon_sym_throw] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_yield] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1125),
    [anon_sym_async] = ACTIONS(1125),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_new] = ACTIONS(1125),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1127),
    [anon_sym_GT_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_STAR_STAR] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1129),
    [anon_sym_instanceof] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym_number] = ACTIONS(1123),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1125),
    [anon_sym_abstract] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1125),
    [anon_sym_set] = ACTIONS(1125),
    [anon_sym_declare] = ACTIONS(1125),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_module] = ACTIONS(1125),
    [anon_sym_any] = ACTIONS(1125),
    [anon_sym_number] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1125),
    [anon_sym_symbol] = ACTIONS(1125),
    [anon_sym_interface] = ACTIONS(1125),
    [anon_sym_enum] = ACTIONS(1125),
    [sym_readonly] = ACTIONS(1125),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1137),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1139),
    [sym_identifier] = ACTIONS(1141),
    [anon_sym_export] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_as] = ACTIONS(1143),
    [anon_sym_namespace] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_type] = ACTIONS(1141),
    [anon_sym_typeof] = ACTIONS(1141),
    [anon_sym_import] = ACTIONS(1141),
    [anon_sym_var] = ACTIONS(1141),
    [anon_sym_let] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [anon_sym_await] = ACTIONS(1141),
    [anon_sym_in] = ACTIONS(1143),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_try] = ACTIONS(1141),
    [anon_sym_with] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_debugger] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_yield] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_LT] = ACTIONS(1141),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SLASH] = ACTIONS(1141),
    [anon_sym_DOT] = ACTIONS(1143),
    [anon_sym_class] = ACTIONS(1141),
    [anon_sym_async] = ACTIONS(1141),
    [anon_sym_function] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_GT_GT_GT] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1143),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_instanceof] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1141),
    [anon_sym_delete] = ACTIONS(1141),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1139),
    [sym_number] = ACTIONS(1139),
    [sym_this] = ACTIONS(1141),
    [sym_super] = ACTIONS(1141),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [sym_null] = ACTIONS(1141),
    [sym_undefined] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_abstract] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(1141),
    [anon_sym_set] = ACTIONS(1141),
    [anon_sym_declare] = ACTIONS(1141),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_module] = ACTIONS(1141),
    [anon_sym_any] = ACTIONS(1141),
    [anon_sym_number] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1141),
    [anon_sym_symbol] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [sym_readonly] = ACTIONS(1141),
    [sym__automatic_semicolon] = ACTIONS(1147),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_as] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_in] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_GT_GT_GT] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_CARET] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_PERCENT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1149),
    [anon_sym_GT_EQ] = ACTIONS(1149),
    [anon_sym_instanceof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1153),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1155),
    [anon_sym_as] = ACTIONS(1157),
    [anon_sym_namespace] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_type] = ACTIONS(1155),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(1155),
    [anon_sym_let] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1155),
    [anon_sym_else] = ACTIONS(1155),
    [anon_sym_switch] = ACTIONS(1155),
    [anon_sym_for] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_await] = ACTIONS(1155),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_do] = ACTIONS(1155),
    [anon_sym_try] = ACTIONS(1155),
    [anon_sym_with] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1155),
    [anon_sym_continue] = ACTIONS(1155),
    [anon_sym_debugger] = ACTIONS(1155),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_throw] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_class] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1155),
    [anon_sym_function] = ACTIONS(1155),
    [anon_sym_new] = ACTIONS(1155),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_instanceof] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_DQUOTE] = ACTIONS(1153),
    [anon_sym_SQUOTE] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1153),
    [sym_number] = ACTIONS(1153),
    [sym_this] = ACTIONS(1155),
    [sym_super] = ACTIONS(1155),
    [sym_true] = ACTIONS(1155),
    [sym_false] = ACTIONS(1155),
    [sym_null] = ACTIONS(1155),
    [sym_undefined] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1155),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_get] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1155),
    [anon_sym_declare] = ACTIONS(1155),
    [anon_sym_public] = ACTIONS(1155),
    [anon_sym_private] = ACTIONS(1155),
    [anon_sym_protected] = ACTIONS(1155),
    [anon_sym_module] = ACTIONS(1155),
    [anon_sym_any] = ACTIONS(1155),
    [anon_sym_number] = ACTIONS(1155),
    [anon_sym_boolean] = ACTIONS(1155),
    [anon_sym_string] = ACTIONS(1155),
    [anon_sym_symbol] = ACTIONS(1155),
    [anon_sym_interface] = ACTIONS(1155),
    [anon_sym_enum] = ACTIONS(1155),
    [sym_readonly] = ACTIONS(1155),
    [sym__automatic_semicolon] = ACTIONS(1161),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_namespace] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1165),
    [anon_sym_typeof] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_let] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_debugger] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_new] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_void] = ACTIONS(1165),
    [anon_sym_delete] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_number] = ACTIONS(1163),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(1165),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_abstract] = ACTIONS(1165),
    [anon_sym_get] = ACTIONS(1165),
    [anon_sym_set] = ACTIONS(1165),
    [anon_sym_declare] = ACTIONS(1165),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_module] = ACTIONS(1165),
    [anon_sym_any] = ACTIONS(1165),
    [anon_sym_number] = ACTIONS(1165),
    [anon_sym_boolean] = ACTIONS(1165),
    [anon_sym_string] = ACTIONS(1165),
    [anon_sym_symbol] = ACTIONS(1165),
    [anon_sym_interface] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [sym_readonly] = ACTIONS(1165),
    [sym__automatic_semicolon] = ACTIONS(1163),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1167),
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_namespace] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_type] = ACTIONS(1169),
    [anon_sym_typeof] = ACTIONS(1169),
    [anon_sym_import] = ACTIONS(1169),
    [anon_sym_var] = ACTIONS(1169),
    [anon_sym_let] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_await] = ACTIONS(1169),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_debugger] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_throw] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_yield] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1169),
    [anon_sym_function] = ACTIONS(1169),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_void] = ACTIONS(1169),
    [anon_sym_delete] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1167),
    [sym_this] = ACTIONS(1169),
    [sym_super] = ACTIONS(1169),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [sym_null] = ACTIONS(1169),
    [sym_undefined] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1167),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(1169),
    [anon_sym_set] = ACTIONS(1169),
    [anon_sym_declare] = ACTIONS(1169),
    [anon_sym_public] = ACTIONS(1169),
    [anon_sym_private] = ACTIONS(1169),
    [anon_sym_protected] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1169),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [anon_sym_interface] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [sym_readonly] = ACTIONS(1169),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1171),
    [sym_identifier] = ACTIONS(1173),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1175),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_typeof] = ACTIONS(1173),
    [anon_sym_import] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_await] = ACTIONS(1173),
    [anon_sym_in] = ACTIONS(1175),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_try] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_debugger] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_throw] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_class] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1173),
    [anon_sym_new] = ACTIONS(1173),
    [anon_sym_QMARK] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_GT_GT_GT] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_STAR] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1177),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1177),
    [anon_sym_GT_EQ] = ACTIONS(1177),
    [anon_sym_instanceof] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_delete] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [sym_number] = ACTIONS(1171),
    [sym_this] = ACTIONS(1173),
    [sym_super] = ACTIONS(1173),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(1171),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_abstract] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_interface] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [sym_readonly] = ACTIONS(1173),
    [sym__automatic_semicolon] = ACTIONS(1179),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1181),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_typeof] = ACTIONS(1183),
    [anon_sym_import] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(1183),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_const] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_try] = ACTIONS(1183),
    [anon_sym_with] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [anon_sym_debugger] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_throw] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1183),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_function] = ACTIONS(1183),
    [anon_sym_new] = ACTIONS(1183),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1181),
    [anon_sym_void] = ACTIONS(1183),
    [anon_sym_delete] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [sym_number] = ACTIONS(1181),
    [sym_this] = ACTIONS(1183),
    [sym_super] = ACTIONS(1183),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1183),
    [anon_sym_abstract] = ACTIONS(1183),
    [anon_sym_get] = ACTIONS(1183),
    [anon_sym_set] = ACTIONS(1183),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(1183),
    [anon_sym_private] = ACTIONS(1183),
    [anon_sym_protected] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [anon_sym_any] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_boolean] = ACTIONS(1183),
    [anon_sym_string] = ACTIONS(1183),
    [anon_sym_symbol] = ACTIONS(1183),
    [anon_sym_interface] = ACTIONS(1183),
    [anon_sym_enum] = ACTIONS(1183),
    [sym_readonly] = ACTIONS(1183),
    [sym__automatic_semicolon] = ACTIONS(1181),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(1189),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_import] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1187),
    [anon_sym_in] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_do] = ACTIONS(1187),
    [anon_sym_try] = ACTIONS(1187),
    [anon_sym_with] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [anon_sym_debugger] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1187),
    [anon_sym_yield] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1189),
    [anon_sym_class] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_new] = ACTIONS(1187),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_GT_GT_GT] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_STAR] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1191),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1191),
    [anon_sym_GT_EQ] = ACTIONS(1191),
    [anon_sym_instanceof] = ACTIONS(1189),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_void] = ACTIONS(1187),
    [anon_sym_delete] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_number] = ACTIONS(1185),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(1187),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(1187),
    [anon_sym_get] = ACTIONS(1187),
    [anon_sym_set] = ACTIONS(1187),
    [anon_sym_declare] = ACTIONS(1187),
    [anon_sym_public] = ACTIONS(1187),
    [anon_sym_private] = ACTIONS(1187),
    [anon_sym_protected] = ACTIONS(1187),
    [anon_sym_module] = ACTIONS(1187),
    [anon_sym_any] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_boolean] = ACTIONS(1187),
    [anon_sym_string] = ACTIONS(1187),
    [anon_sym_symbol] = ACTIONS(1187),
    [anon_sym_interface] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [sym_readonly] = ACTIONS(1187),
    [sym__automatic_semicolon] = ACTIONS(1193),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_in] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [sym__automatic_semicolon] = ACTIONS(1195),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1203),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_default] = ACTIONS(1211),
    [anon_sym_as] = ACTIONS(1211),
    [anon_sym_namespace] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_type] = ACTIONS(1211),
    [anon_sym_typeof] = ACTIONS(1211),
    [anon_sym_import] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_await] = ACTIONS(1211),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_do] = ACTIONS(1211),
    [anon_sym_try] = ACTIONS(1211),
    [anon_sym_with] = ACTIONS(1211),
    [anon_sym_break] = ACTIONS(1211),
    [anon_sym_continue] = ACTIONS(1211),
    [anon_sym_debugger] = ACTIONS(1211),
    [anon_sym_return] = ACTIONS(1211),
    [anon_sym_throw] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1211),
    [anon_sym_yield] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_class] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_function] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1211),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1211),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1211),
    [anon_sym_delete] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym_number] = ACTIONS(1209),
    [sym_this] = ACTIONS(1211),
    [sym_super] = ACTIONS(1211),
    [sym_true] = ACTIONS(1211),
    [sym_false] = ACTIONS(1211),
    [sym_null] = ACTIONS(1211),
    [sym_undefined] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1211),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1211),
    [anon_sym_declare] = ACTIONS(1211),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1211),
    [anon_sym_any] = ACTIONS(1211),
    [anon_sym_number] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1211),
    [anon_sym_symbol] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [sym_readonly] = ACTIONS(1211),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_AMP_AMP] = ACTIONS(1213),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1213),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_instanceof] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
    [sym__automatic_semicolon] = ACTIONS(1213),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1217),
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_export] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(1221),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_type] = ACTIONS(1219),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_import] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1219),
    [anon_sym_let] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_if] = ACTIONS(1219),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1219),
    [anon_sym_for] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_do] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1219),
    [anon_sym_with] = ACTIONS(1219),
    [anon_sym_break] = ACTIONS(1219),
    [anon_sym_continue] = ACTIONS(1219),
    [anon_sym_debugger] = ACTIONS(1219),
    [anon_sym_return] = ACTIONS(1219),
    [anon_sym_throw] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1217),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_yield] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_class] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_function] = ACTIONS(1219),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1217),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_delete] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [anon_sym_SQUOTE] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1217),
    [sym_number] = ACTIONS(1217),
    [sym_this] = ACTIONS(1219),
    [sym_super] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_declare] = ACTIONS(1219),
    [anon_sym_public] = ACTIONS(1219),
    [anon_sym_private] = ACTIONS(1219),
    [anon_sym_protected] = ACTIONS(1219),
    [anon_sym_module] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_interface] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [sym_readonly] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_export] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_as] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_type] = ACTIONS(1227),
    [anon_sym_typeof] = ACTIONS(1227),
    [anon_sym_import] = ACTIONS(1227),
    [anon_sym_var] = ACTIONS(1227),
    [anon_sym_let] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_await] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_try] = ACTIONS(1227),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_debugger] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_throw] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_class] = ACTIONS(1227),
    [anon_sym_async] = ACTIONS(1227),
    [anon_sym_function] = ACTIONS(1227),
    [anon_sym_new] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1225),
    [anon_sym_void] = ACTIONS(1227),
    [anon_sym_delete] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1225),
    [sym_this] = ACTIONS(1227),
    [sym_super] = ACTIONS(1227),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [sym_null] = ACTIONS(1227),
    [sym_undefined] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_abstract] = ACTIONS(1227),
    [anon_sym_get] = ACTIONS(1227),
    [anon_sym_set] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1227),
    [anon_sym_public] = ACTIONS(1227),
    [anon_sym_private] = ACTIONS(1227),
    [anon_sym_protected] = ACTIONS(1227),
    [anon_sym_module] = ACTIONS(1227),
    [anon_sym_any] = ACTIONS(1227),
    [anon_sym_number] = ACTIONS(1227),
    [anon_sym_boolean] = ACTIONS(1227),
    [anon_sym_string] = ACTIONS(1227),
    [anon_sym_symbol] = ACTIONS(1227),
    [anon_sym_interface] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [sym_readonly] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(1237),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_var] = ACTIONS(1237),
    [anon_sym_let] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_with] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_debugger] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_yield] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1237),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_delete] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym_number] = ACTIONS(1235),
    [sym_this] = ACTIONS(1237),
    [sym_super] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [sym_null] = ACTIONS(1237),
    [sym_undefined] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1235),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_interface] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [sym_readonly] = ACTIONS(1237),
    [sym__automatic_semicolon] = ACTIONS(1235),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1239),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_STAR] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1243),
    [anon_sym_as] = ACTIONS(1245),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_do] = ACTIONS(1243),
    [anon_sym_try] = ACTIONS(1243),
    [anon_sym_with] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1243),
    [anon_sym_continue] = ACTIONS(1243),
    [anon_sym_debugger] = ACTIONS(1243),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_throw] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1245),
    [anon_sym_class] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1243),
    [anon_sym_new] = ACTIONS(1243),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_GT_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1247),
    [anon_sym_GT_EQ] = ACTIONS(1247),
    [anon_sym_instanceof] = ACTIONS(1245),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1243),
    [anon_sym_delete] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_null] = ACTIONS(1243),
    [sym_undefined] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1243),
    [anon_sym_get] = ACTIONS(1243),
    [anon_sym_set] = ACTIONS(1243),
    [anon_sym_declare] = ACTIONS(1243),
    [anon_sym_public] = ACTIONS(1243),
    [anon_sym_private] = ACTIONS(1243),
    [anon_sym_protected] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1243),
    [anon_sym_number] = ACTIONS(1243),
    [anon_sym_boolean] = ACTIONS(1243),
    [anon_sym_string] = ACTIONS(1243),
    [anon_sym_symbol] = ACTIONS(1243),
    [anon_sym_interface] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(1243),
    [sym__automatic_semicolon] = ACTIONS(1249),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_in] = ACTIONS(1255),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_debugger] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_GT_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [sym_this] = ACTIONS(1253),
    [sym_super] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1251),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [sym_readonly] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1259),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_as] = ACTIONS(1265),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_type] = ACTIONS(1263),
    [anon_sym_typeof] = ACTIONS(1263),
    [anon_sym_import] = ACTIONS(1263),
    [anon_sym_var] = ACTIONS(1263),
    [anon_sym_let] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_await] = ACTIONS(1263),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1263),
    [anon_sym_with] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_debugger] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_throw] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_yield] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1263),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_function] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1267),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_instanceof] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_delete] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [sym_number] = ACTIONS(1261),
    [sym_this] = ACTIONS(1263),
    [sym_super] = ACTIONS(1263),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_undefined] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_abstract] = ACTIONS(1263),
    [anon_sym_get] = ACTIONS(1263),
    [anon_sym_set] = ACTIONS(1263),
    [anon_sym_declare] = ACTIONS(1263),
    [anon_sym_public] = ACTIONS(1263),
    [anon_sym_private] = ACTIONS(1263),
    [anon_sym_protected] = ACTIONS(1263),
    [anon_sym_module] = ACTIONS(1263),
    [anon_sym_any] = ACTIONS(1263),
    [anon_sym_number] = ACTIONS(1263),
    [anon_sym_boolean] = ACTIONS(1263),
    [anon_sym_string] = ACTIONS(1263),
    [anon_sym_symbol] = ACTIONS(1263),
    [anon_sym_interface] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [sym_readonly] = ACTIONS(1263),
    [sym__automatic_semicolon] = ACTIONS(1269),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1273),
    [anon_sym_export] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_as] = ACTIONS(1275),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(1273),
    [anon_sym_import] = ACTIONS(1273),
    [anon_sym_var] = ACTIONS(1273),
    [anon_sym_let] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_await] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_try] = ACTIONS(1273),
    [anon_sym_with] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_debugger] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1273),
    [anon_sym_async] = ACTIONS(1273),
    [anon_sym_function] = ACTIONS(1273),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_GT_GT_GT] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_instanceof] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1273),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_void] = ACTIONS(1273),
    [anon_sym_delete] = ACTIONS(1273),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [sym_number] = ACTIONS(1271),
    [sym_this] = ACTIONS(1273),
    [sym_super] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_undefined] = ACTIONS(1273),
    [anon_sym_AT] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_abstract] = ACTIONS(1273),
    [anon_sym_get] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(1273),
    [anon_sym_declare] = ACTIONS(1273),
    [anon_sym_public] = ACTIONS(1273),
    [anon_sym_private] = ACTIONS(1273),
    [anon_sym_protected] = ACTIONS(1273),
    [anon_sym_module] = ACTIONS(1273),
    [anon_sym_any] = ACTIONS(1273),
    [anon_sym_number] = ACTIONS(1273),
    [anon_sym_boolean] = ACTIONS(1273),
    [anon_sym_string] = ACTIONS(1273),
    [anon_sym_symbol] = ACTIONS(1273),
    [anon_sym_interface] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [sym_readonly] = ACTIONS(1273),
    [sym__automatic_semicolon] = ACTIONS(1279),
  },
  [140] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_empty_statement] = STATE(164),
    [sym_parenthesized_expression] = STATE(875),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1378),
    [sym_array] = STATE(1382),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(875),
    [sym_subscript_expression] = STATE(875),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_namespace] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_get] = ACTIONS(1283),
    [anon_sym_set] = ACTIONS(1283),
    [anon_sym_declare] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1283),
    [anon_sym_private] = ACTIONS(1283),
    [anon_sym_protected] = ACTIONS(1283),
    [anon_sym_module] = ACTIONS(1283),
    [anon_sym_any] = ACTIONS(1283),
    [anon_sym_number] = ACTIONS(1283),
    [anon_sym_boolean] = ACTIONS(1283),
    [anon_sym_string] = ACTIONS(1283),
    [anon_sym_symbol] = ACTIONS(1283),
    [sym_readonly] = ACTIONS(1283),
  },
  [141] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(161),
    [sym_variable_declaration] = STATE(161),
    [sym_lexical_declaration] = STATE(161),
    [sym_empty_statement] = STATE(161),
    [sym_parenthesized_expression] = STATE(875),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1378),
    [sym_array] = STATE(1382),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(875),
    [sym_subscript_expression] = STATE(875),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_namespace] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_get] = ACTIONS(1283),
    [anon_sym_set] = ACTIONS(1283),
    [anon_sym_declare] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1283),
    [anon_sym_private] = ACTIONS(1283),
    [anon_sym_protected] = ACTIONS(1283),
    [anon_sym_module] = ACTIONS(1283),
    [anon_sym_any] = ACTIONS(1283),
    [anon_sym_number] = ACTIONS(1283),
    [anon_sym_boolean] = ACTIONS(1283),
    [anon_sym_string] = ACTIONS(1283),
    [anon_sym_symbol] = ACTIONS(1283),
    [sym_readonly] = ACTIONS(1283),
  },
  [142] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(162),
    [sym_variable_declaration] = STATE(162),
    [sym_lexical_declaration] = STATE(162),
    [sym_empty_statement] = STATE(162),
    [sym_parenthesized_expression] = STATE(875),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1378),
    [sym_array] = STATE(1382),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(875),
    [sym_subscript_expression] = STATE(875),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_namespace] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_get] = ACTIONS(1283),
    [anon_sym_set] = ACTIONS(1283),
    [anon_sym_declare] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1283),
    [anon_sym_private] = ACTIONS(1283),
    [anon_sym_protected] = ACTIONS(1283),
    [anon_sym_module] = ACTIONS(1283),
    [anon_sym_any] = ACTIONS(1283),
    [anon_sym_number] = ACTIONS(1283),
    [anon_sym_boolean] = ACTIONS(1283),
    [anon_sym_string] = ACTIONS(1283),
    [anon_sym_symbol] = ACTIONS(1283),
    [sym_readonly] = ACTIONS(1283),
  },
  [143] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_sequence_expression] = STATE(3013),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1297),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1299),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_null] = ACTIONS(851),
    [sym_undefined] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [sym_readonly] = ACTIONS(843),
  },
  [144] = {
    [sym_import] = STATE(1031),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1031),
    [sym_yield_expression] = STATE(1031),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1031),
    [sym_jsx_fragment] = STATE(1031),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1031),
    [sym_class] = STATE(1031),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1031),
    [sym_arrow_function] = STATE(1031),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1031),
    [sym_new_expression] = STATE(1031),
    [sym_await_expression] = STATE(1031),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1031),
    [sym_augmented_assignment_expression] = STATE(1031),
    [sym_ternary_expression] = STATE(1031),
    [sym_binary_expression] = STATE(1031),
    [sym_unary_expression] = STATE(1031),
    [sym_update_expression] = STATE(1031),
    [sym_sequence_expression] = STATE(2977),
    [sym_string] = STATE(1031),
    [sym_template_string] = STATE(1031),
    [sym_regex] = STATE(1031),
    [sym_meta_property] = STATE(1031),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1031),
    [sym_as_expression] = STATE(1031),
    [sym_internal_module] = STATE(1031),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1297),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1303),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(849),
    [sym_false] = ACTIONS(849),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [sym_readonly] = ACTIONS(843),
  },
  [145] = {
    [sym_import] = STATE(1043),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1043),
    [sym_jsx_fragment] = STATE(1043),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1043),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_sequence_expression] = STATE(2978),
    [sym_string] = STATE(1043),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1297),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1305),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(837),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [sym_readonly] = ACTIONS(843),
  },
  [146] = {
    [sym_import] = STATE(1214),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1214),
    [sym_yield_expression] = STATE(1214),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1214),
    [sym_jsx_fragment] = STATE(1214),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1214),
    [sym_class] = STATE(1214),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1214),
    [sym_arrow_function] = STATE(1214),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1214),
    [sym_new_expression] = STATE(1214),
    [sym_await_expression] = STATE(1214),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1214),
    [sym_augmented_assignment_expression] = STATE(1214),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1214),
    [sym_binary_expression] = STATE(1214),
    [sym_unary_expression] = STATE(1214),
    [sym_update_expression] = STATE(1214),
    [sym_string] = STATE(1214),
    [sym_template_string] = STATE(1214),
    [sym_regex] = STATE(1214),
    [sym_meta_property] = STATE(1214),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1214),
    [sym_as_expression] = STATE(1214),
    [sym_internal_module] = STATE(1214),
    [sym_mapped_type_clause] = STATE(2985),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(1307),
    [anon_sym_export] = ACTIONS(1309),
    [anon_sym_namespace] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(1309),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1313),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1315),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1317),
    [sym_this] = ACTIONS(1319),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1319),
    [sym_false] = ACTIONS(1319),
    [sym_null] = ACTIONS(1319),
    [sym_undefined] = ACTIONS(1319),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_get] = ACTIONS(1309),
    [anon_sym_set] = ACTIONS(1309),
    [anon_sym_declare] = ACTIONS(1309),
    [anon_sym_public] = ACTIONS(1309),
    [anon_sym_private] = ACTIONS(1309),
    [anon_sym_protected] = ACTIONS(1309),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_any] = ACTIONS(1309),
    [anon_sym_number] = ACTIONS(1309),
    [anon_sym_boolean] = ACTIONS(1309),
    [anon_sym_string] = ACTIONS(1309),
    [anon_sym_symbol] = ACTIONS(1309),
    [sym_readonly] = ACTIONS(1309),
  },
  [147] = {
    [sym_import] = STATE(1300),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1300),
    [sym_yield_expression] = STATE(1300),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1300),
    [sym_jsx_fragment] = STATE(1300),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1300),
    [sym_class] = STATE(1300),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1300),
    [sym_arrow_function] = STATE(1300),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1300),
    [sym_new_expression] = STATE(1300),
    [sym_await_expression] = STATE(1300),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1300),
    [sym_augmented_assignment_expression] = STATE(1300),
    [sym_spread_element] = STATE(2727),
    [sym_ternary_expression] = STATE(1300),
    [sym_binary_expression] = STATE(1300),
    [sym_unary_expression] = STATE(1300),
    [sym_update_expression] = STATE(1300),
    [sym_string] = STATE(1300),
    [sym_template_string] = STATE(1300),
    [sym_regex] = STATE(1300),
    [sym_meta_property] = STATE(1300),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1300),
    [sym_as_expression] = STATE(1300),
    [sym_internal_module] = STATE(1300),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1321),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1323),
    [sym_this] = ACTIONS(1325),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [sym_null] = ACTIONS(1325),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [148] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1319),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1319),
    [sym_jsx_fragment] = STATE(1319),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1319),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1319),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1319),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1319),
    [sym_augmented_assignment_expression] = STATE(1319),
    [sym_spread_element] = STATE(2709),
    [sym_ternary_expression] = STATE(1319),
    [sym_binary_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1319),
    [sym_update_expression] = STATE(1319),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1319),
    [sym_as_expression] = STATE(1319),
    [sym_internal_module] = STATE(1319),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2710),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1329),
    [sym_this] = ACTIONS(1331),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_undefined] = ACTIONS(1331),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [149] = {
    [sym_import] = STATE(1307),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1307),
    [sym_jsx_fragment] = STATE(1307),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1307),
    [sym_class] = STATE(1307),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1307),
    [sym_arrow_function] = STATE(1307),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1307),
    [sym_new_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1307),
    [sym_augmented_assignment_expression] = STATE(1307),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_unary_expression] = STATE(1307),
    [sym_update_expression] = STATE(1307),
    [sym_string] = STATE(1307),
    [sym_template_string] = STATE(1307),
    [sym_regex] = STATE(1307),
    [sym_meta_property] = STATE(1307),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1307),
    [sym_as_expression] = STATE(1307),
    [sym_internal_module] = STATE(1307),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1333),
    [sym_this] = ACTIONS(1335),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1335),
    [sym_false] = ACTIONS(1335),
    [sym_null] = ACTIONS(1335),
    [sym_undefined] = ACTIONS(1335),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [150] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1219),
    [sym_jsx_fragment] = STATE(1219),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1219),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2659),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1219),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2657),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1337),
    [sym_this] = ACTIONS(873),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(873),
    [sym_false] = ACTIONS(873),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [151] = {
    [sym_import] = STATE(1209),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1209),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1209),
    [sym_jsx_fragment] = STATE(1209),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1209),
    [sym_class] = STATE(1209),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1209),
    [sym_arrow_function] = STATE(1209),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1209),
    [sym_new_expression] = STATE(1209),
    [sym_await_expression] = STATE(1209),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1209),
    [sym_augmented_assignment_expression] = STATE(1209),
    [sym_spread_element] = STATE(2597),
    [sym_ternary_expression] = STATE(1209),
    [sym_binary_expression] = STATE(1209),
    [sym_unary_expression] = STATE(1209),
    [sym_update_expression] = STATE(1209),
    [sym_string] = STATE(1209),
    [sym_template_string] = STATE(1209),
    [sym_regex] = STATE(1209),
    [sym_meta_property] = STATE(1209),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1209),
    [sym_as_expression] = STATE(1209),
    [sym_internal_module] = STATE(1209),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2596),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1341),
    [sym_this] = ACTIONS(1343),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_null] = ACTIONS(1343),
    [sym_undefined] = ACTIONS(1343),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [152] = {
    [sym_import] = STATE(1211),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1211),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1211),
    [sym_jsx_fragment] = STATE(1211),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1211),
    [sym_class] = STATE(1211),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1211),
    [sym_arrow_function] = STATE(1211),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1211),
    [sym_new_expression] = STATE(1211),
    [sym_await_expression] = STATE(1211),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1211),
    [sym_augmented_assignment_expression] = STATE(1211),
    [sym_spread_element] = STATE(2614),
    [sym_ternary_expression] = STATE(1211),
    [sym_binary_expression] = STATE(1211),
    [sym_unary_expression] = STATE(1211),
    [sym_update_expression] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_template_string] = STATE(1211),
    [sym_regex] = STATE(1211),
    [sym_meta_property] = STATE(1211),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1211),
    [sym_as_expression] = STATE(1211),
    [sym_internal_module] = STATE(1211),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2615),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1345),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1349),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [sym_null] = ACTIONS(1349),
    [sym_undefined] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [153] = {
    [sym_import] = STATE(1410),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1410),
    [sym_yield_expression] = STATE(1410),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1410),
    [sym_jsx_fragment] = STATE(1410),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1410),
    [sym_class] = STATE(1410),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1410),
    [sym_arrow_function] = STATE(1410),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1410),
    [sym_new_expression] = STATE(1410),
    [sym_await_expression] = STATE(1410),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1410),
    [sym_augmented_assignment_expression] = STATE(1410),
    [sym_spread_element] = STATE(2617),
    [sym_ternary_expression] = STATE(1410),
    [sym_binary_expression] = STATE(1410),
    [sym_unary_expression] = STATE(1410),
    [sym_update_expression] = STATE(1410),
    [sym_sequence_expression] = STATE(2480),
    [sym_string] = STATE(1410),
    [sym_template_string] = STATE(1410),
    [sym_regex] = STATE(1410),
    [sym_meta_property] = STATE(1410),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1410),
    [sym_as_expression] = STATE(1410),
    [sym_internal_module] = STATE(1410),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1353),
    [sym_this] = ACTIONS(1355),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [sym_null] = ACTIONS(1355),
    [sym_undefined] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [154] = {
    [sym_import] = STATE(1207),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1207),
    [sym_jsx_fragment] = STATE(1207),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1207),
    [sym_class] = STATE(1207),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1207),
    [sym_arrow_function] = STATE(1207),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1207),
    [sym_new_expression] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_string] = STATE(1207),
    [sym_template_string] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1357),
    [sym_this] = ACTIONS(883),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(883),
    [sym_false] = ACTIONS(883),
    [sym_null] = ACTIONS(883),
    [sym_undefined] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [155] = {
    [sym_import] = STATE(1213),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1213),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1213),
    [sym_jsx_fragment] = STATE(1213),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1213),
    [sym_class] = STATE(1213),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1213),
    [sym_arrow_function] = STATE(1213),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1213),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1213),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2617),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1213),
    [sym_template_string] = STATE(1213),
    [sym_regex] = STATE(1213),
    [sym_meta_property] = STATE(1213),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1213),
    [sym_as_expression] = STATE(1213),
    [sym_internal_module] = STATE(1213),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1359),
    [sym_this] = ACTIONS(1361),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_undefined] = ACTIONS(1361),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [156] = {
    [sym_import] = STATE(1295),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1295),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1295),
    [sym_jsx_fragment] = STATE(1295),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1295),
    [sym_class] = STATE(1295),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1295),
    [sym_arrow_function] = STATE(1295),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1295),
    [sym_new_expression] = STATE(1295),
    [sym_await_expression] = STATE(1295),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1295),
    [sym_augmented_assignment_expression] = STATE(1295),
    [sym_spread_element] = STATE(2731),
    [sym_ternary_expression] = STATE(1295),
    [sym_binary_expression] = STATE(1295),
    [sym_unary_expression] = STATE(1295),
    [sym_update_expression] = STATE(1295),
    [sym_string] = STATE(1295),
    [sym_template_string] = STATE(1295),
    [sym_regex] = STATE(1295),
    [sym_meta_property] = STATE(1295),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1295),
    [sym_as_expression] = STATE(1295),
    [sym_internal_module] = STATE(1295),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2732),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1365),
    [sym_this] = ACTIONS(1367),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1367),
    [sym_false] = ACTIONS(1367),
    [sym_null] = ACTIONS(1367),
    [sym_undefined] = ACTIONS(1367),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [157] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1220),
    [sym_jsx_fragment] = STATE(1220),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2664),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2665),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1369),
    [sym_this] = ACTIONS(879),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_null] = ACTIONS(879),
    [sym_undefined] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [158] = {
    [sym_import] = STATE(1299),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1299),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1299),
    [sym_jsx_fragment] = STATE(1299),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1299),
    [sym_class] = STATE(1299),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1299),
    [sym_arrow_function] = STATE(1299),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1299),
    [sym_new_expression] = STATE(1299),
    [sym_await_expression] = STATE(1299),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1299),
    [sym_augmented_assignment_expression] = STATE(1299),
    [sym_spread_element] = STATE(2646),
    [sym_ternary_expression] = STATE(1299),
    [sym_binary_expression] = STATE(1299),
    [sym_unary_expression] = STATE(1299),
    [sym_update_expression] = STATE(1299),
    [sym_string] = STATE(1299),
    [sym_template_string] = STATE(1299),
    [sym_regex] = STATE(1299),
    [sym_meta_property] = STATE(1299),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1299),
    [sym_as_expression] = STATE(1299),
    [sym_internal_module] = STATE(1299),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2647),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1371),
    [sym_this] = ACTIONS(1373),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_undefined] = ACTIONS(1373),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [159] = {
    [sym_import] = STATE(1269),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1269),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1269),
    [sym_jsx_fragment] = STATE(1269),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1269),
    [sym_class] = STATE(1269),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1269),
    [sym_arrow_function] = STATE(1269),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1269),
    [sym_new_expression] = STATE(1269),
    [sym_await_expression] = STATE(1269),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1269),
    [sym_augmented_assignment_expression] = STATE(1269),
    [sym_spread_element] = STATE(2646),
    [sym_ternary_expression] = STATE(1269),
    [sym_binary_expression] = STATE(1269),
    [sym_unary_expression] = STATE(1269),
    [sym_update_expression] = STATE(1269),
    [sym_string] = STATE(1269),
    [sym_template_string] = STATE(1269),
    [sym_regex] = STATE(1269),
    [sym_meta_property] = STATE(1269),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1269),
    [sym_as_expression] = STATE(1269),
    [sym_internal_module] = STATE(1269),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2647),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1375),
    [sym_this] = ACTIONS(887),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(887),
    [sym_false] = ACTIONS(887),
    [sym_null] = ACTIONS(887),
    [sym_undefined] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [160] = {
    [sym_import] = STATE(1352),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1352),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1352),
    [sym_jsx_fragment] = STATE(1352),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1352),
    [sym_class] = STATE(1352),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1352),
    [sym_arrow_function] = STATE(1352),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1352),
    [sym_new_expression] = STATE(1352),
    [sym_await_expression] = STATE(1352),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1352),
    [sym_augmented_assignment_expression] = STATE(1352),
    [sym_spread_element] = STATE(3175),
    [sym_ternary_expression] = STATE(1352),
    [sym_binary_expression] = STATE(1352),
    [sym_unary_expression] = STATE(1352),
    [sym_update_expression] = STATE(1352),
    [sym_sequence_expression] = STATE(3175),
    [sym_string] = STATE(1352),
    [sym_template_string] = STATE(1352),
    [sym_regex] = STATE(1352),
    [sym_meta_property] = STATE(1352),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1352),
    [sym_as_expression] = STATE(1352),
    [sym_internal_module] = STATE(1352),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1381),
    [sym_this] = ACTIONS(1383),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_undefined] = ACTIONS(1383),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [161] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(171),
    [sym_empty_statement] = STATE(171),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [162] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(172),
    [sym_empty_statement] = STATE(172),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [163] = {
    [sym_import] = STATE(1337),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1337),
    [sym_jsx_fragment] = STATE(1337),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1337),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_spread_element] = STATE(3078),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_sequence_expression] = STATE(3078),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1387),
    [sym_this] = ACTIONS(1389),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [sym_null] = ACTIONS(1389),
    [sym_undefined] = ACTIONS(1389),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [164] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(173),
    [sym_empty_statement] = STATE(173),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [165] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1265),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1265),
    [sym_jsx_fragment] = STATE(1265),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(3069),
    [sym_jsx_self_closing_element] = STATE(1265),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1265),
    [sym_await_expression] = STATE(1265),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1265),
    [sym_augmented_assignment_expression] = STATE(1265),
    [sym_ternary_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_update_expression] = STATE(1265),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1265),
    [sym_as_expression] = STATE(1265),
    [sym_internal_module] = STATE(1265),
    [sym_nested_type_identifier] = STATE(2312),
    [sym_generic_type] = STATE(2622),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1395),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [sym_undefined] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [166] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1215),
    [sym_yield_expression] = STATE(1215),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1215),
    [sym_jsx_fragment] = STATE(1215),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1215),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1215),
    [sym_await_expression] = STATE(1215),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(1215),
    [sym_ternary_expression] = STATE(1215),
    [sym_binary_expression] = STATE(1215),
    [sym_unary_expression] = STATE(1215),
    [sym_update_expression] = STATE(1215),
    [sym_string] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1215),
    [sym_as_expression] = STATE(1215),
    [sym_internal_module] = STATE(1215),
    [sym_nested_type_identifier] = STATE(2301),
    [sym_generic_type] = STATE(2592),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1399),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1401),
    [sym_this] = ACTIONS(1403),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_undefined] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [167] = {
    [sym_import] = STATE(1591),
    [sym_parenthesized_expression] = STATE(930),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1720),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(930),
    [sym_subscript_expression] = STATE(930),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1405),
    [anon_sym_export] = ACTIONS(1407),
    [anon_sym_namespace] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1407),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_var] = ACTIONS(1411),
    [anon_sym_let] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1407),
    [anon_sym_get] = ACTIONS(1407),
    [anon_sym_set] = ACTIONS(1407),
    [anon_sym_declare] = ACTIONS(1407),
    [anon_sym_public] = ACTIONS(1407),
    [anon_sym_private] = ACTIONS(1407),
    [anon_sym_protected] = ACTIONS(1407),
    [anon_sym_module] = ACTIONS(1407),
    [anon_sym_any] = ACTIONS(1407),
    [anon_sym_number] = ACTIONS(1407),
    [anon_sym_boolean] = ACTIONS(1407),
    [anon_sym_string] = ACTIONS(1407),
    [anon_sym_symbol] = ACTIONS(1407),
    [sym_readonly] = ACTIONS(1407),
  },
  [168] = {
    [sym_import] = STATE(1071),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1071),
    [sym_yield_expression] = STATE(1071),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1071),
    [sym_jsx_fragment] = STATE(1071),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1071),
    [sym_class] = STATE(1071),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1071),
    [sym_arrow_function] = STATE(1071),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1071),
    [sym_new_expression] = STATE(1071),
    [sym_await_expression] = STATE(1071),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1071),
    [sym_augmented_assignment_expression] = STATE(1071),
    [sym_ternary_expression] = STATE(1071),
    [sym_binary_expression] = STATE(1071),
    [sym_unary_expression] = STATE(1071),
    [sym_update_expression] = STATE(1071),
    [sym_string] = STATE(1071),
    [sym_template_string] = STATE(1071),
    [sym_regex] = STATE(1071),
    [sym_meta_property] = STATE(1071),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1071),
    [sym_as_expression] = STATE(1071),
    [sym_internal_module] = STATE(1071),
    [sym_nested_type_identifier] = STATE(2155),
    [sym_generic_type] = STATE(2457),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1423),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [169] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1023),
    [sym_jsx_fragment] = STATE(1023),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(3069),
    [sym_jsx_self_closing_element] = STATE(1023),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_nested_type_identifier] = STATE(2132),
    [sym_generic_type] = STATE(2515),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1429),
    [sym_this] = ACTIONS(1431),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1431),
    [sym_false] = ACTIONS(1431),
    [sym_null] = ACTIONS(1431),
    [sym_undefined] = ACTIONS(1431),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [170] = {
    [sym_import] = STATE(1293),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1293),
    [sym_jsx_fragment] = STATE(1293),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1293),
    [sym_class] = STATE(1293),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1293),
    [sym_arrow_function] = STATE(1293),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1293),
    [sym_new_expression] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_sequence_expression] = STATE(2953),
    [sym_string] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1435),
    [sym_this] = ACTIONS(1437),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [sym_null] = ACTIONS(1437),
    [sym_undefined] = ACTIONS(1437),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(1433),
  },
  [171] = {
    [sym_import] = STATE(1387),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1387),
    [sym_yield_expression] = STATE(1387),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1387),
    [sym_jsx_fragment] = STATE(1387),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1387),
    [sym_class] = STATE(1387),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1387),
    [sym_arrow_function] = STATE(1387),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1387),
    [sym_new_expression] = STATE(1387),
    [sym_await_expression] = STATE(1387),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1387),
    [sym_augmented_assignment_expression] = STATE(1387),
    [sym_ternary_expression] = STATE(1387),
    [sym_binary_expression] = STATE(1387),
    [sym_unary_expression] = STATE(1387),
    [sym_update_expression] = STATE(1387),
    [sym_sequence_expression] = STATE(3179),
    [sym_string] = STATE(1387),
    [sym_template_string] = STATE(1387),
    [sym_regex] = STATE(1387),
    [sym_meta_property] = STATE(1387),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1387),
    [sym_as_expression] = STATE(1387),
    [sym_internal_module] = STATE(1387),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1441),
    [sym_this] = ACTIONS(1443),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_undefined] = ACTIONS(1443),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [172] = {
    [sym_import] = STATE(1397),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1397),
    [sym_yield_expression] = STATE(1397),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1397),
    [sym_jsx_fragment] = STATE(1397),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1397),
    [sym_class] = STATE(1397),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1397),
    [sym_arrow_function] = STATE(1397),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1397),
    [sym_new_expression] = STATE(1397),
    [sym_await_expression] = STATE(1397),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1397),
    [sym_augmented_assignment_expression] = STATE(1397),
    [sym_ternary_expression] = STATE(1397),
    [sym_binary_expression] = STATE(1397),
    [sym_unary_expression] = STATE(1397),
    [sym_update_expression] = STATE(1397),
    [sym_sequence_expression] = STATE(3058),
    [sym_string] = STATE(1397),
    [sym_template_string] = STATE(1397),
    [sym_regex] = STATE(1397),
    [sym_meta_property] = STATE(1397),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1397),
    [sym_as_expression] = STATE(1397),
    [sym_internal_module] = STATE(1397),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1447),
    [sym_this] = ACTIONS(1449),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1449),
    [sym_false] = ACTIONS(1449),
    [sym_null] = ACTIONS(1449),
    [sym_undefined] = ACTIONS(1449),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [173] = {
    [sym_import] = STATE(1384),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1384),
    [sym_jsx_fragment] = STATE(1384),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1384),
    [sym_class] = STATE(1384),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1384),
    [sym_arrow_function] = STATE(1384),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1384),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1384),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3092),
    [sym_string] = STATE(1384),
    [sym_template_string] = STATE(1384),
    [sym_regex] = STATE(1384),
    [sym_meta_property] = STATE(1384),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1451),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1453),
    [sym_this] = ACTIONS(1455),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1455),
    [sym_false] = ACTIONS(1455),
    [sym_null] = ACTIONS(1455),
    [sym_undefined] = ACTIONS(1455),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [174] = {
    [sym_import] = STATE(1128),
    [sym_statement_block] = STATE(1437),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1128),
    [sym_yield_expression] = STATE(1128),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1128),
    [sym_jsx_fragment] = STATE(1128),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1128),
    [sym_class] = STATE(1128),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1128),
    [sym_arrow_function] = STATE(1128),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1128),
    [sym_new_expression] = STATE(1128),
    [sym_await_expression] = STATE(1128),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1128),
    [sym_augmented_assignment_expression] = STATE(1128),
    [sym_ternary_expression] = STATE(1128),
    [sym_binary_expression] = STATE(1128),
    [sym_unary_expression] = STATE(1128),
    [sym_update_expression] = STATE(1128),
    [sym_string] = STATE(1128),
    [sym_template_string] = STATE(1128),
    [sym_regex] = STATE(1128),
    [sym_meta_property] = STATE(1128),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1128),
    [sym_as_expression] = STATE(1128),
    [sym_internal_module] = STATE(1128),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [175] = {
    [sym_import] = STATE(1404),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1404),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1404),
    [sym_jsx_fragment] = STATE(1404),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1404),
    [sym_class] = STATE(1404),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1404),
    [sym_arrow_function] = STATE(1404),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1404),
    [sym_new_expression] = STATE(1404),
    [sym_await_expression] = STATE(1404),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1404),
    [sym_augmented_assignment_expression] = STATE(1404),
    [sym_ternary_expression] = STATE(1404),
    [sym_binary_expression] = STATE(1404),
    [sym_unary_expression] = STATE(1404),
    [sym_update_expression] = STATE(1404),
    [sym_sequence_expression] = STATE(3057),
    [sym_string] = STATE(1404),
    [sym_template_string] = STATE(1404),
    [sym_regex] = STATE(1404),
    [sym_meta_property] = STATE(1404),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1404),
    [sym_as_expression] = STATE(1404),
    [sym_internal_module] = STATE(1404),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [176] = {
    [sym_import] = STATE(1405),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1405),
    [sym_yield_expression] = STATE(1405),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1405),
    [sym_jsx_fragment] = STATE(1405),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1405),
    [sym_arrow_function] = STATE(1405),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1405),
    [sym_new_expression] = STATE(1405),
    [sym_await_expression] = STATE(1405),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1405),
    [sym_augmented_assignment_expression] = STATE(1405),
    [sym_ternary_expression] = STATE(1405),
    [sym_binary_expression] = STATE(1405),
    [sym_unary_expression] = STATE(1405),
    [sym_update_expression] = STATE(1405),
    [sym_sequence_expression] = STATE(3056),
    [sym_string] = STATE(1405),
    [sym_template_string] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_meta_property] = STATE(1405),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1405),
    [sym_as_expression] = STATE(1405),
    [sym_internal_module] = STATE(1405),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1467),
    [sym_this] = ACTIONS(1469),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_undefined] = ACTIONS(1469),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [177] = {
    [sym_import] = STATE(1494),
    [sym_parenthesized_expression] = STATE(876),
    [sym__expression] = STATE(1687),
    [sym_yield_expression] = STATE(1687),
    [sym_object] = STATE(1322),
    [sym_array] = STATE(1323),
    [sym_jsx_element] = STATE(1687),
    [sym_jsx_fragment] = STATE(1687),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1687),
    [sym_class] = STATE(1494),
    [sym_function] = STATE(1313),
    [sym_generator_function] = STATE(1494),
    [sym_arrow_function] = STATE(1494),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1687),
    [sym_new_expression] = STATE(1494),
    [sym_await_expression] = STATE(1687),
    [sym_member_expression] = STATE(876),
    [sym_subscript_expression] = STATE(876),
    [sym_assignment_expression] = STATE(1687),
    [sym_augmented_assignment_expression] = STATE(1687),
    [sym_ternary_expression] = STATE(1687),
    [sym_binary_expression] = STATE(1687),
    [sym_unary_expression] = STATE(1687),
    [sym_update_expression] = STATE(1687),
    [sym_string] = STATE(1494),
    [sym_template_string] = STATE(1494),
    [sym_regex] = STATE(1494),
    [sym_meta_property] = STATE(1494),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1687),
    [sym_as_expression] = STATE(1687),
    [sym_internal_module] = STATE(1687),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1471),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1483),
    [sym_this] = ACTIONS(1485),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [sym_null] = ACTIONS(1485),
    [sym_undefined] = ACTIONS(1485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [sym_readonly] = ACTIONS(1473),
  },
  [178] = {
    [sym_import] = STATE(1286),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1286),
    [sym_jsx_fragment] = STATE(1286),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1286),
    [sym_class] = STATE(1286),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1286),
    [sym_arrow_function] = STATE(1286),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1286),
    [sym_new_expression] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_sequence_expression] = STATE(2956),
    [sym_string] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1489),
    [sym_this] = ACTIONS(1491),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_undefined] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [179] = {
    [sym_import] = STATE(1019),
    [sym_statement_block] = STATE(1056),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1019),
    [sym_yield_expression] = STATE(1019),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1019),
    [sym_jsx_fragment] = STATE(1019),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1019),
    [sym_class] = STATE(1019),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1019),
    [sym_arrow_function] = STATE(1019),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1019),
    [sym_new_expression] = STATE(1019),
    [sym_await_expression] = STATE(1019),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1019),
    [sym_augmented_assignment_expression] = STATE(1019),
    [sym_ternary_expression] = STATE(1019),
    [sym_binary_expression] = STATE(1019),
    [sym_unary_expression] = STATE(1019),
    [sym_update_expression] = STATE(1019),
    [sym_string] = STATE(1019),
    [sym_template_string] = STATE(1019),
    [sym_regex] = STATE(1019),
    [sym_meta_property] = STATE(1019),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1019),
    [sym_as_expression] = STATE(1019),
    [sym_internal_module] = STATE(1019),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1495),
    [sym_this] = ACTIONS(1497),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [sym_null] = ACTIONS(1497),
    [sym_undefined] = ACTIONS(1497),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [180] = {
    [sym_import] = STATE(1524),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1524),
    [sym_yield_expression] = STATE(1524),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1524),
    [sym_jsx_fragment] = STATE(1524),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1524),
    [sym_class] = STATE(1524),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1524),
    [sym_arrow_function] = STATE(1524),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1524),
    [sym_new_expression] = STATE(1524),
    [sym_await_expression] = STATE(1524),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1524),
    [sym_augmented_assignment_expression] = STATE(1524),
    [sym_ternary_expression] = STATE(1524),
    [sym_binary_expression] = STATE(1524),
    [sym_unary_expression] = STATE(1524),
    [sym_update_expression] = STATE(1524),
    [sym_string] = STATE(1524),
    [sym_template_string] = STATE(1524),
    [sym_regex] = STATE(1524),
    [sym_meta_property] = STATE(1524),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1524),
    [sym_as_expression] = STATE(1524),
    [sym_internal_module] = STATE(1524),
    [sym_mapped_type_clause] = STATE(2985),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(1501),
    [anon_sym_namespace] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1501),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1507),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1509),
    [sym_this] = ACTIONS(1511),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1511),
    [sym_false] = ACTIONS(1511),
    [sym_null] = ACTIONS(1511),
    [sym_undefined] = ACTIONS(1511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_get] = ACTIONS(1501),
    [anon_sym_set] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_public] = ACTIONS(1501),
    [anon_sym_private] = ACTIONS(1501),
    [anon_sym_protected] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_any] = ACTIONS(1501),
    [anon_sym_number] = ACTIONS(1501),
    [anon_sym_boolean] = ACTIONS(1501),
    [anon_sym_string] = ACTIONS(1501),
    [anon_sym_symbol] = ACTIONS(1501),
    [sym_readonly] = ACTIONS(1501),
  },
  [181] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1513),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [182] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1525),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [183] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [184] = {
    [sym_import] = STATE(1407),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1407),
    [sym_yield_expression] = STATE(1407),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1407),
    [sym_jsx_fragment] = STATE(1407),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1407),
    [sym_class] = STATE(1407),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1407),
    [sym_arrow_function] = STATE(1407),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1407),
    [sym_new_expression] = STATE(1407),
    [sym_await_expression] = STATE(1407),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1407),
    [sym_augmented_assignment_expression] = STATE(1407),
    [sym_ternary_expression] = STATE(1407),
    [sym_binary_expression] = STATE(1407),
    [sym_unary_expression] = STATE(1407),
    [sym_update_expression] = STATE(1407),
    [sym_sequence_expression] = STATE(3052),
    [sym_string] = STATE(1407),
    [sym_template_string] = STATE(1407),
    [sym_regex] = STATE(1407),
    [sym_meta_property] = STATE(1407),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1407),
    [sym_as_expression] = STATE(1407),
    [sym_internal_module] = STATE(1407),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1533),
    [sym_this] = ACTIONS(1535),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_undefined] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [185] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [sym_readonly] = ACTIONS(1539),
  },
  [186] = {
    [sym_import] = STATE(1326),
    [sym_statement_block] = STATE(1500),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1326),
    [sym_jsx_fragment] = STATE(1326),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1326),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1555),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [187] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1559),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1565),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1567),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [188] = {
    [sym_import] = STATE(1103),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1103),
    [sym_yield_expression] = STATE(1103),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1103),
    [sym_jsx_fragment] = STATE(1103),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1103),
    [sym_class] = STATE(1103),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1103),
    [sym_arrow_function] = STATE(1103),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1103),
    [sym_new_expression] = STATE(1103),
    [sym_await_expression] = STATE(1103),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1103),
    [sym_augmented_assignment_expression] = STATE(1103),
    [sym_ternary_expression] = STATE(1103),
    [sym_binary_expression] = STATE(1103),
    [sym_unary_expression] = STATE(1103),
    [sym_update_expression] = STATE(1103),
    [sym_sequence_expression] = STATE(3084),
    [sym_string] = STATE(1103),
    [sym_template_string] = STATE(1103),
    [sym_regex] = STATE(1103),
    [sym_meta_property] = STATE(1103),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1103),
    [sym_as_expression] = STATE(1103),
    [sym_internal_module] = STATE(1103),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1569),
    [sym_this] = ACTIONS(1571),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1571),
    [sym_false] = ACTIONS(1571),
    [sym_null] = ACTIONS(1571),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [189] = {
    [sym_import] = STATE(1195),
    [sym_statement_block] = STATE(1048),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1195),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1195),
    [sym_jsx_fragment] = STATE(1195),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1195),
    [sym_class] = STATE(1195),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1195),
    [sym_arrow_function] = STATE(1195),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1195),
    [sym_augmented_assignment_expression] = STATE(1195),
    [sym_ternary_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_update_expression] = STATE(1195),
    [sym_string] = STATE(1195),
    [sym_template_string] = STATE(1195),
    [sym_regex] = STATE(1195),
    [sym_meta_property] = STATE(1195),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1195),
    [sym_as_expression] = STATE(1195),
    [sym_internal_module] = STATE(1195),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1573),
    [sym_this] = ACTIONS(1575),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1575),
    [sym_false] = ACTIONS(1575),
    [sym_null] = ACTIONS(1575),
    [sym_undefined] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [190] = {
    [sym_import] = STATE(1196),
    [sym_statement_block] = STATE(1056),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1196),
    [sym_yield_expression] = STATE(1196),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1196),
    [sym_jsx_fragment] = STATE(1196),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1196),
    [sym_class] = STATE(1196),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1196),
    [sym_arrow_function] = STATE(1196),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1196),
    [sym_new_expression] = STATE(1196),
    [sym_await_expression] = STATE(1196),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1196),
    [sym_augmented_assignment_expression] = STATE(1196),
    [sym_ternary_expression] = STATE(1196),
    [sym_binary_expression] = STATE(1196),
    [sym_unary_expression] = STATE(1196),
    [sym_update_expression] = STATE(1196),
    [sym_string] = STATE(1196),
    [sym_template_string] = STATE(1196),
    [sym_regex] = STATE(1196),
    [sym_meta_property] = STATE(1196),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1196),
    [sym_as_expression] = STATE(1196),
    [sym_internal_module] = STATE(1196),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1577),
    [sym_this] = ACTIONS(1579),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1579),
    [sym_false] = ACTIONS(1579),
    [sym_null] = ACTIONS(1579),
    [sym_undefined] = ACTIONS(1579),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [191] = {
    [sym_import] = STATE(1228),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1228),
    [sym_yield_expression] = STATE(1228),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1228),
    [sym_jsx_fragment] = STATE(1228),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1228),
    [sym_class] = STATE(1228),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1228),
    [sym_arrow_function] = STATE(1228),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1228),
    [sym_new_expression] = STATE(1228),
    [sym_await_expression] = STATE(1228),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1228),
    [sym_augmented_assignment_expression] = STATE(1228),
    [sym_ternary_expression] = STATE(1228),
    [sym_binary_expression] = STATE(1228),
    [sym_unary_expression] = STATE(1228),
    [sym_update_expression] = STATE(1228),
    [sym_string] = STATE(1228),
    [sym_template_string] = STATE(1228),
    [sym_regex] = STATE(1228),
    [sym_meta_property] = STATE(1228),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1228),
    [sym_as_expression] = STATE(1228),
    [sym_internal_module] = STATE(1228),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1581),
    [sym_this] = ACTIONS(1583),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1583),
    [sym_false] = ACTIONS(1583),
    [sym_null] = ACTIONS(1583),
    [sym_undefined] = ACTIONS(1583),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [192] = {
    [sym_import] = STATE(1197),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1197),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1197),
    [sym_jsx_fragment] = STATE(1197),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1197),
    [sym_class] = STATE(1197),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1197),
    [sym_arrow_function] = STATE(1197),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1197),
    [sym_new_expression] = STATE(1197),
    [sym_await_expression] = STATE(1197),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1197),
    [sym_augmented_assignment_expression] = STATE(1197),
    [sym_ternary_expression] = STATE(1197),
    [sym_binary_expression] = STATE(1197),
    [sym_unary_expression] = STATE(1197),
    [sym_update_expression] = STATE(1197),
    [sym_string] = STATE(1197),
    [sym_template_string] = STATE(1197),
    [sym_regex] = STATE(1197),
    [sym_meta_property] = STATE(1197),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1197),
    [sym_as_expression] = STATE(1197),
    [sym_internal_module] = STATE(1197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1585),
    [sym_this] = ACTIONS(1587),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1587),
    [sym_false] = ACTIONS(1587),
    [sym_null] = ACTIONS(1587),
    [sym_undefined] = ACTIONS(1587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [193] = {
    [sym_import] = STATE(1199),
    [sym_statement_block] = STATE(1064),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1199),
    [sym_yield_expression] = STATE(1199),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1199),
    [sym_jsx_fragment] = STATE(1199),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1199),
    [sym_class] = STATE(1199),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1199),
    [sym_arrow_function] = STATE(1199),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1199),
    [sym_new_expression] = STATE(1199),
    [sym_await_expression] = STATE(1199),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1199),
    [sym_augmented_assignment_expression] = STATE(1199),
    [sym_ternary_expression] = STATE(1199),
    [sym_binary_expression] = STATE(1199),
    [sym_unary_expression] = STATE(1199),
    [sym_update_expression] = STATE(1199),
    [sym_string] = STATE(1199),
    [sym_template_string] = STATE(1199),
    [sym_regex] = STATE(1199),
    [sym_meta_property] = STATE(1199),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1199),
    [sym_as_expression] = STATE(1199),
    [sym_internal_module] = STATE(1199),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1589),
    [sym_this] = ACTIONS(1591),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1591),
    [sym_false] = ACTIONS(1591),
    [sym_null] = ACTIONS(1591),
    [sym_undefined] = ACTIONS(1591),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [194] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1593),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [195] = {
    [sym_import] = STATE(1399),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1399),
    [sym_yield_expression] = STATE(1399),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1399),
    [sym_jsx_fragment] = STATE(1399),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1399),
    [sym_class] = STATE(1399),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1399),
    [sym_arrow_function] = STATE(1399),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1399),
    [sym_new_expression] = STATE(1399),
    [sym_await_expression] = STATE(1399),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1399),
    [sym_augmented_assignment_expression] = STATE(1399),
    [sym_ternary_expression] = STATE(1399),
    [sym_binary_expression] = STATE(1399),
    [sym_unary_expression] = STATE(1399),
    [sym_update_expression] = STATE(1399),
    [sym_sequence_expression] = STATE(3101),
    [sym_string] = STATE(1399),
    [sym_template_string] = STATE(1399),
    [sym_regex] = STATE(1399),
    [sym_meta_property] = STATE(1399),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1399),
    [sym_as_expression] = STATE(1399),
    [sym_internal_module] = STATE(1399),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1595),
    [sym_this] = ACTIONS(1597),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [sym_null] = ACTIONS(1597),
    [sym_undefined] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [196] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [197] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1559),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1565),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1567),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [198] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1642),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [199] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2733),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2869),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1525),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [200] = {
    [sym_import] = STATE(1392),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1392),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1392),
    [sym_jsx_fragment] = STATE(1392),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1392),
    [sym_class] = STATE(1392),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1392),
    [sym_arrow_function] = STATE(1392),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1392),
    [sym_new_expression] = STATE(1392),
    [sym_await_expression] = STATE(1392),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1392),
    [sym_augmented_assignment_expression] = STATE(1392),
    [sym_ternary_expression] = STATE(1392),
    [sym_binary_expression] = STATE(1392),
    [sym_unary_expression] = STATE(1392),
    [sym_update_expression] = STATE(1392),
    [sym_sequence_expression] = STATE(3091),
    [sym_string] = STATE(1392),
    [sym_template_string] = STATE(1392),
    [sym_regex] = STATE(1392),
    [sym_meta_property] = STATE(1392),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1392),
    [sym_as_expression] = STATE(1392),
    [sym_internal_module] = STATE(1392),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1644),
    [sym_this] = ACTIONS(1646),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1646),
    [sym_false] = ACTIONS(1646),
    [sym_null] = ACTIONS(1646),
    [sym_undefined] = ACTIONS(1646),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [201] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1650),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1656),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
    [anon_sym_declare] = ACTIONS(1650),
    [anon_sym_public] = ACTIONS(1650),
    [anon_sym_private] = ACTIONS(1650),
    [anon_sym_protected] = ACTIONS(1650),
    [anon_sym_module] = ACTIONS(1650),
    [anon_sym_any] = ACTIONS(1650),
    [anon_sym_number] = ACTIONS(1650),
    [anon_sym_boolean] = ACTIONS(1650),
    [anon_sym_string] = ACTIONS(1650),
    [anon_sym_symbol] = ACTIONS(1650),
    [sym_readonly] = ACTIONS(1650),
  },
  [202] = {
    [sym_import] = STATE(1591),
    [sym_variable_declarator] = STATE(2520),
    [sym_parenthesized_expression] = STATE(932),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1006),
    [sym_array] = STATE(1018),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(932),
    [sym_subscript_expression] = STATE(932),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1660),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1660),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1660),
    [anon_sym_set] = ACTIONS(1660),
    [anon_sym_declare] = ACTIONS(1660),
    [anon_sym_public] = ACTIONS(1660),
    [anon_sym_private] = ACTIONS(1660),
    [anon_sym_protected] = ACTIONS(1660),
    [anon_sym_module] = ACTIONS(1660),
    [anon_sym_any] = ACTIONS(1660),
    [anon_sym_number] = ACTIONS(1660),
    [anon_sym_boolean] = ACTIONS(1660),
    [anon_sym_string] = ACTIONS(1660),
    [anon_sym_symbol] = ACTIONS(1660),
    [sym_readonly] = ACTIONS(1660),
  },
  [203] = {
    [sym_import] = STATE(1591),
    [sym_variable_declarator] = STATE(2472),
    [sym_parenthesized_expression] = STATE(932),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1006),
    [sym_array] = STATE(1018),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(932),
    [sym_subscript_expression] = STATE(932),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1660),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1660),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1660),
    [anon_sym_set] = ACTIONS(1660),
    [anon_sym_declare] = ACTIONS(1660),
    [anon_sym_public] = ACTIONS(1660),
    [anon_sym_private] = ACTIONS(1660),
    [anon_sym_protected] = ACTIONS(1660),
    [anon_sym_module] = ACTIONS(1660),
    [anon_sym_any] = ACTIONS(1660),
    [anon_sym_number] = ACTIONS(1660),
    [anon_sym_boolean] = ACTIONS(1660),
    [anon_sym_string] = ACTIONS(1660),
    [anon_sym_symbol] = ACTIONS(1660),
    [sym_readonly] = ACTIONS(1660),
  },
  [204] = {
    [sym_import] = STATE(1390),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1390),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1390),
    [sym_jsx_fragment] = STATE(1390),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1390),
    [sym_class] = STATE(1390),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1390),
    [sym_arrow_function] = STATE(1390),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1390),
    [sym_new_expression] = STATE(1390),
    [sym_await_expression] = STATE(1390),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1390),
    [sym_augmented_assignment_expression] = STATE(1390),
    [sym_ternary_expression] = STATE(1390),
    [sym_binary_expression] = STATE(1390),
    [sym_unary_expression] = STATE(1390),
    [sym_update_expression] = STATE(1390),
    [sym_sequence_expression] = STATE(3061),
    [sym_string] = STATE(1390),
    [sym_template_string] = STATE(1390),
    [sym_regex] = STATE(1390),
    [sym_meta_property] = STATE(1390),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1390),
    [sym_as_expression] = STATE(1390),
    [sym_internal_module] = STATE(1390),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1668),
    [sym_this] = ACTIONS(1670),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1670),
    [sym_false] = ACTIONS(1670),
    [sym_null] = ACTIONS(1670),
    [sym_undefined] = ACTIONS(1670),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [205] = {
    [sym_import] = STATE(1127),
    [sym_statement_block] = STATE(1438),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1127),
    [sym_jsx_fragment] = STATE(1127),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1127),
    [sym_class] = STATE(1127),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1127),
    [sym_arrow_function] = STATE(1127),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1127),
    [sym_new_expression] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_string] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_meta_property] = STATE(1127),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1127),
    [sym_as_expression] = STATE(1127),
    [sym_internal_module] = STATE(1127),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1672),
    [sym_this] = ACTIONS(1674),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_undefined] = ACTIONS(1674),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [206] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [207] = {
    [sym_import] = STATE(1181),
    [sym_statement_block] = STATE(1668),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1181),
    [sym_yield_expression] = STATE(1181),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1181),
    [sym_jsx_fragment] = STATE(1181),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1181),
    [sym_class] = STATE(1181),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1181),
    [sym_arrow_function] = STATE(1181),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1181),
    [sym_new_expression] = STATE(1181),
    [sym_await_expression] = STATE(1181),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1181),
    [sym_augmented_assignment_expression] = STATE(1181),
    [sym_ternary_expression] = STATE(1181),
    [sym_binary_expression] = STATE(1181),
    [sym_unary_expression] = STATE(1181),
    [sym_update_expression] = STATE(1181),
    [sym_string] = STATE(1181),
    [sym_template_string] = STATE(1181),
    [sym_regex] = STATE(1181),
    [sym_meta_property] = STATE(1181),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1181),
    [sym_as_expression] = STATE(1181),
    [sym_internal_module] = STATE(1181),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1680),
    [sym_this] = ACTIONS(1682),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_undefined] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [208] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [209] = {
    [sym_import] = STATE(972),
    [sym_statement_block] = STATE(1051),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(972),
    [sym_yield_expression] = STATE(972),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(972),
    [sym_jsx_fragment] = STATE(972),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(972),
    [sym_class] = STATE(972),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(972),
    [sym_arrow_function] = STATE(972),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(972),
    [sym_new_expression] = STATE(972),
    [sym_await_expression] = STATE(972),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(972),
    [sym_augmented_assignment_expression] = STATE(972),
    [sym_ternary_expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym_update_expression] = STATE(972),
    [sym_string] = STATE(972),
    [sym_template_string] = STATE(972),
    [sym_regex] = STATE(972),
    [sym_meta_property] = STATE(972),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(972),
    [sym_as_expression] = STATE(972),
    [sym_internal_module] = STATE(972),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [210] = {
    [sym_import] = STATE(1180),
    [sym_statement_block] = STATE(1038),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1180),
    [sym_yield_expression] = STATE(1180),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1180),
    [sym_jsx_fragment] = STATE(1180),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1180),
    [sym_class] = STATE(1180),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1180),
    [sym_arrow_function] = STATE(1180),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1180),
    [sym_new_expression] = STATE(1180),
    [sym_await_expression] = STATE(1180),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1180),
    [sym_augmented_assignment_expression] = STATE(1180),
    [sym_ternary_expression] = STATE(1180),
    [sym_binary_expression] = STATE(1180),
    [sym_unary_expression] = STATE(1180),
    [sym_update_expression] = STATE(1180),
    [sym_string] = STATE(1180),
    [sym_template_string] = STATE(1180),
    [sym_regex] = STATE(1180),
    [sym_meta_property] = STATE(1180),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1180),
    [sym_as_expression] = STATE(1180),
    [sym_internal_module] = STATE(1180),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1690),
    [sym_this] = ACTIONS(1692),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_null] = ACTIONS(1692),
    [sym_undefined] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [211] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1650),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1656),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
    [anon_sym_declare] = ACTIONS(1650),
    [anon_sym_public] = ACTIONS(1650),
    [anon_sym_private] = ACTIONS(1650),
    [anon_sym_protected] = ACTIONS(1650),
    [anon_sym_module] = ACTIONS(1650),
    [anon_sym_any] = ACTIONS(1650),
    [anon_sym_number] = ACTIONS(1650),
    [anon_sym_boolean] = ACTIONS(1650),
    [anon_sym_string] = ACTIONS(1650),
    [anon_sym_symbol] = ACTIONS(1650),
    [sym_readonly] = ACTIONS(1650),
  },
  [212] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1694),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [213] = {
    [sym_import] = STATE(1227),
    [sym_statement_block] = STATE(1064),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1227),
    [sym_yield_expression] = STATE(1227),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1227),
    [sym_jsx_fragment] = STATE(1227),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1227),
    [sym_class] = STATE(1227),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1227),
    [sym_arrow_function] = STATE(1227),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1227),
    [sym_new_expression] = STATE(1227),
    [sym_await_expression] = STATE(1227),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1227),
    [sym_augmented_assignment_expression] = STATE(1227),
    [sym_ternary_expression] = STATE(1227),
    [sym_binary_expression] = STATE(1227),
    [sym_unary_expression] = STATE(1227),
    [sym_update_expression] = STATE(1227),
    [sym_string] = STATE(1227),
    [sym_template_string] = STATE(1227),
    [sym_regex] = STATE(1227),
    [sym_meta_property] = STATE(1227),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1227),
    [sym_as_expression] = STATE(1227),
    [sym_internal_module] = STATE(1227),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1696),
    [sym_this] = ACTIONS(1698),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_null] = ACTIONS(1698),
    [sym_undefined] = ACTIONS(1698),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [214] = {
    [sym_import] = STATE(1129),
    [sym_statement_block] = STATE(1434),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1129),
    [sym_yield_expression] = STATE(1129),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1129),
    [sym_jsx_fragment] = STATE(1129),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1129),
    [sym_class] = STATE(1129),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1129),
    [sym_arrow_function] = STATE(1129),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1129),
    [sym_new_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1129),
    [sym_augmented_assignment_expression] = STATE(1129),
    [sym_ternary_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_update_expression] = STATE(1129),
    [sym_string] = STATE(1129),
    [sym_template_string] = STATE(1129),
    [sym_regex] = STATE(1129),
    [sym_meta_property] = STATE(1129),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1129),
    [sym_as_expression] = STATE(1129),
    [sym_internal_module] = STATE(1129),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1700),
    [sym_this] = ACTIONS(1702),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1702),
    [sym_false] = ACTIONS(1702),
    [sym_null] = ACTIONS(1702),
    [sym_undefined] = ACTIONS(1702),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [215] = {
    [sym_import] = STATE(977),
    [sym_statement_block] = STATE(1064),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(977),
    [sym_jsx_fragment] = STATE(977),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(977),
    [sym_class] = STATE(977),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1704),
    [sym_this] = ACTIONS(1706),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1706),
    [sym_false] = ACTIONS(1706),
    [sym_null] = ACTIONS(1706),
    [sym_undefined] = ACTIONS(1706),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [216] = {
    [sym_import] = STATE(1186),
    [sym_statement_block] = STATE(1051),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1186),
    [sym_yield_expression] = STATE(1186),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1186),
    [sym_jsx_fragment] = STATE(1186),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1186),
    [sym_class] = STATE(1186),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1186),
    [sym_arrow_function] = STATE(1186),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1186),
    [sym_new_expression] = STATE(1186),
    [sym_await_expression] = STATE(1186),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1186),
    [sym_augmented_assignment_expression] = STATE(1186),
    [sym_ternary_expression] = STATE(1186),
    [sym_binary_expression] = STATE(1186),
    [sym_unary_expression] = STATE(1186),
    [sym_update_expression] = STATE(1186),
    [sym_string] = STATE(1186),
    [sym_template_string] = STATE(1186),
    [sym_regex] = STATE(1186),
    [sym_meta_property] = STATE(1186),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1186),
    [sym_as_expression] = STATE(1186),
    [sym_internal_module] = STATE(1186),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1708),
    [sym_this] = ACTIONS(1710),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1710),
    [sym_false] = ACTIONS(1710),
    [sym_null] = ACTIONS(1710),
    [sym_undefined] = ACTIONS(1710),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [217] = {
    [sym_import] = STATE(1330),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1330),
    [sym_yield_expression] = STATE(1330),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1330),
    [sym_jsx_fragment] = STATE(1330),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1330),
    [sym_class] = STATE(1330),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1330),
    [sym_arrow_function] = STATE(1330),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1330),
    [sym_new_expression] = STATE(1330),
    [sym_await_expression] = STATE(1330),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1330),
    [sym_augmented_assignment_expression] = STATE(1330),
    [sym_ternary_expression] = STATE(1330),
    [sym_binary_expression] = STATE(1330),
    [sym_unary_expression] = STATE(1330),
    [sym_update_expression] = STATE(1330),
    [sym_sequence_expression] = STATE(3139),
    [sym_string] = STATE(1330),
    [sym_template_string] = STATE(1330),
    [sym_regex] = STATE(1330),
    [sym_meta_property] = STATE(1330),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1330),
    [sym_as_expression] = STATE(1330),
    [sym_internal_module] = STATE(1330),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1712),
    [sym_this] = ACTIONS(1714),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1714),
    [sym_false] = ACTIONS(1714),
    [sym_null] = ACTIONS(1714),
    [sym_undefined] = ACTIONS(1714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [218] = {
    [sym_import] = STATE(1334),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1334),
    [sym_yield_expression] = STATE(1334),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1334),
    [sym_jsx_fragment] = STATE(1334),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1334),
    [sym_class] = STATE(1334),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1334),
    [sym_arrow_function] = STATE(1334),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1334),
    [sym_new_expression] = STATE(1334),
    [sym_await_expression] = STATE(1334),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1334),
    [sym_augmented_assignment_expression] = STATE(1334),
    [sym_ternary_expression] = STATE(1334),
    [sym_binary_expression] = STATE(1334),
    [sym_unary_expression] = STATE(1334),
    [sym_update_expression] = STATE(1334),
    [sym_sequence_expression] = STATE(3138),
    [sym_string] = STATE(1334),
    [sym_template_string] = STATE(1334),
    [sym_regex] = STATE(1334),
    [sym_meta_property] = STATE(1334),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1334),
    [sym_as_expression] = STATE(1334),
    [sym_internal_module] = STATE(1334),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1716),
    [sym_this] = ACTIONS(1718),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1718),
    [sym_false] = ACTIONS(1718),
    [sym_null] = ACTIONS(1718),
    [sym_undefined] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [219] = {
    [sym_import] = STATE(1229),
    [sym_statement_block] = STATE(1056),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1229),
    [sym_yield_expression] = STATE(1229),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1229),
    [sym_jsx_fragment] = STATE(1229),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1229),
    [sym_class] = STATE(1229),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1229),
    [sym_arrow_function] = STATE(1229),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1229),
    [sym_new_expression] = STATE(1229),
    [sym_await_expression] = STATE(1229),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1229),
    [sym_augmented_assignment_expression] = STATE(1229),
    [sym_ternary_expression] = STATE(1229),
    [sym_binary_expression] = STATE(1229),
    [sym_unary_expression] = STATE(1229),
    [sym_update_expression] = STATE(1229),
    [sym_string] = STATE(1229),
    [sym_template_string] = STATE(1229),
    [sym_regex] = STATE(1229),
    [sym_meta_property] = STATE(1229),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1229),
    [sym_as_expression] = STATE(1229),
    [sym_internal_module] = STATE(1229),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1720),
    [sym_this] = ACTIONS(1722),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1722),
    [sym_false] = ACTIONS(1722),
    [sym_null] = ACTIONS(1722),
    [sym_undefined] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [220] = {
    [sym_import] = STATE(1340),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1340),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1340),
    [sym_jsx_fragment] = STATE(1340),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1340),
    [sym_class] = STATE(1340),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1340),
    [sym_arrow_function] = STATE(1340),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_await_expression] = STATE(1340),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1340),
    [sym_augmented_assignment_expression] = STATE(1340),
    [sym_ternary_expression] = STATE(1340),
    [sym_binary_expression] = STATE(1340),
    [sym_unary_expression] = STATE(1340),
    [sym_update_expression] = STATE(1340),
    [sym_sequence_expression] = STATE(3135),
    [sym_string] = STATE(1340),
    [sym_template_string] = STATE(1340),
    [sym_regex] = STATE(1340),
    [sym_meta_property] = STATE(1340),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1340),
    [sym_as_expression] = STATE(1340),
    [sym_internal_module] = STATE(1340),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1724),
    [sym_this] = ACTIONS(1726),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_undefined] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [221] = {
    [sym_import] = STATE(1021),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1021),
    [sym_yield_expression] = STATE(1021),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1021),
    [sym_jsx_fragment] = STATE(1021),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1021),
    [sym_class] = STATE(1021),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1021),
    [sym_arrow_function] = STATE(1021),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1021),
    [sym_new_expression] = STATE(1021),
    [sym_await_expression] = STATE(1021),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1021),
    [sym_augmented_assignment_expression] = STATE(1021),
    [sym_ternary_expression] = STATE(1021),
    [sym_binary_expression] = STATE(1021),
    [sym_unary_expression] = STATE(1021),
    [sym_update_expression] = STATE(1021),
    [sym_sequence_expression] = STATE(3106),
    [sym_string] = STATE(1021),
    [sym_template_string] = STATE(1021),
    [sym_regex] = STATE(1021),
    [sym_meta_property] = STATE(1021),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1021),
    [sym_as_expression] = STATE(1021),
    [sym_internal_module] = STATE(1021),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1728),
    [sym_this] = ACTIONS(1730),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_null] = ACTIONS(1730),
    [sym_undefined] = ACTIONS(1730),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [222] = {
    [sym_import] = STATE(1230),
    [sym_statement_block] = STATE(1048),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1230),
    [sym_yield_expression] = STATE(1230),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1230),
    [sym_jsx_fragment] = STATE(1230),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1230),
    [sym_class] = STATE(1230),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1230),
    [sym_arrow_function] = STATE(1230),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1230),
    [sym_new_expression] = STATE(1230),
    [sym_await_expression] = STATE(1230),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1230),
    [sym_augmented_assignment_expression] = STATE(1230),
    [sym_ternary_expression] = STATE(1230),
    [sym_binary_expression] = STATE(1230),
    [sym_unary_expression] = STATE(1230),
    [sym_update_expression] = STATE(1230),
    [sym_string] = STATE(1230),
    [sym_template_string] = STATE(1230),
    [sym_regex] = STATE(1230),
    [sym_meta_property] = STATE(1230),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1230),
    [sym_as_expression] = STATE(1230),
    [sym_internal_module] = STATE(1230),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1732),
    [sym_this] = ACTIONS(1734),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_null] = ACTIONS(1734),
    [sym_undefined] = ACTIONS(1734),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [223] = {
    [sym_import] = STATE(1205),
    [sym_statement_block] = STATE(1593),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1205),
    [sym_yield_expression] = STATE(1205),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1205),
    [sym_jsx_fragment] = STATE(1205),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1205),
    [sym_class] = STATE(1205),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1205),
    [sym_arrow_function] = STATE(1205),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1205),
    [sym_new_expression] = STATE(1205),
    [sym_await_expression] = STATE(1205),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1205),
    [sym_augmented_assignment_expression] = STATE(1205),
    [sym_ternary_expression] = STATE(1205),
    [sym_binary_expression] = STATE(1205),
    [sym_unary_expression] = STATE(1205),
    [sym_update_expression] = STATE(1205),
    [sym_string] = STATE(1205),
    [sym_template_string] = STATE(1205),
    [sym_regex] = STATE(1205),
    [sym_meta_property] = STATE(1205),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1205),
    [sym_as_expression] = STATE(1205),
    [sym_internal_module] = STATE(1205),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1736),
    [sym_this] = ACTIONS(1738),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1738),
    [sym_false] = ACTIONS(1738),
    [sym_null] = ACTIONS(1738),
    [sym_undefined] = ACTIONS(1738),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [224] = {
    [sym_import] = STATE(1335),
    [sym_statement_block] = STATE(1508),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1335),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1335),
    [sym_jsx_fragment] = STATE(1335),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1335),
    [sym_class] = STATE(1335),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1335),
    [sym_arrow_function] = STATE(1335),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1335),
    [sym_new_expression] = STATE(1335),
    [sym_await_expression] = STATE(1335),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1335),
    [sym_augmented_assignment_expression] = STATE(1335),
    [sym_ternary_expression] = STATE(1335),
    [sym_binary_expression] = STATE(1335),
    [sym_unary_expression] = STATE(1335),
    [sym_update_expression] = STATE(1335),
    [sym_string] = STATE(1335),
    [sym_template_string] = STATE(1335),
    [sym_regex] = STATE(1335),
    [sym_meta_property] = STATE(1335),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1335),
    [sym_as_expression] = STATE(1335),
    [sym_internal_module] = STATE(1335),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1740),
    [sym_this] = ACTIONS(1742),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_null] = ACTIONS(1742),
    [sym_undefined] = ACTIONS(1742),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [225] = {
    [sym_import] = STATE(1344),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1344),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1344),
    [sym_jsx_fragment] = STATE(1344),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1344),
    [sym_class] = STATE(1344),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1344),
    [sym_arrow_function] = STATE(1344),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1344),
    [sym_new_expression] = STATE(1344),
    [sym_await_expression] = STATE(1344),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1344),
    [sym_augmented_assignment_expression] = STATE(1344),
    [sym_ternary_expression] = STATE(1344),
    [sym_binary_expression] = STATE(1344),
    [sym_unary_expression] = STATE(1344),
    [sym_update_expression] = STATE(1344),
    [sym_sequence_expression] = STATE(3134),
    [sym_string] = STATE(1344),
    [sym_template_string] = STATE(1344),
    [sym_regex] = STATE(1344),
    [sym_meta_property] = STATE(1344),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1344),
    [sym_as_expression] = STATE(1344),
    [sym_internal_module] = STATE(1344),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1744),
    [sym_this] = ACTIONS(1746),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_undefined] = ACTIONS(1746),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [226] = {
    [sym_import] = STATE(973),
    [sym_statement_block] = STATE(1048),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(973),
    [sym_yield_expression] = STATE(973),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(973),
    [sym_jsx_fragment] = STATE(973),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(973),
    [sym_class] = STATE(973),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(973),
    [sym_arrow_function] = STATE(973),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(973),
    [sym_new_expression] = STATE(973),
    [sym_await_expression] = STATE(973),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(973),
    [sym_augmented_assignment_expression] = STATE(973),
    [sym_ternary_expression] = STATE(973),
    [sym_binary_expression] = STATE(973),
    [sym_unary_expression] = STATE(973),
    [sym_update_expression] = STATE(973),
    [sym_string] = STATE(973),
    [sym_template_string] = STATE(973),
    [sym_regex] = STATE(973),
    [sym_meta_property] = STATE(973),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(973),
    [sym_as_expression] = STATE(973),
    [sym_internal_module] = STATE(973),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1748),
    [sym_this] = ACTIONS(1750),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1750),
    [sym_false] = ACTIONS(1750),
    [sym_null] = ACTIONS(1750),
    [sym_undefined] = ACTIONS(1750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [227] = {
    [sym_import] = STATE(1338),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1338),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1338),
    [sym_jsx_fragment] = STATE(1338),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1338),
    [sym_class] = STATE(1338),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1338),
    [sym_arrow_function] = STATE(1338),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1338),
    [sym_new_expression] = STATE(1338),
    [sym_await_expression] = STATE(1338),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1338),
    [sym_augmented_assignment_expression] = STATE(1338),
    [sym_ternary_expression] = STATE(1338),
    [sym_binary_expression] = STATE(1338),
    [sym_unary_expression] = STATE(1338),
    [sym_update_expression] = STATE(1338),
    [sym_sequence_expression] = STATE(3173),
    [sym_string] = STATE(1338),
    [sym_template_string] = STATE(1338),
    [sym_regex] = STATE(1338),
    [sym_meta_property] = STATE(1338),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1338),
    [sym_as_expression] = STATE(1338),
    [sym_internal_module] = STATE(1338),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1752),
    [sym_this] = ACTIONS(1754),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1754),
    [sym_false] = ACTIONS(1754),
    [sym_null] = ACTIONS(1754),
    [sym_undefined] = ACTIONS(1754),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [228] = {
    [sym_import] = STATE(1354),
    [sym_statement_block] = STATE(1478),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1354),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1354),
    [sym_jsx_fragment] = STATE(1354),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1354),
    [sym_class] = STATE(1354),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1354),
    [sym_arrow_function] = STATE(1354),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_await_expression] = STATE(1354),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1354),
    [sym_augmented_assignment_expression] = STATE(1354),
    [sym_ternary_expression] = STATE(1354),
    [sym_binary_expression] = STATE(1354),
    [sym_unary_expression] = STATE(1354),
    [sym_update_expression] = STATE(1354),
    [sym_string] = STATE(1354),
    [sym_template_string] = STATE(1354),
    [sym_regex] = STATE(1354),
    [sym_meta_property] = STATE(1354),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1354),
    [sym_as_expression] = STATE(1354),
    [sym_internal_module] = STATE(1354),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1756),
    [sym_this] = ACTIONS(1758),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1758),
    [sym_false] = ACTIONS(1758),
    [sym_null] = ACTIONS(1758),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [229] = {
    [sym_import] = STATE(1017),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1017),
    [sym_yield_expression] = STATE(1017),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1017),
    [sym_jsx_fragment] = STATE(1017),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1017),
    [sym_class] = STATE(1017),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1017),
    [sym_arrow_function] = STATE(1017),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1017),
    [sym_new_expression] = STATE(1017),
    [sym_await_expression] = STATE(1017),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1017),
    [sym_augmented_assignment_expression] = STATE(1017),
    [sym_ternary_expression] = STATE(1017),
    [sym_binary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym_update_expression] = STATE(1017),
    [sym_string] = STATE(1017),
    [sym_template_string] = STATE(1017),
    [sym_regex] = STATE(1017),
    [sym_meta_property] = STATE(1017),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1017),
    [sym_as_expression] = STATE(1017),
    [sym_internal_module] = STATE(1017),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1760),
    [sym_this] = ACTIONS(1762),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_null] = ACTIONS(1762),
    [sym_undefined] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [230] = {
    [sym_import] = STATE(1284),
    [sym_statement_block] = STATE(1714),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1284),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1284),
    [sym_jsx_fragment] = STATE(1284),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1284),
    [sym_class] = STATE(1284),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1284),
    [sym_arrow_function] = STATE(1284),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1284),
    [sym_new_expression] = STATE(1284),
    [sym_await_expression] = STATE(1284),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1284),
    [sym_augmented_assignment_expression] = STATE(1284),
    [sym_ternary_expression] = STATE(1284),
    [sym_binary_expression] = STATE(1284),
    [sym_unary_expression] = STATE(1284),
    [sym_update_expression] = STATE(1284),
    [sym_string] = STATE(1284),
    [sym_template_string] = STATE(1284),
    [sym_regex] = STATE(1284),
    [sym_meta_property] = STATE(1284),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1284),
    [sym_as_expression] = STATE(1284),
    [sym_internal_module] = STATE(1284),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1764),
    [sym_this] = ACTIONS(1766),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1766),
    [sym_false] = ACTIONS(1766),
    [sym_null] = ACTIONS(1766),
    [sym_undefined] = ACTIONS(1766),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [231] = {
    [sym_import] = STATE(1371),
    [sym_statement_block] = STATE(1434),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1371),
    [sym_yield_expression] = STATE(1371),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1371),
    [sym_jsx_fragment] = STATE(1371),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1371),
    [sym_class] = STATE(1371),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1371),
    [sym_arrow_function] = STATE(1371),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1371),
    [sym_new_expression] = STATE(1371),
    [sym_await_expression] = STATE(1371),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1371),
    [sym_augmented_assignment_expression] = STATE(1371),
    [sym_ternary_expression] = STATE(1371),
    [sym_binary_expression] = STATE(1371),
    [sym_unary_expression] = STATE(1371),
    [sym_update_expression] = STATE(1371),
    [sym_string] = STATE(1371),
    [sym_template_string] = STATE(1371),
    [sym_regex] = STATE(1371),
    [sym_meta_property] = STATE(1371),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1371),
    [sym_as_expression] = STATE(1371),
    [sym_internal_module] = STATE(1371),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1768),
    [sym_this] = ACTIONS(1770),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1770),
    [sym_false] = ACTIONS(1770),
    [sym_null] = ACTIONS(1770),
    [sym_undefined] = ACTIONS(1770),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [232] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1437),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1372),
    [sym_jsx_fragment] = STATE(1372),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1372),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1772),
    [sym_this] = ACTIONS(1774),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1774),
    [sym_false] = ACTIONS(1774),
    [sym_null] = ACTIONS(1774),
    [sym_undefined] = ACTIONS(1774),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [233] = {
    [sym_import] = STATE(1370),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1370),
    [sym_yield_expression] = STATE(1370),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1370),
    [sym_jsx_fragment] = STATE(1370),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1370),
    [sym_class] = STATE(1370),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1370),
    [sym_arrow_function] = STATE(1370),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1370),
    [sym_new_expression] = STATE(1370),
    [sym_await_expression] = STATE(1370),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1370),
    [sym_augmented_assignment_expression] = STATE(1370),
    [sym_ternary_expression] = STATE(1370),
    [sym_binary_expression] = STATE(1370),
    [sym_unary_expression] = STATE(1370),
    [sym_update_expression] = STATE(1370),
    [sym_sequence_expression] = STATE(3186),
    [sym_string] = STATE(1370),
    [sym_template_string] = STATE(1370),
    [sym_regex] = STATE(1370),
    [sym_meta_property] = STATE(1370),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1370),
    [sym_as_expression] = STATE(1370),
    [sym_internal_module] = STATE(1370),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1776),
    [sym_this] = ACTIONS(1778),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1778),
    [sym_false] = ACTIONS(1778),
    [sym_null] = ACTIONS(1778),
    [sym_undefined] = ACTIONS(1778),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [234] = {
    [sym_import] = STATE(1373),
    [sym_statement_block] = STATE(1438),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1373),
    [sym_jsx_fragment] = STATE(1373),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1373),
    [sym_class] = STATE(1373),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1373),
    [sym_arrow_function] = STATE(1373),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1373),
    [sym_new_expression] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_string] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_meta_property] = STATE(1373),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1780),
    [sym_this] = ACTIONS(1782),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1782),
    [sym_false] = ACTIONS(1782),
    [sym_null] = ACTIONS(1782),
    [sym_undefined] = ACTIONS(1782),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [235] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [236] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1794),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [sym_readonly] = ACTIONS(1788),
  },
  [237] = {
    [sym_import] = STATE(1083),
    [sym_statement_block] = STATE(1508),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1083),
    [sym_yield_expression] = STATE(1083),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1083),
    [sym_jsx_fragment] = STATE(1083),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1083),
    [sym_class] = STATE(1083),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1083),
    [sym_arrow_function] = STATE(1083),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1083),
    [sym_new_expression] = STATE(1083),
    [sym_await_expression] = STATE(1083),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1083),
    [sym_augmented_assignment_expression] = STATE(1083),
    [sym_ternary_expression] = STATE(1083),
    [sym_binary_expression] = STATE(1083),
    [sym_unary_expression] = STATE(1083),
    [sym_update_expression] = STATE(1083),
    [sym_string] = STATE(1083),
    [sym_template_string] = STATE(1083),
    [sym_regex] = STATE(1083),
    [sym_meta_property] = STATE(1083),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1083),
    [sym_as_expression] = STATE(1083),
    [sym_internal_module] = STATE(1083),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1796),
    [sym_this] = ACTIONS(1798),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_null] = ACTIONS(1798),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [238] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1794),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [sym_readonly] = ACTIONS(1788),
  },
  [239] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [240] = {
    [sym_import] = STATE(1332),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1332),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1332),
    [sym_jsx_fragment] = STATE(1332),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1332),
    [sym_class] = STATE(1332),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1332),
    [sym_arrow_function] = STATE(1332),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_await_expression] = STATE(1332),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1332),
    [sym_augmented_assignment_expression] = STATE(1332),
    [sym_ternary_expression] = STATE(1332),
    [sym_binary_expression] = STATE(1332),
    [sym_unary_expression] = STATE(1332),
    [sym_update_expression] = STATE(1332),
    [sym_sequence_expression] = STATE(3141),
    [sym_string] = STATE(1332),
    [sym_template_string] = STATE(1332),
    [sym_regex] = STATE(1332),
    [sym_meta_property] = STATE(1332),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1332),
    [sym_as_expression] = STATE(1332),
    [sym_internal_module] = STATE(1332),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1800),
    [sym_this] = ACTIONS(1802),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1802),
    [sym_false] = ACTIONS(1802),
    [sym_null] = ACTIONS(1802),
    [sym_undefined] = ACTIONS(1802),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [241] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1804),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [242] = {
    [sym_import] = STATE(1204),
    [sym_statement_block] = STATE(1599),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1204),
    [sym_jsx_fragment] = STATE(1204),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1204),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1204),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1806),
    [sym_this] = ACTIONS(1808),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1808),
    [sym_false] = ACTIONS(1808),
    [sym_null] = ACTIONS(1808),
    [sym_undefined] = ACTIONS(1808),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [243] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [sym_readonly] = ACTIONS(1539),
  },
  [244] = {
    [sym_import] = STATE(1241),
    [sym_statement_block] = STATE(1038),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1241),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1241),
    [sym_jsx_fragment] = STATE(1241),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1241),
    [sym_class] = STATE(1241),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1241),
    [sym_arrow_function] = STATE(1241),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1241),
    [sym_new_expression] = STATE(1241),
    [sym_await_expression] = STATE(1241),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1241),
    [sym_augmented_assignment_expression] = STATE(1241),
    [sym_ternary_expression] = STATE(1241),
    [sym_binary_expression] = STATE(1241),
    [sym_unary_expression] = STATE(1241),
    [sym_update_expression] = STATE(1241),
    [sym_string] = STATE(1241),
    [sym_template_string] = STATE(1241),
    [sym_regex] = STATE(1241),
    [sym_meta_property] = STATE(1241),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1241),
    [sym_as_expression] = STATE(1241),
    [sym_internal_module] = STATE(1241),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1810),
    [sym_this] = ACTIONS(1812),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1812),
    [sym_false] = ACTIONS(1812),
    [sym_null] = ACTIONS(1812),
    [sym_undefined] = ACTIONS(1812),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [245] = {
    [sym_import] = STATE(1069),
    [sym_statement_block] = STATE(1500),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1069),
    [sym_yield_expression] = STATE(1069),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1069),
    [sym_jsx_fragment] = STATE(1069),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1069),
    [sym_class] = STATE(1069),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1069),
    [sym_arrow_function] = STATE(1069),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1069),
    [sym_new_expression] = STATE(1069),
    [sym_await_expression] = STATE(1069),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1069),
    [sym_augmented_assignment_expression] = STATE(1069),
    [sym_ternary_expression] = STATE(1069),
    [sym_binary_expression] = STATE(1069),
    [sym_unary_expression] = STATE(1069),
    [sym_update_expression] = STATE(1069),
    [sym_string] = STATE(1069),
    [sym_template_string] = STATE(1069),
    [sym_regex] = STATE(1069),
    [sym_meta_property] = STATE(1069),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1069),
    [sym_as_expression] = STATE(1069),
    [sym_internal_module] = STATE(1069),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1814),
    [sym_this] = ACTIONS(1816),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1816),
    [sym_false] = ACTIONS(1816),
    [sym_null] = ACTIONS(1816),
    [sym_undefined] = ACTIONS(1816),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [246] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [247] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(984),
    [sym_yield_expression] = STATE(984),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(984),
    [sym_jsx_fragment] = STATE(984),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(984),
    [sym_class] = STATE(984),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(984),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(984),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(984),
    [sym_augmented_assignment_expression] = STATE(984),
    [sym_ternary_expression] = STATE(984),
    [sym_binary_expression] = STATE(984),
    [sym_unary_expression] = STATE(984),
    [sym_update_expression] = STATE(984),
    [sym_sequence_expression] = STATE(2480),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(984),
    [sym_as_expression] = STATE(984),
    [sym_internal_module] = STATE(984),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(1820),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1820),
    [sym_false] = ACTIONS(1820),
    [sym_null] = ACTIONS(1820),
    [sym_undefined] = ACTIONS(1820),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [248] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1525),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [249] = {
    [sym_import] = STATE(989),
    [sym_statement_block] = STATE(1038),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(989),
    [sym_yield_expression] = STATE(989),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(989),
    [sym_jsx_fragment] = STATE(989),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(989),
    [sym_class] = STATE(989),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(989),
    [sym_arrow_function] = STATE(989),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(989),
    [sym_new_expression] = STATE(989),
    [sym_await_expression] = STATE(989),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(989),
    [sym_augmented_assignment_expression] = STATE(989),
    [sym_ternary_expression] = STATE(989),
    [sym_binary_expression] = STATE(989),
    [sym_unary_expression] = STATE(989),
    [sym_update_expression] = STATE(989),
    [sym_string] = STATE(989),
    [sym_template_string] = STATE(989),
    [sym_regex] = STATE(989),
    [sym_meta_property] = STATE(989),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(989),
    [sym_as_expression] = STATE(989),
    [sym_internal_module] = STATE(989),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1822),
    [sym_this] = ACTIONS(1824),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1824),
    [sym_false] = ACTIONS(1824),
    [sym_null] = ACTIONS(1824),
    [sym_undefined] = ACTIONS(1824),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [250] = {
    [sym_import] = STATE(1494),
    [sym_parenthesized_expression] = STATE(876),
    [sym__expression] = STATE(1687),
    [sym_yield_expression] = STATE(1687),
    [sym_object] = STATE(1322),
    [sym_array] = STATE(1323),
    [sym_jsx_element] = STATE(1687),
    [sym_jsx_fragment] = STATE(1687),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1687),
    [sym_class] = STATE(1494),
    [sym_function] = STATE(1313),
    [sym_generator_function] = STATE(1494),
    [sym_arrow_function] = STATE(1494),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1687),
    [sym_new_expression] = STATE(1494),
    [sym_await_expression] = STATE(1687),
    [sym_member_expression] = STATE(876),
    [sym_subscript_expression] = STATE(876),
    [sym_assignment_expression] = STATE(1687),
    [sym_augmented_assignment_expression] = STATE(1687),
    [sym_ternary_expression] = STATE(1687),
    [sym_binary_expression] = STATE(1687),
    [sym_unary_expression] = STATE(1687),
    [sym_update_expression] = STATE(1687),
    [sym_string] = STATE(1494),
    [sym_template_string] = STATE(1494),
    [sym_regex] = STATE(1494),
    [sym_meta_property] = STATE(1494),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1687),
    [sym_as_expression] = STATE(1687),
    [sym_internal_module] = STATE(1687),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1471),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1483),
    [sym_this] = ACTIONS(1485),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [sym_null] = ACTIONS(1485),
    [sym_undefined] = ACTIONS(1485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [sym_readonly] = ACTIONS(1473),
  },
  [251] = {
    [sym_import] = STATE(1246),
    [sym_statement_block] = STATE(1051),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1246),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1246),
    [sym_jsx_fragment] = STATE(1246),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1246),
    [sym_class] = STATE(1246),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1246),
    [sym_arrow_function] = STATE(1246),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1246),
    [sym_new_expression] = STATE(1246),
    [sym_await_expression] = STATE(1246),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1246),
    [sym_augmented_assignment_expression] = STATE(1246),
    [sym_ternary_expression] = STATE(1246),
    [sym_binary_expression] = STATE(1246),
    [sym_unary_expression] = STATE(1246),
    [sym_update_expression] = STATE(1246),
    [sym_string] = STATE(1246),
    [sym_template_string] = STATE(1246),
    [sym_regex] = STATE(1246),
    [sym_meta_property] = STATE(1246),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1246),
    [sym_as_expression] = STATE(1246),
    [sym_internal_module] = STATE(1246),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [252] = {
    [sym_import] = STATE(1113),
    [sym_statement_block] = STATE(1478),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1113),
    [sym_yield_expression] = STATE(1113),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1113),
    [sym_jsx_fragment] = STATE(1113),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1113),
    [sym_class] = STATE(1113),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1113),
    [sym_arrow_function] = STATE(1113),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1113),
    [sym_new_expression] = STATE(1113),
    [sym_await_expression] = STATE(1113),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1113),
    [sym_augmented_assignment_expression] = STATE(1113),
    [sym_ternary_expression] = STATE(1113),
    [sym_binary_expression] = STATE(1113),
    [sym_unary_expression] = STATE(1113),
    [sym_update_expression] = STATE(1113),
    [sym_string] = STATE(1113),
    [sym_template_string] = STATE(1113),
    [sym_regex] = STATE(1113),
    [sym_meta_property] = STATE(1113),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1113),
    [sym_as_expression] = STATE(1113),
    [sym_internal_module] = STATE(1113),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1830),
    [sym_this] = ACTIONS(1832),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1832),
    [sym_false] = ACTIONS(1832),
    [sym_null] = ACTIONS(1832),
    [sym_undefined] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [253] = {
    [sym_import] = STATE(1267),
    [sym_statement_block] = STATE(1576),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1267),
    [sym_jsx_fragment] = STATE(1267),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1267),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_string] = STATE(1267),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1834),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [254] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1312),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1312),
    [sym_jsx_fragment] = STATE(1312),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1312),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1312),
    [sym_await_expression] = STATE(1312),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1312),
    [sym_augmented_assignment_expression] = STATE(1312),
    [sym_ternary_expression] = STATE(1312),
    [sym_binary_expression] = STATE(1312),
    [sym_unary_expression] = STATE(1312),
    [sym_update_expression] = STATE(1312),
    [sym_sequence_expression] = STATE(2883),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1312),
    [sym_as_expression] = STATE(1312),
    [sym_internal_module] = STATE(1312),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [255] = {
    [sym_import] = STATE(1225),
    [sym_statement_block] = STATE(1582),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1225),
    [sym_yield_expression] = STATE(1225),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1225),
    [sym_jsx_fragment] = STATE(1225),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1225),
    [sym_class] = STATE(1225),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1225),
    [sym_arrow_function] = STATE(1225),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1225),
    [sym_new_expression] = STATE(1225),
    [sym_await_expression] = STATE(1225),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1225),
    [sym_augmented_assignment_expression] = STATE(1225),
    [sym_ternary_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_update_expression] = STATE(1225),
    [sym_string] = STATE(1225),
    [sym_template_string] = STATE(1225),
    [sym_regex] = STATE(1225),
    [sym_meta_property] = STATE(1225),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1225),
    [sym_as_expression] = STATE(1225),
    [sym_internal_module] = STATE(1225),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [256] = {
    [sym_import] = STATE(1328),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1328),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1328),
    [sym_jsx_fragment] = STATE(1328),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1328),
    [sym_class] = STATE(1328),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1328),
    [sym_arrow_function] = STATE(1328),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_await_expression] = STATE(1328),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1328),
    [sym_augmented_assignment_expression] = STATE(1328),
    [sym_ternary_expression] = STATE(1328),
    [sym_binary_expression] = STATE(1328),
    [sym_unary_expression] = STATE(1328),
    [sym_update_expression] = STATE(1328),
    [sym_string] = STATE(1328),
    [sym_template_string] = STATE(1328),
    [sym_regex] = STATE(1328),
    [sym_meta_property] = STATE(1328),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1328),
    [sym_as_expression] = STATE(1328),
    [sym_internal_module] = STATE(1328),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1846),
    [sym_this] = ACTIONS(1848),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [257] = {
    [sym_import] = STATE(1365),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1365),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1365),
    [sym_jsx_fragment] = STATE(1365),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1365),
    [sym_class] = STATE(1365),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1365),
    [sym_arrow_function] = STATE(1365),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1365),
    [sym_new_expression] = STATE(1365),
    [sym_await_expression] = STATE(1365),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1365),
    [sym_augmented_assignment_expression] = STATE(1365),
    [sym_ternary_expression] = STATE(1365),
    [sym_binary_expression] = STATE(1365),
    [sym_unary_expression] = STATE(1365),
    [sym_update_expression] = STATE(1365),
    [sym_string] = STATE(1365),
    [sym_template_string] = STATE(1365),
    [sym_regex] = STATE(1365),
    [sym_meta_property] = STATE(1365),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1365),
    [sym_as_expression] = STATE(1365),
    [sym_internal_module] = STATE(1365),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1850),
    [sym_this] = ACTIONS(1852),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_null] = ACTIONS(1852),
    [sym_undefined] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [258] = {
    [sym_import] = STATE(1106),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1106),
    [sym_yield_expression] = STATE(1106),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1106),
    [sym_jsx_fragment] = STATE(1106),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1106),
    [sym_class] = STATE(1106),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1106),
    [sym_arrow_function] = STATE(1106),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1106),
    [sym_new_expression] = STATE(1106),
    [sym_await_expression] = STATE(1106),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1106),
    [sym_augmented_assignment_expression] = STATE(1106),
    [sym_ternary_expression] = STATE(1106),
    [sym_binary_expression] = STATE(1106),
    [sym_unary_expression] = STATE(1106),
    [sym_update_expression] = STATE(1106),
    [sym_string] = STATE(1106),
    [sym_template_string] = STATE(1106),
    [sym_regex] = STATE(1106),
    [sym_meta_property] = STATE(1106),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1106),
    [sym_as_expression] = STATE(1106),
    [sym_internal_module] = STATE(1106),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1854),
    [sym_this] = ACTIONS(931),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(931),
    [sym_false] = ACTIONS(931),
    [sym_null] = ACTIONS(931),
    [sym_undefined] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [259] = {
    [sym_import] = STATE(1077),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1077),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1077),
    [sym_jsx_fragment] = STATE(1077),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1077),
    [sym_class] = STATE(1077),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1077),
    [sym_arrow_function] = STATE(1077),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1077),
    [sym_new_expression] = STATE(1077),
    [sym_await_expression] = STATE(1077),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1077),
    [sym_augmented_assignment_expression] = STATE(1077),
    [sym_ternary_expression] = STATE(1077),
    [sym_binary_expression] = STATE(1077),
    [sym_unary_expression] = STATE(1077),
    [sym_update_expression] = STATE(1077),
    [sym_string] = STATE(1077),
    [sym_template_string] = STATE(1077),
    [sym_regex] = STATE(1077),
    [sym_meta_property] = STATE(1077),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1077),
    [sym_as_expression] = STATE(1077),
    [sym_internal_module] = STATE(1077),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1856),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [260] = {
    [sym_import] = STATE(1486),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1486),
    [sym_yield_expression] = STATE(1486),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1486),
    [sym_jsx_fragment] = STATE(1486),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1486),
    [sym_class] = STATE(1486),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1486),
    [sym_arrow_function] = STATE(1486),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1486),
    [sym_new_expression] = STATE(1486),
    [sym_await_expression] = STATE(1486),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1486),
    [sym_augmented_assignment_expression] = STATE(1486),
    [sym_ternary_expression] = STATE(1486),
    [sym_binary_expression] = STATE(1486),
    [sym_unary_expression] = STATE(1486),
    [sym_update_expression] = STATE(1486),
    [sym_string] = STATE(1486),
    [sym_template_string] = STATE(1486),
    [sym_regex] = STATE(1486),
    [sym_meta_property] = STATE(1486),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1486),
    [sym_as_expression] = STATE(1486),
    [sym_internal_module] = STATE(1486),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1860),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [261] = {
    [sym_import] = STATE(1107),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1107),
    [sym_yield_expression] = STATE(1107),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1107),
    [sym_jsx_fragment] = STATE(1107),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1107),
    [sym_class] = STATE(1107),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1107),
    [sym_arrow_function] = STATE(1107),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1107),
    [sym_new_expression] = STATE(1107),
    [sym_await_expression] = STATE(1107),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1107),
    [sym_augmented_assignment_expression] = STATE(1107),
    [sym_ternary_expression] = STATE(1107),
    [sym_binary_expression] = STATE(1107),
    [sym_unary_expression] = STATE(1107),
    [sym_update_expression] = STATE(1107),
    [sym_string] = STATE(1107),
    [sym_template_string] = STATE(1107),
    [sym_regex] = STATE(1107),
    [sym_meta_property] = STATE(1107),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1107),
    [sym_as_expression] = STATE(1107),
    [sym_internal_module] = STATE(1107),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(1866),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1866),
    [sym_false] = ACTIONS(1866),
    [sym_null] = ACTIONS(1866),
    [sym_undefined] = ACTIONS(1866),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [262] = {
    [sym_import] = STATE(1108),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1108),
    [sym_yield_expression] = STATE(1108),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1108),
    [sym_jsx_fragment] = STATE(1108),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1108),
    [sym_class] = STATE(1108),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1108),
    [sym_arrow_function] = STATE(1108),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1108),
    [sym_new_expression] = STATE(1108),
    [sym_await_expression] = STATE(1108),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1108),
    [sym_augmented_assignment_expression] = STATE(1108),
    [sym_ternary_expression] = STATE(1108),
    [sym_binary_expression] = STATE(1108),
    [sym_unary_expression] = STATE(1108),
    [sym_update_expression] = STATE(1108),
    [sym_string] = STATE(1108),
    [sym_template_string] = STATE(1108),
    [sym_regex] = STATE(1108),
    [sym_meta_property] = STATE(1108),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1108),
    [sym_as_expression] = STATE(1108),
    [sym_internal_module] = STATE(1108),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1868),
    [sym_this] = ACTIONS(1870),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1870),
    [sym_false] = ACTIONS(1870),
    [sym_null] = ACTIONS(1870),
    [sym_undefined] = ACTIONS(1870),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [263] = {
    [sym_import] = STATE(1109),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1109),
    [sym_yield_expression] = STATE(1109),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1109),
    [sym_jsx_fragment] = STATE(1109),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1109),
    [sym_class] = STATE(1109),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1109),
    [sym_arrow_function] = STATE(1109),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1109),
    [sym_new_expression] = STATE(1109),
    [sym_await_expression] = STATE(1109),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1109),
    [sym_augmented_assignment_expression] = STATE(1109),
    [sym_ternary_expression] = STATE(1109),
    [sym_binary_expression] = STATE(1109),
    [sym_unary_expression] = STATE(1109),
    [sym_update_expression] = STATE(1109),
    [sym_string] = STATE(1109),
    [sym_template_string] = STATE(1109),
    [sym_regex] = STATE(1109),
    [sym_meta_property] = STATE(1109),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1109),
    [sym_as_expression] = STATE(1109),
    [sym_internal_module] = STATE(1109),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1872),
    [sym_this] = ACTIONS(1874),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1874),
    [sym_false] = ACTIONS(1874),
    [sym_null] = ACTIONS(1874),
    [sym_undefined] = ACTIONS(1874),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [264] = {
    [sym_import] = STATE(1110),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1110),
    [sym_yield_expression] = STATE(1110),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1110),
    [sym_jsx_fragment] = STATE(1110),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1110),
    [sym_class] = STATE(1110),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1110),
    [sym_arrow_function] = STATE(1110),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1110),
    [sym_new_expression] = STATE(1110),
    [sym_await_expression] = STATE(1110),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1110),
    [sym_augmented_assignment_expression] = STATE(1110),
    [sym_ternary_expression] = STATE(1110),
    [sym_binary_expression] = STATE(1110),
    [sym_unary_expression] = STATE(1110),
    [sym_update_expression] = STATE(1110),
    [sym_string] = STATE(1110),
    [sym_template_string] = STATE(1110),
    [sym_regex] = STATE(1110),
    [sym_meta_property] = STATE(1110),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1110),
    [sym_as_expression] = STATE(1110),
    [sym_internal_module] = STATE(1110),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1876),
    [sym_this] = ACTIONS(1878),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1878),
    [sym_false] = ACTIONS(1878),
    [sym_null] = ACTIONS(1878),
    [sym_undefined] = ACTIONS(1878),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [265] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1356),
    [sym_jsx_fragment] = STATE(1356),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1356),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1880),
    [sym_this] = ACTIONS(1882),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1882),
    [sym_false] = ACTIONS(1882),
    [sym_null] = ACTIONS(1882),
    [sym_undefined] = ACTIONS(1882),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [266] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [267] = {
    [sym_import] = STATE(1111),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1111),
    [sym_yield_expression] = STATE(1111),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1111),
    [sym_jsx_fragment] = STATE(1111),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1111),
    [sym_class] = STATE(1111),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1111),
    [sym_arrow_function] = STATE(1111),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1111),
    [sym_new_expression] = STATE(1111),
    [sym_await_expression] = STATE(1111),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1111),
    [sym_augmented_assignment_expression] = STATE(1111),
    [sym_ternary_expression] = STATE(1111),
    [sym_binary_expression] = STATE(1111),
    [sym_unary_expression] = STATE(1111),
    [sym_update_expression] = STATE(1111),
    [sym_string] = STATE(1111),
    [sym_template_string] = STATE(1111),
    [sym_regex] = STATE(1111),
    [sym_meta_property] = STATE(1111),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1111),
    [sym_as_expression] = STATE(1111),
    [sym_internal_module] = STATE(1111),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1884),
    [sym_this] = ACTIONS(1886),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1886),
    [sym_false] = ACTIONS(1886),
    [sym_null] = ACTIONS(1886),
    [sym_undefined] = ACTIONS(1886),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [268] = {
    [sym_import] = STATE(1112),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1112),
    [sym_yield_expression] = STATE(1112),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1112),
    [sym_jsx_fragment] = STATE(1112),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1112),
    [sym_class] = STATE(1112),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1112),
    [sym_arrow_function] = STATE(1112),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1112),
    [sym_new_expression] = STATE(1112),
    [sym_await_expression] = STATE(1112),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1112),
    [sym_augmented_assignment_expression] = STATE(1112),
    [sym_ternary_expression] = STATE(1112),
    [sym_binary_expression] = STATE(1112),
    [sym_unary_expression] = STATE(1112),
    [sym_update_expression] = STATE(1112),
    [sym_string] = STATE(1112),
    [sym_template_string] = STATE(1112),
    [sym_regex] = STATE(1112),
    [sym_meta_property] = STATE(1112),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1112),
    [sym_as_expression] = STATE(1112),
    [sym_internal_module] = STATE(1112),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1888),
    [sym_this] = ACTIONS(1890),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1890),
    [sym_false] = ACTIONS(1890),
    [sym_null] = ACTIONS(1890),
    [sym_undefined] = ACTIONS(1890),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [269] = {
    [sym_import] = STATE(1104),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1104),
    [sym_yield_expression] = STATE(1104),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1104),
    [sym_jsx_fragment] = STATE(1104),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1104),
    [sym_class] = STATE(1104),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1104),
    [sym_arrow_function] = STATE(1104),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1104),
    [sym_new_expression] = STATE(1104),
    [sym_await_expression] = STATE(1104),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1104),
    [sym_augmented_assignment_expression] = STATE(1104),
    [sym_ternary_expression] = STATE(1104),
    [sym_binary_expression] = STATE(1104),
    [sym_unary_expression] = STATE(1104),
    [sym_update_expression] = STATE(1104),
    [sym_string] = STATE(1104),
    [sym_template_string] = STATE(1104),
    [sym_regex] = STATE(1104),
    [sym_meta_property] = STATE(1104),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1104),
    [sym_as_expression] = STATE(1104),
    [sym_internal_module] = STATE(1104),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1892),
    [sym_this] = ACTIONS(1894),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1894),
    [sym_false] = ACTIONS(1894),
    [sym_null] = ACTIONS(1894),
    [sym_undefined] = ACTIONS(1894),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [270] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [271] = {
    [sym_import] = STATE(1247),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1247),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1247),
    [sym_jsx_fragment] = STATE(1247),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1247),
    [sym_class] = STATE(1247),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1247),
    [sym_arrow_function] = STATE(1247),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1247),
    [sym_new_expression] = STATE(1247),
    [sym_await_expression] = STATE(1247),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1247),
    [sym_augmented_assignment_expression] = STATE(1247),
    [sym_ternary_expression] = STATE(1247),
    [sym_binary_expression] = STATE(1247),
    [sym_unary_expression] = STATE(1247),
    [sym_update_expression] = STATE(1247),
    [sym_string] = STATE(1247),
    [sym_template_string] = STATE(1247),
    [sym_regex] = STATE(1247),
    [sym_meta_property] = STATE(1247),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1247),
    [sym_as_expression] = STATE(1247),
    [sym_internal_module] = STATE(1247),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1896),
    [sym_this] = ACTIONS(1898),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1898),
    [sym_false] = ACTIONS(1898),
    [sym_null] = ACTIONS(1898),
    [sym_undefined] = ACTIONS(1898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [272] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1900),
    [sym_this] = ACTIONS(1902),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1902),
    [sym_false] = ACTIONS(1902),
    [sym_null] = ACTIONS(1902),
    [sym_undefined] = ACTIONS(1902),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [273] = {
    [sym_import] = STATE(1098),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1098),
    [sym_jsx_fragment] = STATE(1098),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1098),
    [sym_class] = STATE(1098),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1098),
    [sym_arrow_function] = STATE(1098),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1098),
    [sym_new_expression] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1904),
    [sym_this] = ACTIONS(1906),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [274] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(988),
    [sym_jsx_fragment] = STATE(988),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(988),
    [sym_class] = STATE(988),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1908),
    [sym_this] = ACTIONS(1910),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [sym_null] = ACTIONS(1910),
    [sym_undefined] = ACTIONS(1910),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [275] = {
    [sym_import] = STATE(1244),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1244),
    [sym_yield_expression] = STATE(1244),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1244),
    [sym_jsx_fragment] = STATE(1244),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1244),
    [sym_class] = STATE(1244),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1244),
    [sym_arrow_function] = STATE(1244),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1244),
    [sym_new_expression] = STATE(1244),
    [sym_await_expression] = STATE(1244),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1244),
    [sym_augmented_assignment_expression] = STATE(1244),
    [sym_ternary_expression] = STATE(1244),
    [sym_binary_expression] = STATE(1244),
    [sym_unary_expression] = STATE(1244),
    [sym_update_expression] = STATE(1244),
    [sym_string] = STATE(1244),
    [sym_template_string] = STATE(1244),
    [sym_regex] = STATE(1244),
    [sym_meta_property] = STATE(1244),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1244),
    [sym_as_expression] = STATE(1244),
    [sym_internal_module] = STATE(1244),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1912),
    [sym_this] = ACTIONS(1914),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1914),
    [sym_false] = ACTIONS(1914),
    [sym_null] = ACTIONS(1914),
    [sym_undefined] = ACTIONS(1914),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [276] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(957),
    [sym_jsx_fragment] = STATE(957),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(957),
    [sym_class] = STATE(957),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [277] = {
    [sym_import] = STATE(1292),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1292),
    [sym_jsx_fragment] = STATE(1292),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1292),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1920),
    [sym_this] = ACTIONS(1922),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1922),
    [sym_false] = ACTIONS(1922),
    [sym_null] = ACTIONS(1922),
    [sym_undefined] = ACTIONS(1922),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [278] = {
    [sym_import] = STATE(1298),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1298),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1298),
    [sym_jsx_fragment] = STATE(1298),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1298),
    [sym_class] = STATE(1298),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1298),
    [sym_arrow_function] = STATE(1298),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1298),
    [sym_new_expression] = STATE(1298),
    [sym_await_expression] = STATE(1298),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1298),
    [sym_augmented_assignment_expression] = STATE(1298),
    [sym_ternary_expression] = STATE(1298),
    [sym_binary_expression] = STATE(1298),
    [sym_unary_expression] = STATE(1298),
    [sym_update_expression] = STATE(1298),
    [sym_string] = STATE(1298),
    [sym_template_string] = STATE(1298),
    [sym_regex] = STATE(1298),
    [sym_meta_property] = STATE(1298),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1298),
    [sym_as_expression] = STATE(1298),
    [sym_internal_module] = STATE(1298),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1924),
    [sym_this] = ACTIONS(1926),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1926),
    [sym_false] = ACTIONS(1926),
    [sym_null] = ACTIONS(1926),
    [sym_undefined] = ACTIONS(1926),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [279] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1297),
    [sym_jsx_fragment] = STATE(1297),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1297),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1928),
    [sym_this] = ACTIONS(1930),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [280] = {
    [sym_import] = STATE(1560),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1560),
    [sym_yield_expression] = STATE(1560),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1560),
    [sym_jsx_fragment] = STATE(1560),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1560),
    [sym_class] = STATE(1560),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1560),
    [sym_arrow_function] = STATE(1560),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1560),
    [sym_new_expression] = STATE(1560),
    [sym_await_expression] = STATE(1560),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1560),
    [sym_augmented_assignment_expression] = STATE(1560),
    [sym_ternary_expression] = STATE(1560),
    [sym_binary_expression] = STATE(1560),
    [sym_unary_expression] = STATE(1560),
    [sym_update_expression] = STATE(1560),
    [sym_string] = STATE(1560),
    [sym_template_string] = STATE(1560),
    [sym_regex] = STATE(1560),
    [sym_meta_property] = STATE(1560),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1560),
    [sym_as_expression] = STATE(1560),
    [sym_internal_module] = STATE(1560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1932),
    [sym_this] = ACTIONS(1934),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [sym_null] = ACTIONS(1934),
    [sym_undefined] = ACTIONS(1934),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [281] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1936),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [282] = {
    [sym_import] = STATE(1296),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1296),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1296),
    [sym_jsx_fragment] = STATE(1296),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1296),
    [sym_class] = STATE(1296),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1296),
    [sym_arrow_function] = STATE(1296),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1296),
    [sym_new_expression] = STATE(1296),
    [sym_await_expression] = STATE(1296),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1296),
    [sym_augmented_assignment_expression] = STATE(1296),
    [sym_ternary_expression] = STATE(1296),
    [sym_binary_expression] = STATE(1296),
    [sym_unary_expression] = STATE(1296),
    [sym_update_expression] = STATE(1296),
    [sym_string] = STATE(1296),
    [sym_template_string] = STATE(1296),
    [sym_regex] = STATE(1296),
    [sym_meta_property] = STATE(1296),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1296),
    [sym_as_expression] = STATE(1296),
    [sym_internal_module] = STATE(1296),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1940),
    [sym_this] = ACTIONS(1942),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [sym_null] = ACTIONS(1942),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [283] = {
    [sym_import] = STATE(1355),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1355),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1355),
    [sym_jsx_fragment] = STATE(1355),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1355),
    [sym_class] = STATE(1355),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1355),
    [sym_arrow_function] = STATE(1355),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1355),
    [sym_new_expression] = STATE(1355),
    [sym_await_expression] = STATE(1355),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1355),
    [sym_augmented_assignment_expression] = STATE(1355),
    [sym_ternary_expression] = STATE(1355),
    [sym_binary_expression] = STATE(1355),
    [sym_unary_expression] = STATE(1355),
    [sym_update_expression] = STATE(1355),
    [sym_string] = STATE(1355),
    [sym_template_string] = STATE(1355),
    [sym_regex] = STATE(1355),
    [sym_meta_property] = STATE(1355),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1355),
    [sym_as_expression] = STATE(1355),
    [sym_internal_module] = STATE(1355),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1944),
    [sym_this] = ACTIONS(1946),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [sym_null] = ACTIONS(1946),
    [sym_undefined] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [284] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1948),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [285] = {
    [sym_import] = STATE(986),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(986),
    [sym_yield_expression] = STATE(986),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(986),
    [sym_jsx_fragment] = STATE(986),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(986),
    [sym_class] = STATE(986),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(986),
    [sym_arrow_function] = STATE(986),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(986),
    [sym_new_expression] = STATE(986),
    [sym_await_expression] = STATE(986),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(986),
    [sym_augmented_assignment_expression] = STATE(986),
    [sym_ternary_expression] = STATE(986),
    [sym_binary_expression] = STATE(986),
    [sym_unary_expression] = STATE(986),
    [sym_update_expression] = STATE(986),
    [sym_string] = STATE(986),
    [sym_template_string] = STATE(986),
    [sym_regex] = STATE(986),
    [sym_meta_property] = STATE(986),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(986),
    [sym_as_expression] = STATE(986),
    [sym_internal_module] = STATE(986),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1950),
    [sym_this] = ACTIONS(1952),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1952),
    [sym_false] = ACTIONS(1952),
    [sym_null] = ACTIONS(1952),
    [sym_undefined] = ACTIONS(1952),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [286] = {
    [sym_import] = STATE(1379),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1379),
    [sym_yield_expression] = STATE(1379),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1379),
    [sym_jsx_fragment] = STATE(1379),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1379),
    [sym_class] = STATE(1379),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1379),
    [sym_arrow_function] = STATE(1379),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1379),
    [sym_new_expression] = STATE(1379),
    [sym_await_expression] = STATE(1379),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1379),
    [sym_augmented_assignment_expression] = STATE(1379),
    [sym_ternary_expression] = STATE(1379),
    [sym_binary_expression] = STATE(1379),
    [sym_unary_expression] = STATE(1379),
    [sym_update_expression] = STATE(1379),
    [sym_string] = STATE(1379),
    [sym_template_string] = STATE(1379),
    [sym_regex] = STATE(1379),
    [sym_meta_property] = STATE(1379),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1379),
    [sym_as_expression] = STATE(1379),
    [sym_internal_module] = STATE(1379),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1954),
    [sym_this] = ACTIONS(1956),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1956),
    [sym_false] = ACTIONS(1956),
    [sym_null] = ACTIONS(1956),
    [sym_undefined] = ACTIONS(1956),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [287] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1311),
    [sym_jsx_fragment] = STATE(1311),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1311),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1958),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [288] = {
    [sym_import] = STATE(1463),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1463),
    [sym_yield_expression] = STATE(1463),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1463),
    [sym_jsx_fragment] = STATE(1463),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1463),
    [sym_class] = STATE(1463),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1463),
    [sym_arrow_function] = STATE(1463),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1463),
    [sym_new_expression] = STATE(1463),
    [sym_await_expression] = STATE(1463),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1463),
    [sym_augmented_assignment_expression] = STATE(1463),
    [sym_ternary_expression] = STATE(1463),
    [sym_binary_expression] = STATE(1463),
    [sym_unary_expression] = STATE(1463),
    [sym_update_expression] = STATE(1463),
    [sym_string] = STATE(1463),
    [sym_template_string] = STATE(1463),
    [sym_regex] = STATE(1463),
    [sym_meta_property] = STATE(1463),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1463),
    [sym_as_expression] = STATE(1463),
    [sym_internal_module] = STATE(1463),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1962),
    [sym_this] = ACTIONS(1964),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [sym_null] = ACTIONS(1964),
    [sym_undefined] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [289] = {
    [sym_import] = STATE(983),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(983),
    [sym_arrow_function] = STATE(983),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(983),
    [sym_new_expression] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_string] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1966),
    [sym_this] = ACTIONS(905),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [sym_null] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [290] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1001),
    [sym_yield_expression] = STATE(1001),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1001),
    [sym_jsx_fragment] = STATE(1001),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1001),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1001),
    [sym_await_expression] = STATE(1001),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1001),
    [sym_augmented_assignment_expression] = STATE(1001),
    [sym_ternary_expression] = STATE(1001),
    [sym_binary_expression] = STATE(1001),
    [sym_unary_expression] = STATE(1001),
    [sym_update_expression] = STATE(1001),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1001),
    [sym_as_expression] = STATE(1001),
    [sym_internal_module] = STATE(1001),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1968),
    [sym_this] = ACTIONS(1970),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1970),
    [sym_false] = ACTIONS(1970),
    [sym_null] = ACTIONS(1970),
    [sym_undefined] = ACTIONS(1970),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [291] = {
    [sym_import] = STATE(1242),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1242),
    [sym_jsx_fragment] = STATE(1242),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1242),
    [sym_class] = STATE(1242),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1242),
    [sym_arrow_function] = STATE(1242),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1242),
    [sym_new_expression] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_string] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_meta_property] = STATE(1242),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1972),
    [sym_this] = ACTIONS(1974),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_undefined] = ACTIONS(1974),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [292] = {
    [sym_import] = STATE(1283),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1283),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1283),
    [sym_jsx_fragment] = STATE(1283),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1283),
    [sym_class] = STATE(1283),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1283),
    [sym_arrow_function] = STATE(1283),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1283),
    [sym_new_expression] = STATE(1283),
    [sym_await_expression] = STATE(1283),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1283),
    [sym_augmented_assignment_expression] = STATE(1283),
    [sym_ternary_expression] = STATE(1283),
    [sym_binary_expression] = STATE(1283),
    [sym_unary_expression] = STATE(1283),
    [sym_update_expression] = STATE(1283),
    [sym_string] = STATE(1283),
    [sym_template_string] = STATE(1283),
    [sym_regex] = STATE(1283),
    [sym_meta_property] = STATE(1283),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1283),
    [sym_as_expression] = STATE(1283),
    [sym_internal_module] = STATE(1283),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1976),
    [sym_this] = ACTIONS(1978),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1978),
    [sym_false] = ACTIONS(1978),
    [sym_null] = ACTIONS(1978),
    [sym_undefined] = ACTIONS(1978),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [293] = {
    [sym_import] = STATE(1188),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1188),
    [sym_yield_expression] = STATE(1188),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1188),
    [sym_jsx_fragment] = STATE(1188),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1188),
    [sym_class] = STATE(1188),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1188),
    [sym_arrow_function] = STATE(1188),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1188),
    [sym_new_expression] = STATE(1188),
    [sym_await_expression] = STATE(1188),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1188),
    [sym_augmented_assignment_expression] = STATE(1188),
    [sym_ternary_expression] = STATE(1188),
    [sym_binary_expression] = STATE(1188),
    [sym_unary_expression] = STATE(1188),
    [sym_update_expression] = STATE(1188),
    [sym_string] = STATE(1188),
    [sym_template_string] = STATE(1188),
    [sym_regex] = STATE(1188),
    [sym_meta_property] = STATE(1188),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1188),
    [sym_as_expression] = STATE(1188),
    [sym_internal_module] = STATE(1188),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1980),
    [sym_this] = ACTIONS(1982),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1982),
    [sym_false] = ACTIONS(1982),
    [sym_null] = ACTIONS(1982),
    [sym_undefined] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [294] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(976),
    [sym_jsx_fragment] = STATE(976),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(976),
    [sym_class] = STATE(976),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1984),
    [sym_this] = ACTIONS(1986),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1986),
    [sym_false] = ACTIONS(1986),
    [sym_null] = ACTIONS(1986),
    [sym_undefined] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [295] = {
    [sym_import] = STATE(1302),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1302),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1302),
    [sym_jsx_fragment] = STATE(1302),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1302),
    [sym_class] = STATE(1302),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1302),
    [sym_arrow_function] = STATE(1302),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1302),
    [sym_new_expression] = STATE(1302),
    [sym_await_expression] = STATE(1302),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1302),
    [sym_augmented_assignment_expression] = STATE(1302),
    [sym_ternary_expression] = STATE(1302),
    [sym_binary_expression] = STATE(1302),
    [sym_unary_expression] = STATE(1302),
    [sym_update_expression] = STATE(1302),
    [sym_string] = STATE(1302),
    [sym_template_string] = STATE(1302),
    [sym_regex] = STATE(1302),
    [sym_meta_property] = STATE(1302),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1302),
    [sym_as_expression] = STATE(1302),
    [sym_internal_module] = STATE(1302),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1988),
    [sym_this] = ACTIONS(1990),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_undefined] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [296] = {
    [sym_import] = STATE(1189),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1189),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1189),
    [sym_jsx_fragment] = STATE(1189),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1189),
    [sym_class] = STATE(1189),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1189),
    [sym_arrow_function] = STATE(1189),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1189),
    [sym_augmented_assignment_expression] = STATE(1189),
    [sym_ternary_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_update_expression] = STATE(1189),
    [sym_string] = STATE(1189),
    [sym_template_string] = STATE(1189),
    [sym_regex] = STATE(1189),
    [sym_meta_property] = STATE(1189),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1189),
    [sym_as_expression] = STATE(1189),
    [sym_internal_module] = STATE(1189),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(1994),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1994),
    [sym_false] = ACTIONS(1994),
    [sym_null] = ACTIONS(1994),
    [sym_undefined] = ACTIONS(1994),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [297] = {
    [sym_import] = STATE(1174),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1174),
    [sym_yield_expression] = STATE(1174),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1174),
    [sym_jsx_fragment] = STATE(1174),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1174),
    [sym_class] = STATE(1174),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1174),
    [sym_arrow_function] = STATE(1174),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1174),
    [sym_new_expression] = STATE(1174),
    [sym_await_expression] = STATE(1174),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1174),
    [sym_augmented_assignment_expression] = STATE(1174),
    [sym_ternary_expression] = STATE(1174),
    [sym_binary_expression] = STATE(1174),
    [sym_unary_expression] = STATE(1174),
    [sym_update_expression] = STATE(1174),
    [sym_string] = STATE(1174),
    [sym_template_string] = STATE(1174),
    [sym_regex] = STATE(1174),
    [sym_meta_property] = STATE(1174),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1174),
    [sym_as_expression] = STATE(1174),
    [sym_internal_module] = STATE(1174),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1996),
    [sym_this] = ACTIONS(1998),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1998),
    [sym_false] = ACTIONS(1998),
    [sym_null] = ACTIONS(1998),
    [sym_undefined] = ACTIONS(1998),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [298] = {
    [sym_import] = STATE(1240),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1240),
    [sym_yield_expression] = STATE(1240),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1240),
    [sym_jsx_fragment] = STATE(1240),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1240),
    [sym_class] = STATE(1240),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1240),
    [sym_arrow_function] = STATE(1240),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1240),
    [sym_new_expression] = STATE(1240),
    [sym_await_expression] = STATE(1240),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1240),
    [sym_augmented_assignment_expression] = STATE(1240),
    [sym_ternary_expression] = STATE(1240),
    [sym_binary_expression] = STATE(1240),
    [sym_unary_expression] = STATE(1240),
    [sym_update_expression] = STATE(1240),
    [sym_string] = STATE(1240),
    [sym_template_string] = STATE(1240),
    [sym_regex] = STATE(1240),
    [sym_meta_property] = STATE(1240),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1240),
    [sym_as_expression] = STATE(1240),
    [sym_internal_module] = STATE(1240),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2000),
    [sym_this] = ACTIONS(2002),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2002),
    [sym_false] = ACTIONS(2002),
    [sym_null] = ACTIONS(2002),
    [sym_undefined] = ACTIONS(2002),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [299] = {
    [sym_import] = STATE(1375),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1375),
    [sym_yield_expression] = STATE(1375),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1375),
    [sym_jsx_fragment] = STATE(1375),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1375),
    [sym_class] = STATE(1375),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1375),
    [sym_arrow_function] = STATE(1375),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1375),
    [sym_new_expression] = STATE(1375),
    [sym_await_expression] = STATE(1375),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1375),
    [sym_augmented_assignment_expression] = STATE(1375),
    [sym_ternary_expression] = STATE(1375),
    [sym_binary_expression] = STATE(1375),
    [sym_unary_expression] = STATE(1375),
    [sym_update_expression] = STATE(1375),
    [sym_string] = STATE(1375),
    [sym_template_string] = STATE(1375),
    [sym_regex] = STATE(1375),
    [sym_meta_property] = STATE(1375),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1375),
    [sym_as_expression] = STATE(1375),
    [sym_internal_module] = STATE(1375),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2004),
    [sym_this] = ACTIONS(2006),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2006),
    [sym_false] = ACTIONS(2006),
    [sym_null] = ACTIONS(2006),
    [sym_undefined] = ACTIONS(2006),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [300] = {
    [sym_import] = STATE(1193),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1193),
    [sym_yield_expression] = STATE(1193),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1193),
    [sym_jsx_fragment] = STATE(1193),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1193),
    [sym_class] = STATE(1193),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1193),
    [sym_arrow_function] = STATE(1193),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1193),
    [sym_new_expression] = STATE(1193),
    [sym_await_expression] = STATE(1193),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1193),
    [sym_augmented_assignment_expression] = STATE(1193),
    [sym_ternary_expression] = STATE(1193),
    [sym_binary_expression] = STATE(1193),
    [sym_unary_expression] = STATE(1193),
    [sym_update_expression] = STATE(1193),
    [sym_string] = STATE(1193),
    [sym_template_string] = STATE(1193),
    [sym_regex] = STATE(1193),
    [sym_meta_property] = STATE(1193),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1193),
    [sym_as_expression] = STATE(1193),
    [sym_internal_module] = STATE(1193),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2008),
    [sym_this] = ACTIONS(2010),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2010),
    [sym_false] = ACTIONS(2010),
    [sym_null] = ACTIONS(2010),
    [sym_undefined] = ACTIONS(2010),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [301] = {
    [sym_import] = STATE(975),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(975),
    [sym_yield_expression] = STATE(975),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_fragment] = STATE(975),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_class] = STATE(975),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(975),
    [sym_arrow_function] = STATE(975),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(975),
    [sym_new_expression] = STATE(975),
    [sym_await_expression] = STATE(975),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(975),
    [sym_augmented_assignment_expression] = STATE(975),
    [sym_ternary_expression] = STATE(975),
    [sym_binary_expression] = STATE(975),
    [sym_unary_expression] = STATE(975),
    [sym_update_expression] = STATE(975),
    [sym_string] = STATE(975),
    [sym_template_string] = STATE(975),
    [sym_regex] = STATE(975),
    [sym_meta_property] = STATE(975),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(975),
    [sym_as_expression] = STATE(975),
    [sym_internal_module] = STATE(975),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2012),
    [sym_this] = ACTIONS(2014),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2014),
    [sym_false] = ACTIONS(2014),
    [sym_null] = ACTIONS(2014),
    [sym_undefined] = ACTIONS(2014),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [302] = {
    [sym_import] = STATE(1191),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1191),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1191),
    [sym_jsx_fragment] = STATE(1191),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1191),
    [sym_class] = STATE(1191),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1191),
    [sym_arrow_function] = STATE(1191),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1191),
    [sym_new_expression] = STATE(1191),
    [sym_await_expression] = STATE(1191),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1191),
    [sym_augmented_assignment_expression] = STATE(1191),
    [sym_ternary_expression] = STATE(1191),
    [sym_binary_expression] = STATE(1191),
    [sym_unary_expression] = STATE(1191),
    [sym_update_expression] = STATE(1191),
    [sym_string] = STATE(1191),
    [sym_template_string] = STATE(1191),
    [sym_regex] = STATE(1191),
    [sym_meta_property] = STATE(1191),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1191),
    [sym_as_expression] = STATE(1191),
    [sym_internal_module] = STATE(1191),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2016),
    [sym_this] = ACTIONS(2018),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_undefined] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [303] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1356),
    [sym_jsx_fragment] = STATE(1356),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1356),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1904),
    [sym_this] = ACTIONS(1882),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1882),
    [sym_false] = ACTIONS(1882),
    [sym_null] = ACTIONS(1882),
    [sym_undefined] = ACTIONS(1882),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [304] = {
    [sym_import] = STATE(994),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(994),
    [sym_yield_expression] = STATE(994),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(994),
    [sym_jsx_fragment] = STATE(994),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(994),
    [sym_class] = STATE(994),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(994),
    [sym_arrow_function] = STATE(994),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(994),
    [sym_new_expression] = STATE(994),
    [sym_await_expression] = STATE(994),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(994),
    [sym_augmented_assignment_expression] = STATE(994),
    [sym_ternary_expression] = STATE(994),
    [sym_binary_expression] = STATE(994),
    [sym_unary_expression] = STATE(994),
    [sym_update_expression] = STATE(994),
    [sym_string] = STATE(994),
    [sym_template_string] = STATE(994),
    [sym_regex] = STATE(994),
    [sym_meta_property] = STATE(994),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(994),
    [sym_as_expression] = STATE(994),
    [sym_internal_module] = STATE(994),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2020),
    [sym_this] = ACTIONS(2022),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2022),
    [sym_false] = ACTIONS(2022),
    [sym_null] = ACTIONS(2022),
    [sym_undefined] = ACTIONS(2022),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [305] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2024),
    [sym_this] = ACTIONS(2026),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2026),
    [sym_false] = ACTIONS(2026),
    [sym_null] = ACTIONS(2026),
    [sym_undefined] = ACTIONS(2026),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [306] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1114),
    [sym_jsx_fragment] = STATE(1114),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1114),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_string] = STATE(1114),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2030),
    [sym_this] = ACTIONS(2032),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [307] = {
    [sym_import] = STATE(974),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(974),
    [sym_yield_expression] = STATE(974),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(974),
    [sym_jsx_fragment] = STATE(974),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(974),
    [sym_class] = STATE(974),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(974),
    [sym_arrow_function] = STATE(974),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(974),
    [sym_new_expression] = STATE(974),
    [sym_await_expression] = STATE(974),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(974),
    [sym_augmented_assignment_expression] = STATE(974),
    [sym_ternary_expression] = STATE(974),
    [sym_binary_expression] = STATE(974),
    [sym_unary_expression] = STATE(974),
    [sym_update_expression] = STATE(974),
    [sym_string] = STATE(974),
    [sym_template_string] = STATE(974),
    [sym_regex] = STATE(974),
    [sym_meta_property] = STATE(974),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(974),
    [sym_as_expression] = STATE(974),
    [sym_internal_module] = STATE(974),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2034),
    [sym_this] = ACTIONS(2036),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [sym_null] = ACTIONS(2036),
    [sym_undefined] = ACTIONS(2036),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [308] = {
    [sym_import] = STATE(1239),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1239),
    [sym_jsx_fragment] = STATE(1239),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1239),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1239),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2038),
    [sym_this] = ACTIONS(951),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(951),
    [sym_false] = ACTIONS(951),
    [sym_null] = ACTIONS(951),
    [sym_undefined] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [309] = {
    [sym_import] = STATE(1075),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1075),
    [sym_yield_expression] = STATE(1075),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1075),
    [sym_jsx_fragment] = STATE(1075),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1075),
    [sym_class] = STATE(1075),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1075),
    [sym_arrow_function] = STATE(1075),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1075),
    [sym_new_expression] = STATE(1075),
    [sym_await_expression] = STATE(1075),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1075),
    [sym_augmented_assignment_expression] = STATE(1075),
    [sym_ternary_expression] = STATE(1075),
    [sym_binary_expression] = STATE(1075),
    [sym_unary_expression] = STATE(1075),
    [sym_update_expression] = STATE(1075),
    [sym_string] = STATE(1075),
    [sym_template_string] = STATE(1075),
    [sym_regex] = STATE(1075),
    [sym_meta_property] = STATE(1075),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1075),
    [sym_as_expression] = STATE(1075),
    [sym_internal_module] = STATE(1075),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2040),
    [sym_this] = ACTIONS(2042),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2042),
    [sym_false] = ACTIONS(2042),
    [sym_null] = ACTIONS(2042),
    [sym_undefined] = ACTIONS(2042),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [310] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1464),
    [sym_yield_expression] = STATE(1464),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1464),
    [sym_jsx_fragment] = STATE(1464),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1464),
    [sym_await_expression] = STATE(1464),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1464),
    [sym_augmented_assignment_expression] = STATE(1464),
    [sym_ternary_expression] = STATE(1464),
    [sym_binary_expression] = STATE(1464),
    [sym_unary_expression] = STATE(1464),
    [sym_update_expression] = STATE(1464),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1464),
    [sym_as_expression] = STATE(1464),
    [sym_internal_module] = STATE(1464),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2044),
    [sym_this] = ACTIONS(2046),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2046),
    [sym_false] = ACTIONS(2046),
    [sym_null] = ACTIONS(2046),
    [sym_undefined] = ACTIONS(2046),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [311] = {
    [sym_import] = STATE(1236),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1236),
    [sym_yield_expression] = STATE(1236),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1236),
    [sym_jsx_fragment] = STATE(1236),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1236),
    [sym_class] = STATE(1236),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1236),
    [sym_arrow_function] = STATE(1236),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1236),
    [sym_new_expression] = STATE(1236),
    [sym_await_expression] = STATE(1236),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1236),
    [sym_augmented_assignment_expression] = STATE(1236),
    [sym_ternary_expression] = STATE(1236),
    [sym_binary_expression] = STATE(1236),
    [sym_unary_expression] = STATE(1236),
    [sym_update_expression] = STATE(1236),
    [sym_string] = STATE(1236),
    [sym_template_string] = STATE(1236),
    [sym_regex] = STATE(1236),
    [sym_meta_property] = STATE(1236),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1236),
    [sym_as_expression] = STATE(1236),
    [sym_internal_module] = STATE(1236),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2048),
    [sym_this] = ACTIONS(2050),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2050),
    [sym_false] = ACTIONS(2050),
    [sym_null] = ACTIONS(2050),
    [sym_undefined] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [312] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1114),
    [sym_jsx_fragment] = STATE(1114),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1114),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_string] = STATE(1114),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2030),
    [sym_this] = ACTIONS(2032),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [313] = {
    [sym_import] = STATE(1235),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1235),
    [sym_yield_expression] = STATE(1235),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1235),
    [sym_jsx_fragment] = STATE(1235),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1235),
    [sym_class] = STATE(1235),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1235),
    [sym_arrow_function] = STATE(1235),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1235),
    [sym_new_expression] = STATE(1235),
    [sym_await_expression] = STATE(1235),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1235),
    [sym_augmented_assignment_expression] = STATE(1235),
    [sym_ternary_expression] = STATE(1235),
    [sym_binary_expression] = STATE(1235),
    [sym_unary_expression] = STATE(1235),
    [sym_update_expression] = STATE(1235),
    [sym_string] = STATE(1235),
    [sym_template_string] = STATE(1235),
    [sym_regex] = STATE(1235),
    [sym_meta_property] = STATE(1235),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1235),
    [sym_as_expression] = STATE(1235),
    [sym_internal_module] = STATE(1235),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2052),
    [sym_this] = ACTIONS(2054),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_undefined] = ACTIONS(2054),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [314] = {
    [sym_import] = STATE(995),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(995),
    [sym_yield_expression] = STATE(995),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(995),
    [sym_jsx_fragment] = STATE(995),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(995),
    [sym_class] = STATE(995),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(995),
    [sym_arrow_function] = STATE(995),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(995),
    [sym_new_expression] = STATE(995),
    [sym_await_expression] = STATE(995),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(995),
    [sym_augmented_assignment_expression] = STATE(995),
    [sym_ternary_expression] = STATE(995),
    [sym_binary_expression] = STATE(995),
    [sym_unary_expression] = STATE(995),
    [sym_update_expression] = STATE(995),
    [sym_string] = STATE(995),
    [sym_template_string] = STATE(995),
    [sym_regex] = STATE(995),
    [sym_meta_property] = STATE(995),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(995),
    [sym_as_expression] = STATE(995),
    [sym_internal_module] = STATE(995),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2056),
    [sym_this] = ACTIONS(2058),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2058),
    [sym_false] = ACTIONS(2058),
    [sym_null] = ACTIONS(2058),
    [sym_undefined] = ACTIONS(2058),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [315] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(957),
    [sym_jsx_fragment] = STATE(957),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(957),
    [sym_class] = STATE(957),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [316] = {
    [sym_import] = STATE(1234),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1234),
    [sym_jsx_fragment] = STATE(1234),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1234),
    [sym_class] = STATE(1234),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1234),
    [sym_arrow_function] = STATE(1234),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_meta_property] = STATE(1234),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2060),
    [sym_this] = ACTIONS(2062),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2062),
    [sym_false] = ACTIONS(2062),
    [sym_null] = ACTIONS(2062),
    [sym_undefined] = ACTIONS(2062),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [317] = {
    [sym_import] = STATE(1524),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1524),
    [sym_yield_expression] = STATE(1524),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1524),
    [sym_jsx_fragment] = STATE(1524),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1524),
    [sym_class] = STATE(1524),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1524),
    [sym_arrow_function] = STATE(1524),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1524),
    [sym_new_expression] = STATE(1524),
    [sym_await_expression] = STATE(1524),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1524),
    [sym_augmented_assignment_expression] = STATE(1524),
    [sym_ternary_expression] = STATE(1524),
    [sym_binary_expression] = STATE(1524),
    [sym_unary_expression] = STATE(1524),
    [sym_update_expression] = STATE(1524),
    [sym_string] = STATE(1524),
    [sym_template_string] = STATE(1524),
    [sym_regex] = STATE(1524),
    [sym_meta_property] = STATE(1524),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1524),
    [sym_as_expression] = STATE(1524),
    [sym_internal_module] = STATE(1524),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1509),
    [sym_this] = ACTIONS(1511),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1511),
    [sym_false] = ACTIONS(1511),
    [sym_null] = ACTIONS(1511),
    [sym_undefined] = ACTIONS(1511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [318] = {
    [sym_import] = STATE(1233),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1233),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1233),
    [sym_jsx_fragment] = STATE(1233),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1233),
    [sym_class] = STATE(1233),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1233),
    [sym_arrow_function] = STATE(1233),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1233),
    [sym_new_expression] = STATE(1233),
    [sym_await_expression] = STATE(1233),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1233),
    [sym_augmented_assignment_expression] = STATE(1233),
    [sym_ternary_expression] = STATE(1233),
    [sym_binary_expression] = STATE(1233),
    [sym_unary_expression] = STATE(1233),
    [sym_update_expression] = STATE(1233),
    [sym_string] = STATE(1233),
    [sym_template_string] = STATE(1233),
    [sym_regex] = STATE(1233),
    [sym_meta_property] = STATE(1233),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1233),
    [sym_as_expression] = STATE(1233),
    [sym_internal_module] = STATE(1233),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2064),
    [sym_this] = ACTIONS(2066),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_undefined] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [319] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1351),
    [sym_jsx_fragment] = STATE(1351),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1351),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1351),
    [sym_as_expression] = STATE(1351),
    [sym_internal_module] = STATE(1351),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2068),
    [sym_this] = ACTIONS(2070),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_undefined] = ACTIONS(2070),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [320] = {
    [sym_import] = STATE(1350),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1350),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1350),
    [sym_jsx_fragment] = STATE(1350),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1350),
    [sym_class] = STATE(1350),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1350),
    [sym_arrow_function] = STATE(1350),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1350),
    [sym_new_expression] = STATE(1350),
    [sym_await_expression] = STATE(1350),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1350),
    [sym_augmented_assignment_expression] = STATE(1350),
    [sym_ternary_expression] = STATE(1350),
    [sym_binary_expression] = STATE(1350),
    [sym_unary_expression] = STATE(1350),
    [sym_update_expression] = STATE(1350),
    [sym_string] = STATE(1350),
    [sym_template_string] = STATE(1350),
    [sym_regex] = STATE(1350),
    [sym_meta_property] = STATE(1350),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1350),
    [sym_as_expression] = STATE(1350),
    [sym_internal_module] = STATE(1350),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2072),
    [sym_this] = ACTIONS(2074),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2074),
    [sym_false] = ACTIONS(2074),
    [sym_null] = ACTIONS(2074),
    [sym_undefined] = ACTIONS(2074),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [321] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1349),
    [sym_jsx_fragment] = STATE(1349),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1349),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_ternary_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_update_expression] = STATE(1349),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_internal_module] = STATE(1349),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2076),
    [sym_this] = ACTIONS(2078),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2078),
    [sym_false] = ACTIONS(2078),
    [sym_null] = ACTIONS(2078),
    [sym_undefined] = ACTIONS(2078),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [322] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(978),
    [sym_jsx_fragment] = STATE(978),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(978),
    [sym_class] = STATE(978),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2080),
    [sym_this] = ACTIONS(2082),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2082),
    [sym_false] = ACTIONS(2082),
    [sym_null] = ACTIONS(2082),
    [sym_undefined] = ACTIONS(2082),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [323] = {
    [sym_import] = STATE(1347),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1347),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1347),
    [sym_jsx_fragment] = STATE(1347),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1347),
    [sym_class] = STATE(1347),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1347),
    [sym_arrow_function] = STATE(1347),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_await_expression] = STATE(1347),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1347),
    [sym_augmented_assignment_expression] = STATE(1347),
    [sym_ternary_expression] = STATE(1347),
    [sym_binary_expression] = STATE(1347),
    [sym_unary_expression] = STATE(1347),
    [sym_update_expression] = STATE(1347),
    [sym_string] = STATE(1347),
    [sym_template_string] = STATE(1347),
    [sym_regex] = STATE(1347),
    [sym_meta_property] = STATE(1347),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1347),
    [sym_as_expression] = STATE(1347),
    [sym_internal_module] = STATE(1347),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2084),
    [sym_this] = ACTIONS(2086),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2086),
    [sym_false] = ACTIONS(2086),
    [sym_null] = ACTIONS(2086),
    [sym_undefined] = ACTIONS(2086),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [324] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1346),
    [sym_yield_expression] = STATE(1346),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1346),
    [sym_jsx_fragment] = STATE(1346),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1346),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1346),
    [sym_await_expression] = STATE(1346),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1346),
    [sym_augmented_assignment_expression] = STATE(1346),
    [sym_ternary_expression] = STATE(1346),
    [sym_binary_expression] = STATE(1346),
    [sym_unary_expression] = STATE(1346),
    [sym_update_expression] = STATE(1346),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1346),
    [sym_as_expression] = STATE(1346),
    [sym_internal_module] = STATE(1346),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2088),
    [sym_this] = ACTIONS(2090),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [sym_null] = ACTIONS(2090),
    [sym_undefined] = ACTIONS(2090),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [325] = {
    [sym_import] = STATE(1343),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1343),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1343),
    [sym_jsx_fragment] = STATE(1343),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1343),
    [sym_class] = STATE(1343),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1343),
    [sym_arrow_function] = STATE(1343),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1343),
    [sym_new_expression] = STATE(1343),
    [sym_await_expression] = STATE(1343),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1343),
    [sym_augmented_assignment_expression] = STATE(1343),
    [sym_ternary_expression] = STATE(1343),
    [sym_binary_expression] = STATE(1343),
    [sym_unary_expression] = STATE(1343),
    [sym_update_expression] = STATE(1343),
    [sym_string] = STATE(1343),
    [sym_template_string] = STATE(1343),
    [sym_regex] = STATE(1343),
    [sym_meta_property] = STATE(1343),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1343),
    [sym_as_expression] = STATE(1343),
    [sym_internal_module] = STATE(1343),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2092),
    [sym_this] = ACTIONS(2094),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [sym_null] = ACTIONS(2094),
    [sym_undefined] = ACTIONS(2094),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [326] = {
    [sym_import] = STATE(1509),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1509),
    [sym_yield_expression] = STATE(1509),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1509),
    [sym_jsx_fragment] = STATE(1509),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1509),
    [sym_class] = STATE(1509),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1509),
    [sym_arrow_function] = STATE(1509),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1509),
    [sym_new_expression] = STATE(1509),
    [sym_await_expression] = STATE(1509),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1509),
    [sym_augmented_assignment_expression] = STATE(1509),
    [sym_ternary_expression] = STATE(1509),
    [sym_binary_expression] = STATE(1509),
    [sym_unary_expression] = STATE(1509),
    [sym_update_expression] = STATE(1509),
    [sym_string] = STATE(1509),
    [sym_template_string] = STATE(1509),
    [sym_regex] = STATE(1509),
    [sym_meta_property] = STATE(1509),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1509),
    [sym_as_expression] = STATE(1509),
    [sym_internal_module] = STATE(1509),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2096),
    [sym_this] = ACTIONS(2098),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2098),
    [sym_false] = ACTIONS(2098),
    [sym_null] = ACTIONS(2098),
    [sym_undefined] = ACTIONS(2098),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [327] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1364),
    [sym_jsx_fragment] = STATE(1364),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1364),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2100),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [328] = {
    [sym_import] = STATE(1004),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1004),
    [sym_yield_expression] = STATE(1004),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1004),
    [sym_jsx_fragment] = STATE(1004),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1004),
    [sym_class] = STATE(1004),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1004),
    [sym_arrow_function] = STATE(1004),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1004),
    [sym_new_expression] = STATE(1004),
    [sym_await_expression] = STATE(1004),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1004),
    [sym_augmented_assignment_expression] = STATE(1004),
    [sym_ternary_expression] = STATE(1004),
    [sym_binary_expression] = STATE(1004),
    [sym_unary_expression] = STATE(1004),
    [sym_update_expression] = STATE(1004),
    [sym_string] = STATE(1004),
    [sym_template_string] = STATE(1004),
    [sym_regex] = STATE(1004),
    [sym_meta_property] = STATE(1004),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1004),
    [sym_as_expression] = STATE(1004),
    [sym_internal_module] = STATE(1004),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_undefined] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [329] = {
    [sym_import] = STATE(1116),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1116),
    [sym_yield_expression] = STATE(1116),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1116),
    [sym_jsx_fragment] = STATE(1116),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1116),
    [sym_class] = STATE(1116),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1116),
    [sym_arrow_function] = STATE(1116),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1116),
    [sym_new_expression] = STATE(1116),
    [sym_await_expression] = STATE(1116),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1116),
    [sym_augmented_assignment_expression] = STATE(1116),
    [sym_ternary_expression] = STATE(1116),
    [sym_binary_expression] = STATE(1116),
    [sym_unary_expression] = STATE(1116),
    [sym_update_expression] = STATE(1116),
    [sym_string] = STATE(1116),
    [sym_template_string] = STATE(1116),
    [sym_regex] = STATE(1116),
    [sym_meta_property] = STATE(1116),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1116),
    [sym_as_expression] = STATE(1116),
    [sym_internal_module] = STATE(1116),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [330] = {
    [sym_import] = STATE(1339),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1339),
    [sym_yield_expression] = STATE(1339),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1339),
    [sym_jsx_fragment] = STATE(1339),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1339),
    [sym_class] = STATE(1339),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1339),
    [sym_arrow_function] = STATE(1339),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1339),
    [sym_new_expression] = STATE(1339),
    [sym_await_expression] = STATE(1339),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1339),
    [sym_augmented_assignment_expression] = STATE(1339),
    [sym_ternary_expression] = STATE(1339),
    [sym_binary_expression] = STATE(1339),
    [sym_unary_expression] = STATE(1339),
    [sym_update_expression] = STATE(1339),
    [sym_string] = STATE(1339),
    [sym_template_string] = STATE(1339),
    [sym_regex] = STATE(1339),
    [sym_meta_property] = STATE(1339),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1339),
    [sym_as_expression] = STATE(1339),
    [sym_internal_module] = STATE(1339),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [331] = {
    [sym_import] = STATE(1015),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1015),
    [sym_yield_expression] = STATE(1015),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1015),
    [sym_jsx_fragment] = STATE(1015),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1015),
    [sym_class] = STATE(1015),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1015),
    [sym_arrow_function] = STATE(1015),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1015),
    [sym_new_expression] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1015),
    [sym_augmented_assignment_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_update_expression] = STATE(1015),
    [sym_string] = STATE(1015),
    [sym_template_string] = STATE(1015),
    [sym_regex] = STATE(1015),
    [sym_meta_property] = STATE(1015),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1015),
    [sym_as_expression] = STATE(1015),
    [sym_internal_module] = STATE(1015),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_undefined] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [332] = {
    [sym_import] = STATE(1176),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1176),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1176),
    [sym_jsx_fragment] = STATE(1176),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1176),
    [sym_class] = STATE(1176),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1176),
    [sym_arrow_function] = STATE(1176),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1176),
    [sym_new_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(1176),
    [sym_ternary_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_update_expression] = STATE(1176),
    [sym_string] = STATE(1176),
    [sym_template_string] = STATE(1176),
    [sym_regex] = STATE(1176),
    [sym_meta_property] = STATE(1176),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1176),
    [sym_internal_module] = STATE(1176),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_undefined] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [333] = {
    [sym_import] = STATE(1117),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1117),
    [sym_yield_expression] = STATE(1117),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1117),
    [sym_jsx_fragment] = STATE(1117),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1117),
    [sym_class] = STATE(1117),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1117),
    [sym_arrow_function] = STATE(1117),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1117),
    [sym_new_expression] = STATE(1117),
    [sym_await_expression] = STATE(1117),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1117),
    [sym_augmented_assignment_expression] = STATE(1117),
    [sym_ternary_expression] = STATE(1117),
    [sym_binary_expression] = STATE(1117),
    [sym_unary_expression] = STATE(1117),
    [sym_update_expression] = STATE(1117),
    [sym_string] = STATE(1117),
    [sym_template_string] = STATE(1117),
    [sym_regex] = STATE(1117),
    [sym_meta_property] = STATE(1117),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1117),
    [sym_as_expression] = STATE(1117),
    [sym_internal_module] = STATE(1117),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2122),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2124),
    [sym_false] = ACTIONS(2124),
    [sym_null] = ACTIONS(2124),
    [sym_undefined] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [334] = {
    [sym_import] = STATE(1285),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1285),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1285),
    [sym_jsx_fragment] = STATE(1285),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1285),
    [sym_class] = STATE(1285),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1285),
    [sym_arrow_function] = STATE(1285),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1285),
    [sym_new_expression] = STATE(1285),
    [sym_await_expression] = STATE(1285),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1285),
    [sym_augmented_assignment_expression] = STATE(1285),
    [sym_ternary_expression] = STATE(1285),
    [sym_binary_expression] = STATE(1285),
    [sym_unary_expression] = STATE(1285),
    [sym_update_expression] = STATE(1285),
    [sym_string] = STATE(1285),
    [sym_template_string] = STATE(1285),
    [sym_regex] = STATE(1285),
    [sym_meta_property] = STATE(1285),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1285),
    [sym_as_expression] = STATE(1285),
    [sym_internal_module] = STATE(1285),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2128),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2128),
    [sym_false] = ACTIONS(2128),
    [sym_null] = ACTIONS(2128),
    [sym_undefined] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [335] = {
    [sym_import] = STATE(1336),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1336),
    [sym_yield_expression] = STATE(1336),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1336),
    [sym_jsx_fragment] = STATE(1336),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1336),
    [sym_class] = STATE(1336),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1336),
    [sym_arrow_function] = STATE(1336),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1336),
    [sym_new_expression] = STATE(1336),
    [sym_await_expression] = STATE(1336),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1336),
    [sym_augmented_assignment_expression] = STATE(1336),
    [sym_ternary_expression] = STATE(1336),
    [sym_binary_expression] = STATE(1336),
    [sym_unary_expression] = STATE(1336),
    [sym_update_expression] = STATE(1336),
    [sym_string] = STATE(1336),
    [sym_template_string] = STATE(1336),
    [sym_regex] = STATE(1336),
    [sym_meta_property] = STATE(1336),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1336),
    [sym_as_expression] = STATE(1336),
    [sym_internal_module] = STATE(1336),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2130),
    [sym_this] = ACTIONS(2132),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2132),
    [sym_false] = ACTIONS(2132),
    [sym_null] = ACTIONS(2132),
    [sym_undefined] = ACTIONS(2132),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [336] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1121),
    [sym_jsx_fragment] = STATE(1121),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1121),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2134),
    [sym_this] = ACTIONS(2136),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2136),
    [sym_false] = ACTIONS(2136),
    [sym_null] = ACTIONS(2136),
    [sym_undefined] = ACTIONS(2136),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [337] = {
    [sym_import] = STATE(1363),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1363),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1363),
    [sym_jsx_fragment] = STATE(1363),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1363),
    [sym_class] = STATE(1363),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1363),
    [sym_arrow_function] = STATE(1363),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1363),
    [sym_new_expression] = STATE(1363),
    [sym_await_expression] = STATE(1363),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1363),
    [sym_augmented_assignment_expression] = STATE(1363),
    [sym_ternary_expression] = STATE(1363),
    [sym_binary_expression] = STATE(1363),
    [sym_unary_expression] = STATE(1363),
    [sym_update_expression] = STATE(1363),
    [sym_string] = STATE(1363),
    [sym_template_string] = STATE(1363),
    [sym_regex] = STATE(1363),
    [sym_meta_property] = STATE(1363),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1363),
    [sym_as_expression] = STATE(1363),
    [sym_internal_module] = STATE(1363),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2138),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [338] = {
    [sym_import] = STATE(1095),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1095),
    [sym_yield_expression] = STATE(1095),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1095),
    [sym_jsx_fragment] = STATE(1095),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1095),
    [sym_class] = STATE(1095),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1095),
    [sym_arrow_function] = STATE(1095),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1095),
    [sym_new_expression] = STATE(1095),
    [sym_await_expression] = STATE(1095),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1095),
    [sym_augmented_assignment_expression] = STATE(1095),
    [sym_ternary_expression] = STATE(1095),
    [sym_binary_expression] = STATE(1095),
    [sym_unary_expression] = STATE(1095),
    [sym_update_expression] = STATE(1095),
    [sym_string] = STATE(1095),
    [sym_template_string] = STATE(1095),
    [sym_regex] = STATE(1095),
    [sym_meta_property] = STATE(1095),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1095),
    [sym_as_expression] = STATE(1095),
    [sym_internal_module] = STATE(1095),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2140),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [339] = {
    [sym_import] = STATE(1333),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1333),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1333),
    [sym_jsx_fragment] = STATE(1333),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1333),
    [sym_class] = STATE(1333),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1333),
    [sym_arrow_function] = STATE(1333),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_ternary_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_update_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_regex] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_internal_module] = STATE(1333),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2144),
    [sym_this] = ACTIONS(2146),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_undefined] = ACTIONS(2146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [340] = {
    [sym_import] = STATE(1232),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1232),
    [sym_yield_expression] = STATE(1232),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1232),
    [sym_jsx_fragment] = STATE(1232),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1232),
    [sym_class] = STATE(1232),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1232),
    [sym_arrow_function] = STATE(1232),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1232),
    [sym_new_expression] = STATE(1232),
    [sym_await_expression] = STATE(1232),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1232),
    [sym_augmented_assignment_expression] = STATE(1232),
    [sym_ternary_expression] = STATE(1232),
    [sym_binary_expression] = STATE(1232),
    [sym_unary_expression] = STATE(1232),
    [sym_update_expression] = STATE(1232),
    [sym_string] = STATE(1232),
    [sym_template_string] = STATE(1232),
    [sym_regex] = STATE(1232),
    [sym_meta_property] = STATE(1232),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1232),
    [sym_as_expression] = STATE(1232),
    [sym_internal_module] = STATE(1232),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2148),
    [sym_this] = ACTIONS(2150),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2150),
    [sym_false] = ACTIONS(2150),
    [sym_null] = ACTIONS(2150),
    [sym_undefined] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [341] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1005),
    [sym_yield_expression] = STATE(1005),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1005),
    [sym_jsx_fragment] = STATE(1005),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1005),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1005),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1005),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1005),
    [sym_augmented_assignment_expression] = STATE(1005),
    [sym_ternary_expression] = STATE(1005),
    [sym_binary_expression] = STATE(1005),
    [sym_unary_expression] = STATE(1005),
    [sym_update_expression] = STATE(1005),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1005),
    [sym_as_expression] = STATE(1005),
    [sym_internal_module] = STATE(1005),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2152),
    [sym_this] = ACTIONS(2154),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [sym_null] = ACTIONS(2154),
    [sym_undefined] = ACTIONS(2154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [342] = {
    [sym_import] = STATE(1177),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1177),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1177),
    [sym_jsx_fragment] = STATE(1177),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1177),
    [sym_class] = STATE(1177),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1177),
    [sym_arrow_function] = STATE(1177),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(1177),
    [sym_ternary_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_update_expression] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_template_string] = STATE(1177),
    [sym_regex] = STATE(1177),
    [sym_meta_property] = STATE(1177),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1177),
    [sym_as_expression] = STATE(1177),
    [sym_internal_module] = STATE(1177),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2156),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [343] = {
    [sym_import] = STATE(1367),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1367),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1367),
    [sym_jsx_fragment] = STATE(1367),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1367),
    [sym_class] = STATE(1367),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1367),
    [sym_arrow_function] = STATE(1367),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1367),
    [sym_new_expression] = STATE(1367),
    [sym_await_expression] = STATE(1367),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1367),
    [sym_augmented_assignment_expression] = STATE(1367),
    [sym_ternary_expression] = STATE(1367),
    [sym_binary_expression] = STATE(1367),
    [sym_unary_expression] = STATE(1367),
    [sym_update_expression] = STATE(1367),
    [sym_string] = STATE(1367),
    [sym_template_string] = STATE(1367),
    [sym_regex] = STATE(1367),
    [sym_meta_property] = STATE(1367),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1367),
    [sym_as_expression] = STATE(1367),
    [sym_internal_module] = STATE(1367),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2160),
    [sym_this] = ACTIONS(2162),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_null] = ACTIONS(2162),
    [sym_undefined] = ACTIONS(2162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [344] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1178),
    [sym_jsx_fragment] = STATE(1178),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1178),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1178),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2164),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [345] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1179),
    [sym_jsx_fragment] = STATE(1179),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1179),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1179),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2168),
    [sym_this] = ACTIONS(2170),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2170),
    [sym_false] = ACTIONS(2170),
    [sym_null] = ACTIONS(2170),
    [sym_undefined] = ACTIONS(2170),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [346] = {
    [sym_import] = STATE(1506),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1506),
    [sym_yield_expression] = STATE(1506),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1506),
    [sym_jsx_fragment] = STATE(1506),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1506),
    [sym_class] = STATE(1506),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1506),
    [sym_arrow_function] = STATE(1506),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1506),
    [sym_new_expression] = STATE(1506),
    [sym_await_expression] = STATE(1506),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1506),
    [sym_augmented_assignment_expression] = STATE(1506),
    [sym_ternary_expression] = STATE(1506),
    [sym_binary_expression] = STATE(1506),
    [sym_unary_expression] = STATE(1506),
    [sym_update_expression] = STATE(1506),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1506),
    [sym_regex] = STATE(1506),
    [sym_meta_property] = STATE(1506),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1506),
    [sym_as_expression] = STATE(1506),
    [sym_internal_module] = STATE(1506),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2172),
    [sym_this] = ACTIONS(2174),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2174),
    [sym_false] = ACTIONS(2174),
    [sym_null] = ACTIONS(2174),
    [sym_undefined] = ACTIONS(2174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [347] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1329),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1329),
    [sym_jsx_fragment] = STATE(1329),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1329),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1329),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1329),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1329),
    [sym_augmented_assignment_expression] = STATE(1329),
    [sym_ternary_expression] = STATE(1329),
    [sym_binary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1329),
    [sym_update_expression] = STATE(1329),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1329),
    [sym_as_expression] = STATE(1329),
    [sym_internal_module] = STATE(1329),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2176),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [348] = {
    [sym_import] = STATE(1231),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1231),
    [sym_yield_expression] = STATE(1231),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1231),
    [sym_jsx_fragment] = STATE(1231),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1231),
    [sym_class] = STATE(1231),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1231),
    [sym_arrow_function] = STATE(1231),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1231),
    [sym_new_expression] = STATE(1231),
    [sym_await_expression] = STATE(1231),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1231),
    [sym_augmented_assignment_expression] = STATE(1231),
    [sym_ternary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(1231),
    [sym_unary_expression] = STATE(1231),
    [sym_update_expression] = STATE(1231),
    [sym_string] = STATE(1231),
    [sym_template_string] = STATE(1231),
    [sym_regex] = STATE(1231),
    [sym_meta_property] = STATE(1231),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1231),
    [sym_as_expression] = STATE(1231),
    [sym_internal_module] = STATE(1231),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2180),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [349] = {
    [sym_import] = STATE(1068),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1068),
    [sym_yield_expression] = STATE(1068),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1068),
    [sym_jsx_fragment] = STATE(1068),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1068),
    [sym_class] = STATE(1068),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1068),
    [sym_arrow_function] = STATE(1068),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1068),
    [sym_new_expression] = STATE(1068),
    [sym_await_expression] = STATE(1068),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1068),
    [sym_augmented_assignment_expression] = STATE(1068),
    [sym_ternary_expression] = STATE(1068),
    [sym_binary_expression] = STATE(1068),
    [sym_unary_expression] = STATE(1068),
    [sym_update_expression] = STATE(1068),
    [sym_string] = STATE(1068),
    [sym_template_string] = STATE(1068),
    [sym_regex] = STATE(1068),
    [sym_meta_property] = STATE(1068),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1068),
    [sym_as_expression] = STATE(1068),
    [sym_internal_module] = STATE(1068),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2184),
    [sym_this] = ACTIONS(2186),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [sym_null] = ACTIONS(2186),
    [sym_undefined] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [350] = {
    [sym_import] = STATE(1291),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1291),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1291),
    [sym_jsx_fragment] = STATE(1291),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1291),
    [sym_class] = STATE(1291),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1291),
    [sym_arrow_function] = STATE(1291),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1291),
    [sym_new_expression] = STATE(1291),
    [sym_await_expression] = STATE(1291),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1291),
    [sym_augmented_assignment_expression] = STATE(1291),
    [sym_ternary_expression] = STATE(1291),
    [sym_binary_expression] = STATE(1291),
    [sym_unary_expression] = STATE(1291),
    [sym_update_expression] = STATE(1291),
    [sym_string] = STATE(1291),
    [sym_template_string] = STATE(1291),
    [sym_regex] = STATE(1291),
    [sym_meta_property] = STATE(1291),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1291),
    [sym_as_expression] = STATE(1291),
    [sym_internal_module] = STATE(1291),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2188),
    [sym_this] = ACTIONS(2190),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [sym_null] = ACTIONS(2190),
    [sym_undefined] = ACTIONS(2190),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [351] = {
    [sym_import] = STATE(1123),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1123),
    [sym_yield_expression] = STATE(1123),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1123),
    [sym_jsx_fragment] = STATE(1123),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1123),
    [sym_class] = STATE(1123),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1123),
    [sym_arrow_function] = STATE(1123),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1123),
    [sym_new_expression] = STATE(1123),
    [sym_await_expression] = STATE(1123),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1123),
    [sym_augmented_assignment_expression] = STATE(1123),
    [sym_ternary_expression] = STATE(1123),
    [sym_binary_expression] = STATE(1123),
    [sym_unary_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_string] = STATE(1123),
    [sym_template_string] = STATE(1123),
    [sym_regex] = STATE(1123),
    [sym_meta_property] = STATE(1123),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1123),
    [sym_as_expression] = STATE(1123),
    [sym_internal_module] = STATE(1123),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2192),
    [sym_this] = ACTIONS(2194),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [sym_null] = ACTIONS(2194),
    [sym_undefined] = ACTIONS(2194),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [352] = {
    [sym_import] = STATE(1591),
    [sym_parenthesized_expression] = STATE(932),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1731),
    [sym_array] = STATE(1729),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(932),
    [sym_subscript_expression] = STATE(932),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(1660),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1660),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1660),
    [anon_sym_set] = ACTIONS(1660),
    [anon_sym_declare] = ACTIONS(1660),
    [anon_sym_public] = ACTIONS(1660),
    [anon_sym_private] = ACTIONS(1660),
    [anon_sym_protected] = ACTIONS(1660),
    [anon_sym_module] = ACTIONS(1660),
    [anon_sym_any] = ACTIONS(1660),
    [anon_sym_number] = ACTIONS(1660),
    [anon_sym_boolean] = ACTIONS(1660),
    [anon_sym_string] = ACTIONS(1660),
    [anon_sym_symbol] = ACTIONS(1660),
    [sym_readonly] = ACTIONS(1660),
  },
  [353] = {
    [sym_import] = STATE(1182),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1182),
    [sym_yield_expression] = STATE(1182),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1182),
    [sym_jsx_fragment] = STATE(1182),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1182),
    [sym_class] = STATE(1182),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1182),
    [sym_arrow_function] = STATE(1182),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1182),
    [sym_new_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1182),
    [sym_augmented_assignment_expression] = STATE(1182),
    [sym_ternary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_update_expression] = STATE(1182),
    [sym_string] = STATE(1182),
    [sym_template_string] = STATE(1182),
    [sym_regex] = STATE(1182),
    [sym_meta_property] = STATE(1182),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1182),
    [sym_as_expression] = STATE(1182),
    [sym_internal_module] = STATE(1182),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [354] = {
    [sym_import] = STATE(1325),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1325),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1325),
    [sym_jsx_fragment] = STATE(1325),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1325),
    [sym_class] = STATE(1325),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1325),
    [sym_arrow_function] = STATE(1325),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1325),
    [sym_new_expression] = STATE(1325),
    [sym_await_expression] = STATE(1325),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1325),
    [sym_augmented_assignment_expression] = STATE(1325),
    [sym_ternary_expression] = STATE(1325),
    [sym_binary_expression] = STATE(1325),
    [sym_unary_expression] = STATE(1325),
    [sym_update_expression] = STATE(1325),
    [sym_string] = STATE(1325),
    [sym_template_string] = STATE(1325),
    [sym_regex] = STATE(1325),
    [sym_meta_property] = STATE(1325),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1325),
    [sym_as_expression] = STATE(1325),
    [sym_internal_module] = STATE(1325),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [355] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [356] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [357] = {
    [sym_import] = STATE(1504),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1504),
    [sym_yield_expression] = STATE(1504),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1504),
    [sym_jsx_fragment] = STATE(1504),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1504),
    [sym_class] = STATE(1504),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1504),
    [sym_arrow_function] = STATE(1504),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1504),
    [sym_new_expression] = STATE(1504),
    [sym_await_expression] = STATE(1504),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1504),
    [sym_augmented_assignment_expression] = STATE(1504),
    [sym_ternary_expression] = STATE(1504),
    [sym_binary_expression] = STATE(1504),
    [sym_unary_expression] = STATE(1504),
    [sym_update_expression] = STATE(1504),
    [sym_string] = STATE(1504),
    [sym_template_string] = STATE(1504),
    [sym_regex] = STATE(1504),
    [sym_meta_property] = STATE(1504),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1504),
    [sym_as_expression] = STATE(1504),
    [sym_internal_module] = STATE(1504),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2208),
    [sym_this] = ACTIONS(2210),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [sym_null] = ACTIONS(2210),
    [sym_undefined] = ACTIONS(2210),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [358] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2212),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [359] = {
    [sym_import] = STATE(1331),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1331),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1331),
    [sym_jsx_fragment] = STATE(1331),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1331),
    [sym_class] = STATE(1331),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1331),
    [sym_arrow_function] = STATE(1331),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_ternary_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_update_expression] = STATE(1331),
    [sym_string] = STATE(1331),
    [sym_template_string] = STATE(1331),
    [sym_regex] = STATE(1331),
    [sym_meta_property] = STATE(1331),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1331),
    [sym_as_expression] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [360] = {
    [sym_import] = STATE(1201),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1201),
    [sym_yield_expression] = STATE(1201),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1201),
    [sym_jsx_fragment] = STATE(1201),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1201),
    [sym_class] = STATE(1201),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1201),
    [sym_arrow_function] = STATE(1201),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1201),
    [sym_new_expression] = STATE(1201),
    [sym_await_expression] = STATE(1201),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1201),
    [sym_augmented_assignment_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(1201),
    [sym_binary_expression] = STATE(1201),
    [sym_unary_expression] = STATE(1201),
    [sym_update_expression] = STATE(1201),
    [sym_string] = STATE(1201),
    [sym_template_string] = STATE(1201),
    [sym_regex] = STATE(1201),
    [sym_meta_property] = STATE(1201),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1201),
    [sym_as_expression] = STATE(1201),
    [sym_internal_module] = STATE(1201),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [361] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [362] = {
    [sym_import] = STATE(1306),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1306),
    [sym_yield_expression] = STATE(1306),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1306),
    [sym_jsx_fragment] = STATE(1306),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1306),
    [sym_class] = STATE(1306),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1306),
    [sym_arrow_function] = STATE(1306),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1306),
    [sym_new_expression] = STATE(1306),
    [sym_await_expression] = STATE(1306),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1306),
    [sym_augmented_assignment_expression] = STATE(1306),
    [sym_ternary_expression] = STATE(1306),
    [sym_binary_expression] = STATE(1306),
    [sym_unary_expression] = STATE(1306),
    [sym_update_expression] = STATE(1306),
    [sym_string] = STATE(1306),
    [sym_template_string] = STATE(1306),
    [sym_regex] = STATE(1306),
    [sym_meta_property] = STATE(1306),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1306),
    [sym_as_expression] = STATE(1306),
    [sym_internal_module] = STATE(1306),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [363] = {
    [sym_import] = STATE(1000),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1000),
    [sym_yield_expression] = STATE(1000),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1000),
    [sym_jsx_fragment] = STATE(1000),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1000),
    [sym_class] = STATE(1000),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1000),
    [sym_arrow_function] = STATE(1000),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1000),
    [sym_new_expression] = STATE(1000),
    [sym_await_expression] = STATE(1000),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1000),
    [sym_augmented_assignment_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym_update_expression] = STATE(1000),
    [sym_string] = STATE(1000),
    [sym_template_string] = STATE(1000),
    [sym_regex] = STATE(1000),
    [sym_meta_property] = STATE(1000),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1000),
    [sym_as_expression] = STATE(1000),
    [sym_internal_module] = STATE(1000),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [364] = {
    [sym_import] = STATE(1009),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1009),
    [sym_yield_expression] = STATE(1009),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1009),
    [sym_jsx_fragment] = STATE(1009),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1009),
    [sym_class] = STATE(1009),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1009),
    [sym_arrow_function] = STATE(1009),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1009),
    [sym_new_expression] = STATE(1009),
    [sym_await_expression] = STATE(1009),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1009),
    [sym_augmented_assignment_expression] = STATE(1009),
    [sym_ternary_expression] = STATE(1009),
    [sym_binary_expression] = STATE(1009),
    [sym_unary_expression] = STATE(1009),
    [sym_update_expression] = STATE(1009),
    [sym_string] = STATE(1009),
    [sym_template_string] = STATE(1009),
    [sym_regex] = STATE(1009),
    [sym_meta_property] = STATE(1009),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1009),
    [sym_as_expression] = STATE(1009),
    [sym_internal_module] = STATE(1009),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [365] = {
    [sym_import] = STATE(1098),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1098),
    [sym_jsx_fragment] = STATE(1098),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1098),
    [sym_class] = STATE(1098),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1098),
    [sym_arrow_function] = STATE(1098),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1098),
    [sym_new_expression] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(1906),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [366] = {
    [sym_import] = STATE(1096),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1096),
    [sym_yield_expression] = STATE(1096),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1096),
    [sym_jsx_fragment] = STATE(1096),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1096),
    [sym_class] = STATE(1096),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1096),
    [sym_arrow_function] = STATE(1096),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1096),
    [sym_new_expression] = STATE(1096),
    [sym_await_expression] = STATE(1096),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1096),
    [sym_augmented_assignment_expression] = STATE(1096),
    [sym_ternary_expression] = STATE(1096),
    [sym_binary_expression] = STATE(1096),
    [sym_unary_expression] = STATE(1096),
    [sym_update_expression] = STATE(1096),
    [sym_string] = STATE(1096),
    [sym_template_string] = STATE(1096),
    [sym_regex] = STATE(1096),
    [sym_meta_property] = STATE(1096),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1096),
    [sym_as_expression] = STATE(1096),
    [sym_internal_module] = STATE(1096),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2236),
    [sym_this] = ACTIONS(2238),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [sym_null] = ACTIONS(2238),
    [sym_undefined] = ACTIONS(2238),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [367] = {
    [sym_import] = STATE(1250),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1250),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1250),
    [sym_jsx_fragment] = STATE(1250),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1250),
    [sym_class] = STATE(1250),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1250),
    [sym_arrow_function] = STATE(1250),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1250),
    [sym_new_expression] = STATE(1250),
    [sym_await_expression] = STATE(1250),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1250),
    [sym_augmented_assignment_expression] = STATE(1250),
    [sym_ternary_expression] = STATE(1250),
    [sym_binary_expression] = STATE(1250),
    [sym_unary_expression] = STATE(1250),
    [sym_update_expression] = STATE(1250),
    [sym_string] = STATE(1250),
    [sym_template_string] = STATE(1250),
    [sym_regex] = STATE(1250),
    [sym_meta_property] = STATE(1250),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1250),
    [sym_as_expression] = STATE(1250),
    [sym_internal_module] = STATE(1250),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2240),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [368] = {
    [sym_import] = STATE(1183),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1183),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1183),
    [sym_jsx_fragment] = STATE(1183),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1183),
    [sym_class] = STATE(1183),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1183),
    [sym_arrow_function] = STATE(1183),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1183),
    [sym_new_expression] = STATE(1183),
    [sym_await_expression] = STATE(1183),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1183),
    [sym_augmented_assignment_expression] = STATE(1183),
    [sym_ternary_expression] = STATE(1183),
    [sym_binary_expression] = STATE(1183),
    [sym_unary_expression] = STATE(1183),
    [sym_update_expression] = STATE(1183),
    [sym_string] = STATE(1183),
    [sym_template_string] = STATE(1183),
    [sym_regex] = STATE(1183),
    [sym_meta_property] = STATE(1183),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1183),
    [sym_as_expression] = STATE(1183),
    [sym_internal_module] = STATE(1183),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2244),
    [sym_this] = ACTIONS(2246),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2246),
    [sym_false] = ACTIONS(2246),
    [sym_null] = ACTIONS(2246),
    [sym_undefined] = ACTIONS(2246),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [369] = {
    [sym_import] = STATE(1061),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1061),
    [sym_yield_expression] = STATE(1061),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1061),
    [sym_jsx_fragment] = STATE(1061),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1061),
    [sym_class] = STATE(1061),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1061),
    [sym_arrow_function] = STATE(1061),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1061),
    [sym_new_expression] = STATE(1061),
    [sym_await_expression] = STATE(1061),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1061),
    [sym_augmented_assignment_expression] = STATE(1061),
    [sym_ternary_expression] = STATE(1061),
    [sym_binary_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1061),
    [sym_update_expression] = STATE(1061),
    [sym_string] = STATE(1061),
    [sym_template_string] = STATE(1061),
    [sym_regex] = STATE(1061),
    [sym_meta_property] = STATE(1061),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1061),
    [sym_as_expression] = STATE(1061),
    [sym_internal_module] = STATE(1061),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [370] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [371] = {
    [sym_import] = STATE(1359),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1359),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1359),
    [sym_jsx_fragment] = STATE(1359),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1359),
    [sym_class] = STATE(1359),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1359),
    [sym_arrow_function] = STATE(1359),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1359),
    [sym_new_expression] = STATE(1359),
    [sym_await_expression] = STATE(1359),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1359),
    [sym_augmented_assignment_expression] = STATE(1359),
    [sym_ternary_expression] = STATE(1359),
    [sym_binary_expression] = STATE(1359),
    [sym_unary_expression] = STATE(1359),
    [sym_update_expression] = STATE(1359),
    [sym_string] = STATE(1359),
    [sym_template_string] = STATE(1359),
    [sym_regex] = STATE(1359),
    [sym_meta_property] = STATE(1359),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1359),
    [sym_as_expression] = STATE(1359),
    [sym_internal_module] = STATE(1359),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [372] = {
    [sym_import] = STATE(1274),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1274),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1274),
    [sym_jsx_fragment] = STATE(1274),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1274),
    [sym_class] = STATE(1274),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1274),
    [sym_arrow_function] = STATE(1274),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1274),
    [sym_new_expression] = STATE(1274),
    [sym_await_expression] = STATE(1274),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1274),
    [sym_augmented_assignment_expression] = STATE(1274),
    [sym_ternary_expression] = STATE(1274),
    [sym_binary_expression] = STATE(1274),
    [sym_unary_expression] = STATE(1274),
    [sym_update_expression] = STATE(1274),
    [sym_string] = STATE(1274),
    [sym_template_string] = STATE(1274),
    [sym_regex] = STATE(1274),
    [sym_meta_property] = STATE(1274),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1274),
    [sym_as_expression] = STATE(1274),
    [sym_internal_module] = STATE(1274),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [373] = {
    [sym_import] = STATE(1272),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1272),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1272),
    [sym_jsx_fragment] = STATE(1272),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1272),
    [sym_class] = STATE(1272),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1272),
    [sym_arrow_function] = STATE(1272),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1272),
    [sym_new_expression] = STATE(1272),
    [sym_await_expression] = STATE(1272),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1272),
    [sym_augmented_assignment_expression] = STATE(1272),
    [sym_ternary_expression] = STATE(1272),
    [sym_binary_expression] = STATE(1272),
    [sym_unary_expression] = STATE(1272),
    [sym_update_expression] = STATE(1272),
    [sym_string] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_regex] = STATE(1272),
    [sym_meta_property] = STATE(1272),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1272),
    [sym_as_expression] = STATE(1272),
    [sym_internal_module] = STATE(1272),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1936),
    [sym_this] = ACTIONS(2262),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [sym_null] = ACTIONS(2262),
    [sym_undefined] = ACTIONS(2262),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [374] = {
    [sym_import] = STATE(1095),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1095),
    [sym_yield_expression] = STATE(1095),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1095),
    [sym_jsx_fragment] = STATE(1095),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1095),
    [sym_class] = STATE(1095),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1095),
    [sym_arrow_function] = STATE(1095),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1095),
    [sym_new_expression] = STATE(1095),
    [sym_await_expression] = STATE(1095),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1095),
    [sym_augmented_assignment_expression] = STATE(1095),
    [sym_ternary_expression] = STATE(1095),
    [sym_binary_expression] = STATE(1095),
    [sym_unary_expression] = STATE(1095),
    [sym_update_expression] = STATE(1095),
    [sym_string] = STATE(1095),
    [sym_template_string] = STATE(1095),
    [sym_regex] = STATE(1095),
    [sym_meta_property] = STATE(1095),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1095),
    [sym_as_expression] = STATE(1095),
    [sym_internal_module] = STATE(1095),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2140),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [375] = {
    [sym_import] = STATE(1268),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1268),
    [sym_yield_expression] = STATE(1268),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1268),
    [sym_jsx_fragment] = STATE(1268),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1268),
    [sym_class] = STATE(1268),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1268),
    [sym_arrow_function] = STATE(1268),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1268),
    [sym_new_expression] = STATE(1268),
    [sym_await_expression] = STATE(1268),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1268),
    [sym_augmented_assignment_expression] = STATE(1268),
    [sym_ternary_expression] = STATE(1268),
    [sym_binary_expression] = STATE(1268),
    [sym_unary_expression] = STATE(1268),
    [sym_update_expression] = STATE(1268),
    [sym_string] = STATE(1268),
    [sym_template_string] = STATE(1268),
    [sym_regex] = STATE(1268),
    [sym_meta_property] = STATE(1268),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1268),
    [sym_as_expression] = STATE(1268),
    [sym_internal_module] = STATE(1268),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2264),
    [sym_this] = ACTIONS(2266),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [sym_null] = ACTIONS(2266),
    [sym_undefined] = ACTIONS(2266),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [376] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1311),
    [sym_jsx_fragment] = STATE(1311),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1311),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2268),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [377] = {
    [sym_import] = STATE(1308),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1308),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1308),
    [sym_jsx_fragment] = STATE(1308),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1308),
    [sym_class] = STATE(1308),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1308),
    [sym_arrow_function] = STATE(1308),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1308),
    [sym_new_expression] = STATE(1308),
    [sym_await_expression] = STATE(1308),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1308),
    [sym_augmented_assignment_expression] = STATE(1308),
    [sym_ternary_expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_update_expression] = STATE(1308),
    [sym_string] = STATE(1308),
    [sym_template_string] = STATE(1308),
    [sym_regex] = STATE(1308),
    [sym_meta_property] = STATE(1308),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1308),
    [sym_as_expression] = STATE(1308),
    [sym_internal_module] = STATE(1308),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [378] = {
    [sym_import] = STATE(1077),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1077),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1077),
    [sym_jsx_fragment] = STATE(1077),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1077),
    [sym_class] = STATE(1077),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1077),
    [sym_arrow_function] = STATE(1077),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1077),
    [sym_new_expression] = STATE(1077),
    [sym_await_expression] = STATE(1077),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1077),
    [sym_augmented_assignment_expression] = STATE(1077),
    [sym_ternary_expression] = STATE(1077),
    [sym_binary_expression] = STATE(1077),
    [sym_unary_expression] = STATE(1077),
    [sym_update_expression] = STATE(1077),
    [sym_string] = STATE(1077),
    [sym_template_string] = STATE(1077),
    [sym_regex] = STATE(1077),
    [sym_meta_property] = STATE(1077),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1077),
    [sym_as_expression] = STATE(1077),
    [sym_internal_module] = STATE(1077),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1856),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [379] = {
    [sym_import] = STATE(1226),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1226),
    [sym_yield_expression] = STATE(1226),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1226),
    [sym_jsx_fragment] = STATE(1226),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1226),
    [sym_class] = STATE(1226),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1226),
    [sym_arrow_function] = STATE(1226),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1226),
    [sym_new_expression] = STATE(1226),
    [sym_await_expression] = STATE(1226),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1226),
    [sym_augmented_assignment_expression] = STATE(1226),
    [sym_ternary_expression] = STATE(1226),
    [sym_binary_expression] = STATE(1226),
    [sym_unary_expression] = STATE(1226),
    [sym_update_expression] = STATE(1226),
    [sym_string] = STATE(1226),
    [sym_template_string] = STATE(1226),
    [sym_regex] = STATE(1226),
    [sym_meta_property] = STATE(1226),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1226),
    [sym_as_expression] = STATE(1226),
    [sym_internal_module] = STATE(1226),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [380] = {
    [sym_import] = STATE(1261),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1261),
    [sym_yield_expression] = STATE(1261),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1261),
    [sym_jsx_fragment] = STATE(1261),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1261),
    [sym_class] = STATE(1261),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1261),
    [sym_arrow_function] = STATE(1261),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1261),
    [sym_new_expression] = STATE(1261),
    [sym_await_expression] = STATE(1261),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1261),
    [sym_ternary_expression] = STATE(1261),
    [sym_binary_expression] = STATE(1261),
    [sym_unary_expression] = STATE(1261),
    [sym_update_expression] = STATE(1261),
    [sym_string] = STATE(1261),
    [sym_template_string] = STATE(1261),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1261),
    [sym_as_expression] = STATE(1261),
    [sym_internal_module] = STATE(1261),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [381] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1297),
    [sym_jsx_fragment] = STATE(1297),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1297),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1936),
    [sym_this] = ACTIONS(1930),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [382] = {
    [sym_import] = STATE(1194),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1194),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1194),
    [sym_jsx_fragment] = STATE(1194),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1194),
    [sym_class] = STATE(1194),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1194),
    [sym_arrow_function] = STATE(1194),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1194),
    [sym_new_expression] = STATE(1194),
    [sym_await_expression] = STATE(1194),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1194),
    [sym_augmented_assignment_expression] = STATE(1194),
    [sym_ternary_expression] = STATE(1194),
    [sym_binary_expression] = STATE(1194),
    [sym_unary_expression] = STATE(1194),
    [sym_update_expression] = STATE(1194),
    [sym_string] = STATE(1194),
    [sym_template_string] = STATE(1194),
    [sym_regex] = STATE(1194),
    [sym_meta_property] = STATE(1194),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1194),
    [sym_as_expression] = STATE(1194),
    [sym_internal_module] = STATE(1194),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2282),
    [sym_this] = ACTIONS(2284),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [sym_null] = ACTIONS(2284),
    [sym_undefined] = ACTIONS(2284),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [383] = {
    [sym_import] = STATE(1316),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1316),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1316),
    [sym_jsx_fragment] = STATE(1316),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1316),
    [sym_class] = STATE(1316),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1316),
    [sym_arrow_function] = STATE(1316),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1316),
    [sym_new_expression] = STATE(1316),
    [sym_await_expression] = STATE(1316),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1316),
    [sym_augmented_assignment_expression] = STATE(1316),
    [sym_ternary_expression] = STATE(1316),
    [sym_binary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1316),
    [sym_update_expression] = STATE(1316),
    [sym_string] = STATE(1316),
    [sym_template_string] = STATE(1316),
    [sym_regex] = STATE(1316),
    [sym_meta_property] = STATE(1316),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1316),
    [sym_as_expression] = STATE(1316),
    [sym_internal_module] = STATE(1316),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [384] = {
    [sym_import] = STATE(1061),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1061),
    [sym_yield_expression] = STATE(1061),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1061),
    [sym_jsx_fragment] = STATE(1061),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1061),
    [sym_class] = STATE(1061),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1061),
    [sym_arrow_function] = STATE(1061),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1061),
    [sym_new_expression] = STATE(1061),
    [sym_await_expression] = STATE(1061),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1061),
    [sym_augmented_assignment_expression] = STATE(1061),
    [sym_ternary_expression] = STATE(1061),
    [sym_binary_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1061),
    [sym_update_expression] = STATE(1061),
    [sym_string] = STATE(1061),
    [sym_template_string] = STATE(1061),
    [sym_regex] = STATE(1061),
    [sym_meta_property] = STATE(1061),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1061),
    [sym_as_expression] = STATE(1061),
    [sym_internal_module] = STATE(1061),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [385] = {
    [sym_import] = STATE(1014),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1014),
    [sym_jsx_fragment] = STATE(1014),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1014),
    [sym_class] = STATE(1014),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1014),
    [sym_arrow_function] = STATE(1014),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1014),
    [sym_new_expression] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_string] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2290),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [386] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [387] = {
    [sym_import] = STATE(1305),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1305),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1305),
    [sym_jsx_fragment] = STATE(1305),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1305),
    [sym_class] = STATE(1305),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1305),
    [sym_arrow_function] = STATE(1305),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1305),
    [sym_new_expression] = STATE(1305),
    [sym_await_expression] = STATE(1305),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1305),
    [sym_augmented_assignment_expression] = STATE(1305),
    [sym_ternary_expression] = STATE(1305),
    [sym_binary_expression] = STATE(1305),
    [sym_unary_expression] = STATE(1305),
    [sym_update_expression] = STATE(1305),
    [sym_string] = STATE(1305),
    [sym_template_string] = STATE(1305),
    [sym_regex] = STATE(1305),
    [sym_meta_property] = STATE(1305),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1305),
    [sym_as_expression] = STATE(1305),
    [sym_internal_module] = STATE(1305),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2294),
    [sym_this] = ACTIONS(2296),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [sym_null] = ACTIONS(2296),
    [sym_undefined] = ACTIONS(2296),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [388] = {
    [sym_import] = STATE(1277),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1277),
    [sym_jsx_fragment] = STATE(1277),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1277),
    [sym_class] = STATE(1277),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1277),
    [sym_arrow_function] = STATE(1277),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1277),
    [sym_new_expression] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_string] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_meta_property] = STATE(1277),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2298),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [389] = {
    [sym_import] = STATE(1259),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1259),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1259),
    [sym_jsx_fragment] = STATE(1259),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1259),
    [sym_class] = STATE(1259),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1259),
    [sym_arrow_function] = STATE(1259),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1259),
    [sym_new_expression] = STATE(1259),
    [sym_await_expression] = STATE(1259),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1259),
    [sym_augmented_assignment_expression] = STATE(1259),
    [sym_ternary_expression] = STATE(1259),
    [sym_binary_expression] = STATE(1259),
    [sym_unary_expression] = STATE(1259),
    [sym_update_expression] = STATE(1259),
    [sym_string] = STATE(1259),
    [sym_template_string] = STATE(1259),
    [sym_regex] = STATE(1259),
    [sym_meta_property] = STATE(1259),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1259),
    [sym_as_expression] = STATE(1259),
    [sym_internal_module] = STATE(1259),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2302),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [390] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1258),
    [sym_jsx_fragment] = STATE(1258),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1258),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1258),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2306),
    [sym_this] = ACTIONS(1017),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [391] = {
    [sym_import] = STATE(1190),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1190),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1190),
    [sym_jsx_fragment] = STATE(1190),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1190),
    [sym_class] = STATE(1190),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1190),
    [sym_arrow_function] = STATE(1190),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1190),
    [sym_new_expression] = STATE(1190),
    [sym_await_expression] = STATE(1190),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1190),
    [sym_augmented_assignment_expression] = STATE(1190),
    [sym_ternary_expression] = STATE(1190),
    [sym_binary_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1190),
    [sym_update_expression] = STATE(1190),
    [sym_string] = STATE(1190),
    [sym_template_string] = STATE(1190),
    [sym_regex] = STATE(1190),
    [sym_meta_property] = STATE(1190),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1190),
    [sym_as_expression] = STATE(1190),
    [sym_internal_module] = STATE(1190),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2308),
    [sym_this] = ACTIONS(2310),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [sym_null] = ACTIONS(2310),
    [sym_undefined] = ACTIONS(2310),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [392] = {
    [sym_import] = STATE(1327),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1327),
    [sym_jsx_fragment] = STATE(1327),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1327),
    [sym_class] = STATE(1327),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1327),
    [sym_arrow_function] = STATE(1327),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1327),
    [sym_new_expression] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_string] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2312),
    [sym_this] = ACTIONS(2314),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [sym_null] = ACTIONS(2314),
    [sym_undefined] = ACTIONS(2314),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [393] = {
    [sym_import] = STATE(1252),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1252),
    [sym_jsx_fragment] = STATE(1252),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1252),
    [sym_class] = STATE(1252),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1252),
    [sym_arrow_function] = STATE(1252),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1252),
    [sym_new_expression] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_string] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_meta_property] = STATE(1252),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2316),
    [sym_this] = ACTIONS(2318),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_undefined] = ACTIONS(2318),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [394] = {
    [sym_import] = STATE(1418),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1418),
    [sym_yield_expression] = STATE(1418),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1418),
    [sym_jsx_fragment] = STATE(1418),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1418),
    [sym_class] = STATE(1418),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1418),
    [sym_arrow_function] = STATE(1418),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1418),
    [sym_new_expression] = STATE(1418),
    [sym_await_expression] = STATE(1418),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1418),
    [sym_augmented_assignment_expression] = STATE(1418),
    [sym_ternary_expression] = STATE(1418),
    [sym_binary_expression] = STATE(1418),
    [sym_unary_expression] = STATE(1418),
    [sym_update_expression] = STATE(1418),
    [sym_string] = STATE(1418),
    [sym_template_string] = STATE(1418),
    [sym_regex] = STATE(1418),
    [sym_meta_property] = STATE(1418),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1418),
    [sym_as_expression] = STATE(1418),
    [sym_internal_module] = STATE(1418),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2320),
    [sym_this] = ACTIONS(2322),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [sym_null] = ACTIONS(2322),
    [sym_undefined] = ACTIONS(2322),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [395] = {
    [sym_import] = STATE(1251),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1251),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1251),
    [sym_jsx_fragment] = STATE(1251),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1251),
    [sym_class] = STATE(1251),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1251),
    [sym_arrow_function] = STATE(1251),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1251),
    [sym_new_expression] = STATE(1251),
    [sym_await_expression] = STATE(1251),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1251),
    [sym_augmented_assignment_expression] = STATE(1251),
    [sym_ternary_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_unary_expression] = STATE(1251),
    [sym_update_expression] = STATE(1251),
    [sym_string] = STATE(1251),
    [sym_template_string] = STATE(1251),
    [sym_regex] = STATE(1251),
    [sym_meta_property] = STATE(1251),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1251),
    [sym_as_expression] = STATE(1251),
    [sym_internal_module] = STATE(1251),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2324),
    [sym_this] = ACTIONS(2326),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [sym_null] = ACTIONS(2326),
    [sym_undefined] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [396] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(957),
    [sym_jsx_fragment] = STATE(957),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(957),
    [sym_class] = STATE(957),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [397] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1271),
    [sym_jsx_fragment] = STATE(1271),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2328),
    [sym_this] = ACTIONS(2330),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [sym_null] = ACTIONS(2330),
    [sym_undefined] = ACTIONS(2330),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [398] = {
    [sym_import] = STATE(1272),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1272),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1272),
    [sym_jsx_fragment] = STATE(1272),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1272),
    [sym_class] = STATE(1272),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1272),
    [sym_arrow_function] = STATE(1272),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1272),
    [sym_new_expression] = STATE(1272),
    [sym_await_expression] = STATE(1272),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1272),
    [sym_augmented_assignment_expression] = STATE(1272),
    [sym_ternary_expression] = STATE(1272),
    [sym_binary_expression] = STATE(1272),
    [sym_unary_expression] = STATE(1272),
    [sym_update_expression] = STATE(1272),
    [sym_string] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_regex] = STATE(1272),
    [sym_meta_property] = STATE(1272),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1272),
    [sym_as_expression] = STATE(1272),
    [sym_internal_module] = STATE(1272),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2332),
    [sym_this] = ACTIONS(2262),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [sym_null] = ACTIONS(2262),
    [sym_undefined] = ACTIONS(2262),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [399] = {
    [sym_import] = STATE(1238),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1238),
    [sym_yield_expression] = STATE(1238),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1238),
    [sym_jsx_fragment] = STATE(1238),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1238),
    [sym_class] = STATE(1238),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1238),
    [sym_arrow_function] = STATE(1238),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1238),
    [sym_new_expression] = STATE(1238),
    [sym_await_expression] = STATE(1238),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1238),
    [sym_augmented_assignment_expression] = STATE(1238),
    [sym_ternary_expression] = STATE(1238),
    [sym_binary_expression] = STATE(1238),
    [sym_unary_expression] = STATE(1238),
    [sym_update_expression] = STATE(1238),
    [sym_string] = STATE(1238),
    [sym_template_string] = STATE(1238),
    [sym_regex] = STATE(1238),
    [sym_meta_property] = STATE(1238),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1238),
    [sym_as_expression] = STATE(1238),
    [sym_internal_module] = STATE(1238),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2334),
    [sym_this] = ACTIONS(2336),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_undefined] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [400] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1243),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1243),
    [sym_jsx_fragment] = STATE(1243),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1243),
    [sym_class] = STATE(1243),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1243),
    [sym_arrow_function] = STATE(1243),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1243),
    [sym_new_expression] = STATE(1243),
    [sym_await_expression] = STATE(1243),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1243),
    [sym_augmented_assignment_expression] = STATE(1243),
    [sym_ternary_expression] = STATE(1243),
    [sym_binary_expression] = STATE(1243),
    [sym_unary_expression] = STATE(1243),
    [sym_update_expression] = STATE(1243),
    [sym_string] = STATE(1243),
    [sym_template_string] = STATE(1243),
    [sym_regex] = STATE(1243),
    [sym_meta_property] = STATE(1243),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1243),
    [sym_as_expression] = STATE(1243),
    [sym_internal_module] = STATE(1243),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2338),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [401] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1248),
    [sym_jsx_fragment] = STATE(1248),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1248),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [402] = {
    [sym_import] = STATE(1184),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1184),
    [sym_yield_expression] = STATE(1184),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1184),
    [sym_jsx_fragment] = STATE(1184),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1184),
    [sym_class] = STATE(1184),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1184),
    [sym_arrow_function] = STATE(1184),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1184),
    [sym_new_expression] = STATE(1184),
    [sym_await_expression] = STATE(1184),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1184),
    [sym_augmented_assignment_expression] = STATE(1184),
    [sym_ternary_expression] = STATE(1184),
    [sym_binary_expression] = STATE(1184),
    [sym_unary_expression] = STATE(1184),
    [sym_update_expression] = STATE(1184),
    [sym_string] = STATE(1184),
    [sym_template_string] = STATE(1184),
    [sym_regex] = STATE(1184),
    [sym_meta_property] = STATE(1184),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1184),
    [sym_as_expression] = STATE(1184),
    [sym_internal_module] = STATE(1184),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2346),
    [sym_this] = ACTIONS(2348),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [403] = {
    [sym_import] = STATE(1377),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1377),
    [sym_yield_expression] = STATE(1377),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1377),
    [sym_jsx_fragment] = STATE(1377),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1377),
    [sym_class] = STATE(1377),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1377),
    [sym_arrow_function] = STATE(1377),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1377),
    [sym_new_expression] = STATE(1377),
    [sym_await_expression] = STATE(1377),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1377),
    [sym_augmented_assignment_expression] = STATE(1377),
    [sym_ternary_expression] = STATE(1377),
    [sym_binary_expression] = STATE(1377),
    [sym_unary_expression] = STATE(1377),
    [sym_update_expression] = STATE(1377),
    [sym_string] = STATE(1377),
    [sym_template_string] = STATE(1377),
    [sym_regex] = STATE(1377),
    [sym_meta_property] = STATE(1377),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1377),
    [sym_as_expression] = STATE(1377),
    [sym_internal_module] = STATE(1377),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2350),
    [sym_this] = ACTIONS(2352),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [sym_null] = ACTIONS(2352),
    [sym_undefined] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [404] = {
    [sym_import] = STATE(1187),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1187),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1187),
    [sym_jsx_fragment] = STATE(1187),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1187),
    [sym_class] = STATE(1187),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1187),
    [sym_arrow_function] = STATE(1187),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_await_expression] = STATE(1187),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1187),
    [sym_augmented_assignment_expression] = STATE(1187),
    [sym_ternary_expression] = STATE(1187),
    [sym_binary_expression] = STATE(1187),
    [sym_unary_expression] = STATE(1187),
    [sym_update_expression] = STATE(1187),
    [sym_string] = STATE(1187),
    [sym_template_string] = STATE(1187),
    [sym_regex] = STATE(1187),
    [sym_meta_property] = STATE(1187),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1187),
    [sym_as_expression] = STATE(1187),
    [sym_internal_module] = STATE(1187),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2354),
    [sym_this] = ACTIONS(2356),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_null] = ACTIONS(2356),
    [sym_undefined] = ACTIONS(2356),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [405] = {
    [sym_import] = STATE(1376),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1376),
    [sym_yield_expression] = STATE(1376),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1376),
    [sym_jsx_fragment] = STATE(1376),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1376),
    [sym_class] = STATE(1376),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1376),
    [sym_arrow_function] = STATE(1376),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1376),
    [sym_new_expression] = STATE(1376),
    [sym_await_expression] = STATE(1376),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1376),
    [sym_augmented_assignment_expression] = STATE(1376),
    [sym_ternary_expression] = STATE(1376),
    [sym_binary_expression] = STATE(1376),
    [sym_unary_expression] = STATE(1376),
    [sym_update_expression] = STATE(1376),
    [sym_string] = STATE(1376),
    [sym_template_string] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_meta_property] = STATE(1376),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1376),
    [sym_as_expression] = STATE(1376),
    [sym_internal_module] = STATE(1376),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2358),
    [sym_this] = ACTIONS(2360),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2360),
    [sym_false] = ACTIONS(2360),
    [sym_null] = ACTIONS(2360),
    [sym_undefined] = ACTIONS(2360),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [406] = {
    [sym_import] = STATE(1367),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1367),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1367),
    [sym_jsx_fragment] = STATE(1367),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1367),
    [sym_class] = STATE(1367),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1367),
    [sym_arrow_function] = STATE(1367),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1367),
    [sym_new_expression] = STATE(1367),
    [sym_await_expression] = STATE(1367),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1367),
    [sym_augmented_assignment_expression] = STATE(1367),
    [sym_ternary_expression] = STATE(1367),
    [sym_binary_expression] = STATE(1367),
    [sym_unary_expression] = STATE(1367),
    [sym_update_expression] = STATE(1367),
    [sym_string] = STATE(1367),
    [sym_template_string] = STATE(1367),
    [sym_regex] = STATE(1367),
    [sym_meta_property] = STATE(1367),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1367),
    [sym_as_expression] = STATE(1367),
    [sym_internal_module] = STATE(1367),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2160),
    [sym_this] = ACTIONS(2162),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_null] = ACTIONS(2162),
    [sym_undefined] = ACTIONS(2162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [407] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2362),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [408] = {
    [sym_import] = STATE(1026),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1026),
    [sym_yield_expression] = STATE(1026),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1026),
    [sym_jsx_fragment] = STATE(1026),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1026),
    [sym_class] = STATE(1026),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1026),
    [sym_arrow_function] = STATE(1026),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1026),
    [sym_new_expression] = STATE(1026),
    [sym_await_expression] = STATE(1026),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1026),
    [sym_augmented_assignment_expression] = STATE(1026),
    [sym_ternary_expression] = STATE(1026),
    [sym_binary_expression] = STATE(1026),
    [sym_unary_expression] = STATE(1026),
    [sym_update_expression] = STATE(1026),
    [sym_string] = STATE(1026),
    [sym_template_string] = STATE(1026),
    [sym_regex] = STATE(1026),
    [sym_meta_property] = STATE(1026),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1026),
    [sym_as_expression] = STATE(1026),
    [sym_internal_module] = STATE(1026),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2364),
    [sym_this] = ACTIONS(2366),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [sym_null] = ACTIONS(2366),
    [sym_undefined] = ACTIONS(2366),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [409] = {
    [sym_import] = STATE(1249),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1249),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1249),
    [sym_jsx_fragment] = STATE(1249),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1249),
    [sym_class] = STATE(1249),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1249),
    [sym_arrow_function] = STATE(1249),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1249),
    [sym_new_expression] = STATE(1249),
    [sym_await_expression] = STATE(1249),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1249),
    [sym_augmented_assignment_expression] = STATE(1249),
    [sym_ternary_expression] = STATE(1249),
    [sym_binary_expression] = STATE(1249),
    [sym_unary_expression] = STATE(1249),
    [sym_update_expression] = STATE(1249),
    [sym_string] = STATE(1249),
    [sym_template_string] = STATE(1249),
    [sym_regex] = STATE(1249),
    [sym_meta_property] = STATE(1249),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1249),
    [sym_as_expression] = STATE(1249),
    [sym_internal_module] = STATE(1249),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2368),
    [sym_this] = ACTIONS(2370),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [sym_null] = ACTIONS(2370),
    [sym_undefined] = ACTIONS(2370),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [410] = {
    [sym_import] = STATE(1066),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1066),
    [sym_yield_expression] = STATE(1066),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1066),
    [sym_jsx_fragment] = STATE(1066),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1066),
    [sym_class] = STATE(1066),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1066),
    [sym_arrow_function] = STATE(1066),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1066),
    [sym_new_expression] = STATE(1066),
    [sym_await_expression] = STATE(1066),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1066),
    [sym_augmented_assignment_expression] = STATE(1066),
    [sym_ternary_expression] = STATE(1066),
    [sym_binary_expression] = STATE(1066),
    [sym_unary_expression] = STATE(1066),
    [sym_update_expression] = STATE(1066),
    [sym_string] = STATE(1066),
    [sym_template_string] = STATE(1066),
    [sym_regex] = STATE(1066),
    [sym_meta_property] = STATE(1066),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1066),
    [sym_as_expression] = STATE(1066),
    [sym_internal_module] = STATE(1066),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2372),
    [sym_this] = ACTIONS(2374),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [sym_null] = ACTIONS(2374),
    [sym_undefined] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [411] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [412] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [413] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [414] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [415] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2386),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [416] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_namespace] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1165),
    [anon_sym_typeof] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_let] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_debugger] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_EQ_GT] = ACTIONS(1163),
    [anon_sym_new] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_void] = ACTIONS(1165),
    [anon_sym_delete] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_number] = ACTIONS(1163),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(1165),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_abstract] = ACTIONS(1165),
    [anon_sym_get] = ACTIONS(1165),
    [anon_sym_set] = ACTIONS(1165),
    [anon_sym_declare] = ACTIONS(1165),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_module] = ACTIONS(1165),
    [anon_sym_any] = ACTIONS(1165),
    [anon_sym_number] = ACTIONS(1165),
    [anon_sym_boolean] = ACTIONS(1165),
    [anon_sym_string] = ACTIONS(1165),
    [anon_sym_symbol] = ACTIONS(1165),
    [anon_sym_interface] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [sym_readonly] = ACTIONS(1165),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(1167),
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_namespace] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_type] = ACTIONS(1169),
    [anon_sym_typeof] = ACTIONS(1169),
    [anon_sym_import] = ACTIONS(1169),
    [anon_sym_var] = ACTIONS(1169),
    [anon_sym_let] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(1167),
    [anon_sym_await] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_debugger] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_throw] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_yield] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_RBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(1167),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1169),
    [anon_sym_function] = ACTIONS(1169),
    [anon_sym_EQ_GT] = ACTIONS(1167),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_void] = ACTIONS(1169),
    [anon_sym_delete] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1167),
    [sym_this] = ACTIONS(1169),
    [sym_super] = ACTIONS(1169),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [sym_null] = ACTIONS(1169),
    [sym_undefined] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1167),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(1169),
    [anon_sym_set] = ACTIONS(1169),
    [anon_sym_declare] = ACTIONS(1169),
    [anon_sym_public] = ACTIONS(1169),
    [anon_sym_private] = ACTIONS(1169),
    [anon_sym_protected] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1169),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [anon_sym_interface] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [sym_readonly] = ACTIONS(1169),
  },
  [419] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [420] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2392),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [421] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_export] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_EQ] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_import] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_else] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_with] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_debugger] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_function] = ACTIONS(2396),
    [anon_sym_EQ_GT] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_void] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [sym_number] = ACTIONS(2394),
    [sym_this] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [sym_null] = ACTIONS(2396),
    [sym_undefined] = ACTIONS(2396),
    [anon_sym_AT] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_declare] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_module] = ACTIONS(2396),
    [anon_sym_any] = ACTIONS(2396),
    [anon_sym_number] = ACTIONS(2396),
    [anon_sym_boolean] = ACTIONS(2396),
    [anon_sym_string] = ACTIONS(2396),
    [anon_sym_symbol] = ACTIONS(2396),
    [anon_sym_implements] = ACTIONS(2396),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [sym_readonly] = ACTIONS(2396),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_export] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_typeof] = ACTIONS(2400),
    [anon_sym_import] = ACTIONS(2400),
    [anon_sym_var] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_else] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_RPAREN] = ACTIONS(2398),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_with] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_debugger] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_GT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2400),
    [anon_sym_EQ_GT] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_void] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym_number] = ACTIONS(2398),
    [sym_this] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [sym_null] = ACTIONS(2400),
    [sym_undefined] = ACTIONS(2400),
    [anon_sym_AT] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2400),
    [anon_sym_set] = ACTIONS(2400),
    [anon_sym_declare] = ACTIONS(2400),
    [anon_sym_public] = ACTIONS(2400),
    [anon_sym_private] = ACTIONS(2400),
    [anon_sym_protected] = ACTIONS(2400),
    [anon_sym_module] = ACTIONS(2400),
    [anon_sym_any] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2400),
    [anon_sym_string] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2400),
    [anon_sym_implements] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [sym_readonly] = ACTIONS(2400),
  },
  [424] = {
    [sym__call_signature] = STATE(3025),
    [sym_string] = STATE(2197),
    [sym_formal_parameters] = STATE(2527),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [sym_readonly] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_export] = ACTIONS(2432),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_EQ] = ACTIONS(2432),
    [anon_sym_namespace] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_type] = ACTIONS(2432),
    [anon_sym_typeof] = ACTIONS(2432),
    [anon_sym_import] = ACTIONS(2432),
    [anon_sym_var] = ACTIONS(2432),
    [anon_sym_let] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [anon_sym_if] = ACTIONS(2432),
    [anon_sym_else] = ACTIONS(2432),
    [anon_sym_switch] = ACTIONS(2432),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2430),
    [anon_sym_await] = ACTIONS(2432),
    [anon_sym_while] = ACTIONS(2432),
    [anon_sym_do] = ACTIONS(2432),
    [anon_sym_try] = ACTIONS(2432),
    [anon_sym_with] = ACTIONS(2432),
    [anon_sym_break] = ACTIONS(2432),
    [anon_sym_continue] = ACTIONS(2432),
    [anon_sym_debugger] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2432),
    [anon_sym_throw] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2432),
    [anon_sym_yield] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_function] = ACTIONS(2432),
    [anon_sym_EQ_GT] = ACTIONS(2430),
    [anon_sym_new] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [anon_sym_void] = ACTIONS(2432),
    [anon_sym_delete] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [sym_number] = ACTIONS(2430),
    [sym_this] = ACTIONS(2432),
    [sym_super] = ACTIONS(2432),
    [sym_true] = ACTIONS(2432),
    [sym_false] = ACTIONS(2432),
    [sym_null] = ACTIONS(2432),
    [sym_undefined] = ACTIONS(2432),
    [anon_sym_AT] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2432),
    [anon_sym_get] = ACTIONS(2432),
    [anon_sym_set] = ACTIONS(2432),
    [anon_sym_declare] = ACTIONS(2432),
    [anon_sym_public] = ACTIONS(2432),
    [anon_sym_private] = ACTIONS(2432),
    [anon_sym_protected] = ACTIONS(2432),
    [anon_sym_module] = ACTIONS(2432),
    [anon_sym_any] = ACTIONS(2432),
    [anon_sym_number] = ACTIONS(2432),
    [anon_sym_boolean] = ACTIONS(2432),
    [anon_sym_string] = ACTIONS(2432),
    [anon_sym_symbol] = ACTIONS(2432),
    [anon_sym_implements] = ACTIONS(2432),
    [anon_sym_interface] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
    [sym_readonly] = ACTIONS(2432),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(2434),
    [sym_identifier] = ACTIONS(2436),
    [anon_sym_export] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_EQ] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_type] = ACTIONS(2436),
    [anon_sym_typeof] = ACTIONS(2436),
    [anon_sym_import] = ACTIONS(2436),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_else] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2434),
    [anon_sym_await] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_with] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_debugger] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_yield] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_RBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_async] = ACTIONS(2436),
    [anon_sym_function] = ACTIONS(2436),
    [anon_sym_EQ_GT] = ACTIONS(2434),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [anon_sym_void] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [sym_number] = ACTIONS(2434),
    [sym_this] = ACTIONS(2436),
    [sym_super] = ACTIONS(2436),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [sym_null] = ACTIONS(2436),
    [sym_undefined] = ACTIONS(2436),
    [anon_sym_AT] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_abstract] = ACTIONS(2436),
    [anon_sym_get] = ACTIONS(2436),
    [anon_sym_set] = ACTIONS(2436),
    [anon_sym_declare] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(2436),
    [anon_sym_any] = ACTIONS(2436),
    [anon_sym_number] = ACTIONS(2436),
    [anon_sym_boolean] = ACTIONS(2436),
    [anon_sym_string] = ACTIONS(2436),
    [anon_sym_symbol] = ACTIONS(2436),
    [anon_sym_interface] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [sym_readonly] = ACTIONS(2436),
  },
  [427] = {
    [sym__call_signature] = STATE(3025),
    [sym_string] = STATE(2197),
    [sym_formal_parameters] = STATE(2527),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [sym_readonly] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [428] = {
    [sym__call_signature] = STATE(3025),
    [sym_string] = STATE(2197),
    [sym_formal_parameters] = STATE(2527),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [sym_readonly] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2440),
    [sym_identifier] = ACTIONS(2442),
    [anon_sym_export] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2442),
    [anon_sym_namespace] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_type] = ACTIONS(2442),
    [anon_sym_typeof] = ACTIONS(2442),
    [anon_sym_import] = ACTIONS(2442),
    [anon_sym_var] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_else] = ACTIONS(2442),
    [anon_sym_switch] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_RPAREN] = ACTIONS(2440),
    [anon_sym_await] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_do] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [anon_sym_with] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_debugger] = ACTIONS(2442),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_throw] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_case] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_RBRACK] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2442),
    [anon_sym_class] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_function] = ACTIONS(2442),
    [anon_sym_EQ_GT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_TILDE] = ACTIONS(2440),
    [anon_sym_void] = ACTIONS(2442),
    [anon_sym_delete] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [sym_number] = ACTIONS(2440),
    [sym_this] = ACTIONS(2442),
    [sym_super] = ACTIONS(2442),
    [sym_true] = ACTIONS(2442),
    [sym_false] = ACTIONS(2442),
    [sym_null] = ACTIONS(2442),
    [sym_undefined] = ACTIONS(2442),
    [anon_sym_AT] = ACTIONS(2440),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_abstract] = ACTIONS(2442),
    [anon_sym_get] = ACTIONS(2442),
    [anon_sym_set] = ACTIONS(2442),
    [anon_sym_declare] = ACTIONS(2442),
    [anon_sym_public] = ACTIONS(2442),
    [anon_sym_private] = ACTIONS(2442),
    [anon_sym_protected] = ACTIONS(2442),
    [anon_sym_module] = ACTIONS(2442),
    [anon_sym_any] = ACTIONS(2442),
    [anon_sym_number] = ACTIONS(2442),
    [anon_sym_boolean] = ACTIONS(2442),
    [anon_sym_string] = ACTIONS(2442),
    [anon_sym_symbol] = ACTIONS(2442),
    [anon_sym_interface] = ACTIONS(2442),
    [anon_sym_enum] = ACTIONS(2442),
    [sym_readonly] = ACTIONS(2442),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(2444),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_export] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_EQ] = ACTIONS(2446),
    [anon_sym_namespace] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_type] = ACTIONS(2446),
    [anon_sym_typeof] = ACTIONS(2446),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_var] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_else] = ACTIONS(2446),
    [anon_sym_switch] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2444),
    [anon_sym_await] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_do] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_debugger] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_throw] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_case] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_function] = ACTIONS(2446),
    [anon_sym_EQ_GT] = ACTIONS(2444),
    [anon_sym_new] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(2446),
    [anon_sym_delete] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2444),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [sym_number] = ACTIONS(2444),
    [sym_this] = ACTIONS(2446),
    [sym_super] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_null] = ACTIONS(2446),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_abstract] = ACTIONS(2446),
    [anon_sym_get] = ACTIONS(2446),
    [anon_sym_set] = ACTIONS(2446),
    [anon_sym_declare] = ACTIONS(2446),
    [anon_sym_public] = ACTIONS(2446),
    [anon_sym_private] = ACTIONS(2446),
    [anon_sym_protected] = ACTIONS(2446),
    [anon_sym_module] = ACTIONS(2446),
    [anon_sym_any] = ACTIONS(2446),
    [anon_sym_number] = ACTIONS(2446),
    [anon_sym_boolean] = ACTIONS(2446),
    [anon_sym_string] = ACTIONS(2446),
    [anon_sym_symbol] = ACTIONS(2446),
    [anon_sym_interface] = ACTIONS(2446),
    [anon_sym_enum] = ACTIONS(2446),
    [sym_readonly] = ACTIONS(2446),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym_identifier] = ACTIONS(2450),
    [anon_sym_export] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_namespace] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_type] = ACTIONS(2450),
    [anon_sym_typeof] = ACTIONS(2450),
    [anon_sym_import] = ACTIONS(2450),
    [anon_sym_var] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_else] = ACTIONS(2450),
    [anon_sym_switch] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_await] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_do] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [anon_sym_with] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_debugger] = ACTIONS(2450),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_throw] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_case] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2450),
    [anon_sym_class] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_function] = ACTIONS(2450),
    [anon_sym_EQ_GT] = ACTIONS(2448),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2448),
    [anon_sym_void] = ACTIONS(2450),
    [anon_sym_delete] = ACTIONS(2450),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_DQUOTE] = ACTIONS(2448),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2448),
    [sym_number] = ACTIONS(2448),
    [sym_this] = ACTIONS(2450),
    [sym_super] = ACTIONS(2450),
    [sym_true] = ACTIONS(2450),
    [sym_false] = ACTIONS(2450),
    [sym_null] = ACTIONS(2450),
    [sym_undefined] = ACTIONS(2450),
    [anon_sym_AT] = ACTIONS(2448),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_abstract] = ACTIONS(2450),
    [anon_sym_get] = ACTIONS(2450),
    [anon_sym_set] = ACTIONS(2450),
    [anon_sym_declare] = ACTIONS(2450),
    [anon_sym_public] = ACTIONS(2450),
    [anon_sym_private] = ACTIONS(2450),
    [anon_sym_protected] = ACTIONS(2450),
    [anon_sym_module] = ACTIONS(2450),
    [anon_sym_any] = ACTIONS(2450),
    [anon_sym_number] = ACTIONS(2450),
    [anon_sym_boolean] = ACTIONS(2450),
    [anon_sym_string] = ACTIONS(2450),
    [anon_sym_symbol] = ACTIONS(2450),
    [anon_sym_interface] = ACTIONS(2450),
    [anon_sym_enum] = ACTIONS(2450),
    [sym_readonly] = ACTIONS(2450),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2452),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2454),
    [anon_sym_var] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_else] = ACTIONS(2454),
    [anon_sym_switch] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_debugger] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_throw] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_case] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_class] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_EQ_GT] = ACTIONS(2452),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_void] = ACTIONS(2454),
    [anon_sym_delete] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [sym_number] = ACTIONS(2452),
    [sym_this] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_true] = ACTIONS(2454),
    [sym_false] = ACTIONS(2454),
    [sym_null] = ACTIONS(2454),
    [sym_undefined] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_abstract] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_interface] = ACTIONS(2454),
    [anon_sym_enum] = ACTIONS(2454),
    [sym_readonly] = ACTIONS(2454),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2456),
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_else] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2456),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_case] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_EQ_GT] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_TILDE] = ACTIONS(2456),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2456),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [sym_number] = ACTIONS(2456),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2456),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
    [sym_readonly] = ACTIONS(2458),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2460),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_export] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_type] = ACTIONS(2462),
    [anon_sym_typeof] = ACTIONS(2462),
    [anon_sym_import] = ACTIONS(2462),
    [anon_sym_var] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_else] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_debugger] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_RBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_EQ_GT] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2462),
    [sym_super] = ACTIONS(2462),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [sym_null] = ACTIONS(2462),
    [sym_undefined] = ACTIONS(2462),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_abstract] = ACTIONS(2462),
    [anon_sym_get] = ACTIONS(2462),
    [anon_sym_set] = ACTIONS(2462),
    [anon_sym_declare] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(2462),
    [anon_sym_any] = ACTIONS(2462),
    [anon_sym_number] = ACTIONS(2462),
    [anon_sym_boolean] = ACTIONS(2462),
    [anon_sym_string] = ACTIONS(2462),
    [anon_sym_symbol] = ACTIONS(2462),
    [anon_sym_interface] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [sym_readonly] = ACTIONS(2462),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_export] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_type] = ACTIONS(2466),
    [anon_sym_typeof] = ACTIONS(2466),
    [anon_sym_import] = ACTIONS(2466),
    [anon_sym_var] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_await] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_debugger] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_RBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_void] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym_number] = ACTIONS(2464),
    [sym_this] = ACTIONS(2466),
    [sym_super] = ACTIONS(2466),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [sym_null] = ACTIONS(2466),
    [sym_undefined] = ACTIONS(2466),
    [anon_sym_AT] = ACTIONS(2464),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_get] = ACTIONS(2466),
    [anon_sym_set] = ACTIONS(2466),
    [anon_sym_declare] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_module] = ACTIONS(2466),
    [anon_sym_any] = ACTIONS(2466),
    [anon_sym_number] = ACTIONS(2466),
    [anon_sym_boolean] = ACTIONS(2466),
    [anon_sym_string] = ACTIONS(2466),
    [anon_sym_symbol] = ACTIONS(2466),
    [anon_sym_interface] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [sym_readonly] = ACTIONS(2466),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(2468),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_export] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_import] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_else] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_RPAREN] = ACTIONS(2468),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_debugger] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_RBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_EQ_GT] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_void] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [sym_number] = ACTIONS(2468),
    [sym_this] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [sym_null] = ACTIONS(2470),
    [sym_undefined] = ACTIONS(2470),
    [anon_sym_AT] = ACTIONS(2468),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2470),
    [anon_sym_any] = ACTIONS(2470),
    [anon_sym_number] = ACTIONS(2470),
    [anon_sym_boolean] = ACTIONS(2470),
    [anon_sym_string] = ACTIONS(2470),
    [anon_sym_symbol] = ACTIONS(2470),
    [anon_sym_interface] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [sym_readonly] = ACTIONS(2470),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_export] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_import] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_debugger] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_EQ_GT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_void] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [sym_number] = ACTIONS(2472),
    [sym_this] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [sym_null] = ACTIONS(2474),
    [sym_undefined] = ACTIONS(2474),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_declare] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_module] = ACTIONS(2474),
    [anon_sym_any] = ACTIONS(2474),
    [anon_sym_number] = ACTIONS(2474),
    [anon_sym_boolean] = ACTIONS(2474),
    [anon_sym_string] = ACTIONS(2474),
    [anon_sym_symbol] = ACTIONS(2474),
    [anon_sym_interface] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [sym_readonly] = ACTIONS(2474),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(2476),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_export] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_import] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_with] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_debugger] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_GT] = ACTIONS(2476),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_function] = ACTIONS(2478),
    [anon_sym_EQ_GT] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym_number] = ACTIONS(2476),
    [sym_this] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_true] = ACTIONS(2478),
    [sym_false] = ACTIONS(2478),
    [sym_null] = ACTIONS(2478),
    [sym_undefined] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_declare] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_module] = ACTIONS(2478),
    [anon_sym_any] = ACTIONS(2478),
    [anon_sym_number] = ACTIONS(2478),
    [anon_sym_boolean] = ACTIONS(2478),
    [anon_sym_string] = ACTIONS(2478),
    [anon_sym_symbol] = ACTIONS(2478),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
    [sym_readonly] = ACTIONS(2478),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_RPAREN] = ACTIONS(2480),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_GT] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_EQ_GT] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym_number] = ACTIONS(2480),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [sym_readonly] = ACTIONS(2482),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2486),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_typeof] = ACTIONS(2488),
    [anon_sym_import] = ACTIONS(2488),
    [anon_sym_var] = ACTIONS(2488),
    [anon_sym_let] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_else] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [anon_sym_await] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_with] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_debugger] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_yield] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_RBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_function] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(2486),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [sym_number] = ACTIONS(2486),
    [sym_this] = ACTIONS(2488),
    [sym_super] = ACTIONS(2488),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [sym_null] = ACTIONS(2488),
    [sym_undefined] = ACTIONS(2488),
    [anon_sym_AT] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_abstract] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_interface] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2488),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2490),
    [sym_identifier] = ACTIONS(2492),
    [anon_sym_export] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2492),
    [anon_sym_typeof] = ACTIONS(2492),
    [anon_sym_import] = ACTIONS(2492),
    [anon_sym_var] = ACTIONS(2492),
    [anon_sym_let] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_else] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_await] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_with] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_debugger] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_yield] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_SLASH] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_async] = ACTIONS(2492),
    [anon_sym_function] = ACTIONS(2492),
    [anon_sym_EQ_GT] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_void] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2490),
    [sym_number] = ACTIONS(2490),
    [sym_this] = ACTIONS(2492),
    [sym_super] = ACTIONS(2492),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [sym_null] = ACTIONS(2492),
    [sym_undefined] = ACTIONS(2492),
    [anon_sym_AT] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_abstract] = ACTIONS(2492),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_module] = ACTIONS(2492),
    [anon_sym_any] = ACTIONS(2492),
    [anon_sym_number] = ACTIONS(2492),
    [anon_sym_boolean] = ACTIONS(2492),
    [anon_sym_string] = ACTIONS(2492),
    [anon_sym_symbol] = ACTIONS(2492),
    [anon_sym_interface] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [sym_readonly] = ACTIONS(2492),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(2494),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_export] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_EQ] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_type] = ACTIONS(2496),
    [anon_sym_typeof] = ACTIONS(2496),
    [anon_sym_import] = ACTIONS(2496),
    [anon_sym_var] = ACTIONS(2496),
    [anon_sym_let] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2494),
    [anon_sym_await] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_with] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_debugger] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_yield] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_RBRACK] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_SLASH] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_async] = ACTIONS(2496),
    [anon_sym_function] = ACTIONS(2496),
    [anon_sym_EQ_GT] = ACTIONS(2494),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_void] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2494),
    [sym_number] = ACTIONS(2494),
    [sym_this] = ACTIONS(2496),
    [sym_super] = ACTIONS(2496),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [sym_null] = ACTIONS(2496),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_AT] = ACTIONS(2494),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_abstract] = ACTIONS(2496),
    [anon_sym_get] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(2496),
    [anon_sym_declare] = ACTIONS(2496),
    [anon_sym_public] = ACTIONS(2496),
    [anon_sym_private] = ACTIONS(2496),
    [anon_sym_protected] = ACTIONS(2496),
    [anon_sym_module] = ACTIONS(2496),
    [anon_sym_any] = ACTIONS(2496),
    [anon_sym_number] = ACTIONS(2496),
    [anon_sym_boolean] = ACTIONS(2496),
    [anon_sym_string] = ACTIONS(2496),
    [anon_sym_symbol] = ACTIONS(2496),
    [anon_sym_interface] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [sym_readonly] = ACTIONS(2496),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(2498),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_export] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2500),
    [anon_sym_typeof] = ACTIONS(2500),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_var] = ACTIONS(2500),
    [anon_sym_let] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [anon_sym_await] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_with] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_debugger] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_yield] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_RBRACK] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2498),
    [anon_sym_GT] = ACTIONS(2498),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_async] = ACTIONS(2500),
    [anon_sym_function] = ACTIONS(2500),
    [anon_sym_EQ_GT] = ACTIONS(2498),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_void] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2498),
    [sym_number] = ACTIONS(2498),
    [sym_this] = ACTIONS(2500),
    [sym_super] = ACTIONS(2500),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [sym_null] = ACTIONS(2500),
    [sym_undefined] = ACTIONS(2500),
    [anon_sym_AT] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_abstract] = ACTIONS(2500),
    [anon_sym_get] = ACTIONS(2500),
    [anon_sym_set] = ACTIONS(2500),
    [anon_sym_declare] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_module] = ACTIONS(2500),
    [anon_sym_any] = ACTIONS(2500),
    [anon_sym_number] = ACTIONS(2500),
    [anon_sym_boolean] = ACTIONS(2500),
    [anon_sym_string] = ACTIONS(2500),
    [anon_sym_symbol] = ACTIONS(2500),
    [anon_sym_interface] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [sym_readonly] = ACTIONS(2500),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2504),
    [anon_sym_export] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2504),
    [anon_sym_import] = ACTIONS(2504),
    [anon_sym_var] = ACTIONS(2504),
    [anon_sym_let] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_with] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_debugger] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_yield] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_SLASH] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_async] = ACTIONS(2504),
    [anon_sym_function] = ACTIONS(2504),
    [anon_sym_EQ_GT] = ACTIONS(2502),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_void] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [sym_number] = ACTIONS(2502),
    [sym_this] = ACTIONS(2504),
    [sym_super] = ACTIONS(2504),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [sym_null] = ACTIONS(2504),
    [sym_undefined] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_abstract] = ACTIONS(2504),
    [anon_sym_get] = ACTIONS(2504),
    [anon_sym_set] = ACTIONS(2504),
    [anon_sym_declare] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_module] = ACTIONS(2504),
    [anon_sym_any] = ACTIONS(2504),
    [anon_sym_number] = ACTIONS(2504),
    [anon_sym_boolean] = ACTIONS(2504),
    [anon_sym_string] = ACTIONS(2504),
    [anon_sym_symbol] = ACTIONS(2504),
    [anon_sym_interface] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [sym_readonly] = ACTIONS(2504),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_export] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_type] = ACTIONS(2508),
    [anon_sym_typeof] = ACTIONS(2508),
    [anon_sym_import] = ACTIONS(2508),
    [anon_sym_var] = ACTIONS(2508),
    [anon_sym_let] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_await] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_with] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_debugger] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_async] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2508),
    [anon_sym_EQ_GT] = ACTIONS(2506),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_void] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [sym_number] = ACTIONS(2506),
    [sym_this] = ACTIONS(2508),
    [sym_super] = ACTIONS(2508),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [sym_null] = ACTIONS(2508),
    [sym_undefined] = ACTIONS(2508),
    [anon_sym_AT] = ACTIONS(2506),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_abstract] = ACTIONS(2508),
    [anon_sym_get] = ACTIONS(2508),
    [anon_sym_set] = ACTIONS(2508),
    [anon_sym_declare] = ACTIONS(2508),
    [anon_sym_public] = ACTIONS(2508),
    [anon_sym_private] = ACTIONS(2508),
    [anon_sym_protected] = ACTIONS(2508),
    [anon_sym_module] = ACTIONS(2508),
    [anon_sym_any] = ACTIONS(2508),
    [anon_sym_number] = ACTIONS(2508),
    [anon_sym_boolean] = ACTIONS(2508),
    [anon_sym_string] = ACTIONS(2508),
    [anon_sym_symbol] = ACTIONS(2508),
    [anon_sym_interface] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [sym_readonly] = ACTIONS(2508),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(617),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_type] = ACTIONS(2510),
    [anon_sym_typeof] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_var] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_await] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_with] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_debugger] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_async] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_EQ_GT] = ACTIONS(617),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [sym_number] = ACTIONS(617),
    [sym_this] = ACTIONS(2510),
    [sym_super] = ACTIONS(2510),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [sym_null] = ACTIONS(2510),
    [sym_undefined] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(617),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_get] = ACTIONS(2510),
    [anon_sym_set] = ACTIONS(2510),
    [anon_sym_declare] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_any] = ACTIONS(2510),
    [anon_sym_number] = ACTIONS(2510),
    [anon_sym_boolean] = ACTIONS(2510),
    [anon_sym_string] = ACTIONS(2510),
    [anon_sym_symbol] = ACTIONS(2510),
    [anon_sym_interface] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [sym_readonly] = ACTIONS(2510),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(2512),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_case] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_GT] = ACTIONS(2512),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_EQ_GT] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [sym_number] = ACTIONS(2512),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
    [sym_readonly] = ACTIONS(2514),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(2516),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_default] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2518),
    [anon_sym_namespace] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_type] = ACTIONS(2518),
    [anon_sym_typeof] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_var] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_switch] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_break] = ACTIONS(2518),
    [anon_sym_continue] = ACTIONS(2518),
    [anon_sym_debugger] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_throw] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_case] = ACTIONS(2518),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_GT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2518),
    [anon_sym_class] = ACTIONS(2518),
    [anon_sym_async] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_EQ_GT] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2518),
    [anon_sym_delete] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2518),
    [sym_super] = ACTIONS(2518),
    [sym_true] = ACTIONS(2518),
    [sym_false] = ACTIONS(2518),
    [sym_null] = ACTIONS(2518),
    [sym_undefined] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_get] = ACTIONS(2518),
    [anon_sym_set] = ACTIONS(2518),
    [anon_sym_declare] = ACTIONS(2518),
    [anon_sym_public] = ACTIONS(2518),
    [anon_sym_private] = ACTIONS(2518),
    [anon_sym_protected] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_any] = ACTIONS(2518),
    [anon_sym_number] = ACTIONS(2518),
    [anon_sym_boolean] = ACTIONS(2518),
    [anon_sym_string] = ACTIONS(2518),
    [anon_sym_symbol] = ACTIONS(2518),
    [anon_sym_interface] = ACTIONS(2518),
    [anon_sym_enum] = ACTIONS(2518),
    [sym_readonly] = ACTIONS(2518),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(2520),
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2522),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_namespace] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_type] = ACTIONS(2522),
    [anon_sym_typeof] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_var] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_switch] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_await] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_with] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_debugger] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_throw] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_case] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_EQ_GT] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2520),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_delete] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [sym_number] = ACTIONS(2520),
    [sym_this] = ACTIONS(2522),
    [sym_super] = ACTIONS(2522),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_null] = ACTIONS(2522),
    [sym_undefined] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_get] = ACTIONS(2522),
    [anon_sym_set] = ACTIONS(2522),
    [anon_sym_declare] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(2522),
    [anon_sym_private] = ACTIONS(2522),
    [anon_sym_protected] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_interface] = ACTIONS(2522),
    [anon_sym_enum] = ACTIONS(2522),
    [sym_readonly] = ACTIONS(2522),
  },
  [450] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [451] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [452] = {
    [sym_type_arguments] = STATE(425),
    [ts_builtin_sym_end] = ACTIONS(2532),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_default] = ACTIONS(2534),
    [anon_sym_namespace] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_type] = ACTIONS(2534),
    [anon_sym_typeof] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_var] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_switch] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_await] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_with] = ACTIONS(2534),
    [anon_sym_break] = ACTIONS(2534),
    [anon_sym_continue] = ACTIONS(2534),
    [anon_sym_debugger] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_throw] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2534),
    [anon_sym_yield] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2534),
    [anon_sym_async] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_new] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2532),
    [anon_sym_void] = ACTIONS(2534),
    [anon_sym_delete] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [sym_number] = ACTIONS(2532),
    [sym_this] = ACTIONS(2534),
    [sym_super] = ACTIONS(2534),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_get] = ACTIONS(2534),
    [anon_sym_set] = ACTIONS(2534),
    [anon_sym_declare] = ACTIONS(2534),
    [anon_sym_public] = ACTIONS(2534),
    [anon_sym_private] = ACTIONS(2534),
    [anon_sym_protected] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_any] = ACTIONS(2534),
    [anon_sym_number] = ACTIONS(2534),
    [anon_sym_boolean] = ACTIONS(2534),
    [anon_sym_string] = ACTIONS(2534),
    [anon_sym_symbol] = ACTIONS(2534),
    [anon_sym_interface] = ACTIONS(2534),
    [anon_sym_enum] = ACTIONS(2534),
    [sym_readonly] = ACTIONS(2534),
    [anon_sym_is] = ACTIONS(2539),
  },
  [453] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [454] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [455] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [456] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [457] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [458] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [459] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(2541),
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2543),
    [anon_sym_default] = ACTIONS(2543),
    [anon_sym_namespace] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_RBRACE] = ACTIONS(2541),
    [anon_sym_type] = ACTIONS(2543),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_import] = ACTIONS(2543),
    [anon_sym_var] = ACTIONS(2543),
    [anon_sym_let] = ACTIONS(2543),
    [anon_sym_const] = ACTIONS(2543),
    [anon_sym_if] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [anon_sym_switch] = ACTIONS(2543),
    [anon_sym_for] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_await] = ACTIONS(2543),
    [anon_sym_while] = ACTIONS(2543),
    [anon_sym_do] = ACTIONS(2543),
    [anon_sym_try] = ACTIONS(2543),
    [anon_sym_with] = ACTIONS(2543),
    [anon_sym_break] = ACTIONS(2543),
    [anon_sym_continue] = ACTIONS(2543),
    [anon_sym_debugger] = ACTIONS(2543),
    [anon_sym_return] = ACTIONS(2543),
    [anon_sym_throw] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(2541),
    [anon_sym_case] = ACTIONS(2543),
    [anon_sym_yield] = ACTIONS(2543),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(2541),
    [anon_sym_SLASH] = ACTIONS(2543),
    [anon_sym_class] = ACTIONS(2543),
    [anon_sym_async] = ACTIONS(2543),
    [anon_sym_function] = ACTIONS(2543),
    [anon_sym_new] = ACTIONS(2543),
    [anon_sym_AMP] = ACTIONS(2541),
    [anon_sym_PIPE] = ACTIONS(2541),
    [anon_sym_PLUS] = ACTIONS(2543),
    [anon_sym_DASH] = ACTIONS(2543),
    [anon_sym_BANG] = ACTIONS(2541),
    [anon_sym_TILDE] = ACTIONS(2541),
    [anon_sym_void] = ACTIONS(2543),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_PLUS_PLUS] = ACTIONS(2541),
    [anon_sym_DASH_DASH] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2541),
    [anon_sym_SQUOTE] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [sym_number] = ACTIONS(2541),
    [sym_this] = ACTIONS(2543),
    [sym_super] = ACTIONS(2543),
    [sym_true] = ACTIONS(2543),
    [sym_false] = ACTIONS(2543),
    [sym_null] = ACTIONS(2543),
    [sym_undefined] = ACTIONS(2543),
    [anon_sym_AT] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2543),
    [anon_sym_abstract] = ACTIONS(2543),
    [anon_sym_get] = ACTIONS(2543),
    [anon_sym_set] = ACTIONS(2543),
    [anon_sym_declare] = ACTIONS(2543),
    [anon_sym_public] = ACTIONS(2543),
    [anon_sym_private] = ACTIONS(2543),
    [anon_sym_protected] = ACTIONS(2543),
    [anon_sym_module] = ACTIONS(2543),
    [anon_sym_any] = ACTIONS(2543),
    [anon_sym_number] = ACTIONS(2543),
    [anon_sym_boolean] = ACTIONS(2543),
    [anon_sym_string] = ACTIONS(2543),
    [anon_sym_symbol] = ACTIONS(2543),
    [anon_sym_implements] = ACTIONS(2543),
    [anon_sym_interface] = ACTIONS(2543),
    [anon_sym_enum] = ACTIONS(2543),
    [sym_readonly] = ACTIONS(2543),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(2545),
    [sym_identifier] = ACTIONS(2547),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_default] = ACTIONS(2547),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_typeof] = ACTIONS(2547),
    [anon_sym_import] = ACTIONS(2547),
    [anon_sym_var] = ACTIONS(2547),
    [anon_sym_let] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(2547),
    [anon_sym_else] = ACTIONS(2547),
    [anon_sym_switch] = ACTIONS(2547),
    [anon_sym_for] = ACTIONS(2547),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_await] = ACTIONS(2547),
    [anon_sym_while] = ACTIONS(2547),
    [anon_sym_do] = ACTIONS(2547),
    [anon_sym_try] = ACTIONS(2547),
    [anon_sym_with] = ACTIONS(2547),
    [anon_sym_break] = ACTIONS(2547),
    [anon_sym_continue] = ACTIONS(2547),
    [anon_sym_debugger] = ACTIONS(2547),
    [anon_sym_return] = ACTIONS(2547),
    [anon_sym_throw] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2545),
    [anon_sym_case] = ACTIONS(2547),
    [anon_sym_yield] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_LT] = ACTIONS(2545),
    [anon_sym_SLASH] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_AMP] = ACTIONS(2545),
    [anon_sym_PIPE] = ACTIONS(2545),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2545),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_delete] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(2545),
    [anon_sym_DASH_DASH] = ACTIONS(2545),
    [anon_sym_DQUOTE] = ACTIONS(2545),
    [anon_sym_SQUOTE] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2545),
    [sym_number] = ACTIONS(2545),
    [sym_this] = ACTIONS(2547),
    [sym_super] = ACTIONS(2547),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [sym_null] = ACTIONS(2547),
    [sym_undefined] = ACTIONS(2547),
    [anon_sym_AT] = ACTIONS(2545),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_abstract] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
    [anon_sym_implements] = ACTIONS(2547),
    [anon_sym_interface] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [sym_readonly] = ACTIONS(2547),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_catch] = ACTIONS(1135),
    [anon_sym_finally] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(2549),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_catch] = ACTIONS(1105),
    [anon_sym_finally] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [464] = {
    [sym_catch_clause] = STATE(490),
    [sym_finally_clause] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(2551),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_export] = ACTIONS(2553),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2551),
    [anon_sym_type] = ACTIONS(2553),
    [anon_sym_typeof] = ACTIONS(2553),
    [anon_sym_import] = ACTIONS(2553),
    [anon_sym_var] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_else] = ACTIONS(2553),
    [anon_sym_switch] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_await] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_with] = ACTIONS(2553),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2553),
    [anon_sym_debugger] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_throw] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_case] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(2555),
    [anon_sym_finally] = ACTIONS(2557),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2551),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2551),
    [anon_sym_TILDE] = ACTIONS(2551),
    [anon_sym_void] = ACTIONS(2553),
    [anon_sym_delete] = ACTIONS(2553),
    [anon_sym_PLUS_PLUS] = ACTIONS(2551),
    [anon_sym_DASH_DASH] = ACTIONS(2551),
    [anon_sym_DQUOTE] = ACTIONS(2551),
    [anon_sym_SQUOTE] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2551),
    [sym_number] = ACTIONS(2551),
    [sym_this] = ACTIONS(2553),
    [sym_super] = ACTIONS(2553),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [sym_null] = ACTIONS(2553),
    [sym_undefined] = ACTIONS(2553),
    [anon_sym_AT] = ACTIONS(2551),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_abstract] = ACTIONS(2553),
    [anon_sym_get] = ACTIONS(2553),
    [anon_sym_set] = ACTIONS(2553),
    [anon_sym_declare] = ACTIONS(2553),
    [anon_sym_public] = ACTIONS(2553),
    [anon_sym_private] = ACTIONS(2553),
    [anon_sym_protected] = ACTIONS(2553),
    [anon_sym_module] = ACTIONS(2553),
    [anon_sym_any] = ACTIONS(2553),
    [anon_sym_number] = ACTIONS(2553),
    [anon_sym_boolean] = ACTIONS(2553),
    [anon_sym_string] = ACTIONS(2553),
    [anon_sym_symbol] = ACTIONS(2553),
    [anon_sym_interface] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [sym_readonly] = ACTIONS(2553),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(2559),
    [sym_identifier] = ACTIONS(2561),
    [anon_sym_export] = ACTIONS(2561),
    [anon_sym_default] = ACTIONS(2561),
    [anon_sym_namespace] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(2559),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_RBRACE] = ACTIONS(2559),
    [anon_sym_type] = ACTIONS(2561),
    [anon_sym_typeof] = ACTIONS(2561),
    [anon_sym_import] = ACTIONS(2561),
    [anon_sym_var] = ACTIONS(2561),
    [anon_sym_let] = ACTIONS(2561),
    [anon_sym_const] = ACTIONS(2561),
    [anon_sym_if] = ACTIONS(2561),
    [anon_sym_else] = ACTIONS(2561),
    [anon_sym_switch] = ACTIONS(2561),
    [anon_sym_for] = ACTIONS(2561),
    [anon_sym_LPAREN] = ACTIONS(2559),
    [anon_sym_await] = ACTIONS(2561),
    [anon_sym_while] = ACTIONS(2561),
    [anon_sym_do] = ACTIONS(2561),
    [anon_sym_try] = ACTIONS(2561),
    [anon_sym_with] = ACTIONS(2561),
    [anon_sym_break] = ACTIONS(2561),
    [anon_sym_continue] = ACTIONS(2561),
    [anon_sym_debugger] = ACTIONS(2561),
    [anon_sym_return] = ACTIONS(2561),
    [anon_sym_throw] = ACTIONS(2561),
    [anon_sym_SEMI] = ACTIONS(2559),
    [anon_sym_case] = ACTIONS(2561),
    [anon_sym_yield] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_SLASH] = ACTIONS(2561),
    [anon_sym_class] = ACTIONS(2561),
    [anon_sym_async] = ACTIONS(2561),
    [anon_sym_function] = ACTIONS(2561),
    [anon_sym_new] = ACTIONS(2561),
    [anon_sym_AMP] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2559),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_BANG] = ACTIONS(2559),
    [anon_sym_TILDE] = ACTIONS(2559),
    [anon_sym_void] = ACTIONS(2561),
    [anon_sym_delete] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(2559),
    [anon_sym_DASH_DASH] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2559),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2559),
    [sym_number] = ACTIONS(2559),
    [sym_this] = ACTIONS(2561),
    [sym_super] = ACTIONS(2561),
    [sym_true] = ACTIONS(2561),
    [sym_false] = ACTIONS(2561),
    [sym_null] = ACTIONS(2561),
    [sym_undefined] = ACTIONS(2561),
    [anon_sym_AT] = ACTIONS(2559),
    [anon_sym_static] = ACTIONS(2561),
    [anon_sym_abstract] = ACTIONS(2561),
    [anon_sym_get] = ACTIONS(2561),
    [anon_sym_set] = ACTIONS(2561),
    [anon_sym_declare] = ACTIONS(2561),
    [anon_sym_public] = ACTIONS(2561),
    [anon_sym_private] = ACTIONS(2561),
    [anon_sym_protected] = ACTIONS(2561),
    [anon_sym_module] = ACTIONS(2561),
    [anon_sym_any] = ACTIONS(2561),
    [anon_sym_number] = ACTIONS(2561),
    [anon_sym_boolean] = ACTIONS(2561),
    [anon_sym_string] = ACTIONS(2561),
    [anon_sym_symbol] = ACTIONS(2561),
    [anon_sym_implements] = ACTIONS(2561),
    [anon_sym_interface] = ACTIONS(2561),
    [anon_sym_enum] = ACTIONS(2561),
    [sym_readonly] = ACTIONS(2561),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1149),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1213),
    [sym__automatic_semicolon] = ACTIONS(1213),
  },
  [468] = {
    [sym__call_signature] = STATE(3113),
    [sym_arguments] = STATE(1033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [469] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2686),
    [sym_constructor_type] = STATE(2686),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2686),
    [sym_intersection_type] = STATE(2686),
    [sym_function_type] = STATE(2686),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(2601),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_catch] = ACTIONS(1215),
    [anon_sym_finally] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(1195),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(1237),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_var] = ACTIONS(1237),
    [anon_sym_let] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_with] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_debugger] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_yield] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1237),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_delete] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym_number] = ACTIONS(1235),
    [sym_this] = ACTIONS(1237),
    [sym_super] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [sym_null] = ACTIONS(1237),
    [sym_undefined] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1235),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_interface] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [sym_readonly] = ACTIONS(1237),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(2603),
  },
  [475] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(2605),
    [sym_identifier] = ACTIONS(2607),
    [anon_sym_export] = ACTIONS(2607),
    [anon_sym_default] = ACTIONS(2607),
    [anon_sym_namespace] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2607),
    [anon_sym_import] = ACTIONS(2607),
    [anon_sym_var] = ACTIONS(2607),
    [anon_sym_let] = ACTIONS(2607),
    [anon_sym_const] = ACTIONS(2607),
    [anon_sym_if] = ACTIONS(2607),
    [anon_sym_else] = ACTIONS(2607),
    [anon_sym_switch] = ACTIONS(2607),
    [anon_sym_for] = ACTIONS(2607),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_await] = ACTIONS(2607),
    [anon_sym_while] = ACTIONS(2607),
    [anon_sym_do] = ACTIONS(2607),
    [anon_sym_try] = ACTIONS(2607),
    [anon_sym_with] = ACTIONS(2607),
    [anon_sym_break] = ACTIONS(2607),
    [anon_sym_continue] = ACTIONS(2607),
    [anon_sym_debugger] = ACTIONS(2607),
    [anon_sym_return] = ACTIONS(2607),
    [anon_sym_throw] = ACTIONS(2607),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_case] = ACTIONS(2607),
    [anon_sym_yield] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2607),
    [anon_sym_DOT] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2607),
    [anon_sym_async] = ACTIONS(2607),
    [anon_sym_function] = ACTIONS(2607),
    [anon_sym_new] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2605),
    [anon_sym_TILDE] = ACTIONS(2605),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_delete] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2605),
    [anon_sym_DQUOTE] = ACTIONS(2605),
    [anon_sym_SQUOTE] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2605),
    [sym_number] = ACTIONS(2605),
    [sym_this] = ACTIONS(2607),
    [sym_super] = ACTIONS(2607),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_AT] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2607),
    [anon_sym_get] = ACTIONS(2607),
    [anon_sym_set] = ACTIONS(2607),
    [anon_sym_declare] = ACTIONS(2607),
    [anon_sym_public] = ACTIONS(2607),
    [anon_sym_private] = ACTIONS(2607),
    [anon_sym_protected] = ACTIONS(2607),
    [anon_sym_module] = ACTIONS(2607),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_interface] = ACTIONS(2607),
    [anon_sym_enum] = ACTIONS(2607),
    [sym_readonly] = ACTIONS(2607),
  },
  [477] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2747),
    [sym_constructor_type] = STATE(2747),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2747),
    [sym_intersection_type] = STATE(2747),
    [sym_function_type] = STATE(2747),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_catch] = ACTIONS(1135),
    [anon_sym_finally] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
  },
  [479] = {
    [sym_type_arguments] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(2611),
    [sym_identifier] = ACTIONS(2613),
    [anon_sym_export] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(2613),
    [anon_sym_typeof] = ACTIONS(2613),
    [anon_sym_import] = ACTIONS(2613),
    [anon_sym_var] = ACTIONS(2613),
    [anon_sym_let] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2613),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_await] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_with] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_debugger] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_yield] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_async] = ACTIONS(2613),
    [anon_sym_function] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_void] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2613),
    [sym_super] = ACTIONS(2613),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [sym_null] = ACTIONS(2613),
    [sym_undefined] = ACTIONS(2613),
    [anon_sym_AT] = ACTIONS(2611),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_get] = ACTIONS(2613),
    [anon_sym_set] = ACTIONS(2613),
    [anon_sym_declare] = ACTIONS(2613),
    [anon_sym_public] = ACTIONS(2613),
    [anon_sym_private] = ACTIONS(2613),
    [anon_sym_protected] = ACTIONS(2613),
    [anon_sym_module] = ACTIONS(2613),
    [anon_sym_any] = ACTIONS(2613),
    [anon_sym_number] = ACTIONS(2613),
    [anon_sym_boolean] = ACTIONS(2613),
    [anon_sym_string] = ACTIONS(2613),
    [anon_sym_symbol] = ACTIONS(2613),
    [anon_sym_interface] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [sym_readonly] = ACTIONS(2613),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [481] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2580),
    [sym_constructor_type] = STATE(2580),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2580),
    [sym_intersection_type] = STATE(2580),
    [sym_function_type] = STATE(2580),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [482] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2621),
    [sym_constructor_type] = STATE(2621),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2621),
    [sym_intersection_type] = STATE(2621),
    [sym_function_type] = STATE(2621),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [483] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_namespace] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2624),
    [anon_sym_typeof] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_var] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_switch] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_await] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_with] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_debugger] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_throw] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_async] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2624),
    [anon_sym_delete] = ACTIONS(2624),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [anon_sym_DQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [sym_number] = ACTIONS(2622),
    [sym_this] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_null] = ACTIONS(2624),
    [sym_undefined] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(2622),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_get] = ACTIONS(2624),
    [anon_sym_set] = ACTIONS(2624),
    [anon_sym_declare] = ACTIONS(2624),
    [anon_sym_public] = ACTIONS(2624),
    [anon_sym_private] = ACTIONS(2624),
    [anon_sym_protected] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_any] = ACTIONS(2624),
    [anon_sym_number] = ACTIONS(2624),
    [anon_sym_boolean] = ACTIONS(2624),
    [anon_sym_string] = ACTIONS(2624),
    [anon_sym_symbol] = ACTIONS(2624),
    [anon_sym_interface] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [sym_readonly] = ACTIONS(2624),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_namespace] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_type] = ACTIONS(2632),
    [anon_sym_typeof] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_var] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_switch] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_await] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_with] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_debugger] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_throw] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_async] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_void] = ACTIONS(2632),
    [anon_sym_delete] = ACTIONS(2632),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [sym_number] = ACTIONS(2630),
    [sym_this] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_null] = ACTIONS(2632),
    [sym_undefined] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_get] = ACTIONS(2632),
    [anon_sym_set] = ACTIONS(2632),
    [anon_sym_declare] = ACTIONS(2632),
    [anon_sym_public] = ACTIONS(2632),
    [anon_sym_private] = ACTIONS(2632),
    [anon_sym_protected] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_any] = ACTIONS(2632),
    [anon_sym_number] = ACTIONS(2632),
    [anon_sym_boolean] = ACTIONS(2632),
    [anon_sym_string] = ACTIONS(2632),
    [anon_sym_symbol] = ACTIONS(2632),
    [anon_sym_interface] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [sym_readonly] = ACTIONS(2632),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_namespace] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_type] = ACTIONS(2636),
    [anon_sym_typeof] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_var] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_switch] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_await] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_with] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_debugger] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_throw] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_async] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_void] = ACTIONS(2636),
    [anon_sym_delete] = ACTIONS(2636),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2634),
    [sym_number] = ACTIONS(2634),
    [sym_this] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [sym_null] = ACTIONS(2636),
    [sym_undefined] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2634),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_get] = ACTIONS(2636),
    [anon_sym_set] = ACTIONS(2636),
    [anon_sym_declare] = ACTIONS(2636),
    [anon_sym_public] = ACTIONS(2636),
    [anon_sym_private] = ACTIONS(2636),
    [anon_sym_protected] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_any] = ACTIONS(2636),
    [anon_sym_number] = ACTIONS(2636),
    [anon_sym_boolean] = ACTIONS(2636),
    [anon_sym_string] = ACTIONS(2636),
    [anon_sym_symbol] = ACTIONS(2636),
    [anon_sym_interface] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [sym_readonly] = ACTIONS(2636),
  },
  [487] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(2644),
    [sym_identifier] = ACTIONS(2646),
    [anon_sym_export] = ACTIONS(2646),
    [anon_sym_default] = ACTIONS(2646),
    [anon_sym_namespace] = ACTIONS(2646),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_type] = ACTIONS(2646),
    [anon_sym_typeof] = ACTIONS(2646),
    [anon_sym_import] = ACTIONS(2646),
    [anon_sym_var] = ACTIONS(2646),
    [anon_sym_let] = ACTIONS(2646),
    [anon_sym_const] = ACTIONS(2646),
    [anon_sym_if] = ACTIONS(2646),
    [anon_sym_else] = ACTIONS(2646),
    [anon_sym_switch] = ACTIONS(2646),
    [anon_sym_for] = ACTIONS(2646),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_await] = ACTIONS(2646),
    [anon_sym_while] = ACTIONS(2646),
    [anon_sym_do] = ACTIONS(2646),
    [anon_sym_try] = ACTIONS(2646),
    [anon_sym_with] = ACTIONS(2646),
    [anon_sym_break] = ACTIONS(2646),
    [anon_sym_continue] = ACTIONS(2646),
    [anon_sym_debugger] = ACTIONS(2646),
    [anon_sym_return] = ACTIONS(2646),
    [anon_sym_throw] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2646),
    [anon_sym_yield] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_class] = ACTIONS(2646),
    [anon_sym_async] = ACTIONS(2646),
    [anon_sym_function] = ACTIONS(2646),
    [anon_sym_new] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2644),
    [anon_sym_void] = ACTIONS(2646),
    [anon_sym_delete] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_SQUOTE] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [sym_number] = ACTIONS(2644),
    [sym_this] = ACTIONS(2646),
    [sym_super] = ACTIONS(2646),
    [sym_true] = ACTIONS(2646),
    [sym_false] = ACTIONS(2646),
    [sym_null] = ACTIONS(2646),
    [sym_undefined] = ACTIONS(2646),
    [anon_sym_AT] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2646),
    [anon_sym_abstract] = ACTIONS(2646),
    [anon_sym_get] = ACTIONS(2646),
    [anon_sym_set] = ACTIONS(2646),
    [anon_sym_declare] = ACTIONS(2646),
    [anon_sym_public] = ACTIONS(2646),
    [anon_sym_private] = ACTIONS(2646),
    [anon_sym_protected] = ACTIONS(2646),
    [anon_sym_module] = ACTIONS(2646),
    [anon_sym_any] = ACTIONS(2646),
    [anon_sym_number] = ACTIONS(2646),
    [anon_sym_boolean] = ACTIONS(2646),
    [anon_sym_string] = ACTIONS(2646),
    [anon_sym_symbol] = ACTIONS(2646),
    [anon_sym_interface] = ACTIONS(2646),
    [anon_sym_enum] = ACTIONS(2646),
    [sym_readonly] = ACTIONS(2646),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(2648),
    [sym_identifier] = ACTIONS(2650),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_default] = ACTIONS(2650),
    [anon_sym_namespace] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_type] = ACTIONS(2650),
    [anon_sym_typeof] = ACTIONS(2650),
    [anon_sym_import] = ACTIONS(2650),
    [anon_sym_var] = ACTIONS(2650),
    [anon_sym_let] = ACTIONS(2650),
    [anon_sym_const] = ACTIONS(2650),
    [anon_sym_if] = ACTIONS(2650),
    [anon_sym_else] = ACTIONS(2650),
    [anon_sym_switch] = ACTIONS(2650),
    [anon_sym_for] = ACTIONS(2650),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_await] = ACTIONS(2650),
    [anon_sym_while] = ACTIONS(2650),
    [anon_sym_do] = ACTIONS(2650),
    [anon_sym_try] = ACTIONS(2650),
    [anon_sym_with] = ACTIONS(2650),
    [anon_sym_break] = ACTIONS(2650),
    [anon_sym_continue] = ACTIONS(2650),
    [anon_sym_debugger] = ACTIONS(2650),
    [anon_sym_return] = ACTIONS(2650),
    [anon_sym_throw] = ACTIONS(2650),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2650),
    [anon_sym_yield] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_class] = ACTIONS(2650),
    [anon_sym_async] = ACTIONS(2650),
    [anon_sym_function] = ACTIONS(2650),
    [anon_sym_new] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_void] = ACTIONS(2650),
    [anon_sym_delete] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [anon_sym_DQUOTE] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2650),
    [sym_super] = ACTIONS(2650),
    [sym_true] = ACTIONS(2650),
    [sym_false] = ACTIONS(2650),
    [sym_null] = ACTIONS(2650),
    [sym_undefined] = ACTIONS(2650),
    [anon_sym_AT] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2650),
    [anon_sym_abstract] = ACTIONS(2650),
    [anon_sym_get] = ACTIONS(2650),
    [anon_sym_set] = ACTIONS(2650),
    [anon_sym_declare] = ACTIONS(2650),
    [anon_sym_public] = ACTIONS(2650),
    [anon_sym_private] = ACTIONS(2650),
    [anon_sym_protected] = ACTIONS(2650),
    [anon_sym_module] = ACTIONS(2650),
    [anon_sym_any] = ACTIONS(2650),
    [anon_sym_number] = ACTIONS(2650),
    [anon_sym_boolean] = ACTIONS(2650),
    [anon_sym_string] = ACTIONS(2650),
    [anon_sym_symbol] = ACTIONS(2650),
    [anon_sym_interface] = ACTIONS(2650),
    [anon_sym_enum] = ACTIONS(2650),
    [sym_readonly] = ACTIONS(2650),
  },
  [490] = {
    [sym_finally_clause] = STATE(536),
    [ts_builtin_sym_end] = ACTIONS(2652),
    [sym_identifier] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2654),
    [anon_sym_default] = ACTIONS(2654),
    [anon_sym_namespace] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_type] = ACTIONS(2654),
    [anon_sym_typeof] = ACTIONS(2654),
    [anon_sym_import] = ACTIONS(2654),
    [anon_sym_var] = ACTIONS(2654),
    [anon_sym_let] = ACTIONS(2654),
    [anon_sym_const] = ACTIONS(2654),
    [anon_sym_if] = ACTIONS(2654),
    [anon_sym_else] = ACTIONS(2654),
    [anon_sym_switch] = ACTIONS(2654),
    [anon_sym_for] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_await] = ACTIONS(2654),
    [anon_sym_while] = ACTIONS(2654),
    [anon_sym_do] = ACTIONS(2654),
    [anon_sym_try] = ACTIONS(2654),
    [anon_sym_with] = ACTIONS(2654),
    [anon_sym_break] = ACTIONS(2654),
    [anon_sym_continue] = ACTIONS(2654),
    [anon_sym_debugger] = ACTIONS(2654),
    [anon_sym_return] = ACTIONS(2654),
    [anon_sym_throw] = ACTIONS(2654),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2654),
    [anon_sym_finally] = ACTIONS(2557),
    [anon_sym_yield] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_LT] = ACTIONS(2652),
    [anon_sym_SLASH] = ACTIONS(2654),
    [anon_sym_class] = ACTIONS(2654),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_function] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2654),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2652),
    [anon_sym_TILDE] = ACTIONS(2652),
    [anon_sym_void] = ACTIONS(2654),
    [anon_sym_delete] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2652),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [sym_number] = ACTIONS(2652),
    [sym_this] = ACTIONS(2654),
    [sym_super] = ACTIONS(2654),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_null] = ACTIONS(2654),
    [sym_undefined] = ACTIONS(2654),
    [anon_sym_AT] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2654),
    [anon_sym_abstract] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2654),
    [anon_sym_public] = ACTIONS(2654),
    [anon_sym_private] = ACTIONS(2654),
    [anon_sym_protected] = ACTIONS(2654),
    [anon_sym_module] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2654),
    [anon_sym_number] = ACTIONS(2654),
    [anon_sym_boolean] = ACTIONS(2654),
    [anon_sym_string] = ACTIONS(2654),
    [anon_sym_symbol] = ACTIONS(2654),
    [anon_sym_interface] = ACTIONS(2654),
    [anon_sym_enum] = ACTIONS(2654),
    [sym_readonly] = ACTIONS(2654),
  },
  [491] = {
    [sym_statement_block] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
  },
  [492] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(2658),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_typeof] = ACTIONS(2660),
    [anon_sym_import] = ACTIONS(2660),
    [anon_sym_var] = ACTIONS(2660),
    [anon_sym_let] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_else] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_await] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_with] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_debugger] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_async] = ACTIONS(2660),
    [anon_sym_function] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_void] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [sym_number] = ACTIONS(2658),
    [sym_this] = ACTIONS(2660),
    [sym_super] = ACTIONS(2660),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [sym_null] = ACTIONS(2660),
    [sym_undefined] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(2658),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_abstract] = ACTIONS(2660),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_interface] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [sym_readonly] = ACTIONS(2660),
  },
  [494] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [495] = {
    [sym__call_signature] = STATE(3025),
    [sym_arguments] = STATE(1534),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1139),
    [sym_identifier] = ACTIONS(1141),
    [anon_sym_export] = ACTIONS(1141),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_namespace] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_type] = ACTIONS(1141),
    [anon_sym_typeof] = ACTIONS(1141),
    [anon_sym_import] = ACTIONS(1141),
    [anon_sym_var] = ACTIONS(1141),
    [anon_sym_let] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [anon_sym_await] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_try] = ACTIONS(1141),
    [anon_sym_with] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_debugger] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_yield] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_LT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1141),
    [anon_sym_class] = ACTIONS(1141),
    [anon_sym_async] = ACTIONS(1141),
    [anon_sym_function] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1141),
    [anon_sym_delete] = ACTIONS(1141),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1139),
    [sym_number] = ACTIONS(1139),
    [sym_this] = ACTIONS(1141),
    [sym_super] = ACTIONS(1141),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [sym_null] = ACTIONS(1141),
    [sym_undefined] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_abstract] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(1141),
    [anon_sym_set] = ACTIONS(1141),
    [anon_sym_declare] = ACTIONS(1141),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_module] = ACTIONS(1141),
    [anon_sym_any] = ACTIONS(1141),
    [anon_sym_number] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1141),
    [anon_sym_symbol] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [sym_readonly] = ACTIONS(1141),
    [sym__automatic_semicolon] = ACTIONS(1147),
  },
  [497] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2668),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [498] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2672),
    [anon_sym_export] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_type] = ACTIONS(2672),
    [anon_sym_typeof] = ACTIONS(2672),
    [anon_sym_import] = ACTIONS(2672),
    [anon_sym_var] = ACTIONS(2672),
    [anon_sym_let] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_else] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_RPAREN] = ACTIONS(2670),
    [anon_sym_await] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_with] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_debugger] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_SLASH] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_async] = ACTIONS(2672),
    [anon_sym_function] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_void] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2670),
    [sym_number] = ACTIONS(2670),
    [sym_this] = ACTIONS(2672),
    [sym_super] = ACTIONS(2672),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [sym_null] = ACTIONS(2672),
    [sym_undefined] = ACTIONS(2672),
    [anon_sym_AT] = ACTIONS(2670),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_abstract] = ACTIONS(2672),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2672),
    [anon_sym_public] = ACTIONS(2672),
    [anon_sym_private] = ACTIONS(2672),
    [anon_sym_protected] = ACTIONS(2672),
    [anon_sym_module] = ACTIONS(2672),
    [anon_sym_any] = ACTIONS(2672),
    [anon_sym_number] = ACTIONS(2672),
    [anon_sym_boolean] = ACTIONS(2672),
    [anon_sym_string] = ACTIONS(2672),
    [anon_sym_symbol] = ACTIONS(2672),
    [anon_sym_interface] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [sym_readonly] = ACTIONS(2672),
  },
  [500] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2668),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_import] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_do] = ACTIONS(1187),
    [anon_sym_try] = ACTIONS(1187),
    [anon_sym_with] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [anon_sym_debugger] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1187),
    [anon_sym_yield] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_class] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_new] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1185),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_void] = ACTIONS(1187),
    [anon_sym_delete] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_number] = ACTIONS(1185),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(1187),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(1187),
    [anon_sym_get] = ACTIONS(1187),
    [anon_sym_set] = ACTIONS(1187),
    [anon_sym_declare] = ACTIONS(1187),
    [anon_sym_public] = ACTIONS(1187),
    [anon_sym_private] = ACTIONS(1187),
    [anon_sym_protected] = ACTIONS(1187),
    [anon_sym_module] = ACTIONS(1187),
    [anon_sym_any] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_boolean] = ACTIONS(1187),
    [anon_sym_string] = ACTIONS(1187),
    [anon_sym_symbol] = ACTIONS(1187),
    [anon_sym_interface] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [sym_readonly] = ACTIONS(1187),
    [sym__automatic_semicolon] = ACTIONS(1193),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1153),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(1155),
    [anon_sym_default] = ACTIONS(1155),
    [anon_sym_namespace] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1153),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_type] = ACTIONS(1155),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(1155),
    [anon_sym_let] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1155),
    [anon_sym_else] = ACTIONS(1155),
    [anon_sym_switch] = ACTIONS(1155),
    [anon_sym_for] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_await] = ACTIONS(1155),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_do] = ACTIONS(1155),
    [anon_sym_try] = ACTIONS(1155),
    [anon_sym_with] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1155),
    [anon_sym_continue] = ACTIONS(1155),
    [anon_sym_debugger] = ACTIONS(1155),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_throw] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1153),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_class] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1155),
    [anon_sym_function] = ACTIONS(1155),
    [anon_sym_new] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_DQUOTE] = ACTIONS(1153),
    [anon_sym_SQUOTE] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1153),
    [sym_number] = ACTIONS(1153),
    [sym_this] = ACTIONS(1155),
    [sym_super] = ACTIONS(1155),
    [sym_true] = ACTIONS(1155),
    [sym_false] = ACTIONS(1155),
    [sym_null] = ACTIONS(1155),
    [sym_undefined] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1155),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_get] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1155),
    [anon_sym_declare] = ACTIONS(1155),
    [anon_sym_public] = ACTIONS(1155),
    [anon_sym_private] = ACTIONS(1155),
    [anon_sym_protected] = ACTIONS(1155),
    [anon_sym_module] = ACTIONS(1155),
    [anon_sym_any] = ACTIONS(1155),
    [anon_sym_number] = ACTIONS(1155),
    [anon_sym_boolean] = ACTIONS(1155),
    [anon_sym_string] = ACTIONS(1155),
    [anon_sym_symbol] = ACTIONS(1155),
    [anon_sym_interface] = ACTIONS(1155),
    [anon_sym_enum] = ACTIONS(1155),
    [sym_readonly] = ACTIONS(1155),
    [sym__automatic_semicolon] = ACTIONS(1161),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1171),
    [sym_identifier] = ACTIONS(1173),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_typeof] = ACTIONS(1173),
    [anon_sym_import] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_await] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_try] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_debugger] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_throw] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_class] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1173),
    [anon_sym_new] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_delete] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [sym_number] = ACTIONS(1171),
    [sym_this] = ACTIONS(1173),
    [sym_super] = ACTIONS(1173),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(1171),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_abstract] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_interface] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [sym_readonly] = ACTIONS(1173),
    [sym__automatic_semicolon] = ACTIONS(1179),
  },
  [504] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(2674),
    [sym_identifier] = ACTIONS(2676),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_type] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2676),
    [anon_sym_import] = ACTIONS(2676),
    [anon_sym_var] = ACTIONS(2676),
    [anon_sym_let] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_await] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_with] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_debugger] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_finally] = ACTIONS(2676),
    [anon_sym_yield] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_async] = ACTIONS(2676),
    [anon_sym_function] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_void] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2674),
    [sym_number] = ACTIONS(2674),
    [sym_this] = ACTIONS(2676),
    [sym_super] = ACTIONS(2676),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [sym_null] = ACTIONS(2676),
    [sym_undefined] = ACTIONS(2676),
    [anon_sym_AT] = ACTIONS(2674),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_abstract] = ACTIONS(2676),
    [anon_sym_get] = ACTIONS(2676),
    [anon_sym_set] = ACTIONS(2676),
    [anon_sym_declare] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2676),
    [anon_sym_any] = ACTIONS(2676),
    [anon_sym_number] = ACTIONS(2676),
    [anon_sym_boolean] = ACTIONS(2676),
    [anon_sym_string] = ACTIONS(2676),
    [anon_sym_symbol] = ACTIONS(2676),
    [anon_sym_interface] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [sym_readonly] = ACTIONS(2676),
  },
  [506] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1273),
    [anon_sym_export] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(1273),
    [anon_sym_import] = ACTIONS(1273),
    [anon_sym_var] = ACTIONS(1273),
    [anon_sym_let] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_await] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_try] = ACTIONS(1273),
    [anon_sym_with] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_debugger] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_class] = ACTIONS(1273),
    [anon_sym_async] = ACTIONS(1273),
    [anon_sym_function] = ACTIONS(1273),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_void] = ACTIONS(1273),
    [anon_sym_delete] = ACTIONS(1273),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [sym_number] = ACTIONS(1271),
    [sym_this] = ACTIONS(1273),
    [sym_super] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_undefined] = ACTIONS(1273),
    [anon_sym_AT] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_abstract] = ACTIONS(1273),
    [anon_sym_get] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(1273),
    [anon_sym_declare] = ACTIONS(1273),
    [anon_sym_public] = ACTIONS(1273),
    [anon_sym_private] = ACTIONS(1273),
    [anon_sym_protected] = ACTIONS(1273),
    [anon_sym_module] = ACTIONS(1273),
    [anon_sym_any] = ACTIONS(1273),
    [anon_sym_number] = ACTIONS(1273),
    [anon_sym_boolean] = ACTIONS(1273),
    [anon_sym_string] = ACTIONS(1273),
    [anon_sym_symbol] = ACTIONS(1273),
    [anon_sym_interface] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [sym_readonly] = ACTIONS(1273),
    [sym__automatic_semicolon] = ACTIONS(1279),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_export] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_type] = ACTIONS(1227),
    [anon_sym_typeof] = ACTIONS(1227),
    [anon_sym_import] = ACTIONS(1227),
    [anon_sym_var] = ACTIONS(1227),
    [anon_sym_let] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_await] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_try] = ACTIONS(1227),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_debugger] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_throw] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(1227),
    [anon_sym_async] = ACTIONS(1227),
    [anon_sym_function] = ACTIONS(1227),
    [anon_sym_new] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_TILDE] = ACTIONS(1225),
    [anon_sym_void] = ACTIONS(1227),
    [anon_sym_delete] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1225),
    [sym_this] = ACTIONS(1227),
    [sym_super] = ACTIONS(1227),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [sym_null] = ACTIONS(1227),
    [sym_undefined] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_abstract] = ACTIONS(1227),
    [anon_sym_get] = ACTIONS(1227),
    [anon_sym_set] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1227),
    [anon_sym_public] = ACTIONS(1227),
    [anon_sym_private] = ACTIONS(1227),
    [anon_sym_protected] = ACTIONS(1227),
    [anon_sym_module] = ACTIONS(1227),
    [anon_sym_any] = ACTIONS(1227),
    [anon_sym_number] = ACTIONS(1227),
    [anon_sym_boolean] = ACTIONS(1227),
    [anon_sym_string] = ACTIONS(1227),
    [anon_sym_symbol] = ACTIONS(1227),
    [anon_sym_interface] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [sym_readonly] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [509] = {
    [sym_statement_block] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
  },
  [510] = {
    [sym__call_signature] = STATE(3001),
    [sym_arguments] = STATE(1033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [anon_sym_implements] = ACTIONS(521),
    [sym_readonly] = ACTIONS(2680),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(2682),
    [sym_identifier] = ACTIONS(2684),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_typeof] = ACTIONS(2684),
    [anon_sym_import] = ACTIONS(2684),
    [anon_sym_var] = ACTIONS(2684),
    [anon_sym_let] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_else] = ACTIONS(2684),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(2682),
    [anon_sym_await] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_with] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_debugger] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_finally] = ACTIONS(2684),
    [anon_sym_yield] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2682),
    [anon_sym_LT] = ACTIONS(2682),
    [anon_sym_SLASH] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_async] = ACTIONS(2684),
    [anon_sym_function] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2682),
    [anon_sym_void] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_PLUS_PLUS] = ACTIONS(2682),
    [anon_sym_DASH_DASH] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2682),
    [sym_number] = ACTIONS(2682),
    [sym_this] = ACTIONS(2684),
    [sym_super] = ACTIONS(2684),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [sym_null] = ACTIONS(2684),
    [sym_undefined] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2682),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_abstract] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2684),
    [anon_sym_set] = ACTIONS(2684),
    [anon_sym_declare] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(2684),
    [anon_sym_number] = ACTIONS(2684),
    [anon_sym_boolean] = ACTIONS(2684),
    [anon_sym_string] = ACTIONS(2684),
    [anon_sym_symbol] = ACTIONS(2684),
    [anon_sym_interface] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [sym_readonly] = ACTIONS(2684),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1123),
    [sym_identifier] = ACTIONS(1125),
    [anon_sym_export] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1125),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_type] = ACTIONS(1125),
    [anon_sym_typeof] = ACTIONS(1125),
    [anon_sym_import] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(1125),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_const] = ACTIONS(1125),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1125),
    [anon_sym_switch] = ACTIONS(1125),
    [anon_sym_for] = ACTIONS(1125),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_await] = ACTIONS(1125),
    [anon_sym_while] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_with] = ACTIONS(1125),
    [anon_sym_break] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1125),
    [anon_sym_debugger] = ACTIONS(1125),
    [anon_sym_return] = ACTIONS(1125),
    [anon_sym_throw] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_yield] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_class] = ACTIONS(1125),
    [anon_sym_async] = ACTIONS(1125),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_new] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_TILDE] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym_number] = ACTIONS(1123),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1125),
    [anon_sym_abstract] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1125),
    [anon_sym_set] = ACTIONS(1125),
    [anon_sym_declare] = ACTIONS(1125),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_module] = ACTIONS(1125),
    [anon_sym_any] = ACTIONS(1125),
    [anon_sym_number] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1125),
    [anon_sym_symbol] = ACTIONS(1125),
    [anon_sym_interface] = ACTIONS(1125),
    [anon_sym_enum] = ACTIONS(1125),
    [sym_readonly] = ACTIONS(1125),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_type] = ACTIONS(1263),
    [anon_sym_typeof] = ACTIONS(1263),
    [anon_sym_import] = ACTIONS(1263),
    [anon_sym_var] = ACTIONS(1263),
    [anon_sym_let] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_await] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1263),
    [anon_sym_with] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_debugger] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_throw] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_yield] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_class] = ACTIONS(1263),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_function] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_delete] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [sym_number] = ACTIONS(1261),
    [sym_this] = ACTIONS(1263),
    [sym_super] = ACTIONS(1263),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_undefined] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_abstract] = ACTIONS(1263),
    [anon_sym_get] = ACTIONS(1263),
    [anon_sym_set] = ACTIONS(1263),
    [anon_sym_declare] = ACTIONS(1263),
    [anon_sym_public] = ACTIONS(1263),
    [anon_sym_private] = ACTIONS(1263),
    [anon_sym_protected] = ACTIONS(1263),
    [anon_sym_module] = ACTIONS(1263),
    [anon_sym_any] = ACTIONS(1263),
    [anon_sym_number] = ACTIONS(1263),
    [anon_sym_boolean] = ACTIONS(1263),
    [anon_sym_string] = ACTIONS(1263),
    [anon_sym_symbol] = ACTIONS(1263),
    [anon_sym_interface] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [sym_readonly] = ACTIONS(1263),
    [sym__automatic_semicolon] = ACTIONS(1269),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_debugger] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [sym_this] = ACTIONS(1253),
    [sym_super] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1251),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [sym_readonly] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1259),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_default] = ACTIONS(1243),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_do] = ACTIONS(1243),
    [anon_sym_try] = ACTIONS(1243),
    [anon_sym_with] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1243),
    [anon_sym_continue] = ACTIONS(1243),
    [anon_sym_debugger] = ACTIONS(1243),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_throw] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_class] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1243),
    [anon_sym_new] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1243),
    [anon_sym_delete] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_null] = ACTIONS(1243),
    [sym_undefined] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1243),
    [anon_sym_get] = ACTIONS(1243),
    [anon_sym_set] = ACTIONS(1243),
    [anon_sym_declare] = ACTIONS(1243),
    [anon_sym_public] = ACTIONS(1243),
    [anon_sym_private] = ACTIONS(1243),
    [anon_sym_protected] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1243),
    [anon_sym_number] = ACTIONS(1243),
    [anon_sym_boolean] = ACTIONS(1243),
    [anon_sym_string] = ACTIONS(1243),
    [anon_sym_symbol] = ACTIONS(1243),
    [anon_sym_interface] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(1243),
    [sym__automatic_semicolon] = ACTIONS(1249),
  },
  [516] = {
    [sym__call_signature] = STATE(3033),
    [sym_arguments] = STATE(1033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_export] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_RBRACE] = ACTIONS(2690),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_typeof] = ACTIONS(2692),
    [anon_sym_import] = ACTIONS(2692),
    [anon_sym_var] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_await] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_with] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_debugger] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_finally] = ACTIONS(2692),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_async] = ACTIONS(2692),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_void] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [sym_number] = ACTIONS(2690),
    [sym_this] = ACTIONS(2692),
    [sym_super] = ACTIONS(2692),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [sym_null] = ACTIONS(2692),
    [sym_undefined] = ACTIONS(2692),
    [anon_sym_AT] = ACTIONS(2690),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_abstract] = ACTIONS(2692),
    [anon_sym_get] = ACTIONS(2692),
    [anon_sym_set] = ACTIONS(2692),
    [anon_sym_declare] = ACTIONS(2692),
    [anon_sym_public] = ACTIONS(2692),
    [anon_sym_private] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_any] = ACTIONS(2692),
    [anon_sym_number] = ACTIONS(2692),
    [anon_sym_boolean] = ACTIONS(2692),
    [anon_sym_string] = ACTIONS(2692),
    [anon_sym_symbol] = ACTIONS(2692),
    [anon_sym_interface] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [sym_readonly] = ACTIONS(2692),
  },
  [518] = {
    [sym__call_signature] = STATE(2989),
    [sym_arguments] = STATE(1589),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2696),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2696),
    [anon_sym_function] = ACTIONS(2700),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2696),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_get] = ACTIONS(2696),
    [anon_sym_set] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2696),
    [anon_sym_private] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(2696),
    [anon_sym_number] = ACTIONS(2696),
    [anon_sym_boolean] = ACTIONS(2696),
    [anon_sym_string] = ACTIONS(2696),
    [anon_sym_symbol] = ACTIONS(2696),
    [sym_readonly] = ACTIONS(2696),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(2702),
    [sym_identifier] = ACTIONS(2704),
    [anon_sym_export] = ACTIONS(2704),
    [anon_sym_default] = ACTIONS(2704),
    [anon_sym_namespace] = ACTIONS(2704),
    [anon_sym_LBRACE] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_type] = ACTIONS(2704),
    [anon_sym_typeof] = ACTIONS(2704),
    [anon_sym_import] = ACTIONS(2704),
    [anon_sym_var] = ACTIONS(2704),
    [anon_sym_let] = ACTIONS(2704),
    [anon_sym_const] = ACTIONS(2704),
    [anon_sym_if] = ACTIONS(2704),
    [anon_sym_else] = ACTIONS(2704),
    [anon_sym_switch] = ACTIONS(2704),
    [anon_sym_for] = ACTIONS(2704),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_await] = ACTIONS(2704),
    [anon_sym_while] = ACTIONS(2704),
    [anon_sym_do] = ACTIONS(2704),
    [anon_sym_try] = ACTIONS(2704),
    [anon_sym_with] = ACTIONS(2704),
    [anon_sym_break] = ACTIONS(2704),
    [anon_sym_continue] = ACTIONS(2704),
    [anon_sym_debugger] = ACTIONS(2704),
    [anon_sym_return] = ACTIONS(2704),
    [anon_sym_throw] = ACTIONS(2704),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_case] = ACTIONS(2704),
    [anon_sym_yield] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2704),
    [anon_sym_class] = ACTIONS(2704),
    [anon_sym_async] = ACTIONS(2704),
    [anon_sym_function] = ACTIONS(2704),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_TILDE] = ACTIONS(2702),
    [anon_sym_void] = ACTIONS(2704),
    [anon_sym_delete] = ACTIONS(2704),
    [anon_sym_PLUS_PLUS] = ACTIONS(2702),
    [anon_sym_DASH_DASH] = ACTIONS(2702),
    [anon_sym_DQUOTE] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2702),
    [sym_number] = ACTIONS(2702),
    [sym_this] = ACTIONS(2704),
    [sym_super] = ACTIONS(2704),
    [sym_true] = ACTIONS(2704),
    [sym_false] = ACTIONS(2704),
    [sym_null] = ACTIONS(2704),
    [sym_undefined] = ACTIONS(2704),
    [anon_sym_AT] = ACTIONS(2702),
    [anon_sym_static] = ACTIONS(2704),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_get] = ACTIONS(2704),
    [anon_sym_set] = ACTIONS(2704),
    [anon_sym_declare] = ACTIONS(2704),
    [anon_sym_public] = ACTIONS(2704),
    [anon_sym_private] = ACTIONS(2704),
    [anon_sym_protected] = ACTIONS(2704),
    [anon_sym_module] = ACTIONS(2704),
    [anon_sym_any] = ACTIONS(2704),
    [anon_sym_number] = ACTIONS(2704),
    [anon_sym_boolean] = ACTIONS(2704),
    [anon_sym_string] = ACTIONS(2704),
    [anon_sym_symbol] = ACTIONS(2704),
    [anon_sym_interface] = ACTIONS(2704),
    [anon_sym_enum] = ACTIONS(2704),
    [sym_readonly] = ACTIONS(2704),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(1115),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_namespace] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1115),
    [anon_sym_typeof] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_var] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_do] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_debugger] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_throw] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_case] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1115),
    [anon_sym_delete] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_number] = ACTIONS(1113),
    [sym_this] = ACTIONS(1115),
    [sym_super] = ACTIONS(1115),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_undefined] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1115),
    [anon_sym_abstract] = ACTIONS(1115),
    [anon_sym_get] = ACTIONS(1115),
    [anon_sym_set] = ACTIONS(1115),
    [anon_sym_declare] = ACTIONS(1115),
    [anon_sym_public] = ACTIONS(1115),
    [anon_sym_private] = ACTIONS(1115),
    [anon_sym_protected] = ACTIONS(1115),
    [anon_sym_module] = ACTIONS(1115),
    [anon_sym_any] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_boolean] = ACTIONS(1115),
    [anon_sym_string] = ACTIONS(1115),
    [anon_sym_symbol] = ACTIONS(1115),
    [anon_sym_interface] = ACTIONS(1115),
    [anon_sym_enum] = ACTIONS(1115),
    [sym_readonly] = ACTIONS(1115),
    [sym__automatic_semicolon] = ACTIONS(1121),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(2706),
    [sym_identifier] = ACTIONS(2708),
    [anon_sym_export] = ACTIONS(2708),
    [anon_sym_default] = ACTIONS(2708),
    [anon_sym_namespace] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(2706),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_type] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2708),
    [anon_sym_import] = ACTIONS(2708),
    [anon_sym_var] = ACTIONS(2708),
    [anon_sym_let] = ACTIONS(2708),
    [anon_sym_const] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2708),
    [anon_sym_else] = ACTIONS(2708),
    [anon_sym_switch] = ACTIONS(2708),
    [anon_sym_for] = ACTIONS(2708),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_await] = ACTIONS(2708),
    [anon_sym_while] = ACTIONS(2708),
    [anon_sym_do] = ACTIONS(2708),
    [anon_sym_try] = ACTIONS(2708),
    [anon_sym_with] = ACTIONS(2708),
    [anon_sym_break] = ACTIONS(2708),
    [anon_sym_continue] = ACTIONS(2708),
    [anon_sym_debugger] = ACTIONS(2708),
    [anon_sym_return] = ACTIONS(2708),
    [anon_sym_throw] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_case] = ACTIONS(2708),
    [anon_sym_finally] = ACTIONS(2708),
    [anon_sym_yield] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2706),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_class] = ACTIONS(2708),
    [anon_sym_async] = ACTIONS(2708),
    [anon_sym_function] = ACTIONS(2708),
    [anon_sym_new] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_BANG] = ACTIONS(2706),
    [anon_sym_TILDE] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2708),
    [anon_sym_delete] = ACTIONS(2708),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_DQUOTE] = ACTIONS(2706),
    [anon_sym_SQUOTE] = ACTIONS(2706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2706),
    [sym_number] = ACTIONS(2706),
    [sym_this] = ACTIONS(2708),
    [sym_super] = ACTIONS(2708),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_null] = ACTIONS(2708),
    [sym_undefined] = ACTIONS(2708),
    [anon_sym_AT] = ACTIONS(2706),
    [anon_sym_static] = ACTIONS(2708),
    [anon_sym_abstract] = ACTIONS(2708),
    [anon_sym_get] = ACTIONS(2708),
    [anon_sym_set] = ACTIONS(2708),
    [anon_sym_declare] = ACTIONS(2708),
    [anon_sym_public] = ACTIONS(2708),
    [anon_sym_private] = ACTIONS(2708),
    [anon_sym_protected] = ACTIONS(2708),
    [anon_sym_module] = ACTIONS(2708),
    [anon_sym_any] = ACTIONS(2708),
    [anon_sym_number] = ACTIONS(2708),
    [anon_sym_boolean] = ACTIONS(2708),
    [anon_sym_string] = ACTIONS(2708),
    [anon_sym_symbol] = ACTIONS(2708),
    [anon_sym_interface] = ACTIONS(2708),
    [anon_sym_enum] = ACTIONS(2708),
    [sym_readonly] = ACTIONS(2708),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_default] = ACTIONS(2712),
    [anon_sym_namespace] = ACTIONS(2712),
    [anon_sym_LBRACE] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_type] = ACTIONS(2712),
    [anon_sym_typeof] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_var] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_else] = ACTIONS(2712),
    [anon_sym_switch] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [anon_sym_do] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_with] = ACTIONS(2712),
    [anon_sym_break] = ACTIONS(2712),
    [anon_sym_continue] = ACTIONS(2712),
    [anon_sym_debugger] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_throw] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2710),
    [anon_sym_case] = ACTIONS(2712),
    [anon_sym_yield] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2710),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_SLASH] = ACTIONS(2712),
    [anon_sym_class] = ACTIONS(2712),
    [anon_sym_async] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_new] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2712),
    [anon_sym_BANG] = ACTIONS(2710),
    [anon_sym_TILDE] = ACTIONS(2710),
    [anon_sym_void] = ACTIONS(2712),
    [anon_sym_delete] = ACTIONS(2712),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_SQUOTE] = ACTIONS(2710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [sym_number] = ACTIONS(2710),
    [sym_this] = ACTIONS(2712),
    [sym_super] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_null] = ACTIONS(2712),
    [sym_undefined] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2710),
    [anon_sym_static] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_get] = ACTIONS(2712),
    [anon_sym_set] = ACTIONS(2712),
    [anon_sym_declare] = ACTIONS(2712),
    [anon_sym_public] = ACTIONS(2712),
    [anon_sym_private] = ACTIONS(2712),
    [anon_sym_protected] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_any] = ACTIONS(2712),
    [anon_sym_number] = ACTIONS(2712),
    [anon_sym_boolean] = ACTIONS(2712),
    [anon_sym_string] = ACTIONS(2712),
    [anon_sym_symbol] = ACTIONS(2712),
    [anon_sym_interface] = ACTIONS(2712),
    [anon_sym_enum] = ACTIONS(2712),
    [sym_readonly] = ACTIONS(2712),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(2714),
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_default] = ACTIONS(2716),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_LBRACE] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_var] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_switch] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_await] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [anon_sym_do] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_with] = ACTIONS(2716),
    [anon_sym_break] = ACTIONS(2716),
    [anon_sym_continue] = ACTIONS(2716),
    [anon_sym_debugger] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_throw] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_case] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2716),
    [anon_sym_class] = ACTIONS(2716),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2714),
    [anon_sym_void] = ACTIONS(2716),
    [anon_sym_delete] = ACTIONS(2716),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_DQUOTE] = ACTIONS(2714),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [sym_number] = ACTIONS(2714),
    [sym_this] = ACTIONS(2716),
    [sym_super] = ACTIONS(2716),
    [sym_true] = ACTIONS(2716),
    [sym_false] = ACTIONS(2716),
    [sym_null] = ACTIONS(2716),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2714),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2716),
    [anon_sym_set] = ACTIONS(2716),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_interface] = ACTIONS(2716),
    [anon_sym_enum] = ACTIONS(2716),
    [sym_readonly] = ACTIONS(2716),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(2718),
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_default] = ACTIONS(2720),
    [anon_sym_namespace] = ACTIONS(2720),
    [anon_sym_LBRACE] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2720),
    [anon_sym_typeof] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_var] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_else] = ACTIONS(2720),
    [anon_sym_switch] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [anon_sym_do] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_with] = ACTIONS(2720),
    [anon_sym_break] = ACTIONS(2720),
    [anon_sym_continue] = ACTIONS(2720),
    [anon_sym_debugger] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_throw] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_case] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_class] = ACTIONS(2720),
    [anon_sym_async] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_new] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2720),
    [anon_sym_BANG] = ACTIONS(2718),
    [anon_sym_TILDE] = ACTIONS(2718),
    [anon_sym_void] = ACTIONS(2720),
    [anon_sym_delete] = ACTIONS(2720),
    [anon_sym_PLUS_PLUS] = ACTIONS(2718),
    [anon_sym_DASH_DASH] = ACTIONS(2718),
    [anon_sym_DQUOTE] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(2718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [sym_number] = ACTIONS(2718),
    [sym_this] = ACTIONS(2720),
    [sym_super] = ACTIONS(2720),
    [sym_true] = ACTIONS(2720),
    [sym_false] = ACTIONS(2720),
    [sym_null] = ACTIONS(2720),
    [sym_undefined] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2718),
    [anon_sym_static] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_get] = ACTIONS(2720),
    [anon_sym_set] = ACTIONS(2720),
    [anon_sym_declare] = ACTIONS(2720),
    [anon_sym_public] = ACTIONS(2720),
    [anon_sym_private] = ACTIONS(2720),
    [anon_sym_protected] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_any] = ACTIONS(2720),
    [anon_sym_number] = ACTIONS(2720),
    [anon_sym_boolean] = ACTIONS(2720),
    [anon_sym_string] = ACTIONS(2720),
    [anon_sym_symbol] = ACTIONS(2720),
    [anon_sym_interface] = ACTIONS(2720),
    [anon_sym_enum] = ACTIONS(2720),
    [sym_readonly] = ACTIONS(2720),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(2722),
    [sym_identifier] = ACTIONS(2724),
    [anon_sym_export] = ACTIONS(2724),
    [anon_sym_default] = ACTIONS(2724),
    [anon_sym_namespace] = ACTIONS(2724),
    [anon_sym_LBRACE] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_type] = ACTIONS(2724),
    [anon_sym_typeof] = ACTIONS(2724),
    [anon_sym_import] = ACTIONS(2724),
    [anon_sym_var] = ACTIONS(2724),
    [anon_sym_let] = ACTIONS(2724),
    [anon_sym_const] = ACTIONS(2724),
    [anon_sym_if] = ACTIONS(2724),
    [anon_sym_else] = ACTIONS(2724),
    [anon_sym_switch] = ACTIONS(2724),
    [anon_sym_for] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_await] = ACTIONS(2724),
    [anon_sym_while] = ACTIONS(2724),
    [anon_sym_do] = ACTIONS(2724),
    [anon_sym_try] = ACTIONS(2724),
    [anon_sym_with] = ACTIONS(2724),
    [anon_sym_break] = ACTIONS(2724),
    [anon_sym_continue] = ACTIONS(2724),
    [anon_sym_debugger] = ACTIONS(2724),
    [anon_sym_return] = ACTIONS(2724),
    [anon_sym_throw] = ACTIONS(2724),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_case] = ACTIONS(2724),
    [anon_sym_yield] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(2724),
    [anon_sym_class] = ACTIONS(2724),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(2724),
    [anon_sym_new] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2724),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_BANG] = ACTIONS(2722),
    [anon_sym_TILDE] = ACTIONS(2722),
    [anon_sym_void] = ACTIONS(2724),
    [anon_sym_delete] = ACTIONS(2724),
    [anon_sym_PLUS_PLUS] = ACTIONS(2722),
    [anon_sym_DASH_DASH] = ACTIONS(2722),
    [anon_sym_DQUOTE] = ACTIONS(2722),
    [anon_sym_SQUOTE] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2722),
    [sym_number] = ACTIONS(2722),
    [sym_this] = ACTIONS(2724),
    [sym_super] = ACTIONS(2724),
    [sym_true] = ACTIONS(2724),
    [sym_false] = ACTIONS(2724),
    [sym_null] = ACTIONS(2724),
    [sym_undefined] = ACTIONS(2724),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2724),
    [anon_sym_abstract] = ACTIONS(2724),
    [anon_sym_get] = ACTIONS(2724),
    [anon_sym_set] = ACTIONS(2724),
    [anon_sym_declare] = ACTIONS(2724),
    [anon_sym_public] = ACTIONS(2724),
    [anon_sym_private] = ACTIONS(2724),
    [anon_sym_protected] = ACTIONS(2724),
    [anon_sym_module] = ACTIONS(2724),
    [anon_sym_any] = ACTIONS(2724),
    [anon_sym_number] = ACTIONS(2724),
    [anon_sym_boolean] = ACTIONS(2724),
    [anon_sym_string] = ACTIONS(2724),
    [anon_sym_symbol] = ACTIONS(2724),
    [anon_sym_interface] = ACTIONS(2724),
    [anon_sym_enum] = ACTIONS(2724),
    [sym_readonly] = ACTIONS(2724),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(2726),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_default] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_typeof] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_var] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2728),
    [anon_sym_switch] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_await] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [anon_sym_do] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_with] = ACTIONS(2728),
    [anon_sym_break] = ACTIONS(2728),
    [anon_sym_continue] = ACTIONS(2728),
    [anon_sym_debugger] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_throw] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_case] = ACTIONS(2728),
    [anon_sym_yield] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_SLASH] = ACTIONS(2728),
    [anon_sym_class] = ACTIONS(2728),
    [anon_sym_async] = ACTIONS(2728),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2726),
    [anon_sym_void] = ACTIONS(2728),
    [anon_sym_delete] = ACTIONS(2728),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [anon_sym_SQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_number] = ACTIONS(2726),
    [sym_this] = ACTIONS(2728),
    [sym_super] = ACTIONS(2728),
    [sym_true] = ACTIONS(2728),
    [sym_false] = ACTIONS(2728),
    [sym_null] = ACTIONS(2728),
    [sym_undefined] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_static] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_get] = ACTIONS(2728),
    [anon_sym_set] = ACTIONS(2728),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2728),
    [anon_sym_private] = ACTIONS(2728),
    [anon_sym_protected] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_interface] = ACTIONS(2728),
    [anon_sym_enum] = ACTIONS(2728),
    [sym_readonly] = ACTIONS(2728),
  },
  [528] = {
    [sym__call_signature] = STATE(3001),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(2680),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(2730),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_default] = ACTIONS(2732),
    [anon_sym_namespace] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2732),
    [anon_sym_import] = ACTIONS(2732),
    [anon_sym_var] = ACTIONS(2732),
    [anon_sym_let] = ACTIONS(2732),
    [anon_sym_const] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2732),
    [anon_sym_else] = ACTIONS(2732),
    [anon_sym_switch] = ACTIONS(2732),
    [anon_sym_for] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2730),
    [anon_sym_await] = ACTIONS(2732),
    [anon_sym_while] = ACTIONS(2732),
    [anon_sym_do] = ACTIONS(2732),
    [anon_sym_try] = ACTIONS(2732),
    [anon_sym_with] = ACTIONS(2732),
    [anon_sym_break] = ACTIONS(2732),
    [anon_sym_continue] = ACTIONS(2732),
    [anon_sym_debugger] = ACTIONS(2732),
    [anon_sym_return] = ACTIONS(2732),
    [anon_sym_throw] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2730),
    [anon_sym_case] = ACTIONS(2732),
    [anon_sym_yield] = ACTIONS(2732),
    [anon_sym_LBRACK] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_SLASH] = ACTIONS(2732),
    [anon_sym_class] = ACTIONS(2732),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_function] = ACTIONS(2732),
    [anon_sym_new] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2732),
    [anon_sym_DASH] = ACTIONS(2732),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_TILDE] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2732),
    [anon_sym_delete] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(2730),
    [anon_sym_DASH_DASH] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [anon_sym_SQUOTE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [sym_number] = ACTIONS(2730),
    [sym_this] = ACTIONS(2732),
    [sym_super] = ACTIONS(2732),
    [sym_true] = ACTIONS(2732),
    [sym_false] = ACTIONS(2732),
    [sym_null] = ACTIONS(2732),
    [sym_undefined] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2730),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_abstract] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [anon_sym_interface] = ACTIONS(2732),
    [anon_sym_enum] = ACTIONS(2732),
    [sym_readonly] = ACTIONS(2732),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(2734),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_default] = ACTIONS(2736),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_import] = ACTIONS(2736),
    [anon_sym_var] = ACTIONS(2736),
    [anon_sym_let] = ACTIONS(2736),
    [anon_sym_const] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2736),
    [anon_sym_else] = ACTIONS(2736),
    [anon_sym_switch] = ACTIONS(2736),
    [anon_sym_for] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_await] = ACTIONS(2736),
    [anon_sym_while] = ACTIONS(2736),
    [anon_sym_do] = ACTIONS(2736),
    [anon_sym_try] = ACTIONS(2736),
    [anon_sym_with] = ACTIONS(2736),
    [anon_sym_break] = ACTIONS(2736),
    [anon_sym_continue] = ACTIONS(2736),
    [anon_sym_debugger] = ACTIONS(2736),
    [anon_sym_return] = ACTIONS(2736),
    [anon_sym_throw] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_case] = ACTIONS(2736),
    [anon_sym_yield] = ACTIONS(2736),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2736),
    [anon_sym_DASH] = ACTIONS(2736),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_TILDE] = ACTIONS(2734),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_delete] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_number] = ACTIONS(2734),
    [sym_this] = ACTIONS(2736),
    [sym_super] = ACTIONS(2736),
    [sym_true] = ACTIONS(2736),
    [sym_false] = ACTIONS(2736),
    [sym_null] = ACTIONS(2736),
    [sym_undefined] = ACTIONS(2736),
    [anon_sym_AT] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_abstract] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
    [anon_sym_interface] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2736),
    [sym_readonly] = ACTIONS(2736),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_namespace] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2740),
    [anon_sym_import] = ACTIONS(2740),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_else] = ACTIONS(2740),
    [anon_sym_switch] = ACTIONS(2740),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_await] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(2740),
    [anon_sym_try] = ACTIONS(2740),
    [anon_sym_with] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_debugger] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_throw] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_case] = ACTIONS(2740),
    [anon_sym_yield] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_function] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_TILDE] = ACTIONS(2738),
    [anon_sym_void] = ACTIONS(2740),
    [anon_sym_delete] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2738),
    [anon_sym_DASH_DASH] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_number] = ACTIONS(2738),
    [sym_this] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [sym_true] = ACTIONS(2740),
    [sym_false] = ACTIONS(2740),
    [sym_null] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2738),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2740),
    [anon_sym_public] = ACTIONS(2740),
    [anon_sym_private] = ACTIONS(2740),
    [anon_sym_protected] = ACTIONS(2740),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_any] = ACTIONS(2740),
    [anon_sym_number] = ACTIONS(2740),
    [anon_sym_boolean] = ACTIONS(2740),
    [anon_sym_string] = ACTIONS(2740),
    [anon_sym_symbol] = ACTIONS(2740),
    [anon_sym_interface] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
    [sym_readonly] = ACTIONS(2740),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_type] = ACTIONS(2744),
    [anon_sym_typeof] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [anon_sym_await] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_with] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_debugger] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_yield] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_TILDE] = ACTIONS(2742),
    [anon_sym_void] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_PLUS_PLUS] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2742),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2742),
    [sym_number] = ACTIONS(2742),
    [sym_this] = ACTIONS(2744),
    [sym_super] = ACTIONS(2744),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_undefined] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_get] = ACTIONS(2744),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_declare] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_any] = ACTIONS(2744),
    [anon_sym_number] = ACTIONS(2744),
    [anon_sym_boolean] = ACTIONS(2744),
    [anon_sym_string] = ACTIONS(2744),
    [anon_sym_symbol] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [sym_readonly] = ACTIONS(2744),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_export] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_namespace] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2748),
    [anon_sym_import] = ACTIONS(2748),
    [anon_sym_var] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_switch] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_await] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_debugger] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_throw] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_case] = ACTIONS(2748),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_SLASH] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_void] = ACTIONS(2748),
    [anon_sym_delete] = ACTIONS(2748),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [sym_number] = ACTIONS(2746),
    [sym_this] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_null] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_get] = ACTIONS(2748),
    [anon_sym_set] = ACTIONS(2748),
    [anon_sym_declare] = ACTIONS(2748),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_module] = ACTIONS(2748),
    [anon_sym_any] = ACTIONS(2748),
    [anon_sym_number] = ACTIONS(2748),
    [anon_sym_boolean] = ACTIONS(2748),
    [anon_sym_string] = ACTIONS(2748),
    [anon_sym_symbol] = ACTIONS(2748),
    [anon_sym_interface] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
    [sym_readonly] = ACTIONS(2748),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2752),
    [anon_sym_export] = ACTIONS(2752),
    [anon_sym_default] = ACTIONS(2752),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_typeof] = ACTIONS(2752),
    [anon_sym_import] = ACTIONS(2752),
    [anon_sym_var] = ACTIONS(2752),
    [anon_sym_let] = ACTIONS(2752),
    [anon_sym_const] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2752),
    [anon_sym_else] = ACTIONS(2752),
    [anon_sym_switch] = ACTIONS(2752),
    [anon_sym_for] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_await] = ACTIONS(2752),
    [anon_sym_while] = ACTIONS(2752),
    [anon_sym_do] = ACTIONS(2752),
    [anon_sym_try] = ACTIONS(2752),
    [anon_sym_with] = ACTIONS(2752),
    [anon_sym_break] = ACTIONS(2752),
    [anon_sym_continue] = ACTIONS(2752),
    [anon_sym_debugger] = ACTIONS(2752),
    [anon_sym_return] = ACTIONS(2752),
    [anon_sym_throw] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_case] = ACTIONS(2752),
    [anon_sym_yield] = ACTIONS(2752),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2752),
    [anon_sym_async] = ACTIONS(2752),
    [anon_sym_function] = ACTIONS(2752),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_TILDE] = ACTIONS(2750),
    [anon_sym_void] = ACTIONS(2752),
    [anon_sym_delete] = ACTIONS(2752),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2750),
    [sym_number] = ACTIONS(2750),
    [sym_this] = ACTIONS(2752),
    [sym_super] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_null] = ACTIONS(2752),
    [sym_undefined] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2750),
    [anon_sym_static] = ACTIONS(2752),
    [anon_sym_abstract] = ACTIONS(2752),
    [anon_sym_get] = ACTIONS(2752),
    [anon_sym_set] = ACTIONS(2752),
    [anon_sym_declare] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2752),
    [anon_sym_private] = ACTIONS(2752),
    [anon_sym_protected] = ACTIONS(2752),
    [anon_sym_module] = ACTIONS(2752),
    [anon_sym_any] = ACTIONS(2752),
    [anon_sym_number] = ACTIONS(2752),
    [anon_sym_boolean] = ACTIONS(2752),
    [anon_sym_string] = ACTIONS(2752),
    [anon_sym_symbol] = ACTIONS(2752),
    [anon_sym_interface] = ACTIONS(2752),
    [anon_sym_enum] = ACTIONS(2752),
    [sym_readonly] = ACTIONS(2752),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_export] = ACTIONS(2756),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_namespace] = ACTIONS(2756),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_type] = ACTIONS(2756),
    [anon_sym_typeof] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2756),
    [anon_sym_var] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_else] = ACTIONS(2756),
    [anon_sym_switch] = ACTIONS(2756),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_await] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_break] = ACTIONS(2756),
    [anon_sym_continue] = ACTIONS(2756),
    [anon_sym_debugger] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_throw] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_case] = ACTIONS(2756),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2756),
    [anon_sym_async] = ACTIONS(2756),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_BANG] = ACTIONS(2754),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_void] = ACTIONS(2756),
    [anon_sym_delete] = ACTIONS(2756),
    [anon_sym_PLUS_PLUS] = ACTIONS(2754),
    [anon_sym_DASH_DASH] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_super] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_null] = ACTIONS(2756),
    [sym_undefined] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2754),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_abstract] = ACTIONS(2756),
    [anon_sym_get] = ACTIONS(2756),
    [anon_sym_set] = ACTIONS(2756),
    [anon_sym_declare] = ACTIONS(2756),
    [anon_sym_public] = ACTIONS(2756),
    [anon_sym_private] = ACTIONS(2756),
    [anon_sym_protected] = ACTIONS(2756),
    [anon_sym_module] = ACTIONS(2756),
    [anon_sym_any] = ACTIONS(2756),
    [anon_sym_number] = ACTIONS(2756),
    [anon_sym_boolean] = ACTIONS(2756),
    [anon_sym_string] = ACTIONS(2756),
    [anon_sym_symbol] = ACTIONS(2756),
    [anon_sym_interface] = ACTIONS(2756),
    [anon_sym_enum] = ACTIONS(2756),
    [sym_readonly] = ACTIONS(2756),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_export] = ACTIONS(2760),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_namespace] = ACTIONS(2760),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_type] = ACTIONS(2760),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_const] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_else] = ACTIONS(2760),
    [anon_sym_switch] = ACTIONS(2760),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_await] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_break] = ACTIONS(2760),
    [anon_sym_continue] = ACTIONS(2760),
    [anon_sym_debugger] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_throw] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_case] = ACTIONS(2760),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_SLASH] = ACTIONS(2760),
    [anon_sym_class] = ACTIONS(2760),
    [anon_sym_async] = ACTIONS(2760),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_BANG] = ACTIONS(2758),
    [anon_sym_TILDE] = ACTIONS(2758),
    [anon_sym_void] = ACTIONS(2760),
    [anon_sym_delete] = ACTIONS(2760),
    [anon_sym_PLUS_PLUS] = ACTIONS(2758),
    [anon_sym_DASH_DASH] = ACTIONS(2758),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2758),
    [sym_number] = ACTIONS(2758),
    [sym_this] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_undefined] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(2758),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_abstract] = ACTIONS(2760),
    [anon_sym_get] = ACTIONS(2760),
    [anon_sym_set] = ACTIONS(2760),
    [anon_sym_declare] = ACTIONS(2760),
    [anon_sym_public] = ACTIONS(2760),
    [anon_sym_private] = ACTIONS(2760),
    [anon_sym_protected] = ACTIONS(2760),
    [anon_sym_module] = ACTIONS(2760),
    [anon_sym_any] = ACTIONS(2760),
    [anon_sym_number] = ACTIONS(2760),
    [anon_sym_boolean] = ACTIONS(2760),
    [anon_sym_string] = ACTIONS(2760),
    [anon_sym_symbol] = ACTIONS(2760),
    [anon_sym_interface] = ACTIONS(2760),
    [anon_sym_enum] = ACTIONS(2760),
    [sym_readonly] = ACTIONS(2760),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_export] = ACTIONS(2764),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_namespace] = ACTIONS(2764),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_type] = ACTIONS(2764),
    [anon_sym_typeof] = ACTIONS(2764),
    [anon_sym_import] = ACTIONS(2764),
    [anon_sym_var] = ACTIONS(2764),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_else] = ACTIONS(2764),
    [anon_sym_switch] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_await] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2764),
    [anon_sym_do] = ACTIONS(2764),
    [anon_sym_try] = ACTIONS(2764),
    [anon_sym_with] = ACTIONS(2764),
    [anon_sym_break] = ACTIONS(2764),
    [anon_sym_continue] = ACTIONS(2764),
    [anon_sym_debugger] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(2764),
    [anon_sym_throw] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_case] = ACTIONS(2764),
    [anon_sym_yield] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2764),
    [anon_sym_class] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_function] = ACTIONS(2764),
    [anon_sym_new] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_TILDE] = ACTIONS(2762),
    [anon_sym_void] = ACTIONS(2764),
    [anon_sym_delete] = ACTIONS(2764),
    [anon_sym_PLUS_PLUS] = ACTIONS(2762),
    [anon_sym_DASH_DASH] = ACTIONS(2762),
    [anon_sym_DQUOTE] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2762),
    [sym_number] = ACTIONS(2762),
    [sym_this] = ACTIONS(2764),
    [sym_super] = ACTIONS(2764),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_null] = ACTIONS(2764),
    [sym_undefined] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_static] = ACTIONS(2764),
    [anon_sym_abstract] = ACTIONS(2764),
    [anon_sym_get] = ACTIONS(2764),
    [anon_sym_set] = ACTIONS(2764),
    [anon_sym_declare] = ACTIONS(2764),
    [anon_sym_public] = ACTIONS(2764),
    [anon_sym_private] = ACTIONS(2764),
    [anon_sym_protected] = ACTIONS(2764),
    [anon_sym_module] = ACTIONS(2764),
    [anon_sym_any] = ACTIONS(2764),
    [anon_sym_number] = ACTIONS(2764),
    [anon_sym_boolean] = ACTIONS(2764),
    [anon_sym_string] = ACTIONS(2764),
    [anon_sym_symbol] = ACTIONS(2764),
    [anon_sym_interface] = ACTIONS(2764),
    [anon_sym_enum] = ACTIONS(2764),
    [sym_readonly] = ACTIONS(2764),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_typeof] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_var] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_else] = ACTIONS(2768),
    [anon_sym_switch] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_await] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_debugger] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_throw] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_case] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2768),
    [anon_sym_class] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_BANG] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2766),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_delete] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2766),
    [anon_sym_DASH_DASH] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2766),
    [sym_number] = ACTIONS(2766),
    [sym_this] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [sym_true] = ACTIONS(2768),
    [sym_false] = ACTIONS(2768),
    [sym_null] = ACTIONS(2768),
    [sym_undefined] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_interface] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
    [sym_readonly] = ACTIONS(2768),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2772),
    [anon_sym_namespace] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_type] = ACTIONS(2772),
    [anon_sym_typeof] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_var] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_switch] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_await] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [anon_sym_do] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_with] = ACTIONS(2772),
    [anon_sym_break] = ACTIONS(2772),
    [anon_sym_continue] = ACTIONS(2772),
    [anon_sym_debugger] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_throw] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2772),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [anon_sym_void] = ACTIONS(2772),
    [anon_sym_delete] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2770),
    [sym_number] = ACTIONS(2770),
    [sym_this] = ACTIONS(2772),
    [sym_super] = ACTIONS(2772),
    [sym_true] = ACTIONS(2772),
    [sym_false] = ACTIONS(2772),
    [sym_null] = ACTIONS(2772),
    [sym_undefined] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_static] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_get] = ACTIONS(2772),
    [anon_sym_set] = ACTIONS(2772),
    [anon_sym_declare] = ACTIONS(2772),
    [anon_sym_public] = ACTIONS(2772),
    [anon_sym_private] = ACTIONS(2772),
    [anon_sym_protected] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_any] = ACTIONS(2772),
    [anon_sym_number] = ACTIONS(2772),
    [anon_sym_boolean] = ACTIONS(2772),
    [anon_sym_string] = ACTIONS(2772),
    [anon_sym_symbol] = ACTIONS(2772),
    [anon_sym_interface] = ACTIONS(2772),
    [anon_sym_enum] = ACTIONS(2772),
    [sym_readonly] = ACTIONS(2772),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_export] = ACTIONS(2776),
    [anon_sym_default] = ACTIONS(2776),
    [anon_sym_namespace] = ACTIONS(2776),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_type] = ACTIONS(2776),
    [anon_sym_typeof] = ACTIONS(2776),
    [anon_sym_import] = ACTIONS(2776),
    [anon_sym_var] = ACTIONS(2776),
    [anon_sym_let] = ACTIONS(2776),
    [anon_sym_const] = ACTIONS(2776),
    [anon_sym_if] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2776),
    [anon_sym_switch] = ACTIONS(2776),
    [anon_sym_for] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(2774),
    [anon_sym_await] = ACTIONS(2776),
    [anon_sym_while] = ACTIONS(2776),
    [anon_sym_do] = ACTIONS(2776),
    [anon_sym_try] = ACTIONS(2776),
    [anon_sym_with] = ACTIONS(2776),
    [anon_sym_break] = ACTIONS(2776),
    [anon_sym_continue] = ACTIONS(2776),
    [anon_sym_debugger] = ACTIONS(2776),
    [anon_sym_return] = ACTIONS(2776),
    [anon_sym_throw] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_case] = ACTIONS(2776),
    [anon_sym_yield] = ACTIONS(2776),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2776),
    [anon_sym_class] = ACTIONS(2776),
    [anon_sym_async] = ACTIONS(2776),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_new] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2776),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2774),
    [anon_sym_void] = ACTIONS(2776),
    [anon_sym_delete] = ACTIONS(2776),
    [anon_sym_PLUS_PLUS] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(2774),
    [anon_sym_SQUOTE] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2774),
    [sym_number] = ACTIONS(2774),
    [sym_this] = ACTIONS(2776),
    [sym_super] = ACTIONS(2776),
    [sym_true] = ACTIONS(2776),
    [sym_false] = ACTIONS(2776),
    [sym_null] = ACTIONS(2776),
    [sym_undefined] = ACTIONS(2776),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_static] = ACTIONS(2776),
    [anon_sym_abstract] = ACTIONS(2776),
    [anon_sym_get] = ACTIONS(2776),
    [anon_sym_set] = ACTIONS(2776),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_public] = ACTIONS(2776),
    [anon_sym_private] = ACTIONS(2776),
    [anon_sym_protected] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(2776),
    [anon_sym_number] = ACTIONS(2776),
    [anon_sym_boolean] = ACTIONS(2776),
    [anon_sym_string] = ACTIONS(2776),
    [anon_sym_symbol] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2776),
    [anon_sym_enum] = ACTIONS(2776),
    [sym_readonly] = ACTIONS(2776),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_default] = ACTIONS(2780),
    [anon_sym_namespace] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_import] = ACTIONS(2780),
    [anon_sym_var] = ACTIONS(2780),
    [anon_sym_let] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_switch] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2778),
    [anon_sym_await] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_try] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_break] = ACTIONS(2780),
    [anon_sym_continue] = ACTIONS(2780),
    [anon_sym_debugger] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_throw] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_case] = ACTIONS(2780),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_function] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2778),
    [anon_sym_TILDE] = ACTIONS(2778),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_delete] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(2778),
    [anon_sym_DQUOTE] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2778),
    [sym_number] = ACTIONS(2778),
    [sym_this] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_AT] = ACTIONS(2778),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_declare] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_module] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_interface] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
    [sym_readonly] = ACTIONS(2780),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_var] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_throw] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_case] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_var] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_else] = ACTIONS(2788),
    [anon_sym_switch] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_do] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [anon_sym_with] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_debugger] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_throw] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_interface] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_default] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_import] = ACTIONS(2792),
    [anon_sym_var] = ACTIONS(2792),
    [anon_sym_let] = ACTIONS(2792),
    [anon_sym_const] = ACTIONS(2792),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_await] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_do] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2792),
    [anon_sym_with] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2792),
    [anon_sym_continue] = ACTIONS(2792),
    [anon_sym_debugger] = ACTIONS(2792),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_throw] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_case] = ACTIONS(2792),
    [anon_sym_yield] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_class] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2792),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_TILDE] = ACTIONS(2790),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_delete] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2790),
    [anon_sym_DASH_DASH] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2792),
    [sym_super] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_AT] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2792),
    [anon_sym_enum] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2796),
    [anon_sym_var] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_else] = ACTIONS(2796),
    [anon_sym_switch] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_await] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_do] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [anon_sym_with] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_debugger] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_throw] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_declare] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_module] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [sym_readonly] = ACTIONS(2796),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2800),
    [anon_sym_import] = ACTIONS(2800),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_else] = ACTIONS(2800),
    [anon_sym_switch] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_await] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_do] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [anon_sym_with] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_debugger] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_throw] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_case] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_SLASH] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_function] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_PLUS] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_void] = ACTIONS(2800),
    [anon_sym_delete] = ACTIONS(2800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [sym_readonly] = ACTIONS(2800),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(2802),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_export] = ACTIONS(2804),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_namespace] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_type] = ACTIONS(2804),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_import] = ACTIONS(2804),
    [anon_sym_var] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2804),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_await] = ACTIONS(2804),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_break] = ACTIONS(2804),
    [anon_sym_continue] = ACTIONS(2804),
    [anon_sym_debugger] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_throw] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_case] = ACTIONS(2804),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2802),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_class] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_void] = ACTIONS(2804),
    [anon_sym_delete] = ACTIONS(2804),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_DQUOTE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2802),
    [sym_number] = ACTIONS(2802),
    [sym_this] = ACTIONS(2804),
    [sym_super] = ACTIONS(2804),
    [sym_true] = ACTIONS(2804),
    [sym_false] = ACTIONS(2804),
    [sym_null] = ACTIONS(2804),
    [sym_undefined] = ACTIONS(2804),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_get] = ACTIONS(2804),
    [anon_sym_set] = ACTIONS(2804),
    [anon_sym_declare] = ACTIONS(2804),
    [anon_sym_public] = ACTIONS(2804),
    [anon_sym_private] = ACTIONS(2804),
    [anon_sym_protected] = ACTIONS(2804),
    [anon_sym_module] = ACTIONS(2804),
    [anon_sym_any] = ACTIONS(2804),
    [anon_sym_number] = ACTIONS(2804),
    [anon_sym_boolean] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_symbol] = ACTIONS(2804),
    [anon_sym_interface] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
    [sym_readonly] = ACTIONS(2804),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_default] = ACTIONS(1211),
    [anon_sym_namespace] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_type] = ACTIONS(1211),
    [anon_sym_typeof] = ACTIONS(1211),
    [anon_sym_import] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_await] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_do] = ACTIONS(1211),
    [anon_sym_try] = ACTIONS(1211),
    [anon_sym_with] = ACTIONS(1211),
    [anon_sym_break] = ACTIONS(1211),
    [anon_sym_continue] = ACTIONS(1211),
    [anon_sym_debugger] = ACTIONS(1211),
    [anon_sym_return] = ACTIONS(1211),
    [anon_sym_throw] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1211),
    [anon_sym_yield] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1209),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_class] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_function] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1211),
    [anon_sym_delete] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym_number] = ACTIONS(1209),
    [sym_this] = ACTIONS(1211),
    [sym_super] = ACTIONS(1211),
    [sym_true] = ACTIONS(1211),
    [sym_false] = ACTIONS(1211),
    [sym_null] = ACTIONS(1211),
    [sym_undefined] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1211),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1211),
    [anon_sym_declare] = ACTIONS(1211),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1211),
    [anon_sym_any] = ACTIONS(1211),
    [anon_sym_number] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1211),
    [anon_sym_symbol] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [sym_readonly] = ACTIONS(1211),
  },
  [549] = {
    [sym__call_signature] = STATE(3108),
    [sym_arguments] = STATE(1534),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2806),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [sym_readonly] = ACTIONS(2808),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(2810),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_typeof] = ACTIONS(2812),
    [anon_sym_import] = ACTIONS(2812),
    [anon_sym_var] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_switch] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_await] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_break] = ACTIONS(2812),
    [anon_sym_continue] = ACTIONS(2812),
    [anon_sym_debugger] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_throw] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_case] = ACTIONS(2812),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2810),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_SLASH] = ACTIONS(2812),
    [anon_sym_class] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_BANG] = ACTIONS(2810),
    [anon_sym_TILDE] = ACTIONS(2810),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_delete] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2810),
    [anon_sym_DASH_DASH] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2810),
    [sym_number] = ACTIONS(2810),
    [sym_this] = ACTIONS(2812),
    [sym_super] = ACTIONS(2812),
    [sym_true] = ACTIONS(2812),
    [sym_false] = ACTIONS(2812),
    [sym_null] = ACTIONS(2812),
    [sym_undefined] = ACTIONS(2812),
    [anon_sym_AT] = ACTIONS(2810),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [anon_sym_interface] = ACTIONS(2812),
    [anon_sym_enum] = ACTIONS(2812),
    [sym_readonly] = ACTIONS(2812),
  },
  [551] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(2814),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_function] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [sym_false] = ACTIONS(2816),
    [sym_null] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [sym_readonly] = ACTIONS(2816),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_export] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_namespace] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_import] = ACTIONS(2820),
    [anon_sym_var] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2820),
    [anon_sym_switch] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_do] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [anon_sym_with] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_debugger] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_throw] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2820),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_SLASH] = ACTIONS(2820),
    [anon_sym_class] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2820),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_delete] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_declare] = ACTIONS(2820),
    [anon_sym_public] = ACTIONS(2820),
    [anon_sym_private] = ACTIONS(2820),
    [anon_sym_protected] = ACTIONS(2820),
    [anon_sym_module] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
    [sym_readonly] = ACTIONS(2820),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_typeof] = ACTIONS(2824),
    [anon_sym_import] = ACTIONS(2824),
    [anon_sym_var] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_await] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_do] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [anon_sym_with] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_debugger] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2824),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2824),
    [anon_sym_class] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2824),
    [anon_sym_new] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_TILDE] = ACTIONS(2822),
    [anon_sym_void] = ACTIONS(2824),
    [anon_sym_delete] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_true] = ACTIONS(2824),
    [sym_false] = ACTIONS(2824),
    [sym_null] = ACTIONS(2824),
    [sym_undefined] = ACTIONS(2824),
    [anon_sym_AT] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2824),
    [anon_sym_get] = ACTIONS(2824),
    [anon_sym_set] = ACTIONS(2824),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2824),
    [anon_sym_private] = ACTIONS(2824),
    [anon_sym_protected] = ACTIONS(2824),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
    [sym_readonly] = ACTIONS(2824),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_export] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_namespace] = ACTIONS(2828),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_typeof] = ACTIONS(2828),
    [anon_sym_import] = ACTIONS(2828),
    [anon_sym_var] = ACTIONS(2828),
    [anon_sym_let] = ACTIONS(2828),
    [anon_sym_const] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2828),
    [anon_sym_else] = ACTIONS(2828),
    [anon_sym_switch] = ACTIONS(2828),
    [anon_sym_for] = ACTIONS(2828),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_await] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2828),
    [anon_sym_do] = ACTIONS(2828),
    [anon_sym_try] = ACTIONS(2828),
    [anon_sym_with] = ACTIONS(2828),
    [anon_sym_break] = ACTIONS(2828),
    [anon_sym_continue] = ACTIONS(2828),
    [anon_sym_debugger] = ACTIONS(2828),
    [anon_sym_return] = ACTIONS(2828),
    [anon_sym_throw] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2828),
    [anon_sym_yield] = ACTIONS(2828),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2828),
    [anon_sym_class] = ACTIONS(2828),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2828),
    [anon_sym_new] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_TILDE] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2828),
    [anon_sym_delete] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_super] = ACTIONS(2828),
    [sym_true] = ACTIONS(2828),
    [sym_false] = ACTIONS(2828),
    [sym_null] = ACTIONS(2828),
    [sym_undefined] = ACTIONS(2828),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_abstract] = ACTIONS(2828),
    [anon_sym_get] = ACTIONS(2828),
    [anon_sym_set] = ACTIONS(2828),
    [anon_sym_declare] = ACTIONS(2828),
    [anon_sym_public] = ACTIONS(2828),
    [anon_sym_private] = ACTIONS(2828),
    [anon_sym_protected] = ACTIONS(2828),
    [anon_sym_module] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(2828),
    [anon_sym_number] = ACTIONS(2828),
    [anon_sym_boolean] = ACTIONS(2828),
    [anon_sym_string] = ACTIONS(2828),
    [anon_sym_symbol] = ACTIONS(2828),
    [anon_sym_interface] = ACTIONS(2828),
    [anon_sym_enum] = ACTIONS(2828),
    [sym_readonly] = ACTIONS(2828),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(2830),
    [sym_identifier] = ACTIONS(2832),
    [anon_sym_export] = ACTIONS(2832),
    [anon_sym_default] = ACTIONS(2832),
    [anon_sym_namespace] = ACTIONS(2832),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_type] = ACTIONS(2832),
    [anon_sym_typeof] = ACTIONS(2832),
    [anon_sym_import] = ACTIONS(2832),
    [anon_sym_var] = ACTIONS(2832),
    [anon_sym_let] = ACTIONS(2832),
    [anon_sym_const] = ACTIONS(2832),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_else] = ACTIONS(2832),
    [anon_sym_switch] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2832),
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_await] = ACTIONS(2832),
    [anon_sym_while] = ACTIONS(2832),
    [anon_sym_do] = ACTIONS(2832),
    [anon_sym_try] = ACTIONS(2832),
    [anon_sym_with] = ACTIONS(2832),
    [anon_sym_break] = ACTIONS(2832),
    [anon_sym_continue] = ACTIONS(2832),
    [anon_sym_debugger] = ACTIONS(2832),
    [anon_sym_return] = ACTIONS(2832),
    [anon_sym_throw] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2832),
    [anon_sym_yield] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_SLASH] = ACTIONS(2832),
    [anon_sym_class] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2832),
    [anon_sym_function] = ACTIONS(2832),
    [anon_sym_new] = ACTIONS(2832),
    [anon_sym_PLUS] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_void] = ACTIONS(2832),
    [anon_sym_delete] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_number] = ACTIONS(2830),
    [sym_this] = ACTIONS(2832),
    [sym_super] = ACTIONS(2832),
    [sym_true] = ACTIONS(2832),
    [sym_false] = ACTIONS(2832),
    [sym_null] = ACTIONS(2832),
    [sym_undefined] = ACTIONS(2832),
    [anon_sym_AT] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_abstract] = ACTIONS(2832),
    [anon_sym_get] = ACTIONS(2832),
    [anon_sym_set] = ACTIONS(2832),
    [anon_sym_declare] = ACTIONS(2832),
    [anon_sym_public] = ACTIONS(2832),
    [anon_sym_private] = ACTIONS(2832),
    [anon_sym_protected] = ACTIONS(2832),
    [anon_sym_module] = ACTIONS(2832),
    [anon_sym_any] = ACTIONS(2832),
    [anon_sym_number] = ACTIONS(2832),
    [anon_sym_boolean] = ACTIONS(2832),
    [anon_sym_string] = ACTIONS(2832),
    [anon_sym_symbol] = ACTIONS(2832),
    [anon_sym_interface] = ACTIONS(2832),
    [anon_sym_enum] = ACTIONS(2832),
    [sym_readonly] = ACTIONS(2832),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(2836),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_await] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_with] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_debugger] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_function] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_TILDE] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [sym_number] = ACTIONS(2834),
    [sym_this] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_undefined] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_abstract] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [sym_readonly] = ACTIONS(2836),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(2838),
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_export] = ACTIONS(2840),
    [anon_sym_default] = ACTIONS(2840),
    [anon_sym_namespace] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_typeof] = ACTIONS(2840),
    [anon_sym_import] = ACTIONS(2840),
    [anon_sym_var] = ACTIONS(2840),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2840),
    [anon_sym_if] = ACTIONS(2840),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2840),
    [anon_sym_LPAREN] = ACTIONS(2838),
    [anon_sym_await] = ACTIONS(2840),
    [anon_sym_while] = ACTIONS(2840),
    [anon_sym_do] = ACTIONS(2840),
    [anon_sym_try] = ACTIONS(2840),
    [anon_sym_with] = ACTIONS(2840),
    [anon_sym_break] = ACTIONS(2840),
    [anon_sym_continue] = ACTIONS(2840),
    [anon_sym_debugger] = ACTIONS(2840),
    [anon_sym_return] = ACTIONS(2840),
    [anon_sym_throw] = ACTIONS(2840),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2840),
    [anon_sym_yield] = ACTIONS(2840),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_SLASH] = ACTIONS(2840),
    [anon_sym_class] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_function] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_void] = ACTIONS(2840),
    [anon_sym_delete] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2838),
    [sym_number] = ACTIONS(2838),
    [sym_this] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [sym_true] = ACTIONS(2840),
    [sym_false] = ACTIONS(2840),
    [sym_null] = ACTIONS(2840),
    [sym_undefined] = ACTIONS(2840),
    [anon_sym_AT] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_abstract] = ACTIONS(2840),
    [anon_sym_get] = ACTIONS(2840),
    [anon_sym_set] = ACTIONS(2840),
    [anon_sym_declare] = ACTIONS(2840),
    [anon_sym_public] = ACTIONS(2840),
    [anon_sym_private] = ACTIONS(2840),
    [anon_sym_protected] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2840),
    [anon_sym_any] = ACTIONS(2840),
    [anon_sym_number] = ACTIONS(2840),
    [anon_sym_boolean] = ACTIONS(2840),
    [anon_sym_string] = ACTIONS(2840),
    [anon_sym_symbol] = ACTIONS(2840),
    [anon_sym_interface] = ACTIONS(2840),
    [anon_sym_enum] = ACTIONS(2840),
    [sym_readonly] = ACTIONS(2840),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2842),
    [sym_identifier] = ACTIONS(2844),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_default] = ACTIONS(2844),
    [anon_sym_namespace] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_type] = ACTIONS(2844),
    [anon_sym_typeof] = ACTIONS(2844),
    [anon_sym_import] = ACTIONS(2844),
    [anon_sym_var] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_const] = ACTIONS(2844),
    [anon_sym_if] = ACTIONS(2844),
    [anon_sym_else] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_for] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [anon_sym_await] = ACTIONS(2844),
    [anon_sym_while] = ACTIONS(2844),
    [anon_sym_do] = ACTIONS(2844),
    [anon_sym_try] = ACTIONS(2844),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_break] = ACTIONS(2844),
    [anon_sym_continue] = ACTIONS(2844),
    [anon_sym_debugger] = ACTIONS(2844),
    [anon_sym_return] = ACTIONS(2844),
    [anon_sym_throw] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_class] = ACTIONS(2844),
    [anon_sym_async] = ACTIONS(2844),
    [anon_sym_function] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_void] = ACTIONS(2844),
    [anon_sym_delete] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2842),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_SQUOTE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2842),
    [sym_number] = ACTIONS(2842),
    [sym_this] = ACTIONS(2844),
    [sym_super] = ACTIONS(2844),
    [sym_true] = ACTIONS(2844),
    [sym_false] = ACTIONS(2844),
    [sym_null] = ACTIONS(2844),
    [sym_undefined] = ACTIONS(2844),
    [anon_sym_AT] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2844),
    [anon_sym_abstract] = ACTIONS(2844),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_declare] = ACTIONS(2844),
    [anon_sym_public] = ACTIONS(2844),
    [anon_sym_private] = ACTIONS(2844),
    [anon_sym_protected] = ACTIONS(2844),
    [anon_sym_module] = ACTIONS(2844),
    [anon_sym_any] = ACTIONS(2844),
    [anon_sym_number] = ACTIONS(2844),
    [anon_sym_boolean] = ACTIONS(2844),
    [anon_sym_string] = ACTIONS(2844),
    [anon_sym_symbol] = ACTIONS(2844),
    [anon_sym_interface] = ACTIONS(2844),
    [anon_sym_enum] = ACTIONS(2844),
    [sym_readonly] = ACTIONS(2844),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(2846),
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_export] = ACTIONS(2848),
    [anon_sym_default] = ACTIONS(2848),
    [anon_sym_namespace] = ACTIONS(2848),
    [anon_sym_LBRACE] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_type] = ACTIONS(2848),
    [anon_sym_typeof] = ACTIONS(2848),
    [anon_sym_import] = ACTIONS(2848),
    [anon_sym_var] = ACTIONS(2848),
    [anon_sym_let] = ACTIONS(2848),
    [anon_sym_const] = ACTIONS(2848),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_else] = ACTIONS(2848),
    [anon_sym_switch] = ACTIONS(2848),
    [anon_sym_for] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2846),
    [anon_sym_await] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_try] = ACTIONS(2848),
    [anon_sym_with] = ACTIONS(2848),
    [anon_sym_break] = ACTIONS(2848),
    [anon_sym_continue] = ACTIONS(2848),
    [anon_sym_debugger] = ACTIONS(2848),
    [anon_sym_return] = ACTIONS(2848),
    [anon_sym_throw] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2848),
    [anon_sym_yield] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_LT] = ACTIONS(2846),
    [anon_sym_SLASH] = ACTIONS(2848),
    [anon_sym_class] = ACTIONS(2848),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2848),
    [anon_sym_new] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_TILDE] = ACTIONS(2846),
    [anon_sym_void] = ACTIONS(2848),
    [anon_sym_delete] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2846),
    [anon_sym_DQUOTE] = ACTIONS(2846),
    [anon_sym_SQUOTE] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2846),
    [sym_number] = ACTIONS(2846),
    [sym_this] = ACTIONS(2848),
    [sym_super] = ACTIONS(2848),
    [sym_true] = ACTIONS(2848),
    [sym_false] = ACTIONS(2848),
    [sym_null] = ACTIONS(2848),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_AT] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_abstract] = ACTIONS(2848),
    [anon_sym_get] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(2848),
    [anon_sym_declare] = ACTIONS(2848),
    [anon_sym_public] = ACTIONS(2848),
    [anon_sym_private] = ACTIONS(2848),
    [anon_sym_protected] = ACTIONS(2848),
    [anon_sym_module] = ACTIONS(2848),
    [anon_sym_any] = ACTIONS(2848),
    [anon_sym_number] = ACTIONS(2848),
    [anon_sym_boolean] = ACTIONS(2848),
    [anon_sym_string] = ACTIONS(2848),
    [anon_sym_symbol] = ACTIONS(2848),
    [anon_sym_interface] = ACTIONS(2848),
    [anon_sym_enum] = ACTIONS(2848),
    [sym_readonly] = ACTIONS(2848),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_default] = ACTIONS(2852),
    [anon_sym_namespace] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_type] = ACTIONS(2852),
    [anon_sym_typeof] = ACTIONS(2852),
    [anon_sym_import] = ACTIONS(2852),
    [anon_sym_var] = ACTIONS(2852),
    [anon_sym_let] = ACTIONS(2852),
    [anon_sym_const] = ACTIONS(2852),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_switch] = ACTIONS(2852),
    [anon_sym_for] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2850),
    [anon_sym_await] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2852),
    [anon_sym_break] = ACTIONS(2852),
    [anon_sym_continue] = ACTIONS(2852),
    [anon_sym_debugger] = ACTIONS(2852),
    [anon_sym_return] = ACTIONS(2852),
    [anon_sym_throw] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2852),
    [anon_sym_yield] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_class] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_function] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_TILDE] = ACTIONS(2850),
    [anon_sym_void] = ACTIONS(2852),
    [anon_sym_delete] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2850),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_SQUOTE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2850),
    [sym_number] = ACTIONS(2850),
    [sym_this] = ACTIONS(2852),
    [sym_super] = ACTIONS(2852),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_AT] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_abstract] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(2852),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_public] = ACTIONS(2852),
    [anon_sym_private] = ACTIONS(2852),
    [anon_sym_protected] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2852),
    [anon_sym_any] = ACTIONS(2852),
    [anon_sym_number] = ACTIONS(2852),
    [anon_sym_boolean] = ACTIONS(2852),
    [anon_sym_string] = ACTIONS(2852),
    [anon_sym_symbol] = ACTIONS(2852),
    [anon_sym_interface] = ACTIONS(2852),
    [anon_sym_enum] = ACTIONS(2852),
    [sym_readonly] = ACTIONS(2852),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(2854),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_export] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_typeof] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_await] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_with] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_debugger] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_yield] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2854),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_function] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_void] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_number] = ACTIONS(2854),
    [sym_this] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [sym_null] = ACTIONS(2856),
    [sym_undefined] = ACTIONS(2856),
    [anon_sym_AT] = ACTIONS(2854),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2856),
    [anon_sym_set] = ACTIONS(2856),
    [anon_sym_declare] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_module] = ACTIONS(2856),
    [anon_sym_any] = ACTIONS(2856),
    [anon_sym_number] = ACTIONS(2856),
    [anon_sym_boolean] = ACTIONS(2856),
    [anon_sym_string] = ACTIONS(2856),
    [anon_sym_symbol] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [sym_readonly] = ACTIONS(2856),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(2858),
    [sym_identifier] = ACTIONS(2860),
    [anon_sym_export] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_type] = ACTIONS(2860),
    [anon_sym_typeof] = ACTIONS(2860),
    [anon_sym_import] = ACTIONS(2860),
    [anon_sym_var] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_else] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_await] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_with] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_debugger] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_yield] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_async] = ACTIONS(2860),
    [anon_sym_function] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_void] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2858),
    [sym_number] = ACTIONS(2858),
    [sym_this] = ACTIONS(2860),
    [sym_super] = ACTIONS(2860),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_undefined] = ACTIONS(2860),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_abstract] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_declare] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2860),
    [anon_sym_any] = ACTIONS(2860),
    [anon_sym_number] = ACTIONS(2860),
    [anon_sym_boolean] = ACTIONS(2860),
    [anon_sym_string] = ACTIONS(2860),
    [anon_sym_symbol] = ACTIONS(2860),
    [anon_sym_interface] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [sym_readonly] = ACTIONS(2860),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2864),
    [anon_sym_export] = ACTIONS(2864),
    [anon_sym_default] = ACTIONS(2864),
    [anon_sym_namespace] = ACTIONS(2864),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_type] = ACTIONS(2864),
    [anon_sym_typeof] = ACTIONS(2864),
    [anon_sym_import] = ACTIONS(2864),
    [anon_sym_var] = ACTIONS(2864),
    [anon_sym_let] = ACTIONS(2864),
    [anon_sym_const] = ACTIONS(2864),
    [anon_sym_if] = ACTIONS(2864),
    [anon_sym_else] = ACTIONS(2864),
    [anon_sym_switch] = ACTIONS(2864),
    [anon_sym_for] = ACTIONS(2864),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_await] = ACTIONS(2864),
    [anon_sym_while] = ACTIONS(2864),
    [anon_sym_do] = ACTIONS(2864),
    [anon_sym_try] = ACTIONS(2864),
    [anon_sym_with] = ACTIONS(2864),
    [anon_sym_break] = ACTIONS(2864),
    [anon_sym_continue] = ACTIONS(2864),
    [anon_sym_debugger] = ACTIONS(2864),
    [anon_sym_return] = ACTIONS(2864),
    [anon_sym_throw] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_case] = ACTIONS(2864),
    [anon_sym_yield] = ACTIONS(2864),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2862),
    [anon_sym_SLASH] = ACTIONS(2864),
    [anon_sym_class] = ACTIONS(2864),
    [anon_sym_async] = ACTIONS(2864),
    [anon_sym_function] = ACTIONS(2864),
    [anon_sym_new] = ACTIONS(2864),
    [anon_sym_PLUS] = ACTIONS(2864),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_void] = ACTIONS(2864),
    [anon_sym_delete] = ACTIONS(2864),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_number] = ACTIONS(2862),
    [sym_this] = ACTIONS(2864),
    [sym_super] = ACTIONS(2864),
    [sym_true] = ACTIONS(2864),
    [sym_false] = ACTIONS(2864),
    [sym_null] = ACTIONS(2864),
    [sym_undefined] = ACTIONS(2864),
    [anon_sym_AT] = ACTIONS(2862),
    [anon_sym_static] = ACTIONS(2864),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_get] = ACTIONS(2864),
    [anon_sym_set] = ACTIONS(2864),
    [anon_sym_declare] = ACTIONS(2864),
    [anon_sym_public] = ACTIONS(2864),
    [anon_sym_private] = ACTIONS(2864),
    [anon_sym_protected] = ACTIONS(2864),
    [anon_sym_module] = ACTIONS(2864),
    [anon_sym_any] = ACTIONS(2864),
    [anon_sym_number] = ACTIONS(2864),
    [anon_sym_boolean] = ACTIONS(2864),
    [anon_sym_string] = ACTIONS(2864),
    [anon_sym_symbol] = ACTIONS(2864),
    [anon_sym_interface] = ACTIONS(2864),
    [anon_sym_enum] = ACTIONS(2864),
    [sym_readonly] = ACTIONS(2864),
  },
  [566] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(2866),
    [sym_identifier] = ACTIONS(2868),
    [anon_sym_export] = ACTIONS(2868),
    [anon_sym_default] = ACTIONS(2868),
    [anon_sym_namespace] = ACTIONS(2868),
    [anon_sym_LBRACE] = ACTIONS(2866),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_type] = ACTIONS(2868),
    [anon_sym_typeof] = ACTIONS(2868),
    [anon_sym_import] = ACTIONS(2868),
    [anon_sym_var] = ACTIONS(2868),
    [anon_sym_let] = ACTIONS(2868),
    [anon_sym_const] = ACTIONS(2868),
    [anon_sym_if] = ACTIONS(2868),
    [anon_sym_else] = ACTIONS(2868),
    [anon_sym_switch] = ACTIONS(2868),
    [anon_sym_for] = ACTIONS(2868),
    [anon_sym_LPAREN] = ACTIONS(2866),
    [anon_sym_await] = ACTIONS(2868),
    [anon_sym_while] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2868),
    [anon_sym_try] = ACTIONS(2868),
    [anon_sym_with] = ACTIONS(2868),
    [anon_sym_break] = ACTIONS(2868),
    [anon_sym_continue] = ACTIONS(2868),
    [anon_sym_debugger] = ACTIONS(2868),
    [anon_sym_return] = ACTIONS(2868),
    [anon_sym_throw] = ACTIONS(2868),
    [anon_sym_SEMI] = ACTIONS(2866),
    [anon_sym_case] = ACTIONS(2868),
    [anon_sym_yield] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2868),
    [anon_sym_class] = ACTIONS(2868),
    [anon_sym_async] = ACTIONS(2868),
    [anon_sym_function] = ACTIONS(2868),
    [anon_sym_new] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2868),
    [anon_sym_DASH] = ACTIONS(2868),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_TILDE] = ACTIONS(2866),
    [anon_sym_void] = ACTIONS(2868),
    [anon_sym_delete] = ACTIONS(2868),
    [anon_sym_PLUS_PLUS] = ACTIONS(2866),
    [anon_sym_DASH_DASH] = ACTIONS(2866),
    [anon_sym_DQUOTE] = ACTIONS(2866),
    [anon_sym_SQUOTE] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [sym_number] = ACTIONS(2866),
    [sym_this] = ACTIONS(2868),
    [sym_super] = ACTIONS(2868),
    [sym_true] = ACTIONS(2868),
    [sym_false] = ACTIONS(2868),
    [sym_null] = ACTIONS(2868),
    [sym_undefined] = ACTIONS(2868),
    [anon_sym_AT] = ACTIONS(2866),
    [anon_sym_static] = ACTIONS(2868),
    [anon_sym_abstract] = ACTIONS(2868),
    [anon_sym_get] = ACTIONS(2868),
    [anon_sym_set] = ACTIONS(2868),
    [anon_sym_declare] = ACTIONS(2868),
    [anon_sym_public] = ACTIONS(2868),
    [anon_sym_private] = ACTIONS(2868),
    [anon_sym_protected] = ACTIONS(2868),
    [anon_sym_module] = ACTIONS(2868),
    [anon_sym_any] = ACTIONS(2868),
    [anon_sym_number] = ACTIONS(2868),
    [anon_sym_boolean] = ACTIONS(2868),
    [anon_sym_string] = ACTIONS(2868),
    [anon_sym_symbol] = ACTIONS(2868),
    [anon_sym_interface] = ACTIONS(2868),
    [anon_sym_enum] = ACTIONS(2868),
    [sym_readonly] = ACTIONS(2868),
  },
  [568] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(2870),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_export] = ACTIONS(2872),
    [anon_sym_default] = ACTIONS(2872),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_type] = ACTIONS(2872),
    [anon_sym_typeof] = ACTIONS(2872),
    [anon_sym_import] = ACTIONS(2872),
    [anon_sym_var] = ACTIONS(2872),
    [anon_sym_let] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2872),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2872),
    [anon_sym_switch] = ACTIONS(2872),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_await] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_do] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2872),
    [anon_sym_with] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2872),
    [anon_sym_debugger] = ACTIONS(2872),
    [anon_sym_return] = ACTIONS(2872),
    [anon_sym_throw] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2870),
    [anon_sym_case] = ACTIONS(2872),
    [anon_sym_yield] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2870),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2872),
    [anon_sym_async] = ACTIONS(2872),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_new] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_void] = ACTIONS(2872),
    [anon_sym_delete] = ACTIONS(2872),
    [anon_sym_PLUS_PLUS] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2870),
    [anon_sym_DQUOTE] = ACTIONS(2870),
    [anon_sym_SQUOTE] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym_this] = ACTIONS(2872),
    [sym_super] = ACTIONS(2872),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_null] = ACTIONS(2872),
    [sym_undefined] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_static] = ACTIONS(2872),
    [anon_sym_abstract] = ACTIONS(2872),
    [anon_sym_get] = ACTIONS(2872),
    [anon_sym_set] = ACTIONS(2872),
    [anon_sym_declare] = ACTIONS(2872),
    [anon_sym_public] = ACTIONS(2872),
    [anon_sym_private] = ACTIONS(2872),
    [anon_sym_protected] = ACTIONS(2872),
    [anon_sym_module] = ACTIONS(2872),
    [anon_sym_any] = ACTIONS(2872),
    [anon_sym_number] = ACTIONS(2872),
    [anon_sym_boolean] = ACTIONS(2872),
    [anon_sym_string] = ACTIONS(2872),
    [anon_sym_symbol] = ACTIONS(2872),
    [anon_sym_interface] = ACTIONS(2872),
    [anon_sym_enum] = ACTIONS(2872),
    [sym_readonly] = ACTIONS(2872),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(2874),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2876),
    [anon_sym_default] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_typeof] = ACTIONS(2876),
    [anon_sym_import] = ACTIONS(2876),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2876),
    [anon_sym_switch] = ACTIONS(2876),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_await] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_do] = ACTIONS(2876),
    [anon_sym_try] = ACTIONS(2876),
    [anon_sym_with] = ACTIONS(2876),
    [anon_sym_break] = ACTIONS(2876),
    [anon_sym_continue] = ACTIONS(2876),
    [anon_sym_debugger] = ACTIONS(2876),
    [anon_sym_return] = ACTIONS(2876),
    [anon_sym_throw] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_case] = ACTIONS(2876),
    [anon_sym_yield] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2874),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_class] = ACTIONS(2876),
    [anon_sym_async] = ACTIONS(2876),
    [anon_sym_function] = ACTIONS(2876),
    [anon_sym_new] = ACTIONS(2876),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_void] = ACTIONS(2876),
    [anon_sym_delete] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2874),
    [sym_number] = ACTIONS(2874),
    [sym_this] = ACTIONS(2876),
    [sym_super] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_null] = ACTIONS(2876),
    [sym_undefined] = ACTIONS(2876),
    [anon_sym_AT] = ACTIONS(2874),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2876),
    [anon_sym_get] = ACTIONS(2876),
    [anon_sym_set] = ACTIONS(2876),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2876),
    [anon_sym_private] = ACTIONS(2876),
    [anon_sym_protected] = ACTIONS(2876),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_interface] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
    [sym_readonly] = ACTIONS(2876),
  },
  [571] = {
    [sym_object] = STATE(2429),
    [sym_array] = STATE(2433),
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(2880),
  },
  [572] = {
    [sym__call_signature] = STATE(2989),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2696),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2696),
    [anon_sym_function] = ACTIONS(2700),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2696),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_get] = ACTIONS(2696),
    [anon_sym_set] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2696),
    [anon_sym_private] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(2696),
    [anon_sym_number] = ACTIONS(2696),
    [anon_sym_boolean] = ACTIONS(2696),
    [anon_sym_string] = ACTIONS(2696),
    [anon_sym_symbol] = ACTIONS(2696),
    [sym_readonly] = ACTIONS(2696),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_typeof] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_var] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_await] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_with] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_debugger] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_async] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_void] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2887),
    [sym_number] = ACTIONS(2887),
    [sym_this] = ACTIONS(2889),
    [sym_super] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_null] = ACTIONS(2889),
    [sym_undefined] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_get] = ACTIONS(2889),
    [anon_sym_set] = ACTIONS(2889),
    [anon_sym_declare] = ACTIONS(2889),
    [anon_sym_public] = ACTIONS(2889),
    [anon_sym_private] = ACTIONS(2889),
    [anon_sym_protected] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_any] = ACTIONS(2889),
    [anon_sym_number] = ACTIONS(2889),
    [anon_sym_boolean] = ACTIONS(2889),
    [anon_sym_string] = ACTIONS(2889),
    [anon_sym_symbol] = ACTIONS(2889),
    [anon_sym_interface] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [sym_readonly] = ACTIONS(2889),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [sym_number] = ACTIONS(2891),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_readonly] = ACTIONS(2893),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_export] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_typeof] = ACTIONS(2897),
    [anon_sym_import] = ACTIONS(2897),
    [anon_sym_var] = ACTIONS(2897),
    [anon_sym_let] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_with] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_debugger] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_throw] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LT] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_this] = ACTIONS(2897),
    [sym_super] = ACTIONS(2897),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [sym_null] = ACTIONS(2897),
    [sym_undefined] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2897),
    [anon_sym_get] = ACTIONS(2897),
    [anon_sym_set] = ACTIONS(2897),
    [anon_sym_declare] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2897),
    [anon_sym_private] = ACTIONS(2897),
    [anon_sym_protected] = ACTIONS(2897),
    [anon_sym_module] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_interface] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [sym_readonly] = ACTIONS(2897),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_type] = ACTIONS(2901),
    [anon_sym_typeof] = ACTIONS(2901),
    [anon_sym_import] = ACTIONS(2901),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_await] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_with] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_debugger] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_yield] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_async] = ACTIONS(2901),
    [anon_sym_function] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_void] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [sym_number] = ACTIONS(2899),
    [sym_this] = ACTIONS(2901),
    [sym_super] = ACTIONS(2901),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [sym_null] = ACTIONS(2901),
    [sym_undefined] = ACTIONS(2901),
    [anon_sym_AT] = ACTIONS(2899),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_abstract] = ACTIONS(2901),
    [anon_sym_get] = ACTIONS(2901),
    [anon_sym_set] = ACTIONS(2901),
    [anon_sym_declare] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_module] = ACTIONS(2901),
    [anon_sym_any] = ACTIONS(2901),
    [anon_sym_number] = ACTIONS(2901),
    [anon_sym_boolean] = ACTIONS(2901),
    [anon_sym_string] = ACTIONS(2901),
    [anon_sym_symbol] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [sym_readonly] = ACTIONS(2901),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_export] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_type] = ACTIONS(2905),
    [anon_sym_typeof] = ACTIONS(2905),
    [anon_sym_import] = ACTIONS(2905),
    [anon_sym_var] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_await] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_debugger] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_yield] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_async] = ACTIONS(2905),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_void] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2903),
    [sym_number] = ACTIONS(2903),
    [sym_this] = ACTIONS(2905),
    [sym_super] = ACTIONS(2905),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [sym_null] = ACTIONS(2905),
    [sym_undefined] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_abstract] = ACTIONS(2905),
    [anon_sym_get] = ACTIONS(2905),
    [anon_sym_set] = ACTIONS(2905),
    [anon_sym_declare] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_module] = ACTIONS(2905),
    [anon_sym_any] = ACTIONS(2905),
    [anon_sym_number] = ACTIONS(2905),
    [anon_sym_boolean] = ACTIONS(2905),
    [anon_sym_string] = ACTIONS(2905),
    [anon_sym_symbol] = ACTIONS(2905),
    [anon_sym_interface] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [sym_readonly] = ACTIONS(2905),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_export] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2909),
    [anon_sym_namespace] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_typeof] = ACTIONS(2909),
    [anon_sym_import] = ACTIONS(2909),
    [anon_sym_var] = ACTIONS(2909),
    [anon_sym_let] = ACTIONS(2909),
    [anon_sym_const] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_switch] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_await] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [anon_sym_with] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_debugger] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_throw] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_yield] = ACTIONS(2909),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_class] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_function] = ACTIONS(2909),
    [anon_sym_new] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_void] = ACTIONS(2909),
    [anon_sym_delete] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2907),
    [sym_number] = ACTIONS(2907),
    [sym_this] = ACTIONS(2909),
    [sym_super] = ACTIONS(2909),
    [sym_true] = ACTIONS(2909),
    [sym_false] = ACTIONS(2909),
    [sym_null] = ACTIONS(2909),
    [sym_undefined] = ACTIONS(2909),
    [anon_sym_AT] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2909),
    [anon_sym_abstract] = ACTIONS(2909),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_declare] = ACTIONS(2909),
    [anon_sym_public] = ACTIONS(2909),
    [anon_sym_private] = ACTIONS(2909),
    [anon_sym_protected] = ACTIONS(2909),
    [anon_sym_module] = ACTIONS(2909),
    [anon_sym_any] = ACTIONS(2909),
    [anon_sym_number] = ACTIONS(2909),
    [anon_sym_boolean] = ACTIONS(2909),
    [anon_sym_string] = ACTIONS(2909),
    [anon_sym_symbol] = ACTIONS(2909),
    [anon_sym_interface] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2909),
    [sym_readonly] = ACTIONS(2909),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_export] = ACTIONS(2913),
    [anon_sym_default] = ACTIONS(2913),
    [anon_sym_namespace] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_type] = ACTIONS(2913),
    [anon_sym_typeof] = ACTIONS(2913),
    [anon_sym_import] = ACTIONS(2913),
    [anon_sym_var] = ACTIONS(2913),
    [anon_sym_let] = ACTIONS(2913),
    [anon_sym_const] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_await] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_with] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_debugger] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_throw] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2913),
    [anon_sym_yield] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_function] = ACTIONS(2913),
    [anon_sym_new] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_TILDE] = ACTIONS(2911),
    [anon_sym_void] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_DQUOTE] = ACTIONS(2911),
    [anon_sym_SQUOTE] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2911),
    [sym_number] = ACTIONS(2911),
    [sym_this] = ACTIONS(2913),
    [sym_super] = ACTIONS(2913),
    [sym_true] = ACTIONS(2913),
    [sym_false] = ACTIONS(2913),
    [sym_null] = ACTIONS(2913),
    [sym_undefined] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_abstract] = ACTIONS(2913),
    [anon_sym_get] = ACTIONS(2913),
    [anon_sym_set] = ACTIONS(2913),
    [anon_sym_declare] = ACTIONS(2913),
    [anon_sym_public] = ACTIONS(2913),
    [anon_sym_private] = ACTIONS(2913),
    [anon_sym_protected] = ACTIONS(2913),
    [anon_sym_module] = ACTIONS(2913),
    [anon_sym_any] = ACTIONS(2913),
    [anon_sym_number] = ACTIONS(2913),
    [anon_sym_boolean] = ACTIONS(2913),
    [anon_sym_string] = ACTIONS(2913),
    [anon_sym_symbol] = ACTIONS(2913),
    [anon_sym_interface] = ACTIONS(2913),
    [anon_sym_enum] = ACTIONS(2913),
    [sym_readonly] = ACTIONS(2913),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(2917),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2919),
    [anon_sym_typeof] = ACTIONS(2919),
    [anon_sym_import] = ACTIONS(2919),
    [anon_sym_var] = ACTIONS(2919),
    [anon_sym_let] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2919),
    [anon_sym_switch] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_await] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_with] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_debugger] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_throw] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_case] = ACTIONS(2919),
    [anon_sym_yield] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_async] = ACTIONS(2919),
    [anon_sym_function] = ACTIONS(2919),
    [anon_sym_new] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_void] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2917),
    [sym_number] = ACTIONS(2917),
    [sym_this] = ACTIONS(2919),
    [sym_super] = ACTIONS(2919),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [sym_null] = ACTIONS(2919),
    [sym_undefined] = ACTIONS(2919),
    [anon_sym_AT] = ACTIONS(2917),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_abstract] = ACTIONS(2919),
    [anon_sym_get] = ACTIONS(2919),
    [anon_sym_set] = ACTIONS(2919),
    [anon_sym_declare] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_any] = ACTIONS(2919),
    [anon_sym_number] = ACTIONS(2919),
    [anon_sym_boolean] = ACTIONS(2919),
    [anon_sym_string] = ACTIONS(2919),
    [anon_sym_symbol] = ACTIONS(2919),
    [anon_sym_interface] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [sym_readonly] = ACTIONS(2919),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1181),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(1183),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_typeof] = ACTIONS(1183),
    [anon_sym_import] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(1183),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_const] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_try] = ACTIONS(1183),
    [anon_sym_with] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [anon_sym_debugger] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_throw] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1183),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_function] = ACTIONS(1183),
    [anon_sym_new] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1181),
    [anon_sym_TILDE] = ACTIONS(1181),
    [anon_sym_void] = ACTIONS(1183),
    [anon_sym_delete] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [sym_number] = ACTIONS(1181),
    [sym_this] = ACTIONS(1183),
    [sym_super] = ACTIONS(1183),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1183),
    [anon_sym_abstract] = ACTIONS(1183),
    [anon_sym_get] = ACTIONS(1183),
    [anon_sym_set] = ACTIONS(1183),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(1183),
    [anon_sym_private] = ACTIONS(1183),
    [anon_sym_protected] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [anon_sym_any] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_boolean] = ACTIONS(1183),
    [anon_sym_string] = ACTIONS(1183),
    [anon_sym_symbol] = ACTIONS(1183),
    [anon_sym_interface] = ACTIONS(1183),
    [anon_sym_enum] = ACTIONS(1183),
    [sym_readonly] = ACTIONS(1183),
  },
  [583] = {
    [sym_object] = STATE(2429),
    [sym_array] = STATE(2433),
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(2880),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(2921),
    [sym_identifier] = ACTIONS(2923),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_default] = ACTIONS(2923),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_type] = ACTIONS(2923),
    [anon_sym_typeof] = ACTIONS(2923),
    [anon_sym_import] = ACTIONS(2923),
    [anon_sym_var] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_debugger] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_throw] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_case] = ACTIONS(2923),
    [anon_sym_yield] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_async] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_void] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2921),
    [sym_number] = ACTIONS(2921),
    [sym_this] = ACTIONS(2923),
    [sym_super] = ACTIONS(2923),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [sym_null] = ACTIONS(2923),
    [sym_undefined] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_abstract] = ACTIONS(2923),
    [anon_sym_get] = ACTIONS(2923),
    [anon_sym_set] = ACTIONS(2923),
    [anon_sym_declare] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_any] = ACTIONS(2923),
    [anon_sym_number] = ACTIONS(2923),
    [anon_sym_boolean] = ACTIONS(2923),
    [anon_sym_string] = ACTIONS(2923),
    [anon_sym_symbol] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [sym_readonly] = ACTIONS(2923),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(2925),
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2927),
    [anon_sym_import] = ACTIONS(2927),
    [anon_sym_var] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_await] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_debugger] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_yield] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_async] = ACTIONS(2927),
    [anon_sym_function] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_void] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2925),
    [sym_number] = ACTIONS(2925),
    [sym_this] = ACTIONS(2927),
    [sym_super] = ACTIONS(2927),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_undefined] = ACTIONS(2927),
    [anon_sym_AT] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_abstract] = ACTIONS(2927),
    [anon_sym_get] = ACTIONS(2927),
    [anon_sym_set] = ACTIONS(2927),
    [anon_sym_declare] = ACTIONS(2927),
    [anon_sym_public] = ACTIONS(2927),
    [anon_sym_private] = ACTIONS(2927),
    [anon_sym_protected] = ACTIONS(2927),
    [anon_sym_module] = ACTIONS(2927),
    [anon_sym_any] = ACTIONS(2927),
    [anon_sym_number] = ACTIONS(2927),
    [anon_sym_boolean] = ACTIONS(2927),
    [anon_sym_string] = ACTIONS(2927),
    [anon_sym_symbol] = ACTIONS(2927),
    [anon_sym_interface] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [sym_readonly] = ACTIONS(2927),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(2929),
    [sym_identifier] = ACTIONS(2931),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_default] = ACTIONS(2931),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2931),
    [anon_sym_typeof] = ACTIONS(2931),
    [anon_sym_import] = ACTIONS(2931),
    [anon_sym_var] = ACTIONS(2931),
    [anon_sym_let] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_switch] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_await] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_with] = ACTIONS(2931),
    [anon_sym_break] = ACTIONS(2931),
    [anon_sym_continue] = ACTIONS(2931),
    [anon_sym_debugger] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_throw] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_yield] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_async] = ACTIONS(2931),
    [anon_sym_function] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_void] = ACTIONS(2931),
    [anon_sym_delete] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2929),
    [sym_number] = ACTIONS(2929),
    [sym_this] = ACTIONS(2931),
    [sym_super] = ACTIONS(2931),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [sym_null] = ACTIONS(2931),
    [sym_undefined] = ACTIONS(2931),
    [anon_sym_AT] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_abstract] = ACTIONS(2931),
    [anon_sym_get] = ACTIONS(2931),
    [anon_sym_set] = ACTIONS(2931),
    [anon_sym_declare] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_any] = ACTIONS(2931),
    [anon_sym_number] = ACTIONS(2931),
    [anon_sym_boolean] = ACTIONS(2931),
    [anon_sym_string] = ACTIONS(2931),
    [anon_sym_symbol] = ACTIONS(2931),
    [anon_sym_interface] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [sym_readonly] = ACTIONS(2931),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(2933),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2935),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_import] = ACTIONS(2935),
    [anon_sym_var] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_else] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2933),
    [anon_sym_await] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [anon_sym_do] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_debugger] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_throw] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_case] = ACTIONS(2935),
    [anon_sym_yield] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_function] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_void] = ACTIONS(2935),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2933),
    [sym_number] = ACTIONS(2933),
    [sym_this] = ACTIONS(2935),
    [sym_super] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_null] = ACTIONS(2935),
    [sym_undefined] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(2933),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_abstract] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2935),
    [anon_sym_private] = ACTIONS(2935),
    [anon_sym_protected] = ACTIONS(2935),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2935),
    [anon_sym_number] = ACTIONS(2935),
    [anon_sym_boolean] = ACTIONS(2935),
    [anon_sym_string] = ACTIONS(2935),
    [anon_sym_symbol] = ACTIONS(2935),
    [anon_sym_interface] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [sym_readonly] = ACTIONS(2935),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(2937),
    [sym_identifier] = ACTIONS(2939),
    [anon_sym_export] = ACTIONS(2939),
    [anon_sym_default] = ACTIONS(2939),
    [anon_sym_namespace] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2939),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_import] = ACTIONS(2939),
    [anon_sym_var] = ACTIONS(2939),
    [anon_sym_let] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_else] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_do] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_with] = ACTIONS(2939),
    [anon_sym_break] = ACTIONS(2939),
    [anon_sym_continue] = ACTIONS(2939),
    [anon_sym_debugger] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_throw] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2939),
    [anon_sym_yield] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_async] = ACTIONS(2939),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_delete] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2937),
    [anon_sym_DASH_DASH] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2937),
    [sym_number] = ACTIONS(2937),
    [sym_this] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [sym_null] = ACTIONS(2939),
    [sym_undefined] = ACTIONS(2939),
    [anon_sym_AT] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_abstract] = ACTIONS(2939),
    [anon_sym_get] = ACTIONS(2939),
    [anon_sym_set] = ACTIONS(2939),
    [anon_sym_declare] = ACTIONS(2939),
    [anon_sym_public] = ACTIONS(2939),
    [anon_sym_private] = ACTIONS(2939),
    [anon_sym_protected] = ACTIONS(2939),
    [anon_sym_module] = ACTIONS(2939),
    [anon_sym_any] = ACTIONS(2939),
    [anon_sym_number] = ACTIONS(2939),
    [anon_sym_boolean] = ACTIONS(2939),
    [anon_sym_string] = ACTIONS(2939),
    [anon_sym_symbol] = ACTIONS(2939),
    [anon_sym_interface] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [sym_readonly] = ACTIONS(2939),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2941),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_export] = ACTIONS(2943),
    [anon_sym_default] = ACTIONS(2943),
    [anon_sym_namespace] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_type] = ACTIONS(2943),
    [anon_sym_typeof] = ACTIONS(2943),
    [anon_sym_import] = ACTIONS(2943),
    [anon_sym_var] = ACTIONS(2943),
    [anon_sym_let] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_else] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_await] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [anon_sym_do] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_with] = ACTIONS(2943),
    [anon_sym_break] = ACTIONS(2943),
    [anon_sym_continue] = ACTIONS(2943),
    [anon_sym_debugger] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_throw] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym_case] = ACTIONS(2943),
    [anon_sym_yield] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2943),
    [anon_sym_async] = ACTIONS(2943),
    [anon_sym_function] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_void] = ACTIONS(2943),
    [anon_sym_delete] = ACTIONS(2943),
    [anon_sym_PLUS_PLUS] = ACTIONS(2941),
    [anon_sym_DASH_DASH] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [sym_number] = ACTIONS(2941),
    [sym_this] = ACTIONS(2943),
    [sym_super] = ACTIONS(2943),
    [sym_true] = ACTIONS(2943),
    [sym_false] = ACTIONS(2943),
    [sym_null] = ACTIONS(2943),
    [sym_undefined] = ACTIONS(2943),
    [anon_sym_AT] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2943),
    [anon_sym_abstract] = ACTIONS(2943),
    [anon_sym_get] = ACTIONS(2943),
    [anon_sym_set] = ACTIONS(2943),
    [anon_sym_declare] = ACTIONS(2943),
    [anon_sym_public] = ACTIONS(2943),
    [anon_sym_private] = ACTIONS(2943),
    [anon_sym_protected] = ACTIONS(2943),
    [anon_sym_module] = ACTIONS(2943),
    [anon_sym_any] = ACTIONS(2943),
    [anon_sym_number] = ACTIONS(2943),
    [anon_sym_boolean] = ACTIONS(2943),
    [anon_sym_string] = ACTIONS(2943),
    [anon_sym_symbol] = ACTIONS(2943),
    [anon_sym_interface] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(2943),
    [sym_readonly] = ACTIONS(2943),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2945),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2947),
    [anon_sym_default] = ACTIONS(2947),
    [anon_sym_namespace] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_type] = ACTIONS(2947),
    [anon_sym_typeof] = ACTIONS(2947),
    [anon_sym_import] = ACTIONS(2947),
    [anon_sym_var] = ACTIONS(2947),
    [anon_sym_let] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_await] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_with] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_debugger] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_throw] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2947),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2947),
    [anon_sym_async] = ACTIONS(2947),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_void] = ACTIONS(2947),
    [anon_sym_delete] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [sym_number] = ACTIONS(2945),
    [sym_this] = ACTIONS(2947),
    [sym_super] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_null] = ACTIONS(2947),
    [sym_undefined] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2947),
    [anon_sym_abstract] = ACTIONS(2947),
    [anon_sym_get] = ACTIONS(2947),
    [anon_sym_set] = ACTIONS(2947),
    [anon_sym_declare] = ACTIONS(2947),
    [anon_sym_public] = ACTIONS(2947),
    [anon_sym_private] = ACTIONS(2947),
    [anon_sym_protected] = ACTIONS(2947),
    [anon_sym_module] = ACTIONS(2947),
    [anon_sym_any] = ACTIONS(2947),
    [anon_sym_number] = ACTIONS(2947),
    [anon_sym_boolean] = ACTIONS(2947),
    [anon_sym_string] = ACTIONS(2947),
    [anon_sym_symbol] = ACTIONS(2947),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [sym_readonly] = ACTIONS(2947),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2949),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2951),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_type] = ACTIONS(2951),
    [anon_sym_typeof] = ACTIONS(2951),
    [anon_sym_import] = ACTIONS(2951),
    [anon_sym_var] = ACTIONS(2951),
    [anon_sym_let] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_else] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2949),
    [anon_sym_await] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [anon_sym_do] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_with] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_debugger] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_throw] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_function] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_delete] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2949),
    [sym_number] = ACTIONS(2949),
    [sym_this] = ACTIONS(2951),
    [sym_super] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_null] = ACTIONS(2951),
    [sym_undefined] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2951),
    [anon_sym_abstract] = ACTIONS(2951),
    [anon_sym_get] = ACTIONS(2951),
    [anon_sym_set] = ACTIONS(2951),
    [anon_sym_declare] = ACTIONS(2951),
    [anon_sym_public] = ACTIONS(2951),
    [anon_sym_private] = ACTIONS(2951),
    [anon_sym_protected] = ACTIONS(2951),
    [anon_sym_module] = ACTIONS(2951),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [anon_sym_interface] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2951),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2953),
    [sym_identifier] = ACTIONS(2955),
    [anon_sym_export] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_namespace] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_type] = ACTIONS(2955),
    [anon_sym_typeof] = ACTIONS(2955),
    [anon_sym_import] = ACTIONS(2955),
    [anon_sym_var] = ACTIONS(2955),
    [anon_sym_let] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_else] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2953),
    [anon_sym_await] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [anon_sym_do] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_with] = ACTIONS(2955),
    [anon_sym_break] = ACTIONS(2955),
    [anon_sym_continue] = ACTIONS(2955),
    [anon_sym_debugger] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_throw] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_yield] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2953),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_async] = ACTIONS(2955),
    [anon_sym_function] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2953),
    [anon_sym_void] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2953),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_super] = ACTIONS(2955),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [sym_null] = ACTIONS(2955),
    [sym_undefined] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_abstract] = ACTIONS(2955),
    [anon_sym_get] = ACTIONS(2955),
    [anon_sym_set] = ACTIONS(2955),
    [anon_sym_declare] = ACTIONS(2955),
    [anon_sym_public] = ACTIONS(2955),
    [anon_sym_private] = ACTIONS(2955),
    [anon_sym_protected] = ACTIONS(2955),
    [anon_sym_module] = ACTIONS(2955),
    [anon_sym_any] = ACTIONS(2955),
    [anon_sym_number] = ACTIONS(2955),
    [anon_sym_boolean] = ACTIONS(2955),
    [anon_sym_string] = ACTIONS(2955),
    [anon_sym_symbol] = ACTIONS(2955),
    [anon_sym_interface] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [sym_readonly] = ACTIONS(2955),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2957),
    [sym_identifier] = ACTIONS(2959),
    [anon_sym_export] = ACTIONS(2959),
    [anon_sym_default] = ACTIONS(2959),
    [anon_sym_namespace] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_type] = ACTIONS(2959),
    [anon_sym_typeof] = ACTIONS(2959),
    [anon_sym_import] = ACTIONS(2959),
    [anon_sym_var] = ACTIONS(2959),
    [anon_sym_let] = ACTIONS(2959),
    [anon_sym_const] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2959),
    [anon_sym_switch] = ACTIONS(2959),
    [anon_sym_for] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym_await] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_try] = ACTIONS(2959),
    [anon_sym_with] = ACTIONS(2959),
    [anon_sym_break] = ACTIONS(2959),
    [anon_sym_continue] = ACTIONS(2959),
    [anon_sym_debugger] = ACTIONS(2959),
    [anon_sym_return] = ACTIONS(2959),
    [anon_sym_throw] = ACTIONS(2959),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym_case] = ACTIONS(2959),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_class] = ACTIONS(2959),
    [anon_sym_async] = ACTIONS(2959),
    [anon_sym_function] = ACTIONS(2959),
    [anon_sym_new] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_void] = ACTIONS(2959),
    [anon_sym_delete] = ACTIONS(2959),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2957),
    [sym_number] = ACTIONS(2957),
    [sym_this] = ACTIONS(2959),
    [sym_super] = ACTIONS(2959),
    [sym_true] = ACTIONS(2959),
    [sym_false] = ACTIONS(2959),
    [sym_null] = ACTIONS(2959),
    [sym_undefined] = ACTIONS(2959),
    [anon_sym_AT] = ACTIONS(2957),
    [anon_sym_static] = ACTIONS(2959),
    [anon_sym_abstract] = ACTIONS(2959),
    [anon_sym_get] = ACTIONS(2959),
    [anon_sym_set] = ACTIONS(2959),
    [anon_sym_declare] = ACTIONS(2959),
    [anon_sym_public] = ACTIONS(2959),
    [anon_sym_private] = ACTIONS(2959),
    [anon_sym_protected] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2959),
    [anon_sym_any] = ACTIONS(2959),
    [anon_sym_number] = ACTIONS(2959),
    [anon_sym_boolean] = ACTIONS(2959),
    [anon_sym_string] = ACTIONS(2959),
    [anon_sym_symbol] = ACTIONS(2959),
    [anon_sym_interface] = ACTIONS(2959),
    [anon_sym_enum] = ACTIONS(2959),
    [sym_readonly] = ACTIONS(2959),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2961),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_export] = ACTIONS(2963),
    [anon_sym_default] = ACTIONS(2963),
    [anon_sym_namespace] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2961),
    [anon_sym_RBRACE] = ACTIONS(2961),
    [anon_sym_type] = ACTIONS(2963),
    [anon_sym_typeof] = ACTIONS(2963),
    [anon_sym_import] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_const] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_switch] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_await] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_try] = ACTIONS(2963),
    [anon_sym_with] = ACTIONS(2963),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_continue] = ACTIONS(2963),
    [anon_sym_debugger] = ACTIONS(2963),
    [anon_sym_return] = ACTIONS(2963),
    [anon_sym_throw] = ACTIONS(2963),
    [anon_sym_SEMI] = ACTIONS(2961),
    [anon_sym_case] = ACTIONS(2963),
    [anon_sym_yield] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2963),
    [anon_sym_class] = ACTIONS(2963),
    [anon_sym_async] = ACTIONS(2963),
    [anon_sym_function] = ACTIONS(2963),
    [anon_sym_new] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2961),
    [anon_sym_void] = ACTIONS(2963),
    [anon_sym_delete] = ACTIONS(2963),
    [anon_sym_PLUS_PLUS] = ACTIONS(2961),
    [anon_sym_DASH_DASH] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2961),
    [sym_number] = ACTIONS(2961),
    [sym_this] = ACTIONS(2963),
    [sym_super] = ACTIONS(2963),
    [sym_true] = ACTIONS(2963),
    [sym_false] = ACTIONS(2963),
    [sym_null] = ACTIONS(2963),
    [sym_undefined] = ACTIONS(2963),
    [anon_sym_AT] = ACTIONS(2961),
    [anon_sym_static] = ACTIONS(2963),
    [anon_sym_abstract] = ACTIONS(2963),
    [anon_sym_get] = ACTIONS(2963),
    [anon_sym_set] = ACTIONS(2963),
    [anon_sym_declare] = ACTIONS(2963),
    [anon_sym_public] = ACTIONS(2963),
    [anon_sym_private] = ACTIONS(2963),
    [anon_sym_protected] = ACTIONS(2963),
    [anon_sym_module] = ACTIONS(2963),
    [anon_sym_any] = ACTIONS(2963),
    [anon_sym_number] = ACTIONS(2963),
    [anon_sym_boolean] = ACTIONS(2963),
    [anon_sym_string] = ACTIONS(2963),
    [anon_sym_symbol] = ACTIONS(2963),
    [anon_sym_interface] = ACTIONS(2963),
    [anon_sym_enum] = ACTIONS(2963),
    [sym_readonly] = ACTIONS(2963),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_export] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_type] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2967),
    [anon_sym_import] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_await] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_with] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_debugger] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2965),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_function] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2965),
    [anon_sym_void] = ACTIONS(2967),
    [anon_sym_delete] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2965),
    [anon_sym_DASH_DASH] = ACTIONS(2965),
    [anon_sym_DQUOTE] = ACTIONS(2965),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2965),
    [sym_number] = ACTIONS(2965),
    [sym_this] = ACTIONS(2967),
    [sym_super] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_null] = ACTIONS(2967),
    [sym_undefined] = ACTIONS(2967),
    [anon_sym_AT] = ACTIONS(2965),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_get] = ACTIONS(2967),
    [anon_sym_set] = ACTIONS(2967),
    [anon_sym_declare] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_module] = ACTIONS(2967),
    [anon_sym_any] = ACTIONS(2967),
    [anon_sym_number] = ACTIONS(2967),
    [anon_sym_boolean] = ACTIONS(2967),
    [anon_sym_string] = ACTIONS(2967),
    [anon_sym_symbol] = ACTIONS(2967),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [sym_readonly] = ACTIONS(2967),
  },
  [596] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2969),
    [sym_identifier] = ACTIONS(2971),
    [anon_sym_export] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_type] = ACTIONS(2971),
    [anon_sym_typeof] = ACTIONS(2971),
    [anon_sym_import] = ACTIONS(2971),
    [anon_sym_var] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_await] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_with] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_debugger] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_yield] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_async] = ACTIONS(2971),
    [anon_sym_function] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_void] = ACTIONS(2971),
    [anon_sym_delete] = ACTIONS(2971),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2969),
    [sym_number] = ACTIONS(2969),
    [sym_this] = ACTIONS(2971),
    [sym_super] = ACTIONS(2971),
    [sym_true] = ACTIONS(2971),
    [sym_false] = ACTIONS(2971),
    [sym_null] = ACTIONS(2971),
    [sym_undefined] = ACTIONS(2971),
    [anon_sym_AT] = ACTIONS(2969),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_abstract] = ACTIONS(2971),
    [anon_sym_get] = ACTIONS(2971),
    [anon_sym_set] = ACTIONS(2971),
    [anon_sym_declare] = ACTIONS(2971),
    [anon_sym_public] = ACTIONS(2971),
    [anon_sym_private] = ACTIONS(2971),
    [anon_sym_protected] = ACTIONS(2971),
    [anon_sym_module] = ACTIONS(2971),
    [anon_sym_any] = ACTIONS(2971),
    [anon_sym_number] = ACTIONS(2971),
    [anon_sym_boolean] = ACTIONS(2971),
    [anon_sym_string] = ACTIONS(2971),
    [anon_sym_symbol] = ACTIONS(2971),
    [anon_sym_interface] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [sym_readonly] = ACTIONS(2971),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2973),
    [sym_identifier] = ACTIONS(2975),
    [anon_sym_export] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_type] = ACTIONS(2975),
    [anon_sym_typeof] = ACTIONS(2975),
    [anon_sym_import] = ACTIONS(2975),
    [anon_sym_var] = ACTIONS(2975),
    [anon_sym_let] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_await] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_with] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_debugger] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_case] = ACTIONS(2975),
    [anon_sym_yield] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_function] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_void] = ACTIONS(2975),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2973),
    [sym_number] = ACTIONS(2973),
    [sym_this] = ACTIONS(2975),
    [sym_super] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_null] = ACTIONS(2975),
    [sym_undefined] = ACTIONS(2975),
    [anon_sym_AT] = ACTIONS(2973),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_abstract] = ACTIONS(2975),
    [anon_sym_get] = ACTIONS(2975),
    [anon_sym_set] = ACTIONS(2975),
    [anon_sym_declare] = ACTIONS(2975),
    [anon_sym_public] = ACTIONS(2975),
    [anon_sym_private] = ACTIONS(2975),
    [anon_sym_protected] = ACTIONS(2975),
    [anon_sym_module] = ACTIONS(2975),
    [anon_sym_any] = ACTIONS(2975),
    [anon_sym_number] = ACTIONS(2975),
    [anon_sym_boolean] = ACTIONS(2975),
    [anon_sym_string] = ACTIONS(2975),
    [anon_sym_symbol] = ACTIONS(2975),
    [anon_sym_interface] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [sym_readonly] = ACTIONS(2975),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2977),
    [sym_identifier] = ACTIONS(2979),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_type] = ACTIONS(2979),
    [anon_sym_typeof] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2979),
    [anon_sym_var] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_debugger] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_case] = ACTIONS(2979),
    [anon_sym_yield] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_async] = ACTIONS(2979),
    [anon_sym_function] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_void] = ACTIONS(2979),
    [anon_sym_delete] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2977),
    [sym_number] = ACTIONS(2977),
    [sym_this] = ACTIONS(2979),
    [sym_super] = ACTIONS(2979),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [sym_null] = ACTIONS(2979),
    [sym_undefined] = ACTIONS(2979),
    [anon_sym_AT] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2979),
    [anon_sym_get] = ACTIONS(2979),
    [anon_sym_set] = ACTIONS(2979),
    [anon_sym_declare] = ACTIONS(2979),
    [anon_sym_public] = ACTIONS(2979),
    [anon_sym_private] = ACTIONS(2979),
    [anon_sym_protected] = ACTIONS(2979),
    [anon_sym_module] = ACTIONS(2979),
    [anon_sym_any] = ACTIONS(2979),
    [anon_sym_number] = ACTIONS(2979),
    [anon_sym_boolean] = ACTIONS(2979),
    [anon_sym_string] = ACTIONS(2979),
    [anon_sym_symbol] = ACTIONS(2979),
    [anon_sym_interface] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [sym_readonly] = ACTIONS(2979),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2981),
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_default] = ACTIONS(2983),
    [anon_sym_namespace] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_type] = ACTIONS(2983),
    [anon_sym_typeof] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_var] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_await] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [anon_sym_break] = ACTIONS(2983),
    [anon_sym_continue] = ACTIONS(2983),
    [anon_sym_debugger] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_throw] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_case] = ACTIONS(2983),
    [anon_sym_yield] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2983),
    [anon_sym_class] = ACTIONS(2983),
    [anon_sym_async] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_new] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(2983),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_void] = ACTIONS(2983),
    [anon_sym_delete] = ACTIONS(2983),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2981),
    [sym_number] = ACTIONS(2981),
    [sym_this] = ACTIONS(2983),
    [sym_super] = ACTIONS(2983),
    [sym_true] = ACTIONS(2983),
    [sym_false] = ACTIONS(2983),
    [sym_null] = ACTIONS(2983),
    [sym_undefined] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2981),
    [anon_sym_static] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_get] = ACTIONS(2983),
    [anon_sym_set] = ACTIONS(2983),
    [anon_sym_declare] = ACTIONS(2983),
    [anon_sym_public] = ACTIONS(2983),
    [anon_sym_private] = ACTIONS(2983),
    [anon_sym_protected] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_any] = ACTIONS(2983),
    [anon_sym_number] = ACTIONS(2983),
    [anon_sym_boolean] = ACTIONS(2983),
    [anon_sym_string] = ACTIONS(2983),
    [anon_sym_symbol] = ACTIONS(2983),
    [anon_sym_interface] = ACTIONS(2983),
    [anon_sym_enum] = ACTIONS(2983),
    [sym_readonly] = ACTIONS(2983),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2985),
    [sym_identifier] = ACTIONS(2987),
    [anon_sym_export] = ACTIONS(2987),
    [anon_sym_default] = ACTIONS(2987),
    [anon_sym_namespace] = ACTIONS(2987),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2987),
    [anon_sym_typeof] = ACTIONS(2987),
    [anon_sym_import] = ACTIONS(2987),
    [anon_sym_var] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_const] = ACTIONS(2987),
    [anon_sym_if] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_for] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2987),
    [anon_sym_while] = ACTIONS(2987),
    [anon_sym_do] = ACTIONS(2987),
    [anon_sym_try] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [anon_sym_break] = ACTIONS(2987),
    [anon_sym_continue] = ACTIONS(2987),
    [anon_sym_debugger] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2987),
    [anon_sym_throw] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2987),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2987),
    [anon_sym_class] = ACTIONS(2987),
    [anon_sym_async] = ACTIONS(2987),
    [anon_sym_function] = ACTIONS(2987),
    [anon_sym_new] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_void] = ACTIONS(2987),
    [anon_sym_delete] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [sym_number] = ACTIONS(2985),
    [sym_this] = ACTIONS(2987),
    [sym_super] = ACTIONS(2987),
    [sym_true] = ACTIONS(2987),
    [sym_false] = ACTIONS(2987),
    [sym_null] = ACTIONS(2987),
    [sym_undefined] = ACTIONS(2987),
    [anon_sym_AT] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2987),
    [anon_sym_abstract] = ACTIONS(2987),
    [anon_sym_get] = ACTIONS(2987),
    [anon_sym_set] = ACTIONS(2987),
    [anon_sym_declare] = ACTIONS(2987),
    [anon_sym_public] = ACTIONS(2987),
    [anon_sym_private] = ACTIONS(2987),
    [anon_sym_protected] = ACTIONS(2987),
    [anon_sym_module] = ACTIONS(2987),
    [anon_sym_any] = ACTIONS(2987),
    [anon_sym_number] = ACTIONS(2987),
    [anon_sym_boolean] = ACTIONS(2987),
    [anon_sym_string] = ACTIONS(2987),
    [anon_sym_symbol] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2987),
    [anon_sym_enum] = ACTIONS(2987),
    [sym_readonly] = ACTIONS(2987),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2989),
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_export] = ACTIONS(2991),
    [anon_sym_default] = ACTIONS(2991),
    [anon_sym_namespace] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_type] = ACTIONS(2991),
    [anon_sym_typeof] = ACTIONS(2991),
    [anon_sym_import] = ACTIONS(2991),
    [anon_sym_var] = ACTIONS(2991),
    [anon_sym_let] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2991),
    [anon_sym_if] = ACTIONS(2991),
    [anon_sym_else] = ACTIONS(2991),
    [anon_sym_switch] = ACTIONS(2991),
    [anon_sym_for] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_await] = ACTIONS(2991),
    [anon_sym_while] = ACTIONS(2991),
    [anon_sym_do] = ACTIONS(2991),
    [anon_sym_try] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2991),
    [anon_sym_break] = ACTIONS(2991),
    [anon_sym_continue] = ACTIONS(2991),
    [anon_sym_debugger] = ACTIONS(2991),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_throw] = ACTIONS(2991),
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_case] = ACTIONS(2991),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2991),
    [anon_sym_class] = ACTIONS(2991),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_function] = ACTIONS(2991),
    [anon_sym_new] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2991),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_void] = ACTIONS(2991),
    [anon_sym_delete] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2989),
    [sym_number] = ACTIONS(2989),
    [sym_this] = ACTIONS(2991),
    [sym_super] = ACTIONS(2991),
    [sym_true] = ACTIONS(2991),
    [sym_false] = ACTIONS(2991),
    [sym_null] = ACTIONS(2991),
    [sym_undefined] = ACTIONS(2991),
    [anon_sym_AT] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2991),
    [anon_sym_abstract] = ACTIONS(2991),
    [anon_sym_get] = ACTIONS(2991),
    [anon_sym_set] = ACTIONS(2991),
    [anon_sym_declare] = ACTIONS(2991),
    [anon_sym_public] = ACTIONS(2991),
    [anon_sym_private] = ACTIONS(2991),
    [anon_sym_protected] = ACTIONS(2991),
    [anon_sym_module] = ACTIONS(2991),
    [anon_sym_any] = ACTIONS(2991),
    [anon_sym_number] = ACTIONS(2991),
    [anon_sym_boolean] = ACTIONS(2991),
    [anon_sym_string] = ACTIONS(2991),
    [anon_sym_symbol] = ACTIONS(2991),
    [anon_sym_interface] = ACTIONS(2991),
    [anon_sym_enum] = ACTIONS(2991),
    [sym_readonly] = ACTIONS(2991),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(2993),
    [sym_identifier] = ACTIONS(2995),
    [anon_sym_export] = ACTIONS(2995),
    [anon_sym_default] = ACTIONS(2995),
    [anon_sym_namespace] = ACTIONS(2995),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_type] = ACTIONS(2995),
    [anon_sym_typeof] = ACTIONS(2995),
    [anon_sym_import] = ACTIONS(2995),
    [anon_sym_var] = ACTIONS(2995),
    [anon_sym_let] = ACTIONS(2995),
    [anon_sym_const] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2995),
    [anon_sym_else] = ACTIONS(2995),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_for] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_await] = ACTIONS(2995),
    [anon_sym_while] = ACTIONS(2995),
    [anon_sym_do] = ACTIONS(2995),
    [anon_sym_try] = ACTIONS(2995),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_break] = ACTIONS(2995),
    [anon_sym_continue] = ACTIONS(2995),
    [anon_sym_debugger] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2995),
    [anon_sym_throw] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_yield] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(2995),
    [anon_sym_async] = ACTIONS(2995),
    [anon_sym_function] = ACTIONS(2995),
    [anon_sym_new] = ACTIONS(2995),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_void] = ACTIONS(2995),
    [anon_sym_delete] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [sym_number] = ACTIONS(2993),
    [sym_this] = ACTIONS(2995),
    [sym_super] = ACTIONS(2995),
    [sym_true] = ACTIONS(2995),
    [sym_false] = ACTIONS(2995),
    [sym_null] = ACTIONS(2995),
    [sym_undefined] = ACTIONS(2995),
    [anon_sym_AT] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2995),
    [anon_sym_abstract] = ACTIONS(2995),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_declare] = ACTIONS(2995),
    [anon_sym_public] = ACTIONS(2995),
    [anon_sym_private] = ACTIONS(2995),
    [anon_sym_protected] = ACTIONS(2995),
    [anon_sym_module] = ACTIONS(2995),
    [anon_sym_any] = ACTIONS(2995),
    [anon_sym_number] = ACTIONS(2995),
    [anon_sym_boolean] = ACTIONS(2995),
    [anon_sym_string] = ACTIONS(2995),
    [anon_sym_symbol] = ACTIONS(2995),
    [anon_sym_interface] = ACTIONS(2995),
    [anon_sym_enum] = ACTIONS(2995),
    [sym_readonly] = ACTIONS(2995),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(2997),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_export] = ACTIONS(2999),
    [anon_sym_default] = ACTIONS(2999),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_type] = ACTIONS(2999),
    [anon_sym_typeof] = ACTIONS(2999),
    [anon_sym_import] = ACTIONS(2999),
    [anon_sym_var] = ACTIONS(2999),
    [anon_sym_let] = ACTIONS(2999),
    [anon_sym_const] = ACTIONS(2999),
    [anon_sym_if] = ACTIONS(2999),
    [anon_sym_else] = ACTIONS(2999),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_for] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_await] = ACTIONS(2999),
    [anon_sym_while] = ACTIONS(2999),
    [anon_sym_do] = ACTIONS(2999),
    [anon_sym_try] = ACTIONS(2999),
    [anon_sym_with] = ACTIONS(2999),
    [anon_sym_break] = ACTIONS(2999),
    [anon_sym_continue] = ACTIONS(2999),
    [anon_sym_debugger] = ACTIONS(2999),
    [anon_sym_return] = ACTIONS(2999),
    [anon_sym_throw] = ACTIONS(2999),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_case] = ACTIONS(2999),
    [anon_sym_yield] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(2999),
    [anon_sym_async] = ACTIONS(2999),
    [anon_sym_function] = ACTIONS(2999),
    [anon_sym_new] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2999),
    [anon_sym_DASH] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_void] = ACTIONS(2999),
    [anon_sym_delete] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2997),
    [sym_number] = ACTIONS(2997),
    [sym_this] = ACTIONS(2999),
    [sym_super] = ACTIONS(2999),
    [sym_true] = ACTIONS(2999),
    [sym_false] = ACTIONS(2999),
    [sym_null] = ACTIONS(2999),
    [sym_undefined] = ACTIONS(2999),
    [anon_sym_AT] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(2999),
    [anon_sym_abstract] = ACTIONS(2999),
    [anon_sym_get] = ACTIONS(2999),
    [anon_sym_set] = ACTIONS(2999),
    [anon_sym_declare] = ACTIONS(2999),
    [anon_sym_public] = ACTIONS(2999),
    [anon_sym_private] = ACTIONS(2999),
    [anon_sym_protected] = ACTIONS(2999),
    [anon_sym_module] = ACTIONS(2999),
    [anon_sym_any] = ACTIONS(2999),
    [anon_sym_number] = ACTIONS(2999),
    [anon_sym_boolean] = ACTIONS(2999),
    [anon_sym_string] = ACTIONS(2999),
    [anon_sym_symbol] = ACTIONS(2999),
    [anon_sym_interface] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(2999),
    [sym_readonly] = ACTIONS(2999),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_export] = ACTIONS(3003),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_namespace] = ACTIONS(3003),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3003),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_import] = ACTIONS(3003),
    [anon_sym_var] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_const] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_else] = ACTIONS(3003),
    [anon_sym_switch] = ACTIONS(3003),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_await] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_with] = ACTIONS(3003),
    [anon_sym_break] = ACTIONS(3003),
    [anon_sym_continue] = ACTIONS(3003),
    [anon_sym_debugger] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_throw] = ACTIONS(3003),
    [anon_sym_SEMI] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3003),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_async] = ACTIONS(3003),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_void] = ACTIONS(3003),
    [anon_sym_delete] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3001),
    [sym_number] = ACTIONS(3001),
    [sym_this] = ACTIONS(3003),
    [sym_super] = ACTIONS(3003),
    [sym_true] = ACTIONS(3003),
    [sym_false] = ACTIONS(3003),
    [sym_null] = ACTIONS(3003),
    [sym_undefined] = ACTIONS(3003),
    [anon_sym_AT] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3003),
    [anon_sym_abstract] = ACTIONS(3003),
    [anon_sym_get] = ACTIONS(3003),
    [anon_sym_set] = ACTIONS(3003),
    [anon_sym_declare] = ACTIONS(3003),
    [anon_sym_public] = ACTIONS(3003),
    [anon_sym_private] = ACTIONS(3003),
    [anon_sym_protected] = ACTIONS(3003),
    [anon_sym_module] = ACTIONS(3003),
    [anon_sym_any] = ACTIONS(3003),
    [anon_sym_number] = ACTIONS(3003),
    [anon_sym_boolean] = ACTIONS(3003),
    [anon_sym_string] = ACTIONS(3003),
    [anon_sym_symbol] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(3003),
    [anon_sym_enum] = ACTIONS(3003),
    [sym_readonly] = ACTIONS(3003),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(3005),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_default] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3005),
    [anon_sym_RBRACE] = ACTIONS(3005),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_typeof] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_var] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_const] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_else] = ACTIONS(3007),
    [anon_sym_switch] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_await] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3007),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_continue] = ACTIONS(3007),
    [anon_sym_debugger] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_throw] = ACTIONS(3007),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_case] = ACTIONS(3007),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_class] = ACTIONS(3007),
    [anon_sym_async] = ACTIONS(3007),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3005),
    [anon_sym_TILDE] = ACTIONS(3005),
    [anon_sym_void] = ACTIONS(3007),
    [anon_sym_delete] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3005),
    [anon_sym_DASH_DASH] = ACTIONS(3005),
    [anon_sym_DQUOTE] = ACTIONS(3005),
    [anon_sym_SQUOTE] = ACTIONS(3005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3005),
    [sym_number] = ACTIONS(3005),
    [sym_this] = ACTIONS(3007),
    [sym_super] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_null] = ACTIONS(3007),
    [sym_undefined] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(3005),
    [anon_sym_static] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(3007),
    [anon_sym_get] = ACTIONS(3007),
    [anon_sym_set] = ACTIONS(3007),
    [anon_sym_declare] = ACTIONS(3007),
    [anon_sym_public] = ACTIONS(3007),
    [anon_sym_private] = ACTIONS(3007),
    [anon_sym_protected] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_any] = ACTIONS(3007),
    [anon_sym_number] = ACTIONS(3007),
    [anon_sym_boolean] = ACTIONS(3007),
    [anon_sym_string] = ACTIONS(3007),
    [anon_sym_symbol] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3007),
    [anon_sym_enum] = ACTIONS(3007),
    [sym_readonly] = ACTIONS(3007),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(3009),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_export] = ACTIONS(3011),
    [anon_sym_default] = ACTIONS(3011),
    [anon_sym_namespace] = ACTIONS(3011),
    [anon_sym_LBRACE] = ACTIONS(3009),
    [anon_sym_RBRACE] = ACTIONS(3009),
    [anon_sym_type] = ACTIONS(3011),
    [anon_sym_typeof] = ACTIONS(3011),
    [anon_sym_import] = ACTIONS(3011),
    [anon_sym_var] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_const] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_else] = ACTIONS(3011),
    [anon_sym_switch] = ACTIONS(3011),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_await] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_with] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3011),
    [anon_sym_continue] = ACTIONS(3011),
    [anon_sym_debugger] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_throw] = ACTIONS(3011),
    [anon_sym_SEMI] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3011),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_SLASH] = ACTIONS(3011),
    [anon_sym_class] = ACTIONS(3011),
    [anon_sym_async] = ACTIONS(3011),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3009),
    [anon_sym_TILDE] = ACTIONS(3009),
    [anon_sym_void] = ACTIONS(3011),
    [anon_sym_delete] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(3009),
    [anon_sym_SQUOTE] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3009),
    [sym_number] = ACTIONS(3009),
    [sym_this] = ACTIONS(3011),
    [sym_super] = ACTIONS(3011),
    [sym_true] = ACTIONS(3011),
    [sym_false] = ACTIONS(3011),
    [sym_null] = ACTIONS(3011),
    [sym_undefined] = ACTIONS(3011),
    [anon_sym_AT] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3011),
    [anon_sym_abstract] = ACTIONS(3011),
    [anon_sym_get] = ACTIONS(3011),
    [anon_sym_set] = ACTIONS(3011),
    [anon_sym_declare] = ACTIONS(3011),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_module] = ACTIONS(3011),
    [anon_sym_any] = ACTIONS(3011),
    [anon_sym_number] = ACTIONS(3011),
    [anon_sym_boolean] = ACTIONS(3011),
    [anon_sym_string] = ACTIONS(3011),
    [anon_sym_symbol] = ACTIONS(3011),
    [anon_sym_interface] = ACTIONS(3011),
    [anon_sym_enum] = ACTIONS(3011),
    [sym_readonly] = ACTIONS(3011),
  },
  [608] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [609] = {
    [sym__call_signature] = STATE(3108),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2806),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [sym_readonly] = ACTIONS(2808),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2618),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [611] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2618),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [612] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(790),
    [anon_sym_of] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [613] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [614] = {
    [sym_identifier] = ACTIONS(3013),
    [anon_sym_export] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_type] = ACTIONS(3013),
    [anon_sym_typeof] = ACTIONS(3013),
    [anon_sym_import] = ACTIONS(3013),
    [anon_sym_var] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_await] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_with] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_debugger] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_yield] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_SLASH] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_async] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [sym_number] = ACTIONS(3015),
    [sym_this] = ACTIONS(3013),
    [sym_super] = ACTIONS(3013),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [sym_null] = ACTIONS(3013),
    [sym_undefined] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3015),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_get] = ACTIONS(3013),
    [anon_sym_set] = ACTIONS(3013),
    [anon_sym_declare] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_any] = ACTIONS(3013),
    [anon_sym_number] = ACTIONS(3013),
    [anon_sym_boolean] = ACTIONS(3013),
    [anon_sym_string] = ACTIONS(3013),
    [anon_sym_symbol] = ACTIONS(3013),
    [anon_sym_interface] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [sym_readonly] = ACTIONS(3013),
  },
  [615] = {
    [sym_identifier] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_type] = ACTIONS(3017),
    [anon_sym_typeof] = ACTIONS(3017),
    [anon_sym_import] = ACTIONS(3017),
    [anon_sym_var] = ACTIONS(3017),
    [anon_sym_let] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3017),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_switch] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_await] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [anon_sym_do] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_with] = ACTIONS(3017),
    [anon_sym_break] = ACTIONS(3017),
    [anon_sym_continue] = ACTIONS(3017),
    [anon_sym_debugger] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_throw] = ACTIONS(3017),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_yield] = ACTIONS(3017),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_SLASH] = ACTIONS(3017),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_async] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_DASH] = ACTIONS(3017),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_delete] = ACTIONS(3017),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3019),
    [sym_number] = ACTIONS(3019),
    [sym_this] = ACTIONS(3017),
    [sym_super] = ACTIONS(3017),
    [sym_true] = ACTIONS(3017),
    [sym_false] = ACTIONS(3017),
    [sym_null] = ACTIONS(3017),
    [sym_undefined] = ACTIONS(3017),
    [anon_sym_AT] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3017),
    [anon_sym_get] = ACTIONS(3017),
    [anon_sym_set] = ACTIONS(3017),
    [anon_sym_declare] = ACTIONS(3017),
    [anon_sym_public] = ACTIONS(3017),
    [anon_sym_private] = ACTIONS(3017),
    [anon_sym_protected] = ACTIONS(3017),
    [anon_sym_module] = ACTIONS(3017),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_interface] = ACTIONS(3017),
    [anon_sym_enum] = ACTIONS(3017),
    [sym_readonly] = ACTIONS(3017),
  },
  [616] = {
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_readonly] = ACTIONS(3021),
  },
  [617] = {
    [sym_identifier] = ACTIONS(3025),
    [anon_sym_export] = ACTIONS(3025),
    [anon_sym_namespace] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_type] = ACTIONS(3025),
    [anon_sym_typeof] = ACTIONS(3025),
    [anon_sym_import] = ACTIONS(3025),
    [anon_sym_var] = ACTIONS(3025),
    [anon_sym_let] = ACTIONS(3025),
    [anon_sym_const] = ACTIONS(3025),
    [anon_sym_if] = ACTIONS(3025),
    [anon_sym_switch] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_await] = ACTIONS(3025),
    [anon_sym_while] = ACTIONS(3025),
    [anon_sym_do] = ACTIONS(3025),
    [anon_sym_try] = ACTIONS(3025),
    [anon_sym_with] = ACTIONS(3025),
    [anon_sym_break] = ACTIONS(3025),
    [anon_sym_continue] = ACTIONS(3025),
    [anon_sym_debugger] = ACTIONS(3025),
    [anon_sym_return] = ACTIONS(3025),
    [anon_sym_throw] = ACTIONS(3025),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym_yield] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_SLASH] = ACTIONS(3025),
    [anon_sym_class] = ACTIONS(3025),
    [anon_sym_async] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3025),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_void] = ACTIONS(3025),
    [anon_sym_delete] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3027),
    [sym_number] = ACTIONS(3027),
    [sym_this] = ACTIONS(3025),
    [sym_super] = ACTIONS(3025),
    [sym_true] = ACTIONS(3025),
    [sym_false] = ACTIONS(3025),
    [sym_null] = ACTIONS(3025),
    [sym_undefined] = ACTIONS(3025),
    [anon_sym_AT] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3025),
    [anon_sym_abstract] = ACTIONS(3025),
    [anon_sym_get] = ACTIONS(3025),
    [anon_sym_set] = ACTIONS(3025),
    [anon_sym_declare] = ACTIONS(3025),
    [anon_sym_public] = ACTIONS(3025),
    [anon_sym_private] = ACTIONS(3025),
    [anon_sym_protected] = ACTIONS(3025),
    [anon_sym_module] = ACTIONS(3025),
    [anon_sym_any] = ACTIONS(3025),
    [anon_sym_number] = ACTIONS(3025),
    [anon_sym_boolean] = ACTIONS(3025),
    [anon_sym_string] = ACTIONS(3025),
    [anon_sym_symbol] = ACTIONS(3025),
    [anon_sym_interface] = ACTIONS(3025),
    [anon_sym_enum] = ACTIONS(3025),
    [sym_readonly] = ACTIONS(3025),
  },
  [618] = {
    [sym_identifier] = ACTIONS(3029),
    [anon_sym_export] = ACTIONS(3029),
    [anon_sym_namespace] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_type] = ACTIONS(3029),
    [anon_sym_typeof] = ACTIONS(3029),
    [anon_sym_import] = ACTIONS(3029),
    [anon_sym_var] = ACTIONS(3029),
    [anon_sym_let] = ACTIONS(3029),
    [anon_sym_const] = ACTIONS(3029),
    [anon_sym_if] = ACTIONS(3029),
    [anon_sym_switch] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_await] = ACTIONS(3029),
    [anon_sym_while] = ACTIONS(3029),
    [anon_sym_do] = ACTIONS(3029),
    [anon_sym_try] = ACTIONS(3029),
    [anon_sym_with] = ACTIONS(3029),
    [anon_sym_break] = ACTIONS(3029),
    [anon_sym_continue] = ACTIONS(3029),
    [anon_sym_debugger] = ACTIONS(3029),
    [anon_sym_return] = ACTIONS(3029),
    [anon_sym_throw] = ACTIONS(3029),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_yield] = ACTIONS(3029),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3029),
    [anon_sym_class] = ACTIONS(3029),
    [anon_sym_async] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3029),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3029),
    [anon_sym_delete] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3031),
    [sym_number] = ACTIONS(3031),
    [sym_this] = ACTIONS(3029),
    [sym_super] = ACTIONS(3029),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_AT] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3029),
    [anon_sym_abstract] = ACTIONS(3029),
    [anon_sym_get] = ACTIONS(3029),
    [anon_sym_set] = ACTIONS(3029),
    [anon_sym_declare] = ACTIONS(3029),
    [anon_sym_public] = ACTIONS(3029),
    [anon_sym_private] = ACTIONS(3029),
    [anon_sym_protected] = ACTIONS(3029),
    [anon_sym_module] = ACTIONS(3029),
    [anon_sym_any] = ACTIONS(3029),
    [anon_sym_number] = ACTIONS(3029),
    [anon_sym_boolean] = ACTIONS(3029),
    [anon_sym_string] = ACTIONS(3029),
    [anon_sym_symbol] = ACTIONS(3029),
    [anon_sym_interface] = ACTIONS(3029),
    [anon_sym_enum] = ACTIONS(3029),
    [sym_readonly] = ACTIONS(3029),
  },
  [619] = {
    [sym_identifier] = ACTIONS(3033),
    [anon_sym_export] = ACTIONS(3033),
    [anon_sym_namespace] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_type] = ACTIONS(3033),
    [anon_sym_typeof] = ACTIONS(3033),
    [anon_sym_import] = ACTIONS(3033),
    [anon_sym_var] = ACTIONS(3033),
    [anon_sym_let] = ACTIONS(3033),
    [anon_sym_const] = ACTIONS(3033),
    [anon_sym_if] = ACTIONS(3033),
    [anon_sym_switch] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_await] = ACTIONS(3033),
    [anon_sym_while] = ACTIONS(3033),
    [anon_sym_do] = ACTIONS(3033),
    [anon_sym_try] = ACTIONS(3033),
    [anon_sym_with] = ACTIONS(3033),
    [anon_sym_break] = ACTIONS(3033),
    [anon_sym_continue] = ACTIONS(3033),
    [anon_sym_debugger] = ACTIONS(3033),
    [anon_sym_return] = ACTIONS(3033),
    [anon_sym_throw] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_yield] = ACTIONS(3033),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_SLASH] = ACTIONS(3033),
    [anon_sym_class] = ACTIONS(3033),
    [anon_sym_async] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3033),
    [anon_sym_PLUS] = ACTIONS(3033),
    [anon_sym_DASH] = ACTIONS(3033),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_void] = ACTIONS(3033),
    [anon_sym_delete] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3035),
    [sym_number] = ACTIONS(3035),
    [sym_this] = ACTIONS(3033),
    [sym_super] = ACTIONS(3033),
    [sym_true] = ACTIONS(3033),
    [sym_false] = ACTIONS(3033),
    [sym_null] = ACTIONS(3033),
    [sym_undefined] = ACTIONS(3033),
    [anon_sym_AT] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3033),
    [anon_sym_abstract] = ACTIONS(3033),
    [anon_sym_get] = ACTIONS(3033),
    [anon_sym_set] = ACTIONS(3033),
    [anon_sym_declare] = ACTIONS(3033),
    [anon_sym_public] = ACTIONS(3033),
    [anon_sym_private] = ACTIONS(3033),
    [anon_sym_protected] = ACTIONS(3033),
    [anon_sym_module] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3033),
    [anon_sym_number] = ACTIONS(3033),
    [anon_sym_boolean] = ACTIONS(3033),
    [anon_sym_string] = ACTIONS(3033),
    [anon_sym_symbol] = ACTIONS(3033),
    [anon_sym_interface] = ACTIONS(3033),
    [anon_sym_enum] = ACTIONS(3033),
    [sym_readonly] = ACTIONS(3033),
  },
  [620] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_export] = ACTIONS(3037),
    [anon_sym_namespace] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_type] = ACTIONS(3037),
    [anon_sym_typeof] = ACTIONS(3037),
    [anon_sym_import] = ACTIONS(3037),
    [anon_sym_var] = ACTIONS(3037),
    [anon_sym_let] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3037),
    [anon_sym_if] = ACTIONS(3037),
    [anon_sym_switch] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_await] = ACTIONS(3037),
    [anon_sym_while] = ACTIONS(3037),
    [anon_sym_do] = ACTIONS(3037),
    [anon_sym_try] = ACTIONS(3037),
    [anon_sym_with] = ACTIONS(3037),
    [anon_sym_break] = ACTIONS(3037),
    [anon_sym_continue] = ACTIONS(3037),
    [anon_sym_debugger] = ACTIONS(3037),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_throw] = ACTIONS(3037),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_yield] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3039),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_class] = ACTIONS(3037),
    [anon_sym_async] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3039),
    [anon_sym_void] = ACTIONS(3037),
    [anon_sym_delete] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_SQUOTE] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3039),
    [sym_number] = ACTIONS(3039),
    [sym_this] = ACTIONS(3037),
    [sym_super] = ACTIONS(3037),
    [sym_true] = ACTIONS(3037),
    [sym_false] = ACTIONS(3037),
    [sym_null] = ACTIONS(3037),
    [sym_undefined] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3037),
    [anon_sym_abstract] = ACTIONS(3037),
    [anon_sym_get] = ACTIONS(3037),
    [anon_sym_set] = ACTIONS(3037),
    [anon_sym_declare] = ACTIONS(3037),
    [anon_sym_public] = ACTIONS(3037),
    [anon_sym_private] = ACTIONS(3037),
    [anon_sym_protected] = ACTIONS(3037),
    [anon_sym_module] = ACTIONS(3037),
    [anon_sym_any] = ACTIONS(3037),
    [anon_sym_number] = ACTIONS(3037),
    [anon_sym_boolean] = ACTIONS(3037),
    [anon_sym_string] = ACTIONS(3037),
    [anon_sym_symbol] = ACTIONS(3037),
    [anon_sym_interface] = ACTIONS(3037),
    [anon_sym_enum] = ACTIONS(3037),
    [sym_readonly] = ACTIONS(3037),
  },
  [621] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_export] = ACTIONS(3041),
    [anon_sym_namespace] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_type] = ACTIONS(3041),
    [anon_sym_typeof] = ACTIONS(3041),
    [anon_sym_import] = ACTIONS(3041),
    [anon_sym_var] = ACTIONS(3041),
    [anon_sym_let] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_switch] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_await] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [anon_sym_do] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_with] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_debugger] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_throw] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_yield] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_class] = ACTIONS(3041),
    [anon_sym_async] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_void] = ACTIONS(3041),
    [anon_sym_delete] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3043),
    [sym_number] = ACTIONS(3043),
    [sym_this] = ACTIONS(3041),
    [sym_super] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_null] = ACTIONS(3041),
    [sym_undefined] = ACTIONS(3041),
    [anon_sym_AT] = ACTIONS(3043),
    [anon_sym_static] = ACTIONS(3041),
    [anon_sym_abstract] = ACTIONS(3041),
    [anon_sym_get] = ACTIONS(3041),
    [anon_sym_set] = ACTIONS(3041),
    [anon_sym_declare] = ACTIONS(3041),
    [anon_sym_public] = ACTIONS(3041),
    [anon_sym_private] = ACTIONS(3041),
    [anon_sym_protected] = ACTIONS(3041),
    [anon_sym_module] = ACTIONS(3041),
    [anon_sym_any] = ACTIONS(3041),
    [anon_sym_number] = ACTIONS(3041),
    [anon_sym_boolean] = ACTIONS(3041),
    [anon_sym_string] = ACTIONS(3041),
    [anon_sym_symbol] = ACTIONS(3041),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [sym_readonly] = ACTIONS(3041),
  },
  [622] = {
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_export] = ACTIONS(3045),
    [anon_sym_namespace] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_type] = ACTIONS(3045),
    [anon_sym_typeof] = ACTIONS(3045),
    [anon_sym_import] = ACTIONS(3045),
    [anon_sym_var] = ACTIONS(3045),
    [anon_sym_let] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_switch] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_await] = ACTIONS(3045),
    [anon_sym_while] = ACTIONS(3045),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_try] = ACTIONS(3045),
    [anon_sym_with] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_debugger] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_throw] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_yield] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LT] = ACTIONS(3047),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_class] = ACTIONS(3045),
    [anon_sym_async] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_void] = ACTIONS(3045),
    [anon_sym_delete] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [sym_number] = ACTIONS(3047),
    [sym_this] = ACTIONS(3045),
    [sym_super] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_null] = ACTIONS(3045),
    [sym_undefined] = ACTIONS(3045),
    [anon_sym_AT] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3045),
    [anon_sym_abstract] = ACTIONS(3045),
    [anon_sym_get] = ACTIONS(3045),
    [anon_sym_set] = ACTIONS(3045),
    [anon_sym_declare] = ACTIONS(3045),
    [anon_sym_public] = ACTIONS(3045),
    [anon_sym_private] = ACTIONS(3045),
    [anon_sym_protected] = ACTIONS(3045),
    [anon_sym_module] = ACTIONS(3045),
    [anon_sym_any] = ACTIONS(3045),
    [anon_sym_number] = ACTIONS(3045),
    [anon_sym_boolean] = ACTIONS(3045),
    [anon_sym_string] = ACTIONS(3045),
    [anon_sym_symbol] = ACTIONS(3045),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [sym_readonly] = ACTIONS(3045),
  },
  [623] = {
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_typeof] = ACTIONS(3049),
    [anon_sym_import] = ACTIONS(3049),
    [anon_sym_var] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_await] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_with] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_debugger] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_throw] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_yield] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LT] = ACTIONS(3051),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_class] = ACTIONS(3049),
    [anon_sym_async] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3051),
    [anon_sym_void] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3051),
    [sym_number] = ACTIONS(3051),
    [sym_this] = ACTIONS(3049),
    [sym_super] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_undefined] = ACTIONS(3049),
    [anon_sym_AT] = ACTIONS(3051),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3049),
    [anon_sym_get] = ACTIONS(3049),
    [anon_sym_set] = ACTIONS(3049),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3049),
    [anon_sym_private] = ACTIONS(3049),
    [anon_sym_protected] = ACTIONS(3049),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [sym_readonly] = ACTIONS(3049),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(3053), 1,
      sym_identifier,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [97] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(3053), 1,
      sym_identifier,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [194] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3055), 1,
      sym_identifier,
    ACTIONS(3057), 1,
      anon_sym_DQUOTE,
    ACTIONS(3059), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(130), 1,
      sym__module,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [291] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(3053), 1,
      sym_identifier,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [388] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1033), 1,
      sym_arguments,
    STATE(1139), 1,
      sym__module,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 16,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [479] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3055), 1,
      sym_identifier,
    ACTIONS(3057), 1,
      anon_sym_DQUOTE,
    ACTIONS(3059), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(130), 1,
      sym__module,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [576] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3055), 1,
      sym_identifier,
    ACTIONS(3057), 1,
      anon_sym_DQUOTE,
    ACTIONS(3059), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(130), 1,
      sym__module,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [673] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    STATE(1534), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [763] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [849] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1033), 1,
      sym_arguments,
    STATE(1139), 1,
      sym__module,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [938] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3067), 1,
      sym_identifier,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1012), 1,
      sym_string,
    STATE(1290), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1023] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3071), 1,
      anon_sym_export,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3077), 1,
      anon_sym_RBRACE,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3081), 1,
      anon_sym_SEMI,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3085), 1,
      anon_sym_async,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3095), 1,
      anon_sym_static,
    ACTIONS(3101), 1,
      sym_readonly,
    ACTIONS(3103), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2587), 1,
      aux_sym_object_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3097), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3099), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2585), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3069), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1152] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3081), 1,
      anon_sym_SEMI,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3103), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3107), 1,
      anon_sym_export,
    ACTIONS(3109), 1,
      anon_sym_RBRACE,
    ACTIONS(3111), 1,
      anon_sym_async,
    ACTIONS(3113), 1,
      anon_sym_static,
    ACTIONS(3119), 1,
      sym_readonly,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2610), 1,
      aux_sym_object_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3117), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2606), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3105), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1281] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3081), 1,
      anon_sym_SEMI,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3103), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3123), 1,
      anon_sym_export,
    ACTIONS(3125), 1,
      anon_sym_RBRACE,
    ACTIONS(3127), 1,
      anon_sym_async,
    ACTIONS(3129), 1,
      anon_sym_static,
    ACTIONS(3135), 1,
      sym_readonly,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2667), 1,
      aux_sym_object_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3131), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3133), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2668), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3121), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1410] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3123), 1,
      anon_sym_export,
    ACTIONS(3127), 1,
      anon_sym_async,
    ACTIONS(3129), 1,
      anon_sym_static,
    ACTIONS(3135), 1,
      sym_readonly,
    ACTIONS(3137), 1,
      anon_sym_COMMA,
    ACTIONS(3139), 1,
      anon_sym_RBRACE,
    ACTIONS(3141), 1,
      anon_sym_SEMI,
    ACTIONS(3143), 1,
      anon_sym_PIPE_RBRACE,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2667), 1,
      aux_sym_object_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3131), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3133), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2668), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2131), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3121), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1539] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(646), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    STATE(1589), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 13,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(521), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1628] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(636), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3067), 1,
      sym_identifier,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1012), 1,
      sym_string,
    STATE(1290), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1715] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(623), 1,
      anon_sym_in,
    ACTIONS(626), 1,
      anon_sym_of,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3067), 1,
      sym_identifier,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1012), 1,
      sym_string,
    STATE(1290), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [1804] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3081), 1,
      anon_sym_SEMI,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3103), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3123), 1,
      anon_sym_export,
    ACTIONS(3127), 1,
      anon_sym_async,
    ACTIONS(3129), 1,
      anon_sym_static,
    ACTIONS(3135), 1,
      sym_readonly,
    ACTIONS(3147), 1,
      anon_sym_RBRACE,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2667), 1,
      aux_sym_object_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3131), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3133), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2668), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3121), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1933] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(634), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(3053), 1,
      sym_identifier,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2020] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1033), 1,
      sym_arguments,
    STATE(1139), 1,
      sym__module,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 14,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2109] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3081), 1,
      anon_sym_SEMI,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3103), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3151), 1,
      anon_sym_export,
    ACTIONS(3153), 1,
      anon_sym_RBRACE,
    ACTIONS(3155), 1,
      anon_sym_async,
    ACTIONS(3157), 1,
      anon_sym_static,
    ACTIONS(3163), 1,
      sym_readonly,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2658), 1,
      aux_sym_object_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3159), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3161), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2656), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3149), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2238] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(638), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(3053), 1,
      sym_identifier,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2325] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(638), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3067), 1,
      sym_identifier,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1012), 1,
      sym_string,
    STATE(1290), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2412] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(636), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(3165), 1,
      sym_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    STATE(2484), 1,
      sym_nested_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2499] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(634), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3055), 1,
      sym_identifier,
    ACTIONS(3057), 1,
      anon_sym_DQUOTE,
    ACTIONS(3059), 1,
      anon_sym_SQUOTE,
    STATE(113), 1,
      sym_nested_identifier,
    STATE(114), 1,
      sym_string,
    STATE(130), 1,
      sym__module,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2586] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3081), 1,
      anon_sym_SEMI,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3103), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3123), 1,
      anon_sym_export,
    ACTIONS(3127), 1,
      anon_sym_async,
    ACTIONS(3129), 1,
      anon_sym_static,
    ACTIONS(3135), 1,
      sym_readonly,
    ACTIONS(3167), 1,
      anon_sym_RBRACE,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2667), 1,
      aux_sym_object_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3131), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3133), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2668), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3121), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2715] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_EQ_GT,
    ACTIONS(700), 1,
      anon_sym_EQ,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2698), 1,
      anon_sym_DOT,
    ACTIONS(3169), 1,
      sym_identifier,
    STATE(1415), 1,
      sym_string,
    STATE(1416), 1,
      sym_nested_identifier,
    STATE(1631), 1,
      sym__module,
    ACTIONS(730), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2799] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(642), 1,
      anon_sym_EQ_GT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    STATE(1534), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [2887] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(758), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(774), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 21,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
  [2971] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(648), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(651), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(479), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3057] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(648), 1,
      anon_sym_EQ,
    ACTIONS(658), 1,
      anon_sym_COLON,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(651), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(479), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3145] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(640), 1,
      anon_sym_COLON,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3231] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3315] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(640), 1,
      anon_sym_COLON,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3400] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(642), 1,
      anon_sym_EQ_GT,
    ACTIONS(666), 1,
      anon_sym_EQ,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3067), 1,
      sym_identifier,
    STATE(1011), 1,
      sym_nested_identifier,
    STATE(1012), 1,
      sym_string,
    STATE(1290), 1,
      sym__module,
    ACTIONS(680), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3483] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(1627), 1,
      sym_template_string,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1601), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3599] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3205), 1,
      sym_identifier,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3743] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(623), 1,
      anon_sym_in,
    ACTIONS(626), 1,
      anon_sym_of,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(479), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [3829] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(1041), 1,
      sym_template_string,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1042), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [3945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3015), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4007] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3247), 1,
      anon_sym_export,
    ACTIONS(3251), 1,
      anon_sym_async,
    ACTIONS(3253), 1,
      anon_sym_static,
    ACTIONS(3259), 1,
      sym_readonly,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3255), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3257), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2815), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2118), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3245), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3263), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4187] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(790), 1,
      anon_sym_in,
    ACTIONS(793), 1,
      anon_sym_of,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3061), 1,
      sym_identifier,
    STATE(996), 1,
      sym_string,
    STATE(999), 1,
      sym_nested_identifier,
    STATE(1139), 1,
      sym__module,
    ACTIONS(479), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4273] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3073), 1,
      anon_sym_STAR,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3083), 1,
      anon_sym_LBRACK,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3093), 1,
      sym_number,
    ACTIONS(3247), 1,
      anon_sym_export,
    ACTIONS(3251), 1,
      anon_sym_async,
    ACTIONS(3253), 1,
      anon_sym_static,
    ACTIONS(3259), 1,
      sym_readonly,
    STATE(1826), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3255), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3257), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1880), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2815), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(2125), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3245), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4391] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    STATE(1035), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3265), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 21,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4461] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3273), 1,
      anon_sym_EQ,
    ACTIONS(3277), 1,
      anon_sym_in,
    ACTIONS(3280), 1,
      anon_sym_of,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    STATE(2341), 1,
      sym_type_annotation,
    STATE(2750), 1,
      sym__initializer,
    ACTIONS(3275), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4543] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3205), 1,
      sym_identifier,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4625] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3293), 1,
      anon_sym_LT,
    ACTIONS(3296), 1,
      anon_sym_DOT,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3305), 1,
      anon_sym_is,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(3302), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2532), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3290), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [4707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3037), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3039), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3309), 35,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4831] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_DOT,
    ACTIONS(3316), 1,
      anon_sym_is,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3302), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [4911] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3205), 1,
      sym_identifier,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [4993] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(1496), 1,
      sym_template_string,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1491), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5109] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3358), 1,
      anon_sym_RBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2566), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5222] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3364), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5335] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5414] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3366), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5527] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3368), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5640] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3370), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5753] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3372), 1,
      sym_identifier,
    ACTIONS(3374), 1,
      sym_jsx_identifier,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2363), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [5866] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(3376), 1,
      anon_sym_EQ,
    ACTIONS(3381), 1,
      anon_sym_LT,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(3378), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [5945] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3390), 1,
      anon_sym_RBRACK,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2595), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6058] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3392), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6171] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3394), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6284] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3396), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    STATE(1035), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3265), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6470] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(3376), 1,
      anon_sym_EQ,
    ACTIONS(3381), 1,
      anon_sym_LT,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(3378), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6549] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3398), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 1,
      anon_sym_EQ,
    ACTIONS(3015), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3400), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3402), 22,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [6727] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3404), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [6840] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3408), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3302), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6919] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(3376), 1,
      anon_sym_EQ,
    ACTIONS(3381), 1,
      anon_sym_LT,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(3378), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [6998] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7077] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3410), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7190] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3412), 1,
      anon_sym_RBRACK,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2642), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7303] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3414), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7416] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3416), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3419), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [7483] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(1033), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(521), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(529), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7556] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3425), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7669] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3427), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7782] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(473), 1,
      anon_sym_EQ,
    ACTIONS(485), 1,
      anon_sym_COLON,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(1621), 1,
      anon_sym_LT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(502), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [7861] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3429), 1,
      anon_sym_RBRACK,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2705), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [7974] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3431), 1,
      anon_sym_RBRACK,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2717), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8087] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3433), 1,
      anon_sym_GT,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3435), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 31,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [8265] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 1,
      anon_sym_COMMA,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    ACTIONS(3290), 1,
      anon_sym_LBRACK,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(3438), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3302), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8346] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2346), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8456] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2519), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8566] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(1913), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8676] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2621), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8786] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1515), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [8896] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1134), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9006] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(1914), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9116] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1516), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9226] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_EQ,
    ACTIONS(3476), 1,
      anon_sym_LBRACE,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3483), 1,
      anon_sym_DOT,
    ACTIONS(3485), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2467), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2687), 1,
      sym_type_arguments,
    ACTIONS(3487), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [9306] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2485), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9416] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2363), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9526] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(638), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3205), 1,
      sym_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [9598] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1136), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9708] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(1919), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9818] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2686), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [9928] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2580), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10038] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2385), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10148] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(636), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3205), 1,
      sym_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [10220] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1171), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10330] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1170), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10440] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(447), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10550] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10660] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(575), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(590), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10732] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2583), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10842] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(493), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [10952] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(445), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11062] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1568), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11172] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1168), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11282] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1569), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11392] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1570), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11502] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(445), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11612] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(447), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11722] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1571), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [11832] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_EQ,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    ACTIONS(3505), 1,
      anon_sym_LT,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_EQ_GT,
    STATE(425), 1,
      sym_type_arguments,
    STATE(2495), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3489), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(3512), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [11910] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2546), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12020] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2264), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12130] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2309), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12240] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2490), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12350] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2345), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12460] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12532] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2360), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12642] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(434), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12752] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(448), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12862] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2361), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [12972] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1155), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13082] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1154), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13192] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2404), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13302] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2405), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13412] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2413), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13522] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2747), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13632] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2099), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13742] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2438), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13852] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(445), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [13962] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2442), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14072] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(447), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14182] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1544), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14292] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1540), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14402] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2623), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14512] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2227), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14622] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1923), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14732] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2071), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14842] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3326), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3330), 1,
      anon_sym_new,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3334), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_PIPE,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3344), 1,
      sym_this,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3143), 1,
      sym_nested_identifier,
    STATE(3168), 1,
      sym_formal_parameters,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    STATE(1532), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1433), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [14952] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1966), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15062] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1952), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15172] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2654), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15282] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2355), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15392] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2010), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15502] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3269), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3265), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15574] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3219), 1,
      anon_sym_LPAREN,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3223), 1,
      anon_sym_new,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3227), 1,
      anon_sym_AMP,
    ACTIONS(3229), 1,
      anon_sym_PIPE,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3237), 1,
      sym_this,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(2913), 1,
      sym_type_parameters,
    STATE(3053), 1,
      sym_nested_identifier,
    STATE(3067), 1,
      sym_formal_parameters,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    STATE(1138), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1147), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15684] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    STATE(1534), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [15756] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(1910), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [15866] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_DOT,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(3501), 1,
      anon_sym_EQ,
    ACTIONS(3510), 1,
      anon_sym_EQ_GT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3302), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3512), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [15944] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2348), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16054] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3444), 1,
      anon_sym_new,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_AMP,
    ACTIONS(3450), 1,
      anon_sym_PIPE,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(2766), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3124), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2450), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16164] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(1918), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16274] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2440), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16384] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2169), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16494] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(434), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16604] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(448), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16714] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(590), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(575), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(617), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [16788] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1614), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [16898] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1615), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17008] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(634), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3205), 1,
      sym_identifier,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 20,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
  [17080] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1616), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17190] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1938), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17300] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1965), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17410] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1958), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17520] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1953), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17630] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2316), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17740] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(823), 1,
      anon_sym_AMP,
    ACTIONS(825), 1,
      anon_sym_PIPE,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2585), 1,
      anon_sym_new,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(2912), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3026), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(2295), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [17850] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3516), 1,
      anon_sym_DOT,
    ACTIONS(2607), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2605), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [17922] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1642), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18032] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1643), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18142] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1617), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18252] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18320] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1618), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18430] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(3474), 1,
      anon_sym_EQ,
    ACTIONS(3485), 1,
      anon_sym_EQ_GT,
    ACTIONS(3518), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3290), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3302), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3487), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18508] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_LBRACK,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_EQ,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
    ACTIONS(3530), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3302), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3523), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1223), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [18590] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(489), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18700] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(2451), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18810] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(484), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [18920] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(485), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19030] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1657), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19140] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1936), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19250] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3179), 1,
      anon_sym_LPAREN,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      anon_sym_new,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3187), 1,
      anon_sym_AMP,
    ACTIONS(3189), 1,
      anon_sym_PIPE,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3197), 1,
      sym_this,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(2890), 1,
      sym_type_parameters,
    STATE(3076), 1,
      sym_nested_identifier,
    STATE(3131), 1,
      sym_formal_parameters,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    STATE(1656), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1574), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19360] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 1,
      anon_sym_COMMA,
    ACTIONS(3290), 1,
      anon_sym_LBRACK,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(3532), 1,
      anon_sym_EQ,
    ACTIONS(3534), 1,
      anon_sym_DOT,
    ACTIONS(3536), 1,
      anon_sym_EQ_GT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3302), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3538), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19440] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(971), 1,
      anon_sym_AMP,
    ACTIONS(973), 1,
      anon_sym_PIPE,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3462), 1,
      anon_sym_new,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3470), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2966), 1,
      sym_type_parameters,
    STATE(2982), 1,
      sym_nested_identifier,
    STATE(3080), 1,
      sym_formal_parameters,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    STATE(1935), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1968), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19550] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(448), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19660] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19728] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(434), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19838] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(486), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [19948] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2579), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3362), 1,
      sym_this,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3493), 1,
      anon_sym_new,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3497), 1,
      anon_sym_AMP,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(2901), 1,
      sym_type_parameters,
    STATE(3014), 1,
      sym_nested_identifier,
    STATE(3148), 1,
      sym_formal_parameters,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    STATE(488), 5,
      sym__type,
      sym_constructor_type,
      sym_union_type,
      sym_intersection_type,
      sym_function_type,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(439), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [20058] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_EQ,
    ACTIONS(3480), 1,
      anon_sym_LT,
    ACTIONS(3483), 1,
      anon_sym_DOT,
    ACTIONS(3485), 1,
      anon_sym_EQ_GT,
    ACTIONS(3540), 1,
      anon_sym_LBRACE,
    STATE(2687), 1,
      sym_type_arguments,
    ACTIONS(3542), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3487), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20133] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(1033), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3263), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20263] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    STATE(1035), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3269), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3265), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20334] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(638), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20403] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(638), 1,
      anon_sym_COLON,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3015), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(634), 1,
      anon_sym_COLON,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20600] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(634), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20669] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    STATE(2940), 1,
      sym_type_annotation,
    ACTIONS(3544), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20742] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 1,
      anon_sym_COLON,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [20811] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3549), 1,
      anon_sym_in,
    ACTIONS(3552), 1,
      anon_sym_of,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20882] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(623), 1,
      anon_sym_in,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3554), 1,
      anon_sym_of,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20953] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(575), 1,
      anon_sym_LBRACK,
    ACTIONS(617), 1,
      anon_sym_COMMA,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(590), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21026] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_EQ_GT,
    STATE(1035), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3269), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3265), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(636), 1,
      anon_sym_COLON,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21166] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3556), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21235] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_EQ,
    ACTIONS(3505), 1,
      anon_sym_LT,
    ACTIONS(3508), 1,
      anon_sym_DOT,
    ACTIONS(3510), 1,
      anon_sym_EQ_GT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3542), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3512), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21308] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3311), 1,
      anon_sym_LT,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(3558), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(3302), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3290), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3309), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21444] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3560), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3562), 1,
      anon_sym_DOT,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3386), 1,
      anon_sym_EQ_GT,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(1033), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(521), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [21781] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(2394), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3416), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3419), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21911] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    ACTIONS(3564), 1,
      anon_sym_DOT,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21982] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3485), 1,
      anon_sym_EQ_GT,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    STATE(1586), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3269), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3265), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22053] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3265), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22120] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(575), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(590), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3037), 19,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3039), 32,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22250] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1235), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3422), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3207), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      anon_sym_EQ_GT,
    ACTIONS(621), 1,
      anon_sym_EQ,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(500), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22382] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(646), 1,
      anon_sym_EQ_GT,
    ACTIONS(2698), 1,
      anon_sym_DOT,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    STATE(1589), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(521), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22453] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_EQ,
    ACTIONS(3485), 1,
      anon_sym_EQ_GT,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3487), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22519] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_EQ,
    ACTIONS(3536), 1,
      anon_sym_EQ_GT,
    ACTIONS(3568), 1,
      anon_sym_DOT,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3538), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3520), 1,
      anon_sym_EQ,
    ACTIONS(3523), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22657] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(575), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      anon_sym_EQ,
    ACTIONS(654), 1,
      anon_sym_RPAREN,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(590), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(651), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(479), 12,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22731] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_EQ_GT,
    ACTIONS(700), 1,
      anon_sym_EQ,
    ACTIONS(2698), 1,
      anon_sym_DOT,
    ACTIONS(575), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(590), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(730), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22801] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(648), 1,
      anon_sym_EQ,
    ACTIONS(658), 1,
      anon_sym_COLON,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(651), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3435), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22933] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [22999] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_EQ,
    ACTIONS(3510), 1,
      anon_sym_EQ_GT,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3512), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [23069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(758), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(774), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23135] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(575), 1,
      anon_sym_LBRACK,
    ACTIONS(617), 1,
      anon_sym_COMMA,
    ACTIONS(642), 1,
      anon_sym_EQ_GT,
    ACTIONS(666), 1,
      anon_sym_EQ,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(590), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(680), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23207] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(648), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(651), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23337] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3435), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 28,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3416), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3419), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 28,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23465] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3501), 1,
      anon_sym_EQ,
    ACTIONS(3510), 1,
      anon_sym_EQ_GT,
    ACTIONS(3512), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23531] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3406), 1,
      anon_sym_EQ,
    ACTIONS(3549), 1,
      anon_sym_in,
    ACTIONS(3552), 1,
      anon_sym_of,
    ACTIONS(3388), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 18,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23597] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    STATE(1586), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3269), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3265), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23663] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3570), 1,
      anon_sym_DOT,
    ACTIONS(2605), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2607), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 15,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23733] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 17,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 1,
      anon_sym_EQ,
    ACTIONS(3015), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3400), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3402), 19,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_EQ,
    ACTIONS(3485), 1,
      anon_sym_EQ_GT,
    ACTIONS(3572), 1,
      anon_sym_DOT,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2607), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3487), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 16,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [23931] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3536), 1,
      anon_sym_EQ_GT,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3269), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3265), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24001] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(640), 1,
      anon_sym_COLON,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_EQ_GT,
    ACTIONS(758), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(575), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(590), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(774), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(471), 15,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(479), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [24139] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3576), 1,
      anon_sym_COLON,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24209] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3520), 1,
      anon_sym_EQ,
    ACTIONS(3578), 1,
      anon_sym_COLON,
    ACTIONS(3523), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24279] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(642), 1,
      anon_sym_EQ_GT,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    STATE(1534), 1,
      sym_arguments,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(529), 15,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(521), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      anon_sym_EQ_GT,
    ACTIONS(700), 1,
      anon_sym_EQ,
    ACTIONS(2698), 1,
      anon_sym_DOT,
    ACTIONS(730), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(471), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_COMMA,
    ACTIONS(3416), 1,
      anon_sym_LBRACK,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3419), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 28,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3416), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3419), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3422), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3207), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 27,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 18,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_EQ,
    ACTIONS(3512), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 18,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [24727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3474), 1,
      anon_sym_EQ,
    ACTIONS(3487), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(642), 1,
      anon_sym_EQ_GT,
    ACTIONS(666), 1,
      anon_sym_EQ,
    ACTIONS(1624), 1,
      anon_sym_DOT,
    ACTIONS(680), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [24853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3416), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3419), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [24973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3532), 1,
      anon_sym_EQ,
    ACTIONS(3536), 1,
      anon_sym_EQ_GT,
    ACTIONS(3538), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 16,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 1,
      anon_sym_EQ,
    ACTIONS(3015), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(3402), 17,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3400), 19,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3435), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25160] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(547), 1,
      anon_sym_EQ_GT,
    ACTIONS(571), 1,
      anon_sym_EQ,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(590), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(575), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(599), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25229] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3288), 1,
      anon_sym_EQ,
    ACTIONS(3298), 1,
      anon_sym_EQ_GT,
    ACTIONS(3580), 1,
      anon_sym_DOT,
    ACTIONS(2607), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2605), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3300), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 13,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 16,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3309), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25355] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    ACTIONS(3574), 1,
      anon_sym_in,
    ACTIONS(3576), 1,
      anon_sym_COLON,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25424] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3416), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(3207), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25487] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_COMMA,
    ACTIONS(3416), 1,
      anon_sym_LBRACK,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3419), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 2,
      anon_sym_LBRACK,
      anon_sym_DOT,
    ACTIONS(3435), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3037), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3039), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3263), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25729] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(640), 1,
      anon_sym_COLON,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3416), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3419), 2,
      anon_sym_LBRACE,
      anon_sym_LT,
    ACTIONS(3207), 18,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 26,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 20,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3015), 29,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [25916] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(623), 1,
      anon_sym_in,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3554), 1,
      anon_sym_of,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [25984] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3081), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3103), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2152), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_DOT,
    ACTIONS(3416), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3419), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3207), 16,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [26150] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3602), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3604), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2136), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26254] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1609), 1,
      anon_sym_LBRACE,
    ACTIONS(3606), 1,
      anon_sym_STAR,
    ACTIONS(3608), 1,
      anon_sym_default,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3612), 1,
      anon_sym_as,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3638), 1,
      anon_sym_module,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    STATE(1854), 1,
      sym_decorator,
    STATE(2501), 1,
      sym_export_clause,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2219), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26358] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1609), 1,
      anon_sym_LBRACE,
    ACTIONS(3606), 1,
      anon_sym_STAR,
    ACTIONS(3608), 1,
      anon_sym_default,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3612), 1,
      anon_sym_as,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3638), 1,
      anon_sym_module,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    STATE(1854), 1,
      sym_decorator,
    STATE(2501), 1,
      sym_export_clause,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2219), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26462] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3141), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3143), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2131), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26566] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    ACTIONS(3549), 1,
      anon_sym_in,
    ACTIONS(3552), 1,
      anon_sym_of,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26634] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      anon_sym_EQ,
    ACTIONS(619), 1,
      anon_sym_EQ_GT,
    ACTIONS(790), 1,
      anon_sym_in,
    ACTIONS(2567), 1,
      anon_sym_DOT,
    ACTIONS(3644), 1,
      anon_sym_of,
    ACTIONS(551), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(479), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(471), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26702] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1609), 1,
      anon_sym_LBRACE,
    ACTIONS(3606), 1,
      anon_sym_STAR,
    ACTIONS(3608), 1,
      anon_sym_default,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3612), 1,
      anon_sym_as,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3638), 1,
      anon_sym_module,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    STATE(1854), 1,
      sym_decorator,
    STATE(2501), 1,
      sym_export_clause,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2219), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_EQ,
    ACTIONS(3538), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 17,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [26866] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3646), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3648), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2153), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26970] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1609), 1,
      anon_sym_LBRACE,
    ACTIONS(3606), 1,
      anon_sym_STAR,
    ACTIONS(3608), 1,
      anon_sym_default,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3612), 1,
      anon_sym_as,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3638), 1,
      anon_sym_module,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    STATE(1854), 1,
      sym_decorator,
    STATE(2501), 1,
      sym_export_clause,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2219), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27074] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3277), 1,
      anon_sym_in,
    ACTIONS(3280), 1,
      anon_sym_of,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3286), 1,
      anon_sym_EQ_GT,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 14,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [27142] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3650), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3652), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2185), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3422), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
    ACTIONS(3207), 17,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3209), 25,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27306] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3654), 1,
      sym_identifier,
    ACTIONS(3656), 1,
      anon_sym_STAR,
    ACTIONS(3660), 1,
      anon_sym_LBRACE,
    STATE(2930), 1,
      sym_import_clause,
    ACTIONS(3664), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(2932), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3028), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(3658), 14,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(3662), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [27379] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1609), 1,
      anon_sym_LBRACE,
    ACTIONS(3606), 1,
      anon_sym_STAR,
    ACTIONS(3608), 1,
      anon_sym_default,
    ACTIONS(3612), 1,
      anon_sym_as,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3638), 1,
      anon_sym_module,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    ACTIONS(3666), 1,
      anon_sym_EQ,
    STATE(1854), 1,
      sym_decorator,
    STATE(2501), 1,
      sym_export_clause,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2219), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3549), 1,
      anon_sym_in,
    ACTIONS(3552), 1,
      anon_sym_of,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [27543] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1609), 1,
      anon_sym_LBRACE,
    ACTIONS(3606), 1,
      anon_sym_STAR,
    ACTIONS(3608), 1,
      anon_sym_default,
    ACTIONS(3610), 1,
      anon_sym_EQ,
    ACTIONS(3612), 1,
      anon_sym_as,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3638), 1,
      anon_sym_module,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    STATE(1854), 1,
      sym_decorator,
    STATE(2501), 1,
      sym_export_clause,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3668), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3616), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(2219), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [27646] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    ACTIONS(3277), 1,
      anon_sym_in,
    ACTIONS(3280), 1,
      anon_sym_of,
    ACTIONS(3271), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1223), 15,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1221), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
  [27709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3671), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27809] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3673), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3675), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28009] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3677), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28109] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3679), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28209] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3681), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28309] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3683), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28409] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3685), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28509] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3687), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28609] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3689), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3691), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28809] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3693), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3695), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29009] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3697), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29109] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3699), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29209] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2175), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29305] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2138), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29401] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2118), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29497] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2230), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29593] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2125), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29689] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3087), 1,
      anon_sym_new,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3584), 1,
      anon_sym_export,
    ACTIONS(3586), 1,
      anon_sym_STAR,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_async,
    ACTIONS(3592), 1,
      sym_number,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3600), 1,
      sym_readonly,
    STATE(1824), 1,
      sym_accessibility_modifier,
    STATE(1854), 1,
      sym_decorator,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2436), 1,
      sym__call_signature,
    STATE(2456), 1,
      aux_sym_export_statement_repeat1,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(3596), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2163), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3582), 11,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1036), 1,
      sym_arguments,
    STATE(1078), 1,
      sym_template_string,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [29842] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3703), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [29907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [29968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3705), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3709), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3711), 1,
      anon_sym_EQ,
    STATE(1035), 1,
      sym_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3715), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3717), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3719), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3723), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3727), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3731), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3733), 1,
      anon_sym_EQ,
    STATE(1035), 1,
      sym_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1167), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [30441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_EQ,
    ACTIONS(3735), 1,
      sym__automatic_semicolon,
    ACTIONS(1105), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1103), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30545] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3737), 1,
      anon_sym_LT,
    ACTIONS(3740), 1,
      anon_sym_DOT,
    ACTIONS(3742), 1,
      anon_sym_is,
    STATE(1158), 1,
      sym_type_arguments,
    ACTIONS(2534), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2532), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1163), 29,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [30653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3746), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3750), 28,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [30753] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3754), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [30842] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3782), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30931] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3788), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 8,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31006] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3786), 1,
      anon_sym_PIPE,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
  [31091] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3786), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
  [31172] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3791), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31261] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3793), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [31350] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3440), 1,
      sym_identifier,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3446), 1,
      anon_sym_QMARK,
    ACTIONS(3795), 1,
      anon_sym_LPAREN,
    ACTIONS(3797), 1,
      sym_this,
    STATE(2044), 1,
      sym_nested_type_identifier,
    STATE(3014), 1,
      sym_nested_identifier,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(449), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31435] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(821), 1,
      anon_sym_QMARK,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2577), 1,
      anon_sym_typeof,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3352), 1,
      sym_identifier,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3795), 1,
      anon_sym_LPAREN,
    ACTIONS(3797), 1,
      sym_this,
    STATE(1885), 1,
      sym_nested_type_identifier,
    STATE(3014), 1,
      sym_nested_identifier,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(449), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [31520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2492), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1107), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      sym__automatic_semicolon,
    ACTIONS(1135), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1133), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31624] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 6,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 14,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31701] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3803), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3805), 1,
      anon_sym_LT,
    STATE(1161), 1,
      sym_type_arguments,
    ACTIONS(2613), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2611), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31845] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3788), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 17,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31916] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3808), 1,
      anon_sym_COMMA,
    ACTIONS(3810), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2741), 1,
      aux_sym_array_repeat1,
    STATE(3003), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32013] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3812), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32102] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3814), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32191] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32260] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_SQUOTE,
    ACTIONS(3211), 1,
      sym_identifier,
    ACTIONS(3213), 1,
      anon_sym_STAR,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    ACTIONS(3217), 1,
      anon_sym_typeof,
    ACTIONS(3221), 1,
      anon_sym_LBRACK,
    ACTIONS(3225), 1,
      anon_sym_QMARK,
    ACTIONS(3235), 1,
      sym_number,
    ACTIONS(3241), 1,
      anon_sym_keyof,
    ACTIONS(3243), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3823), 1,
      anon_sym_LPAREN,
    ACTIONS(3825), 1,
      sym_this,
    STATE(985), 1,
      sym_nested_type_identifier,
    STATE(3053), 1,
      sym_nested_identifier,
    ACTIONS(3231), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3239), 2,
      sym_true,
      sym_false,
    STATE(1146), 2,
      sym_string,
      sym__number,
    ACTIONS(3233), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1153), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32345] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3808), 1,
      anon_sym_COMMA,
    ACTIONS(3827), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2629), 1,
      aux_sym_array_repeat1,
    STATE(3003), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3735), 1,
      sym__automatic_semicolon,
    ACTIONS(1105), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1103), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32493] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3829), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [32582] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3788), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [32651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1142), 1,
      sym_statement_block,
    ACTIONS(1097), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1095), 26,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32704] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_STAR,
    ACTIONS(845), 1,
      anon_sym_keyof,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2591), 1,
      sym_number,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 1,
      anon_sym_LBRACK,
    ACTIONS(3442), 1,
      anon_sym_typeof,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(3495), 1,
      anon_sym_QMARK,
    ACTIONS(3795), 1,
      anon_sym_LPAREN,
    ACTIONS(3797), 1,
      sym_this,
    STATE(479), 1,
      sym_nested_type_identifier,
    STATE(3014), 1,
      sym_nested_identifier,
    ACTIONS(2587), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2595), 2,
      sym_true,
      sym_false,
    STATE(436), 2,
      sym_string,
      sym__number,
    ACTIONS(3360), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(449), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32789] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_DQUOTE,
    ACTIONS(744), 1,
      anon_sym_SQUOTE,
    ACTIONS(3171), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_STAR,
    ACTIONS(3175), 1,
      anon_sym_LBRACE,
    ACTIONS(3177), 1,
      anon_sym_typeof,
    ACTIONS(3181), 1,
      anon_sym_LBRACK,
    ACTIONS(3185), 1,
      anon_sym_QMARK,
    ACTIONS(3195), 1,
      sym_number,
    ACTIONS(3201), 1,
      anon_sym_keyof,
    ACTIONS(3203), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3835), 1,
      sym_this,
    STATE(1462), 1,
      sym_nested_type_identifier,
    STATE(3076), 1,
      sym_nested_identifier,
    ACTIONS(3191), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3199), 2,
      sym_true,
      sym_false,
    STATE(1669), 2,
      sym_string,
      sym__number,
    ACTIONS(3193), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1658), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [32874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_DOT,
    STATE(1142), 1,
      sym_statement_block,
    ACTIONS(1097), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1095), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [32929] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3839), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33018] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33087] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3820), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 18,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33154] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_STAR,
    ACTIONS(969), 1,
      anon_sym_QMARK,
    ACTIONS(989), 1,
      anon_sym_keyof,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(3456), 1,
      anon_sym_typeof,
    ACTIONS(3460), 1,
      anon_sym_LBRACK,
    ACTIONS(3468), 1,
      sym_number,
    ACTIONS(3841), 1,
      anon_sym_LPAREN,
    ACTIONS(3843), 1,
      sym_this,
    STATE(1899), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_nested_identifier,
    ACTIONS(3464), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3472), 2,
      sym_true,
      sym_false,
    STATE(1971), 2,
      sym_string,
      sym__number,
    ACTIONS(3466), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1937), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [33239] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3845), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33328] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3847), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33417] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(3849), 1,
      anon_sym_EQ,
    ACTIONS(3853), 1,
      anon_sym_in,
    ACTIONS(3856), 1,
      anon_sym_of,
    STATE(2351), 1,
      sym_type_annotation,
    STATE(2739), 1,
      sym__initializer,
    ACTIONS(3851), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(1035), 1,
      sym_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [33533] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3858), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33622] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3860), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3808), 1,
      anon_sym_COMMA,
    ACTIONS(3862), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2649), 1,
      aux_sym_array_repeat1,
    STATE(3003), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33808] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    ACTIONS(3866), 1,
      anon_sym_DOT,
    STATE(1281), 1,
      sym_statement_block,
    ACTIONS(1097), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1095), 25,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1281), 1,
      sym_statement_block,
    ACTIONS(1097), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1095), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [33916] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(3318), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      anon_sym_STAR,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 1,
      anon_sym_typeof,
    ACTIONS(3328), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_QMARK,
    ACTIONS(3342), 1,
      sym_number,
    ACTIONS(3348), 1,
      anon_sym_keyof,
    ACTIONS(3350), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3868), 1,
      anon_sym_LPAREN,
    ACTIONS(3870), 1,
      sym_this,
    STATE(1401), 1,
      sym_nested_type_identifier,
    STATE(3143), 1,
      sym_nested_identifier,
    ACTIONS(3338), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3346), 2,
      sym_true,
      sym_false,
    STATE(1432), 2,
      sym_string,
      sym__number,
    ACTIONS(3340), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
    STATE(1514), 14,
      sym__primary_type,
      sym_generic_type,
      sym_type_predicate,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
  [34001] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3872), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34090] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3874), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3876), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3878), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34230] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3882), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34319] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(3884), 1,
      anon_sym_EQ,
    ACTIONS(3888), 1,
      anon_sym_in,
    ACTIONS(3891), 1,
      anon_sym_of,
    STATE(2356), 1,
      sym_type_annotation,
    STATE(2730), 1,
      sym__initializer,
    ACTIONS(3886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34382] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3893), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3897), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34519] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(3899), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(3083), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3715), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [34661] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3905), 1,
      anon_sym_LBRACE,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(3935), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2478), 1,
      sym_type_arguments,
    STATE(2535), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1149), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3939), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34851] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3872), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3981), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35039] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3985), 1,
      anon_sym_RBRACE,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3989), 1,
      anon_sym_async,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(3993), 1,
      anon_sym_static,
    ACTIONS(3999), 1,
      sym_readonly,
    STATE(1827), 1,
      sym_accessibility_modifier,
    STATE(2658), 1,
      aux_sym_object_repeat1,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3995), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3997), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2656), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(3983), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35125] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(4003), 1,
      anon_sym_RBRACE,
    ACTIONS(4005), 1,
      anon_sym_async,
    ACTIONS(4007), 1,
      anon_sym_static,
    ACTIONS(4013), 1,
      sym_readonly,
    STATE(1827), 1,
      sym_accessibility_modifier,
    STATE(2587), 1,
      aux_sym_object_repeat1,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(4009), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4011), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2585), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4001), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [35211] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4015), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2986), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4019), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4023), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4025), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4027), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4031), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4031), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4035), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3814), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3876), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3878), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4039), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4041), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4045), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4045), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35833] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4047), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(3003), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [35927] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(4051), 1,
      anon_sym_RBRACE,
    ACTIONS(4053), 1,
      anon_sym_async,
    ACTIONS(4055), 1,
      anon_sym_static,
    ACTIONS(4061), 1,
      sym_readonly,
    STATE(1827), 1,
      sym_accessibility_modifier,
    STATE(2667), 1,
      aux_sym_object_repeat1,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(4057), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4059), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2668), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4049), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4066), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3723), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4071), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3782), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4077), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3754), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4083), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4087), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4089), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3893), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4093), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4097), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3717), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3719), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [36737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3882), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36785] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4101), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [36873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4105), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4109), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4111), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2440), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37065] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3839), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3750), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [37201] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3793), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37289] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3754), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3402), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37425] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2507), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3935), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2446), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 25,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4139), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4143), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37665] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3829), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1191), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37801] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3847), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4147), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1145), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1231), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1277), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4151), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38129] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3814), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4155), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4157), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4159), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4163), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4171), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4173), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4175), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1127), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1129), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1267), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1247), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1119), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38745] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    STATE(2541), 1,
      sym_type_arguments,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3705), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3709), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [38803] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4177), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4182), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38919] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(4177), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38985] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1078), 1,
      sym_template_string,
    STATE(1527), 1,
      sym_arguments,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [39039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1159), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1177), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4186), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39183] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4188), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(3144), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39277] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4190), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39347] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(4195), 1,
      anon_sym_RBRACE,
    ACTIONS(4197), 1,
      anon_sym_async,
    ACTIONS(4199), 1,
      anon_sym_static,
    ACTIONS(4205), 1,
      sym_readonly,
    STATE(1827), 1,
      sym_accessibility_modifier,
    STATE(2706), 1,
      aux_sym_object_repeat1,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(4201), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4203), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2704), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4193), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [39433] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 6,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39509] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3786), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
  [39589] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3786), 1,
      anon_sym_PIPE,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
  [39673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4190), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 8,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39747] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4190), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39815] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3845), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39903] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3874), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39991] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3782), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40079] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4207), 1,
      anon_sym_COMMA,
    ACTIONS(4210), 1,
      anon_sym_RBRACE,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3746), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40219] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4210), 1,
      anon_sym_RBRACE,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3829), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40311] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4215), 1,
      anon_sym_COMMA,
    ACTIONS(4218), 1,
      anon_sym_RBRACE,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3845), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3731), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40451] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3858), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3727), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [40587] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4220), 1,
      anon_sym_COMMA,
    ACTIONS(4223), 1,
      anon_sym_RBRACE,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3874), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40679] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3812), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40767] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3860), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40855] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4225), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(3020), 1,
      sym_type_annotation,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3662), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1235), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41045] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3791), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41133] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3882), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41221] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3893), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2498), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2472), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41405] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4177), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2559), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 1,
      anon_sym_AMP,
    ACTIONS(4229), 1,
      anon_sym_PIPE,
    ACTIONS(2624), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2622), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2456), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 1,
      anon_sym_AMP,
    ACTIONS(4229), 1,
      anon_sym_PIPE,
    ACTIONS(2632), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2630), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2452), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 1,
      anon_sym_AMP,
    ACTIONS(4229), 1,
      anon_sym_PIPE,
    ACTIONS(2650), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2648), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1209), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41821] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(4233), 1,
      anon_sym_RBRACE,
    ACTIONS(4235), 1,
      anon_sym_async,
    ACTIONS(4237), 1,
      anon_sym_static,
    ACTIONS(4243), 1,
      sym_readonly,
    STATE(1827), 1,
      sym_accessibility_modifier,
    STATE(2610), 1,
      aux_sym_object_repeat1,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(4239), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4241), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2606), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4231), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1167), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1181), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1133), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2502), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(617), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2468), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4245), 1,
      anon_sym_LBRACK,
    ACTIONS(2482), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2480), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1163), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1235), 27,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [42341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1213), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2490), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3837), 1,
      anon_sym_DOT,
    ACTIONS(2607), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2605), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4245), 1,
      anon_sym_LBRACK,
    ACTIONS(2522), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2520), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2512), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2506), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2444), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42681] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [42739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2430), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 1,
      anon_sym_DOT,
    ACTIONS(2436), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2434), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2476), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2398), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2545), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42981] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3703), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    STATE(2541), 1,
      sym_type_arguments,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [43043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2448), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2486), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2494), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_DOT,
    ACTIONS(2396), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2394), 26,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 1,
      anon_sym_AMP,
    ACTIONS(4229), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2644), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4227), 1,
      anon_sym_AMP,
    ACTIONS(4229), 1,
      anon_sym_PIPE,
    ACTIONS(2636), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2634), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2460), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2516), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2464), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2541), 27,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43533] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3812), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43620] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [43687] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3786), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_implements,
  [43766] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 6,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
  [43841] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4286), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
  [43910] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3812), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43997] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3814), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44084] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4111), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3791), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44173] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3829), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44260] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3872), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44347] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3793), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym_regex_flags,
    ACTIONS(4289), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4291), 23,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44483] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3754), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44570] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3847), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44657] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4286), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
  [44724] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4286), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 8,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
  [44797] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3845), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44884] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4295), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3839), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44973] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4299), 1,
      anon_sym_RBRACE,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1222), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [45054] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3786), 1,
      anon_sym_PIPE,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_implements,
  [45137] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3874), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45224] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45311] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3893), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45398] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3882), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1149), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [45532] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3791), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45619] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [45686] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45773] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    ACTIONS(4313), 1,
      sym_readonly,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [45842] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(4319), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [45907] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4089), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3893), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [45996] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4099), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3882), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4321), 1,
      sym__automatic_semicolon,
    ACTIONS(1135), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1133), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46134] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4323), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2605), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46225] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4325), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1210), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46306] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4327), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2574), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46397] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4329), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1218), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46478] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4331), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2629), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46569] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4333), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1218), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [46650] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4335), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46737] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4337), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2605), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46828] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4339), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1133), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [46962] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4341), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1212), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47043] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4346), 1,
      anon_sym_STAR,
    ACTIONS(4349), 1,
      anon_sym_RBRACE,
    ACTIONS(4351), 1,
      anon_sym_LBRACK,
    ACTIONS(4354), 1,
      anon_sym_async,
    ACTIONS(4357), 1,
      anon_sym_DQUOTE,
    ACTIONS(4360), 1,
      anon_sym_SQUOTE,
    ACTIONS(4363), 1,
      sym_number,
    ACTIONS(4366), 1,
      anon_sym_AT,
    ACTIONS(4369), 1,
      anon_sym_static,
    ACTIONS(4372), 1,
      anon_sym_abstract,
    ACTIONS(4381), 1,
      sym_readonly,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4375), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1218), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4378), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4343), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47124] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4384), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2624), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47215] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4386), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2674), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47306] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4388), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1224), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47387] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4390), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1218), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47515] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4392), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1218), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47596] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4073), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3782), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47685] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3839), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47772] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3791), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47859] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3882), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47946] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3893), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48033] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3782), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48120] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3874), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48207] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3845), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48294] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4394), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48361] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 8,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 12,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48434] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3786), 1,
      anon_sym_PIPE,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 6,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
  [48517] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3786), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 7,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
  [48596] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [48663] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4397), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3874), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48752] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 6,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 12,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48827] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 15,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48896] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3814), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48983] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3829), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49070] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4399), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3845), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49159] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3872), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49246] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3793), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49333] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3754), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49420] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3847), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49507] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4401), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [49574] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4401), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 9,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [49647] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4404), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49734] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3786), 2,
      anon_sym_LBRACE,
      anon_sym_PIPE,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49817] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 3,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LBRACE_PIPE,
  [49896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3876), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3878), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49945] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    ACTIONS(4313), 1,
      sym_readonly,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [50014] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4406), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1256), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [50095] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4408), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1218), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [50176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3711), 1,
      anon_sym_EQ,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50229] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 7,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [50304] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4401), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 14,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [50373] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [50440] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4410), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3812), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50529] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    ACTIONS(4313), 1,
      sym_readonly,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [50598] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(4319), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [50663] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3703), 1,
      anon_sym_LT,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    STATE(2478), 1,
      sym_type_arguments,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 18,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [50724] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4339), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50813] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3733), 1,
      anon_sym_EQ,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50866] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4037), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50955] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4414), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3829), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51044] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4416), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2608), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51135] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4418), 1,
      anon_sym_COMMA,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4420), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51224] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4422), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51291] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(4422), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2490), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1107), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51407] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4425), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3872), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 1,
      sym__automatic_semicolon,
    ACTIONS(1105), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1103), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51545] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3858), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51632] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51719] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(4319), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [51784] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    ACTIONS(4313), 1,
      sym_readonly,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [51853] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4429), 1,
      anon_sym_LT,
    ACTIONS(4432), 1,
      anon_sym_DOT,
    ACTIONS(4434), 1,
      anon_sym_is,
    STATE(1519), 1,
      sym_type_arguments,
    ACTIONS(2534), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2532), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1181), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51955] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4422), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52022] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4436), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3793), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52111] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3754), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52200] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4438), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3847), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52289] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4418), 1,
      anon_sym_COMMA,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4440), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52378] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_type_arguments,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACE_PIPE,
  [52435] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4442), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
  [52502] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(4319), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [52567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1209), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52614] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52701] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4404), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52788] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4418), 1,
      anon_sym_COMMA,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4445), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52877] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4117), 1,
      anon_sym_LT,
    ACTIONS(4119), 1,
      anon_sym_QMARK,
    ACTIONS(4121), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4127), 1,
      anon_sym_AMP,
    ACTIONS(4129), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4123), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4131), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3858), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4113), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4125), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4115), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4135), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52964] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4447), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2741), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53055] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4404), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53142] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(4442), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
  [53207] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4442), 1,
      anon_sym_LT,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
  [53274] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4449), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2608), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53365] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4451), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2649), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53456] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_STAR,
    ACTIONS(127), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(3987), 1,
      anon_sym_LBRACK,
    ACTIONS(3991), 1,
      sym_number,
    ACTIONS(4455), 1,
      anon_sym_async,
    ACTIONS(4457), 1,
      anon_sym_static,
    ACTIONS(4463), 1,
      sym_readonly,
    STATE(1827), 1,
      sym_accessibility_modifier,
    STATE(3169), 1,
      sym_object,
    STATE(3170), 1,
      sym_array,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4459), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4461), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2815), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4453), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53537] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4404), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53624] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [53691] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4468), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1218), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    STATE(2478), 1,
      sym_type_arguments,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3705), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3709), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [53829] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4470), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3860), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53918] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4472), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2605), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54009] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4474), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 25,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54174] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(4465), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 15,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_LBRACE_PIPE,
  [54239] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3949), 1,
      anon_sym_LT,
    ACTIONS(3951), 1,
      anon_sym_QMARK,
    ACTIONS(3953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3959), 1,
      anon_sym_AMP,
    ACTIONS(3961), 1,
      anon_sym_PIPE,
    ACTIONS(3965), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4418), 1,
      anon_sym_COMMA,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3803), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3955), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3963), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3957), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3945), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3967), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1078), 1,
      sym_template_string,
    STATE(1583), 1,
      sym_arguments,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3265), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [54381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      sym__automatic_semicolon,
    ACTIONS(1103), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1107), 14,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54432] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3903), 1,
      anon_sym_as,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(3911), 1,
      anon_sym_LT,
    ACTIONS(3913), 1,
      anon_sym_QMARK,
    ACTIONS(3915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3921), 1,
      anon_sym_AMP,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    ACTIONS(3927), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3931), 1,
      anon_sym_BANG,
    ACTIONS(4478), 1,
      anon_sym_LBRACE,
    STATE(2478), 1,
      sym_type_arguments,
    ACTIONS(3858), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3917), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3925), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3933), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1703), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3901), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3919), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3907), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3929), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54521] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4404), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54608] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3588), 1,
      anon_sym_LBRACK,
    ACTIONS(4297), 1,
      anon_sym_STAR,
    ACTIONS(4301), 1,
      anon_sym_async,
    ACTIONS(4303), 1,
      sym_number,
    ACTIONS(4305), 1,
      anon_sym_static,
    ACTIONS(4307), 1,
      anon_sym_abstract,
    ACTIONS(4311), 1,
      sym_readonly,
    ACTIONS(4480), 1,
      anon_sym_RBRACE,
    STATE(1781), 1,
      sym_method_definition,
    STATE(1814), 1,
      sym_accessibility_modifier,
    ACTIONS(4309), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1304), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3598), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1871), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2663), 4,
      sym_public_field_definition,
      sym_method_signature,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3582), 12,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1213), 26,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54736] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4482), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(2724), 1,
      aux_sym_array_repeat1,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54875] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [54935] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3711), 1,
      anon_sym_EQ,
    STATE(1586), 1,
      sym_arguments,
    ACTIONS(3265), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [54987] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    ACTIONS(3733), 1,
      anon_sym_EQ,
    STATE(1586), 1,
      sym_arguments,
    ACTIONS(3265), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [55039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1217), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55087] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55173] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3754), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55259] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4510), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55345] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3793), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55431] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3872), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55517] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4512), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55605] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4514), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55691] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4516), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55779] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3829), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55865] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4518), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55953] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3814), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56039] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3812), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56125] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4520), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56213] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4522), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56301] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4524), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 14,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56369] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4527), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2492), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1107), 11,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_EQ,
    ACTIONS(4427), 1,
      sym__automatic_semicolon,
    ACTIONS(1105), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1103), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56557] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3786), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3784), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
  [56635] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4529), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      sym__automatic_semicolon,
    ACTIONS(1185), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1189), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1191), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56773] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3786), 1,
      anon_sym_PIPE,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56855] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4524), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 8,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4066), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2468), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4063), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56979] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4524), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3786), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57045] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3845), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57131] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3874), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57217] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4531), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57305] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4533), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_DOT,
    ACTIONS(4538), 1,
      anon_sym_is,
    STATE(1622), 1,
      sym_type_arguments,
    ACTIONS(2534), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2532), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [57359] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3782), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4540), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57511] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(4540), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3818), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 1,
      sym__automatic_semicolon,
    ACTIONS(1139), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1143), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1145), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57625] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3858), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57711] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3860), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57845] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 1,
      anon_sym_COLON,
    ACTIONS(4550), 1,
      anon_sym_LT,
    ACTIONS(4545), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(3713), 13,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3715), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2611), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3973), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57949] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4553), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58035] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3786), 6,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3784), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58109] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4555), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58195] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    ACTIONS(4313), 1,
      sym_readonly,
    ACTIONS(3668), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58263] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4210), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2444), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58399] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4540), 1,
      anon_sym_LT,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3816), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3818), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58465] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4557), 1,
      anon_sym_RBRACE,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58553] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3893), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58639] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3882), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3791), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58811] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [58871] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4559), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58957] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4218), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59043] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4223), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 1,
      anon_sym_EQ,
    ACTIONS(4561), 1,
      anon_sym_in,
    ACTIONS(4564), 1,
      anon_sym_of,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59181] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3943), 1,
      anon_sym_as,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(3969), 1,
      anon_sym_BANG,
    ACTIONS(4490), 1,
      anon_sym_LT,
    ACTIONS(4492), 1,
      anon_sym_QMARK,
    ACTIONS(4494), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_AMP,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4506), 1,
      anon_sym_STAR_STAR,
    STATE(2541), 1,
      sym_type_arguments,
    ACTIONS(3839), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(3971), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4496), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4504), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1461), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4486), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4498), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4488), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59267] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    ACTIONS(3668), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [59333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 1,
      sym__automatic_semicolon,
    ACTIONS(1171), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1177), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_EQ,
    ACTIONS(4566), 1,
      anon_sym_in,
    ACTIONS(4569), 1,
      anon_sym_of,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59435] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [59495] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4571), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59583] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    ACTIONS(3668), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4319), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [59647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    STATE(1528), 1,
      sym_arguments,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59697] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 1,
      sym__automatic_semicolon,
    ACTIONS(1153), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1157), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1159), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1233), 1,
      sym__automatic_semicolon,
    ACTIONS(1225), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1229), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1231), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59885] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4575), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59973] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4577), 1,
      anon_sym_STAR,
    ACTIONS(4579), 1,
      anon_sym_async,
    ACTIONS(4581), 1,
      sym_number,
    ACTIONS(4583), 1,
      anon_sym_abstract,
    ACTIONS(4585), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1872), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [60037] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_EQ,
    ACTIONS(4589), 1,
      sym__automatic_semicolon,
    ACTIONS(1105), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1103), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [60175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1121), 1,
      sym__automatic_semicolon,
    ACTIONS(1113), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1117), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1119), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60225] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      anon_sym_STAR,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      sym_number,
    ACTIONS(4597), 1,
      anon_sym_abstract,
    ACTIONS(4599), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1867), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [60289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      sym__automatic_semicolon,
    ACTIONS(1271), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1275), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1277), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60339] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4601), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      sym__automatic_semicolon,
    ACTIONS(1241), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1245), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1247), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60477] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4603), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 1,
      sym__automatic_semicolon,
    ACTIONS(1251), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1255), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4605), 1,
      anon_sym_LT,
    STATE(1523), 1,
      sym_type_arguments,
    ACTIONS(2613), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2611), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1269), 1,
      sym__automatic_semicolon,
    ACTIONS(1261), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1267), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60715] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [60775] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4608), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60863] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4610), 1,
      anon_sym_RPAREN,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(3876), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3878), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [60999] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3801), 1,
      anon_sym_COMMA,
    ACTIONS(4612), 1,
      anon_sym_COLON,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4614), 1,
      sym_regex_flags,
    ACTIONS(4289), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4291), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61135] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      sym__automatic_semicolon,
    ACTIONS(1123), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1127), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1129), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61185] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3758), 1,
      anon_sym_LT,
    ACTIONS(3760), 1,
      anon_sym_QMARK,
    ACTIONS(3762), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3768), 1,
      anon_sym_AMP,
    ACTIONS(3770), 1,
      anon_sym_PIPE,
    ACTIONS(3774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3764), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(3772), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4335), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3752), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(3766), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(3756), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 1,
      sym__automatic_semicolon,
    ACTIONS(1199), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1203), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4171), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3750), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3729), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3731), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4616), 1,
      anon_sym_LBRACE,
    STATE(1630), 1,
      sym_statement_block,
    ACTIONS(1097), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1095), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4616), 1,
      anon_sym_LBRACE,
    ACTIONS(4618), 1,
      anon_sym_DOT,
    STATE(1630), 1,
      sym_statement_block,
    ACTIONS(1097), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1095), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [61556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4186), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61601] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4620), 1,
      anon_sym_COLON,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4077), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2492), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1107), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4083), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61870] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4577), 1,
      anon_sym_STAR,
    ACTIONS(4622), 1,
      sym_number,
    ACTIONS(4624), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [61929] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4577), 1,
      anon_sym_STAR,
    ACTIONS(4579), 1,
      anon_sym_async,
    ACTIONS(4581), 1,
      sym_number,
    ACTIONS(4585), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1872), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [61990] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4577), 1,
      anon_sym_STAR,
    ACTIONS(4579), 1,
      anon_sym_async,
    ACTIONS(4581), 1,
      sym_number,
    ACTIONS(4626), 1,
      sym_readonly,
    ACTIONS(4585), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1872), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62053] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4630), 1,
      sym_number,
    ACTIONS(4632), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2124), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62112] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4634), 1,
      anon_sym_async,
    ACTIONS(4636), 1,
      sym_number,
    ACTIONS(4640), 1,
      sym_readonly,
    ACTIONS(4638), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1876), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62175] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4634), 1,
      anon_sym_async,
    ACTIONS(4636), 1,
      sym_number,
    ACTIONS(4638), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1876), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2502), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4087), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(617), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2468), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_LBRACK,
    ACTIONS(2482), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2480), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4089), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3893), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62508] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4644), 1,
      anon_sym_STAR,
    ACTIONS(4646), 1,
      anon_sym_async,
    ACTIONS(4648), 1,
      sym_number,
    ACTIONS(4652), 1,
      sym_readonly,
    ACTIONS(4650), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1881), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4093), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3882), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4111), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3897), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4039), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4041), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3717), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3719), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4654), 1,
      sym__automatic_semicolon,
    ACTIONS(1135), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1133), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [62888] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4644), 1,
      anon_sym_STAR,
    ACTIONS(4646), 1,
      anon_sym_async,
    ACTIONS(4648), 1,
      sym_number,
    ACTIONS(4650), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1881), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [62949] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4644), 1,
      anon_sym_STAR,
    ACTIONS(4656), 1,
      sym_number,
    ACTIONS(4658), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2134), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3713), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3715), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63098] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    ACTIONS(3668), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3744), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3746), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4660), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      sym_number,
    ACTIONS(4666), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63263] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2611), 1,
      anon_sym_COMMA,
    ACTIONS(3973), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(4063), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3402), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3721), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3723), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63455] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4660), 1,
      anon_sym_STAR,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      sym_number,
    ACTIONS(4668), 1,
      sym_readonly,
    ACTIONS(4666), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 15,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3727), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4173), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4175), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4163), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 1,
      sym_regex_flags,
    ACTIONS(4289), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
      anon_sym_implements,
    ACTIONS(4291), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63745] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4670), 1,
      anon_sym_STAR,
    ACTIONS(4672), 1,
      anon_sym_async,
    ACTIONS(4674), 1,
      sym_number,
    ACTIONS(4676), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1873), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [63806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4147), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_LT,
    STATE(1621), 1,
      sym_type_arguments,
    ACTIONS(2613), 13,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2611), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [63900] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4681), 1,
      anon_sym_COLON,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63985] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4683), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1127), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1129), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64115] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4688), 1,
      anon_sym_COLON,
    ACTIONS(4690), 1,
      anon_sym_LT,
    ACTIONS(4685), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 1,
      sym__automatic_semicolon,
    ACTIONS(1105), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1103), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1267), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1247), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4693), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1119), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64440] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 1,
      anon_sym_LBRACK,
    ACTIONS(4695), 1,
      anon_sym_EQ,
    ACTIONS(4697), 1,
      anon_sym_RPAREN,
    ACTIONS(3976), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3523), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 18,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4105), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64540] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4670), 1,
      anon_sym_STAR,
    ACTIONS(4701), 1,
      sym_number,
    ACTIONS(4703), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [64599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2492), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1107), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [64648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4097), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3782), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4705), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2446), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4071), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 1,
      anon_sym_EQ,
    ACTIONS(4713), 1,
      anon_sym_COLON,
    ACTIONS(4710), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 1,
      anon_sym_EQ,
    ACTIONS(4721), 1,
      anon_sym_COLON,
    ACTIONS(4718), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3578), 1,
      anon_sym_COLON,
    ACTIONS(4695), 1,
      anon_sym_EQ,
    ACTIONS(3523), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65032] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4660), 1,
      anon_sym_STAR,
    ACTIONS(4723), 1,
      sym_number,
    ACTIONS(4725), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2180), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65091] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4727), 1,
      anon_sym_COLON,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4066), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4729), 1,
      anon_sym_STAR,
    ACTIONS(4731), 1,
      sym_number,
    ACTIONS(4733), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2167), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4182), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4045), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4137), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4139), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 1,
      anon_sym_EQ,
    ACTIONS(4710), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    STATE(1586), 1,
      sym_arguments,
    ACTIONS(3265), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3269), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [65566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4143), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4045), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 1,
      anon_sym_EQ,
    ACTIONS(4718), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65705] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4735), 1,
      anon_sym_STAR,
    ACTIONS(4737), 1,
      sym_number,
    ACTIONS(4739), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 1,
      anon_sym_EQ,
    ACTIONS(3523), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3754), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65858] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4741), 1,
      anon_sym_STAR,
    ACTIONS(4743), 1,
      anon_sym_async,
    ACTIONS(4745), 1,
      sym_number,
    ACTIONS(4747), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1877), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [65919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4109), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4157), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4159), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66009] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4101), 1,
      anon_sym_RBRACE,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3876), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3878), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66139] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4749), 1,
      anon_sym_COLON,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4155), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3814), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66314] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4751), 1,
      anon_sym_COLON,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4753), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [66446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4755), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [66493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2490), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 1,
      anon_sym_DOT,
    ACTIONS(2607), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2605), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_LBRACK,
    ACTIONS(2522), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2520), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2512), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2506), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2444), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4757), 1,
      anon_sym_EQ,
    ACTIONS(1221), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2430), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4432), 1,
      anon_sym_DOT,
    ACTIONS(2436), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2434), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2476), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4759), 1,
      anon_sym_EQ,
    ACTIONS(1221), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [66998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2398), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67043] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4761), 1,
      anon_sym_RBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4151), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4035), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4031), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4031), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4025), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4027), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3662), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2498), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_PIPE,
    ACTIONS(2650), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2648), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2472), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4023), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4019), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2559), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67672] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4767), 1,
      anon_sym_STAR,
    ACTIONS(4769), 1,
      sym_number,
    ACTIONS(4771), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2186), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [67731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4773), 1,
      sym_regex_flags,
    ACTIONS(4289), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_BANG,
    ACTIONS(4291), 20,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [67778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym_EQ_GT,
    ACTIONS(3876), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3878), 23,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_PIPE,
    ACTIONS(2624), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2622), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2456), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2545), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3981), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_PIPE,
    ACTIONS(2632), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2630), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2452), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2440), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68148] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4775), 1,
      anon_sym_STAR,
    ACTIONS(4777), 1,
      sym_number,
    ACTIONS(4779), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2150), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1191), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3939), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1145), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 23,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3616), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2618), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1177), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1231), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2541), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1277), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1159), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      anon_sym_STAR,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      sym_number,
    ACTIONS(4781), 1,
      sym_readonly,
    ACTIONS(4599), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1867), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68771] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4783), 1,
      anon_sym_COLON,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68856] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      anon_sym_STAR,
    ACTIONS(4785), 1,
      sym_number,
    ACTIONS(4787), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68915] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4741), 1,
      anon_sym_STAR,
    ACTIONS(4789), 1,
      sym_number,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2161), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [68974] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4729), 1,
      anon_sym_STAR,
    ACTIONS(4793), 1,
      anon_sym_async,
    ACTIONS(4795), 1,
      sym_number,
    ACTIONS(4797), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1882), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2448), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2486), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2494), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_DOT,
    ACTIONS(2396), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2394), 23,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2644), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 1,
      anon_sym_AMP,
    ACTIONS(4765), 1,
      anon_sym_PIPE,
    ACTIONS(2636), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2634), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2460), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2516), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2464), 24,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1117), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1119), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LBRACK,
    ACTIONS(2482), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2480), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4081), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4083), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4037), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3814), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69628] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4785), 1,
      sym_number,
    STATE(2165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3895), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3897), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [69776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4033), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4035), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69820] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3703), 1,
      anon_sym_LT,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [69878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3782), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4031), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [69966] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4701), 1,
      sym_number,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70020] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4029), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4031), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4025), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4027), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70176] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(2530), 1,
      sym_readonly,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4023), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70290] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70356] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3284), 1,
      anon_sym_DOT,
    ACTIONS(3701), 1,
      anon_sym_LBRACK,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4019), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4099), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3882), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4091), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4093), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3979), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3981), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3937), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3939), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1205), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2446), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4089), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3893), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70794] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      sym_number,
    STATE(1990), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [70848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4045), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70892] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3703), 1,
      anon_sym_LT,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    STATE(2548), 1,
      sym_type_arguments,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 16,
      anon_sym_as,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [70950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4066), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [70998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2559), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2541), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2545), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1213), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1235), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3973), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1163), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1133), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1167), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4805), 1,
      anon_sym_AMP,
    ACTIONS(4807), 1,
      anon_sym_PIPE,
    ACTIONS(2650), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2648), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4805), 1,
      anon_sym_AMP,
    ACTIONS(4807), 1,
      anon_sym_PIPE,
    ACTIONS(2624), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2622), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4805), 1,
      anon_sym_AMP,
    ACTIONS(4807), 1,
      anon_sym_PIPE,
    ACTIONS(2632), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2630), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4805), 1,
      anon_sym_AMP,
    ACTIONS(4807), 1,
      anon_sym_PIPE,
    ACTIONS(2636), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2634), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71640] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4805), 1,
      anon_sym_AMP,
    ACTIONS(4807), 1,
      anon_sym_PIPE,
    ACTIONS(2646), 12,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2644), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_DOT,
    ACTIONS(2396), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2394), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2446), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2398), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2430), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1195), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [71914] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4777), 1,
      sym_number,
    STATE(2150), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [71968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_COMMA,
    ACTIONS(4063), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72018] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4789), 1,
      sym_number,
    STATE(2161), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4045), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1149), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72160] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4809), 1,
      sym_number,
    STATE(2139), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1181), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1209), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4039), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4041), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2498), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2472), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2456), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72478] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      sym_number,
    STATE(2134), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [72532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4087), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2452), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2440), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4171), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2464), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2516), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2460), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4137), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4139), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2494), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2486), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [72972] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4769), 1,
      sym_number,
    STATE(2186), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4143), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2448), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4155), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1191), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2490), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1107), 12,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1109), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2476), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4536), 1,
      anon_sym_DOT,
    ACTIONS(2436), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2434), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2444), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2506), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2512), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LBRACK,
    ACTIONS(2522), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2520), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4618), 1,
      anon_sym_DOT,
    ACTIONS(2607), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2605), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2490), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4077), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1145), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73696] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      anon_sym_DOT,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3947), 1,
      anon_sym_LBRACK,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4071), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2611), 1,
      anon_sym_COMMA,
    ACTIONS(3973), 1,
      anon_sym_LBRACK,
    ACTIONS(3976), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 10,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 21,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1229), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1231), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [73916] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4622), 1,
      sym_number,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [73970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4111), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3791), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2468), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(617), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74102] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4723), 1,
      sym_number,
    STATE(2180), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1277), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(2502), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74244] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4731), 1,
      sym_number,
    STATE(2167), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3662), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74342] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74410] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74478] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74528] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(2530), 1,
      sym_readonly,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74598] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(2530), 1,
      sym_readonly,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74668] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74734] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4157), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4159), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4186), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4097), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [74932] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4737), 1,
      sym_number,
    STATE(2114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [74986] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    ACTIONS(3566), 1,
      anon_sym_DOT,
    ACTIONS(3707), 1,
      anon_sym_as,
    ACTIONS(3778), 1,
      anon_sym_BANG,
    ACTIONS(3909), 1,
      anon_sym_LBRACK,
    ACTIONS(4254), 1,
      anon_sym_LT,
    ACTIONS(4256), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4264), 1,
      anon_sym_AMP,
    ACTIONS(4266), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 1,
      anon_sym_STAR_STAR,
    STATE(2548), 1,
      sym_type_arguments,
    ACTIONS(3780), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(4268), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1078), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4250), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(4262), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(4252), 4,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4272), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75068] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75134] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(2530), 1,
      sym_readonly,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4182), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4165), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4167), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4173), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4175), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1127), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1129), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75380] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4151), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1267), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3400), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3402), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75580] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4161), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4163), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75674] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4813), 1,
      sym_number,
    STATE(2149), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75728] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4815), 1,
      sym_number,
    STATE(1995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(3582), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [75782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1257), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4147), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4063), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4066), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 21,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3876), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3878), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [75962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1247), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1159), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4819), 1,
      anon_sym_EQ,
    ACTIONS(1221), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 22,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76142] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4630), 1,
      sym_number,
    STATE(2124), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4109), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(4105), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76284] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(4821), 1,
      anon_sym_RBRACE,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(3754), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 14,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1177), 22,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_LBRACE_PIPE,
  [76440] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(2530), 1,
      sym_readonly,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(4821), 1,
      anon_sym_RBRACE,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76510] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(4821), 1,
      anon_sym_RBRACE,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76576] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4825), 1,
      anon_sym_RPAREN,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(1749), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2942), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76647] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [76708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 1,
      anon_sym_EQ,
    ACTIONS(4566), 1,
      anon_sym_in,
    ACTIONS(4569), 1,
      anon_sym_of,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_EQ,
    ACTIONS(4561), 1,
      anon_sym_in,
    ACTIONS(4564), 1,
      anon_sym_of,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76806] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(4829), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2643), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3973), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2444), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76971] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(4831), 1,
      anon_sym_RPAREN,
    STATE(1749), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2942), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77042] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      aux_sym_object_repeat1,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(3668), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(3616), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77152] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 1,
      anon_sym_RPAREN,
    STATE(1749), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2942), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3733), 1,
      anon_sym_EQ,
    ACTIONS(3888), 1,
      anon_sym_in,
    ACTIONS(3891), 1,
      anon_sym_of,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77272] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_EQ,
    ACTIONS(3853), 1,
      anon_sym_in,
    ACTIONS(3856), 1,
      anon_sym_of,
    ACTIONS(1221), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 20,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77382] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(4835), 1,
      anon_sym_RPAREN,
    STATE(1749), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2942), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77453] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77514] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(809), 1,
      anon_sym_RPAREN,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(1750), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2632), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4066), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4063), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1221), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG,
    ACTIONS(1223), 19,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77632] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(4837), 1,
      anon_sym_RPAREN,
    STATE(1749), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2942), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      anon_sym_LPAREN,
    ACTIONS(4845), 1,
      anon_sym_DOT,
    STATE(1766), 1,
      sym_arguments,
    ACTIONS(4841), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4839), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77752] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77815] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      anon_sym_LPAREN,
    ACTIONS(4853), 1,
      anon_sym_DOT,
    STATE(1769), 1,
      sym_arguments,
    ACTIONS(4851), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4849), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77864] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4821), 1,
      anon_sym_RBRACE,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [77925] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(2530), 1,
      sym_readonly,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77990] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(4855), 1,
      anon_sym_RPAREN,
    STATE(1749), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2942), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78061] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78122] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(4857), 1,
      anon_sym_RPAREN,
    STATE(1748), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2707), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78193] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78249] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(1749), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2942), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4859), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78359] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2723), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78427] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2907), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78495] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(819), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2599), 1,
      sym_readonly,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    STATE(1855), 1,
      sym_accessibility_modifier,
    STATE(2076), 1,
      sym__parameter_name,
    STATE(2369), 1,
      sym_array,
    STATE(2381), 1,
      sym_object,
    ACTIONS(4823), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2597), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2643), 3,
      sym_rest_parameter,
      sym_required_parameter,
      sym_optional_parameter,
    ACTIONS(2573), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4865), 10,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4863), 24,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [78605] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    ACTIONS(4867), 1,
      anon_sym_module,
    ACTIONS(4869), 1,
      anon_sym_global,
    STATE(1854), 1,
      sym_decorator,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    STATE(2384), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [78680] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1607), 1,
      anon_sym_namespace,
    ACTIONS(1611), 1,
      anon_sym_type,
    ACTIONS(1613), 1,
      anon_sym_import,
    ACTIONS(1615), 1,
      anon_sym_var,
    ACTIONS(1617), 1,
      anon_sym_let,
    ACTIONS(1619), 1,
      anon_sym_const,
    ACTIONS(1626), 1,
      anon_sym_class,
    ACTIONS(1628), 1,
      anon_sym_async,
    ACTIONS(1630), 1,
      anon_sym_function,
    ACTIONS(1632), 1,
      anon_sym_abstract,
    ACTIONS(1634), 1,
      anon_sym_declare,
    ACTIONS(1636), 1,
      anon_sym_module,
    ACTIONS(1638), 1,
      anon_sym_interface,
    ACTIONS(1640), 1,
      anon_sym_enum,
    ACTIONS(4871), 1,
      anon_sym_default,
    STATE(1854), 1,
      sym_decorator,
    STATE(2528), 1,
      aux_sym_export_statement_repeat1,
    STATE(585), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [78755] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(3614), 1,
      anon_sym_namespace,
    ACTIONS(3618), 1,
      anon_sym_type,
    ACTIONS(3620), 1,
      anon_sym_import,
    ACTIONS(3622), 1,
      anon_sym_var,
    ACTIONS(3624), 1,
      anon_sym_let,
    ACTIONS(3626), 1,
      anon_sym_const,
    ACTIONS(3628), 1,
      anon_sym_class,
    ACTIONS(3630), 1,
      anon_sym_async,
    ACTIONS(3632), 1,
      anon_sym_function,
    ACTIONS(3634), 1,
      anon_sym_abstract,
    ACTIONS(3636), 1,
      anon_sym_declare,
    ACTIONS(3638), 1,
      anon_sym_module,
    ACTIONS(3640), 1,
      anon_sym_interface,
    ACTIONS(3642), 1,
      anon_sym_enum,
    ACTIONS(4873), 1,
      anon_sym_default,
    STATE(1854), 1,
      sym_decorator,
    STATE(2526), 1,
      aux_sym_export_statement_repeat1,
    STATE(2370), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [78830] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1611), 1,
      anon_sym_type,
    ACTIONS(1613), 1,
      anon_sym_import,
    ACTIONS(1615), 1,
      anon_sym_var,
    ACTIONS(1617), 1,
      anon_sym_let,
    ACTIONS(1619), 1,
      anon_sym_const,
    ACTIONS(1626), 1,
      anon_sym_class,
    ACTIONS(1628), 1,
      anon_sym_async,
    ACTIONS(1630), 1,
      anon_sym_function,
    ACTIONS(1632), 1,
      anon_sym_abstract,
    ACTIONS(1638), 1,
      anon_sym_interface,
    ACTIONS(1640), 1,
      anon_sym_enum,
    ACTIONS(2382), 1,
      anon_sym_namespace,
    ACTIONS(2384), 1,
      anon_sym_declare,
    ACTIONS(2386), 1,
      anon_sym_module,
    ACTIONS(4871), 1,
      anon_sym_default,
    STATE(1854), 1,
      sym_decorator,
    STATE(2528), 1,
      aux_sym_export_statement_repeat1,
    STATE(585), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [78905] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1607), 1,
      anon_sym_namespace,
    ACTIONS(1611), 1,
      anon_sym_type,
    ACTIONS(1613), 1,
      anon_sym_import,
    ACTIONS(1615), 1,
      anon_sym_var,
    ACTIONS(1617), 1,
      anon_sym_let,
    ACTIONS(1619), 1,
      anon_sym_const,
    ACTIONS(1626), 1,
      anon_sym_class,
    ACTIONS(1628), 1,
      anon_sym_async,
    ACTIONS(1630), 1,
      anon_sym_function,
    ACTIONS(1632), 1,
      anon_sym_abstract,
    ACTIONS(1634), 1,
      anon_sym_declare,
    ACTIONS(1638), 1,
      anon_sym_interface,
    ACTIONS(1640), 1,
      anon_sym_enum,
    ACTIONS(2376), 1,
      anon_sym_module,
    ACTIONS(2378), 1,
      anon_sym_global,
    STATE(1854), 1,
      sym_decorator,
    STATE(2528), 1,
      aux_sym_export_statement_repeat1,
    STATE(535), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [78980] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4821), 1,
      anon_sym_RBRACE,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79082] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79184] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1611), 1,
      anon_sym_type,
    ACTIONS(1613), 1,
      anon_sym_import,
    ACTIONS(1615), 1,
      anon_sym_var,
    ACTIONS(1617), 1,
      anon_sym_let,
    ACTIONS(1619), 1,
      anon_sym_const,
    ACTIONS(1626), 1,
      anon_sym_class,
    ACTIONS(1628), 1,
      anon_sym_async,
    ACTIONS(1630), 1,
      anon_sym_function,
    ACTIONS(1632), 1,
      anon_sym_abstract,
    ACTIONS(1638), 1,
      anon_sym_interface,
    ACTIONS(1640), 1,
      anon_sym_enum,
    ACTIONS(2378), 1,
      anon_sym_global,
    ACTIONS(2382), 1,
      anon_sym_namespace,
    ACTIONS(2384), 1,
      anon_sym_declare,
    ACTIONS(2392), 1,
      anon_sym_module,
    STATE(1854), 1,
      sym_decorator,
    STATE(2528), 1,
      aux_sym_export_statement_repeat1,
    STATE(535), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [79259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79310] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1607), 1,
      anon_sym_namespace,
    ACTIONS(1611), 1,
      anon_sym_type,
    ACTIONS(1613), 1,
      anon_sym_import,
    ACTIONS(1615), 1,
      anon_sym_var,
    ACTIONS(1617), 1,
      anon_sym_let,
    ACTIONS(1619), 1,
      anon_sym_const,
    ACTIONS(1626), 1,
      anon_sym_class,
    ACTIONS(1628), 1,
      anon_sym_async,
    ACTIONS(1630), 1,
      anon_sym_function,
    ACTIONS(1632), 1,
      anon_sym_abstract,
    ACTIONS(1638), 1,
      anon_sym_interface,
    ACTIONS(1640), 1,
      anon_sym_enum,
    ACTIONS(2378), 1,
      anon_sym_global,
    ACTIONS(2388), 1,
      anon_sym_declare,
    ACTIONS(2390), 1,
      anon_sym_module,
    STATE(1854), 1,
      sym_decorator,
    STATE(2528), 1,
      aux_sym_export_statement_repeat1,
    STATE(535), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [79385] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1607), 1,
      anon_sym_namespace,
    ACTIONS(1611), 1,
      anon_sym_type,
    ACTIONS(1613), 1,
      anon_sym_import,
    ACTIONS(1615), 1,
      anon_sym_var,
    ACTIONS(1617), 1,
      anon_sym_let,
    ACTIONS(1619), 1,
      anon_sym_const,
    ACTIONS(1626), 1,
      anon_sym_class,
    ACTIONS(1628), 1,
      anon_sym_async,
    ACTIONS(1630), 1,
      anon_sym_function,
    ACTIONS(1632), 1,
      anon_sym_abstract,
    ACTIONS(1636), 1,
      anon_sym_module,
    ACTIONS(1638), 1,
      anon_sym_interface,
    ACTIONS(1640), 1,
      anon_sym_enum,
    ACTIONS(2388), 1,
      anon_sym_declare,
    ACTIONS(4871), 1,
      anon_sym_default,
    STATE(1854), 1,
      sym_decorator,
    STATE(2528), 1,
      aux_sym_export_statement_repeat1,
    STATE(585), 15,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_internal_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [79460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4849), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4875), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79540] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2620), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2618), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3402), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3400), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4881), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4879), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4167), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4165), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 9,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3876), 23,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79746] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4883), 1,
      anon_sym_STAR,
    ACTIONS(4885), 1,
      anon_sym_async,
    ACTIONS(4887), 1,
      sym_number,
    ACTIONS(4891), 1,
      sym_readonly,
    ACTIONS(4889), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2160), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 16,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79803] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4893), 1,
      anon_sym_STAR,
    ACTIONS(4895), 1,
      sym_number,
    ACTIONS(4897), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79856] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4899), 1,
      anon_sym_STAR,
    ACTIONS(4901), 1,
      sym_number,
    ACTIONS(4903), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2195), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79909] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4887), 1,
      sym_number,
    ACTIONS(4905), 1,
      anon_sym_EQ_GT,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2160), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [79960] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4899), 1,
      anon_sym_STAR,
    ACTIONS(4901), 1,
      sym_number,
    ACTIONS(4907), 1,
      anon_sym_async,
    ACTIONS(4903), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2195), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80015] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4883), 1,
      anon_sym_STAR,
    ACTIONS(4887), 1,
      sym_number,
    ACTIONS(4889), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2160), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80068] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4883), 1,
      anon_sym_STAR,
    ACTIONS(4885), 1,
      anon_sym_async,
    ACTIONS(4887), 1,
      sym_number,
    ACTIONS(4889), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2160), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80123] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2134), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80171] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4622), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4911), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4909), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4737), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4701), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(2306), 1,
      sym_object,
    STATE(2308), 1,
      sym_array,
    ACTIONS(4915), 2,
      sym_identifier,
      sym_this,
    ACTIONS(4919), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4917), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4923), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4921), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1133), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1135), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80479] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4777), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2150), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4927), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4925), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80565] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4929), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2192), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4895), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4931), 1,
      sym__automatic_semicolon,
    ACTIONS(1103), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1105), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1215), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4935), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4933), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80777] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4937), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2184), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4939), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4943), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80901] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4789), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2161), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4947), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [80987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    STATE(2429), 1,
      sym_object,
    STATE(2433), 1,
      sym_array,
    ACTIONS(2878), 2,
      sym_identifier,
      sym_this,
    ACTIONS(658), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2880), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4951), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4957), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4955), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81111] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4731), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2167), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81159] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4959), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2133), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81207] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4961), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2147), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81255] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4723), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2180), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4963), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81341] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4887), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2160), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4967), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4769), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2186), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4971), 1,
      sym__automatic_semicolon,
    ACTIONS(1133), 8,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1135), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4975), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4973), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4979), 9,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4977), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4901), 1,
      sym_number,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2195), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81639] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4591), 1,
      anon_sym_STAR,
    ACTIONS(4593), 1,
      anon_sym_async,
    ACTIONS(4595), 1,
      sym_number,
    ACTIONS(4981), 1,
      anon_sym_static,
    ACTIONS(4983), 1,
      anon_sym_abstract,
    ACTIONS(4985), 1,
      sym_readonly,
    ACTIONS(4599), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1867), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3582), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81696] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4987), 1,
      anon_sym_RBRACE,
    ACTIONS(4989), 1,
      sym_number,
    STATE(2831), 1,
      sym_enum_assignment,
    STATE(2536), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81745] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4991), 1,
      anon_sym_RBRACE,
    ACTIONS(4993), 1,
      sym_number,
    STATE(2737), 1,
      sym_enum_assignment,
    STATE(2331), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81794] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4989), 1,
      sym_number,
    ACTIONS(4995), 1,
      anon_sym_RBRACE,
    STATE(2831), 1,
      sym_enum_assignment,
    STATE(2536), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81843] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4997), 1,
      anon_sym_RBRACE,
    ACTIONS(4999), 1,
      sym_number,
    STATE(2641), 1,
      sym_enum_assignment,
    STATE(2427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81892] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4989), 1,
      sym_number,
    ACTIONS(5001), 1,
      anon_sym_RBRACE,
    STATE(2831), 1,
      sym_enum_assignment,
    STATE(2536), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4989), 1,
      sym_number,
    ACTIONS(5003), 1,
      anon_sym_RBRACE,
    STATE(2831), 1,
      sym_enum_assignment,
    STATE(2536), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [81990] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(5005), 1,
      anon_sym_STAR,
    ACTIONS(5007), 1,
      sym_number,
    ACTIONS(5011), 1,
      sym_readonly,
    ACTIONS(5009), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1870), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82040] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(5013), 1,
      anon_sym_STAR,
    ACTIONS(5015), 1,
      sym_number,
    ACTIONS(5019), 1,
      sym_readonly,
    ACTIONS(5017), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1868), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3582), 17,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(5021), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82126] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4628), 1,
      anon_sym_STAR,
    ACTIONS(4634), 1,
      anon_sym_async,
    ACTIONS(4636), 1,
      sym_number,
    ACTIONS(4640), 1,
      sym_readonly,
    ACTIONS(5023), 1,
      anon_sym_static,
    ACTIONS(4638), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1876), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3582), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_AT,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
    ACTIONS(5027), 3,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5025), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82222] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4274), 1,
      anon_sym_STAR,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4280), 1,
      anon_sym_async,
    ACTIONS(4282), 1,
      sym_number,
    ACTIONS(4313), 1,
      sym_readonly,
    ACTIONS(5032), 1,
      anon_sym_static,
    ACTIONS(4284), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1875), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3582), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82276] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(2526), 1,
      anon_sym_async,
    ACTIONS(2530), 1,
      sym_readonly,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4801), 1,
      anon_sym_STAR,
    ACTIONS(5034), 1,
      anon_sym_static,
    ACTIONS(2528), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 15,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_void,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(658), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2618), 21,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82368] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4989), 1,
      sym_number,
    STATE(2831), 1,
      sym_enum_assignment,
    STATE(2536), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82414] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4731), 1,
      sym_number,
    STATE(2167), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4809), 1,
      sym_number,
    STATE(2139), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4887), 1,
      sym_number,
    STATE(2160), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82543] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4901), 1,
      sym_number,
    STATE(2195), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82586] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4929), 1,
      sym_number,
    STATE(2192), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82629] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4723), 1,
      sym_number,
    STATE(2180), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82672] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4622), 1,
      sym_number,
    STATE(2156), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82715] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4317), 1,
      sym_number,
    STATE(2188), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4961), 1,
      sym_number,
    STATE(2147), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4959), 1,
      sym_number,
    STATE(2133), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82844] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4769), 1,
      sym_number,
    STATE(2186), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4789), 1,
      sym_number,
    STATE(2161), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82930] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4813), 1,
      sym_number,
    STATE(2149), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [82973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4630), 1,
      sym_number,
    STATE(2124), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83016] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4785), 1,
      sym_number,
    STATE(2165), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4895), 1,
      sym_number,
    STATE(2119), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83102] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4937), 1,
      sym_number,
    STATE(2184), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83145] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4815), 1,
      sym_number,
    STATE(1995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3582), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(2426), 1,
      sym_number,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    STATE(2197), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4777), 1,
      sym_number,
    STATE(2150), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83274] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4737), 1,
      sym_number,
    STATE(2114), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83317] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4701), 1,
      sym_number,
    STATE(2201), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83360] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(4315), 1,
      anon_sym_LBRACK,
    ACTIONS(4656), 1,
      sym_number,
    STATE(2134), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2524), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83403] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      sym_number,
    STATE(1990), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3582), 20,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AT,
    ACTIONS(5036), 22,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_class,
      anon_sym_async,
      anon_sym_void,
      sym_identifier,
      sym_this,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83480] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(5040), 1,
      sym_readonly,
    STATE(2429), 1,
      sym_object,
    STATE(2433), 1,
      sym_array,
    ACTIONS(2878), 2,
      sym_identifier,
      sym_this,
    ACTIONS(2880), 18,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5042), 1,
      sym_identifier,
    STATE(1739), 1,
      sym_decorator_member_expression,
    STATE(1765), 1,
      sym_decorator_call_expression,
    ACTIONS(5044), 19,
      anon_sym_export,
      anon_sym_namespace,
      anon_sym_type,
      anon_sym_async,
      anon_sym_void,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      sym_readonly,
  [83557] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5048), 1,
      anon_sym_EQ,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_COMMA,
    ACTIONS(5054), 1,
      anon_sym_COLON,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5058), 1,
      anon_sym_GT,
    ACTIONS(5061), 1,
      anon_sym_SLASH,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5067), 1,
      anon_sym_extends,
    STATE(1974), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2532), 1,
      sym_constraint,
    STATE(2798), 1,
      sym_default_type,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [83613] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5048), 1,
      anon_sym_EQ,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_COMMA,
    ACTIONS(5054), 1,
      anon_sym_COLON,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5058), 1,
      anon_sym_GT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5067), 1,
      anon_sym_extends,
    ACTIONS(5069), 1,
      anon_sym_SLASH,
    STATE(2013), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2532), 1,
      sym_constraint,
    STATE(2798), 1,
      sym_default_type,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [83669] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5048), 1,
      anon_sym_EQ,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_COMMA,
    ACTIONS(5054), 1,
      anon_sym_COLON,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5058), 1,
      anon_sym_GT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5067), 1,
      anon_sym_extends,
    ACTIONS(5071), 1,
      anon_sym_SLASH,
    STATE(1977), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2532), 1,
      sym_constraint,
    STATE(2798), 1,
      sym_default_type,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [83725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 4,
      anon_sym_EQ,
      anon_sym_while,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1235), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [83749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 3,
      anon_sym_EQ,
      anon_sym_while,
      sym_identifier,
    ACTIONS(2541), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [83772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 3,
      anon_sym_EQ,
      anon_sym_while,
      sym_identifier,
    ACTIONS(2545), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [83795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 3,
      anon_sym_EQ,
      anon_sym_while,
      sym_identifier,
    ACTIONS(2559), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [83818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1167), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [83841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      anon_sym_PIPE,
    ACTIONS(1163), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [83864] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 1,
      anon_sym_EQ,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5073), 1,
      anon_sym_DOT,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(2532), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [83895] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    ACTIONS(5079), 1,
      anon_sym_QMARK,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2422), 1,
      sym__call_signature,
    STATE(2428), 1,
      sym_type_annotation,
    STATE(2604), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5077), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [83937] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    ACTIONS(5085), 1,
      anon_sym_QMARK,
    ACTIONS(5087), 1,
      anon_sym_BANG,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2386), 1,
      sym_type_annotation,
    STATE(2569), 1,
      sym__call_signature,
    STATE(2582), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5083), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [83979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5073), 1,
      anon_sym_DOT,
    ACTIONS(5093), 1,
      anon_sym_GT,
    ACTIONS(5096), 1,
      anon_sym_is,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(5089), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5091), 2,
      anon_sym_LBRACE,
      sym_jsx_identifier,
    ACTIONS(2532), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [84013] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    ACTIONS(5081), 1,
      anon_sym_BANG,
    ACTIONS(5098), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2428), 1,
      sym_type_annotation,
    STATE(2601), 1,
      sym__call_signature,
    STATE(2604), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5077), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84055] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    ACTIONS(5102), 1,
      anon_sym_QMARK,
    ACTIONS(5104), 1,
      anon_sym_BANG,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2406), 1,
      sym__call_signature,
    STATE(2407), 1,
      sym_type_annotation,
    STATE(2666), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5100), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84097] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    ACTIONS(5087), 1,
      anon_sym_BANG,
    ACTIONS(5106), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2221), 1,
      sym__call_signature,
    STATE(2386), 1,
      sym_type_annotation,
    STATE(2582), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5083), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84139] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    ACTIONS(5110), 1,
      anon_sym_QMARK,
    ACTIONS(5112), 1,
      anon_sym_BANG,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2416), 1,
      sym__call_signature,
    STATE(2420), 1,
      sym_type_annotation,
    STATE(2562), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5108), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84181] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 1,
      anon_sym_PIPE,
    ACTIONS(3305), 1,
      anon_sym_is,
    ACTIONS(5114), 1,
      anon_sym_LT,
    ACTIONS(5116), 1,
      anon_sym_DOT,
    STATE(1933), 1,
      sym_type_arguments,
    ACTIONS(2532), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [84211] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5120), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2056), 1,
      sym__call_signature,
    STATE(2215), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5118), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84246] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5122), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2215), 1,
      sym_type_annotation,
    STATE(2344), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5118), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5126), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2279), 1,
      sym_type_annotation,
    STATE(2292), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5124), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84316] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5132), 1,
      anon_sym_SLASH,
    STATE(1989), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [84357] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5134), 1,
      anon_sym_SLASH,
    STATE(2014), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [84398] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5138), 1,
      anon_sym_COLON,
    ACTIONS(5140), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2105), 1,
      sym__call_signature,
    STATE(2281), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5136), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84433] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5144), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2403), 1,
      sym_type_annotation,
    STATE(2411), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84468] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5146), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2111), 1,
      sym__call_signature,
    STATE(2279), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5124), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84503] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5148), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2080), 1,
      sym__call_signature,
    STATE(2403), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5142), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84538] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5150), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2272), 1,
      sym__call_signature,
    STATE(2281), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5136), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_EQ,
    ACTIONS(5056), 1,
      anon_sym_LT,
    STATE(423), 1,
      sym_type_arguments,
    ACTIONS(2611), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [84598] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2311), 1,
      sym_type_annotation,
    STATE(2366), 1,
      sym__call_signature,
    STATE(2555), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5152), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84634] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2075), 1,
      sym__call_signature,
    STATE(2402), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5154), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84666] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5061), 1,
      anon_sym_SLASH,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(1974), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [84704] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5134), 1,
      anon_sym_SLASH,
    STATE(2014), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [84742] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2259), 1,
      sym_type_annotation,
    STATE(2271), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5156), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84774] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2104), 1,
      sym__call_signature,
    STATE(2259), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5156), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84806] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2314), 1,
      sym_type_annotation,
    STATE(2333), 1,
      sym__call_signature,
    STATE(2577), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5158), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84842] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3316), 1,
      anon_sym_is,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5073), 1,
      anon_sym_DOT,
    ACTIONS(5160), 1,
      anon_sym_RPAREN,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(2532), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3578), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [84872] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2064), 1,
      sym__call_signature,
    STATE(2285), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5163), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_EQ,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(2605), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
  [84926] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2237), 1,
      sym__call_signature,
    STATE(2241), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5165), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [84958] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2311), 1,
      sym_type_annotation,
    STATE(2555), 1,
      sym__initializer,
    STATE(2568), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5152), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [84994] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5069), 1,
      anon_sym_SLASH,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(2013), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_PIPE,
    ACTIONS(5114), 1,
      anon_sym_LT,
    STATE(1931), 1,
      sym_type_arguments,
    ACTIONS(2611), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85056] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2359), 1,
      sym_type_annotation,
    STATE(2382), 1,
      sym__call_signature,
    STATE(2618), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5167), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85092] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5071), 1,
      anon_sym_SLASH,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(1977), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85130] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2402), 1,
      sym_type_annotation,
    STATE(2417), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5154), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85162] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2387), 1,
      sym__call_signature,
    STATE(2435), 1,
      sym_type_annotation,
    STATE(2557), 1,
      sym__initializer,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5169), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85198] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2435), 1,
      sym_type_annotation,
    STATE(2557), 1,
      sym__initializer,
    STATE(2561), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5169), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [85234] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2285), 1,
      sym_type_annotation,
    STATE(2310), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5163), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85266] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5056), 1,
      anon_sym_LT,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5132), 1,
      anon_sym_SLASH,
    STATE(1989), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2016), 1,
      sym_type_arguments,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85304] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2052), 1,
      sym__call_signature,
    STATE(2241), 1,
      sym_type_annotation,
    STATE(2892), 1,
      sym_type_parameters,
    ACTIONS(5165), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [85336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DOT,
    ACTIONS(2396), 1,
      anon_sym_PIPE,
    ACTIONS(2394), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      anon_sym_EQ,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(2644), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [85402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [85419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_EQ,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(2622), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [85463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_EQ,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(2630), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [85486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [85528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_PIPE,
    ACTIONS(5175), 1,
      anon_sym_DOT,
    ACTIONS(2605), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym_EQ,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(2634), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [85572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_EQ,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(2648), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
  [85595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PIPE_RBRACE,
  [85612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_PIPE,
    ACTIONS(5116), 1,
      anon_sym_DOT,
    ACTIONS(2434), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 1,
      anon_sym_PIPE,
    ACTIONS(1235), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5179), 1,
      anon_sym_PIPE,
    ACTIONS(2648), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [85672] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      sym_identifier,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    STATE(1417), 1,
      sym_class_body,
    STATE(2060), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2951), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [85706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_PIPE,
    ACTIONS(2448), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85724] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5189), 1,
      sym_identifier,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1102), 1,
      sym_class_body,
    STATE(2066), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2858), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [85758] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5193), 1,
      sym_identifier,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1596), 1,
      sym_class_body,
    STATE(2094), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2864), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [85792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_PIPE,
    ACTIONS(2545), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85810] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5132), 1,
      anon_sym_SLASH,
    STATE(1989), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [85842] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5197), 1,
      sym_identifier,
    STATE(1549), 1,
      sym_class_body,
    STATE(2109), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2895), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [85876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_PIPE,
    ACTIONS(2398), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      anon_sym_PIPE,
    ACTIONS(2476), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 1,
      anon_sym_PIPE,
    ACTIONS(2430), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_PIPE,
    ACTIONS(2444), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_PIPE,
    ACTIONS(2506), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 1,
      anon_sym_PIPE,
    ACTIONS(2512), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [85984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_PIPE,
    ACTIONS(5199), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_PIPE,
    ACTIONS(2516), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 1,
      anon_sym_PIPE,
    ACTIONS(2490), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 1,
      anon_sym_PIPE,
    ACTIONS(2502), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_PIPE,
    ACTIONS(2464), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 1,
      anon_sym_PIPE,
    ACTIONS(2494), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 1,
      anon_sym_EQ,
    ACTIONS(4548), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [86112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_PIPE,
    ACTIONS(2541), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86130] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5134), 1,
      anon_sym_SLASH,
    STATE(2014), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86162] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    ACTIONS(5201), 1,
      sym_identifier,
    STATE(1025), 1,
      sym_class_body,
    STATE(2083), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2804), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      anon_sym_PIPE,
    ACTIONS(2472), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_PIPE,
    ACTIONS(2486), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86232] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    ACTIONS(5203), 1,
      sym_identifier,
    STATE(1684), 1,
      sym_class_body,
    STATE(2078), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2973), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      anon_sym_PIPE,
    ACTIONS(2440), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_PIPE,
    ACTIONS(2452), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5179), 1,
      anon_sym_PIPE,
    ACTIONS(2630), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [86322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5179), 1,
      anon_sym_PIPE,
    ACTIONS(2644), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [86342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_PIPE,
    ACTIONS(2456), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86360] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5205), 1,
      sym_identifier,
    STATE(1417), 1,
      sym_class_body,
    STATE(2060), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2951), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86394] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5061), 1,
      anon_sym_SLASH,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(1974), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86426] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5207), 1,
      sym_identifier,
    STATE(1549), 1,
      sym_class_body,
    STATE(2109), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2895), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5179), 1,
      anon_sym_PIPE,
    ACTIONS(2634), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [86480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5209), 1,
      anon_sym_LT,
    ACTIONS(5211), 1,
      anon_sym_DQUOTE,
    ACTIONS(5213), 1,
      anon_sym_SQUOTE,
    STATE(1975), 1,
      sym_jsx_opening_element,
    STATE(2263), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [86506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5209), 1,
      anon_sym_LT,
    ACTIONS(5211), 1,
      anon_sym_DQUOTE,
    ACTIONS(5213), 1,
      anon_sym_SQUOTE,
    STATE(1975), 1,
      sym_jsx_opening_element,
    STATE(2260), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [86532] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5071), 1,
      anon_sym_SLASH,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(1977), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_PIPE,
    ACTIONS(2559), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86582] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5215), 1,
      sym_identifier,
    STATE(1417), 1,
      sym_class_body,
    STATE(2060), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2951), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86616] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5185), 1,
      anon_sym_implements,
    ACTIONS(5187), 1,
      anon_sym_extends,
    ACTIONS(5217), 1,
      sym_identifier,
    STATE(1549), 1,
      sym_class_body,
    STATE(2109), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2895), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_PIPE,
    ACTIONS(2460), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5179), 1,
      anon_sym_PIPE,
    ACTIONS(2622), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [86688] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5069), 1,
      anon_sym_SLASH,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(2013), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_PIPE,
    ACTIONS(5199), 1,
      anon_sym_LBRACK,
    ACTIONS(2480), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(3668), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3616), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [86760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 1,
      anon_sym_PIPE,
    ACTIONS(2498), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_PIPE,
    ACTIONS(2468), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(617), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [86814] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(3660), 1,
      anon_sym_LBRACE,
    ACTIONS(5219), 1,
      sym_identifier,
    ACTIONS(5221), 1,
      anon_sym_STAR,
    STATE(2777), 1,
      sym_import_clause,
    STATE(2776), 2,
      sym_string,
      sym_import_require_clause,
    STATE(3028), 2,
      sym_namespace_import,
      sym_named_imports,
  [86844] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5223), 1,
      anon_sym_GT,
    ACTIONS(5225), 1,
      anon_sym_SLASH,
    STATE(1999), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86873] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5229), 1,
      anon_sym_LT,
    ACTIONS(5231), 1,
      sym_jsx_text,
    ACTIONS(5233), 1,
      sym_comment,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2447), 1,
      sym_jsx_closing_element,
    STATE(2000), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [86898] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1455), 1,
      sym_class_body,
    STATE(2057), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2917), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86929] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5223), 1,
      anon_sym_GT,
    ACTIONS(5239), 1,
      anon_sym_SLASH,
    STATE(1999), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [86958] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_class_body,
    STATE(2059), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2968), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [86989] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5243), 1,
      anon_sym_LT,
    ACTIONS(5245), 1,
      sym_jsx_text,
    STATE(1058), 1,
      sym_jsx_closing_element,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2001), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87014] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_class_body,
    STATE(2043), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2929), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87045] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5069), 1,
      anon_sym_SLASH,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(2013), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87074] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5061), 1,
      anon_sym_SLASH,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(1974), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87103] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1081), 1,
      sym_class_body,
    STATE(2058), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2823), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87134] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1672), 1,
      sym_class_body,
    STATE(2110), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2794), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87165] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5249), 1,
      anon_sym_LT,
    ACTIONS(5251), 1,
      sym_jsx_text,
    STATE(1481), 1,
      sym_jsx_closing_element,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87190] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5253), 1,
      anon_sym_LT,
    ACTIONS(5255), 1,
      sym_jsx_text,
    STATE(1685), 1,
      sym_jsx_closing_element,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(1987), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87215] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5251), 1,
      sym_jsx_text,
    ACTIONS(5253), 1,
      anon_sym_LT,
    STATE(1664), 1,
      sym_jsx_closing_element,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87240] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2038), 1,
      sym_type_parameters,
    STATE(2226), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2758), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87271] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5223), 1,
      anon_sym_GT,
    ACTIONS(5257), 1,
      anon_sym_SLASH,
    STATE(1999), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87300] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2420), 1,
      sym_type_annotation,
    STATE(2562), 1,
      sym__initializer,
    ACTIONS(5112), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(5108), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87325] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1597), 1,
      sym_class_body,
    STATE(2100), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2856), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87356] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1396), 1,
      sym_class_body,
    STATE(2082), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2763), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87387] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5251), 1,
      sym_jsx_text,
    ACTIONS(5259), 1,
      anon_sym_LT,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2650), 1,
      sym_jsx_closing_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87412] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5071), 1,
      anon_sym_SLASH,
    ACTIONS(5130), 1,
      anon_sym_GT,
    STATE(1977), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2386), 1,
      sym_type_annotation,
    STATE(2582), 1,
      sym__initializer,
    ACTIONS(5087), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    ACTIONS(5083), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87466] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(520), 1,
      sym_class_body,
    STATE(2106), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2906), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87497] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1411), 1,
      sym_class_body,
    STATE(2091), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2825), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87528] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(587), 1,
      sym_class_body,
    STATE(2112), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2957), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87559] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5263), 1,
      sym_identifier,
    ACTIONS(5266), 1,
      anon_sym_LBRACE,
    ACTIONS(5269), 1,
      anon_sym_GT,
    ACTIONS(5271), 1,
      anon_sym_SLASH,
    ACTIONS(5273), 1,
      sym_jsx_identifier,
    STATE(1999), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87588] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5229), 1,
      anon_sym_LT,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5251), 1,
      sym_jsx_text,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2401), 1,
      sym_jsx_closing_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87613] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5243), 1,
      anon_sym_LT,
    ACTIONS(5251), 1,
      sym_jsx_text,
    STATE(1047), 1,
      sym_jsx_closing_element,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87638] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2087), 1,
      sym_type_parameters,
    STATE(2352), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2802), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87669] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5249), 1,
      anon_sym_LT,
    ACTIONS(5276), 1,
      sym_jsx_text,
    STATE(1477), 1,
      sym_jsx_closing_element,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(1985), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87694] = 7,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5278), 1,
      sym_jsx_text,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2637), 1,
      sym_jsx_closing_element,
    STATE(1993), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [87719] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1557), 1,
      sym_class_body,
    STATE(2042), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2920), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87750] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5134), 1,
      anon_sym_SLASH,
    STATE(2014), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87779] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1049), 1,
      sym_class_body,
    STATE(2102), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2801), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87810] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5130), 1,
      anon_sym_GT,
    ACTIONS(5132), 1,
      anon_sym_SLASH,
    STATE(1989), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5073), 1,
      anon_sym_DOT,
    ACTIONS(5280), 1,
      anon_sym_LT,
    ACTIONS(5282), 1,
      anon_sym_is,
    STATE(425), 1,
      sym_type_arguments,
    ACTIONS(2532), 5,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [87862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5179), 1,
      anon_sym_PIPE,
    ACTIONS(5284), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [87881] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(139), 1,
      sym_class_body,
    STATE(2039), 1,
      sym_type_parameters,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2971), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87912] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2090), 1,
      sym_type_parameters,
    STATE(2339), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2786), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [87943] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5223), 1,
      anon_sym_GT,
    ACTIONS(5286), 1,
      anon_sym_SLASH,
    STATE(1999), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [87972] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5223), 1,
      anon_sym_GT,
    ACTIONS(5288), 1,
      anon_sym_SLASH,
    STATE(1999), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88001] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5251), 1,
      sym_jsx_text,
    ACTIONS(5290), 1,
      anon_sym_LT,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5292), 1,
      anon_sym_GT,
    STATE(2035), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2719), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2164), 1,
      sym_type_annotation,
    ACTIONS(5294), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(515), 1,
      anon_sym_RBRACE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2718), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88111] = 6,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5296), 1,
      anon_sym_LBRACE,
    ACTIONS(5299), 1,
      anon_sym_LT,
    ACTIONS(5302), 1,
      sym_jsx_text,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88133] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5251), 1,
      sym_jsx_text,
    ACTIONS(5305), 1,
      anon_sym_LT,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88155] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5251), 1,
      sym_jsx_text,
    ACTIONS(5307), 1,
      anon_sym_LT,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1109), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(2490), 4,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [88193] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5309), 1,
      anon_sym_LT,
    ACTIONS(5311), 1,
      sym_jsx_text,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2025), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88215] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5251), 1,
      sym_jsx_text,
    ACTIONS(5313), 1,
      anon_sym_LT,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2020), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88237] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      sym_jsx_text,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2022), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(513), 1,
      anon_sym_RBRACE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2671), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(481), 1,
      anon_sym_RBRACE,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    STATE(2645), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 1,
      anon_sym_RPAREN,
    ACTIONS(2611), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3578), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [88321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5175), 1,
      anon_sym_DOT,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2244), 1,
      sym_statement_block,
    ACTIONS(1095), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 1,
      anon_sym_RPAREN,
    ACTIONS(617), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(658), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [88359] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LT,
    ACTIONS(5329), 1,
      sym_jsx_text,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2021), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88381] = 6,
    ACTIONS(5227), 1,
      anon_sym_LBRACE,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5331), 1,
      anon_sym_LT,
    ACTIONS(5333), 1,
      sym_jsx_text,
    STATE(2004), 1,
      sym_jsx_opening_element,
    STATE(2015), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [88403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2193), 1,
      sym_type_annotation,
    ACTIONS(5335), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5046), 1,
      sym_identifier,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5063), 1,
      sym_jsx_identifier,
    ACTIONS(5337), 1,
      anon_sym_GT,
    STATE(1999), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(2116), 1,
      sym_jsx_namespace_name,
    STATE(2444), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [88447] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4821), 1,
      anon_sym_RBRACE,
    STATE(2602), 1,
      aux_sym_object_repeat1,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5048), 1,
      anon_sym_EQ,
    STATE(2532), 1,
      sym_constraint,
    STATE(2798), 1,
      sym_default_type,
    ACTIONS(5052), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(5339), 2,
      anon_sym_COLON,
      anon_sym_extends,
  [88490] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2251), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2878), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88515] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(116), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2859), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(5341), 1,
      sym_identifier,
    ACTIONS(5343), 1,
      anon_sym_DOT,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    STATE(2484), 1,
      sym_nested_identifier,
  [88565] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5345), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_STAR,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2893), 1,
      sym__call_signature,
  [88590] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1472), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2840), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88615] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(521), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2852), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5280), 1,
      anon_sym_LT,
    STATE(423), 1,
      sym_type_arguments,
    ACTIONS(2611), 5,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [88657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [88670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3145), 1,
      sym_predefined_type,
    ACTIONS(5353), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88685] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2314), 1,
      sym_type_annotation,
    STATE(2577), 1,
      sym__initializer,
    ACTIONS(5158), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88706] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5355), 1,
      sym_identifier,
    ACTIONS(5357), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2931), 1,
      sym__call_signature,
  [88731] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5359), 1,
      sym_identifier,
    ACTIONS(5361), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2893), 1,
      sym__call_signature,
  [88756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3087), 1,
      sym_predefined_type,
    ACTIONS(5353), 6,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88771] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2341), 1,
      sym_type_annotation,
    STATE(2750), 1,
      sym__initializer,
    ACTIONS(3275), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2923), 1,
      sym_statement_block,
    ACTIONS(5363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_EQ,
    ACTIONS(4847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3616), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [88826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [88839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5367), 1,
      anon_sym_COLON,
    ACTIONS(5369), 1,
      anon_sym_QMARK,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2805), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [88864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2925), 1,
      sym_statement_block,
    ACTIONS(5371), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88881] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1550), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2922), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88906] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1094), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2884), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88931] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(119), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2969), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88956] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1543), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2972), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [88981] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(5373), 1,
      anon_sym_LT,
    ACTIONS(5375), 1,
      anon_sym_extends,
    STATE(2212), 1,
      sym_object_type,
    STATE(2267), 1,
      sym_type_parameters,
    STATE(2748), 1,
      sym_extends_clause,
  [89006] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5377), 1,
      sym_identifier,
    ACTIONS(5379), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2962), 1,
      sym__call_signature,
  [89031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(5381), 1,
      sym_identifier,
    ACTIONS(5383), 1,
      anon_sym_DOT,
    STATE(2030), 1,
      sym_nested_identifier,
    STATE(2070), 1,
      sym_string,
    STATE(2372), 1,
      sym__module,
  [89056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2767), 1,
      sym_statement_block,
    ACTIONS(5385), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2311), 1,
      sym_type_annotation,
    STATE(2555), 1,
      sym__initializer,
    ACTIONS(5152), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1028), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2813), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2351), 1,
      sym_type_annotation,
    STATE(2739), 1,
      sym__initializer,
    ACTIONS(3851), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2356), 1,
      sym_type_annotation,
    STATE(2730), 1,
      sym__initializer,
    ACTIONS(3886), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2435), 1,
      sym_type_annotation,
    STATE(2557), 1,
      sym__initializer,
    ACTIONS(5169), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2244), 1,
      sym_statement_block,
    ACTIONS(1095), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5179), 1,
      anon_sym_PIPE,
    ACTIONS(2658), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2359), 1,
      sym_type_annotation,
    STATE(2618), 1,
      sym__initializer,
    ACTIONS(5167), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [89250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2325), 1,
      sym_type_annotation,
    ACTIONS(5389), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2849), 1,
      sym_statement_block,
    ACTIONS(5391), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89284] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(5393), 1,
      anon_sym_EQ,
    ACTIONS(5397), 1,
      anon_sym_QMARK,
    STATE(2468), 1,
      sym_type_annotation,
    STATE(2964), 1,
      sym__initializer,
    ACTIONS(5395), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [89307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5399), 1,
      sym_identifier,
    ACTIONS(5401), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2893), 1,
      sym__call_signature,
  [89332] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1595), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2876), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5403), 1,
      sym_identifier,
    ACTIONS(5405), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2874), 1,
      sym__call_signature,
  [89382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2844), 1,
      sym_statement_block,
    ACTIONS(5407), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [89412] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1394), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2875), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1074), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2761), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89462] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5409), 1,
      sym_identifier,
    ACTIONS(5411), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2931), 1,
      sym__call_signature,
  [89487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2829), 1,
      sym_statement_block,
    ACTIONS(5413), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89504] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5415), 1,
      sym_identifier,
    ACTIONS(5417), 1,
      anon_sym_LBRACE,
    ACTIONS(5419), 1,
      anon_sym_LBRACK,
    ACTIONS(5421), 1,
      anon_sym_enum,
    STATE(2067), 1,
      sym_object,
    STATE(2068), 1,
      sym_array,
    STATE(2476), 1,
      sym_variable_declarator,
  [89529] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2220), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2759), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89554] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5423), 1,
      sym_identifier,
    ACTIONS(5425), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2812), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [89579] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5427), 1,
      sym_identifier,
    ACTIONS(5429), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2931), 1,
      sym__call_signature,
  [89604] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2266), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2868), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89629] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1357), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2796), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2822), 1,
      sym_statement_block,
    ACTIONS(5431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5433), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [89684] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1648), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2775), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89709] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym_identifier,
    ACTIONS(5437), 1,
      anon_sym_DOT,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
  [89734] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(5373), 1,
      anon_sym_LT,
    ACTIONS(5375), 1,
      anon_sym_extends,
    STATE(543), 1,
      sym_object_type,
    STATE(2342), 1,
      sym_type_parameters,
    STATE(2708), 1,
      sym_extends_clause,
  [89759] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym_identifier,
    ACTIONS(5439), 1,
      anon_sym_DOT,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
  [89784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2820), 1,
      sym_statement_block,
    ACTIONS(5441), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5443), 1,
      anon_sym_EQ,
    ACTIONS(5284), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
  [89820] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1662), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2789), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2818), 1,
      sym_statement_block,
    ACTIONS(5445), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89862] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1079), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2757), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(5449), 1,
      anon_sym_EQ,
    ACTIONS(5447), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5451), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [89906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2809), 1,
      sym_statement_block,
    ACTIONS(5453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2916), 1,
      sym_statement_block,
    ACTIONS(5455), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(496), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2934), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [89965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2410), 1,
      sym_type_annotation,
    ACTIONS(5457), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89982] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5415), 1,
      sym_identifier,
    ACTIONS(5417), 1,
      anon_sym_LBRACE,
    ACTIONS(5419), 1,
      anon_sym_LBRACK,
    ACTIONS(5459), 1,
      anon_sym_enum,
    STATE(2067), 1,
      sym_object,
    STATE(2068), 1,
      sym_array,
    STATE(2520), 1,
      sym_variable_declarator,
  [90007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1495), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2939), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [90032] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    STATE(1573), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2797), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [90057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2778), 1,
      sym_statement_block,
    ACTIONS(5461), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(5237), 1,
      anon_sym_extends,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(561), 1,
      sym_class_body,
    STATE(2678), 1,
      sym_extends_clause,
    STATE(2866), 1,
      sym_class_heritage,
    STATE(3008), 1,
      sym_implements_clause,
  [90099] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5463), 1,
      sym_identifier,
    ACTIONS(5465), 1,
      anon_sym_STAR,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2854), 1,
      sym__call_signature,
  [90124] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5467), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2101), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym_BQUOTE,
    ACTIONS(5473), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5469), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2190), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [90164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5477), 1,
      anon_sym_EQ,
    ACTIONS(5475), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5479), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [90180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3693), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5481), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2123), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3693), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5481), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90212] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5483), 1,
      anon_sym_QMARK,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2779), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [90234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5488), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5485), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90250] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      anon_sym_LBRACE,
    ACTIONS(5419), 1,
      anon_sym_LBRACK,
    ACTIONS(5490), 1,
      sym_identifier,
    STATE(2067), 1,
      sym_object,
    STATE(2068), 1,
      sym_array,
    STATE(2520), 1,
      sym_variable_declarator,
  [90272] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      anon_sym_LBRACE,
    ACTIONS(5419), 1,
      anon_sym_LBRACK,
    ACTIONS(5490), 1,
      sym_identifier,
    STATE(2067), 1,
      sym_object,
    STATE(2068), 1,
      sym_array,
    STATE(2472), 1,
      sym_variable_declarator,
  [90294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3699), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5492), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90310] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2344), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2135), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3687), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5496), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3687), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5496), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90364] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    ACTIONS(5500), 1,
      anon_sym_COMMA,
    ACTIONS(5502), 1,
      anon_sym_RBRACE,
    STATE(2716), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [90384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5506), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2808), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [90406] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym_identifier,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(548), 1,
      sym__module,
  [90428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5508), 1,
      anon_sym_default,
    ACTIONS(5511), 1,
      anon_sym_RBRACE,
    ACTIONS(5513), 1,
      anon_sym_case,
    STATE(2130), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [90446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2117), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5518), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5516), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90462] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
    ACTIONS(3905), 1,
      anon_sym_LBRACE,
    ACTIONS(3935), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5520), 1,
      anon_sym_LT,
    STATE(2535), 1,
      aux_sym_extends_clause_repeat1,
    STATE(2689), 1,
      sym_type_arguments,
  [90484] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2819), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [90506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5524), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2411), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3695), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5526), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2140), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5530), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5528), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5532), 1,
      sym_identifier,
    ACTIONS(5534), 1,
      anon_sym_GT,
    ACTIONS(5536), 1,
      sym_jsx_identifier,
    STATE(1898), 1,
      sym_nested_identifier,
    STATE(1981), 1,
      sym_jsx_namespace_name,
    STATE(2661), 1,
      sym_type_parameter,
  [90582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2141), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3691), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90598] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5540), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2565), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3691), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5538), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3689), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5542), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5544), 1,
      anon_sym_BQUOTE,
    ACTIONS(5469), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2190), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [90670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5546), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2873), 1,
      sym__call_signature,
  [90692] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym_identifier,
    STATE(491), 1,
      sym_nested_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
  [90714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5550), 1,
      anon_sym_BQUOTE,
    ACTIONS(5548), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2200), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [90732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(5393), 1,
      anon_sym_EQ,
    STATE(2503), 1,
      sym_type_annotation,
    STATE(2946), 1,
      sym__initializer,
    ACTIONS(5552), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [90752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5554), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2092), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90774] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(5381), 1,
      sym_identifier,
    STATE(2030), 1,
      sym_nested_identifier,
    STATE(2070), 1,
      sym_string,
    STATE(2302), 1,
      sym__module,
  [90796] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5556), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2569), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5558), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2320), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    ACTIONS(5381), 1,
      sym_identifier,
    STATE(2030), 1,
      sym_nested_identifier,
    STATE(2070), 1,
      sym_string,
    STATE(2372), 1,
      sym__module,
  [90862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2126), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5562), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5560), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2171), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5566), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5564), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5570), 1,
      anon_sym_BQUOTE,
    ACTIONS(5568), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2142), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [90912] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    ACTIONS(5280), 1,
      anon_sym_LT,
    STATE(423), 1,
      sym_type_arguments,
    STATE(2507), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3935), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [90932] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5572), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2221), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [90954] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5574), 1,
      sym_identifier,
    ACTIONS(5576), 1,
      anon_sym_GT,
    ACTIONS(5578), 1,
      sym_jsx_identifier,
    STATE(1888), 1,
      sym_nested_identifier,
    STATE(1982), 1,
      sym_jsx_namespace_name,
    STATE(2661), 1,
      sym_type_parameter,
  [90976] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5580), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2756), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [90998] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5582), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2756), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [91020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5584), 1,
      anon_sym_QMARK,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2924), 1,
      sym__call_signature,
  [91042] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5586), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2292), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [91076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2172), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3675), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5590), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91104] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5592), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2422), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3683), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5594), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91142] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5596), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2111), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91164] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(5341), 1,
      sym_identifier,
    STATE(509), 1,
      sym_string,
    STATE(548), 1,
      sym__module,
    STATE(2484), 1,
      sym_nested_identifier,
  [91186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5598), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_GT,
  [91202] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 1,
      sym_identifier,
    ACTIONS(5602), 1,
      anon_sym_GT,
    ACTIONS(5604), 1,
      sym_jsx_identifier,
    STATE(1901), 1,
      sym_nested_identifier,
    STATE(1994), 1,
      sym_jsx_namespace_name,
    STATE(2661), 1,
      sym_type_parameter,
  [91224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3675), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3697), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_default,
    ACTIONS(5610), 1,
      anon_sym_RBRACE,
    ACTIONS(5612), 1,
      anon_sym_case,
    STATE(2187), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [91274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2120), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3685), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5614), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2166), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3685), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5614), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    ACTIONS(5616), 1,
      anon_sym_COMMA,
    ACTIONS(5618), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [91326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5089), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5091), 4,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [91340] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      anon_sym_LBRACE,
    ACTIONS(5419), 1,
      anon_sym_LBRACK,
    ACTIONS(5490), 1,
      sym_identifier,
    STATE(2067), 1,
      sym_object,
    STATE(2068), 1,
      sym_array,
    STATE(2684), 1,
      sym_variable_declarator,
  [91362] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      anon_sym_LBRACE,
    ACTIONS(5419), 1,
      anon_sym_LBRACK,
    ACTIONS(5490), 1,
      sym_identifier,
    STATE(2067), 1,
      sym_object,
    STATE(2068), 1,
      sym_array,
    STATE(2469), 1,
      sym_variable_declarator,
  [91384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2080), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91406] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5417), 1,
      anon_sym_LBRACE,
    ACTIONS(5419), 1,
      anon_sym_LBRACK,
    ACTIONS(5490), 1,
      sym_identifier,
    STATE(2067), 1,
      sym_object,
    STATE(2068), 1,
      sym_array,
    STATE(2476), 1,
      sym_variable_declarator,
  [91428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5624), 1,
      anon_sym_BQUOTE,
    ACTIONS(5622), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2115), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [91446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5626), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2888), 1,
      sym__call_signature,
  [91468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5628), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2274), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2174), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(5632), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5630), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5634), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2269), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_default,
    ACTIONS(5612), 1,
      anon_sym_case,
    ACTIONS(5636), 1,
      anon_sym_RBRACE,
    STATE(2130), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [91546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5638), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2056), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5640), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2888), 1,
      sym__call_signature,
  [91590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5645), 1,
      anon_sym_BQUOTE,
    ACTIONS(5647), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5642), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2190), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [91608] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    ACTIONS(5341), 1,
      sym_identifier,
    STATE(509), 1,
      sym_string,
    STATE(534), 1,
      sym__module,
    STATE(2484), 1,
      sym_nested_identifier,
  [91630] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5650), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2247), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91664] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5654), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2888), 1,
      sym__call_signature,
  [91686] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5656), 1,
      anon_sym_QMARK,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2843), 1,
      sym__call_signature,
  [91708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5658), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2788), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [91730] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5660), 1,
      anon_sym_QMARK,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2841), 1,
      sym__call_signature,
  [91752] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5662), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2811), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [91774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3616), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [91786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5664), 1,
      anon_sym_BQUOTE,
    ACTIONS(5469), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2190), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [91804] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    ACTIONS(5666), 1,
      anon_sym_QMARK,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2416), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91826] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    ACTIONS(5668), 1,
      sym_identifier,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2756), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [91848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91859] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2098), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2965), 1,
      sym__call_signature,
  [91897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2387), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2795), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [91935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5674), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [91948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2491), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [91967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [91989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2814), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92044] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2787), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [92063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1788), 1,
      sym_statement_block,
    ACTIONS(5407), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92111] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2921), 1,
      sym__call_signature,
  [92130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2909), 1,
      sym__call_signature,
  [92149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2502), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DOT,
    ACTIONS(2396), 1,
      anon_sym_LBRACE,
    ACTIONS(2394), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [92183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    ACTIONS(5684), 1,
      anon_sym_GT,
    STATE(2648), 1,
      aux_sym_implements_clause_repeat1,
  [92213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5488), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92246] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2842), 1,
      sym__call_signature,
  [92265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2933), 1,
      sym__call_signature,
  [92284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    ACTIONS(5686), 1,
      anon_sym_RBRACE,
    STATE(2919), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [92301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5690), 1,
      anon_sym_SLASH,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [92320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2792), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [92350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5363), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5694), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [92380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2799), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [92399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2845), 1,
      sym__call_signature,
  [92418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5696), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2271), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5413), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2522), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92511] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2521), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92541] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2245), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5698), 1,
      sym_identifier,
    ACTIONS(5700), 1,
      anon_sym_GT,
    ACTIONS(5702), 1,
      sym_jsx_identifier,
    STATE(1889), 1,
      sym_nested_identifier,
    STATE(2006), 1,
      sym_jsx_namespace_name,
  [92601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2871), 1,
      sym__call_signature,
  [92631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5441), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_statement_block,
    ACTIONS(5413), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92657] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2790), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [92676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5704), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5708), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [92700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2544), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5710), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5712), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [92743] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5714), 1,
      anon_sym_COMMA,
    ACTIONS(5716), 1,
      anon_sym_GT,
    STATE(2740), 1,
      aux_sym_implements_clause_repeat1,
  [92762] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5718), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [92781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(5375), 1,
      anon_sym_extends,
    STATE(2394), 1,
      sym_object_type,
    STATE(2734), 1,
      sym_extends_clause,
  [92811] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2465), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2256), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5455), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2915), 1,
      sym__call_signature,
  [92901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1800), 1,
      sym_statement_block,
    ACTIONS(5431), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2257), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [92935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1796), 1,
      sym_statement_block,
    ACTIONS(5441), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [92950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5720), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [92969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5722), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2867), 1,
      sym__call_signature,
  [93032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5726), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [93043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    ACTIONS(5728), 1,
      anon_sym_RBRACE,
    STATE(2935), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [93060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5730), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2710), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5734), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [93145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5461), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2814), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [93175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(5738), 1,
      anon_sym_RBRACK,
    STATE(2564), 1,
      aux_sym_implements_clause_repeat1,
  [93205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4919), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2529), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [93246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2891), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5280), 1,
      anon_sym_LT,
    STATE(423), 1,
      sym_type_arguments,
    ACTIONS(4339), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [93283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5740), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5744), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2926), 1,
      sym__call_signature,
  [93357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [93368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(5748), 1,
      anon_sym_RBRACK,
    STATE(2721), 1,
      aux_sym_implements_clause_repeat1,
  [93387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2559), 1,
      sym__initializer,
    ACTIONS(5750), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    ACTIONS(5520), 1,
      anon_sym_LT,
    STATE(2689), 1,
      sym_type_arguments,
    ACTIONS(4339), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [93430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5752), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [93449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2581), 1,
      sym__initializer,
    ACTIONS(5754), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93464] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2755), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [93483] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5756), 1,
      anon_sym_COMMA,
    ACTIONS(5758), 1,
      anon_sym_GT,
    STATE(2573), 1,
      aux_sym_implements_clause_repeat1,
  [93502] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5760), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [93521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1109), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5762), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [93551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1795), 1,
      sym_statement_block,
    ACTIONS(5445), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93566] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2276), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [93585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    ACTIONS(5764), 1,
      anon_sym_RBRACE,
    STATE(2919), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [93602] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_LBRACK,
    ACTIONS(5766), 1,
      sym_identifier,
    STATE(3068), 1,
      sym_object,
    STATE(3071), 1,
      sym_array,
  [93621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3723), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5457), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2879), 1,
      sym__call_signature,
  [93662] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2918), 1,
      sym__call_signature,
  [93681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 1,
      anon_sym_EQ,
    ACTIONS(4548), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4169), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4171), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [93707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5768), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [93726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5393), 1,
      anon_sym_EQ,
    ACTIONS(5770), 1,
      anon_sym_COMMA,
    ACTIONS(5772), 1,
      anon_sym_RBRACE,
    STATE(2713), 1,
      aux_sym_enum_body_repeat1,
    STATE(2865), 1,
      sym__initializer,
  [93745] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2855), 1,
      sym__call_signature,
  [93764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1793), 1,
      sym_statement_block,
    ACTIONS(5453), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2768), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [93798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5774), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1169), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1167), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [93822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2821), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [93841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [93852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2075), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [93882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2685), 1,
      sym__initializer,
    ACTIONS(5776), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    ACTIONS(5375), 1,
      anon_sym_extends,
    STATE(597), 1,
      sym_object_type,
    STATE(2644), 1,
      sym_extends_clause,
  [93916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5778), 1,
      anon_sym_COMMA,
    ACTIONS(5780), 1,
      anon_sym_GT,
    STATE(2742), 1,
      aux_sym_implements_clause_repeat1,
  [93957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(2644), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [93972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2417), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [93991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5786), 1,
      anon_sym_COMMA,
    ACTIONS(5788), 1,
      anon_sym_GT,
    STATE(2631), 1,
      aux_sym_implements_clause_repeat1,
  [94010] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5790), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [94029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5792), 1,
      sym__automatic_semicolon,
    ACTIONS(1225), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2683), 1,
      sym__initializer,
    ACTIONS(5794), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5796), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [94087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5798), 1,
      anon_sym_export,
    ACTIONS(5800), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [94106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(5802), 1,
      anon_sym_RBRACK,
    STATE(2640), 1,
      aux_sym_implements_clause_repeat1,
  [94125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2682), 1,
      sym__initializer,
    ACTIONS(5804), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2567), 1,
      sym__initializer,
    ACTIONS(5806), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(2634), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [94192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5808), 1,
      anon_sym_COMMA,
    ACTIONS(5810), 1,
      anon_sym_GT,
    STATE(2728), 1,
      aux_sym_implements_clause_repeat1,
  [94211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2810), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5812), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [94237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4155), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1785), 1,
      sym_statement_block,
    ACTIONS(5391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    ACTIONS(5814), 1,
      anon_sym_RBRACE,
    STATE(2935), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [94304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4713), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2887), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5816), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_implements,
      anon_sym_extends,
  [94359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4151), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2832), 1,
      sym__call_signature,
  [94391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2895), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94402] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2561), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [94421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2818), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      sym__automatic_semicolon,
    ACTIONS(1261), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5820), 1,
      sym__automatic_semicolon,
    ACTIONS(1251), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1801), 1,
      sym_statement_block,
    ACTIONS(5363), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(658), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94506] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(5822), 1,
      anon_sym_RBRACK,
    STATE(2599), 1,
      aux_sym_implements_clause_repeat1,
  [94525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2558), 1,
      sym__initializer,
    ACTIONS(5824), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1812), 1,
      sym_statement_block,
    ACTIONS(5385), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94555] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2064), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [94574] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2881), 1,
      sym__call_signature,
  [94593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5826), 1,
      sym__automatic_semicolon,
    ACTIONS(1153), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2085), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [94625] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5828), 1,
      anon_sym_export,
    ACTIONS(5830), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [94644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2810), 1,
      sym__call_signature,
    STATE(2830), 1,
      sym_type_parameters,
  [94663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4075), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4077), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3727), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3723), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3746), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2333), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [94739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_formal_parameters,
    STATE(2830), 1,
      sym_type_parameters,
    STATE(2963), 1,
      sym__call_signature,
  [94758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4071), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [94771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5832), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5834), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(2630), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [94808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(2622), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [94823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1798), 1,
      sym_statement_block,
    ACTIONS(5455), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2600), 1,
      sym__initializer,
    ACTIONS(5836), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94864] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2513), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [94883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5838), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5407), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2104), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [94924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(2648), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_LBRACK,
  [94939] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2310), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [94958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5840), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [94969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1808), 1,
      sym_statement_block,
    ACTIONS(5461), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5391), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [94995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5830), 1,
      anon_sym_class,
    ACTIONS(5842), 1,
      anon_sym_export,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [95014] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2579), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [95033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2578), 1,
      sym__initializer,
    ACTIONS(5844), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2034), 1,
      sym_formal_parameters,
    STATE(2366), 1,
      sym__call_signature,
    STATE(2892), 1,
      sym_type_parameters,
  [95067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 1,
      anon_sym_LBRACE,
    STATE(1806), 1,
      sym_statement_block,
    ACTIONS(5371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5846), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [95101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5848), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(5598), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_GT,
  [95116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5853), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5393), 1,
      anon_sym_EQ,
    ACTIONS(5855), 1,
      anon_sym_COMMA,
    ACTIONS(5857), 1,
      anon_sym_RBRACE,
    STATE(2591), 1,
      aux_sym_enum_body_repeat1,
    STATE(2865), 1,
      sym__initializer,
  [95159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2572), 1,
      sym__initializer,
    ACTIONS(5859), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    ACTIONS(5863), 1,
      anon_sym_SLASH,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [95204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4182), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3731), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_EQ,
    STATE(2576), 1,
      sym__initializer,
    ACTIONS(5867), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5869), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1109), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95287] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(5871), 1,
      anon_sym_RBRACK,
    STATE(2703), 1,
      aux_sym_implements_clause_repeat1,
  [95306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(5873), 1,
      anon_sym_LBRACE,
    STATE(2652), 1,
      aux_sym_implements_clause_repeat1,
  [95336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3719), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5875), 1,
      anon_sym_COMMA,
    ACTIONS(5877), 1,
      anon_sym_GT,
    STATE(2695), 1,
      aux_sym_implements_clause_repeat1,
  [95366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2722), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5881), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3715), 5,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [95401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [95412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4095), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4097), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1163), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [95438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2524), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5885), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5782), 1,
      anon_sym_AMP,
    ACTIONS(5784), 1,
      anon_sym_PIPE,
    ACTIONS(2658), 2,
      anon_sym_else,
      anon_sym_while,
  [95466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5889), 1,
      anon_sym_PIPE,
    ACTIONS(5887), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95480] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5891), 1,
      anon_sym_SQUOTE,
    ACTIONS(5893), 1,
      aux_sym_string_token2,
    ACTIONS(5895), 1,
      sym_escape_sequence,
    STATE(2474), 1,
      aux_sym_string_repeat2,
  [95496] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5897), 1,
      anon_sym_DQUOTE,
    ACTIONS(5899), 1,
      aux_sym_string_token1,
    ACTIONS(5901), 1,
      sym_escape_sequence,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [95512] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5891), 1,
      anon_sym_DQUOTE,
    ACTIONS(5903), 1,
      aux_sym_string_token1,
    ACTIONS(5905), 1,
      sym_escape_sequence,
    STATE(2473), 1,
      aux_sym_string_repeat1,
  [95528] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5907), 1,
      anon_sym_DQUOTE,
    ACTIONS(5909), 1,
      aux_sym_string_token1,
    ACTIONS(5912), 1,
      sym_escape_sequence,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [95544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5915), 1,
      anon_sym_export,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [95560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    STATE(2507), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3935), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [95574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5692), 1,
      sym_jsx_identifier,
    STATE(1906), 1,
      sym_nested_identifier,
    STATE(2008), 1,
      sym_jsx_namespace_name,
  [95590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5917), 1,
      sym_identifier,
    ACTIONS(5919), 1,
      sym_jsx_identifier,
    STATE(2944), 1,
      sym_nested_identifier,
    STATE(3011), 1,
      sym_jsx_namespace_name,
  [95606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2974), 1,
      sym_type_parameters,
    STATE(3102), 1,
      sym_formal_parameters,
  [95622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2910), 1,
      sym_type_parameters,
    STATE(3047), 1,
      sym_formal_parameters,
  [95638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(5921), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [95654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5923), 1,
      anon_sym_COMMA,
    STATE(2463), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(4339), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [95668] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym_SQUOTE,
    ACTIONS(5928), 1,
      aux_sym_string_token2,
    ACTIONS(5930), 1,
      sym_escape_sequence,
    STATE(2500), 1,
      aux_sym_string_repeat2,
  [95684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    STATE(133), 1,
      sym_statement_block,
    ACTIONS(5932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95698] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5926), 1,
      anon_sym_DQUOTE,
    ACTIONS(5934), 1,
      aux_sym_string_token1,
    ACTIONS(5936), 1,
      sym_escape_sequence,
    STATE(2453), 1,
      aux_sym_string_repeat1,
  [95714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
    ACTIONS(5938), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2517), 1,
      aux_sym_extends_clause_repeat1,
  [95730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5393), 1,
      anon_sym_EQ,
    STATE(2952), 1,
      sym__initializer,
    ACTIONS(5942), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [95744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2543), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5944), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    STATE(2940), 1,
      sym_type_annotation,
    ACTIONS(5946), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [95772] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5948), 1,
      anon_sym_SQUOTE,
    ACTIONS(5950), 1,
      aux_sym_string_token2,
    ACTIONS(5952), 1,
      sym_escape_sequence,
    STATE(2549), 1,
      aux_sym_string_repeat2,
  [95788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2449), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5954), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95802] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5899), 1,
      aux_sym_string_token1,
    ACTIONS(5901), 1,
      sym_escape_sequence,
    ACTIONS(5956), 1,
      anon_sym_DQUOTE,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [95818] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5956), 1,
      anon_sym_SQUOTE,
    ACTIONS(5958), 1,
      aux_sym_string_token2,
    ACTIONS(5960), 1,
      sym_escape_sequence,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [95834] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5948), 1,
      anon_sym_DQUOTE,
    ACTIONS(5962), 1,
      aux_sym_string_token1,
    ACTIONS(5964), 1,
      sym_escape_sequence,
    STATE(2550), 1,
      aux_sym_string_repeat1,
  [95850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2542), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5966), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [95864] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_DQUOTE,
    ACTIONS(5970), 1,
      aux_sym_string_token1,
    ACTIONS(5972), 1,
      sym_escape_sequence,
    STATE(2481), 1,
      aux_sym_string_repeat1,
  [95880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(746), 1,
      anon_sym_BQUOTE,
    ACTIONS(3145), 1,
      anon_sym_LPAREN,
    STATE(1632), 2,
      sym_template_string,
      sym_arguments,
  [95894] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_SQUOTE,
    ACTIONS(5974), 1,
      aux_sym_string_token2,
    ACTIONS(5976), 1,
      sym_escape_sequence,
    STATE(2483), 1,
      aux_sym_string_repeat2,
  [95910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [95920] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5899), 1,
      aux_sym_string_token1,
    ACTIONS(5901), 1,
      sym_escape_sequence,
    ACTIONS(5978), 1,
      anon_sym_DQUOTE,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [95936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    STATE(2891), 1,
      sym_type_annotation,
    ACTIONS(5294), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [95950] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5958), 1,
      aux_sym_string_token2,
    ACTIONS(5960), 1,
      sym_escape_sequence,
    ACTIONS(5978), 1,
      anon_sym_SQUOTE,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [95966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 1,
      anon_sym_while,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    STATE(582), 1,
      sym_statement_block,
  [95982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(5980), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [95996] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_DQUOTE,
    ACTIONS(5984), 1,
      aux_sym_string_token1,
    ACTIONS(5986), 1,
      sym_escape_sequence,
    STATE(2538), 1,
      aux_sym_string_repeat1,
  [96012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2524), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(5988), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96026] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5990), 1,
      anon_sym_DQUOTE,
    ACTIONS(5992), 1,
      aux_sym_string_token1,
    ACTIONS(5994), 1,
      sym_escape_sequence,
    STATE(2492), 1,
      aux_sym_string_repeat1,
  [96042] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5990), 1,
      anon_sym_SQUOTE,
    ACTIONS(5996), 1,
      aux_sym_string_token2,
    ACTIONS(5998), 1,
      sym_escape_sequence,
    STATE(2493), 1,
      aux_sym_string_repeat2,
  [96058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5889), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2379), 1,
      sym_statement_block,
    ACTIONS(6002), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96086] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5899), 1,
      aux_sym_string_token1,
    ACTIONS(5901), 1,
      sym_escape_sequence,
    ACTIONS(6004), 1,
      anon_sym_DQUOTE,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [96102] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5958), 1,
      aux_sym_string_token2,
    ACTIONS(5960), 1,
      sym_escape_sequence,
    ACTIONS(6004), 1,
      anon_sym_SQUOTE,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [96118] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_SQUOTE,
    ACTIONS(6006), 1,
      aux_sym_string_token2,
    ACTIONS(6008), 1,
      sym_escape_sequence,
    STATE(2539), 1,
      aux_sym_string_repeat2,
  [96134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    STATE(2463), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5940), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [96148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_COMMA,
    STATE(2496), 1,
      aux_sym_array_repeat1,
    ACTIONS(4335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [96162] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5958), 1,
      aux_sym_string_token2,
    ACTIONS(5960), 1,
      sym_escape_sequence,
    ACTIONS(6013), 1,
      anon_sym_SQUOTE,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [96178] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5899), 1,
      aux_sym_string_token1,
    ACTIONS(5901), 1,
      sym_escape_sequence,
    ACTIONS(6013), 1,
      anon_sym_DQUOTE,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [96194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6015), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [96210] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5897), 1,
      anon_sym_SQUOTE,
    ACTIONS(5958), 1,
      aux_sym_string_token2,
    ACTIONS(5960), 1,
      sym_escape_sequence,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [96226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_from,
    STATE(2828), 1,
      sym__from_clause,
    ACTIONS(6019), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1402), 1,
      sym_statement_block,
    ACTIONS(6021), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5393), 1,
      anon_sym_EQ,
    STATE(2903), 1,
      sym__initializer,
    ACTIONS(6023), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [96268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3660), 1,
      anon_sym_LBRACE,
    ACTIONS(5221), 1,
      anon_sym_STAR,
    STATE(3034), 2,
      sym_namespace_import,
      sym_named_imports,
  [96282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_from,
    STATE(2885), 1,
      sym__from_clause,
    ACTIONS(6025), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6027), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [96312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    STATE(2463), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6029), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [96326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2889), 1,
      sym_type_parameters,
    STATE(3146), 1,
      sym_formal_parameters,
  [96342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    STATE(2919), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [96356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2958), 1,
      sym_type_parameters,
    STATE(3158), 1,
      sym_formal_parameters,
  [96372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6031), 1,
      sym_identifier,
    ACTIONS(6033), 1,
      sym_jsx_identifier,
    STATE(2760), 1,
      sym_nested_identifier,
    STATE(3209), 1,
      sym_jsx_namespace_name,
  [96388] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6035), 1,
      anon_sym_SQUOTE,
    ACTIONS(6037), 1,
      aux_sym_string_token2,
    ACTIONS(6039), 1,
      sym_escape_sequence,
    STATE(2497), 1,
      aux_sym_string_repeat2,
  [96404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    STATE(138), 1,
      sym_statement_block,
    ACTIONS(6021), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96418] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6035), 1,
      anon_sym_DQUOTE,
    ACTIONS(6041), 1,
      aux_sym_string_token1,
    ACTIONS(6043), 1,
      sym_escape_sequence,
    STATE(2498), 1,
      aux_sym_string_repeat1,
  [96434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
    ACTIONS(3905), 1,
      anon_sym_LBRACE,
    ACTIONS(3935), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2535), 1,
      aux_sym_extends_clause_repeat1,
  [96450] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6045), 1,
      anon_sym_SQUOTE,
    ACTIONS(6047), 1,
      aux_sym_string_token2,
    ACTIONS(6050), 1,
      sym_escape_sequence,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [96466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    ACTIONS(6053), 1,
      anon_sym_COMMA,
    STATE(2517), 1,
      aux_sym_extends_clause_repeat1,
  [96482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2074), 1,
      sym_formal_parameters,
    STATE(2880), 1,
      sym_type_parameters,
  [96498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5889), 1,
      anon_sym_PIPE,
    ACTIONS(6056), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2487), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6058), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2350), 1,
      sym_statement_block,
    ACTIONS(6060), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      sym_statement_block,
    ACTIONS(6021), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2765), 1,
      sym_type_parameters,
    STATE(3136), 1,
      sym_formal_parameters,
  [96570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6062), 1,
      anon_sym_COMMA,
    STATE(2524), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6065), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6067), 1,
      sym_identifier,
    ACTIONS(6069), 1,
      sym_jsx_identifier,
    STATE(2943), 1,
      sym_nested_identifier,
    STATE(3009), 1,
      sym_jsx_namespace_name,
  [96600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6071), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [96616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    STATE(2899), 1,
      sym_type_annotation,
    ACTIONS(5335), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [96630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(6073), 1,
      anon_sym_class,
    STATE(1825), 1,
      aux_sym_export_statement_repeat1,
    STATE(1854), 1,
      sym_decorator,
  [96646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1389), 1,
      sym_statement_block,
    ACTIONS(5932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 1,
      anon_sym_EQ_GT,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [96672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ_GT,
    ACTIONS(3616), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [96684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5048), 1,
      anon_sym_EQ,
    STATE(2960), 1,
      sym_default_type,
    ACTIONS(6077), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [96698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 1,
      sym_identifier,
    ACTIONS(6081), 1,
      sym_jsx_identifier,
    STATE(2900), 1,
      sym_nested_identifier,
    STATE(3073), 1,
      sym_jsx_namespace_name,
  [96714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6083), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [96724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
    ACTIONS(6029), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6085), 1,
      anon_sym_LBRACE,
    STATE(2517), 1,
      aux_sym_extends_clause_repeat1,
  [96740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5393), 1,
      anon_sym_EQ,
    STATE(2865), 1,
      sym__initializer,
    ACTIONS(6087), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [96754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2898), 1,
      sym_type_parameters,
    STATE(3037), 1,
      sym_formal_parameters,
  [96770] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5899), 1,
      aux_sym_string_token1,
    ACTIONS(5901), 1,
      sym_escape_sequence,
    ACTIONS(6089), 1,
      anon_sym_DQUOTE,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [96786] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5958), 1,
      aux_sym_string_token2,
    ACTIONS(5960), 1,
      sym_escape_sequence,
    ACTIONS(6089), 1,
      anon_sym_SQUOTE,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [96802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2861), 1,
      sym_type_parameters,
    STATE(3181), 1,
      sym_formal_parameters,
  [96818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(3065), 1,
      anon_sym_LPAREN,
    STATE(1440), 2,
      sym_template_string,
      sym_arguments,
  [96832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2524), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6091), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 1,
      anon_sym_COMMA,
    STATE(2524), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6093), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(508), 1,
      sym_statement_block,
    ACTIONS(5932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 1,
      sym_identifier,
    ACTIONS(6097), 1,
      sym_jsx_identifier,
    STATE(2770), 1,
      sym_nested_identifier,
    STATE(3208), 1,
      sym_jsx_namespace_name,
  [96890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5177), 1,
      anon_sym_AMP,
    ACTIONS(5889), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [96904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      sym_identifier,
    STATE(2935), 1,
      sym__import_export_specifier,
    ACTIONS(5504), 2,
      anon_sym_type,
      anon_sym_typeof,
  [96918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_BQUOTE,
    ACTIONS(3063), 1,
      anon_sym_LPAREN,
    STATE(1040), 2,
      sym_template_string,
      sym_arguments,
  [96932] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5958), 1,
      aux_sym_string_token2,
    ACTIONS(5960), 1,
      sym_escape_sequence,
    ACTIONS(6101), 1,
      anon_sym_SQUOTE,
    STATE(2516), 1,
      aux_sym_string_repeat2,
  [96948] = 5,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5899), 1,
      aux_sym_string_token1,
    ACTIONS(5901), 1,
      sym_escape_sequence,
    ACTIONS(6101), 1,
      anon_sym_DQUOTE,
    STATE(2455), 1,
      aux_sym_string_repeat1,
  [96964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [96973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6105), 1,
      anon_sym_LPAREN,
    ACTIONS(6107), 1,
      anon_sym_await,
    STATE(36), 1,
      sym__for_header,
  [96986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 1,
      anon_sym_RBRACE,
    ACTIONS(6109), 1,
      anon_sym_COMMA,
    STATE(2553), 1,
      aux_sym_enum_body_repeat1,
  [96999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6112), 1,
      anon_sym_GT,
  [97012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6114), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 1,
      anon_sym_LPAREN,
    ACTIONS(6118), 1,
      anon_sym_await,
    STATE(33), 1,
      sym__for_header,
  [97034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6120), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6122), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6124), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6126), 1,
      sym_identifier,
    ACTIONS(6128), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6132), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6134), 1,
      anon_sym_COMMA,
    ACTIONS(6136), 1,
      anon_sym_GT,
    STATE(2670), 1,
      aux_sym_type_parameters_repeat1,
  [97103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(6138), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [97116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6140), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6142), 1,
      anon_sym_RBRACK,
  [97138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6144), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6146), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6148), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6136), 1,
      anon_sym_GT,
    ACTIONS(6150), 1,
      sym_identifier,
    STATE(2961), 1,
      sym_type_parameter,
  [97178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      sym_identifier,
    ACTIONS(6154), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [97189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_GT,
    ACTIONS(6158), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [97211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6160), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6162), 1,
      anon_sym_LPAREN,
    ACTIONS(6164), 1,
      anon_sym_await,
    STATE(51), 1,
      sym__for_header,
  [97237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6168), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6170), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6172), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6174), 1,
      anon_sym_RPAREN,
  [97286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6176), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6178), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6180), 1,
      anon_sym_RBRACK,
  [97317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5433), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [97326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6182), 1,
      anon_sym_RBRACE,
    STATE(2603), 1,
      aux_sym_object_repeat1,
  [97339] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6184), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [97348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6182), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [97361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [97370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6188), 1,
      anon_sym_EQ_GT,
    STATE(2891), 1,
      sym_type_annotation,
  [97383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(6191), 1,
      anon_sym_EQ,
    STATE(3116), 1,
      sym_type_parameters,
  [97396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5001), 1,
      anon_sym_RBRACE,
    ACTIONS(6193), 1,
      anon_sym_COMMA,
    STATE(2553), 1,
      aux_sym_enum_body_repeat1,
  [97409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [97418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4323), 1,
      anon_sym_RBRACK,
    STATE(2605), 1,
      aux_sym_array_repeat1,
  [97431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4323), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6195), 1,
      anon_sym_RBRACK,
  [97457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4327), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4327), 1,
      anon_sym_RPAREN,
    STATE(2574), 1,
      aux_sym_array_repeat1,
  [97483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6197), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [97494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(6199), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [97507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6201), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6205), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [97538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6207), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [97551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6209), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6211), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6213), 1,
      anon_sym_RBRACE,
    STATE(2754), 1,
      aux_sym_object_repeat1,
  [97586] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6215), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [97595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6217), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6219), 1,
      anon_sym_LBRACE,
    ACTIONS(5816), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [97619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6213), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [97632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6221), 1,
      sym_identifier,
    STATE(1160), 1,
      sym_nested_type_identifier,
    STATE(3053), 1,
      sym_nested_identifier,
  [97645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_LT,
    ACTIONS(6223), 1,
      anon_sym_EQ,
    STATE(3176), 1,
      sym_type_parameters,
  [97658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6225), 1,
      sym_identifier,
    STATE(1932), 1,
      sym_nested_type_identifier,
    STATE(2982), 1,
      sym_nested_identifier,
  [97671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4331), 1,
      anon_sym_RPAREN,
    STATE(2629), 1,
      aux_sym_array_repeat1,
  [97684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4331), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [97706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4335), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [97715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6227), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_DQUOTE,
    ACTIONS(2424), 1,
      anon_sym_SQUOTE,
    STATE(3133), 1,
      sym_string,
  [97737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6229), 1,
      anon_sym_COMMA,
    ACTIONS(6232), 1,
      anon_sym_RBRACE,
    STATE(2620), 1,
      aux_sym_named_imports_repeat1,
  [97750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6234), 1,
      anon_sym_RPAREN,
  [97763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym_LBRACE,
    ACTIONS(4339), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [97774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 1,
      anon_sym_while,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
  [97787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6236), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6238), 1,
      anon_sym_EQ,
    ACTIONS(6240), 1,
      anon_sym_COMMA,
    ACTIONS(6242), 1,
      anon_sym_from,
  [97813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6244), 1,
      anon_sym_COMMA,
    ACTIONS(6247), 1,
      anon_sym_RBRACE,
    STATE(2626), 1,
      aux_sym_export_clause_repeat1,
  [97826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [97835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym_LBRACE,
    ACTIONS(5726), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [97846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6251), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [97859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    ACTIONS(6253), 1,
      anon_sym_LPAREN,
    STATE(511), 1,
      sym_statement_block,
  [97872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_GT,
    ACTIONS(6255), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [97885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6257), 1,
      anon_sym_COMMA,
    ACTIONS(6259), 1,
      anon_sym_RPAREN,
    STATE(2660), 1,
      aux_sym_formal_parameters_repeat1,
  [97898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6261), 1,
      anon_sym_GT,
  [97911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6263), 1,
      anon_sym_GT,
  [97924] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5672), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [97933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6265), 1,
      anon_sym_EQ_GT,
    STATE(2891), 1,
      sym_type_annotation,
  [97946] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(4095), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [97955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6268), 1,
      anon_sym_EQ_GT,
    STATE(2899), 1,
      sym_type_annotation,
  [97968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6271), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [97981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(6273), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [97994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5855), 1,
      anon_sym_COMMA,
    ACTIONS(5857), 1,
      anon_sym_RBRACE,
    STATE(2591), 1,
      aux_sym_enum_body_repeat1,
  [98007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6275), 1,
      anon_sym_RBRACK,
  [98020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4831), 1,
      anon_sym_RPAREN,
    ACTIONS(6277), 1,
      anon_sym_COMMA,
    STATE(2677), 1,
      aux_sym_formal_parameters_repeat1,
  [98033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(553), 1,
      sym_object_type,
  [98046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6279), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4416), 1,
      anon_sym_RBRACK,
    STATE(2608), 1,
      aux_sym_array_repeat1,
  [98072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4416), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [98085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3368), 1,
      anon_sym_GT,
    ACTIONS(6281), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [98098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6283), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [98111] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(4069), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98120] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(4075), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(6285), 1,
      anon_sym_LBRACE,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [98142] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(4153), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6287), 1,
      anon_sym_RPAREN,
  [98164] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(4169), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6289), 1,
      anon_sym_RBRACE,
    STATE(2672), 1,
      aux_sym_object_repeat1,
  [98186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4384), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [98199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6289), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4384), 1,
      anon_sym_RBRACK,
    STATE(2624), 1,
      aux_sym_array_repeat1,
  [98225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4831), 1,
      anon_sym_RPAREN,
    ACTIONS(6277), 1,
      anon_sym_COMMA,
    STATE(2679), 1,
      aux_sym_formal_parameters_repeat1,
  [98238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 1,
      anon_sym_COMMA,
    ACTIONS(6293), 1,
      anon_sym_GT,
    STATE(2563), 1,
      aux_sym_type_parameters_repeat1,
  [98251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [98260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4386), 1,
      anon_sym_RBRACK,
    STATE(2674), 1,
      aux_sym_array_repeat1,
  [98282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4386), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [98295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6297), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6297), 1,
      anon_sym_RBRACE,
    STATE(2639), 1,
      aux_sym_object_repeat1,
  [98330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5175), 1,
      anon_sym_DOT,
    ACTIONS(6299), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [98341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      anon_sym_COMMA,
    ACTIONS(6304), 1,
      anon_sym_GT,
    STATE(2670), 1,
      aux_sym_type_parameters_repeat1,
  [98354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6306), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6308), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 1,
      sym_identifier,
    ACTIONS(6310), 1,
      anon_sym_GT,
    STATE(2961), 1,
      sym_type_parameter,
  [98393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6312), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [98406] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6314), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98415] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6316), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 1,
      anon_sym_RPAREN,
    ACTIONS(6318), 1,
      anon_sym_COMMA,
    STATE(2679), 1,
      aux_sym_formal_parameters_repeat1,
  [98437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5235), 1,
      anon_sym_implements,
    ACTIONS(6320), 1,
      anon_sym_LBRACE,
    STATE(3064), 1,
      sym_implements_clause,
  [98450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 1,
      anon_sym_COMMA,
    ACTIONS(6325), 1,
      anon_sym_RPAREN,
    STATE(2679), 1,
      aux_sym_formal_parameters_repeat1,
  [98463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 1,
      sym_identifier,
    STATE(1653), 1,
      sym_nested_type_identifier,
    STATE(3076), 1,
      sym_nested_identifier,
  [98476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [98485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6331), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6333), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6335), 1,
      anon_sym_RPAREN,
  [98534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 1,
      anon_sym_LBRACE,
    ACTIONS(2430), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [98545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5686), 1,
      anon_sym_RBRACE,
    ACTIONS(6337), 1,
      anon_sym_COMMA,
    STATE(2620), 1,
      aux_sym_named_imports_repeat1,
  [98558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_LBRACE,
    ACTIONS(2398), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [98569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_LBRACE,
    ACTIONS(2545), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [98580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_LBRACE,
    ACTIONS(2541), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [98591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_LBRACE,
    ACTIONS(2559), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [98602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5814), 1,
      anon_sym_RBRACE,
    ACTIONS(6339), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_export_clause_repeat1,
  [98615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6341), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [98624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_GT,
    ACTIONS(6343), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [98637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6345), 1,
      anon_sym_as,
    ACTIONS(6347), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [98648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [98661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6351), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [98670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_DQUOTE,
    ACTIONS(3091), 1,
      anon_sym_SQUOTE,
    STATE(2896), 1,
      sym_string,
  [98683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6353), 1,
      anon_sym_EQ_GT,
    STATE(2891), 1,
      sym_type_annotation,
  [98696] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(5851), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [98705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6356), 1,
      anon_sym_EQ_GT,
    STATE(2899), 1,
      sym_type_annotation,
  [98718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(6359), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [98731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6361), 1,
      anon_sym_RBRACE,
    STATE(2720), 1,
      aux_sym_object_repeat1,
  [98744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6363), 1,
      anon_sym_RBRACK,
  [98757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6361), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6365), 1,
      anon_sym_COMMA,
    ACTIONS(6367), 1,
      anon_sym_RPAREN,
    STATE(2722), 1,
      aux_sym_formal_parameters_repeat1,
  [98783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(592), 1,
      sym_object_type,
  [98796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4482), 1,
      anon_sym_RBRACK,
    STATE(2724), 1,
      aux_sym_array_repeat1,
  [98809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4482), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [98822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6369), 1,
      anon_sym_EQ_GT,
    STATE(2891), 1,
      sym_type_annotation,
  [98835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      anon_sym_COMMA,
    ACTIONS(6374), 1,
      anon_sym_GT,
    STATE(2725), 1,
      aux_sym_type_parameters_repeat1,
  [98848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4995), 1,
      anon_sym_RBRACE,
    ACTIONS(6376), 1,
      anon_sym_COMMA,
    STATE(2553), 1,
      aux_sym_enum_body_repeat1,
  [98861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6378), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [98870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_as,
    ACTIONS(6382), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [98881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 1,
      anon_sym_COMMA,
    ACTIONS(6386), 1,
      anon_sym_RBRACE,
    STATE(2693), 1,
      aux_sym_export_clause_repeat1,
  [98894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6388), 1,
      anon_sym_RBRACK,
  [98907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6390), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6392), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6394), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [98946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_COMMA,
    ACTIONS(6396), 1,
      anon_sym_RBRACK,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [98959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 1,
      anon_sym_RPAREN,
    ACTIONS(6398), 1,
      anon_sym_COMMA,
    STATE(2679), 1,
      aux_sym_formal_parameters_repeat1,
  [98972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 1,
      anon_sym_RPAREN,
    ACTIONS(6398), 1,
      anon_sym_COMMA,
    STATE(2735), 1,
      aux_sym_formal_parameters_repeat1,
  [98985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6400), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [98998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 1,
      anon_sym_COMMA,
    ACTIONS(6404), 1,
      anon_sym_GT,
    STATE(2670), 1,
      aux_sym_type_parameters_repeat1,
  [99011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4451), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [99024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4451), 1,
      anon_sym_RPAREN,
    STATE(2649), 1,
      aux_sym_array_repeat1,
  [99037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_GT,
    ACTIONS(6406), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [99050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      sym_identifier,
    STATE(1521), 1,
      sym_nested_type_identifier,
    STATE(3143), 1,
      sym_nested_identifier,
  [99063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6410), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4447), 1,
      anon_sym_RPAREN,
    STATE(2741), 1,
      aux_sym_array_repeat1,
  [99085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(4447), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [99098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6412), 1,
      anon_sym_EQ_GT,
    STATE(2899), 1,
      sym_type_annotation,
  [99111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    STATE(2378), 1,
      sym_object_type,
  [99124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 1,
      anon_sym_RPAREN,
    ACTIONS(6415), 1,
      anon_sym_COMMA,
    STATE(2679), 1,
      aux_sym_formal_parameters_repeat1,
  [99137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5175), 1,
      anon_sym_DOT,
    ACTIONS(6417), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5770), 1,
      anon_sym_COMMA,
    ACTIONS(5772), 1,
      anon_sym_RBRACE,
    STATE(2713), 1,
      aux_sym_enum_body_repeat1,
  [99161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 1,
      sym_identifier,
    ACTIONS(6421), 1,
      anon_sym_require,
    STATE(2669), 1,
      sym_nested_identifier,
  [99174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3410), 1,
      anon_sym_GT,
    ACTIONS(6425), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [99196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(6427), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      aux_sym_array_repeat1,
  [99209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3398), 1,
      anon_sym_GT,
    ACTIONS(6429), 1,
      anon_sym_COMMA,
    STATE(2424), 1,
      aux_sym_implements_clause_repeat1,
  [99222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6240), 1,
      anon_sym_COMMA,
    ACTIONS(6242), 1,
      anon_sym_from,
    ACTIONS(6431), 1,
      anon_sym_EQ,
  [99235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6433), 1,
      anon_sym_COMMA,
    ACTIONS(6435), 1,
      anon_sym_RBRACE,
    STATE(2688), 1,
      aux_sym_named_imports_repeat1,
  [99248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6437), 1,
      sym_identifier,
    STATE(438), 1,
      sym_nested_type_identifier,
    STATE(3014), 1,
      sym_nested_identifier,
  [99261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(6439), 1,
      anon_sym_EQ_GT,
    STATE(2899), 1,
      sym_type_annotation,
  [99274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5171), 1,
      anon_sym_AMP,
    ACTIONS(5173), 1,
      anon_sym_PIPE,
    ACTIONS(6442), 1,
      anon_sym_RPAREN,
  [99287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    STATE(2364), 1,
      sym_object_type,
  [99300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 1,
      sym_identifier,
    ACTIONS(6444), 1,
      anon_sym_GT,
    STATE(2961), 1,
      sym_type_parameter,
  [99313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6448), 1,
      anon_sym_GT,
  [99335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6450), 1,
      anon_sym_COMMA,
    ACTIONS(6453), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [99348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 1,
      sym_identifier,
    ACTIONS(6404), 1,
      anon_sym_GT,
    STATE(2961), 1,
      sym_type_parameter,
  [99361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(117), 1,
      anon_sym_COMMA,
    ACTIONS(6455), 1,
      anon_sym_RBRACE,
    STATE(2752), 1,
      aux_sym_object_repeat1,
  [99374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1388), 1,
      sym_statement_block,
  [99384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1503), 1,
      sym_statement_block,
  [99394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1090), 1,
      sym_class_body,
  [99404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2254), 1,
      sym_class_body,
  [99414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2261), 1,
      sym_class_body,
  [99424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(6112), 1,
      anon_sym_GT,
  [99434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1089), 1,
      sym_class_body,
  [99444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_parenthesized_expression,
  [99454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1398), 1,
      sym_class_body,
  [99464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [99474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3142), 1,
      sym_formal_parameters,
  [99484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3137), 1,
      sym_formal_parameters,
  [99494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4979), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [99502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2809), 1,
      sym_statement_block,
  [99512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(2937), 1,
      sym_parenthesized_expression,
  [99522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(6448), 1,
      anon_sym_GT,
  [99532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6448), 1,
      anon_sym_GT,
  [99542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [99552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym_parenthesized_expression,
  [99562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym_parenthesized_expression,
  [99572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1692), 1,
      sym_class_body,
  [99582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_from,
    STATE(2927), 1,
      sym__from_clause,
  [99600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [99608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2818), 1,
      sym_statement_block,
  [99618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_from,
    STATE(2828), 1,
      sym__from_clause,
  [99636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2335), 1,
      sym_type_annotation,
  [99646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2203), 1,
      sym_type_annotation,
  [99656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(50), 1,
      sym_parenthesized_expression,
  [99666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(464), 1,
      sym_statement_block,
  [99676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2439), 1,
      sym_class_body,
  [99686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1400), 1,
      sym_statement_block,
  [99696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1085), 1,
      sym_statement_block,
  [99706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1693), 1,
      sym_class_body,
  [99716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1696), 1,
      sym_statement_block,
  [99726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parenthesized_expression,
  [99736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1702), 1,
      sym_statement_block,
  [99746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym__for_header,
  [99756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1706), 1,
      sym_class_body,
  [99766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1708), 1,
      sym_statement_block,
  [99776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1409), 1,
      sym_class_body,
  [99786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1715), 1,
      sym_class_body,
  [99796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6077), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [99804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1080), 1,
      sym_statement_block,
  [99814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 1,
      anon_sym_while,
    ACTIONS(6467), 1,
      anon_sym_else,
  [99824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1076), 1,
      sym_class_body,
  [99834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2343), 1,
      sym_class_body,
  [99844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1073), 1,
      sym_class_body,
  [99862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2916), 1,
      sym_statement_block,
  [99872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 1,
      anon_sym_LPAREN,
    STATE(46), 1,
      sym__for_header,
  [99882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6471), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [99890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1683), 1,
      sym_statement_block,
  [99900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4935), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [99908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1092), 1,
      sym_statement_block,
  [99918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1020), 1,
      sym_statement_block,
  [99928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1057), 1,
      sym_statement_block,
  [99938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1055), 1,
      sym_class_body,
  [99948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2820), 1,
      sym_statement_block,
  [99958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [99966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(49), 1,
      sym_parenthesized_expression,
  [99976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parenthesized_expression,
  [99986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [99994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2822), 1,
      sym_statement_block,
  [100004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2829), 1,
      sym_statement_block,
  [100022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1093), 1,
      sym_class_body,
  [100040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      sym_identifier,
    STATE(1513), 1,
      sym_nested_identifier,
  [100050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1345), 1,
      sym_class_body,
  [100060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4420), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 1,
      anon_sym_while,
    ACTIONS(6475), 1,
      anon_sym_else,
  [100078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3556), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4975), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2482), 1,
      sym_formal_parameters,
  [100104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1666), 1,
      sym_statement_block,
  [100122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(505), 1,
      sym_statement_block,
  [100132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_statement_block,
  [100142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(522), 1,
      sym_statement_block,
  [100152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3188), 1,
      sym_formal_parameters,
  [100162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(2286), 1,
      sym_enum_body,
  [100172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3374), 1,
      sym_jsx_identifier,
    ACTIONS(6479), 1,
      sym_identifier,
  [100182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_from,
    STATE(2885), 1,
      sym__from_clause,
  [100192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1554), 1,
      sym_class_body,
  [100202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2925), 1,
      sym_statement_block,
  [100212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1558), 1,
      sym_statement_block,
  [100222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2778), 1,
      sym_statement_block,
  [100232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4927), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2767), 1,
      sym_statement_block,
  [100250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2700), 1,
      sym_formal_parameters,
  [100260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 1,
      sym_identifier,
    STATE(476), 1,
      sym_nested_identifier,
  [100270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LBRACE,
    STATE(2357), 1,
      sym_enum_body,
  [100280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4923), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      sym_identifier,
    STATE(2736), 1,
      sym_nested_identifier,
  [100298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2213), 1,
      sym_statement_block,
  [100308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_class_body,
  [100318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 1,
      sym_identifier,
    ACTIONS(6487), 1,
      anon_sym_STAR,
  [100328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1032), 1,
      sym_statement_block,
  [100338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(502), 1,
      sym_statement_block,
  [100348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1651), 1,
      sym_class_body,
  [100358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1025), 1,
      sym_class_body,
  [100376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(125), 1,
      sym_class_body,
  [100386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6491), 1,
      sym_identifier,
    ACTIONS(6493), 1,
      anon_sym_STAR,
  [100396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3126), 1,
      sym_formal_parameters,
  [100406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 1,
      sym_identifier,
    STATE(2712), 1,
      sym_type_parameter,
  [100416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 1,
      sym_identifier,
    ACTIONS(6497), 1,
      anon_sym_STAR,
  [100426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1644), 1,
      sym_class_body,
  [100436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_class_body,
  [100454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      sym_statement_block,
  [100464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2214), 1,
      sym_class_body,
  [100474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2711), 1,
      sym_formal_parameters,
  [100484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 1,
      sym_identifier,
    ACTIONS(6503), 1,
      anon_sym_STAR,
  [100494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2380), 1,
      sym_statement_block,
  [100504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_enum_body,
  [100514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1578), 1,
      sym_statement_block,
  [100524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1594), 1,
      sym_statement_block,
  [100534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1381), 1,
      sym_class_body,
  [100544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1637), 1,
      sym_class_body,
  [100554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6112), 1,
      anon_sym_GT,
  [100564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(2218), 1,
      sym_class_body,
  [100574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1100), 1,
      sym_statement_block,
  [100584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2107), 1,
      sym_formal_parameters,
  [100594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(2390), 1,
      sym_statement_block,
  [100604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_COLON,
    STATE(2287), 1,
      sym_type_annotation,
  [100614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3803), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_LBRACE,
    STATE(1101), 1,
      sym_class_body,
  [100632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3560), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 1,
      sym_identifier,
    STATE(2961), 1,
      sym_type_parameter,
  [100650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2636), 1,
      sym_formal_parameters,
  [100660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1439), 1,
      sym_statement_block,
  [100670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3154), 1,
      sym_formal_parameters,
  [100680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3171), 1,
      sym_formal_parameters,
  [100690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5590), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [100698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 1,
      anon_sym_LPAREN,
    STATE(2018), 1,
      sym_formal_parameters,
  [100708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1436), 1,
      sym_statement_block,
  [100718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6507), 1,
      sym_identifier,
    STATE(1152), 1,
      sym_nested_identifier,
  [100728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1492), 1,
      sym_class_body,
  [100738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [100754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3079), 1,
      sym_formal_parameters,
  [100764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [100772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [100782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3059), 1,
      sym_formal_parameters,
  [100792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [100802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6515), 1,
      sym_identifier,
    STATE(2669), 1,
      sym_nested_identifier,
  [100820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6150), 1,
      sym_identifier,
    STATE(2661), 1,
      sym_type_parameter,
  [100830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(501), 1,
      sym_class_body,
  [100840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [100848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 1,
      anon_sym_LBRACE,
    STATE(546), 1,
      sym_enum_body,
  [100858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1469), 1,
      sym_statement_block,
  [100868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3000), 1,
      sym_formal_parameters,
  [100878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(541), 1,
      sym_statement_block,
  [100888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2991), 1,
      sym_formal_parameters,
  [100898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3024), 1,
      sym_formal_parameters,
  [100908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6519), 1,
      sym_identifier,
    STATE(1917), 1,
      sym_nested_identifier,
  [100918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2923), 1,
      sym_statement_block,
  [100928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1548), 1,
      sym_class_body,
  [100946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1555), 1,
      sym_statement_block,
  [100956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [100964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1470), 1,
      sym_class_body,
  [100974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1468), 1,
      sym_statement_block,
  [100984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1465), 1,
      sym_class_body,
  [100994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4957), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2844), 1,
      sym_statement_block,
  [101012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(2849), 1,
      sym_statement_block,
  [101030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LBRACE,
    STATE(539), 1,
      sym_statement_block,
  [101048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(515), 1,
      sym_class_body,
  [101058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_from,
    STATE(2776), 1,
      sym__from_clause,
  [101068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_LBRACE,
    STATE(1535), 1,
      sym_statement_block,
  [101078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      sym_statement_block,
  [101096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5247), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      sym_class_body,
  [101106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [101122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 1,
      anon_sym_LBRACE,
    STATE(584), 1,
      sym_switch_body,
  [101132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym__for_header,
  [101142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1457), 1,
      sym_class_body,
  [101152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6261), 1,
      anon_sym_GT,
  [101170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(6261), 1,
      anon_sym_GT,
  [101188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5065), 1,
      anon_sym_DOT,
    ACTIONS(6263), 1,
      anon_sym_GT,
  [101198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_COLON,
    ACTIONS(6263), 1,
      anon_sym_GT,
  [101208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(2589), 1,
      sym_formal_parameters,
  [101242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 1,
      anon_sym_LPAREN,
    STATE(2955), 1,
      sym_parenthesized_expression,
  [101252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1549), 1,
      sym_class_body,
  [101262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6545), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 1,
      sym_identifier,
    STATE(1659), 1,
      sym_nested_identifier,
  [101288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4440), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5261), 1,
      anon_sym_LBRACE,
    STATE(562), 1,
      sym_class_body,
  [101314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3183), 1,
      sym_formal_parameters,
  [101324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 1,
      sym_identifier,
    STATE(1895), 1,
      sym_nested_identifier,
  [101334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6553), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [101342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6304), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [101350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LBRACE,
    STATE(1592), 1,
      sym_statement_block,
  [101360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 1,
      anon_sym_LBRACE,
    STATE(137), 1,
      sym_statement_block,
  [101370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [101378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3831), 1,
      anon_sym_LBRACE,
    STATE(1091), 1,
      sym_statement_block,
  [101388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3164), 1,
      sym_formal_parameters,
  [101398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(127), 1,
      sym_class_body,
  [101416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(117), 1,
      sym_class_body,
  [101426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [101434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 1,
      anon_sym_LBRACE,
    STATE(136), 1,
      sym_class_body,
  [101444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_LBRACE,
    STATE(1430), 1,
      sym_class_body,
  [101454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5195), 1,
      anon_sym_LBRACE,
    STATE(1596), 1,
      sym_class_body,
  [101464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 1,
      anon_sym_LPAREN,
    STATE(3090), 1,
      sym_formal_parameters,
  [101474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6557), 1,
      anon_sym_EQ_GT,
  [101481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 1,
      sym_identifier,
  [101488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 1,
      anon_sym_RPAREN,
  [101495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_RPAREN,
  [101502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6561), 1,
      anon_sym_SLASH2,
  [101509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      sym_identifier,
  [101516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6565), 1,
      sym_identifier,
  [101523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5116), 1,
      anon_sym_DOT,
  [101530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 1,
      sym_identifier,
  [101537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6569), 1,
      sym_identifier,
  [101544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 1,
      anon_sym_RBRACK,
  [101551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6573), 1,
      anon_sym_RPAREN,
  [101558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 1,
      anon_sym_GT,
  [101565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 1,
      anon_sym_EQ_GT,
  [101572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6579), 1,
      anon_sym_EQ_GT,
  [101579] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6581), 1,
      sym_regex_pattern,
  [101586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6583), 1,
      anon_sym_EQ_GT,
  [101593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6585), 1,
      sym_identifier,
  [101600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6587), 1,
      anon_sym_COLON,
  [101607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6589), 1,
      anon_sym_target,
  [101614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6591), 1,
      sym_identifier,
  [101621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6593), 1,
      sym_identifier,
  [101628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6595), 1,
      anon_sym_GT,
  [101635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      sym_identifier,
  [101642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_COLON,
  [101649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym_EQ_GT,
  [101656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      anon_sym_EQ_GT,
  [101663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6605), 1,
      anon_sym_EQ_GT,
  [101670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6607), 1,
      anon_sym_RPAREN,
  [101677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 1,
      anon_sym_EQ_GT,
  [101684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 1,
      anon_sym_EQ_GT,
  [101691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 1,
      anon_sym_while,
  [101698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      anon_sym_GT,
  [101705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_LBRACE,
  [101712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6261), 1,
      anon_sym_GT,
  [101719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6617), 1,
      sym_number,
  [101726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_GT,
  [101733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6619), 1,
      sym_number,
  [101740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_RPAREN,
  [101747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5073), 1,
      anon_sym_DOT,
  [101754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ_GT,
  [101761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      sym_identifier,
  [101768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      sym_identifier,
  [101775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      sym_identifier,
  [101782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 1,
      anon_sym_COLON,
  [101789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6629), 1,
      anon_sym_RPAREN,
  [101796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 1,
      sym_identifier,
  [101803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_GT,
  [101810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 1,
      anon_sym_EQ_GT,
  [101817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6635), 1,
      anon_sym_EQ_GT,
  [101824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6637), 1,
      anon_sym_EQ_GT,
  [101831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6639), 1,
      anon_sym_EQ_GT,
  [101838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6641), 1,
      sym_identifier,
  [101845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6242), 1,
      anon_sym_from,
  [101852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym_target,
  [101859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6645), 1,
      anon_sym_EQ_GT,
  [101866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6647), 1,
      anon_sym_EQ_GT,
  [101873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      anon_sym_EQ_GT,
  [101880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6651), 1,
      anon_sym_EQ_GT,
  [101887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6653), 1,
      anon_sym_from,
  [101894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 1,
      anon_sym_LPAREN,
  [101901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6657), 1,
      anon_sym_require,
  [101908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6659), 1,
      anon_sym_EQ_GT,
  [101915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6661), 1,
      anon_sym_EQ_GT,
  [101922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 1,
      sym_identifier,
  [101929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6665), 1,
      sym_identifier,
  [101936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6667), 1,
      anon_sym_from,
  [101943] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6669), 1,
      sym_regex_pattern,
  [101950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6671), 1,
      sym_identifier,
  [101957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      anon_sym_from,
  [101964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_from,
  [101971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6677), 1,
      anon_sym_from,
  [101978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6679), 1,
      anon_sym_EQ_GT,
  [101985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6681), 1,
      anon_sym_GT,
  [101992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6683), 1,
      anon_sym_GT,
  [101999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6685), 1,
      anon_sym_as,
  [102006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6687), 1,
      anon_sym_GT,
  [102013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4612), 1,
      anon_sym_COLON,
  [102020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 1,
      anon_sym_DOT,
  [102027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 1,
      sym_identifier,
  [102034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 1,
      sym_identifier,
  [102041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4610), 1,
      anon_sym_RPAREN,
  [102048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4608), 1,
      anon_sym_RPAREN,
  [102055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_RPAREN,
  [102062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6693), 1,
      anon_sym_EQ_GT,
  [102069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 1,
      sym_identifier,
  [102076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 1,
      anon_sym_RPAREN,
  [102083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6697), 1,
      sym_identifier,
  [102090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6699), 1,
      anon_sym_GT,
  [102097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6701), 1,
      anon_sym_LBRACE,
  [102104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 1,
      anon_sym_RPAREN,
  [102111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6705), 1,
      sym_number,
  [102118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 1,
      anon_sym_EQ_GT,
  [102125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6709), 1,
      anon_sym_RPAREN,
  [102132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 1,
      anon_sym_DOT,
  [102139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6713), 1,
      sym_identifier,
  [102146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6715), 1,
      anon_sym_RPAREN,
  [102153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6717), 1,
      anon_sym_GT,
  [102160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_GT,
  [102167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6719), 1,
      sym_number,
  [102174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6721), 1,
      anon_sym_EQ_GT,
  [102181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4536), 1,
      anon_sym_DOT,
  [102188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6723), 1,
      sym_identifier,
  [102195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4520), 1,
      anon_sym_RBRACE,
  [102202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6725), 1,
      anon_sym_EQ_GT,
  [102209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6727), 1,
      anon_sym_EQ_GT,
  [102216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6729), 1,
      sym_identifier,
  [102223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6731), 1,
      anon_sym_GT,
  [102230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6733), 1,
      anon_sym_RPAREN,
  [102237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 1,
      anon_sym_RPAREN,
  [102244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6735), 1,
      sym_identifier,
  [102251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6737), 1,
      sym_identifier,
  [102258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      anon_sym_RBRACK,
  [102265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6741), 1,
      sym_identifier,
  [102272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6743), 1,
      anon_sym_class,
  [102279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6745), 1,
      anon_sym_EQ_GT,
  [102286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
  [102293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 1,
      anon_sym_RPAREN,
  [102300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6747), 1,
      sym_identifier,
  [102307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_SLASH2,
  [102314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6751), 1,
      sym_identifier,
  [102321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      anon_sym_SLASH2,
  [102328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6755), 1,
      anon_sym_RBRACE,
  [102335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6757), 1,
      sym_identifier,
  [102342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6759), 1,
      anon_sym_SLASH2,
  [102349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6761), 1,
      anon_sym_COLON,
  [102356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4603), 1,
      anon_sym_RBRACK,
  [102363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6763), 1,
      anon_sym_EQ_GT,
  [102370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6765), 1,
      anon_sym_EQ,
  [102377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6767), 1,
      sym_identifier,
  [102384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6769), 1,
      anon_sym_EQ_GT,
  [102391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3899), 1,
      anon_sym_RPAREN,
  [102398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6771), 1,
      anon_sym_EQ_GT,
  [102405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6773), 1,
      anon_sym_EQ_GT,
  [102412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6775), 1,
      sym_identifier,
  [102419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6777), 1,
      anon_sym_function,
  [102426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6779), 1,
      anon_sym_EQ_GT,
  [102433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6781), 1,
      anon_sym_EQ_GT,
  [102440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6783), 1,
      anon_sym_EQ_GT,
  [102447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6785), 1,
      anon_sym_EQ,
  [102454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym_target,
  [102461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      anon_sym_EQ,
  [102468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6791), 1,
      sym_identifier,
  [102475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6793), 1,
      sym_identifier,
  [102482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 1,
      sym_identifier,
  [102489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6797), 1,
      sym_identifier,
  [102496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6799), 1,
      sym_identifier,
  [102503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      sym_identifier,
  [102510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6803), 1,
      sym_identifier,
  [102517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6805), 1,
      anon_sym_EQ_GT,
  [102524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6807), 1,
      sym_identifier,
  [102531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_EQ_GT,
  [102538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_namespace,
  [102545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      sym_identifier,
  [102552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6815), 1,
      sym_identifier,
  [102559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6817), 1,
      anon_sym_namespace,
  [102566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6819), 1,
      anon_sym_EQ_GT,
  [102573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6821), 1,
      anon_sym_from,
  [102580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6823), 1,
      anon_sym_RPAREN,
  [102587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 1,
      anon_sym_RPAREN,
  [102594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4527), 1,
      anon_sym_RPAREN,
  [102601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6825), 1,
      anon_sym_EQ_GT,
  [102608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6827), 1,
      anon_sym_EQ_GT,
  [102615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_RPAREN,
  [102622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 1,
      anon_sym_RPAREN,
  [102629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6829), 1,
      anon_sym_GT,
  [102636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4516), 1,
      anon_sym_RBRACK,
  [102643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6831), 1,
      anon_sym_EQ_GT,
  [102650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4432), 1,
      anon_sym_DOT,
  [102657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_RPAREN,
  [102664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6835), 1,
      anon_sym_RBRACK,
  [102671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6837), 1,
      anon_sym_EQ_GT,
  [102678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 1,
      sym_identifier,
  [102685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6841), 1,
      anon_sym_EQ_GT,
  [102692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6843), 1,
      anon_sym_GT,
  [102699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6845), 1,
      anon_sym_GT,
  [102706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 1,
      sym_identifier,
  [102713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6849), 1,
      anon_sym_EQ_GT,
  [102720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6851), 1,
      anon_sym_GT,
  [102727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6853), 1,
      anon_sym_EQ_GT,
  [102734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6855), 1,
      sym_number,
  [102741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6857), 1,
      sym_identifier,
  [102748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6859), 1,
      anon_sym_GT,
  [102755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6861), 1,
      anon_sym_EQ_GT,
  [102762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6863), 1,
      ts_builtin_sym_end,
  [102769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 1,
      sym_identifier,
  [102776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6867), 1,
      sym_identifier,
  [102783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6869), 1,
      anon_sym_class,
  [102790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6871), 1,
      sym_identifier,
  [102797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6873), 1,
      anon_sym_EQ_GT,
  [102804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6875), 1,
      sym_identifier,
  [102811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6877), 1,
      sym_identifier,
  [102818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6879), 1,
      sym_identifier,
  [102825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6881), 1,
      anon_sym_EQ_GT,
  [102832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6883), 1,
      anon_sym_EQ,
  [102839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_EQ,
  [102846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6887), 1,
      anon_sym_EQ_GT,
  [102853] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6889), 1,
      sym_regex_pattern,
  [102860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_RBRACK,
  [102867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6891), 1,
      sym_identifier,
  [102874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 1,
      anon_sym_RBRACE,
  [102881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6893), 1,
      anon_sym_EQ,
  [102888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6895), 1,
      anon_sym_EQ_GT,
  [102895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6897), 1,
      anon_sym_GT,
  [102902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
  [102909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      anon_sym_GT,
  [102916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 1,
      anon_sym_EQ_GT,
  [102923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 1,
      sym_identifier,
  [102930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6905), 1,
      anon_sym_EQ_GT,
  [102937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_GT,
  [102944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6909), 1,
      sym_identifier,
  [102951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4557), 1,
      anon_sym_RBRACE,
  [102958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      sym_identifier,
  [102965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6913), 1,
      anon_sym_EQ_GT,
  [102972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6915), 1,
      sym_identifier,
  [102979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6917), 1,
      anon_sym_COLON,
  [102986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6919), 1,
      sym_identifier,
  [102993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 1,
      sym_identifier,
  [103000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6923), 1,
      anon_sym_RBRACE,
  [103007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6925), 1,
      sym_identifier,
  [103014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6927), 1,
      sym_identifier,
  [103021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 1,
      sym_identifier,
  [103028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 1,
      sym_identifier,
  [103035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6933), 1,
      anon_sym_function,
  [103042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      anon_sym_from,
  [103049] = 2,
    ACTIONS(5233), 1,
      sym_comment,
    ACTIONS(6937), 1,
      sym_regex_pattern,
  [103056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6939), 1,
      sym_identifier,
  [103063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      sym_identifier,
  [103070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6943), 1,
      sym_identifier,
  [103077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 1,
      sym_identifier,
  [103084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6947), 1,
      sym_identifier,
  [103091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      sym_identifier,
  [103098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6951), 1,
      sym_identifier,
  [103105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      anon_sym_GT,
  [103112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 1,
      anon_sym_GT,
  [103119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      sym_identifier,
  [103126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      sym_identifier,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(624)] = 0,
  [SMALL_STATE(625)] = 97,
  [SMALL_STATE(626)] = 194,
  [SMALL_STATE(627)] = 291,
  [SMALL_STATE(628)] = 388,
  [SMALL_STATE(629)] = 479,
  [SMALL_STATE(630)] = 576,
  [SMALL_STATE(631)] = 673,
  [SMALL_STATE(632)] = 763,
  [SMALL_STATE(633)] = 849,
  [SMALL_STATE(634)] = 938,
  [SMALL_STATE(635)] = 1023,
  [SMALL_STATE(636)] = 1152,
  [SMALL_STATE(637)] = 1281,
  [SMALL_STATE(638)] = 1410,
  [SMALL_STATE(639)] = 1539,
  [SMALL_STATE(640)] = 1628,
  [SMALL_STATE(641)] = 1715,
  [SMALL_STATE(642)] = 1804,
  [SMALL_STATE(643)] = 1933,
  [SMALL_STATE(644)] = 2020,
  [SMALL_STATE(645)] = 2109,
  [SMALL_STATE(646)] = 2238,
  [SMALL_STATE(647)] = 2325,
  [SMALL_STATE(648)] = 2412,
  [SMALL_STATE(649)] = 2499,
  [SMALL_STATE(650)] = 2586,
  [SMALL_STATE(651)] = 2715,
  [SMALL_STATE(652)] = 2799,
  [SMALL_STATE(653)] = 2887,
  [SMALL_STATE(654)] = 2971,
  [SMALL_STATE(655)] = 3057,
  [SMALL_STATE(656)] = 3145,
  [SMALL_STATE(657)] = 3231,
  [SMALL_STATE(658)] = 3315,
  [SMALL_STATE(659)] = 3400,
  [SMALL_STATE(660)] = 3483,
  [SMALL_STATE(661)] = 3599,
  [SMALL_STATE(662)] = 3681,
  [SMALL_STATE(663)] = 3743,
  [SMALL_STATE(664)] = 3829,
  [SMALL_STATE(665)] = 3945,
  [SMALL_STATE(666)] = 4007,
  [SMALL_STATE(667)] = 4125,
  [SMALL_STATE(668)] = 4187,
  [SMALL_STATE(669)] = 4273,
  [SMALL_STATE(670)] = 4391,
  [SMALL_STATE(671)] = 4461,
  [SMALL_STATE(672)] = 4543,
  [SMALL_STATE(673)] = 4625,
  [SMALL_STATE(674)] = 4707,
  [SMALL_STATE(675)] = 4769,
  [SMALL_STATE(676)] = 4831,
  [SMALL_STATE(677)] = 4911,
  [SMALL_STATE(678)] = 4993,
  [SMALL_STATE(679)] = 5109,
  [SMALL_STATE(680)] = 5222,
  [SMALL_STATE(681)] = 5335,
  [SMALL_STATE(682)] = 5414,
  [SMALL_STATE(683)] = 5527,
  [SMALL_STATE(684)] = 5640,
  [SMALL_STATE(685)] = 5753,
  [SMALL_STATE(686)] = 5866,
  [SMALL_STATE(687)] = 5945,
  [SMALL_STATE(688)] = 6058,
  [SMALL_STATE(689)] = 6171,
  [SMALL_STATE(690)] = 6284,
  [SMALL_STATE(691)] = 6397,
  [SMALL_STATE(692)] = 6470,
  [SMALL_STATE(693)] = 6549,
  [SMALL_STATE(694)] = 6662,
  [SMALL_STATE(695)] = 6727,
  [SMALL_STATE(696)] = 6840,
  [SMALL_STATE(697)] = 6919,
  [SMALL_STATE(698)] = 6998,
  [SMALL_STATE(699)] = 7077,
  [SMALL_STATE(700)] = 7190,
  [SMALL_STATE(701)] = 7303,
  [SMALL_STATE(702)] = 7416,
  [SMALL_STATE(703)] = 7483,
  [SMALL_STATE(704)] = 7556,
  [SMALL_STATE(705)] = 7669,
  [SMALL_STATE(706)] = 7782,
  [SMALL_STATE(707)] = 7861,
  [SMALL_STATE(708)] = 7974,
  [SMALL_STATE(709)] = 8087,
  [SMALL_STATE(710)] = 8200,
  [SMALL_STATE(711)] = 8265,
  [SMALL_STATE(712)] = 8346,
  [SMALL_STATE(713)] = 8456,
  [SMALL_STATE(714)] = 8566,
  [SMALL_STATE(715)] = 8676,
  [SMALL_STATE(716)] = 8786,
  [SMALL_STATE(717)] = 8896,
  [SMALL_STATE(718)] = 9006,
  [SMALL_STATE(719)] = 9116,
  [SMALL_STATE(720)] = 9226,
  [SMALL_STATE(721)] = 9306,
  [SMALL_STATE(722)] = 9416,
  [SMALL_STATE(723)] = 9526,
  [SMALL_STATE(724)] = 9598,
  [SMALL_STATE(725)] = 9708,
  [SMALL_STATE(726)] = 9818,
  [SMALL_STATE(727)] = 9928,
  [SMALL_STATE(728)] = 10038,
  [SMALL_STATE(729)] = 10148,
  [SMALL_STATE(730)] = 10220,
  [SMALL_STATE(731)] = 10330,
  [SMALL_STATE(732)] = 10440,
  [SMALL_STATE(733)] = 10550,
  [SMALL_STATE(734)] = 10660,
  [SMALL_STATE(735)] = 10732,
  [SMALL_STATE(736)] = 10842,
  [SMALL_STATE(737)] = 10952,
  [SMALL_STATE(738)] = 11062,
  [SMALL_STATE(739)] = 11172,
  [SMALL_STATE(740)] = 11282,
  [SMALL_STATE(741)] = 11392,
  [SMALL_STATE(742)] = 11502,
  [SMALL_STATE(743)] = 11612,
  [SMALL_STATE(744)] = 11722,
  [SMALL_STATE(745)] = 11832,
  [SMALL_STATE(746)] = 11910,
  [SMALL_STATE(747)] = 12020,
  [SMALL_STATE(748)] = 12130,
  [SMALL_STATE(749)] = 12240,
  [SMALL_STATE(750)] = 12350,
  [SMALL_STATE(751)] = 12460,
  [SMALL_STATE(752)] = 12532,
  [SMALL_STATE(753)] = 12642,
  [SMALL_STATE(754)] = 12752,
  [SMALL_STATE(755)] = 12862,
  [SMALL_STATE(756)] = 12972,
  [SMALL_STATE(757)] = 13082,
  [SMALL_STATE(758)] = 13192,
  [SMALL_STATE(759)] = 13302,
  [SMALL_STATE(760)] = 13412,
  [SMALL_STATE(761)] = 13522,
  [SMALL_STATE(762)] = 13632,
  [SMALL_STATE(763)] = 13742,
  [SMALL_STATE(764)] = 13852,
  [SMALL_STATE(765)] = 13962,
  [SMALL_STATE(766)] = 14072,
  [SMALL_STATE(767)] = 14182,
  [SMALL_STATE(768)] = 14292,
  [SMALL_STATE(769)] = 14402,
  [SMALL_STATE(770)] = 14512,
  [SMALL_STATE(771)] = 14622,
  [SMALL_STATE(772)] = 14732,
  [SMALL_STATE(773)] = 14842,
  [SMALL_STATE(774)] = 14952,
  [SMALL_STATE(775)] = 15062,
  [SMALL_STATE(776)] = 15172,
  [SMALL_STATE(777)] = 15282,
  [SMALL_STATE(778)] = 15392,
  [SMALL_STATE(779)] = 15502,
  [SMALL_STATE(780)] = 15574,
  [SMALL_STATE(781)] = 15684,
  [SMALL_STATE(782)] = 15756,
  [SMALL_STATE(783)] = 15866,
  [SMALL_STATE(784)] = 15944,
  [SMALL_STATE(785)] = 16054,
  [SMALL_STATE(786)] = 16164,
  [SMALL_STATE(787)] = 16274,
  [SMALL_STATE(788)] = 16384,
  [SMALL_STATE(789)] = 16494,
  [SMALL_STATE(790)] = 16604,
  [SMALL_STATE(791)] = 16714,
  [SMALL_STATE(792)] = 16788,
  [SMALL_STATE(793)] = 16898,
  [SMALL_STATE(794)] = 17008,
  [SMALL_STATE(795)] = 17080,
  [SMALL_STATE(796)] = 17190,
  [SMALL_STATE(797)] = 17300,
  [SMALL_STATE(798)] = 17410,
  [SMALL_STATE(799)] = 17520,
  [SMALL_STATE(800)] = 17630,
  [SMALL_STATE(801)] = 17740,
  [SMALL_STATE(802)] = 17850,
  [SMALL_STATE(803)] = 17922,
  [SMALL_STATE(804)] = 18032,
  [SMALL_STATE(805)] = 18142,
  [SMALL_STATE(806)] = 18252,
  [SMALL_STATE(807)] = 18320,
  [SMALL_STATE(808)] = 18430,
  [SMALL_STATE(809)] = 18508,
  [SMALL_STATE(810)] = 18590,
  [SMALL_STATE(811)] = 18700,
  [SMALL_STATE(812)] = 18810,
  [SMALL_STATE(813)] = 18920,
  [SMALL_STATE(814)] = 19030,
  [SMALL_STATE(815)] = 19140,
  [SMALL_STATE(816)] = 19250,
  [SMALL_STATE(817)] = 19360,
  [SMALL_STATE(818)] = 19440,
  [SMALL_STATE(819)] = 19550,
  [SMALL_STATE(820)] = 19660,
  [SMALL_STATE(821)] = 19728,
  [SMALL_STATE(822)] = 19838,
  [SMALL_STATE(823)] = 19948,
  [SMALL_STATE(824)] = 20058,
  [SMALL_STATE(825)] = 20133,
  [SMALL_STATE(826)] = 20204,
  [SMALL_STATE(827)] = 20263,
  [SMALL_STATE(828)] = 20334,
  [SMALL_STATE(829)] = 20403,
  [SMALL_STATE(830)] = 20472,
  [SMALL_STATE(831)] = 20531,
  [SMALL_STATE(832)] = 20600,
  [SMALL_STATE(833)] = 20669,
  [SMALL_STATE(834)] = 20742,
  [SMALL_STATE(835)] = 20811,
  [SMALL_STATE(836)] = 20882,
  [SMALL_STATE(837)] = 20953,
  [SMALL_STATE(838)] = 21026,
  [SMALL_STATE(839)] = 21097,
  [SMALL_STATE(840)] = 21166,
  [SMALL_STATE(841)] = 21235,
  [SMALL_STATE(842)] = 21308,
  [SMALL_STATE(843)] = 21385,
  [SMALL_STATE(844)] = 21444,
  [SMALL_STATE(845)] = 21513,
  [SMALL_STATE(846)] = 21584,
  [SMALL_STATE(847)] = 21643,
  [SMALL_STATE(848)] = 21710,
  [SMALL_STATE(849)] = 21781,
  [SMALL_STATE(850)] = 21848,
  [SMALL_STATE(851)] = 21911,
  [SMALL_STATE(852)] = 21982,
  [SMALL_STATE(853)] = 22053,
  [SMALL_STATE(854)] = 22120,
  [SMALL_STATE(855)] = 22191,
  [SMALL_STATE(856)] = 22250,
  [SMALL_STATE(857)] = 22315,
  [SMALL_STATE(858)] = 22382,
  [SMALL_STATE(859)] = 22453,
  [SMALL_STATE(860)] = 22519,
  [SMALL_STATE(861)] = 22589,
  [SMALL_STATE(862)] = 22657,
  [SMALL_STATE(863)] = 22731,
  [SMALL_STATE(864)] = 22801,
  [SMALL_STATE(865)] = 22871,
  [SMALL_STATE(866)] = 22933,
  [SMALL_STATE(867)] = 22999,
  [SMALL_STATE(868)] = 23069,
  [SMALL_STATE(869)] = 23135,
  [SMALL_STATE(870)] = 23207,
  [SMALL_STATE(871)] = 23275,
  [SMALL_STATE(872)] = 23337,
  [SMALL_STATE(873)] = 23401,
  [SMALL_STATE(874)] = 23465,
  [SMALL_STATE(875)] = 23531,
  [SMALL_STATE(876)] = 23597,
  [SMALL_STATE(877)] = 23663,
  [SMALL_STATE(878)] = 23733,
  [SMALL_STATE(879)] = 23799,
  [SMALL_STATE(880)] = 23861,
  [SMALL_STATE(881)] = 23931,
  [SMALL_STATE(882)] = 24001,
  [SMALL_STATE(883)] = 24069,
  [SMALL_STATE(884)] = 24139,
  [SMALL_STATE(885)] = 24209,
  [SMALL_STATE(886)] = 24279,
  [SMALL_STATE(887)] = 24349,
  [SMALL_STATE(888)] = 24415,
  [SMALL_STATE(889)] = 24481,
  [SMALL_STATE(890)] = 24544,
  [SMALL_STATE(891)] = 24605,
  [SMALL_STATE(892)] = 24666,
  [SMALL_STATE(893)] = 24727,
  [SMALL_STATE(894)] = 24788,
  [SMALL_STATE(895)] = 24853,
  [SMALL_STATE(896)] = 24916,
  [SMALL_STATE(897)] = 24973,
  [SMALL_STATE(898)] = 25038,
  [SMALL_STATE(899)] = 25099,
  [SMALL_STATE(900)] = 25160,
  [SMALL_STATE(901)] = 25229,
  [SMALL_STATE(902)] = 25298,
  [SMALL_STATE(903)] = 25355,
  [SMALL_STATE(904)] = 25424,
  [SMALL_STATE(905)] = 25487,
  [SMALL_STATE(906)] = 25552,
  [SMALL_STATE(907)] = 25615,
  [SMALL_STATE(908)] = 25672,
  [SMALL_STATE(909)] = 25729,
  [SMALL_STATE(910)] = 25796,
  [SMALL_STATE(911)] = 25859,
  [SMALL_STATE(912)] = 25916,
  [SMALL_STATE(913)] = 25984,
  [SMALL_STATE(914)] = 26088,
  [SMALL_STATE(915)] = 26150,
  [SMALL_STATE(916)] = 26254,
  [SMALL_STATE(917)] = 26358,
  [SMALL_STATE(918)] = 26462,
  [SMALL_STATE(919)] = 26566,
  [SMALL_STATE(920)] = 26634,
  [SMALL_STATE(921)] = 26702,
  [SMALL_STATE(922)] = 26806,
  [SMALL_STATE(923)] = 26866,
  [SMALL_STATE(924)] = 26970,
  [SMALL_STATE(925)] = 27074,
  [SMALL_STATE(926)] = 27142,
  [SMALL_STATE(927)] = 27246,
  [SMALL_STATE(928)] = 27306,
  [SMALL_STATE(929)] = 27379,
  [SMALL_STATE(930)] = 27480,
  [SMALL_STATE(931)] = 27543,
  [SMALL_STATE(932)] = 27646,
  [SMALL_STATE(933)] = 27709,
  [SMALL_STATE(934)] = 27809,
  [SMALL_STATE(935)] = 27909,
  [SMALL_STATE(936)] = 28009,
  [SMALL_STATE(937)] = 28109,
  [SMALL_STATE(938)] = 28209,
  [SMALL_STATE(939)] = 28309,
  [SMALL_STATE(940)] = 28409,
  [SMALL_STATE(941)] = 28509,
  [SMALL_STATE(942)] = 28609,
  [SMALL_STATE(943)] = 28709,
  [SMALL_STATE(944)] = 28809,
  [SMALL_STATE(945)] = 28909,
  [SMALL_STATE(946)] = 29009,
  [SMALL_STATE(947)] = 29109,
  [SMALL_STATE(948)] = 29209,
  [SMALL_STATE(949)] = 29305,
  [SMALL_STATE(950)] = 29401,
  [SMALL_STATE(951)] = 29497,
  [SMALL_STATE(952)] = 29593,
  [SMALL_STATE(953)] = 29689,
  [SMALL_STATE(954)] = 29785,
  [SMALL_STATE(955)] = 29842,
  [SMALL_STATE(956)] = 29907,
  [SMALL_STATE(957)] = 29968,
  [SMALL_STATE(958)] = 30029,
  [SMALL_STATE(959)] = 30085,
  [SMALL_STATE(960)] = 30135,
  [SMALL_STATE(961)] = 30185,
  [SMALL_STATE(962)] = 30235,
  [SMALL_STATE(963)] = 30285,
  [SMALL_STATE(964)] = 30335,
  [SMALL_STATE(965)] = 30391,
  [SMALL_STATE(966)] = 30441,
  [SMALL_STATE(967)] = 30495,
  [SMALL_STATE(968)] = 30545,
  [SMALL_STATE(969)] = 30603,
  [SMALL_STATE(970)] = 30653,
  [SMALL_STATE(971)] = 30703,
  [SMALL_STATE(972)] = 30753,
  [SMALL_STATE(973)] = 30842,
  [SMALL_STATE(974)] = 30931,
  [SMALL_STATE(975)] = 31006,
  [SMALL_STATE(976)] = 31091,
  [SMALL_STATE(977)] = 31172,
  [SMALL_STATE(978)] = 31261,
  [SMALL_STATE(979)] = 31350,
  [SMALL_STATE(980)] = 31435,
  [SMALL_STATE(981)] = 31520,
  [SMALL_STATE(982)] = 31573,
  [SMALL_STATE(983)] = 31624,
  [SMALL_STATE(984)] = 31701,
  [SMALL_STATE(985)] = 31792,
  [SMALL_STATE(986)] = 31845,
  [SMALL_STATE(987)] = 31916,
  [SMALL_STATE(988)] = 32013,
  [SMALL_STATE(989)] = 32102,
  [SMALL_STATE(990)] = 32191,
  [SMALL_STATE(991)] = 32260,
  [SMALL_STATE(992)] = 32345,
  [SMALL_STATE(993)] = 32442,
  [SMALL_STATE(994)] = 32493,
  [SMALL_STATE(995)] = 32582,
  [SMALL_STATE(996)] = 32651,
  [SMALL_STATE(997)] = 32704,
  [SMALL_STATE(998)] = 32789,
  [SMALL_STATE(999)] = 32874,
  [SMALL_STATE(1000)] = 32929,
  [SMALL_STATE(1001)] = 33018,
  [SMALL_STATE(1002)] = 33087,
  [SMALL_STATE(1003)] = 33154,
  [SMALL_STATE(1004)] = 33239,
  [SMALL_STATE(1005)] = 33328,
  [SMALL_STATE(1006)] = 33417,
  [SMALL_STATE(1007)] = 33480,
  [SMALL_STATE(1008)] = 33533,
  [SMALL_STATE(1009)] = 33622,
  [SMALL_STATE(1010)] = 33711,
  [SMALL_STATE(1011)] = 33808,
  [SMALL_STATE(1012)] = 33863,
  [SMALL_STATE(1013)] = 33916,
  [SMALL_STATE(1014)] = 34001,
  [SMALL_STATE(1015)] = 34090,
  [SMALL_STATE(1016)] = 34179,
  [SMALL_STATE(1017)] = 34230,
  [SMALL_STATE(1018)] = 34319,
  [SMALL_STATE(1019)] = 34382,
  [SMALL_STATE(1020)] = 34471,
  [SMALL_STATE(1021)] = 34519,
  [SMALL_STATE(1022)] = 34613,
  [SMALL_STATE(1023)] = 34661,
  [SMALL_STATE(1024)] = 34755,
  [SMALL_STATE(1025)] = 34803,
  [SMALL_STATE(1026)] = 34851,
  [SMALL_STATE(1027)] = 34939,
  [SMALL_STATE(1028)] = 34991,
  [SMALL_STATE(1029)] = 35039,
  [SMALL_STATE(1030)] = 35125,
  [SMALL_STATE(1031)] = 35211,
  [SMALL_STATE(1032)] = 35305,
  [SMALL_STATE(1033)] = 35353,
  [SMALL_STATE(1034)] = 35401,
  [SMALL_STATE(1035)] = 35449,
  [SMALL_STATE(1036)] = 35497,
  [SMALL_STATE(1037)] = 35545,
  [SMALL_STATE(1038)] = 35593,
  [SMALL_STATE(1039)] = 35641,
  [SMALL_STATE(1040)] = 35689,
  [SMALL_STATE(1041)] = 35737,
  [SMALL_STATE(1042)] = 35785,
  [SMALL_STATE(1043)] = 35833,
  [SMALL_STATE(1044)] = 35927,
  [SMALL_STATE(1045)] = 36013,
  [SMALL_STATE(1046)] = 36065,
  [SMALL_STATE(1047)] = 36113,
  [SMALL_STATE(1048)] = 36161,
  [SMALL_STATE(1049)] = 36209,
  [SMALL_STATE(1050)] = 36257,
  [SMALL_STATE(1051)] = 36305,
  [SMALL_STATE(1052)] = 36353,
  [SMALL_STATE(1053)] = 36401,
  [SMALL_STATE(1054)] = 36449,
  [SMALL_STATE(1055)] = 36497,
  [SMALL_STATE(1056)] = 36545,
  [SMALL_STATE(1057)] = 36593,
  [SMALL_STATE(1058)] = 36641,
  [SMALL_STATE(1059)] = 36689,
  [SMALL_STATE(1060)] = 36737,
  [SMALL_STATE(1061)] = 36785,
  [SMALL_STATE(1062)] = 36873,
  [SMALL_STATE(1063)] = 36921,
  [SMALL_STATE(1064)] = 36969,
  [SMALL_STATE(1065)] = 37017,
  [SMALL_STATE(1066)] = 37065,
  [SMALL_STATE(1067)] = 37153,
  [SMALL_STATE(1068)] = 37201,
  [SMALL_STATE(1069)] = 37289,
  [SMALL_STATE(1070)] = 37377,
  [SMALL_STATE(1071)] = 37425,
  [SMALL_STATE(1072)] = 37517,
  [SMALL_STATE(1073)] = 37569,
  [SMALL_STATE(1074)] = 37617,
  [SMALL_STATE(1075)] = 37665,
  [SMALL_STATE(1076)] = 37753,
  [SMALL_STATE(1077)] = 37801,
  [SMALL_STATE(1078)] = 37889,
  [SMALL_STATE(1079)] = 37937,
  [SMALL_STATE(1080)] = 37985,
  [SMALL_STATE(1081)] = 38033,
  [SMALL_STATE(1082)] = 38081,
  [SMALL_STATE(1083)] = 38129,
  [SMALL_STATE(1084)] = 38217,
  [SMALL_STATE(1085)] = 38265,
  [SMALL_STATE(1086)] = 38313,
  [SMALL_STATE(1087)] = 38361,
  [SMALL_STATE(1088)] = 38409,
  [SMALL_STATE(1089)] = 38457,
  [SMALL_STATE(1090)] = 38505,
  [SMALL_STATE(1091)] = 38553,
  [SMALL_STATE(1092)] = 38601,
  [SMALL_STATE(1093)] = 38649,
  [SMALL_STATE(1094)] = 38697,
  [SMALL_STATE(1095)] = 38745,
  [SMALL_STATE(1096)] = 38803,
  [SMALL_STATE(1097)] = 38871,
  [SMALL_STATE(1098)] = 38919,
  [SMALL_STATE(1099)] = 38985,
  [SMALL_STATE(1100)] = 39039,
  [SMALL_STATE(1101)] = 39087,
  [SMALL_STATE(1102)] = 39135,
  [SMALL_STATE(1103)] = 39183,
  [SMALL_STATE(1104)] = 39277,
  [SMALL_STATE(1105)] = 39347,
  [SMALL_STATE(1106)] = 39433,
  [SMALL_STATE(1107)] = 39509,
  [SMALL_STATE(1108)] = 39589,
  [SMALL_STATE(1109)] = 39673,
  [SMALL_STATE(1110)] = 39747,
  [SMALL_STATE(1111)] = 39815,
  [SMALL_STATE(1112)] = 39903,
  [SMALL_STATE(1113)] = 39991,
  [SMALL_STATE(1114)] = 40079,
  [SMALL_STATE(1115)] = 40171,
  [SMALL_STATE(1116)] = 40219,
  [SMALL_STATE(1117)] = 40311,
  [SMALL_STATE(1118)] = 40403,
  [SMALL_STATE(1119)] = 40451,
  [SMALL_STATE(1120)] = 40539,
  [SMALL_STATE(1121)] = 40587,
  [SMALL_STATE(1122)] = 40679,
  [SMALL_STATE(1123)] = 40767,
  [SMALL_STATE(1124)] = 40855,
  [SMALL_STATE(1125)] = 40949,
  [SMALL_STATE(1126)] = 40997,
  [SMALL_STATE(1127)] = 41045,
  [SMALL_STATE(1128)] = 41133,
  [SMALL_STATE(1129)] = 41221,
  [SMALL_STATE(1130)] = 41309,
  [SMALL_STATE(1131)] = 41357,
  [SMALL_STATE(1132)] = 41405,
  [SMALL_STATE(1133)] = 41473,
  [SMALL_STATE(1134)] = 41521,
  [SMALL_STATE(1135)] = 41573,
  [SMALL_STATE(1136)] = 41621,
  [SMALL_STATE(1137)] = 41673,
  [SMALL_STATE(1138)] = 41721,
  [SMALL_STATE(1139)] = 41773,
  [SMALL_STATE(1140)] = 41821,
  [SMALL_STATE(1141)] = 41907,
  [SMALL_STATE(1142)] = 41955,
  [SMALL_STATE(1143)] = 42003,
  [SMALL_STATE(1144)] = 42051,
  [SMALL_STATE(1145)] = 42099,
  [SMALL_STATE(1146)] = 42147,
  [SMALL_STATE(1147)] = 42195,
  [SMALL_STATE(1148)] = 42245,
  [SMALL_STATE(1149)] = 42293,
  [SMALL_STATE(1150)] = 42341,
  [SMALL_STATE(1151)] = 42389,
  [SMALL_STATE(1152)] = 42437,
  [SMALL_STATE(1153)] = 42487,
  [SMALL_STATE(1154)] = 42537,
  [SMALL_STATE(1155)] = 42585,
  [SMALL_STATE(1156)] = 42633,
  [SMALL_STATE(1157)] = 42681,
  [SMALL_STATE(1158)] = 42739,
  [SMALL_STATE(1159)] = 42787,
  [SMALL_STATE(1160)] = 42837,
  [SMALL_STATE(1161)] = 42885,
  [SMALL_STATE(1162)] = 42933,
  [SMALL_STATE(1163)] = 42981,
  [SMALL_STATE(1164)] = 43043,
  [SMALL_STATE(1165)] = 43091,
  [SMALL_STATE(1166)] = 43139,
  [SMALL_STATE(1167)] = 43187,
  [SMALL_STATE(1168)] = 43237,
  [SMALL_STATE(1169)] = 43289,
  [SMALL_STATE(1170)] = 43341,
  [SMALL_STATE(1171)] = 43389,
  [SMALL_STATE(1172)] = 43437,
  [SMALL_STATE(1173)] = 43485,
  [SMALL_STATE(1174)] = 43533,
  [SMALL_STATE(1175)] = 43620,
  [SMALL_STATE(1176)] = 43687,
  [SMALL_STATE(1177)] = 43766,
  [SMALL_STATE(1178)] = 43841,
  [SMALL_STATE(1179)] = 43910,
  [SMALL_STATE(1180)] = 43997,
  [SMALL_STATE(1181)] = 44084,
  [SMALL_STATE(1182)] = 44173,
  [SMALL_STATE(1183)] = 44260,
  [SMALL_STATE(1184)] = 44347,
  [SMALL_STATE(1185)] = 44434,
  [SMALL_STATE(1186)] = 44483,
  [SMALL_STATE(1187)] = 44570,
  [SMALL_STATE(1188)] = 44657,
  [SMALL_STATE(1189)] = 44724,
  [SMALL_STATE(1190)] = 44797,
  [SMALL_STATE(1191)] = 44884,
  [SMALL_STATE(1192)] = 44973,
  [SMALL_STATE(1193)] = 45054,
  [SMALL_STATE(1194)] = 45137,
  [SMALL_STATE(1195)] = 45224,
  [SMALL_STATE(1196)] = 45311,
  [SMALL_STATE(1197)] = 45398,
  [SMALL_STATE(1198)] = 45485,
  [SMALL_STATE(1199)] = 45532,
  [SMALL_STATE(1200)] = 45619,
  [SMALL_STATE(1201)] = 45686,
  [SMALL_STATE(1202)] = 45773,
  [SMALL_STATE(1203)] = 45842,
  [SMALL_STATE(1204)] = 45907,
  [SMALL_STATE(1205)] = 45996,
  [SMALL_STATE(1206)] = 46085,
  [SMALL_STATE(1207)] = 46134,
  [SMALL_STATE(1208)] = 46225,
  [SMALL_STATE(1209)] = 46306,
  [SMALL_STATE(1210)] = 46397,
  [SMALL_STATE(1211)] = 46478,
  [SMALL_STATE(1212)] = 46569,
  [SMALL_STATE(1213)] = 46650,
  [SMALL_STATE(1214)] = 46737,
  [SMALL_STATE(1215)] = 46828,
  [SMALL_STATE(1216)] = 46915,
  [SMALL_STATE(1217)] = 46962,
  [SMALL_STATE(1218)] = 47043,
  [SMALL_STATE(1219)] = 47124,
  [SMALL_STATE(1220)] = 47215,
  [SMALL_STATE(1221)] = 47306,
  [SMALL_STATE(1222)] = 47387,
  [SMALL_STATE(1223)] = 47468,
  [SMALL_STATE(1224)] = 47515,
  [SMALL_STATE(1225)] = 47596,
  [SMALL_STATE(1226)] = 47685,
  [SMALL_STATE(1227)] = 47772,
  [SMALL_STATE(1228)] = 47859,
  [SMALL_STATE(1229)] = 47946,
  [SMALL_STATE(1230)] = 48033,
  [SMALL_STATE(1231)] = 48120,
  [SMALL_STATE(1232)] = 48207,
  [SMALL_STATE(1233)] = 48294,
  [SMALL_STATE(1234)] = 48361,
  [SMALL_STATE(1235)] = 48434,
  [SMALL_STATE(1236)] = 48517,
  [SMALL_STATE(1237)] = 48596,
  [SMALL_STATE(1238)] = 48663,
  [SMALL_STATE(1239)] = 48752,
  [SMALL_STATE(1240)] = 48827,
  [SMALL_STATE(1241)] = 48896,
  [SMALL_STATE(1242)] = 48983,
  [SMALL_STATE(1243)] = 49070,
  [SMALL_STATE(1244)] = 49159,
  [SMALL_STATE(1245)] = 49246,
  [SMALL_STATE(1246)] = 49333,
  [SMALL_STATE(1247)] = 49420,
  [SMALL_STATE(1248)] = 49507,
  [SMALL_STATE(1249)] = 49574,
  [SMALL_STATE(1250)] = 49647,
  [SMALL_STATE(1251)] = 49734,
  [SMALL_STATE(1252)] = 49817,
  [SMALL_STATE(1253)] = 49896,
  [SMALL_STATE(1254)] = 49945,
  [SMALL_STATE(1255)] = 50014,
  [SMALL_STATE(1256)] = 50095,
  [SMALL_STATE(1257)] = 50176,
  [SMALL_STATE(1258)] = 50229,
  [SMALL_STATE(1259)] = 50304,
  [SMALL_STATE(1260)] = 50373,
  [SMALL_STATE(1261)] = 50440,
  [SMALL_STATE(1262)] = 50529,
  [SMALL_STATE(1263)] = 50598,
  [SMALL_STATE(1264)] = 50663,
  [SMALL_STATE(1265)] = 50724,
  [SMALL_STATE(1266)] = 50813,
  [SMALL_STATE(1267)] = 50866,
  [SMALL_STATE(1268)] = 50955,
  [SMALL_STATE(1269)] = 51044,
  [SMALL_STATE(1270)] = 51135,
  [SMALL_STATE(1271)] = 51224,
  [SMALL_STATE(1272)] = 51291,
  [SMALL_STATE(1273)] = 51356,
  [SMALL_STATE(1274)] = 51407,
  [SMALL_STATE(1275)] = 51496,
  [SMALL_STATE(1276)] = 51545,
  [SMALL_STATE(1277)] = 51632,
  [SMALL_STATE(1278)] = 51719,
  [SMALL_STATE(1279)] = 51784,
  [SMALL_STATE(1280)] = 51853,
  [SMALL_STATE(1281)] = 51908,
  [SMALL_STATE(1282)] = 51955,
  [SMALL_STATE(1283)] = 52022,
  [SMALL_STATE(1284)] = 52111,
  [SMALL_STATE(1285)] = 52200,
  [SMALL_STATE(1286)] = 52289,
  [SMALL_STATE(1287)] = 52378,
  [SMALL_STATE(1288)] = 52435,
  [SMALL_STATE(1289)] = 52502,
  [SMALL_STATE(1290)] = 52567,
  [SMALL_STATE(1291)] = 52614,
  [SMALL_STATE(1292)] = 52701,
  [SMALL_STATE(1293)] = 52788,
  [SMALL_STATE(1294)] = 52877,
  [SMALL_STATE(1295)] = 52964,
  [SMALL_STATE(1296)] = 53055,
  [SMALL_STATE(1297)] = 53142,
  [SMALL_STATE(1298)] = 53207,
  [SMALL_STATE(1299)] = 53274,
  [SMALL_STATE(1300)] = 53365,
  [SMALL_STATE(1301)] = 53456,
  [SMALL_STATE(1302)] = 53537,
  [SMALL_STATE(1303)] = 53624,
  [SMALL_STATE(1304)] = 53691,
  [SMALL_STATE(1305)] = 53772,
  [SMALL_STATE(1306)] = 53829,
  [SMALL_STATE(1307)] = 53918,
  [SMALL_STATE(1308)] = 54009,
  [SMALL_STATE(1309)] = 54076,
  [SMALL_STATE(1310)] = 54125,
  [SMALL_STATE(1311)] = 54174,
  [SMALL_STATE(1312)] = 54239,
  [SMALL_STATE(1313)] = 54328,
  [SMALL_STATE(1314)] = 54381,
  [SMALL_STATE(1315)] = 54432,
  [SMALL_STATE(1316)] = 54521,
  [SMALL_STATE(1317)] = 54608,
  [SMALL_STATE(1318)] = 54689,
  [SMALL_STATE(1319)] = 54736,
  [SMALL_STATE(1320)] = 54827,
  [SMALL_STATE(1321)] = 54875,
  [SMALL_STATE(1322)] = 54935,
  [SMALL_STATE(1323)] = 54987,
  [SMALL_STATE(1324)] = 55039,
  [SMALL_STATE(1325)] = 55087,
  [SMALL_STATE(1326)] = 55173,
  [SMALL_STATE(1327)] = 55259,
  [SMALL_STATE(1328)] = 55345,
  [SMALL_STATE(1329)] = 55431,
  [SMALL_STATE(1330)] = 55517,
  [SMALL_STATE(1331)] = 55605,
  [SMALL_STATE(1332)] = 55691,
  [SMALL_STATE(1333)] = 55779,
  [SMALL_STATE(1334)] = 55865,
  [SMALL_STATE(1335)] = 55953,
  [SMALL_STATE(1336)] = 56039,
  [SMALL_STATE(1337)] = 56125,
  [SMALL_STATE(1338)] = 56213,
  [SMALL_STATE(1339)] = 56301,
  [SMALL_STATE(1340)] = 56369,
  [SMALL_STATE(1341)] = 56457,
  [SMALL_STATE(1342)] = 56507,
  [SMALL_STATE(1343)] = 56557,
  [SMALL_STATE(1344)] = 56635,
  [SMALL_STATE(1345)] = 56723,
  [SMALL_STATE(1346)] = 56773,
  [SMALL_STATE(1347)] = 56855,
  [SMALL_STATE(1348)] = 56927,
  [SMALL_STATE(1349)] = 56979,
  [SMALL_STATE(1350)] = 57045,
  [SMALL_STATE(1351)] = 57131,
  [SMALL_STATE(1352)] = 57217,
  [SMALL_STATE(1353)] = 57305,
  [SMALL_STATE(1354)] = 57359,
  [SMALL_STATE(1355)] = 57445,
  [SMALL_STATE(1356)] = 57511,
  [SMALL_STATE(1357)] = 57575,
  [SMALL_STATE(1358)] = 57625,
  [SMALL_STATE(1359)] = 57711,
  [SMALL_STATE(1360)] = 57797,
  [SMALL_STATE(1361)] = 57845,
  [SMALL_STATE(1362)] = 57897,
  [SMALL_STATE(1363)] = 57949,
  [SMALL_STATE(1364)] = 58035,
  [SMALL_STATE(1365)] = 58109,
  [SMALL_STATE(1366)] = 58195,
  [SMALL_STATE(1367)] = 58263,
  [SMALL_STATE(1368)] = 58349,
  [SMALL_STATE(1369)] = 58399,
  [SMALL_STATE(1370)] = 58465,
  [SMALL_STATE(1371)] = 58553,
  [SMALL_STATE(1372)] = 58639,
  [SMALL_STATE(1373)] = 58725,
  [SMALL_STATE(1374)] = 58811,
  [SMALL_STATE(1375)] = 58871,
  [SMALL_STATE(1376)] = 58957,
  [SMALL_STATE(1377)] = 59043,
  [SMALL_STATE(1378)] = 59129,
  [SMALL_STATE(1379)] = 59181,
  [SMALL_STATE(1380)] = 59267,
  [SMALL_STATE(1381)] = 59333,
  [SMALL_STATE(1382)] = 59383,
  [SMALL_STATE(1383)] = 59435,
  [SMALL_STATE(1384)] = 59495,
  [SMALL_STATE(1385)] = 59583,
  [SMALL_STATE(1386)] = 59647,
  [SMALL_STATE(1387)] = 59697,
  [SMALL_STATE(1388)] = 59785,
  [SMALL_STATE(1389)] = 59835,
  [SMALL_STATE(1390)] = 59885,
  [SMALL_STATE(1391)] = 59973,
  [SMALL_STATE(1392)] = 60037,
  [SMALL_STATE(1393)] = 60125,
  [SMALL_STATE(1394)] = 60175,
  [SMALL_STATE(1395)] = 60225,
  [SMALL_STATE(1396)] = 60289,
  [SMALL_STATE(1397)] = 60339,
  [SMALL_STATE(1398)] = 60427,
  [SMALL_STATE(1399)] = 60477,
  [SMALL_STATE(1400)] = 60565,
  [SMALL_STATE(1401)] = 60615,
  [SMALL_STATE(1402)] = 60665,
  [SMALL_STATE(1403)] = 60715,
  [SMALL_STATE(1404)] = 60775,
  [SMALL_STATE(1405)] = 60863,
  [SMALL_STATE(1406)] = 60951,
  [SMALL_STATE(1407)] = 60999,
  [SMALL_STATE(1408)] = 61087,
  [SMALL_STATE(1409)] = 61135,
  [SMALL_STATE(1410)] = 61185,
  [SMALL_STATE(1411)] = 61271,
  [SMALL_STATE(1412)] = 61321,
  [SMALL_STATE(1413)] = 61366,
  [SMALL_STATE(1414)] = 61411,
  [SMALL_STATE(1415)] = 61456,
  [SMALL_STATE(1416)] = 61505,
  [SMALL_STATE(1417)] = 61556,
  [SMALL_STATE(1418)] = 61601,
  [SMALL_STATE(1419)] = 61686,
  [SMALL_STATE(1420)] = 61731,
  [SMALL_STATE(1421)] = 61780,
  [SMALL_STATE(1422)] = 61825,
  [SMALL_STATE(1423)] = 61870,
  [SMALL_STATE(1424)] = 61929,
  [SMALL_STATE(1425)] = 61990,
  [SMALL_STATE(1426)] = 62053,
  [SMALL_STATE(1427)] = 62112,
  [SMALL_STATE(1428)] = 62175,
  [SMALL_STATE(1429)] = 62236,
  [SMALL_STATE(1430)] = 62281,
  [SMALL_STATE(1431)] = 62326,
  [SMALL_STATE(1432)] = 62371,
  [SMALL_STATE(1433)] = 62416,
  [SMALL_STATE(1434)] = 62463,
  [SMALL_STATE(1435)] = 62508,
  [SMALL_STATE(1436)] = 62571,
  [SMALL_STATE(1437)] = 62616,
  [SMALL_STATE(1438)] = 62661,
  [SMALL_STATE(1439)] = 62706,
  [SMALL_STATE(1440)] = 62751,
  [SMALL_STATE(1441)] = 62796,
  [SMALL_STATE(1442)] = 62841,
  [SMALL_STATE(1443)] = 62888,
  [SMALL_STATE(1444)] = 62949,
  [SMALL_STATE(1445)] = 63008,
  [SMALL_STATE(1446)] = 63053,
  [SMALL_STATE(1447)] = 63098,
  [SMALL_STATE(1448)] = 63157,
  [SMALL_STATE(1449)] = 63202,
  [SMALL_STATE(1450)] = 63263,
  [SMALL_STATE(1451)] = 63314,
  [SMALL_STATE(1452)] = 63365,
  [SMALL_STATE(1453)] = 63410,
  [SMALL_STATE(1454)] = 63455,
  [SMALL_STATE(1455)] = 63518,
  [SMALL_STATE(1456)] = 63563,
  [SMALL_STATE(1457)] = 63608,
  [SMALL_STATE(1458)] = 63653,
  [SMALL_STATE(1459)] = 63698,
  [SMALL_STATE(1460)] = 63745,
  [SMALL_STATE(1461)] = 63806,
  [SMALL_STATE(1462)] = 63851,
  [SMALL_STATE(1463)] = 63900,
  [SMALL_STATE(1464)] = 63985,
  [SMALL_STATE(1465)] = 64070,
  [SMALL_STATE(1466)] = 64115,
  [SMALL_STATE(1467)] = 64166,
  [SMALL_STATE(1468)] = 64213,
  [SMALL_STATE(1469)] = 64258,
  [SMALL_STATE(1470)] = 64303,
  [SMALL_STATE(1471)] = 64348,
  [SMALL_STATE(1472)] = 64395,
  [SMALL_STATE(1473)] = 64440,
  [SMALL_STATE(1474)] = 64495,
  [SMALL_STATE(1475)] = 64540,
  [SMALL_STATE(1476)] = 64599,
  [SMALL_STATE(1477)] = 64648,
  [SMALL_STATE(1478)] = 64693,
  [SMALL_STATE(1479)] = 64738,
  [SMALL_STATE(1480)] = 64785,
  [SMALL_STATE(1481)] = 64834,
  [SMALL_STATE(1482)] = 64879,
  [SMALL_STATE(1483)] = 64930,
  [SMALL_STATE(1484)] = 64981,
  [SMALL_STATE(1485)] = 65032,
  [SMALL_STATE(1486)] = 65091,
  [SMALL_STATE(1487)] = 65176,
  [SMALL_STATE(1488)] = 65225,
  [SMALL_STATE(1489)] = 65274,
  [SMALL_STATE(1490)] = 65333,
  [SMALL_STATE(1491)] = 65378,
  [SMALL_STATE(1492)] = 65423,
  [SMALL_STATE(1493)] = 65468,
  [SMALL_STATE(1494)] = 65517,
  [SMALL_STATE(1495)] = 65566,
  [SMALL_STATE(1496)] = 65611,
  [SMALL_STATE(1497)] = 65656,
  [SMALL_STATE(1498)] = 65705,
  [SMALL_STATE(1499)] = 65764,
  [SMALL_STATE(1500)] = 65813,
  [SMALL_STATE(1501)] = 65858,
  [SMALL_STATE(1502)] = 65919,
  [SMALL_STATE(1503)] = 65964,
  [SMALL_STATE(1504)] = 66009,
  [SMALL_STATE(1505)] = 66094,
  [SMALL_STATE(1506)] = 66139,
  [SMALL_STATE(1507)] = 66224,
  [SMALL_STATE(1508)] = 66269,
  [SMALL_STATE(1509)] = 66314,
  [SMALL_STATE(1510)] = 66399,
  [SMALL_STATE(1511)] = 66446,
  [SMALL_STATE(1512)] = 66493,
  [SMALL_STATE(1513)] = 66538,
  [SMALL_STATE(1514)] = 66585,
  [SMALL_STATE(1515)] = 66632,
  [SMALL_STATE(1516)] = 66677,
  [SMALL_STATE(1517)] = 66722,
  [SMALL_STATE(1518)] = 66767,
  [SMALL_STATE(1519)] = 66814,
  [SMALL_STATE(1520)] = 66859,
  [SMALL_STATE(1521)] = 66906,
  [SMALL_STATE(1522)] = 66951,
  [SMALL_STATE(1523)] = 66998,
  [SMALL_STATE(1524)] = 67043,
  [SMALL_STATE(1525)] = 67128,
  [SMALL_STATE(1526)] = 67173,
  [SMALL_STATE(1527)] = 67218,
  [SMALL_STATE(1528)] = 67263,
  [SMALL_STATE(1529)] = 67308,
  [SMALL_STATE(1530)] = 67353,
  [SMALL_STATE(1531)] = 67398,
  [SMALL_STATE(1532)] = 67443,
  [SMALL_STATE(1533)] = 67492,
  [SMALL_STATE(1534)] = 67537,
  [SMALL_STATE(1535)] = 67582,
  [SMALL_STATE(1536)] = 67627,
  [SMALL_STATE(1537)] = 67672,
  [SMALL_STATE(1538)] = 67731,
  [SMALL_STATE(1539)] = 67778,
  [SMALL_STATE(1540)] = 67825,
  [SMALL_STATE(1541)] = 67874,
  [SMALL_STATE(1542)] = 67919,
  [SMALL_STATE(1543)] = 67964,
  [SMALL_STATE(1544)] = 68009,
  [SMALL_STATE(1545)] = 68058,
  [SMALL_STATE(1546)] = 68103,
  [SMALL_STATE(1547)] = 68148,
  [SMALL_STATE(1548)] = 68207,
  [SMALL_STATE(1549)] = 68252,
  [SMALL_STATE(1550)] = 68297,
  [SMALL_STATE(1551)] = 68342,
  [SMALL_STATE(1552)] = 68389,
  [SMALL_STATE(1553)] = 68436,
  [SMALL_STATE(1554)] = 68483,
  [SMALL_STATE(1555)] = 68528,
  [SMALL_STATE(1556)] = 68573,
  [SMALL_STATE(1557)] = 68618,
  [SMALL_STATE(1558)] = 68663,
  [SMALL_STATE(1559)] = 68708,
  [SMALL_STATE(1560)] = 68771,
  [SMALL_STATE(1561)] = 68856,
  [SMALL_STATE(1562)] = 68915,
  [SMALL_STATE(1563)] = 68974,
  [SMALL_STATE(1564)] = 69035,
  [SMALL_STATE(1565)] = 69080,
  [SMALL_STATE(1566)] = 69125,
  [SMALL_STATE(1567)] = 69170,
  [SMALL_STATE(1568)] = 69217,
  [SMALL_STATE(1569)] = 69266,
  [SMALL_STATE(1570)] = 69315,
  [SMALL_STATE(1571)] = 69360,
  [SMALL_STATE(1572)] = 69405,
  [SMALL_STATE(1573)] = 69450,
  [SMALL_STATE(1574)] = 69494,
  [SMALL_STATE(1575)] = 69540,
  [SMALL_STATE(1576)] = 69584,
  [SMALL_STATE(1577)] = 69628,
  [SMALL_STATE(1578)] = 69682,
  [SMALL_STATE(1579)] = 69726,
  [SMALL_STATE(1580)] = 69776,
  [SMALL_STATE(1581)] = 69820,
  [SMALL_STATE(1582)] = 69878,
  [SMALL_STATE(1583)] = 69922,
  [SMALL_STATE(1584)] = 69966,
  [SMALL_STATE(1585)] = 70020,
  [SMALL_STATE(1586)] = 70088,
  [SMALL_STATE(1587)] = 70132,
  [SMALL_STATE(1588)] = 70176,
  [SMALL_STATE(1589)] = 70246,
  [SMALL_STATE(1590)] = 70290,
  [SMALL_STATE(1591)] = 70356,
  [SMALL_STATE(1592)] = 70438,
  [SMALL_STATE(1593)] = 70482,
  [SMALL_STATE(1594)] = 70526,
  [SMALL_STATE(1595)] = 70570,
  [SMALL_STATE(1596)] = 70614,
  [SMALL_STATE(1597)] = 70658,
  [SMALL_STATE(1598)] = 70702,
  [SMALL_STATE(1599)] = 70750,
  [SMALL_STATE(1600)] = 70794,
  [SMALL_STATE(1601)] = 70848,
  [SMALL_STATE(1602)] = 70892,
  [SMALL_STATE(1603)] = 70950,
  [SMALL_STATE(1604)] = 70998,
  [SMALL_STATE(1605)] = 71042,
  [SMALL_STATE(1606)] = 71086,
  [SMALL_STATE(1607)] = 71130,
  [SMALL_STATE(1608)] = 71174,
  [SMALL_STATE(1609)] = 71218,
  [SMALL_STATE(1610)] = 71266,
  [SMALL_STATE(1611)] = 71316,
  [SMALL_STATE(1612)] = 71360,
  [SMALL_STATE(1613)] = 71404,
  [SMALL_STATE(1614)] = 71448,
  [SMALL_STATE(1615)] = 71496,
  [SMALL_STATE(1616)] = 71544,
  [SMALL_STATE(1617)] = 71592,
  [SMALL_STATE(1618)] = 71640,
  [SMALL_STATE(1619)] = 71688,
  [SMALL_STATE(1620)] = 71734,
  [SMALL_STATE(1621)] = 71782,
  [SMALL_STATE(1622)] = 71826,
  [SMALL_STATE(1623)] = 71870,
  [SMALL_STATE(1624)] = 71914,
  [SMALL_STATE(1625)] = 71968,
  [SMALL_STATE(1626)] = 72018,
  [SMALL_STATE(1627)] = 72072,
  [SMALL_STATE(1628)] = 72116,
  [SMALL_STATE(1629)] = 72160,
  [SMALL_STATE(1630)] = 72214,
  [SMALL_STATE(1631)] = 72258,
  [SMALL_STATE(1632)] = 72302,
  [SMALL_STATE(1633)] = 72346,
  [SMALL_STATE(1634)] = 72390,
  [SMALL_STATE(1635)] = 72434,
  [SMALL_STATE(1636)] = 72478,
  [SMALL_STATE(1637)] = 72532,
  [SMALL_STATE(1638)] = 72576,
  [SMALL_STATE(1639)] = 72620,
  [SMALL_STATE(1640)] = 72664,
  [SMALL_STATE(1641)] = 72708,
  [SMALL_STATE(1642)] = 72752,
  [SMALL_STATE(1643)] = 72796,
  [SMALL_STATE(1644)] = 72840,
  [SMALL_STATE(1645)] = 72884,
  [SMALL_STATE(1646)] = 72928,
  [SMALL_STATE(1647)] = 72972,
  [SMALL_STATE(1648)] = 73026,
  [SMALL_STATE(1649)] = 73070,
  [SMALL_STATE(1650)] = 73114,
  [SMALL_STATE(1651)] = 73158,
  [SMALL_STATE(1652)] = 73202,
  [SMALL_STATE(1653)] = 73250,
  [SMALL_STATE(1654)] = 73294,
  [SMALL_STATE(1655)] = 73340,
  [SMALL_STATE(1656)] = 73384,
  [SMALL_STATE(1657)] = 73428,
  [SMALL_STATE(1658)] = 73472,
  [SMALL_STATE(1659)] = 73518,
  [SMALL_STATE(1660)] = 73564,
  [SMALL_STATE(1661)] = 73608,
  [SMALL_STATE(1662)] = 73652,
  [SMALL_STATE(1663)] = 73696,
  [SMALL_STATE(1664)] = 73778,
  [SMALL_STATE(1665)] = 73822,
  [SMALL_STATE(1666)] = 73872,
  [SMALL_STATE(1667)] = 73916,
  [SMALL_STATE(1668)] = 73970,
  [SMALL_STATE(1669)] = 74014,
  [SMALL_STATE(1670)] = 74058,
  [SMALL_STATE(1671)] = 74102,
  [SMALL_STATE(1672)] = 74156,
  [SMALL_STATE(1673)] = 74200,
  [SMALL_STATE(1674)] = 74244,
  [SMALL_STATE(1675)] = 74298,
  [SMALL_STATE(1676)] = 74342,
  [SMALL_STATE(1677)] = 74410,
  [SMALL_STATE(1678)] = 74478,
  [SMALL_STATE(1679)] = 74528,
  [SMALL_STATE(1680)] = 74598,
  [SMALL_STATE(1681)] = 74668,
  [SMALL_STATE(1682)] = 74734,
  [SMALL_STATE(1683)] = 74800,
  [SMALL_STATE(1684)] = 74844,
  [SMALL_STATE(1685)] = 74888,
  [SMALL_STATE(1686)] = 74932,
  [SMALL_STATE(1687)] = 74986,
  [SMALL_STATE(1688)] = 75068,
  [SMALL_STATE(1689)] = 75134,
  [SMALL_STATE(1690)] = 75204,
  [SMALL_STATE(1691)] = 75248,
  [SMALL_STATE(1692)] = 75292,
  [SMALL_STATE(1693)] = 75336,
  [SMALL_STATE(1694)] = 75380,
  [SMALL_STATE(1695)] = 75448,
  [SMALL_STATE(1696)] = 75492,
  [SMALL_STATE(1697)] = 75536,
  [SMALL_STATE(1698)] = 75580,
  [SMALL_STATE(1699)] = 75630,
  [SMALL_STATE(1700)] = 75674,
  [SMALL_STATE(1701)] = 75728,
  [SMALL_STATE(1702)] = 75782,
  [SMALL_STATE(1703)] = 75826,
  [SMALL_STATE(1704)] = 75870,
  [SMALL_STATE(1705)] = 75918,
  [SMALL_STATE(1706)] = 75962,
  [SMALL_STATE(1707)] = 76006,
  [SMALL_STATE(1708)] = 76052,
  [SMALL_STATE(1709)] = 76096,
  [SMALL_STATE(1710)] = 76142,
  [SMALL_STATE(1711)] = 76196,
  [SMALL_STATE(1712)] = 76240,
  [SMALL_STATE(1713)] = 76284,
  [SMALL_STATE(1714)] = 76352,
  [SMALL_STATE(1715)] = 76396,
  [SMALL_STATE(1716)] = 76440,
  [SMALL_STATE(1717)] = 76510,
  [SMALL_STATE(1718)] = 76576,
  [SMALL_STATE(1719)] = 76647,
  [SMALL_STATE(1720)] = 76708,
  [SMALL_STATE(1721)] = 76757,
  [SMALL_STATE(1722)] = 76806,
  [SMALL_STATE(1723)] = 76877,
  [SMALL_STATE(1724)] = 76924,
  [SMALL_STATE(1725)] = 76971,
  [SMALL_STATE(1726)] = 77042,
  [SMALL_STATE(1727)] = 77103,
  [SMALL_STATE(1728)] = 77152,
  [SMALL_STATE(1729)] = 77223,
  [SMALL_STATE(1730)] = 77272,
  [SMALL_STATE(1731)] = 77333,
  [SMALL_STATE(1732)] = 77382,
  [SMALL_STATE(1733)] = 77453,
  [SMALL_STATE(1734)] = 77514,
  [SMALL_STATE(1735)] = 77585,
  [SMALL_STATE(1736)] = 77632,
  [SMALL_STATE(1737)] = 77703,
  [SMALL_STATE(1738)] = 77752,
  [SMALL_STATE(1739)] = 77815,
  [SMALL_STATE(1740)] = 77864,
  [SMALL_STATE(1741)] = 77925,
  [SMALL_STATE(1742)] = 77990,
  [SMALL_STATE(1743)] = 78061,
  [SMALL_STATE(1744)] = 78122,
  [SMALL_STATE(1745)] = 78193,
  [SMALL_STATE(1746)] = 78249,
  [SMALL_STATE(1747)] = 78317,
  [SMALL_STATE(1748)] = 78359,
  [SMALL_STATE(1749)] = 78427,
  [SMALL_STATE(1750)] = 78495,
  [SMALL_STATE(1751)] = 78563,
  [SMALL_STATE(1752)] = 78605,
  [SMALL_STATE(1753)] = 78680,
  [SMALL_STATE(1754)] = 78755,
  [SMALL_STATE(1755)] = 78830,
  [SMALL_STATE(1756)] = 78905,
  [SMALL_STATE(1757)] = 78980,
  [SMALL_STATE(1758)] = 79031,
  [SMALL_STATE(1759)] = 79082,
  [SMALL_STATE(1760)] = 79133,
  [SMALL_STATE(1761)] = 79184,
  [SMALL_STATE(1762)] = 79259,
  [SMALL_STATE(1763)] = 79310,
  [SMALL_STATE(1764)] = 79385,
  [SMALL_STATE(1765)] = 79460,
  [SMALL_STATE(1766)] = 79500,
  [SMALL_STATE(1767)] = 79540,
  [SMALL_STATE(1768)] = 79586,
  [SMALL_STATE(1769)] = 79626,
  [SMALL_STATE(1770)] = 79666,
  [SMALL_STATE(1771)] = 79706,
  [SMALL_STATE(1772)] = 79746,
  [SMALL_STATE(1773)] = 79803,
  [SMALL_STATE(1774)] = 79856,
  [SMALL_STATE(1775)] = 79909,
  [SMALL_STATE(1776)] = 79960,
  [SMALL_STATE(1777)] = 80015,
  [SMALL_STATE(1778)] = 80068,
  [SMALL_STATE(1779)] = 80123,
  [SMALL_STATE(1780)] = 80171,
  [SMALL_STATE(1781)] = 80219,
  [SMALL_STATE(1782)] = 80259,
  [SMALL_STATE(1783)] = 80307,
  [SMALL_STATE(1784)] = 80355,
  [SMALL_STATE(1785)] = 80403,
  [SMALL_STATE(1786)] = 80441,
  [SMALL_STATE(1787)] = 80479,
  [SMALL_STATE(1788)] = 80527,
  [SMALL_STATE(1789)] = 80565,
  [SMALL_STATE(1790)] = 80613,
  [SMALL_STATE(1791)] = 80661,
  [SMALL_STATE(1792)] = 80701,
  [SMALL_STATE(1793)] = 80739,
  [SMALL_STATE(1794)] = 80777,
  [SMALL_STATE(1795)] = 80825,
  [SMALL_STATE(1796)] = 80863,
  [SMALL_STATE(1797)] = 80901,
  [SMALL_STATE(1798)] = 80949,
  [SMALL_STATE(1799)] = 80987,
  [SMALL_STATE(1800)] = 81035,
  [SMALL_STATE(1801)] = 81073,
  [SMALL_STATE(1802)] = 81111,
  [SMALL_STATE(1803)] = 81159,
  [SMALL_STATE(1804)] = 81207,
  [SMALL_STATE(1805)] = 81255,
  [SMALL_STATE(1806)] = 81303,
  [SMALL_STATE(1807)] = 81341,
  [SMALL_STATE(1808)] = 81389,
  [SMALL_STATE(1809)] = 81427,
  [SMALL_STATE(1810)] = 81475,
  [SMALL_STATE(1811)] = 81515,
  [SMALL_STATE(1812)] = 81553,
  [SMALL_STATE(1813)] = 81591,
  [SMALL_STATE(1814)] = 81639,
  [SMALL_STATE(1815)] = 81696,
  [SMALL_STATE(1816)] = 81745,
  [SMALL_STATE(1817)] = 81794,
  [SMALL_STATE(1818)] = 81843,
  [SMALL_STATE(1819)] = 81892,
  [SMALL_STATE(1820)] = 81941,
  [SMALL_STATE(1821)] = 81990,
  [SMALL_STATE(1822)] = 82040,
  [SMALL_STATE(1823)] = 82090,
  [SMALL_STATE(1824)] = 82126,
  [SMALL_STATE(1825)] = 82180,
  [SMALL_STATE(1826)] = 82222,
  [SMALL_STATE(1827)] = 82276,
  [SMALL_STATE(1828)] = 82330,
  [SMALL_STATE(1829)] = 82368,
  [SMALL_STATE(1830)] = 82414,
  [SMALL_STATE(1831)] = 82457,
  [SMALL_STATE(1832)] = 82500,
  [SMALL_STATE(1833)] = 82543,
  [SMALL_STATE(1834)] = 82586,
  [SMALL_STATE(1835)] = 82629,
  [SMALL_STATE(1836)] = 82672,
  [SMALL_STATE(1837)] = 82715,
  [SMALL_STATE(1838)] = 82758,
  [SMALL_STATE(1839)] = 82801,
  [SMALL_STATE(1840)] = 82844,
  [SMALL_STATE(1841)] = 82887,
  [SMALL_STATE(1842)] = 82930,
  [SMALL_STATE(1843)] = 82973,
  [SMALL_STATE(1844)] = 83016,
  [SMALL_STATE(1845)] = 83059,
  [SMALL_STATE(1846)] = 83102,
  [SMALL_STATE(1847)] = 83145,
  [SMALL_STATE(1848)] = 83188,
  [SMALL_STATE(1849)] = 83231,
  [SMALL_STATE(1850)] = 83274,
  [SMALL_STATE(1851)] = 83317,
  [SMALL_STATE(1852)] = 83360,
  [SMALL_STATE(1853)] = 83403,
  [SMALL_STATE(1854)] = 83446,
  [SMALL_STATE(1855)] = 83480,
  [SMALL_STATE(1856)] = 83523,
  [SMALL_STATE(1857)] = 83557,
  [SMALL_STATE(1858)] = 83613,
  [SMALL_STATE(1859)] = 83669,
  [SMALL_STATE(1860)] = 83725,
  [SMALL_STATE(1861)] = 83749,
  [SMALL_STATE(1862)] = 83772,
  [SMALL_STATE(1863)] = 83795,
  [SMALL_STATE(1864)] = 83818,
  [SMALL_STATE(1865)] = 83841,
  [SMALL_STATE(1866)] = 83864,
  [SMALL_STATE(1867)] = 83895,
  [SMALL_STATE(1868)] = 83937,
  [SMALL_STATE(1869)] = 83979,
  [SMALL_STATE(1870)] = 84013,
  [SMALL_STATE(1871)] = 84055,
  [SMALL_STATE(1872)] = 84097,
  [SMALL_STATE(1873)] = 84139,
  [SMALL_STATE(1874)] = 84181,
  [SMALL_STATE(1875)] = 84211,
  [SMALL_STATE(1876)] = 84246,
  [SMALL_STATE(1877)] = 84281,
  [SMALL_STATE(1878)] = 84316,
  [SMALL_STATE(1879)] = 84357,
  [SMALL_STATE(1880)] = 84398,
  [SMALL_STATE(1881)] = 84433,
  [SMALL_STATE(1882)] = 84468,
  [SMALL_STATE(1883)] = 84503,
  [SMALL_STATE(1884)] = 84538,
  [SMALL_STATE(1885)] = 84573,
  [SMALL_STATE(1886)] = 84598,
  [SMALL_STATE(1887)] = 84634,
  [SMALL_STATE(1888)] = 84666,
  [SMALL_STATE(1889)] = 84704,
  [SMALL_STATE(1890)] = 84742,
  [SMALL_STATE(1891)] = 84774,
  [SMALL_STATE(1892)] = 84806,
  [SMALL_STATE(1893)] = 84842,
  [SMALL_STATE(1894)] = 84872,
  [SMALL_STATE(1895)] = 84904,
  [SMALL_STATE(1896)] = 84926,
  [SMALL_STATE(1897)] = 84958,
  [SMALL_STATE(1898)] = 84994,
  [SMALL_STATE(1899)] = 85032,
  [SMALL_STATE(1900)] = 85056,
  [SMALL_STATE(1901)] = 85092,
  [SMALL_STATE(1902)] = 85130,
  [SMALL_STATE(1903)] = 85162,
  [SMALL_STATE(1904)] = 85198,
  [SMALL_STATE(1905)] = 85234,
  [SMALL_STATE(1906)] = 85266,
  [SMALL_STATE(1907)] = 85304,
  [SMALL_STATE(1908)] = 85336,
  [SMALL_STATE(1909)] = 85358,
  [SMALL_STATE(1910)] = 85379,
  [SMALL_STATE(1911)] = 85402,
  [SMALL_STATE(1912)] = 85419,
  [SMALL_STATE(1913)] = 85440,
  [SMALL_STATE(1914)] = 85463,
  [SMALL_STATE(1915)] = 85486,
  [SMALL_STATE(1916)] = 85507,
  [SMALL_STATE(1917)] = 85528,
  [SMALL_STATE(1918)] = 85549,
  [SMALL_STATE(1919)] = 85572,
  [SMALL_STATE(1920)] = 85595,
  [SMALL_STATE(1921)] = 85612,
  [SMALL_STATE(1922)] = 85633,
  [SMALL_STATE(1923)] = 85652,
  [SMALL_STATE(1924)] = 85672,
  [SMALL_STATE(1925)] = 85706,
  [SMALL_STATE(1926)] = 85724,
  [SMALL_STATE(1927)] = 85758,
  [SMALL_STATE(1928)] = 85792,
  [SMALL_STATE(1929)] = 85810,
  [SMALL_STATE(1930)] = 85842,
  [SMALL_STATE(1931)] = 85876,
  [SMALL_STATE(1932)] = 85894,
  [SMALL_STATE(1933)] = 85912,
  [SMALL_STATE(1934)] = 85930,
  [SMALL_STATE(1935)] = 85948,
  [SMALL_STATE(1936)] = 85966,
  [SMALL_STATE(1937)] = 85984,
  [SMALL_STATE(1938)] = 86004,
  [SMALL_STATE(1939)] = 86022,
  [SMALL_STATE(1940)] = 86040,
  [SMALL_STATE(1941)] = 86058,
  [SMALL_STATE(1942)] = 86076,
  [SMALL_STATE(1943)] = 86094,
  [SMALL_STATE(1944)] = 86112,
  [SMALL_STATE(1945)] = 86130,
  [SMALL_STATE(1946)] = 86162,
  [SMALL_STATE(1947)] = 86196,
  [SMALL_STATE(1948)] = 86214,
  [SMALL_STATE(1949)] = 86232,
  [SMALL_STATE(1950)] = 86266,
  [SMALL_STATE(1951)] = 86284,
  [SMALL_STATE(1952)] = 86302,
  [SMALL_STATE(1953)] = 86322,
  [SMALL_STATE(1954)] = 86342,
  [SMALL_STATE(1955)] = 86360,
  [SMALL_STATE(1956)] = 86394,
  [SMALL_STATE(1957)] = 86426,
  [SMALL_STATE(1958)] = 86460,
  [SMALL_STATE(1959)] = 86480,
  [SMALL_STATE(1960)] = 86506,
  [SMALL_STATE(1961)] = 86532,
  [SMALL_STATE(1962)] = 86564,
  [SMALL_STATE(1963)] = 86582,
  [SMALL_STATE(1964)] = 86616,
  [SMALL_STATE(1965)] = 86650,
  [SMALL_STATE(1966)] = 86668,
  [SMALL_STATE(1967)] = 86688,
  [SMALL_STATE(1968)] = 86720,
  [SMALL_STATE(1969)] = 86740,
  [SMALL_STATE(1970)] = 86760,
  [SMALL_STATE(1971)] = 86778,
  [SMALL_STATE(1972)] = 86796,
  [SMALL_STATE(1973)] = 86814,
  [SMALL_STATE(1974)] = 86844,
  [SMALL_STATE(1975)] = 86873,
  [SMALL_STATE(1976)] = 86898,
  [SMALL_STATE(1977)] = 86929,
  [SMALL_STATE(1978)] = 86958,
  [SMALL_STATE(1979)] = 86989,
  [SMALL_STATE(1980)] = 87014,
  [SMALL_STATE(1981)] = 87045,
  [SMALL_STATE(1982)] = 87074,
  [SMALL_STATE(1983)] = 87103,
  [SMALL_STATE(1984)] = 87134,
  [SMALL_STATE(1985)] = 87165,
  [SMALL_STATE(1986)] = 87190,
  [SMALL_STATE(1987)] = 87215,
  [SMALL_STATE(1988)] = 87240,
  [SMALL_STATE(1989)] = 87271,
  [SMALL_STATE(1990)] = 87300,
  [SMALL_STATE(1991)] = 87325,
  [SMALL_STATE(1992)] = 87356,
  [SMALL_STATE(1993)] = 87387,
  [SMALL_STATE(1994)] = 87412,
  [SMALL_STATE(1995)] = 87441,
  [SMALL_STATE(1996)] = 87466,
  [SMALL_STATE(1997)] = 87497,
  [SMALL_STATE(1998)] = 87528,
  [SMALL_STATE(1999)] = 87559,
  [SMALL_STATE(2000)] = 87588,
  [SMALL_STATE(2001)] = 87613,
  [SMALL_STATE(2002)] = 87638,
  [SMALL_STATE(2003)] = 87669,
  [SMALL_STATE(2004)] = 87694,
  [SMALL_STATE(2005)] = 87719,
  [SMALL_STATE(2006)] = 87750,
  [SMALL_STATE(2007)] = 87779,
  [SMALL_STATE(2008)] = 87810,
  [SMALL_STATE(2009)] = 87839,
  [SMALL_STATE(2010)] = 87862,
  [SMALL_STATE(2011)] = 87881,
  [SMALL_STATE(2012)] = 87912,
  [SMALL_STATE(2013)] = 87943,
  [SMALL_STATE(2014)] = 87972,
  [SMALL_STATE(2015)] = 88001,
  [SMALL_STATE(2016)] = 88023,
  [SMALL_STATE(2017)] = 88049,
  [SMALL_STATE(2018)] = 88071,
  [SMALL_STATE(2019)] = 88089,
  [SMALL_STATE(2020)] = 88111,
  [SMALL_STATE(2021)] = 88133,
  [SMALL_STATE(2022)] = 88155,
  [SMALL_STATE(2023)] = 88177,
  [SMALL_STATE(2024)] = 88193,
  [SMALL_STATE(2025)] = 88215,
  [SMALL_STATE(2026)] = 88237,
  [SMALL_STATE(2027)] = 88259,
  [SMALL_STATE(2028)] = 88281,
  [SMALL_STATE(2029)] = 88303,
  [SMALL_STATE(2030)] = 88321,
  [SMALL_STATE(2031)] = 88341,
  [SMALL_STATE(2032)] = 88359,
  [SMALL_STATE(2033)] = 88381,
  [SMALL_STATE(2034)] = 88403,
  [SMALL_STATE(2035)] = 88421,
  [SMALL_STATE(2036)] = 88447,
  [SMALL_STATE(2037)] = 88469,
  [SMALL_STATE(2038)] = 88490,
  [SMALL_STATE(2039)] = 88515,
  [SMALL_STATE(2040)] = 88540,
  [SMALL_STATE(2041)] = 88565,
  [SMALL_STATE(2042)] = 88590,
  [SMALL_STATE(2043)] = 88615,
  [SMALL_STATE(2044)] = 88640,
  [SMALL_STATE(2045)] = 88657,
  [SMALL_STATE(2046)] = 88670,
  [SMALL_STATE(2047)] = 88685,
  [SMALL_STATE(2048)] = 88706,
  [SMALL_STATE(2049)] = 88731,
  [SMALL_STATE(2050)] = 88756,
  [SMALL_STATE(2051)] = 88771,
  [SMALL_STATE(2052)] = 88792,
  [SMALL_STATE(2053)] = 88809,
  [SMALL_STATE(2054)] = 88826,
  [SMALL_STATE(2055)] = 88839,
  [SMALL_STATE(2056)] = 88864,
  [SMALL_STATE(2057)] = 88881,
  [SMALL_STATE(2058)] = 88906,
  [SMALL_STATE(2059)] = 88931,
  [SMALL_STATE(2060)] = 88956,
  [SMALL_STATE(2061)] = 88981,
  [SMALL_STATE(2062)] = 89006,
  [SMALL_STATE(2063)] = 89031,
  [SMALL_STATE(2064)] = 89056,
  [SMALL_STATE(2065)] = 89073,
  [SMALL_STATE(2066)] = 89094,
  [SMALL_STATE(2067)] = 89119,
  [SMALL_STATE(2068)] = 89140,
  [SMALL_STATE(2069)] = 89161,
  [SMALL_STATE(2070)] = 89182,
  [SMALL_STATE(2071)] = 89199,
  [SMALL_STATE(2072)] = 89216,
  [SMALL_STATE(2073)] = 89237,
  [SMALL_STATE(2074)] = 89250,
  [SMALL_STATE(2075)] = 89267,
  [SMALL_STATE(2076)] = 89284,
  [SMALL_STATE(2077)] = 89307,
  [SMALL_STATE(2078)] = 89332,
  [SMALL_STATE(2079)] = 89357,
  [SMALL_STATE(2080)] = 89382,
  [SMALL_STATE(2081)] = 89399,
  [SMALL_STATE(2082)] = 89412,
  [SMALL_STATE(2083)] = 89437,
  [SMALL_STATE(2084)] = 89462,
  [SMALL_STATE(2085)] = 89487,
  [SMALL_STATE(2086)] = 89504,
  [SMALL_STATE(2087)] = 89529,
  [SMALL_STATE(2088)] = 89554,
  [SMALL_STATE(2089)] = 89579,
  [SMALL_STATE(2090)] = 89604,
  [SMALL_STATE(2091)] = 89629,
  [SMALL_STATE(2092)] = 89654,
  [SMALL_STATE(2093)] = 89671,
  [SMALL_STATE(2094)] = 89684,
  [SMALL_STATE(2095)] = 89709,
  [SMALL_STATE(2096)] = 89734,
  [SMALL_STATE(2097)] = 89759,
  [SMALL_STATE(2098)] = 89784,
  [SMALL_STATE(2099)] = 89801,
  [SMALL_STATE(2100)] = 89820,
  [SMALL_STATE(2101)] = 89845,
  [SMALL_STATE(2102)] = 89862,
  [SMALL_STATE(2103)] = 89887,
  [SMALL_STATE(2104)] = 89906,
  [SMALL_STATE(2105)] = 89923,
  [SMALL_STATE(2106)] = 89940,
  [SMALL_STATE(2107)] = 89965,
  [SMALL_STATE(2108)] = 89982,
  [SMALL_STATE(2109)] = 90007,
  [SMALL_STATE(2110)] = 90032,
  [SMALL_STATE(2111)] = 90057,
  [SMALL_STATE(2112)] = 90074,
  [SMALL_STATE(2113)] = 90099,
  [SMALL_STATE(2114)] = 90124,
  [SMALL_STATE(2115)] = 90146,
  [SMALL_STATE(2116)] = 90164,
  [SMALL_STATE(2117)] = 90180,
  [SMALL_STATE(2118)] = 90196,
  [SMALL_STATE(2119)] = 90212,
  [SMALL_STATE(2120)] = 90234,
  [SMALL_STATE(2121)] = 90250,
  [SMALL_STATE(2122)] = 90272,
  [SMALL_STATE(2123)] = 90294,
  [SMALL_STATE(2124)] = 90310,
  [SMALL_STATE(2125)] = 90332,
  [SMALL_STATE(2126)] = 90348,
  [SMALL_STATE(2127)] = 90364,
  [SMALL_STATE(2128)] = 90384,
  [SMALL_STATE(2129)] = 90406,
  [SMALL_STATE(2130)] = 90428,
  [SMALL_STATE(2131)] = 90446,
  [SMALL_STATE(2132)] = 90462,
  [SMALL_STATE(2133)] = 90484,
  [SMALL_STATE(2134)] = 90506,
  [SMALL_STATE(2135)] = 90528,
  [SMALL_STATE(2136)] = 90544,
  [SMALL_STATE(2137)] = 90560,
  [SMALL_STATE(2138)] = 90582,
  [SMALL_STATE(2139)] = 90598,
  [SMALL_STATE(2140)] = 90620,
  [SMALL_STATE(2141)] = 90636,
  [SMALL_STATE(2142)] = 90652,
  [SMALL_STATE(2143)] = 90670,
  [SMALL_STATE(2144)] = 90692,
  [SMALL_STATE(2145)] = 90714,
  [SMALL_STATE(2146)] = 90732,
  [SMALL_STATE(2147)] = 90752,
  [SMALL_STATE(2148)] = 90774,
  [SMALL_STATE(2149)] = 90796,
  [SMALL_STATE(2150)] = 90818,
  [SMALL_STATE(2151)] = 90840,
  [SMALL_STATE(2152)] = 90862,
  [SMALL_STATE(2153)] = 90878,
  [SMALL_STATE(2154)] = 90894,
  [SMALL_STATE(2155)] = 90912,
  [SMALL_STATE(2156)] = 90932,
  [SMALL_STATE(2157)] = 90954,
  [SMALL_STATE(2158)] = 90976,
  [SMALL_STATE(2159)] = 90998,
  [SMALL_STATE(2160)] = 91020,
  [SMALL_STATE(2161)] = 91042,
  [SMALL_STATE(2162)] = 91064,
  [SMALL_STATE(2163)] = 91076,
  [SMALL_STATE(2164)] = 91092,
  [SMALL_STATE(2165)] = 91104,
  [SMALL_STATE(2166)] = 91126,
  [SMALL_STATE(2167)] = 91142,
  [SMALL_STATE(2168)] = 91164,
  [SMALL_STATE(2169)] = 91186,
  [SMALL_STATE(2170)] = 91202,
  [SMALL_STATE(2171)] = 91224,
  [SMALL_STATE(2172)] = 91240,
  [SMALL_STATE(2173)] = 91256,
  [SMALL_STATE(2174)] = 91274,
  [SMALL_STATE(2175)] = 91290,
  [SMALL_STATE(2176)] = 91306,
  [SMALL_STATE(2177)] = 91326,
  [SMALL_STATE(2178)] = 91340,
  [SMALL_STATE(2179)] = 91362,
  [SMALL_STATE(2180)] = 91384,
  [SMALL_STATE(2181)] = 91406,
  [SMALL_STATE(2182)] = 91428,
  [SMALL_STATE(2183)] = 91446,
  [SMALL_STATE(2184)] = 91468,
  [SMALL_STATE(2185)] = 91490,
  [SMALL_STATE(2186)] = 91506,
  [SMALL_STATE(2187)] = 91528,
  [SMALL_STATE(2188)] = 91546,
  [SMALL_STATE(2189)] = 91568,
  [SMALL_STATE(2190)] = 91590,
  [SMALL_STATE(2191)] = 91608,
  [SMALL_STATE(2192)] = 91630,
  [SMALL_STATE(2193)] = 91652,
  [SMALL_STATE(2194)] = 91664,
  [SMALL_STATE(2195)] = 91686,
  [SMALL_STATE(2196)] = 91708,
  [SMALL_STATE(2197)] = 91730,
  [SMALL_STATE(2198)] = 91752,
  [SMALL_STATE(2199)] = 91774,
  [SMALL_STATE(2200)] = 91786,
  [SMALL_STATE(2201)] = 91804,
  [SMALL_STATE(2202)] = 91826,
  [SMALL_STATE(2203)] = 91848,
  [SMALL_STATE(2204)] = 91859,
  [SMALL_STATE(2205)] = 91878,
  [SMALL_STATE(2206)] = 91897,
  [SMALL_STATE(2207)] = 91916,
  [SMALL_STATE(2208)] = 91935,
  [SMALL_STATE(2209)] = 91948,
  [SMALL_STATE(2210)] = 91967,
  [SMALL_STATE(2211)] = 91978,
  [SMALL_STATE(2212)] = 91989,
  [SMALL_STATE(2213)] = 92000,
  [SMALL_STATE(2214)] = 92011,
  [SMALL_STATE(2215)] = 92022,
  [SMALL_STATE(2216)] = 92033,
  [SMALL_STATE(2217)] = 92044,
  [SMALL_STATE(2218)] = 92063,
  [SMALL_STATE(2219)] = 92074,
  [SMALL_STATE(2220)] = 92085,
  [SMALL_STATE(2221)] = 92096,
  [SMALL_STATE(2222)] = 92111,
  [SMALL_STATE(2223)] = 92130,
  [SMALL_STATE(2224)] = 92149,
  [SMALL_STATE(2225)] = 92168,
  [SMALL_STATE(2226)] = 92183,
  [SMALL_STATE(2227)] = 92194,
  [SMALL_STATE(2228)] = 92213,
  [SMALL_STATE(2229)] = 92224,
  [SMALL_STATE(2230)] = 92235,
  [SMALL_STATE(2231)] = 92246,
  [SMALL_STATE(2232)] = 92265,
  [SMALL_STATE(2233)] = 92284,
  [SMALL_STATE(2234)] = 92301,
  [SMALL_STATE(2235)] = 92320,
  [SMALL_STATE(2236)] = 92331,
  [SMALL_STATE(2237)] = 92350,
  [SMALL_STATE(2238)] = 92361,
  [SMALL_STATE(2239)] = 92380,
  [SMALL_STATE(2240)] = 92399,
  [SMALL_STATE(2241)] = 92418,
  [SMALL_STATE(2242)] = 92429,
  [SMALL_STATE(2243)] = 92440,
  [SMALL_STATE(2244)] = 92459,
  [SMALL_STATE(2245)] = 92470,
  [SMALL_STATE(2246)] = 92481,
  [SMALL_STATE(2247)] = 92500,
  [SMALL_STATE(2248)] = 92511,
  [SMALL_STATE(2249)] = 92530,
  [SMALL_STATE(2250)] = 92541,
  [SMALL_STATE(2251)] = 92560,
  [SMALL_STATE(2252)] = 92571,
  [SMALL_STATE(2253)] = 92582,
  [SMALL_STATE(2254)] = 92601,
  [SMALL_STATE(2255)] = 92612,
  [SMALL_STATE(2256)] = 92631,
  [SMALL_STATE(2257)] = 92642,
  [SMALL_STATE(2258)] = 92657,
  [SMALL_STATE(2259)] = 92676,
  [SMALL_STATE(2260)] = 92687,
  [SMALL_STATE(2261)] = 92700,
  [SMALL_STATE(2262)] = 92711,
  [SMALL_STATE(2263)] = 92730,
  [SMALL_STATE(2264)] = 92743,
  [SMALL_STATE(2265)] = 92762,
  [SMALL_STATE(2266)] = 92781,
  [SMALL_STATE(2267)] = 92792,
  [SMALL_STATE(2268)] = 92811,
  [SMALL_STATE(2269)] = 92830,
  [SMALL_STATE(2270)] = 92841,
  [SMALL_STATE(2271)] = 92860,
  [SMALL_STATE(2272)] = 92871,
  [SMALL_STATE(2273)] = 92882,
  [SMALL_STATE(2274)] = 92901,
  [SMALL_STATE(2275)] = 92916,
  [SMALL_STATE(2276)] = 92935,
  [SMALL_STATE(2277)] = 92950,
  [SMALL_STATE(2278)] = 92969,
  [SMALL_STATE(2279)] = 92980,
  [SMALL_STATE(2280)] = 92991,
  [SMALL_STATE(2281)] = 93002,
  [SMALL_STATE(2282)] = 93013,
  [SMALL_STATE(2283)] = 93032,
  [SMALL_STATE(2284)] = 93043,
  [SMALL_STATE(2285)] = 93060,
  [SMALL_STATE(2286)] = 93071,
  [SMALL_STATE(2287)] = 93082,
  [SMALL_STATE(2288)] = 93093,
  [SMALL_STATE(2289)] = 93104,
  [SMALL_STATE(2290)] = 93115,
  [SMALL_STATE(2291)] = 93126,
  [SMALL_STATE(2292)] = 93145,
  [SMALL_STATE(2293)] = 93156,
  [SMALL_STATE(2294)] = 93175,
  [SMALL_STATE(2295)] = 93186,
  [SMALL_STATE(2296)] = 93205,
  [SMALL_STATE(2297)] = 93216,
  [SMALL_STATE(2298)] = 93227,
  [SMALL_STATE(2299)] = 93246,
  [SMALL_STATE(2300)] = 93257,
  [SMALL_STATE(2301)] = 93268,
  [SMALL_STATE(2302)] = 93283,
  [SMALL_STATE(2303)] = 93294,
  [SMALL_STATE(2304)] = 93305,
  [SMALL_STATE(2305)] = 93316,
  [SMALL_STATE(2306)] = 93327,
  [SMALL_STATE(2307)] = 93338,
  [SMALL_STATE(2308)] = 93357,
  [SMALL_STATE(2309)] = 93368,
  [SMALL_STATE(2310)] = 93387,
  [SMALL_STATE(2311)] = 93398,
  [SMALL_STATE(2312)] = 93413,
  [SMALL_STATE(2313)] = 93430,
  [SMALL_STATE(2314)] = 93449,
  [SMALL_STATE(2315)] = 93464,
  [SMALL_STATE(2316)] = 93483,
  [SMALL_STATE(2317)] = 93502,
  [SMALL_STATE(2318)] = 93521,
  [SMALL_STATE(2319)] = 93532,
  [SMALL_STATE(2320)] = 93551,
  [SMALL_STATE(2321)] = 93566,
  [SMALL_STATE(2322)] = 93585,
  [SMALL_STATE(2323)] = 93602,
  [SMALL_STATE(2324)] = 93621,
  [SMALL_STATE(2325)] = 93632,
  [SMALL_STATE(2326)] = 93643,
  [SMALL_STATE(2327)] = 93662,
  [SMALL_STATE(2328)] = 93681,
  [SMALL_STATE(2329)] = 93694,
  [SMALL_STATE(2330)] = 93707,
  [SMALL_STATE(2331)] = 93726,
  [SMALL_STATE(2332)] = 93745,
  [SMALL_STATE(2333)] = 93764,
  [SMALL_STATE(2334)] = 93779,
  [SMALL_STATE(2335)] = 93798,
  [SMALL_STATE(2336)] = 93809,
  [SMALL_STATE(2337)] = 93822,
  [SMALL_STATE(2338)] = 93841,
  [SMALL_STATE(2339)] = 93852,
  [SMALL_STATE(2340)] = 93863,
  [SMALL_STATE(2341)] = 93882,
  [SMALL_STATE(2342)] = 93897,
  [SMALL_STATE(2343)] = 93916,
  [SMALL_STATE(2344)] = 93927,
  [SMALL_STATE(2345)] = 93938,
  [SMALL_STATE(2346)] = 93957,
  [SMALL_STATE(2347)] = 93972,
  [SMALL_STATE(2348)] = 93991,
  [SMALL_STATE(2349)] = 94010,
  [SMALL_STATE(2350)] = 94029,
  [SMALL_STATE(2351)] = 94042,
  [SMALL_STATE(2352)] = 94057,
  [SMALL_STATE(2353)] = 94068,
  [SMALL_STATE(2354)] = 94087,
  [SMALL_STATE(2355)] = 94106,
  [SMALL_STATE(2356)] = 94125,
  [SMALL_STATE(2357)] = 94140,
  [SMALL_STATE(2358)] = 94151,
  [SMALL_STATE(2359)] = 94162,
  [SMALL_STATE(2360)] = 94177,
  [SMALL_STATE(2361)] = 94192,
  [SMALL_STATE(2362)] = 94211,
  [SMALL_STATE(2363)] = 94222,
  [SMALL_STATE(2364)] = 94237,
  [SMALL_STATE(2365)] = 94248,
  [SMALL_STATE(2366)] = 94261,
  [SMALL_STATE(2367)] = 94276,
  [SMALL_STATE(2368)] = 94287,
  [SMALL_STATE(2369)] = 94304,
  [SMALL_STATE(2370)] = 94315,
  [SMALL_STATE(2371)] = 94326,
  [SMALL_STATE(2372)] = 94337,
  [SMALL_STATE(2373)] = 94348,
  [SMALL_STATE(2374)] = 94359,
  [SMALL_STATE(2375)] = 94372,
  [SMALL_STATE(2376)] = 94391,
  [SMALL_STATE(2377)] = 94402,
  [SMALL_STATE(2378)] = 94421,
  [SMALL_STATE(2379)] = 94432,
  [SMALL_STATE(2380)] = 94445,
  [SMALL_STATE(2381)] = 94458,
  [SMALL_STATE(2382)] = 94469,
  [SMALL_STATE(2383)] = 94484,
  [SMALL_STATE(2384)] = 94495,
  [SMALL_STATE(2385)] = 94506,
  [SMALL_STATE(2386)] = 94525,
  [SMALL_STATE(2387)] = 94540,
  [SMALL_STATE(2388)] = 94555,
  [SMALL_STATE(2389)] = 94574,
  [SMALL_STATE(2390)] = 94593,
  [SMALL_STATE(2391)] = 94606,
  [SMALL_STATE(2392)] = 94625,
  [SMALL_STATE(2393)] = 94644,
  [SMALL_STATE(2394)] = 94663,
  [SMALL_STATE(2395)] = 94674,
  [SMALL_STATE(2396)] = 94687,
  [SMALL_STATE(2397)] = 94698,
  [SMALL_STATE(2398)] = 94709,
  [SMALL_STATE(2399)] = 94720,
  [SMALL_STATE(2400)] = 94739,
  [SMALL_STATE(2401)] = 94758,
  [SMALL_STATE(2402)] = 94771,
  [SMALL_STATE(2403)] = 94782,
  [SMALL_STATE(2404)] = 94793,
  [SMALL_STATE(2405)] = 94808,
  [SMALL_STATE(2406)] = 94823,
  [SMALL_STATE(2407)] = 94838,
  [SMALL_STATE(2408)] = 94853,
  [SMALL_STATE(2409)] = 94864,
  [SMALL_STATE(2410)] = 94883,
  [SMALL_STATE(2411)] = 94894,
  [SMALL_STATE(2412)] = 94905,
  [SMALL_STATE(2413)] = 94924,
  [SMALL_STATE(2414)] = 94939,
  [SMALL_STATE(2415)] = 94958,
  [SMALL_STATE(2416)] = 94969,
  [SMALL_STATE(2417)] = 94984,
  [SMALL_STATE(2418)] = 94995,
  [SMALL_STATE(2419)] = 95014,
  [SMALL_STATE(2420)] = 95033,
  [SMALL_STATE(2421)] = 95048,
  [SMALL_STATE(2422)] = 95067,
  [SMALL_STATE(2423)] = 95082,
  [SMALL_STATE(2424)] = 95101,
  [SMALL_STATE(2425)] = 95116,
  [SMALL_STATE(2426)] = 95127,
  [SMALL_STATE(2427)] = 95140,
  [SMALL_STATE(2428)] = 95159,
  [SMALL_STATE(2429)] = 95174,
  [SMALL_STATE(2430)] = 95185,
  [SMALL_STATE(2431)] = 95204,
  [SMALL_STATE(2432)] = 95217,
  [SMALL_STATE(2433)] = 95228,
  [SMALL_STATE(2434)] = 95239,
  [SMALL_STATE(2435)] = 95250,
  [SMALL_STATE(2436)] = 95265,
  [SMALL_STATE(2437)] = 95276,
  [SMALL_STATE(2438)] = 95287,
  [SMALL_STATE(2439)] = 95306,
  [SMALL_STATE(2440)] = 95317,
  [SMALL_STATE(2441)] = 95336,
  [SMALL_STATE(2442)] = 95347,
  [SMALL_STATE(2443)] = 95366,
  [SMALL_STATE(2444)] = 95377,
  [SMALL_STATE(2445)] = 95390,
  [SMALL_STATE(2446)] = 95401,
  [SMALL_STATE(2447)] = 95412,
  [SMALL_STATE(2448)] = 95425,
  [SMALL_STATE(2449)] = 95438,
  [SMALL_STATE(2450)] = 95452,
  [SMALL_STATE(2451)] = 95466,
  [SMALL_STATE(2452)] = 95480,
  [SMALL_STATE(2453)] = 95496,
  [SMALL_STATE(2454)] = 95512,
  [SMALL_STATE(2455)] = 95528,
  [SMALL_STATE(2456)] = 95544,
  [SMALL_STATE(2457)] = 95560,
  [SMALL_STATE(2458)] = 95574,
  [SMALL_STATE(2459)] = 95590,
  [SMALL_STATE(2460)] = 95606,
  [SMALL_STATE(2461)] = 95622,
  [SMALL_STATE(2462)] = 95638,
  [SMALL_STATE(2463)] = 95654,
  [SMALL_STATE(2464)] = 95668,
  [SMALL_STATE(2465)] = 95684,
  [SMALL_STATE(2466)] = 95698,
  [SMALL_STATE(2467)] = 95714,
  [SMALL_STATE(2468)] = 95730,
  [SMALL_STATE(2469)] = 95744,
  [SMALL_STATE(2470)] = 95758,
  [SMALL_STATE(2471)] = 95772,
  [SMALL_STATE(2472)] = 95788,
  [SMALL_STATE(2473)] = 95802,
  [SMALL_STATE(2474)] = 95818,
  [SMALL_STATE(2475)] = 95834,
  [SMALL_STATE(2476)] = 95850,
  [SMALL_STATE(2477)] = 95864,
  [SMALL_STATE(2478)] = 95880,
  [SMALL_STATE(2479)] = 95894,
  [SMALL_STATE(2480)] = 95910,
  [SMALL_STATE(2481)] = 95920,
  [SMALL_STATE(2482)] = 95936,
  [SMALL_STATE(2483)] = 95950,
  [SMALL_STATE(2484)] = 95966,
  [SMALL_STATE(2485)] = 95982,
  [SMALL_STATE(2486)] = 95996,
  [SMALL_STATE(2487)] = 96012,
  [SMALL_STATE(2488)] = 96026,
  [SMALL_STATE(2489)] = 96042,
  [SMALL_STATE(2490)] = 96058,
  [SMALL_STATE(2491)] = 96072,
  [SMALL_STATE(2492)] = 96086,
  [SMALL_STATE(2493)] = 96102,
  [SMALL_STATE(2494)] = 96118,
  [SMALL_STATE(2495)] = 96134,
  [SMALL_STATE(2496)] = 96148,
  [SMALL_STATE(2497)] = 96162,
  [SMALL_STATE(2498)] = 96178,
  [SMALL_STATE(2499)] = 96194,
  [SMALL_STATE(2500)] = 96210,
  [SMALL_STATE(2501)] = 96226,
  [SMALL_STATE(2502)] = 96240,
  [SMALL_STATE(2503)] = 96254,
  [SMALL_STATE(2504)] = 96268,
  [SMALL_STATE(2505)] = 96282,
  [SMALL_STATE(2506)] = 96296,
  [SMALL_STATE(2507)] = 96312,
  [SMALL_STATE(2508)] = 96326,
  [SMALL_STATE(2509)] = 96342,
  [SMALL_STATE(2510)] = 96356,
  [SMALL_STATE(2511)] = 96372,
  [SMALL_STATE(2512)] = 96388,
  [SMALL_STATE(2513)] = 96404,
  [SMALL_STATE(2514)] = 96418,
  [SMALL_STATE(2515)] = 96434,
  [SMALL_STATE(2516)] = 96450,
  [SMALL_STATE(2517)] = 96466,
  [SMALL_STATE(2518)] = 96482,
  [SMALL_STATE(2519)] = 96498,
  [SMALL_STATE(2520)] = 96512,
  [SMALL_STATE(2521)] = 96526,
  [SMALL_STATE(2522)] = 96540,
  [SMALL_STATE(2523)] = 96554,
  [SMALL_STATE(2524)] = 96570,
  [SMALL_STATE(2525)] = 96584,
  [SMALL_STATE(2526)] = 96600,
  [SMALL_STATE(2527)] = 96616,
  [SMALL_STATE(2528)] = 96630,
  [SMALL_STATE(2529)] = 96646,
  [SMALL_STATE(2530)] = 96660,
  [SMALL_STATE(2531)] = 96672,
  [SMALL_STATE(2532)] = 96684,
  [SMALL_STATE(2533)] = 96698,
  [SMALL_STATE(2534)] = 96714,
  [SMALL_STATE(2535)] = 96724,
  [SMALL_STATE(2536)] = 96740,
  [SMALL_STATE(2537)] = 96754,
  [SMALL_STATE(2538)] = 96770,
  [SMALL_STATE(2539)] = 96786,
  [SMALL_STATE(2540)] = 96802,
  [SMALL_STATE(2541)] = 96818,
  [SMALL_STATE(2542)] = 96832,
  [SMALL_STATE(2543)] = 96846,
  [SMALL_STATE(2544)] = 96860,
  [SMALL_STATE(2545)] = 96874,
  [SMALL_STATE(2546)] = 96890,
  [SMALL_STATE(2547)] = 96904,
  [SMALL_STATE(2548)] = 96918,
  [SMALL_STATE(2549)] = 96932,
  [SMALL_STATE(2550)] = 96948,
  [SMALL_STATE(2551)] = 96964,
  [SMALL_STATE(2552)] = 96973,
  [SMALL_STATE(2553)] = 96986,
  [SMALL_STATE(2554)] = 96999,
  [SMALL_STATE(2555)] = 97012,
  [SMALL_STATE(2556)] = 97021,
  [SMALL_STATE(2557)] = 97034,
  [SMALL_STATE(2558)] = 97043,
  [SMALL_STATE(2559)] = 97052,
  [SMALL_STATE(2560)] = 97061,
  [SMALL_STATE(2561)] = 97072,
  [SMALL_STATE(2562)] = 97081,
  [SMALL_STATE(2563)] = 97090,
  [SMALL_STATE(2564)] = 97103,
  [SMALL_STATE(2565)] = 97116,
  [SMALL_STATE(2566)] = 97125,
  [SMALL_STATE(2567)] = 97138,
  [SMALL_STATE(2568)] = 97147,
  [SMALL_STATE(2569)] = 97156,
  [SMALL_STATE(2570)] = 97165,
  [SMALL_STATE(2571)] = 97178,
  [SMALL_STATE(2572)] = 97189,
  [SMALL_STATE(2573)] = 97198,
  [SMALL_STATE(2574)] = 97211,
  [SMALL_STATE(2575)] = 97224,
  [SMALL_STATE(2576)] = 97237,
  [SMALL_STATE(2577)] = 97246,
  [SMALL_STATE(2578)] = 97255,
  [SMALL_STATE(2579)] = 97264,
  [SMALL_STATE(2580)] = 97273,
  [SMALL_STATE(2581)] = 97286,
  [SMALL_STATE(2582)] = 97295,
  [SMALL_STATE(2583)] = 97304,
  [SMALL_STATE(2584)] = 97317,
  [SMALL_STATE(2585)] = 97326,
  [SMALL_STATE(2586)] = 97339,
  [SMALL_STATE(2587)] = 97348,
  [SMALL_STATE(2588)] = 97361,
  [SMALL_STATE(2589)] = 97370,
  [SMALL_STATE(2590)] = 97383,
  [SMALL_STATE(2591)] = 97396,
  [SMALL_STATE(2592)] = 97409,
  [SMALL_STATE(2593)] = 97418,
  [SMALL_STATE(2594)] = 97431,
  [SMALL_STATE(2595)] = 97444,
  [SMALL_STATE(2596)] = 97457,
  [SMALL_STATE(2597)] = 97470,
  [SMALL_STATE(2598)] = 97483,
  [SMALL_STATE(2599)] = 97494,
  [SMALL_STATE(2600)] = 97507,
  [SMALL_STATE(2601)] = 97516,
  [SMALL_STATE(2602)] = 97525,
  [SMALL_STATE(2603)] = 97538,
  [SMALL_STATE(2604)] = 97551,
  [SMALL_STATE(2605)] = 97560,
  [SMALL_STATE(2606)] = 97573,
  [SMALL_STATE(2607)] = 97586,
  [SMALL_STATE(2608)] = 97595,
  [SMALL_STATE(2609)] = 97608,
  [SMALL_STATE(2610)] = 97619,
  [SMALL_STATE(2611)] = 97632,
  [SMALL_STATE(2612)] = 97645,
  [SMALL_STATE(2613)] = 97658,
  [SMALL_STATE(2614)] = 97671,
  [SMALL_STATE(2615)] = 97684,
  [SMALL_STATE(2616)] = 97697,
  [SMALL_STATE(2617)] = 97706,
  [SMALL_STATE(2618)] = 97715,
  [SMALL_STATE(2619)] = 97724,
  [SMALL_STATE(2620)] = 97737,
  [SMALL_STATE(2621)] = 97750,
  [SMALL_STATE(2622)] = 97763,
  [SMALL_STATE(2623)] = 97774,
  [SMALL_STATE(2624)] = 97787,
  [SMALL_STATE(2625)] = 97800,
  [SMALL_STATE(2626)] = 97813,
  [SMALL_STATE(2627)] = 97826,
  [SMALL_STATE(2628)] = 97835,
  [SMALL_STATE(2629)] = 97846,
  [SMALL_STATE(2630)] = 97859,
  [SMALL_STATE(2631)] = 97872,
  [SMALL_STATE(2632)] = 97885,
  [SMALL_STATE(2633)] = 97898,
  [SMALL_STATE(2634)] = 97911,
  [SMALL_STATE(2635)] = 97924,
  [SMALL_STATE(2636)] = 97933,
  [SMALL_STATE(2637)] = 97946,
  [SMALL_STATE(2638)] = 97955,
  [SMALL_STATE(2639)] = 97968,
  [SMALL_STATE(2640)] = 97981,
  [SMALL_STATE(2641)] = 97994,
  [SMALL_STATE(2642)] = 98007,
  [SMALL_STATE(2643)] = 98020,
  [SMALL_STATE(2644)] = 98033,
  [SMALL_STATE(2645)] = 98046,
  [SMALL_STATE(2646)] = 98059,
  [SMALL_STATE(2647)] = 98072,
  [SMALL_STATE(2648)] = 98085,
  [SMALL_STATE(2649)] = 98098,
  [SMALL_STATE(2650)] = 98111,
  [SMALL_STATE(2651)] = 98120,
  [SMALL_STATE(2652)] = 98129,
  [SMALL_STATE(2653)] = 98142,
  [SMALL_STATE(2654)] = 98151,
  [SMALL_STATE(2655)] = 98164,
  [SMALL_STATE(2656)] = 98173,
  [SMALL_STATE(2657)] = 98186,
  [SMALL_STATE(2658)] = 98199,
  [SMALL_STATE(2659)] = 98212,
  [SMALL_STATE(2660)] = 98225,
  [SMALL_STATE(2661)] = 98238,
  [SMALL_STATE(2662)] = 98251,
  [SMALL_STATE(2663)] = 98260,
  [SMALL_STATE(2664)] = 98269,
  [SMALL_STATE(2665)] = 98282,
  [SMALL_STATE(2666)] = 98295,
  [SMALL_STATE(2667)] = 98304,
  [SMALL_STATE(2668)] = 98317,
  [SMALL_STATE(2669)] = 98330,
  [SMALL_STATE(2670)] = 98341,
  [SMALL_STATE(2671)] = 98354,
  [SMALL_STATE(2672)] = 98367,
  [SMALL_STATE(2673)] = 98380,
  [SMALL_STATE(2674)] = 98393,
  [SMALL_STATE(2675)] = 98406,
  [SMALL_STATE(2676)] = 98415,
  [SMALL_STATE(2677)] = 98424,
  [SMALL_STATE(2678)] = 98437,
  [SMALL_STATE(2679)] = 98450,
  [SMALL_STATE(2680)] = 98463,
  [SMALL_STATE(2681)] = 98476,
  [SMALL_STATE(2682)] = 98485,
  [SMALL_STATE(2683)] = 98494,
  [SMALL_STATE(2684)] = 98503,
  [SMALL_STATE(2685)] = 98512,
  [SMALL_STATE(2686)] = 98521,
  [SMALL_STATE(2687)] = 98534,
  [SMALL_STATE(2688)] = 98545,
  [SMALL_STATE(2689)] = 98558,
  [SMALL_STATE(2690)] = 98569,
  [SMALL_STATE(2691)] = 98580,
  [SMALL_STATE(2692)] = 98591,
  [SMALL_STATE(2693)] = 98602,
  [SMALL_STATE(2694)] = 98615,
  [SMALL_STATE(2695)] = 98624,
  [SMALL_STATE(2696)] = 98637,
  [SMALL_STATE(2697)] = 98648,
  [SMALL_STATE(2698)] = 98661,
  [SMALL_STATE(2699)] = 98670,
  [SMALL_STATE(2700)] = 98683,
  [SMALL_STATE(2701)] = 98696,
  [SMALL_STATE(2702)] = 98705,
  [SMALL_STATE(2703)] = 98718,
  [SMALL_STATE(2704)] = 98731,
  [SMALL_STATE(2705)] = 98744,
  [SMALL_STATE(2706)] = 98757,
  [SMALL_STATE(2707)] = 98770,
  [SMALL_STATE(2708)] = 98783,
  [SMALL_STATE(2709)] = 98796,
  [SMALL_STATE(2710)] = 98809,
  [SMALL_STATE(2711)] = 98822,
  [SMALL_STATE(2712)] = 98835,
  [SMALL_STATE(2713)] = 98848,
  [SMALL_STATE(2714)] = 98861,
  [SMALL_STATE(2715)] = 98870,
  [SMALL_STATE(2716)] = 98881,
  [SMALL_STATE(2717)] = 98894,
  [SMALL_STATE(2718)] = 98907,
  [SMALL_STATE(2719)] = 98920,
  [SMALL_STATE(2720)] = 98933,
  [SMALL_STATE(2721)] = 98946,
  [SMALL_STATE(2722)] = 98959,
  [SMALL_STATE(2723)] = 98972,
  [SMALL_STATE(2724)] = 98985,
  [SMALL_STATE(2725)] = 98998,
  [SMALL_STATE(2726)] = 99011,
  [SMALL_STATE(2727)] = 99024,
  [SMALL_STATE(2728)] = 99037,
  [SMALL_STATE(2729)] = 99050,
  [SMALL_STATE(2730)] = 99063,
  [SMALL_STATE(2731)] = 99072,
  [SMALL_STATE(2732)] = 99085,
  [SMALL_STATE(2733)] = 99098,
  [SMALL_STATE(2734)] = 99111,
  [SMALL_STATE(2735)] = 99124,
  [SMALL_STATE(2736)] = 99137,
  [SMALL_STATE(2737)] = 99148,
  [SMALL_STATE(2738)] = 99161,
  [SMALL_STATE(2739)] = 99174,
  [SMALL_STATE(2740)] = 99183,
  [SMALL_STATE(2741)] = 99196,
  [SMALL_STATE(2742)] = 99209,
  [SMALL_STATE(2743)] = 99222,
  [SMALL_STATE(2744)] = 99235,
  [SMALL_STATE(2745)] = 99248,
  [SMALL_STATE(2746)] = 99261,
  [SMALL_STATE(2747)] = 99274,
  [SMALL_STATE(2748)] = 99287,
  [SMALL_STATE(2749)] = 99300,
  [SMALL_STATE(2750)] = 99313,
  [SMALL_STATE(2751)] = 99322,
  [SMALL_STATE(2752)] = 99335,
  [SMALL_STATE(2753)] = 99348,
  [SMALL_STATE(2754)] = 99361,
  [SMALL_STATE(2755)] = 99374,
  [SMALL_STATE(2756)] = 99384,
  [SMALL_STATE(2757)] = 99394,
  [SMALL_STATE(2758)] = 99404,
  [SMALL_STATE(2759)] = 99414,
  [SMALL_STATE(2760)] = 99424,
  [SMALL_STATE(2761)] = 99434,
  [SMALL_STATE(2762)] = 99444,
  [SMALL_STATE(2763)] = 99454,
  [SMALL_STATE(2764)] = 99464,
  [SMALL_STATE(2765)] = 99474,
  [SMALL_STATE(2766)] = 99484,
  [SMALL_STATE(2767)] = 99494,
  [SMALL_STATE(2768)] = 99502,
  [SMALL_STATE(2769)] = 99512,
  [SMALL_STATE(2770)] = 99522,
  [SMALL_STATE(2771)] = 99532,
  [SMALL_STATE(2772)] = 99542,
  [SMALL_STATE(2773)] = 99552,
  [SMALL_STATE(2774)] = 99562,
  [SMALL_STATE(2775)] = 99572,
  [SMALL_STATE(2776)] = 99582,
  [SMALL_STATE(2777)] = 99590,
  [SMALL_STATE(2778)] = 99600,
  [SMALL_STATE(2779)] = 99608,
  [SMALL_STATE(2780)] = 99618,
  [SMALL_STATE(2781)] = 99626,
  [SMALL_STATE(2782)] = 99636,
  [SMALL_STATE(2783)] = 99646,
  [SMALL_STATE(2784)] = 99656,
  [SMALL_STATE(2785)] = 99666,
  [SMALL_STATE(2786)] = 99676,
  [SMALL_STATE(2787)] = 99686,
  [SMALL_STATE(2788)] = 99696,
  [SMALL_STATE(2789)] = 99706,
  [SMALL_STATE(2790)] = 99716,
  [SMALL_STATE(2791)] = 99726,
  [SMALL_STATE(2792)] = 99736,
  [SMALL_STATE(2793)] = 99746,
  [SMALL_STATE(2794)] = 99756,
  [SMALL_STATE(2795)] = 99766,
  [SMALL_STATE(2796)] = 99776,
  [SMALL_STATE(2797)] = 99786,
  [SMALL_STATE(2798)] = 99796,
  [SMALL_STATE(2799)] = 99804,
  [SMALL_STATE(2800)] = 99814,
  [SMALL_STATE(2801)] = 99824,
  [SMALL_STATE(2802)] = 99834,
  [SMALL_STATE(2803)] = 99844,
  [SMALL_STATE(2804)] = 99852,
  [SMALL_STATE(2805)] = 99862,
  [SMALL_STATE(2806)] = 99872,
  [SMALL_STATE(2807)] = 99882,
  [SMALL_STATE(2808)] = 99890,
  [SMALL_STATE(2809)] = 99900,
  [SMALL_STATE(2810)] = 99908,
  [SMALL_STATE(2811)] = 99918,
  [SMALL_STATE(2812)] = 99928,
  [SMALL_STATE(2813)] = 99938,
  [SMALL_STATE(2814)] = 99948,
  [SMALL_STATE(2815)] = 99958,
  [SMALL_STATE(2816)] = 99966,
  [SMALL_STATE(2817)] = 99976,
  [SMALL_STATE(2818)] = 99986,
  [SMALL_STATE(2819)] = 99994,
  [SMALL_STATE(2820)] = 100004,
  [SMALL_STATE(2821)] = 100012,
  [SMALL_STATE(2822)] = 100022,
  [SMALL_STATE(2823)] = 100030,
  [SMALL_STATE(2824)] = 100040,
  [SMALL_STATE(2825)] = 100050,
  [SMALL_STATE(2826)] = 100060,
  [SMALL_STATE(2827)] = 100068,
  [SMALL_STATE(2828)] = 100078,
  [SMALL_STATE(2829)] = 100086,
  [SMALL_STATE(2830)] = 100094,
  [SMALL_STATE(2831)] = 100104,
  [SMALL_STATE(2832)] = 100112,
  [SMALL_STATE(2833)] = 100122,
  [SMALL_STATE(2834)] = 100132,
  [SMALL_STATE(2835)] = 100142,
  [SMALL_STATE(2836)] = 100152,
  [SMALL_STATE(2837)] = 100162,
  [SMALL_STATE(2838)] = 100172,
  [SMALL_STATE(2839)] = 100182,
  [SMALL_STATE(2840)] = 100192,
  [SMALL_STATE(2841)] = 100202,
  [SMALL_STATE(2842)] = 100212,
  [SMALL_STATE(2843)] = 100222,
  [SMALL_STATE(2844)] = 100232,
  [SMALL_STATE(2845)] = 100240,
  [SMALL_STATE(2846)] = 100250,
  [SMALL_STATE(2847)] = 100260,
  [SMALL_STATE(2848)] = 100270,
  [SMALL_STATE(2849)] = 100280,
  [SMALL_STATE(2850)] = 100288,
  [SMALL_STATE(2851)] = 100298,
  [SMALL_STATE(2852)] = 100308,
  [SMALL_STATE(2853)] = 100318,
  [SMALL_STATE(2854)] = 100328,
  [SMALL_STATE(2855)] = 100338,
  [SMALL_STATE(2856)] = 100348,
  [SMALL_STATE(2857)] = 100358,
  [SMALL_STATE(2858)] = 100366,
  [SMALL_STATE(2859)] = 100376,
  [SMALL_STATE(2860)] = 100386,
  [SMALL_STATE(2861)] = 100396,
  [SMALL_STATE(2862)] = 100406,
  [SMALL_STATE(2863)] = 100416,
  [SMALL_STATE(2864)] = 100426,
  [SMALL_STATE(2865)] = 100436,
  [SMALL_STATE(2866)] = 100444,
  [SMALL_STATE(2867)] = 100454,
  [SMALL_STATE(2868)] = 100464,
  [SMALL_STATE(2869)] = 100474,
  [SMALL_STATE(2870)] = 100484,
  [SMALL_STATE(2871)] = 100494,
  [SMALL_STATE(2872)] = 100504,
  [SMALL_STATE(2873)] = 100514,
  [SMALL_STATE(2874)] = 100524,
  [SMALL_STATE(2875)] = 100534,
  [SMALL_STATE(2876)] = 100544,
  [SMALL_STATE(2877)] = 100554,
  [SMALL_STATE(2878)] = 100564,
  [SMALL_STATE(2879)] = 100574,
  [SMALL_STATE(2880)] = 100584,
  [SMALL_STATE(2881)] = 100594,
  [SMALL_STATE(2882)] = 100604,
  [SMALL_STATE(2883)] = 100614,
  [SMALL_STATE(2884)] = 100622,
  [SMALL_STATE(2885)] = 100632,
  [SMALL_STATE(2886)] = 100640,
  [SMALL_STATE(2887)] = 100650,
  [SMALL_STATE(2888)] = 100660,
  [SMALL_STATE(2889)] = 100670,
  [SMALL_STATE(2890)] = 100680,
  [SMALL_STATE(2891)] = 100690,
  [SMALL_STATE(2892)] = 100698,
  [SMALL_STATE(2893)] = 100708,
  [SMALL_STATE(2894)] = 100718,
  [SMALL_STATE(2895)] = 100728,
  [SMALL_STATE(2896)] = 100738,
  [SMALL_STATE(2897)] = 100746,
  [SMALL_STATE(2898)] = 100754,
  [SMALL_STATE(2899)] = 100764,
  [SMALL_STATE(2900)] = 100772,
  [SMALL_STATE(2901)] = 100782,
  [SMALL_STATE(2902)] = 100792,
  [SMALL_STATE(2903)] = 100802,
  [SMALL_STATE(2904)] = 100810,
  [SMALL_STATE(2905)] = 100820,
  [SMALL_STATE(2906)] = 100830,
  [SMALL_STATE(2907)] = 100840,
  [SMALL_STATE(2908)] = 100848,
  [SMALL_STATE(2909)] = 100858,
  [SMALL_STATE(2910)] = 100868,
  [SMALL_STATE(2911)] = 100878,
  [SMALL_STATE(2912)] = 100888,
  [SMALL_STATE(2913)] = 100898,
  [SMALL_STATE(2914)] = 100908,
  [SMALL_STATE(2915)] = 100918,
  [SMALL_STATE(2916)] = 100928,
  [SMALL_STATE(2917)] = 100936,
  [SMALL_STATE(2918)] = 100946,
  [SMALL_STATE(2919)] = 100956,
  [SMALL_STATE(2920)] = 100964,
  [SMALL_STATE(2921)] = 100974,
  [SMALL_STATE(2922)] = 100984,
  [SMALL_STATE(2923)] = 100994,
  [SMALL_STATE(2924)] = 101002,
  [SMALL_STATE(2925)] = 101012,
  [SMALL_STATE(2926)] = 101020,
  [SMALL_STATE(2927)] = 101030,
  [SMALL_STATE(2928)] = 101038,
  [SMALL_STATE(2929)] = 101048,
  [SMALL_STATE(2930)] = 101058,
  [SMALL_STATE(2931)] = 101068,
  [SMALL_STATE(2932)] = 101078,
  [SMALL_STATE(2933)] = 101086,
  [SMALL_STATE(2934)] = 101096,
  [SMALL_STATE(2935)] = 101106,
  [SMALL_STATE(2936)] = 101114,
  [SMALL_STATE(2937)] = 101122,
  [SMALL_STATE(2938)] = 101132,
  [SMALL_STATE(2939)] = 101142,
  [SMALL_STATE(2940)] = 101152,
  [SMALL_STATE(2941)] = 101160,
  [SMALL_STATE(2942)] = 101170,
  [SMALL_STATE(2943)] = 101178,
  [SMALL_STATE(2944)] = 101188,
  [SMALL_STATE(2945)] = 101198,
  [SMALL_STATE(2946)] = 101208,
  [SMALL_STATE(2947)] = 101216,
  [SMALL_STATE(2948)] = 101224,
  [SMALL_STATE(2949)] = 101232,
  [SMALL_STATE(2950)] = 101242,
  [SMALL_STATE(2951)] = 101252,
  [SMALL_STATE(2952)] = 101262,
  [SMALL_STATE(2953)] = 101270,
  [SMALL_STATE(2954)] = 101278,
  [SMALL_STATE(2955)] = 101288,
  [SMALL_STATE(2956)] = 101296,
  [SMALL_STATE(2957)] = 101304,
  [SMALL_STATE(2958)] = 101314,
  [SMALL_STATE(2959)] = 101324,
  [SMALL_STATE(2960)] = 101334,
  [SMALL_STATE(2961)] = 101342,
  [SMALL_STATE(2962)] = 101350,
  [SMALL_STATE(2963)] = 101360,
  [SMALL_STATE(2964)] = 101370,
  [SMALL_STATE(2965)] = 101378,
  [SMALL_STATE(2966)] = 101388,
  [SMALL_STATE(2967)] = 101398,
  [SMALL_STATE(2968)] = 101406,
  [SMALL_STATE(2969)] = 101416,
  [SMALL_STATE(2970)] = 101426,
  [SMALL_STATE(2971)] = 101434,
  [SMALL_STATE(2972)] = 101444,
  [SMALL_STATE(2973)] = 101454,
  [SMALL_STATE(2974)] = 101464,
  [SMALL_STATE(2975)] = 101474,
  [SMALL_STATE(2976)] = 101481,
  [SMALL_STATE(2977)] = 101488,
  [SMALL_STATE(2978)] = 101495,
  [SMALL_STATE(2979)] = 101502,
  [SMALL_STATE(2980)] = 101509,
  [SMALL_STATE(2981)] = 101516,
  [SMALL_STATE(2982)] = 101523,
  [SMALL_STATE(2983)] = 101530,
  [SMALL_STATE(2984)] = 101537,
  [SMALL_STATE(2985)] = 101544,
  [SMALL_STATE(2986)] = 101551,
  [SMALL_STATE(2987)] = 101558,
  [SMALL_STATE(2988)] = 101565,
  [SMALL_STATE(2989)] = 101572,
  [SMALL_STATE(2990)] = 101579,
  [SMALL_STATE(2991)] = 101586,
  [SMALL_STATE(2992)] = 101593,
  [SMALL_STATE(2993)] = 101600,
  [SMALL_STATE(2994)] = 101607,
  [SMALL_STATE(2995)] = 101614,
  [SMALL_STATE(2996)] = 101621,
  [SMALL_STATE(2997)] = 101628,
  [SMALL_STATE(2998)] = 101635,
  [SMALL_STATE(2999)] = 101642,
  [SMALL_STATE(3000)] = 101649,
  [SMALL_STATE(3001)] = 101656,
  [SMALL_STATE(3002)] = 101663,
  [SMALL_STATE(3003)] = 101670,
  [SMALL_STATE(3004)] = 101677,
  [SMALL_STATE(3005)] = 101684,
  [SMALL_STATE(3006)] = 101691,
  [SMALL_STATE(3007)] = 101698,
  [SMALL_STATE(3008)] = 101705,
  [SMALL_STATE(3009)] = 101712,
  [SMALL_STATE(3010)] = 101719,
  [SMALL_STATE(3011)] = 101726,
  [SMALL_STATE(3012)] = 101733,
  [SMALL_STATE(3013)] = 101740,
  [SMALL_STATE(3014)] = 101747,
  [SMALL_STATE(3015)] = 101754,
  [SMALL_STATE(3016)] = 101761,
  [SMALL_STATE(3017)] = 101768,
  [SMALL_STATE(3018)] = 101775,
  [SMALL_STATE(3019)] = 101782,
  [SMALL_STATE(3020)] = 101789,
  [SMALL_STATE(3021)] = 101796,
  [SMALL_STATE(3022)] = 101803,
  [SMALL_STATE(3023)] = 101810,
  [SMALL_STATE(3024)] = 101817,
  [SMALL_STATE(3025)] = 101824,
  [SMALL_STATE(3026)] = 101831,
  [SMALL_STATE(3027)] = 101838,
  [SMALL_STATE(3028)] = 101845,
  [SMALL_STATE(3029)] = 101852,
  [SMALL_STATE(3030)] = 101859,
  [SMALL_STATE(3031)] = 101866,
  [SMALL_STATE(3032)] = 101873,
  [SMALL_STATE(3033)] = 101880,
  [SMALL_STATE(3034)] = 101887,
  [SMALL_STATE(3035)] = 101894,
  [SMALL_STATE(3036)] = 101901,
  [SMALL_STATE(3037)] = 101908,
  [SMALL_STATE(3038)] = 101915,
  [SMALL_STATE(3039)] = 101922,
  [SMALL_STATE(3040)] = 101929,
  [SMALL_STATE(3041)] = 101936,
  [SMALL_STATE(3042)] = 101943,
  [SMALL_STATE(3043)] = 101950,
  [SMALL_STATE(3044)] = 101957,
  [SMALL_STATE(3045)] = 101964,
  [SMALL_STATE(3046)] = 101971,
  [SMALL_STATE(3047)] = 101978,
  [SMALL_STATE(3048)] = 101985,
  [SMALL_STATE(3049)] = 101992,
  [SMALL_STATE(3050)] = 101999,
  [SMALL_STATE(3051)] = 102006,
  [SMALL_STATE(3052)] = 102013,
  [SMALL_STATE(3053)] = 102020,
  [SMALL_STATE(3054)] = 102027,
  [SMALL_STATE(3055)] = 102034,
  [SMALL_STATE(3056)] = 102041,
  [SMALL_STATE(3057)] = 102048,
  [SMALL_STATE(3058)] = 102055,
  [SMALL_STATE(3059)] = 102062,
  [SMALL_STATE(3060)] = 102069,
  [SMALL_STATE(3061)] = 102076,
  [SMALL_STATE(3062)] = 102083,
  [SMALL_STATE(3063)] = 102090,
  [SMALL_STATE(3064)] = 102097,
  [SMALL_STATE(3065)] = 102104,
  [SMALL_STATE(3066)] = 102111,
  [SMALL_STATE(3067)] = 102118,
  [SMALL_STATE(3068)] = 102125,
  [SMALL_STATE(3069)] = 102132,
  [SMALL_STATE(3070)] = 102139,
  [SMALL_STATE(3071)] = 102146,
  [SMALL_STATE(3072)] = 102153,
  [SMALL_STATE(3073)] = 102160,
  [SMALL_STATE(3074)] = 102167,
  [SMALL_STATE(3075)] = 102174,
  [SMALL_STATE(3076)] = 102181,
  [SMALL_STATE(3077)] = 102188,
  [SMALL_STATE(3078)] = 102195,
  [SMALL_STATE(3079)] = 102202,
  [SMALL_STATE(3080)] = 102209,
  [SMALL_STATE(3081)] = 102216,
  [SMALL_STATE(3082)] = 102223,
  [SMALL_STATE(3083)] = 102230,
  [SMALL_STATE(3084)] = 102237,
  [SMALL_STATE(3085)] = 102244,
  [SMALL_STATE(3086)] = 102251,
  [SMALL_STATE(3087)] = 102258,
  [SMALL_STATE(3088)] = 102265,
  [SMALL_STATE(3089)] = 102272,
  [SMALL_STATE(3090)] = 102279,
  [SMALL_STATE(3091)] = 102286,
  [SMALL_STATE(3092)] = 102293,
  [SMALL_STATE(3093)] = 102300,
  [SMALL_STATE(3094)] = 102307,
  [SMALL_STATE(3095)] = 102314,
  [SMALL_STATE(3096)] = 102321,
  [SMALL_STATE(3097)] = 102328,
  [SMALL_STATE(3098)] = 102335,
  [SMALL_STATE(3099)] = 102342,
  [SMALL_STATE(3100)] = 102349,
  [SMALL_STATE(3101)] = 102356,
  [SMALL_STATE(3102)] = 102363,
  [SMALL_STATE(3103)] = 102370,
  [SMALL_STATE(3104)] = 102377,
  [SMALL_STATE(3105)] = 102384,
  [SMALL_STATE(3106)] = 102391,
  [SMALL_STATE(3107)] = 102398,
  [SMALL_STATE(3108)] = 102405,
  [SMALL_STATE(3109)] = 102412,
  [SMALL_STATE(3110)] = 102419,
  [SMALL_STATE(3111)] = 102426,
  [SMALL_STATE(3112)] = 102433,
  [SMALL_STATE(3113)] = 102440,
  [SMALL_STATE(3114)] = 102447,
  [SMALL_STATE(3115)] = 102454,
  [SMALL_STATE(3116)] = 102461,
  [SMALL_STATE(3117)] = 102468,
  [SMALL_STATE(3118)] = 102475,
  [SMALL_STATE(3119)] = 102482,
  [SMALL_STATE(3120)] = 102489,
  [SMALL_STATE(3121)] = 102496,
  [SMALL_STATE(3122)] = 102503,
  [SMALL_STATE(3123)] = 102510,
  [SMALL_STATE(3124)] = 102517,
  [SMALL_STATE(3125)] = 102524,
  [SMALL_STATE(3126)] = 102531,
  [SMALL_STATE(3127)] = 102538,
  [SMALL_STATE(3128)] = 102545,
  [SMALL_STATE(3129)] = 102552,
  [SMALL_STATE(3130)] = 102559,
  [SMALL_STATE(3131)] = 102566,
  [SMALL_STATE(3132)] = 102573,
  [SMALL_STATE(3133)] = 102580,
  [SMALL_STATE(3134)] = 102587,
  [SMALL_STATE(3135)] = 102594,
  [SMALL_STATE(3136)] = 102601,
  [SMALL_STATE(3137)] = 102608,
  [SMALL_STATE(3138)] = 102615,
  [SMALL_STATE(3139)] = 102622,
  [SMALL_STATE(3140)] = 102629,
  [SMALL_STATE(3141)] = 102636,
  [SMALL_STATE(3142)] = 102643,
  [SMALL_STATE(3143)] = 102650,
  [SMALL_STATE(3144)] = 102657,
  [SMALL_STATE(3145)] = 102664,
  [SMALL_STATE(3146)] = 102671,
  [SMALL_STATE(3147)] = 102678,
  [SMALL_STATE(3148)] = 102685,
  [SMALL_STATE(3149)] = 102692,
  [SMALL_STATE(3150)] = 102699,
  [SMALL_STATE(3151)] = 102706,
  [SMALL_STATE(3152)] = 102713,
  [SMALL_STATE(3153)] = 102720,
  [SMALL_STATE(3154)] = 102727,
  [SMALL_STATE(3155)] = 102734,
  [SMALL_STATE(3156)] = 102741,
  [SMALL_STATE(3157)] = 102748,
  [SMALL_STATE(3158)] = 102755,
  [SMALL_STATE(3159)] = 102762,
  [SMALL_STATE(3160)] = 102769,
  [SMALL_STATE(3161)] = 102776,
  [SMALL_STATE(3162)] = 102783,
  [SMALL_STATE(3163)] = 102790,
  [SMALL_STATE(3164)] = 102797,
  [SMALL_STATE(3165)] = 102804,
  [SMALL_STATE(3166)] = 102811,
  [SMALL_STATE(3167)] = 102818,
  [SMALL_STATE(3168)] = 102825,
  [SMALL_STATE(3169)] = 102832,
  [SMALL_STATE(3170)] = 102839,
  [SMALL_STATE(3171)] = 102846,
  [SMALL_STATE(3172)] = 102853,
  [SMALL_STATE(3173)] = 102860,
  [SMALL_STATE(3174)] = 102867,
  [SMALL_STATE(3175)] = 102874,
  [SMALL_STATE(3176)] = 102881,
  [SMALL_STATE(3177)] = 102888,
  [SMALL_STATE(3178)] = 102895,
  [SMALL_STATE(3179)] = 102902,
  [SMALL_STATE(3180)] = 102909,
  [SMALL_STATE(3181)] = 102916,
  [SMALL_STATE(3182)] = 102923,
  [SMALL_STATE(3183)] = 102930,
  [SMALL_STATE(3184)] = 102937,
  [SMALL_STATE(3185)] = 102944,
  [SMALL_STATE(3186)] = 102951,
  [SMALL_STATE(3187)] = 102958,
  [SMALL_STATE(3188)] = 102965,
  [SMALL_STATE(3189)] = 102972,
  [SMALL_STATE(3190)] = 102979,
  [SMALL_STATE(3191)] = 102986,
  [SMALL_STATE(3192)] = 102993,
  [SMALL_STATE(3193)] = 103000,
  [SMALL_STATE(3194)] = 103007,
  [SMALL_STATE(3195)] = 103014,
  [SMALL_STATE(3196)] = 103021,
  [SMALL_STATE(3197)] = 103028,
  [SMALL_STATE(3198)] = 103035,
  [SMALL_STATE(3199)] = 103042,
  [SMALL_STATE(3200)] = 103049,
  [SMALL_STATE(3201)] = 103056,
  [SMALL_STATE(3202)] = 103063,
  [SMALL_STATE(3203)] = 103070,
  [SMALL_STATE(3204)] = 103077,
  [SMALL_STATE(3205)] = 103084,
  [SMALL_STATE(3206)] = 103091,
  [SMALL_STATE(3207)] = 103098,
  [SMALL_STATE(3208)] = 103105,
  [SMALL_STATE(3209)] = 103112,
  [SMALL_STATE(3210)] = 103119,
  [SMALL_STATE(3211)] = 103126,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(831),
  [9] = {.count = 1, .reusable = true}, SHIFT(17),
  [11] = {.count = 1, .reusable = false}, SHIFT(413),
  [13] = {.count = 1, .reusable = false}, SHIFT(649),
  [15] = {.count = 1, .reusable = true}, SHIFT(4),
  [17] = {.count = 1, .reusable = false}, SHIFT(794),
  [19] = {.count = 1, .reusable = false}, SHIFT(266),
  [21] = {.count = 1, .reusable = false}, SHIFT(928),
  [23] = {.count = 1, .reusable = false}, SHIFT(2122),
  [25] = {.count = 1, .reusable = false}, SHIFT(2121),
  [27] = {.count = 1, .reusable = false}, SHIFT(2108),
  [29] = {.count = 1, .reusable = false}, SHIFT(2764),
  [31] = {.count = 1, .reusable = false}, SHIFT(2769),
  [33] = {.count = 1, .reusable = false}, SHIFT(2556),
  [35] = {.count = 1, .reusable = true}, SHIFT(143),
  [37] = {.count = 1, .reusable = false}, SHIFT(351),
  [39] = {.count = 1, .reusable = false}, SHIFT(2784),
  [41] = {.count = 1, .reusable = false}, SHIFT(55),
  [43] = {.count = 1, .reusable = false}, SHIFT(2785),
  [45] = {.count = 1, .reusable = false}, SHIFT(2791),
  [47] = {.count = 1, .reusable = false}, SHIFT(2560),
  [49] = {.count = 1, .reusable = false}, SHIFT(2571),
  [51] = {.count = 1, .reusable = false}, SHIFT(2807),
  [53] = {.count = 1, .reusable = false}, SHIFT(170),
  [55] = {.count = 1, .reusable = false}, SHIFT(178),
  [57] = {.count = 1, .reusable = true}, SHIFT(499),
  [59] = {.count = 1, .reusable = false}, SHIFT(108),
  [61] = {.count = 1, .reusable = true}, SHIFT(159),
  [63] = {.count = 1, .reusable = true}, SHIFT(2170),
  [65] = {.count = 1, .reusable = false}, SHIFT(3172),
  [67] = {.count = 1, .reusable = false}, SHIFT(1924),
  [69] = {.count = 1, .reusable = false}, SHIFT(498),
  [71] = {.count = 1, .reusable = false}, SHIFT(2048),
  [73] = {.count = 1, .reusable = false}, SHIFT(185),
  [75] = {.count = 1, .reusable = false}, SHIFT(365),
  [77] = {.count = 1, .reusable = true}, SHIFT(366),
  [79] = {.count = 1, .reusable = false}, SHIFT(69),
  [81] = {.count = 1, .reusable = true}, SHIFT(374),
  [83] = {.count = 1, .reusable = true}, SHIFT(2486),
  [85] = {.count = 1, .reusable = true}, SHIFT(2494),
  [87] = {.count = 1, .reusable = true}, SHIFT(2182),
  [89] = {.count = 1, .reusable = true}, SHIFT(1270),
  [91] = {.count = 1, .reusable = false}, SHIFT(1270),
  [93] = {.count = 1, .reusable = false}, SHIFT(1163),
  [95] = {.count = 1, .reusable = true}, SHIFT(1856),
  [97] = {.count = 1, .reusable = false}, SHIFT(832),
  [99] = {.count = 1, .reusable = false}, SHIFT(3162),
  [101] = {.count = 1, .reusable = false}, SHIFT(421),
  [103] = {.count = 1, .reusable = false}, SHIFT(643),
  [105] = {.count = 1, .reusable = false}, SHIFT(3161),
  [107] = {.count = 1, .reusable = false}, SHIFT(3160),
  [109] = {.count = 1, .reusable = false}, SHIFT(692),
  [111] = {.count = 1, .reusable = false}, SHIFT(246),
  [113] = {.count = 1, .reusable = true}, SHIFT(1848),
  [115] = {.count = 1, .reusable = false}, SHIFT(626),
  [117] = {.count = 1, .reusable = true}, SHIFT(1301),
  [119] = {.count = 1, .reusable = true}, SHIFT(966),
  [121] = {.count = 1, .reusable = false}, SHIFT(661),
  [123] = {.count = 1, .reusable = true}, SHIFT(158),
  [125] = {.count = 1, .reusable = false}, SHIFT(427),
  [127] = {.count = 1, .reusable = true}, SHIFT(384),
  [129] = {.count = 1, .reusable = false}, SHIFT(57),
  [131] = {.count = 1, .reusable = true}, SHIFT(1466),
  [133] = {.count = 1, .reusable = false}, SHIFT(457),
  [135] = {.count = 1, .reusable = false}, SHIFT(455),
  [137] = {.count = 1, .reusable = false}, SHIFT(412),
  [139] = {.count = 1, .reusable = false}, SHIFT(492),
  [141] = {.count = 1, .reusable = false}, SHIFT(625),
  [143] = {.count = 1, .reusable = false}, SHIFT(681),
  [145] = {.count = 1, .reusable = false}, SHIFT(459),
  [147] = {.count = 1, .reusable = false}, SHIFT(697),
  [149] = {.count = 1, .reusable = false}, SHIFT(239),
  [151] = {.count = 1, .reusable = false}, SHIFT(629),
  [153] = {.count = 1, .reusable = true}, SHIFT(1342),
  [155] = {.count = 1, .reusable = false}, SHIFT(677),
  [157] = {.count = 1, .reusable = false}, SHIFT(428),
  [159] = {.count = 1, .reusable = false}, SHIFT(59),
  [161] = {.count = 1, .reusable = false}, SHIFT(450),
  [163] = {.count = 1, .reusable = false}, SHIFT(453),
  [165] = {.count = 1, .reusable = false}, SHIFT(414),
  [167] = {.count = 1, .reusable = false}, SHIFT(494),
  [169] = {.count = 1, .reusable = false}, SHIFT(627),
  [171] = {.count = 1, .reusable = false}, SHIFT(706),
  [173] = {.count = 1, .reusable = false}, SHIFT(458),
  [175] = {.count = 1, .reusable = true}, SHIFT(115),
  [177] = {.count = 1, .reusable = false}, SHIFT(686),
  [179] = {.count = 1, .reusable = false}, SHIFT(196),
  [181] = {.count = 1, .reusable = false}, SHIFT(630),
  [183] = {.count = 1, .reusable = true}, SHIFT(1393),
  [185] = {.count = 1, .reusable = false}, SHIFT(672),
  [187] = {.count = 1, .reusable = false}, SHIFT(424),
  [189] = {.count = 1, .reusable = false}, SHIFT(58),
  [191] = {.count = 1, .reusable = false}, SHIFT(456),
  [193] = {.count = 1, .reusable = false}, SHIFT(454),
  [195] = {.count = 1, .reusable = false}, SHIFT(411),
  [197] = {.count = 1, .reusable = false}, SHIFT(483),
  [199] = {.count = 1, .reusable = false}, SHIFT(624),
  [201] = {.count = 1, .reusable = false}, SHIFT(698),
  [203] = {.count = 1, .reusable = false}, SHIFT(451),
  [205] = {.count = 1, .reusable = true}, SHIFT(1314),
  [207] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [209] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(831),
  [212] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(413),
  [215] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [217] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(649),
  [220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(794),
  [226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(266),
  [229] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(928),
  [232] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2122),
  [235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2121),
  [238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2108),
  [241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2764),
  [244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2769),
  [247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2556),
  [250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(143),
  [253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(351),
  [256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2784),
  [259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(55),
  [262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2785),
  [265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2791),
  [268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2560),
  [271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2571),
  [274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2807),
  [277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(170),
  [280] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(178),
  [283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(499),
  [286] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(108),
  [289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(159),
  [292] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2170),
  [295] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3172),
  [298] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1924),
  [301] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(498),
  [304] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2048),
  [307] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(185),
  [310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(365),
  [313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(366),
  [316] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(69),
  [319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(374),
  [322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2486),
  [325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2494),
  [328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2182),
  [331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1270),
  [334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1270),
  [337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1163),
  [340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1856),
  [343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(832),
  [346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3162),
  [349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(421),
  [352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(643),
  [355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3161),
  [358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3160),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [365] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [369] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [373] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [377] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [379] = {.count = 1, .reusable = true}, SHIFT(1467),
  [381] = {.count = 1, .reusable = true}, SHIFT(1791),
  [383] = {.count = 1, .reusable = true}, SHIFT(1442),
  [385] = {.count = 1, .reusable = true}, SHIFT(462),
  [387] = {.count = 1, .reusable = true}, SHIFT(1206),
  [389] = {.count = 1, .reusable = true}, SHIFT(470),
  [391] = {.count = 1, .reusable = true}, SHIFT(1810),
  [393] = {.count = 1, .reusable = true}, SHIFT(474),
  [395] = {.count = 1, .reusable = true}, SHIFT(1275),
  [397] = {.count = 1, .reusable = true}, SHIFT(993),
  [399] = {.count = 1, .reusable = true}, SHIFT(982),
  [401] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [403] = {.count = 1, .reusable = true}, SHIFT(463),
  [405] = {.count = 1, .reusable = true}, SHIFT(135),
  [407] = {.count = 1, .reusable = true}, SHIFT(118),
  [409] = {.count = 1, .reusable = false}, SHIFT(829),
  [411] = {.count = 1, .reusable = false}, SHIFT(416),
  [413] = {.count = 1, .reusable = false}, SHIFT(647),
  [415] = {.count = 1, .reusable = true}, SHIFT(6),
  [417] = {.count = 1, .reusable = false}, SHIFT(723),
  [419] = {.count = 1, .reusable = false}, SHIFT(2762),
  [421] = {.count = 1, .reusable = false}, SHIFT(2575),
  [423] = {.count = 1, .reusable = false}, SHIFT(2817),
  [425] = {.count = 1, .reusable = false}, SHIFT(2816),
  [427] = {.count = 1, .reusable = false}, SHIFT(1963),
  [429] = {.count = 1, .reusable = false}, SHIFT(500),
  [431] = {.count = 1, .reusable = false}, SHIFT(2084),
  [433] = {.count = 1, .reusable = false}, SHIFT(71),
  [435] = {.count = 1, .reusable = false}, SHIFT(828),
  [437] = {.count = 1, .reusable = false}, SHIFT(419),
  [439] = {.count = 1, .reusable = false}, SHIFT(646),
  [441] = {.count = 1, .reusable = false}, SHIFT(834),
  [443] = {.count = 1, .reusable = false}, SHIFT(415),
  [445] = {.count = 1, .reusable = false}, SHIFT(640),
  [447] = {.count = 1, .reusable = false}, SHIFT(729),
  [449] = {.count = 1, .reusable = false}, SHIFT(2772),
  [451] = {.count = 1, .reusable = false}, SHIFT(2552),
  [453] = {.count = 1, .reusable = false}, SHIFT(2773),
  [455] = {.count = 1, .reusable = false}, SHIFT(2774),
  [457] = {.count = 1, .reusable = false}, SHIFT(497),
  [459] = {.count = 1, .reusable = false}, SHIFT(70),
  [461] = {.count = 1, .reusable = false}, SHIFT(839),
  [463] = {.count = 1, .reusable = false}, SHIFT(420),
  [465] = {.count = 1, .reusable = false}, SHIFT(648),
  [467] = {.count = 1, .reusable = false}, SHIFT(847),
  [469] = {.count = 1, .reusable = false}, SHIFT(857),
  [471] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [473] = {.count = 1, .reusable = false}, SHIFT(312),
  [475] = {.count = 1, .reusable = false}, SHIFT(634),
  [477] = {.count = 1, .reusable = true}, SHIFT(1140),
  [479] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [481] = {.count = 1, .reusable = true}, SHIFT(971),
  [483] = {.count = 1, .reusable = false}, SHIFT(1530),
  [485] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(48),
  [488] = {.count = 1, .reusable = false}, SHIFT(2170),
  [490] = {.count = 1, .reusable = false}, SHIFT(2976),
  [492] = {.count = 1, .reusable = false}, SHIFT(1955),
  [494] = {.count = 1, .reusable = false}, SHIFT(506),
  [496] = {.count = 1, .reusable = false}, SHIFT(2089),
  [498] = {.count = 1, .reusable = true}, SHIFT(245),
  [500] = {.count = 1, .reusable = true}, SHIFT(349),
  [502] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [505] = {.count = 1, .reusable = false}, SHIFT(366),
  [507] = {.count = 1, .reusable = false}, SHIFT(72),
  [509] = {.count = 1, .reusable = true}, SHIFT(1132),
  [511] = {.count = 1, .reusable = false}, SHIFT(1132),
  [513] = {.count = 1, .reusable = true}, SHIFT(1413),
  [515] = {.count = 1, .reusable = true}, SHIFT(1067),
  [517] = {.count = 1, .reusable = false}, SHIFT(866),
  [519] = {.count = 1, .reusable = false}, SHIFT(878),
  [521] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [523] = {.count = 1, .reusable = false}, SHIFT(271),
  [525] = {.count = 1, .reusable = false}, SHIFT(657),
  [527] = {.count = 1, .reusable = true}, SHIFT(1044),
  [529] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [531] = {.count = 1, .reusable = false}, SHIFT(386),
  [533] = {.count = 1, .reusable = false}, SHIFT(1125),
  [535] = {.count = 1, .reusable = false}, SHIFT(388),
  [537] = {.count = 1, .reusable = false}, SHIFT(109),
  [539] = {.count = 1, .reusable = false}, SHIFT(3077),
  [541] = {.count = 1, .reusable = false}, SHIFT(1926),
  [543] = {.count = 1, .reusable = false}, SHIFT(551),
  [545] = {.count = 1, .reusable = false}, SHIFT(2113),
  [547] = {.count = 1, .reusable = true}, SHIFT(209),
  [549] = {.count = 1, .reusable = false}, SHIFT(201),
  [551] = {.count = 1, .reusable = true}, SHIFT(272),
  [553] = {.count = 1, .reusable = true}, SHIFT(397),
  [555] = {.count = 1, .reusable = false}, SHIFT(79),
  [557] = {.count = 1, .reusable = true}, SHIFT(2514),
  [559] = {.count = 1, .reusable = true}, SHIFT(2512),
  [561] = {.count = 1, .reusable = true}, SHIFT(1282),
  [563] = {.count = 1, .reusable = false}, SHIFT(1282),
  [565] = {.count = 1, .reusable = false}, SHIFT(955),
  [567] = {.count = 1, .reusable = false}, SHIFT(820),
  [569] = {.count = 1, .reusable = false}, SHIFT(806),
  [571] = {.count = 1, .reusable = false}, SHIFT(341),
  [573] = {.count = 1, .reusable = false}, SHIFT(632),
  [575] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [578] = {.count = 1, .reusable = false}, SHIFT(370),
  [580] = {.count = 1, .reusable = true}, SHIFT(145),
  [582] = {.count = 1, .reusable = false}, SHIFT(364),
  [584] = {.count = 1, .reusable = false}, SHIFT(105),
  [586] = {.count = 1, .reusable = true}, SHIFT(150),
  [588] = {.count = 1, .reusable = false}, SHIFT(2137),
  [590] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [593] = {.count = 1, .reusable = false}, SHIFT(3200),
  [595] = {.count = 1, .reusable = false}, SHIFT(487),
  [597] = {.count = 1, .reusable = false}, SHIFT(248),
  [599] = {.count = 1, .reusable = true}, SHIFT(322),
  [601] = {.count = 1, .reusable = false}, SHIFT(284),
  [603] = {.count = 1, .reusable = false}, SHIFT(290),
  [605] = {.count = 1, .reusable = true}, SHIFT(290),
  [607] = {.count = 1, .reusable = false}, SHIFT(64),
  [609] = {.count = 1, .reusable = true}, SHIFT(315),
  [611] = {.count = 1, .reusable = true}, SHIFT(2145),
  [613] = {.count = 1, .reusable = true}, SHIFT(990),
  [615] = {.count = 1, .reusable = false}, SHIFT(990),
  [617] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [619] = {.count = 1, .reusable = true}, SHIFT(216),
  [621] = {.count = 1, .reusable = false}, SHIFT(259),
  [623] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(176),
  [626] = {.count = 1, .reusable = false}, SHIFT(176),
  [628] = {.count = 1, .reusable = false}, SHIFT(398),
  [630] = {.count = 1, .reusable = false}, SHIFT(397),
  [632] = {.count = 1, .reusable = true}, SHIFT(396),
  [634] = {.count = 1, .reusable = true}, SHIFT(48),
  [636] = {.count = 1, .reusable = true}, SHIFT(56),
  [638] = {.count = 1, .reusable = true}, SHIFT(53),
  [640] = {.count = 1, .reusable = true}, SHIFT(2046),
  [642] = {.count = 1, .reusable = true}, SHIFT(186),
  [644] = {.count = 1, .reusable = false}, SHIFT(3027),
  [646] = {.count = 1, .reusable = true}, SHIFT(230),
  [648] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(341),
  [651] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [654] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [658] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [660] = {.count = 1, .reusable = true}, SHIFT(251),
  [662] = {.count = 1, .reusable = false}, SHIFT(897),
  [664] = {.count = 1, .reusable = false}, SHIFT(894),
  [666] = {.count = 1, .reusable = false}, SHIFT(354),
  [668] = {.count = 1, .reusable = false}, SHIFT(659),
  [670] = {.count = 1, .reusable = false}, SHIFT(270),
  [672] = {.count = 1, .reusable = false}, SHIFT(371),
  [674] = {.count = 1, .reusable = false}, SHIFT(111),
  [676] = {.count = 1, .reusable = false}, SHIFT(609),
  [678] = {.count = 1, .reusable = false}, SHIFT(236),
  [680] = {.count = 1, .reusable = true}, SHIFT(256),
  [682] = {.count = 1, .reusable = false}, SHIFT(265),
  [684] = {.count = 1, .reusable = false}, SHIFT(283),
  [686] = {.count = 1, .reusable = true}, SHIFT(283),
  [688] = {.count = 1, .reusable = false}, SHIFT(82),
  [690] = {.count = 1, .reusable = true}, SHIFT(338),
  [692] = {.count = 1, .reusable = true}, SHIFT(1369),
  [694] = {.count = 1, .reusable = false}, SHIFT(1369),
  [696] = {.count = 1, .reusable = false}, SHIFT(859),
  [698] = {.count = 1, .reusable = false}, SHIFT(887),
  [700] = {.count = 1, .reusable = false}, SHIFT(334),
  [702] = {.count = 1, .reusable = false}, SHIFT(651),
  [704] = {.count = 1, .reusable = false}, SHIFT(1029),
  [706] = {.count = 1, .reusable = false}, SHIFT(361),
  [708] = {.count = 1, .reusable = false}, SHIFT(1675),
  [710] = {.count = 1, .reusable = true}, SHIFT(144),
  [712] = {.count = 1, .reusable = false}, SHIFT(362),
  [714] = {.count = 1, .reusable = false}, SHIFT(112),
  [716] = {.count = 1, .reusable = true}, SHIFT(157),
  [718] = {.count = 1, .reusable = false}, SHIFT(2157),
  [720] = {.count = 1, .reusable = false}, SHIFT(3042),
  [722] = {.count = 1, .reusable = false}, SHIFT(1949),
  [724] = {.count = 1, .reusable = false}, SHIFT(572),
  [726] = {.count = 1, .reusable = false}, SHIFT(2062),
  [728] = {.count = 1, .reusable = false}, SHIFT(177),
  [730] = {.count = 1, .reusable = true}, SHIFT(292),
  [732] = {.count = 1, .reusable = false}, SHIFT(287),
  [734] = {.count = 1, .reusable = false}, SHIFT(377),
  [736] = {.count = 1, .reusable = true}, SHIFT(377),
  [738] = {.count = 1, .reusable = false}, SHIFT(88),
  [740] = {.count = 1, .reusable = true}, SHIFT(387),
  [742] = {.count = 1, .reusable = true}, SHIFT(2477),
  [744] = {.count = 1, .reusable = true}, SHIFT(2479),
  [746] = {.count = 1, .reusable = true}, SHIFT(2154),
  [748] = {.count = 1, .reusable = true}, SHIFT(1303),
  [750] = {.count = 1, .reusable = false}, SHIFT(1303),
  [752] = {.count = 1, .reusable = false}, SHIFT(1264),
  [754] = {.count = 1, .reusable = false}, SHIFT(874),
  [756] = {.count = 1, .reusable = false}, SHIFT(868),
  [758] = {.count = 1, .reusable = false}, SHIFT(404),
  [760] = {.count = 1, .reusable = false}, SHIFT(653),
  [762] = {.count = 1, .reusable = false}, SHIFT(355),
  [764] = {.count = 1, .reusable = false}, SHIFT(350),
  [766] = {.count = 1, .reusable = false}, SHIFT(110),
  [768] = {.count = 1, .reusable = false}, SHIFT(2990),
  [770] = {.count = 1, .reusable = false}, SHIFT(528),
  [772] = {.count = 1, .reusable = false}, SHIFT(197),
  [774] = {.count = 1, .reusable = true}, SHIFT(402),
  [776] = {.count = 1, .reusable = false}, SHIFT(279),
  [778] = {.count = 1, .reusable = false}, SHIFT(278),
  [780] = {.count = 1, .reusable = true}, SHIFT(278),
  [782] = {.count = 1, .reusable = false}, SHIFT(87),
  [784] = {.count = 1, .reusable = true}, SHIFT(276),
  [786] = {.count = 1, .reusable = true}, SHIFT(1288),
  [788] = {.count = 1, .reusable = false}, SHIFT(1288),
  [790] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(225),
  [793] = {.count = 1, .reusable = false}, SHIFT(225),
  [795] = {.count = 1, .reusable = false}, SHIFT(809),
  [797] = {.count = 1, .reusable = false}, SHIFT(870),
  [799] = {.count = 1, .reusable = true}, SHIFT(444),
  [801] = {.count = 1, .reusable = false}, SHIFT(654),
  [803] = {.count = 1, .reusable = false}, SHIFT(637),
  [805] = {.count = 1, .reusable = false}, SHIFT(206),
  [807] = {.count = 1, .reusable = true}, SHIFT(91),
  [809] = {.count = 1, .reusable = true}, SHIFT(2627),
  [811] = {.count = 1, .reusable = true}, SHIFT(95),
  [813] = {.count = 1, .reusable = true}, SHIFT(2137),
  [815] = {.count = 1, .reusable = false}, SHIFT(566),
  [817] = {.count = 1, .reusable = false}, SHIFT(182),
  [819] = {.count = 1, .reusable = true}, SHIFT(3017),
  [821] = {.count = 1, .reusable = true}, SHIFT(980),
  [823] = {.count = 1, .reusable = true}, SHIFT(732),
  [825] = {.count = 1, .reusable = true}, SHIFT(737),
  [827] = {.count = 1, .reusable = false}, SHIFT(356),
  [829] = {.count = 1, .reusable = false}, SHIFT(76),
  [831] = {.count = 1, .reusable = true}, SHIFT(1704),
  [833] = {.count = 1, .reusable = false}, SHIFT(1473),
  [835] = {.count = 1, .reusable = false}, SHIFT(1704),
  [837] = {.count = 1, .reusable = false}, SHIFT(1043),
  [839] = {.count = 1, .reusable = false}, SHIFT(611),
  [841] = {.count = 1, .reusable = false}, SHIFT(862),
  [843] = {.count = 1, .reusable = false}, SHIFT(571),
  [845] = {.count = 1, .reusable = false}, SHIFT(2745),
  [847] = {.count = 1, .reusable = true}, SHIFT(913),
  [849] = {.count = 1, .reusable = false}, SHIFT(1031),
  [851] = {.count = 1, .reusable = false}, SHIFT(1124),
  [853] = {.count = 1, .reusable = false}, SHIFT(842),
  [855] = {.count = 1, .reusable = false}, SHIFT(650),
  [857] = {.count = 1, .reusable = true}, SHIFT(155),
  [859] = {.count = 1, .reusable = false}, SHIFT(208),
  [861] = {.count = 1, .reusable = true}, SHIFT(963),
  [863] = {.count = 1, .reusable = false}, SHIFT(358),
  [865] = {.count = 1, .reusable = false}, SHIFT(83),
  [867] = {.count = 1, .reusable = true}, SHIFT(1735),
  [869] = {.count = 1, .reusable = false}, SHIFT(1723),
  [871] = {.count = 1, .reusable = false}, SHIFT(1735),
  [873] = {.count = 1, .reusable = false}, SHIFT(1219),
  [875] = {.count = 1, .reusable = false}, SHIFT(900),
  [877] = {.count = 1, .reusable = true}, SHIFT(1414),
  [879] = {.count = 1, .reusable = false}, SHIFT(1220),
  [881] = {.count = 1, .reusable = true}, SHIFT(2434),
  [883] = {.count = 1, .reusable = false}, SHIFT(1207),
  [885] = {.count = 1, .reusable = true}, SHIFT(1118),
  [887] = {.count = 1, .reusable = false}, SHIFT(1269),
  [889] = {.count = 1, .reusable = false}, SHIFT(676),
  [891] = {.count = 1, .reusable = false}, SHIFT(642),
  [893] = {.count = 1, .reusable = false}, SHIFT(181),
  [895] = {.count = 1, .reusable = false}, SHIFT(281),
  [897] = {.count = 1, .reusable = false}, SHIFT(62),
  [899] = {.count = 1, .reusable = true}, SHIFT(1045),
  [901] = {.count = 1, .reusable = false}, SHIFT(1027),
  [903] = {.count = 1, .reusable = false}, SHIFT(1045),
  [905] = {.count = 1, .reusable = false}, SHIFT(983),
  [907] = {.count = 1, .reusable = false}, SHIFT(734),
  [909] = {.count = 1, .reusable = false}, SHIFT(696),
  [911] = {.count = 1, .reusable = false}, SHIFT(636),
  [913] = {.count = 1, .reusable = false}, SHIFT(241),
  [915] = {.count = 1, .reusable = true}, SHIFT(93),
  [917] = {.count = 1, .reusable = true}, SHIFT(98),
  [919] = {.count = 1, .reusable = false}, SHIFT(243),
  [921] = {.count = 1, .reusable = false}, SHIFT(273),
  [923] = {.count = 1, .reusable = false}, SHIFT(68),
  [925] = {.count = 1, .reusable = true}, SHIFT(1488),
  [927] = {.count = 1, .reusable = false}, SHIFT(1487),
  [929] = {.count = 1, .reusable = false}, SHIFT(1488),
  [931] = {.count = 1, .reusable = false}, SHIFT(1106),
  [933] = {.count = 1, .reusable = false}, SHIFT(854),
  [935] = {.count = 1, .reusable = false}, SHIFT(711),
  [937] = {.count = 1, .reusable = false}, SHIFT(212),
  [939] = {.count = 1, .reusable = false}, SHIFT(211),
  [941] = {.count = 1, .reusable = false}, SHIFT(373),
  [943] = {.count = 1, .reusable = false}, SHIFT(67),
  [945] = {.count = 1, .reusable = true}, SHIFT(1451),
  [947] = {.count = 1, .reusable = false}, SHIFT(1450),
  [949] = {.count = 1, .reusable = false}, SHIFT(1451),
  [951] = {.count = 1, .reusable = false}, SHIFT(1239),
  [953] = {.count = 1, .reusable = false}, SHIFT(837),
  [955] = {.count = 1, .reusable = false}, SHIFT(673),
  [957] = {.count = 1, .reusable = true}, SHIFT(1940),
  [959] = {.count = 1, .reusable = false}, SHIFT(638),
  [961] = {.count = 1, .reusable = false}, SHIFT(183),
  [963] = {.count = 1, .reusable = true}, SHIFT(94),
  [965] = {.count = 1, .reusable = true}, SHIFT(99),
  [967] = {.count = 1, .reusable = false}, SHIFT(199),
  [969] = {.count = 1, .reusable = true}, SHIFT(1003),
  [971] = {.count = 1, .reusable = true}, SHIFT(815),
  [973] = {.count = 1, .reusable = true}, SHIFT(818),
  [975] = {.count = 1, .reusable = false}, SHIFT(407),
  [977] = {.count = 1, .reusable = false}, SHIFT(63),
  [979] = {.count = 1, .reusable = true}, SHIFT(1348),
  [981] = {.count = 1, .reusable = false}, SHIFT(1362),
  [983] = {.count = 1, .reusable = false}, SHIFT(1348),
  [985] = {.count = 1, .reusable = false}, SHIFT(1363),
  [987] = {.count = 1, .reusable = false}, SHIFT(791),
  [989] = {.count = 1, .reusable = false}, SHIFT(2613),
  [991] = {.count = 1, .reusable = true}, SHIFT(918),
  [993] = {.count = 1, .reusable = false}, SHIFT(808),
  [995] = {.count = 1, .reusable = false}, SHIFT(645),
  [997] = {.count = 1, .reusable = false}, SHIFT(198),
  [999] = {.count = 1, .reusable = true}, SHIFT(92),
  [1001] = {.count = 1, .reusable = true}, SHIFT(96),
  [1003] = {.count = 1, .reusable = true}, SHIFT(2157),
  [1005] = {.count = 1, .reusable = false}, SHIFT(250),
  [1007] = {.count = 1, .reusable = false}, SHIFT(376),
  [1009] = {.count = 1, .reusable = false}, SHIFT(84),
  [1011] = {.count = 1, .reusable = true}, SHIFT(1603),
  [1013] = {.count = 1, .reusable = false}, SHIFT(1609),
  [1015] = {.count = 1, .reusable = false}, SHIFT(1603),
  [1017] = {.count = 1, .reusable = false}, SHIFT(1258),
  [1019] = {.count = 1, .reusable = false}, SHIFT(863),
  [1021] = {.count = 1, .reusable = false}, SHIFT(385),
  [1023] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [1025] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [1027] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1029] = {.count = 1, .reusable = false}, SHIFT(1008),
  [1031] = {.count = 1, .reusable = false}, SHIFT(783),
  [1033] = {.count = 1, .reusable = false}, SHIFT(194),
  [1035] = {.count = 1, .reusable = false}, SHIFT(187),
  [1037] = {.count = 1, .reusable = false}, SHIFT(381),
  [1039] = {.count = 1, .reusable = false}, SHIFT(86),
  [1041] = {.count = 1, .reusable = false}, SHIFT(1177),
  [1043] = {.count = 1, .reusable = false}, SHIFT(883),
  [1045] = {.count = 1, .reusable = false}, SHIFT(817),
  [1047] = {.count = 1, .reusable = false}, SHIFT(235),
  [1049] = {.count = 1, .reusable = false}, SHIFT(238),
  [1051] = {.count = 1, .reusable = false}, SHIFT(303),
  [1053] = {.count = 1, .reusable = false}, SHIFT(81),
  [1055] = {.count = 1, .reusable = true}, SHIFT(1625),
  [1057] = {.count = 1, .reusable = false}, SHIFT(1665),
  [1059] = {.count = 1, .reusable = false}, SHIFT(1625),
  [1061] = {.count = 1, .reusable = false}, SHIFT(1364),
  [1063] = {.count = 1, .reusable = false}, SHIFT(869),
  [1065] = {.count = 1, .reusable = false}, SHIFT(408),
  [1067] = {.count = 1, .reusable = true}, SHIFT(1119),
  [1069] = {.count = 1, .reusable = false}, SHIFT(1119),
  [1071] = {.count = 1, .reusable = false}, SHIFT(275),
  [1073] = {.count = 1, .reusable = true}, SHIFT(1276),
  [1075] = {.count = 1, .reusable = false}, SHIFT(1276),
  [1077] = {.count = 1, .reusable = false}, SHIFT(368),
  [1079] = {.count = 1, .reusable = true}, SHIFT(1294),
  [1081] = {.count = 1, .reusable = false}, SHIFT(1294),
  [1083] = {.count = 1, .reusable = false}, SHIFT(347),
  [1085] = {.count = 1, .reusable = true}, SHIFT(1358),
  [1087] = {.count = 1, .reusable = false}, SHIFT(1358),
  [1089] = {.count = 1, .reusable = false}, SHIFT(372),
  [1091] = {.count = 1, .reusable = true}, SHIFT(1315),
  [1093] = {.count = 1, .reusable = false}, SHIFT(1315),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 5),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 5),
  [1099] = {.count = 1, .reusable = true}, SHIFT(27),
  [1101] = {.count = 1, .reusable = false}, SHIFT(3125),
  [1103] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1105] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1107] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1109] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1111] = {.count = 1, .reusable = true}, SHIFT(478),
  [1113] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1115] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1117] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 135),
  [1119] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 135),
  [1121] = {.count = 1, .reusable = true}, SHIFT(577),
  [1123] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 125),
  [1125] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 125),
  [1127] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 125),
  [1129] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 125),
  [1131] = {.count = 1, .reusable = true}, SHIFT(599),
  [1133] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1135] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1137] = {.count = 1, .reusable = true}, SHIFT(131),
  [1139] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 95),
  [1141] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 95),
  [1143] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 95),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 95),
  [1147] = {.count = 1, .reusable = true}, SHIFT(581),
  [1149] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [1151] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [1153] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 154),
  [1155] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 154),
  [1157] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 154),
  [1159] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 154),
  [1161] = {.count = 1, .reusable = true}, SHIFT(538),
  [1163] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1165] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1167] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1169] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1171] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [1173] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [1175] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 157),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 157),
  [1179] = {.count = 1, .reusable = true}, SHIFT(532),
  [1181] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 28),
  [1183] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 28),
  [1185] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 94),
  [1187] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 94),
  [1189] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 94),
  [1191] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 94),
  [1193] = {.count = 1, .reusable = true}, SHIFT(576),
  [1195] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [1197] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [1199] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [1201] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [1203] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 50),
  [1205] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 50),
  [1207] = {.count = 1, .reusable = true}, SHIFT(530),
  [1209] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1211] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1213] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [1215] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [1217] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [1219] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [1221] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1223] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1225] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 103),
  [1227] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 103),
  [1229] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 103),
  [1231] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 103),
  [1233] = {.count = 1, .reusable = true}, SHIFT(600),
  [1235] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [1237] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [1239] = {.count = 1, .reusable = true}, SHIFT(122),
  [1241] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [1243] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [1245] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 134),
  [1247] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 134),
  [1249] = {.count = 1, .reusable = true}, SHIFT(540),
  [1251] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 129),
  [1253] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 129),
  [1255] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [1257] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [1259] = {.count = 1, .reusable = true}, SHIFT(558),
  [1261] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 129),
  [1263] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 129),
  [1265] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 129),
  [1267] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 129),
  [1269] = {.count = 1, .reusable = true}, SHIFT(559),
  [1271] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1273] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1275] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 106),
  [1277] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 106),
  [1279] = {.count = 1, .reusable = true}, SHIFT(544),
  [1281] = {.count = 1, .reusable = false}, SHIFT(835),
  [1283] = {.count = 1, .reusable = false}, SHIFT(836),
  [1285] = {.count = 1, .reusable = false}, SHIFT(641),
  [1287] = {.count = 1, .reusable = false}, SHIFT(203),
  [1289] = {.count = 1, .reusable = false}, SHIFT(202),
  [1291] = {.count = 1, .reusable = false}, SHIFT(504),
  [1293] = {.count = 1, .reusable = false}, SHIFT(66),
  [1295] = {.count = 1, .reusable = false}, SHIFT(861),
  [1297] = {.count = 1, .reusable = false}, SHIFT(77),
  [1299] = {.count = 1, .reusable = true}, SHIFT(1124),
  [1301] = {.count = 1, .reusable = false}, SHIFT(1499),
  [1303] = {.count = 1, .reusable = true}, SHIFT(1031),
  [1305] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1307] = {.count = 1, .reusable = false}, SHIFT(884),
  [1309] = {.count = 1, .reusable = false}, SHIFT(882),
  [1311] = {.count = 1, .reusable = false}, SHIFT(656),
  [1313] = {.count = 1, .reusable = false}, SHIFT(568),
  [1315] = {.count = 1, .reusable = false}, SHIFT(73),
  [1317] = {.count = 1, .reusable = true}, SHIFT(1214),
  [1319] = {.count = 1, .reusable = false}, SHIFT(1214),
  [1321] = {.count = 1, .reusable = true}, SHIFT(1505),
  [1323] = {.count = 1, .reusable = true}, SHIFT(1300),
  [1325] = {.count = 1, .reusable = false}, SHIFT(1300),
  [1327] = {.count = 1, .reusable = true}, SHIFT(2432),
  [1329] = {.count = 1, .reusable = true}, SHIFT(1319),
  [1331] = {.count = 1, .reusable = false}, SHIFT(1319),
  [1333] = {.count = 1, .reusable = true}, SHIFT(1307),
  [1335] = {.count = 1, .reusable = false}, SHIFT(1307),
  [1337] = {.count = 1, .reusable = true}, SHIFT(1219),
  [1339] = {.count = 1, .reusable = true}, SHIFT(1771),
  [1341] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1343] = {.count = 1, .reusable = false}, SHIFT(1209),
  [1345] = {.count = 1, .reusable = true}, SHIFT(1705),
  [1347] = {.count = 1, .reusable = true}, SHIFT(1211),
  [1349] = {.count = 1, .reusable = false}, SHIFT(1211),
  [1351] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [1353] = {.count = 1, .reusable = true}, SHIFT(1410),
  [1355] = {.count = 1, .reusable = false}, SHIFT(1410),
  [1357] = {.count = 1, .reusable = true}, SHIFT(1207),
  [1359] = {.count = 1, .reusable = true}, SHIFT(1213),
  [1361] = {.count = 1, .reusable = false}, SHIFT(1213),
  [1363] = {.count = 1, .reusable = true}, SHIFT(1039),
  [1365] = {.count = 1, .reusable = true}, SHIFT(1295),
  [1367] = {.count = 1, .reusable = false}, SHIFT(1295),
  [1369] = {.count = 1, .reusable = true}, SHIFT(1220),
  [1371] = {.count = 1, .reusable = true}, SHIFT(1299),
  [1373] = {.count = 1, .reusable = false}, SHIFT(1299),
  [1375] = {.count = 1, .reusable = true}, SHIFT(1269),
  [1377] = {.count = 1, .reusable = true}, SHIFT(2426),
  [1379] = {.count = 1, .reusable = true}, SHIFT(357),
  [1381] = {.count = 1, .reusable = true}, SHIFT(1352),
  [1383] = {.count = 1, .reusable = false}, SHIFT(1352),
  [1385] = {.count = 1, .reusable = true}, SHIFT(2701),
  [1387] = {.count = 1, .reusable = true}, SHIFT(1337),
  [1389] = {.count = 1, .reusable = false}, SHIFT(1337),
  [1391] = {.count = 1, .reusable = false}, SHIFT(824),
  [1393] = {.count = 1, .reusable = true}, SHIFT(1029),
  [1395] = {.count = 1, .reusable = true}, SHIFT(1265),
  [1397] = {.count = 1, .reusable = false}, SHIFT(1265),
  [1399] = {.count = 1, .reusable = false}, SHIFT(841),
  [1401] = {.count = 1, .reusable = true}, SHIFT(1215),
  [1403] = {.count = 1, .reusable = false}, SHIFT(1215),
  [1405] = {.count = 1, .reusable = false}, SHIFT(919),
  [1407] = {.count = 1, .reusable = false}, SHIFT(912),
  [1409] = {.count = 1, .reusable = false}, SHIFT(663),
  [1411] = {.count = 1, .reusable = false}, SHIFT(352),
  [1413] = {.count = 1, .reusable = false}, SHIFT(613),
  [1415] = {.count = 1, .reusable = false}, SHIFT(89),
  [1417] = {.count = 1, .reusable = true}, SHIFT(1591),
  [1419] = {.count = 1, .reusable = false}, SHIFT(1591),
  [1421] = {.count = 1, .reusable = false}, SHIFT(745),
  [1423] = {.count = 1, .reusable = true}, SHIFT(1071),
  [1425] = {.count = 1, .reusable = false}, SHIFT(1071),
  [1427] = {.count = 1, .reusable = false}, SHIFT(720),
  [1429] = {.count = 1, .reusable = true}, SHIFT(1023),
  [1431] = {.count = 1, .reusable = false}, SHIFT(1023),
  [1433] = {.count = 1, .reusable = true}, SHIFT(594),
  [1435] = {.count = 1, .reusable = true}, SHIFT(1293),
  [1437] = {.count = 1, .reusable = false}, SHIFT(1293),
  [1439] = {.count = 1, .reusable = true}, SHIFT(41),
  [1441] = {.count = 1, .reusable = true}, SHIFT(1387),
  [1443] = {.count = 1, .reusable = false}, SHIFT(1387),
  [1445] = {.count = 1, .reusable = true}, SHIFT(45),
  [1447] = {.count = 1, .reusable = true}, SHIFT(1397),
  [1449] = {.count = 1, .reusable = false}, SHIFT(1397),
  [1451] = {.count = 1, .reusable = true}, SHIFT(47),
  [1453] = {.count = 1, .reusable = true}, SHIFT(1384),
  [1455] = {.count = 1, .reusable = false}, SHIFT(1384),
  [1457] = {.count = 1, .reusable = true}, SHIFT(3),
  [1459] = {.count = 1, .reusable = true}, SHIFT(1128),
  [1461] = {.count = 1, .reusable = false}, SHIFT(1128),
  [1463] = {.count = 1, .reusable = true}, SHIFT(1404),
  [1465] = {.count = 1, .reusable = false}, SHIFT(1404),
  [1467] = {.count = 1, .reusable = true}, SHIFT(1405),
  [1469] = {.count = 1, .reusable = false}, SHIFT(1405),
  [1471] = {.count = 1, .reusable = false}, SHIFT(852),
  [1473] = {.count = 1, .reusable = false}, SHIFT(858),
  [1475] = {.count = 1, .reusable = false}, SHIFT(639),
  [1477] = {.count = 1, .reusable = false}, SHIFT(2994),
  [1479] = {.count = 1, .reusable = false}, SHIFT(518),
  [1481] = {.count = 1, .reusable = false}, SHIFT(75),
  [1483] = {.count = 1, .reusable = true}, SHIFT(1494),
  [1485] = {.count = 1, .reusable = false}, SHIFT(1494),
  [1487] = {.count = 1, .reusable = false}, SHIFT(1602),
  [1489] = {.count = 1, .reusable = true}, SHIFT(1286),
  [1491] = {.count = 1, .reusable = false}, SHIFT(1286),
  [1493] = {.count = 1, .reusable = true}, SHIFT(2),
  [1495] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1497] = {.count = 1, .reusable = false}, SHIFT(1019),
  [1499] = {.count = 1, .reusable = false}, SHIFT(903),
  [1501] = {.count = 1, .reusable = false}, SHIFT(909),
  [1503] = {.count = 1, .reusable = false}, SHIFT(658),
  [1505] = {.count = 1, .reusable = false}, SHIFT(608),
  [1507] = {.count = 1, .reusable = false}, SHIFT(85),
  [1509] = {.count = 1, .reusable = true}, SHIFT(1524),
  [1511] = {.count = 1, .reusable = false}, SHIFT(1524),
  [1513] = {.count = 1, .reusable = false}, SHIFT(751),
  [1515] = {.count = 1, .reusable = false}, SHIFT(691),
  [1517] = {.count = 1, .reusable = false}, SHIFT(703),
  [1519] = {.count = 1, .reusable = false}, SHIFT(628),
  [1521] = {.count = 1, .reusable = false}, SHIFT(3115),
  [1523] = {.count = 1, .reusable = false}, SHIFT(468),
  [1525] = {.count = 1, .reusable = false}, SHIFT(60),
  [1527] = {.count = 1, .reusable = true}, SHIFT(1007),
  [1529] = {.count = 1, .reusable = false}, SHIFT(1007),
  [1531] = {.count = 1, .reusable = false}, SHIFT(802),
  [1533] = {.count = 1, .reusable = true}, SHIFT(1407),
  [1535] = {.count = 1, .reusable = false}, SHIFT(1407),
  [1537] = {.count = 1, .reusable = false}, SHIFT(779),
  [1539] = {.count = 1, .reusable = false}, SHIFT(781),
  [1541] = {.count = 1, .reusable = false}, SHIFT(631),
  [1543] = {.count = 1, .reusable = false}, SHIFT(3029),
  [1545] = {.count = 1, .reusable = false}, SHIFT(495),
  [1547] = {.count = 1, .reusable = false}, SHIFT(61),
  [1549] = {.count = 1, .reusable = true}, SHIFT(1386),
  [1551] = {.count = 1, .reusable = false}, SHIFT(1386),
  [1553] = {.count = 1, .reusable = false}, SHIFT(1581),
  [1555] = {.count = 1, .reusable = true}, SHIFT(1326),
  [1557] = {.count = 1, .reusable = false}, SHIFT(1326),
  [1559] = {.count = 1, .reusable = false}, SHIFT(838),
  [1561] = {.count = 1, .reusable = false}, SHIFT(848),
  [1563] = {.count = 1, .reusable = false}, SHIFT(633),
  [1565] = {.count = 1, .reusable = false}, SHIFT(510),
  [1567] = {.count = 1, .reusable = false}, SHIFT(80),
  [1569] = {.count = 1, .reusable = true}, SHIFT(1103),
  [1571] = {.count = 1, .reusable = false}, SHIFT(1103),
  [1573] = {.count = 1, .reusable = true}, SHIFT(1195),
  [1575] = {.count = 1, .reusable = false}, SHIFT(1195),
  [1577] = {.count = 1, .reusable = true}, SHIFT(1196),
  [1579] = {.count = 1, .reusable = false}, SHIFT(1196),
  [1581] = {.count = 1, .reusable = true}, SHIFT(1228),
  [1583] = {.count = 1, .reusable = false}, SHIFT(1228),
  [1585] = {.count = 1, .reusable = true}, SHIFT(1197),
  [1587] = {.count = 1, .reusable = false}, SHIFT(1197),
  [1589] = {.count = 1, .reusable = true}, SHIFT(1199),
  [1591] = {.count = 1, .reusable = false}, SHIFT(1199),
  [1593] = {.count = 1, .reusable = false}, SHIFT(867),
  [1595] = {.count = 1, .reusable = true}, SHIFT(1399),
  [1597] = {.count = 1, .reusable = false}, SHIFT(1399),
  [1599] = {.count = 1, .reusable = false}, SHIFT(2839),
  [1601] = {.count = 1, .reusable = true}, SHIFT(392),
  [1603] = {.count = 1, .reusable = false}, SHIFT(306),
  [1605] = {.count = 1, .reusable = false}, SHIFT(3130),
  [1607] = {.count = 1, .reusable = true}, SHIFT(2129),
  [1609] = {.count = 1, .reusable = true}, SHIFT(2127),
  [1611] = {.count = 1, .reusable = true}, SHIFT(3123),
  [1613] = {.count = 1, .reusable = true}, SHIFT(3122),
  [1615] = {.count = 1, .reusable = true}, SHIFT(2122),
  [1617] = {.count = 1, .reusable = true}, SHIFT(2121),
  [1619] = {.count = 1, .reusable = true}, SHIFT(2108),
  [1621] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1624] = {.count = 1, .reusable = true}, SHIFT(2976),
  [1626] = {.count = 1, .reusable = true}, SHIFT(3117),
  [1628] = {.count = 1, .reusable = true}, SHIFT(3110),
  [1630] = {.count = 1, .reusable = true}, SHIFT(2863),
  [1632] = {.count = 1, .reusable = true}, SHIFT(3162),
  [1634] = {.count = 1, .reusable = true}, SHIFT(1756),
  [1636] = {.count = 1, .reusable = true}, SHIFT(2144),
  [1638] = {.count = 1, .reusable = true}, SHIFT(3161),
  [1640] = {.count = 1, .reusable = true}, SHIFT(3160),
  [1642] = {.count = 1, .reusable = false}, SHIFT(880),
  [1644] = {.count = 1, .reusable = true}, SHIFT(1392),
  [1646] = {.count = 1, .reusable = false}, SHIFT(1392),
  [1648] = {.count = 1, .reusable = false}, SHIFT(827),
  [1650] = {.count = 1, .reusable = false}, SHIFT(825),
  [1652] = {.count = 1, .reusable = false}, SHIFT(644),
  [1654] = {.count = 1, .reusable = false}, SHIFT(516),
  [1656] = {.count = 1, .reusable = false}, SHIFT(65),
  [1658] = {.count = 1, .reusable = false}, SHIFT(671),
  [1660] = {.count = 1, .reusable = false}, SHIFT(920),
  [1662] = {.count = 1, .reusable = false}, SHIFT(668),
  [1664] = {.count = 1, .reusable = false}, SHIFT(612),
  [1666] = {.count = 1, .reusable = false}, SHIFT(90),
  [1668] = {.count = 1, .reusable = true}, SHIFT(1390),
  [1670] = {.count = 1, .reusable = false}, SHIFT(1390),
  [1672] = {.count = 1, .reusable = true}, SHIFT(1127),
  [1674] = {.count = 1, .reusable = false}, SHIFT(1127),
  [1676] = {.count = 1, .reusable = false}, SHIFT(877),
  [1678] = {.count = 1, .reusable = true}, SHIFT(5),
  [1680] = {.count = 1, .reusable = true}, SHIFT(1181),
  [1682] = {.count = 1, .reusable = false}, SHIFT(1181),
  [1684] = {.count = 1, .reusable = false}, SHIFT(901),
  [1686] = {.count = 1, .reusable = true}, SHIFT(972),
  [1688] = {.count = 1, .reusable = false}, SHIFT(972),
  [1690] = {.count = 1, .reusable = true}, SHIFT(1180),
  [1692] = {.count = 1, .reusable = false}, SHIFT(1180),
  [1694] = {.count = 1, .reusable = false}, SHIFT(851),
  [1696] = {.count = 1, .reusable = true}, SHIFT(1227),
  [1698] = {.count = 1, .reusable = false}, SHIFT(1227),
  [1700] = {.count = 1, .reusable = true}, SHIFT(1129),
  [1702] = {.count = 1, .reusable = false}, SHIFT(1129),
  [1704] = {.count = 1, .reusable = true}, SHIFT(977),
  [1706] = {.count = 1, .reusable = false}, SHIFT(977),
  [1708] = {.count = 1, .reusable = true}, SHIFT(1186),
  [1710] = {.count = 1, .reusable = false}, SHIFT(1186),
  [1712] = {.count = 1, .reusable = true}, SHIFT(1330),
  [1714] = {.count = 1, .reusable = false}, SHIFT(1330),
  [1716] = {.count = 1, .reusable = true}, SHIFT(1334),
  [1718] = {.count = 1, .reusable = false}, SHIFT(1334),
  [1720] = {.count = 1, .reusable = true}, SHIFT(1229),
  [1722] = {.count = 1, .reusable = false}, SHIFT(1229),
  [1724] = {.count = 1, .reusable = true}, SHIFT(1340),
  [1726] = {.count = 1, .reusable = false}, SHIFT(1340),
  [1728] = {.count = 1, .reusable = true}, SHIFT(1021),
  [1730] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1732] = {.count = 1, .reusable = true}, SHIFT(1230),
  [1734] = {.count = 1, .reusable = false}, SHIFT(1230),
  [1736] = {.count = 1, .reusable = true}, SHIFT(1205),
  [1738] = {.count = 1, .reusable = false}, SHIFT(1205),
  [1740] = {.count = 1, .reusable = true}, SHIFT(1335),
  [1742] = {.count = 1, .reusable = false}, SHIFT(1335),
  [1744] = {.count = 1, .reusable = true}, SHIFT(1344),
  [1746] = {.count = 1, .reusable = false}, SHIFT(1344),
  [1748] = {.count = 1, .reusable = true}, SHIFT(973),
  [1750] = {.count = 1, .reusable = false}, SHIFT(973),
  [1752] = {.count = 1, .reusable = true}, SHIFT(1338),
  [1754] = {.count = 1, .reusable = false}, SHIFT(1338),
  [1756] = {.count = 1, .reusable = true}, SHIFT(1354),
  [1758] = {.count = 1, .reusable = false}, SHIFT(1354),
  [1760] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1762] = {.count = 1, .reusable = false}, SHIFT(1017),
  [1764] = {.count = 1, .reusable = true}, SHIFT(1284),
  [1766] = {.count = 1, .reusable = false}, SHIFT(1284),
  [1768] = {.count = 1, .reusable = true}, SHIFT(1371),
  [1770] = {.count = 1, .reusable = false}, SHIFT(1371),
  [1772] = {.count = 1, .reusable = true}, SHIFT(1372),
  [1774] = {.count = 1, .reusable = false}, SHIFT(1372),
  [1776] = {.count = 1, .reusable = true}, SHIFT(1370),
  [1778] = {.count = 1, .reusable = false}, SHIFT(1370),
  [1780] = {.count = 1, .reusable = true}, SHIFT(1373),
  [1782] = {.count = 1, .reusable = false}, SHIFT(1373),
  [1784] = {.count = 1, .reusable = false}, SHIFT(860),
  [1786] = {.count = 1, .reusable = false}, SHIFT(881),
  [1788] = {.count = 1, .reusable = false}, SHIFT(886),
  [1790] = {.count = 1, .reusable = false}, SHIFT(652),
  [1792] = {.count = 1, .reusable = false}, SHIFT(549),
  [1794] = {.count = 1, .reusable = false}, SHIFT(74),
  [1796] = {.count = 1, .reusable = true}, SHIFT(1083),
  [1798] = {.count = 1, .reusable = false}, SHIFT(1083),
  [1800] = {.count = 1, .reusable = true}, SHIFT(1332),
  [1802] = {.count = 1, .reusable = false}, SHIFT(1332),
  [1804] = {.count = 1, .reusable = false}, SHIFT(845),
  [1806] = {.count = 1, .reusable = true}, SHIFT(1204),
  [1808] = {.count = 1, .reusable = false}, SHIFT(1204),
  [1810] = {.count = 1, .reusable = true}, SHIFT(1241),
  [1812] = {.count = 1, .reusable = false}, SHIFT(1241),
  [1814] = {.count = 1, .reusable = true}, SHIFT(1069),
  [1816] = {.count = 1, .reusable = false}, SHIFT(1069),
  [1818] = {.count = 1, .reusable = true}, SHIFT(984),
  [1820] = {.count = 1, .reusable = false}, SHIFT(984),
  [1822] = {.count = 1, .reusable = true}, SHIFT(989),
  [1824] = {.count = 1, .reusable = false}, SHIFT(989),
  [1826] = {.count = 1, .reusable = true}, SHIFT(1246),
  [1828] = {.count = 1, .reusable = false}, SHIFT(1246),
  [1830] = {.count = 1, .reusable = true}, SHIFT(1113),
  [1832] = {.count = 1, .reusable = false}, SHIFT(1113),
  [1834] = {.count = 1, .reusable = true}, SHIFT(1267),
  [1836] = {.count = 1, .reusable = false}, SHIFT(1267),
  [1838] = {.count = 1, .reusable = true}, SHIFT(1312),
  [1840] = {.count = 1, .reusable = false}, SHIFT(1312),
  [1842] = {.count = 1, .reusable = true}, SHIFT(1225),
  [1844] = {.count = 1, .reusable = false}, SHIFT(1225),
  [1846] = {.count = 1, .reusable = true}, SHIFT(1328),
  [1848] = {.count = 1, .reusable = false}, SHIFT(1328),
  [1850] = {.count = 1, .reusable = true}, SHIFT(1365),
  [1852] = {.count = 1, .reusable = false}, SHIFT(1365),
  [1854] = {.count = 1, .reusable = true}, SHIFT(1106),
  [1856] = {.count = 1, .reusable = true}, SHIFT(1077),
  [1858] = {.count = 1, .reusable = false}, SHIFT(1077),
  [1860] = {.count = 1, .reusable = true}, SHIFT(1486),
  [1862] = {.count = 1, .reusable = false}, SHIFT(1486),
  [1864] = {.count = 1, .reusable = true}, SHIFT(1107),
  [1866] = {.count = 1, .reusable = false}, SHIFT(1107),
  [1868] = {.count = 1, .reusable = true}, SHIFT(1108),
  [1870] = {.count = 1, .reusable = false}, SHIFT(1108),
  [1872] = {.count = 1, .reusable = true}, SHIFT(1109),
  [1874] = {.count = 1, .reusable = false}, SHIFT(1109),
  [1876] = {.count = 1, .reusable = true}, SHIFT(1110),
  [1878] = {.count = 1, .reusable = false}, SHIFT(1110),
  [1880] = {.count = 1, .reusable = true}, SHIFT(1356),
  [1882] = {.count = 1, .reusable = false}, SHIFT(1356),
  [1884] = {.count = 1, .reusable = true}, SHIFT(1111),
  [1886] = {.count = 1, .reusable = false}, SHIFT(1111),
  [1888] = {.count = 1, .reusable = true}, SHIFT(1112),
  [1890] = {.count = 1, .reusable = false}, SHIFT(1112),
  [1892] = {.count = 1, .reusable = true}, SHIFT(1104),
  [1894] = {.count = 1, .reusable = false}, SHIFT(1104),
  [1896] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1898] = {.count = 1, .reusable = false}, SHIFT(1247),
  [1900] = {.count = 1, .reusable = true}, SHIFT(1245),
  [1902] = {.count = 1, .reusable = false}, SHIFT(1245),
  [1904] = {.count = 1, .reusable = true}, SHIFT(1480),
  [1906] = {.count = 1, .reusable = false}, SHIFT(1098),
  [1908] = {.count = 1, .reusable = true}, SHIFT(988),
  [1910] = {.count = 1, .reusable = false}, SHIFT(988),
  [1912] = {.count = 1, .reusable = true}, SHIFT(1244),
  [1914] = {.count = 1, .reusable = false}, SHIFT(1244),
  [1916] = {.count = 1, .reusable = true}, SHIFT(957),
  [1918] = {.count = 1, .reusable = false}, SHIFT(957),
  [1920] = {.count = 1, .reusable = true}, SHIFT(1292),
  [1922] = {.count = 1, .reusable = false}, SHIFT(1292),
  [1924] = {.count = 1, .reusable = true}, SHIFT(1298),
  [1926] = {.count = 1, .reusable = false}, SHIFT(1298),
  [1928] = {.count = 1, .reusable = true}, SHIFT(1297),
  [1930] = {.count = 1, .reusable = false}, SHIFT(1297),
  [1932] = {.count = 1, .reusable = true}, SHIFT(1560),
  [1934] = {.count = 1, .reusable = false}, SHIFT(1560),
  [1936] = {.count = 1, .reusable = true}, SHIFT(1072),
  [1938] = {.count = 1, .reusable = false}, SHIFT(1002),
  [1940] = {.count = 1, .reusable = true}, SHIFT(1296),
  [1942] = {.count = 1, .reusable = false}, SHIFT(1296),
  [1944] = {.count = 1, .reusable = true}, SHIFT(1355),
  [1946] = {.count = 1, .reusable = false}, SHIFT(1355),
  [1948] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1950] = {.count = 1, .reusable = true}, SHIFT(986),
  [1952] = {.count = 1, .reusable = false}, SHIFT(986),
  [1954] = {.count = 1, .reusable = true}, SHIFT(1379),
  [1956] = {.count = 1, .reusable = false}, SHIFT(1379),
  [1958] = {.count = 1, .reusable = true}, SHIFT(1311),
  [1960] = {.count = 1, .reusable = false}, SHIFT(1311),
  [1962] = {.count = 1, .reusable = true}, SHIFT(1463),
  [1964] = {.count = 1, .reusable = false}, SHIFT(1463),
  [1966] = {.count = 1, .reusable = true}, SHIFT(983),
  [1968] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1970] = {.count = 1, .reusable = false}, SHIFT(1001),
  [1972] = {.count = 1, .reusable = true}, SHIFT(1242),
  [1974] = {.count = 1, .reusable = false}, SHIFT(1242),
  [1976] = {.count = 1, .reusable = true}, SHIFT(1283),
  [1978] = {.count = 1, .reusable = false}, SHIFT(1283),
  [1980] = {.count = 1, .reusable = true}, SHIFT(1188),
  [1982] = {.count = 1, .reusable = false}, SHIFT(1188),
  [1984] = {.count = 1, .reusable = true}, SHIFT(976),
  [1986] = {.count = 1, .reusable = false}, SHIFT(976),
  [1988] = {.count = 1, .reusable = true}, SHIFT(1302),
  [1990] = {.count = 1, .reusable = false}, SHIFT(1302),
  [1992] = {.count = 1, .reusable = true}, SHIFT(1189),
  [1994] = {.count = 1, .reusable = false}, SHIFT(1189),
  [1996] = {.count = 1, .reusable = true}, SHIFT(1174),
  [1998] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2000] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2002] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2004] = {.count = 1, .reusable = true}, SHIFT(1375),
  [2006] = {.count = 1, .reusable = false}, SHIFT(1375),
  [2008] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2010] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2012] = {.count = 1, .reusable = true}, SHIFT(975),
  [2014] = {.count = 1, .reusable = false}, SHIFT(975),
  [2016] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2018] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2020] = {.count = 1, .reusable = true}, SHIFT(994),
  [2022] = {.count = 1, .reusable = false}, SHIFT(994),
  [2024] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2026] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2028] = {.count = 1, .reusable = false}, SHIFT(844),
  [2030] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2032] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2034] = {.count = 1, .reusable = true}, SHIFT(974),
  [2036] = {.count = 1, .reusable = false}, SHIFT(974),
  [2038] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2040] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2042] = {.count = 1, .reusable = false}, SHIFT(1075),
  [2044] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2046] = {.count = 1, .reusable = false}, SHIFT(1464),
  [2048] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2050] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2052] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2054] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2056] = {.count = 1, .reusable = true}, SHIFT(995),
  [2058] = {.count = 1, .reusable = false}, SHIFT(995),
  [2060] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2062] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2064] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2066] = {.count = 1, .reusable = false}, SHIFT(1233),
  [2068] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2070] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2072] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2074] = {.count = 1, .reusable = false}, SHIFT(1350),
  [2076] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2078] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2080] = {.count = 1, .reusable = true}, SHIFT(978),
  [2082] = {.count = 1, .reusable = false}, SHIFT(978),
  [2084] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2086] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2088] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2090] = {.count = 1, .reusable = false}, SHIFT(1346),
  [2092] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2094] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2096] = {.count = 1, .reusable = true}, SHIFT(1509),
  [2098] = {.count = 1, .reusable = false}, SHIFT(1509),
  [2100] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2104] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2106] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2108] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2112] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2116] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2118] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2120] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2124] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2128] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2132] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2134] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2136] = {.count = 1, .reusable = false}, SHIFT(1121),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2142] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2146] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2150] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2154] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2156] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2158] = {.count = 1, .reusable = false}, SHIFT(840),
  [2160] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2162] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2166] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2170] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1506),
  [2174] = {.count = 1, .reusable = false}, SHIFT(1506),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2178] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2182] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2186] = {.count = 1, .reusable = false}, SHIFT(1068),
  [2188] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2190] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2192] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2194] = {.count = 1, .reusable = false}, SHIFT(1123),
  [2196] = {.count = 1, .reusable = false}, SHIFT(925),
  [2198] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2200] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2202] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2204] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1598),
  [2208] = {.count = 1, .reusable = true}, SHIFT(1504),
  [2210] = {.count = 1, .reusable = false}, SHIFT(1504),
  [2212] = {.count = 1, .reusable = true}, SHIFT(1724),
  [2214] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2216] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2220] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2226] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2228] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2232] = {.count = 1, .reusable = false}, SHIFT(1009),
  [2234] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2236] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2238] = {.count = 1, .reusable = false}, SHIFT(1096),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2244] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2246] = {.count = 1, .reusable = false}, SHIFT(1183),
  [2248] = {.count = 1, .reusable = false}, SHIFT(833),
  [2250] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2252] = {.count = 1, .reusable = false}, SHIFT(1061),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2256] = {.count = 1, .reusable = false}, SHIFT(1359),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2262] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2266] = {.count = 1, .reusable = false}, SHIFT(1268),
  [2268] = {.count = 1, .reusable = true}, SHIFT(1620),
  [2270] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2272] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2276] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2280] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2284] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2288] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2290] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2292] = {.count = 1, .reusable = false}, SHIFT(1014),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2296] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2300] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2304] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2306] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2308] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2310] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2312] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2314] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2316] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2318] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2320] = {.count = 1, .reusable = true}, SHIFT(1418),
  [2322] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2324] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2326] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2330] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2334] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2336] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2338] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2340] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2342] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2344] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2346] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2348] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2350] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2352] = {.count = 1, .reusable = false}, SHIFT(1377),
  [2354] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2356] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2358] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2360] = {.count = 1, .reusable = false}, SHIFT(1376),
  [2362] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2364] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2366] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2368] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2370] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2372] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2374] = {.count = 1, .reusable = false}, SHIFT(1066),
  [2376] = {.count = 1, .reusable = true}, SHIFT(2095),
  [2378] = {.count = 1, .reusable = true}, SHIFT(2911),
  [2380] = {.count = 1, .reusable = false}, SHIFT(378),
  [2382] = {.count = 1, .reusable = true}, SHIFT(2168),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1761),
  [2386] = {.count = 1, .reusable = true}, SHIFT(2191),
  [2388] = {.count = 1, .reusable = true}, SHIFT(1763),
  [2390] = {.count = 1, .reusable = true}, SHIFT(2097),
  [2392] = {.count = 1, .reusable = true}, SHIFT(2040),
  [2394] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [2396] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [2398] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2400] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2402] = {.count = 1, .reusable = false}, SHIFT(2530),
  [2404] = {.count = 1, .reusable = false}, SHIFT(2531),
  [2406] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1832),
  [2409] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1734),
  [2413] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(310),
  [2416] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2905),
  [2420] = {.count = 1, .reusable = false}, SHIFT(2049),
  [2422] = {.count = 1, .reusable = true}, SHIFT(2466),
  [2424] = {.count = 1, .reusable = true}, SHIFT(2464),
  [2426] = {.count = 1, .reusable = true}, SHIFT(2197),
  [2428] = {.count = 1, .reusable = false}, SHIFT(1775),
  [2430] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2432] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2434] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [2436] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [2438] = {.count = 1, .reusable = false}, SHIFT(2981),
  [2440] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [2442] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [2444] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [2446] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [2448] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [2450] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [2452] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [2454] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [2456] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [2458] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [2460] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [2462] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [2464] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [2466] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [2468] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [2470] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [2472] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [2474] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [2476] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2478] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2480] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2482] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [2484] = {.count = 1, .reusable = true}, SHIFT(687),
  [2486] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [2488] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [2490] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2492] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2494] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [2496] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [2498] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [2500] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [2502] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [2504] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [2506] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2508] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2510] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [2512] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2514] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2516] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [2518] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [2520] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2522] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2524] = {.count = 1, .reusable = false}, SHIFT(2199),
  [2526] = {.count = 1, .reusable = false}, SHIFT(1777),
  [2528] = {.count = 1, .reusable = false}, SHIFT(1807),
  [2530] = {.count = 1, .reusable = false}, SHIFT(1778),
  [2532] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2534] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2536] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(747),
  [2539] = {.count = 1, .reusable = false}, SHIFT(823),
  [2541] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [2543] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [2545] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2547] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2549] = {.count = 1, .reusable = true}, SHIFT(471),
  [2551] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2553] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2555] = {.count = 1, .reusable = false}, SHIFT(2630),
  [2557] = {.count = 1, .reusable = false}, SHIFT(2928),
  [2559] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [2561] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [2563] = {.count = 1, .reusable = false}, SHIFT(3112),
  [2565] = {.count = 1, .reusable = false}, SHIFT(3111),
  [2567] = {.count = 1, .reusable = true}, SHIFT(3077),
  [2569] = {.count = 1, .reusable = false}, SHIFT(2088),
  [2571] = {.count = 1, .reusable = false}, SHIFT(1893),
  [2573] = {.count = 1, .reusable = false}, SHIFT(2383),
  [2575] = {.count = 1, .reusable = false}, SHIFT(635),
  [2577] = {.count = 1, .reusable = false}, SHIFT(2959),
  [2579] = {.count = 1, .reusable = true}, SHIFT(475),
  [2581] = {.count = 1, .reusable = true}, SHIFT(97),
  [2583] = {.count = 1, .reusable = true}, SHIFT(2905),
  [2585] = {.count = 1, .reusable = false}, SHIFT(2460),
  [2587] = {.count = 1, .reusable = true}, SHIFT(3012),
  [2589] = {.count = 1, .reusable = false}, SHIFT(2031),
  [2591] = {.count = 1, .reusable = true}, SHIFT(436),
  [2593] = {.count = 1, .reusable = false}, SHIFT(2029),
  [2595] = {.count = 1, .reusable = false}, SHIFT(436),
  [2597] = {.count = 1, .reusable = false}, SHIFT(1828),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1799),
  [2601] = {.count = 1, .reusable = true}, SHIFT(480),
  [2603] = {.count = 1, .reusable = true}, SHIFT(467),
  [2605] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2607] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2609] = {.count = 1, .reusable = false}, SHIFT(2996),
  [2611] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [2613] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [2615] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(747),
  [2618] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [2620] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [2622] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [2624] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [2626] = {.count = 1, .reusable = true}, SHIFT(821),
  [2628] = {.count = 1, .reusable = true}, SHIFT(819),
  [2630] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [2632] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [2634] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [2636] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [2638] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1734),
  [2641] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2905),
  [2644] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [2646] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [2648] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [2650] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [2652] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2654] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2656] = {.count = 1, .reusable = true}, SHIFT(26),
  [2658] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 156),
  [2660] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 156),
  [2662] = {.count = 1, .reusable = false}, SHIFT(3023),
  [2664] = {.count = 1, .reusable = false}, SHIFT(3015),
  [2666] = {.count = 1, .reusable = false}, SHIFT(2077),
  [2668] = {.count = 1, .reusable = false}, SHIFT(2041),
  [2670] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [2672] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [2674] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [2676] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [2678] = {.count = 1, .reusable = false}, SHIFT(3002),
  [2680] = {.count = 1, .reusable = false}, SHIFT(3004),
  [2682] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2684] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2686] = {.count = 1, .reusable = false}, SHIFT(3032),
  [2688] = {.count = 1, .reusable = false}, SHIFT(3031),
  [2690] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [2692] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [2694] = {.count = 1, .reusable = false}, SHIFT(2988),
  [2696] = {.count = 1, .reusable = false}, SHIFT(3177),
  [2698] = {.count = 1, .reusable = true}, SHIFT(3027),
  [2700] = {.count = 1, .reusable = false}, SHIFT(2079),
  [2702] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [2704] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [2706] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 164),
  [2708] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 164),
  [2710] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [2712] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [2714] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2716] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2718] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 113),
  [2720] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 113),
  [2722] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [2724] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [2726] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 112),
  [2728] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 112),
  [2730] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 111),
  [2732] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 111),
  [2734] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2736] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2738] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [2740] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [2742] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [2744] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [2746] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [2748] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 6),
  [2752] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 6),
  [2754] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [2756] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [2760] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [2762] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [2764] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [2766] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 154),
  [2768] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 154),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2772] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2792] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2794] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 133),
  [2796] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 133),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2800] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2802] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2804] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2806] = {.count = 1, .reusable = false}, SHIFT(3107),
  [2808] = {.count = 1, .reusable = false}, SHIFT(3105),
  [2810] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [2812] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [2814] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 155),
  [2816] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 155),
  [2818] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 125),
  [2820] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 125),
  [2822] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 117),
  [2824] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 117),
  [2826] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [2828] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [2830] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2832] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2834] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [2836] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [2838] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 129),
  [2840] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 129),
  [2842] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [2844] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [2846] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 131),
  [2848] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 131),
  [2850] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 130),
  [2852] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 130),
  [2854] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 128),
  [2856] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 128),
  [2858] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 102),
  [2860] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 102),
  [2862] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2864] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2866] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2868] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2870] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [2872] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [2874] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2876] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2878] = {.count = 1, .reusable = false}, SHIFT(2415),
  [2880] = {.count = 1, .reusable = false}, SHIFT(2296),
  [2882] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2884] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(154),
  [2887] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2889] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2891] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2893] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2895] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [2897] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [2899] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [2901] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [2903] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [2905] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [2907] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2909] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2911] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [2913] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [2915] = {.count = 1, .reusable = false}, SHIFT(35),
  [2917] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [2919] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [2921] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2923] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2925] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2927] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2929] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [2931] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [2933] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 105),
  [2935] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 105),
  [2937] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [2939] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [2941] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [2943] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [2945] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2947] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2949] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2951] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2953] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 94),
  [2955] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 94),
  [2957] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 163),
  [2959] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 163),
  [2961] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2963] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [2965] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 139),
  [2967] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 139),
  [2969] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 95),
  [2971] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 95),
  [2973] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2975] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2977] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 125),
  [2979] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 125),
  [2981] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 103),
  [2983] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 103),
  [2985] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2987] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2989] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2991] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2993] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2995] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2997] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [2999] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [3001] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [3003] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [3005] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [3007] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [3009] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [3011] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [3013] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [3015] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3017] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 162),
  [3019] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 162),
  [3021] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3023] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3025] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 161),
  [3027] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 161),
  [3029] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3031] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3033] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 160),
  [3035] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 160),
  [3037] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [3039] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [3041] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 144),
  [3043] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 144),
  [3045] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 143),
  [3047] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 143),
  [3049] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3051] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3053] = {.count = 1, .reusable = false}, SHIFT(491),
  [3055] = {.count = 1, .reusable = false}, SHIFT(113),
  [3057] = {.count = 1, .reusable = true}, SHIFT(2475),
  [3059] = {.count = 1, .reusable = true}, SHIFT(2471),
  [3061] = {.count = 1, .reusable = false}, SHIFT(999),
  [3063] = {.count = 1, .reusable = true}, SHIFT(156),
  [3065] = {.count = 1, .reusable = true}, SHIFT(147),
  [3067] = {.count = 1, .reusable = false}, SHIFT(1011),
  [3069] = {.count = 1, .reusable = false}, SHIFT(1909),
  [3071] = {.count = 1, .reusable = false}, SHIFT(916),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1837),
  [3075] = {.count = 1, .reusable = true}, SHIFT(669),
  [3077] = {.count = 1, .reusable = true}, SHIFT(2023),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3081] = {.count = 1, .reusable = true}, SHIFT(952),
  [3083] = {.count = 1, .reusable = true}, SHIFT(146),
  [3085] = {.count = 1, .reusable = false}, SHIFT(1203),
  [3087] = {.count = 1, .reusable = false}, SHIFT(2518),
  [3089] = {.count = 1, .reusable = true}, SHIFT(2454),
  [3091] = {.count = 1, .reusable = true}, SHIFT(2452),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1880),
  [3095] = {.count = 1, .reusable = false}, SHIFT(1202),
  [3097] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3099] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3101] = {.count = 1, .reusable = false}, SHIFT(1200),
  [3103] = {.count = 1, .reusable = true}, SHIFT(441),
  [3105] = {.count = 1, .reusable = false}, SHIFT(1912),
  [3107] = {.count = 1, .reusable = false}, SHIFT(921),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1341),
  [3111] = {.count = 1, .reusable = false}, SHIFT(1278),
  [3113] = {.count = 1, .reusable = false}, SHIFT(1279),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1321),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1175),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1915),
  [3123] = {.count = 1, .reusable = false}, SHIFT(924),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1263),
  [3129] = {.count = 1, .reusable = false}, SHIFT(1262),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1374),
  [3133] = {.count = 1, .reusable = false}, SHIFT(1579),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1260),
  [3137] = {.count = 1, .reusable = true}, SHIFT(666),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1273),
  [3141] = {.count = 1, .reusable = true}, SHIFT(950),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1939),
  [3145] = {.count = 1, .reusable = true}, SHIFT(152),
  [3147] = {.count = 1, .reusable = true}, SHIFT(981),
  [3149] = {.count = 1, .reusable = false}, SHIFT(1916),
  [3151] = {.count = 1, .reusable = false}, SHIFT(917),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3155] = {.count = 1, .reusable = false}, SHIFT(1289),
  [3157] = {.count = 1, .reusable = false}, SHIFT(1254),
  [3159] = {.count = 1, .reusable = false}, SHIFT(1383),
  [3161] = {.count = 1, .reusable = false}, SHIFT(1610),
  [3163] = {.count = 1, .reusable = false}, SHIFT(1237),
  [3165] = {.count = 1, .reusable = false}, SHIFT(2484),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3169] = {.count = 1, .reusable = false}, SHIFT(1416),
  [3171] = {.count = 1, .reusable = false}, SHIFT(1353),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3175] = {.count = 1, .reusable = false}, SHIFT(923),
  [3177] = {.count = 1, .reusable = false}, SHIFT(2954),
  [3179] = {.count = 1, .reusable = true}, SHIFT(469),
  [3181] = {.count = 1, .reusable = true}, SHIFT(763),
  [3183] = {.count = 1, .reusable = false}, SHIFT(2508),
  [3185] = {.count = 1, .reusable = true}, SHIFT(998),
  [3187] = {.count = 1, .reusable = true}, SHIFT(814),
  [3189] = {.count = 1, .reusable = true}, SHIFT(816),
  [3191] = {.count = 1, .reusable = true}, SHIFT(3010),
  [3193] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3197] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3199] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3201] = {.count = 1, .reusable = false}, SHIFT(2680),
  [3203] = {.count = 1, .reusable = true}, SHIFT(923),
  [3205] = {.count = 1, .reusable = false}, SHIFT(2612),
  [3207] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3209] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3211] = {.count = 1, .reusable = false}, SHIFT(968),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1144),
  [3215] = {.count = 1, .reusable = false}, SHIFT(915),
  [3217] = {.count = 1, .reusable = false}, SHIFT(2894),
  [3219] = {.count = 1, .reusable = true}, SHIFT(482),
  [3221] = {.count = 1, .reusable = true}, SHIFT(777),
  [3223] = {.count = 1, .reusable = false}, SHIFT(2461),
  [3225] = {.count = 1, .reusable = true}, SHIFT(991),
  [3227] = {.count = 1, .reusable = true}, SHIFT(757),
  [3229] = {.count = 1, .reusable = true}, SHIFT(756),
  [3231] = {.count = 1, .reusable = true}, SHIFT(3074),
  [3233] = {.count = 1, .reusable = false}, SHIFT(1145),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1146),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1147),
  [3239] = {.count = 1, .reusable = false}, SHIFT(1146),
  [3241] = {.count = 1, .reusable = false}, SHIFT(2611),
  [3243] = {.count = 1, .reusable = true}, SHIFT(915),
  [3245] = {.count = 1, .reusable = false}, SHIFT(1969),
  [3247] = {.count = 1, .reusable = false}, SHIFT(931),
  [3249] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [3251] = {.count = 1, .reusable = false}, SHIFT(1385),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3255] = {.count = 1, .reusable = false}, SHIFT(1447),
  [3257] = {.count = 1, .reusable = false}, SHIFT(1727),
  [3259] = {.count = 1, .reusable = false}, SHIFT(1380),
  [3261] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 104),
  [3263] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 104),
  [3265] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3267] = {.count = 1, .reusable = false}, SHIFT(291),
  [3269] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3271] = {.count = 1, .reusable = true}, SHIFT(297),
  [3273] = {.count = 1, .reusable = false}, SHIFT(277),
  [3275] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [3277] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(220),
  [3280] = {.count = 1, .reusable = true}, SHIFT(220),
  [3282] = {.count = 1, .reusable = true}, SHIFT(778),
  [3284] = {.count = 1, .reusable = true}, SHIFT(3118),
  [3286] = {.count = 1, .reusable = true}, SHIFT(210),
  [3288] = {.count = 1, .reusable = false}, SHIFT(304),
  [3290] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3293] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(784),
  [3296] = {.count = 1, .reusable = true}, SHIFT(3201),
  [3298] = {.count = 1, .reusable = true}, SHIFT(249),
  [3300] = {.count = 1, .reusable = true}, SHIFT(274),
  [3302] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3305] = {.count = 1, .reusable = true}, SHIFT(799),
  [3307] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [3309] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [3311] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(770),
  [3314] = {.count = 1, .reusable = true}, SHIFT(3167),
  [3316] = {.count = 1, .reusable = true}, SHIFT(782),
  [3318] = {.count = 1, .reusable = false}, SHIFT(1280),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3322] = {.count = 1, .reusable = false}, SHIFT(926),
  [3324] = {.count = 1, .reusable = false}, SHIFT(2824),
  [3326] = {.count = 1, .reusable = true}, SHIFT(477),
  [3328] = {.count = 1, .reusable = true}, SHIFT(748),
  [3330] = {.count = 1, .reusable = false}, SHIFT(2540),
  [3332] = {.count = 1, .reusable = true}, SHIFT(1013),
  [3334] = {.count = 1, .reusable = true}, SHIFT(716),
  [3336] = {.count = 1, .reusable = true}, SHIFT(719),
  [3338] = {.count = 1, .reusable = true}, SHIFT(3155),
  [3340] = {.count = 1, .reusable = false}, SHIFT(1431),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3344] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3346] = {.count = 1, .reusable = false}, SHIFT(1432),
  [3348] = {.count = 1, .reusable = false}, SHIFT(2729),
  [3350] = {.count = 1, .reusable = true}, SHIFT(926),
  [3352] = {.count = 1, .reusable = false}, SHIFT(1866),
  [3354] = {.count = 1, .reusable = false}, SHIFT(913),
  [3356] = {.count = 1, .reusable = true}, SHIFT(728),
  [3358] = {.count = 1, .reusable = true}, SHIFT(1941),
  [3360] = {.count = 1, .reusable = false}, SHIFT(446),
  [3362] = {.count = 1, .reusable = false}, SHIFT(439),
  [3364] = {.count = 1, .reusable = true}, SHIFT(1133),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3368] = {.count = 1, .reusable = true}, SHIFT(1861),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3372] = {.count = 1, .reusable = false}, SHIFT(1869),
  [3374] = {.count = 1, .reusable = true}, SHIFT(2177),
  [3376] = {.count = 1, .reusable = false}, SHIFT(329),
  [3378] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3381] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3384] = {.count = 1, .reusable = true}, SHIFT(3043),
  [3386] = {.count = 1, .reusable = true}, SHIFT(237),
  [3388] = {.count = 1, .reusable = true}, SHIFT(305),
  [3390] = {.count = 1, .reusable = true}, SHIFT(435),
  [3392] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3394] = {.count = 1, .reusable = true}, SHIFT(2691),
  [3396] = {.count = 1, .reusable = true}, SHIFT(2692),
  [3398] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3400] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [3402] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [3404] = {.count = 1, .reusable = true}, SHIFT(465),
  [3406] = {.count = 1, .reusable = false}, SHIFT(309),
  [3408] = {.count = 1, .reusable = true}, SHIFT(3189),
  [3410] = {.count = 1, .reusable = true}, SHIFT(460),
  [3412] = {.count = 1, .reusable = true}, SHIFT(1172),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1944),
  [3416] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [3419] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [3422] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3425] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1173),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1962),
  [3435] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3438] = {.count = 1, .reusable = true}, SHIFT(3018),
  [3440] = {.count = 1, .reusable = false}, SHIFT(2009),
  [3442] = {.count = 1, .reusable = false}, SHIFT(2847),
  [3444] = {.count = 1, .reusable = false}, SHIFT(2523),
  [3446] = {.count = 1, .reusable = true}, SHIFT(979),
  [3448] = {.count = 1, .reusable = true}, SHIFT(743),
  [3450] = {.count = 1, .reusable = true}, SHIFT(742),
  [3452] = {.count = 1, .reusable = false}, SHIFT(1874),
  [3454] = {.count = 1, .reusable = false}, SHIFT(918),
  [3456] = {.count = 1, .reusable = false}, SHIFT(2914),
  [3458] = {.count = 1, .reusable = true}, SHIFT(481),
  [3460] = {.count = 1, .reusable = true}, SHIFT(801),
  [3462] = {.count = 1, .reusable = false}, SHIFT(2510),
  [3464] = {.count = 1, .reusable = true}, SHIFT(3066),
  [3466] = {.count = 1, .reusable = false}, SHIFT(1972),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1971),
  [3470] = {.count = 1, .reusable = false}, SHIFT(1968),
  [3472] = {.count = 1, .reusable = false}, SHIFT(1971),
  [3474] = {.count = 1, .reusable = false}, SHIFT(375),
  [3476] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [3478] = {.count = 1, .reusable = true}, SHIFT(165),
  [3480] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(755),
  [3483] = {.count = 1, .reusable = true}, SHIFT(3060),
  [3485] = {.count = 1, .reusable = true}, SHIFT(253),
  [3487] = {.count = 1, .reusable = true}, SHIFT(380),
  [3489] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [3491] = {.count = 1, .reusable = false}, SHIFT(452),
  [3493] = {.count = 1, .reusable = false}, SHIFT(2537),
  [3495] = {.count = 1, .reusable = true}, SHIFT(997),
  [3497] = {.count = 1, .reusable = true}, SHIFT(766),
  [3499] = {.count = 1, .reusable = true}, SHIFT(764),
  [3501] = {.count = 1, .reusable = false}, SHIFT(353),
  [3503] = {.count = 1, .reusable = true}, SHIFT(166),
  [3505] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(747),
  [3508] = {.count = 1, .reusable = true}, SHIFT(2980),
  [3510] = {.count = 1, .reusable = true}, SHIFT(244),
  [3512] = {.count = 1, .reusable = true}, SHIFT(345),
  [3514] = {.count = 1, .reusable = true}, SHIFT(3121),
  [3516] = {.count = 1, .reusable = true}, SHIFT(3204),
  [3518] = {.count = 1, .reusable = true}, SHIFT(3202),
  [3520] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(304),
  [3523] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3526] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3530] = {.count = 1, .reusable = true}, SHIFT(3151),
  [3532] = {.count = 1, .reusable = false}, SHIFT(339),
  [3534] = {.count = 1, .reusable = true}, SHIFT(3205),
  [3536] = {.count = 1, .reusable = true}, SHIFT(224),
  [3538] = {.count = 1, .reusable = true}, SHIFT(335),
  [3540] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [3542] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [3544] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3547] = {.count = 1, .reusable = true}, SHIFT(762),
  [3549] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(175),
  [3552] = {.count = 1, .reusable = true}, SHIFT(175),
  [3554] = {.count = 1, .reusable = true}, SHIFT(176),
  [3556] = {.count = 1, .reusable = true}, SHIFT(2367),
  [3558] = {.count = 1, .reusable = true}, SHIFT(3210),
  [3560] = {.count = 1, .reusable = true}, SHIFT(590),
  [3562] = {.count = 1, .reusable = true}, SHIFT(3104),
  [3564] = {.count = 1, .reusable = true}, SHIFT(3182),
  [3566] = {.count = 1, .reusable = true}, SHIFT(2995),
  [3568] = {.count = 1, .reusable = true}, SHIFT(3165),
  [3570] = {.count = 1, .reusable = true}, SHIFT(2998),
  [3572] = {.count = 1, .reusable = true}, SHIFT(3207),
  [3574] = {.count = 1, .reusable = false}, SHIFT(735),
  [3576] = {.count = 1, .reusable = true}, SHIFT(2050),
  [3578] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [3580] = {.count = 1, .reusable = true}, SHIFT(3081),
  [3582] = {.count = 1, .reusable = false}, SHIFT(1911),
  [3584] = {.count = 1, .reusable = false}, SHIFT(929),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3588] = {.count = 1, .reusable = true}, SHIFT(180),
  [3590] = {.count = 1, .reusable = false}, SHIFT(1426),
  [3592] = {.count = 1, .reusable = true}, SHIFT(1884),
  [3594] = {.count = 1, .reusable = false}, SHIFT(1427),
  [3596] = {.count = 1, .reusable = false}, SHIFT(1710),
  [3598] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3600] = {.count = 1, .reusable = false}, SHIFT(1428),
  [3602] = {.count = 1, .reusable = true}, SHIFT(949),
  [3604] = {.count = 1, .reusable = true}, SHIFT(1151),
  [3606] = {.count = 1, .reusable = true}, SHIFT(2781),
  [3608] = {.count = 1, .reusable = true}, SHIFT(257),
  [3610] = {.count = 1, .reusable = true}, SHIFT(343),
  [3612] = {.count = 1, .reusable = false}, SHIFT(3127),
  [3614] = {.count = 1, .reusable = true}, SHIFT(2148),
  [3616] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3618] = {.count = 1, .reusable = true}, SHIFT(3196),
  [3620] = {.count = 1, .reusable = true}, SHIFT(3197),
  [3622] = {.count = 1, .reusable = true}, SHIFT(2179),
  [3624] = {.count = 1, .reusable = true}, SHIFT(2181),
  [3626] = {.count = 1, .reusable = true}, SHIFT(2086),
  [3628] = {.count = 1, .reusable = true}, SHIFT(3192),
  [3630] = {.count = 1, .reusable = true}, SHIFT(3198),
  [3632] = {.count = 1, .reusable = true}, SHIFT(2870),
  [3634] = {.count = 1, .reusable = true}, SHIFT(3089),
  [3636] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3638] = {.count = 1, .reusable = true}, SHIFT(2151),
  [3640] = {.count = 1, .reusable = true}, SHIFT(3195),
  [3642] = {.count = 1, .reusable = true}, SHIFT(3194),
  [3644] = {.count = 1, .reusable = true}, SHIFT(225),
  [3646] = {.count = 1, .reusable = true}, SHIFT(953),
  [3648] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3650] = {.count = 1, .reusable = true}, SHIFT(948),
  [3652] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3654] = {.count = 1, .reusable = false}, SHIFT(2625),
  [3656] = {.count = 1, .reusable = false}, SHIFT(3050),
  [3658] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [3660] = {.count = 1, .reusable = true}, SHIFT(2176),
  [3662] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [3664] = {.count = 1, .reusable = false}, SHIFT(1973),
  [3666] = {.count = 1, .reusable = true}, SHIFT(3086),
  [3668] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1130),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3677] = {.count = 1, .reusable = true}, SHIFT(443),
  [3679] = {.count = 1, .reusable = true}, SHIFT(1970),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3687] = {.count = 1, .reusable = true}, SHIFT(429),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1131),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1065),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1950),
  [3695] = {.count = 1, .reusable = true}, SHIFT(437),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1947),
  [3701] = {.count = 1, .reusable = true}, SHIFT(227),
  [3703] = {.count = 1, .reusable = false}, SHIFT(770),
  [3705] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3707] = {.count = 1, .reusable = true}, SHIFT(664),
  [3709] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3711] = {.count = 1, .reusable = false}, SHIFT(340),
  [3713] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3715] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3717] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [3719] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [3721] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3723] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3725] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [3727] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [3729] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [3731] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [3733] = {.count = 1, .reusable = false}, SHIFT(348),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1143),
  [3737] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(765),
  [3740] = {.count = 1, .reusable = true}, SHIFT(3039),
  [3742] = {.count = 1, .reusable = true}, SHIFT(739),
  [3744] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 29),
  [3746] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 29),
  [3748] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 29),
  [3750] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 29),
  [3752] = {.count = 1, .reusable = false}, SHIFT(285),
  [3754] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [3756] = {.count = 1, .reusable = false}, SHIFT(289),
  [3758] = {.count = 1, .reusable = false}, SHIFT(100),
  [3760] = {.count = 1, .reusable = true}, SHIFT(326),
  [3762] = {.count = 1, .reusable = true}, SHIFT(294),
  [3764] = {.count = 1, .reusable = true}, SHIFT(301),
  [3766] = {.count = 1, .reusable = true}, SHIFT(285),
  [3768] = {.count = 1, .reusable = false}, SHIFT(294),
  [3770] = {.count = 1, .reusable = false}, SHIFT(301),
  [3772] = {.count = 1, .reusable = false}, SHIFT(307),
  [3774] = {.count = 1, .reusable = true}, SHIFT(314),
  [3776] = {.count = 1, .reusable = true}, SHIFT(289),
  [3778] = {.count = 1, .reusable = false}, SHIFT(1063),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1062),
  [3782] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3784] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3786] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3788] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(100),
  [3791] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [3793] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [3795] = {.count = 1, .reusable = true}, SHIFT(776),
  [3797] = {.count = 1, .reusable = false}, SHIFT(449),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3801] = {.count = 1, .reusable = true}, SHIFT(247),
  [3803] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 57),
  [3805] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(765),
  [3808] = {.count = 1, .reusable = true}, SHIFT(153),
  [3810] = {.count = 1, .reusable = true}, SHIFT(694),
  [3812] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [3814] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [3816] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3818] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3820] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(100),
  [3823] = {.count = 1, .reusable = true}, SHIFT(715),
  [3825] = {.count = 1, .reusable = false}, SHIFT(1153),
  [3827] = {.count = 1, .reusable = true}, SHIFT(898),
  [3829] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [3831] = {.count = 1, .reusable = true}, SHIFT(23),
  [3833] = {.count = 1, .reusable = true}, SHIFT(726),
  [3835] = {.count = 1, .reusable = false}, SHIFT(1658),
  [3837] = {.count = 1, .reusable = true}, SHIFT(2983),
  [3839] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 132),
  [3841] = {.count = 1, .reusable = true}, SHIFT(727),
  [3843] = {.count = 1, .reusable = false}, SHIFT(1937),
  [3845] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [3847] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [3849] = {.count = 1, .reusable = false}, SHIFT(282),
  [3851] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3853] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(218),
  [3856] = {.count = 1, .reusable = true}, SHIFT(218),
  [3858] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [3860] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [3862] = {.count = 1, .reusable = true}, SHIFT(879),
  [3864] = {.count = 1, .reusable = true}, SHIFT(22),
  [3866] = {.count = 1, .reusable = true}, SHIFT(2992),
  [3868] = {.count = 1, .reusable = true}, SHIFT(761),
  [3870] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3872] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [3874] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3876] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [3878] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [3880] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [3882] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [3884] = {.count = 1, .reusable = false}, SHIFT(295),
  [3886] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3888] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(217),
  [3891] = {.count = 1, .reusable = true}, SHIFT(217),
  [3893] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [3895] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 99),
  [3897] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 99),
  [3899] = {.count = 1, .reusable = true}, SHIFT(2970),
  [3901] = {.count = 1, .reusable = false}, SHIFT(389),
  [3903] = {.count = 1, .reusable = true}, SHIFT(660),
  [3905] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [3907] = {.count = 1, .reusable = false}, SHIFT(390),
  [3909] = {.count = 1, .reusable = true}, SHIFT(195),
  [3911] = {.count = 1, .reusable = false}, SHIFT(104),
  [3913] = {.count = 1, .reusable = true}, SHIFT(280),
  [3915] = {.count = 1, .reusable = true}, SHIFT(393),
  [3917] = {.count = 1, .reusable = true}, SHIFT(395),
  [3919] = {.count = 1, .reusable = true}, SHIFT(389),
  [3921] = {.count = 1, .reusable = false}, SHIFT(393),
  [3923] = {.count = 1, .reusable = false}, SHIFT(395),
  [3925] = {.count = 1, .reusable = false}, SHIFT(409),
  [3927] = {.count = 1, .reusable = true}, SHIFT(401),
  [3929] = {.count = 1, .reusable = true}, SHIFT(390),
  [3931] = {.count = 1, .reusable = false}, SHIFT(1711),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3935] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [3937] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 52),
  [3939] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 52),
  [3941] = {.count = 1, .reusable = false}, SHIFT(269),
  [3943] = {.count = 1, .reusable = true}, SHIFT(678),
  [3945] = {.count = 1, .reusable = false}, SHIFT(258),
  [3947] = {.count = 1, .reusable = true}, SHIFT(240),
  [3949] = {.count = 1, .reusable = false}, SHIFT(101),
  [3951] = {.count = 1, .reusable = true}, SHIFT(260),
  [3953] = {.count = 1, .reusable = true}, SHIFT(261),
  [3955] = {.count = 1, .reusable = true}, SHIFT(262),
  [3957] = {.count = 1, .reusable = true}, SHIFT(269),
  [3959] = {.count = 1, .reusable = false}, SHIFT(261),
  [3961] = {.count = 1, .reusable = false}, SHIFT(262),
  [3963] = {.count = 1, .reusable = false}, SHIFT(263),
  [3965] = {.count = 1, .reusable = true}, SHIFT(264),
  [3967] = {.count = 1, .reusable = true}, SHIFT(258),
  [3969] = {.count = 1, .reusable = false}, SHIFT(1502),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3973] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3976] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3979] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 53),
  [3981] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 53),
  [3983] = {.count = 1, .reusable = false}, SHIFT(2027),
  [3985] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3987] = {.count = 1, .reusable = true}, SHIFT(149),
  [3989] = {.count = 1, .reusable = false}, SHIFT(1681),
  [3991] = {.count = 1, .reusable = true}, SHIFT(2055),
  [3993] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3995] = {.count = 1, .reusable = false}, SHIFT(1730),
  [3997] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3999] = {.count = 1, .reusable = false}, SHIFT(1677),
  [4001] = {.count = 1, .reusable = false}, SHIFT(2036),
  [4003] = {.count = 1, .reusable = true}, SHIFT(2437),
  [4005] = {.count = 1, .reusable = false}, SHIFT(1717),
  [4007] = {.count = 1, .reusable = false}, SHIFT(1716),
  [4009] = {.count = 1, .reusable = false}, SHIFT(1740),
  [4011] = {.count = 1, .reusable = false}, SHIFT(1757),
  [4013] = {.count = 1, .reusable = false}, SHIFT(1713),
  [4015] = {.count = 1, .reusable = true}, SHIFT(911),
  [4017] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 54),
  [4019] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 54),
  [4021] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4023] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4025] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [4027] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [4029] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4031] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4033] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [4035] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [4037] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [4039] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4041] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4043] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [4045] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [4047] = {.count = 1, .reusable = true}, SHIFT(665),
  [4049] = {.count = 1, .reusable = false}, SHIFT(2028),
  [4051] = {.count = 1, .reusable = true}, SHIFT(967),
  [4053] = {.count = 1, .reusable = false}, SHIFT(1682),
  [4055] = {.count = 1, .reusable = false}, SHIFT(1679),
  [4057] = {.count = 1, .reusable = false}, SHIFT(1719),
  [4059] = {.count = 1, .reusable = false}, SHIFT(1760),
  [4061] = {.count = 1, .reusable = false}, SHIFT(1676),
  [4063] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4066] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4069] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [4071] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [4073] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [4075] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 47),
  [4077] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 47),
  [4079] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [4081] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 92),
  [4083] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 92),
  [4085] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 97),
  [4087] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 97),
  [4089] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [4091] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 99),
  [4093] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 99),
  [4095] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [4097] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [4099] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [4101] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [4103] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4105] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4107] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [4109] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [4111] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [4113] = {.count = 1, .reusable = false}, SHIFT(344),
  [4115] = {.count = 1, .reusable = false}, SHIFT(342),
  [4117] = {.count = 1, .reusable = false}, SHIFT(106),
  [4119] = {.count = 1, .reusable = true}, SHIFT(346),
  [4121] = {.count = 1, .reusable = true}, SHIFT(332),
  [4123] = {.count = 1, .reusable = true}, SHIFT(300),
  [4125] = {.count = 1, .reusable = true}, SHIFT(344),
  [4127] = {.count = 1, .reusable = false}, SHIFT(332),
  [4129] = {.count = 1, .reusable = false}, SHIFT(300),
  [4131] = {.count = 1, .reusable = false}, SHIFT(296),
  [4133] = {.count = 1, .reusable = true}, SHIFT(293),
  [4135] = {.count = 1, .reusable = true}, SHIFT(342),
  [4137] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 107),
  [4139] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 107),
  [4141] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 108),
  [4143] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 108),
  [4145] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4147] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4149] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 5),
  [4151] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 5),
  [4153] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 89),
  [4155] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 89),
  [4157] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [4159] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [4161] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [4163] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [4165] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [4167] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [4169] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_closing_element, 4, .production_id = 119),
  [4171] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_closing_element, 4, .production_id = 119),
  [4173] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 136),
  [4175] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 136),
  [4177] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(101),
  [4180] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 6),
  [4182] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 6),
  [4184] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 13),
  [4186] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 13),
  [4188] = {.count = 1, .reusable = true}, SHIFT(614),
  [4190] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(101),
  [4193] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4195] = {.count = 1, .reusable = true}, SHIFT(2318),
  [4197] = {.count = 1, .reusable = false}, SHIFT(1688),
  [4199] = {.count = 1, .reusable = false}, SHIFT(1689),
  [4201] = {.count = 1, .reusable = false}, SHIFT(1726),
  [4203] = {.count = 1, .reusable = false}, SHIFT(1762),
  [4205] = {.count = 1, .reusable = false}, SHIFT(1694),
  [4207] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [4210] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74),
  [4212] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4215] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4218] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64),
  [4220] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 65), REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4223] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 65),
  [4225] = {.count = 1, .reusable = true}, SHIFT(830),
  [4227] = {.count = 1, .reusable = false}, SHIFT(731),
  [4229] = {.count = 1, .reusable = false}, SHIFT(730),
  [4231] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1052),
  [4235] = {.count = 1, .reusable = false}, SHIFT(1590),
  [4237] = {.count = 1, .reusable = false}, SHIFT(1588),
  [4239] = {.count = 1, .reusable = false}, SHIFT(1733),
  [4241] = {.count = 1, .reusable = false}, SHIFT(1759),
  [4243] = {.count = 1, .reusable = false}, SHIFT(1585),
  [4245] = {.count = 1, .reusable = true}, SHIFT(700),
  [4247] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [4250] = {.count = 1, .reusable = false}, SHIFT(298),
  [4252] = {.count = 1, .reusable = false}, SHIFT(308),
  [4254] = {.count = 1, .reusable = false}, SHIFT(102),
  [4256] = {.count = 1, .reusable = true}, SHIFT(394),
  [4258] = {.count = 1, .reusable = true}, SHIFT(311),
  [4260] = {.count = 1, .reusable = true}, SHIFT(313),
  [4262] = {.count = 1, .reusable = true}, SHIFT(298),
  [4264] = {.count = 1, .reusable = false}, SHIFT(311),
  [4266] = {.count = 1, .reusable = false}, SHIFT(313),
  [4268] = {.count = 1, .reusable = false}, SHIFT(316),
  [4270] = {.count = 1, .reusable = true}, SHIFT(318),
  [4272] = {.count = 1, .reusable = true}, SHIFT(308),
  [4274] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4276] = {.count = 1, .reusable = true}, SHIFT(406),
  [4278] = {.count = 1, .reusable = true}, SHIFT(317),
  [4280] = {.count = 1, .reusable = false}, SHIFT(1485),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4284] = {.count = 1, .reusable = false}, SHIFT(1671),
  [4286] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(106),
  [4289] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 49),
  [4291] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 49),
  [4293] = {.count = 1, .reusable = false}, SHIFT(1053),
  [4295] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 132),
  [4297] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4299] = {.count = 1, .reusable = true}, SHIFT(1198),
  [4301] = {.count = 1, .reusable = false}, SHIFT(1561),
  [4303] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4305] = {.count = 1, .reusable = false}, SHIFT(1559),
  [4307] = {.count = 1, .reusable = false}, SHIFT(1821),
  [4309] = {.count = 1, .reusable = false}, SHIFT(1577),
  [4311] = {.count = 1, .reusable = false}, SHIFT(1395),
  [4313] = {.count = 1, .reusable = false}, SHIFT(1449),
  [4315] = {.count = 1, .reusable = true}, SHIFT(310),
  [4317] = {.count = 1, .reusable = true}, SHIFT(2188),
  [4319] = {.count = 1, .reusable = false}, SHIFT(1805),
  [4321] = {.count = 1, .reusable = true}, SHIFT(1318),
  [4323] = {.count = 1, .reusable = true}, SHIFT(2425),
  [4325] = {.count = 1, .reusable = true}, SHIFT(466),
  [4327] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4329] = {.count = 1, .reusable = true}, SHIFT(472),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1697),
  [4333] = {.count = 1, .reusable = true}, SHIFT(128),
  [4335] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [4337] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4339] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4341] = {.count = 1, .reusable = true}, SHIFT(120),
  [4343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1911),
  [4346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1844),
  [4349] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(180),
  [4354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1561),
  [4357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2454),
  [4360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2452),
  [4363] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1871),
  [4366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1856),
  [4369] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1559),
  [4372] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1821),
  [4375] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1577),
  [4378] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1553),
  [4381] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1395),
  [4384] = {.count = 1, .reusable = true}, SHIFT(959),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1446),
  [4388] = {.count = 1, .reusable = true}, SHIFT(554),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1223),
  [4392] = {.count = 1, .reusable = true}, SHIFT(579),
  [4394] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(102),
  [4397] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4399] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4401] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(104),
  [4404] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 78),
  [4406] = {.count = 1, .reusable = true}, SHIFT(1628),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1623),
  [4410] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [4412] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4414] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1022),
  [4418] = {.count = 1, .reusable = true}, SHIFT(254),
  [4420] = {.count = 1, .reusable = true}, SHIFT(519),
  [4422] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(102),
  [4425] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [4427] = {.count = 1, .reusable = true}, SHIFT(1216),
  [4429] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(800),
  [4432] = {.count = 1, .reusable = true}, SHIFT(3185),
  [4434] = {.count = 1, .reusable = true}, SHIFT(738),
  [4436] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [4438] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [4440] = {.count = 1, .reusable = true}, SHIFT(601),
  [4442] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(106),
  [4445] = {.count = 1, .reusable = true}, SHIFT(603),
  [4447] = {.count = 1, .reusable = true}, SHIFT(1070),
  [4449] = {.count = 1, .reusable = true}, SHIFT(1361),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1452),
  [4453] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4455] = {.count = 1, .reusable = false}, SHIFT(1743),
  [4457] = {.count = 1, .reusable = false}, SHIFT(1741),
  [4459] = {.count = 1, .reusable = false}, SHIFT(1745),
  [4461] = {.count = 1, .reusable = false}, SHIFT(1767),
  [4463] = {.count = 1, .reusable = false}, SHIFT(1738),
  [4465] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(104),
  [4468] = {.count = 1, .reusable = true}, SHIFT(1054),
  [4470] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [4472] = {.count = 1, .reusable = true}, SHIFT(2328),
  [4474] = {.count = 1, .reusable = false}, SHIFT(328),
  [4476] = {.count = 1, .reusable = false}, SHIFT(331),
  [4478] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [4480] = {.count = 1, .reusable = true}, SHIFT(1024),
  [4482] = {.count = 1, .reusable = true}, SHIFT(2445),
  [4484] = {.count = 1, .reusable = false}, SHIFT(267),
  [4486] = {.count = 1, .reusable = false}, SHIFT(330),
  [4488] = {.count = 1, .reusable = false}, SHIFT(327),
  [4490] = {.count = 1, .reusable = false}, SHIFT(107),
  [4492] = {.count = 1, .reusable = true}, SHIFT(288),
  [4494] = {.count = 1, .reusable = true}, SHIFT(325),
  [4496] = {.count = 1, .reusable = true}, SHIFT(324),
  [4498] = {.count = 1, .reusable = true}, SHIFT(330),
  [4500] = {.count = 1, .reusable = false}, SHIFT(325),
  [4502] = {.count = 1, .reusable = false}, SHIFT(324),
  [4504] = {.count = 1, .reusable = false}, SHIFT(323),
  [4506] = {.count = 1, .reusable = true}, SHIFT(321),
  [4508] = {.count = 1, .reusable = true}, SHIFT(327),
  [4510] = {.count = 1, .reusable = true}, SHIFT(591),
  [4512] = {.count = 1, .reusable = true}, SHIFT(615),
  [4514] = {.count = 1, .reusable = true}, SHIFT(545),
  [4516] = {.count = 1, .reusable = true}, SHIFT(826),
  [4518] = {.count = 1, .reusable = true}, SHIFT(617),
  [4520] = {.count = 1, .reusable = true}, SHIFT(2635),
  [4522] = {.count = 1, .reusable = true}, SHIFT(667),
  [4524] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(107),
  [4527] = {.count = 1, .reusable = true}, SHIFT(619),
  [4529] = {.count = 1, .reusable = true}, SHIFT(623),
  [4531] = {.count = 1, .reusable = true}, SHIFT(2208),
  [4533] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(750),
  [4536] = {.count = 1, .reusable = true}, SHIFT(3147),
  [4538] = {.count = 1, .reusable = true}, SHIFT(807),
  [4540] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(107),
  [4543] = {.count = 1, .reusable = false}, SHIFT(268),
  [4545] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4548] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [4550] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4553] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 75),
  [4555] = {.count = 1, .reusable = true}, SHIFT(2358),
  [4557] = {.count = 1, .reusable = true}, SHIFT(2534),
  [4559] = {.count = 1, .reusable = true}, SHIFT(2299),
  [4561] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(200),
  [4564] = {.count = 1, .reusable = true}, SHIFT(200),
  [4566] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(204),
  [4569] = {.count = 1, .reusable = true}, SHIFT(204),
  [4571] = {.count = 1, .reusable = true}, SHIFT(52),
  [4573] = {.count = 1, .reusable = true}, SHIFT(40),
  [4575] = {.count = 1, .reusable = true}, SHIFT(621),
  [4577] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4579] = {.count = 1, .reusable = false}, SHIFT(1475),
  [4581] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4583] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4585] = {.count = 1, .reusable = false}, SHIFT(1584),
  [4587] = {.count = 1, .reusable = true}, SHIFT(622),
  [4589] = {.count = 1, .reusable = true}, SHIFT(1612),
  [4591] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4593] = {.count = 1, .reusable = false}, SHIFT(1423),
  [4595] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4597] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4599] = {.count = 1, .reusable = false}, SHIFT(1667),
  [4601] = {.count = 1, .reusable = true}, SHIFT(54),
  [4603] = {.count = 1, .reusable = true}, SHIFT(908),
  [4605] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(800),
  [4608] = {.count = 1, .reusable = true}, SHIFT(616),
  [4610] = {.count = 1, .reusable = true}, SHIFT(618),
  [4612] = {.count = 1, .reusable = true}, SHIFT(8),
  [4614] = {.count = 1, .reusable = false}, SHIFT(1422),
  [4616] = {.count = 1, .reusable = false}, SHIFT(13),
  [4618] = {.count = 1, .reusable = true}, SHIFT(3211),
  [4620] = {.count = 1, .reusable = true}, SHIFT(379),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4624] = {.count = 1, .reusable = false}, SHIFT(1783),
  [4626] = {.count = 1, .reusable = false}, SHIFT(1460),
  [4628] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4630] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4632] = {.count = 1, .reusable = false}, SHIFT(1779),
  [4634] = {.count = 1, .reusable = false}, SHIFT(1444),
  [4636] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4638] = {.count = 1, .reusable = false}, SHIFT(1636),
  [4640] = {.count = 1, .reusable = false}, SHIFT(1443),
  [4642] = {.count = 1, .reusable = true}, SHIFT(708),
  [4644] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4646] = {.count = 1, .reusable = false}, SHIFT(1562),
  [4648] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4650] = {.count = 1, .reusable = false}, SHIFT(1626),
  [4652] = {.count = 1, .reusable = false}, SHIFT(1501),
  [4654] = {.count = 1, .reusable = true}, SHIFT(1607),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4658] = {.count = 1, .reusable = false}, SHIFT(1797),
  [4660] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4662] = {.count = 1, .reusable = false}, SHIFT(1489),
  [4664] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4666] = {.count = 1, .reusable = false}, SHIFT(1674),
  [4668] = {.count = 1, .reusable = false}, SHIFT(1563),
  [4670] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4672] = {.count = 1, .reusable = false}, SHIFT(1547),
  [4674] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4676] = {.count = 1, .reusable = false}, SHIFT(1624),
  [4678] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(750),
  [4681] = {.count = 1, .reusable = true}, SHIFT(286),
  [4683] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4685] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4688] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [4690] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4693] = {.count = 1, .reusable = false}, SHIFT(333),
  [4695] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [4697] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4703] = {.count = 1, .reusable = false}, SHIFT(1787),
  [4705] = {.count = 1, .reusable = false}, SHIFT(336),
  [4707] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(331),
  [4710] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4713] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4715] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(328),
  [4718] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4721] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2180),
  [4725] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4727] = {.count = 1, .reusable = true}, SHIFT(410),
  [4729] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4733] = {.count = 1, .reusable = false}, SHIFT(1782),
  [4735] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4739] = {.count = 1, .reusable = false}, SHIFT(1804),
  [4741] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4743] = {.count = 1, .reusable = false}, SHIFT(1537),
  [4745] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4747] = {.count = 1, .reusable = false}, SHIFT(1647),
  [4749] = {.count = 1, .reusable = true}, SHIFT(360),
  [4751] = {.count = 1, .reusable = true}, SHIFT(363),
  [4753] = {.count = 1, .reusable = false}, SHIFT(391),
  [4755] = {.count = 1, .reusable = false}, SHIFT(382),
  [4757] = {.count = 1, .reusable = false}, SHIFT(399),
  [4759] = {.count = 1, .reusable = false}, SHIFT(400),
  [4761] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4763] = {.count = 1, .reusable = false}, SHIFT(741),
  [4765] = {.count = 1, .reusable = false}, SHIFT(744),
  [4767] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2186),
  [4771] = {.count = 1, .reusable = false}, SHIFT(1789),
  [4773] = {.count = 1, .reusable = false}, SHIFT(1575),
  [4775] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4779] = {.count = 1, .reusable = false}, SHIFT(1794),
  [4781] = {.count = 1, .reusable = false}, SHIFT(1424),
  [4783] = {.count = 1, .reusable = true}, SHIFT(302),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4787] = {.count = 1, .reusable = false}, SHIFT(1780),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4791] = {.count = 1, .reusable = false}, SHIFT(1809),
  [4793] = {.count = 1, .reusable = false}, SHIFT(1498),
  [4795] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4797] = {.count = 1, .reusable = false}, SHIFT(1686),
  [4799] = {.count = 1, .reusable = true}, SHIFT(707),
  [4801] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4803] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4805] = {.count = 1, .reusable = false}, SHIFT(804),
  [4807] = {.count = 1, .reusable = false}, SHIFT(803),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2294),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2149),
  [4815] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4817] = {.count = 1, .reusable = false}, SHIFT(320),
  [4819] = {.count = 1, .reusable = false}, SHIFT(319),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2446),
  [4823] = {.count = 1, .reusable = false}, SHIFT(2076),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2584),
  [4827] = {.count = 1, .reusable = true}, SHIFT(154),
  [4829] = {.count = 1, .reusable = false}, SHIFT(1946),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2681),
  [4833] = {.count = 1, .reusable = true}, SHIFT(2616),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4839] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4841] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4843] = {.count = 1, .reusable = true}, SHIFT(151),
  [4845] = {.count = 1, .reusable = false}, SHIFT(3095),
  [4847] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [4849] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [4851] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [4853] = {.count = 1, .reusable = false}, SHIFT(3120),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4859] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4861] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4863] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [4865] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2851),
  [4871] = {.count = 1, .reusable = true}, SHIFT(359),
  [4873] = {.count = 1, .reusable = true}, SHIFT(299),
  [4875] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [4877] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [4879] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4881] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4883] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4885] = {.count = 1, .reusable = false}, SHIFT(1774),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4889] = {.count = 1, .reusable = false}, SHIFT(1813),
  [4891] = {.count = 1, .reusable = false}, SHIFT(1776),
  [4893] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4895] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4897] = {.count = 1, .reusable = false}, SHIFT(1803),
  [4899] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4903] = {.count = 1, .reusable = false}, SHIFT(1790),
  [4905] = {.count = 1, .reusable = true}, SHIFT(214),
  [4907] = {.count = 1, .reusable = false}, SHIFT(1773),
  [4909] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4911] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4913] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4915] = {.count = 1, .reusable = false}, SHIFT(2305),
  [4917] = {.count = 1, .reusable = false}, SHIFT(2304),
  [4919] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 18),
  [4921] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 138),
  [4923] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 138),
  [4925] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 129),
  [4927] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 129),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4931] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4933] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4935] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2184),
  [4939] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4941] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4943] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 183),
  [4945] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 183),
  [4947] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [4949] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [4951] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 184),
  [4953] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 184),
  [4955] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [4957] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [4959] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4961] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4963] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 103),
  [4965] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 103),
  [4967] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 154),
  [4969] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 154),
  [4971] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4973] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 188),
  [4975] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 188),
  [4977] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [4979] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [4981] = {.count = 1, .reusable = false}, SHIFT(1425),
  [4983] = {.count = 1, .reusable = false}, SHIFT(1822),
  [4985] = {.count = 1, .reusable = false}, SHIFT(1391),
  [4987] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4989] = {.count = 1, .reusable = true}, SHIFT(2536),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2408),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2331),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2216),
  [4997] = {.count = 1, .reusable = true}, SHIFT(598),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5001] = {.count = 1, .reusable = true}, SHIFT(531),
  [5003] = {.count = 1, .reusable = true}, SHIFT(533),
  [5005] = {.count = 1, .reusable = true}, SHIFT(1842),
  [5007] = {.count = 1, .reusable = true}, SHIFT(1870),
  [5009] = {.count = 1, .reusable = false}, SHIFT(1700),
  [5011] = {.count = 1, .reusable = false}, SHIFT(1701),
  [5013] = {.count = 1, .reusable = true}, SHIFT(1831),
  [5015] = {.count = 1, .reusable = true}, SHIFT(1868),
  [5017] = {.count = 1, .reusable = false}, SHIFT(1629),
  [5019] = {.count = 1, .reusable = false}, SHIFT(1600),
  [5021] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5023] = {.count = 1, .reusable = false}, SHIFT(1435),
  [5025] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [5027] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [5029] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1856),
  [5032] = {.count = 1, .reusable = false}, SHIFT(1454),
  [5034] = {.count = 1, .reusable = false}, SHIFT(1772),
  [5036] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5038] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5040] = {.count = 1, .reusable = false}, SHIFT(1784),
  [5042] = {.count = 1, .reusable = false}, SHIFT(1739),
  [5044] = {.count = 1, .reusable = false}, SHIFT(1737),
  [5046] = {.count = 1, .reusable = false}, SHIFT(2103),
  [5048] = {.count = 1, .reusable = true}, SHIFT(721),
  [5050] = {.count = 1, .reusable = true}, SHIFT(160),
  [5052] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5054] = {.count = 1, .reusable = true}, SHIFT(685),
  [5056] = {.count = 1, .reusable = true}, SHIFT(770),
  [5058] = {.count = 2, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14), SHIFT(2586),
  [5061] = {.count = 1, .reusable = false}, SHIFT(3082),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2103),
  [5065] = {.count = 1, .reusable = true}, SHIFT(3129),
  [5067] = {.count = 1, .reusable = false}, SHIFT(722),
  [5069] = {.count = 1, .reusable = false}, SHIFT(3150),
  [5071] = {.count = 1, .reusable = false}, SHIFT(3157),
  [5073] = {.count = 1, .reusable = true}, SHIFT(2981),
  [5075] = {.count = 1, .reusable = true}, SHIFT(367),
  [5077] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 47),
  [5079] = {.count = 1, .reusable = true}, SHIFT(1886),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2065),
  [5083] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 119),
  [5085] = {.count = 1, .reusable = true}, SHIFT(1904),
  [5087] = {.count = 1, .reusable = true}, SHIFT(2069),
  [5089] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_namespace_name, 3),
  [5091] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_namespace_name, 3),
  [5093] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_jsx_namespace_name, 3),
  [5096] = {.count = 1, .reusable = false}, SHIFT(782),
  [5098] = {.count = 1, .reusable = true}, SHIFT(1897),
  [5100] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5102] = {.count = 1, .reusable = true}, SHIFT(1900),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2072),
  [5106] = {.count = 1, .reusable = true}, SHIFT(1903),
  [5108] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 153),
  [5110] = {.count = 1, .reusable = true}, SHIFT(1892),
  [5112] = {.count = 1, .reusable = true}, SHIFT(2047),
  [5114] = {.count = 1, .reusable = true}, SHIFT(784),
  [5116] = {.count = 1, .reusable = true}, SHIFT(3163),
  [5118] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 47),
  [5120] = {.count = 1, .reusable = true}, SHIFT(1887),
  [5122] = {.count = 1, .reusable = true}, SHIFT(1902),
  [5124] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 153),
  [5126] = {.count = 1, .reusable = true}, SHIFT(1890),
  [5128] = {.count = 1, .reusable = true}, SHIFT(2838),
  [5130] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5132] = {.count = 1, .reusable = false}, SHIFT(3048),
  [5134] = {.count = 1, .reusable = false}, SHIFT(2987),
  [5136] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5138] = {.count = 1, .reusable = true}, SHIFT(103),
  [5140] = {.count = 1, .reusable = true}, SHIFT(1907),
  [5142] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 119),
  [5144] = {.count = 1, .reusable = true}, SHIFT(1905),
  [5146] = {.count = 1, .reusable = true}, SHIFT(1891),
  [5148] = {.count = 1, .reusable = true}, SHIFT(1894),
  [5150] = {.count = 1, .reusable = true}, SHIFT(1896),
  [5152] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 47),
  [5154] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 47),
  [5156] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 153),
  [5158] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 153),
  [5160] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [5163] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 119),
  [5165] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5167] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5169] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 119),
  [5171] = {.count = 1, .reusable = true}, SHIFT(789),
  [5173] = {.count = 1, .reusable = true}, SHIFT(790),
  [5175] = {.count = 1, .reusable = true}, SHIFT(3093),
  [5177] = {.count = 1, .reusable = true}, SHIFT(797),
  [5179] = {.count = 1, .reusable = false}, SHIFT(796),
  [5181] = {.count = 1, .reusable = false}, SHIFT(1978),
  [5183] = {.count = 1, .reusable = true}, SHIFT(1192),
  [5185] = {.count = 1, .reusable = false}, SHIFT(787),
  [5187] = {.count = 1, .reusable = false}, SHIFT(168),
  [5189] = {.count = 1, .reusable = false}, SHIFT(2007),
  [5191] = {.count = 1, .reusable = true}, SHIFT(1317),
  [5193] = {.count = 1, .reusable = false}, SHIFT(1984),
  [5195] = {.count = 1, .reusable = true}, SHIFT(1255),
  [5197] = {.count = 1, .reusable = false}, SHIFT(1992),
  [5199] = {.count = 1, .reusable = true}, SHIFT(679),
  [5201] = {.count = 1, .reusable = false}, SHIFT(1983),
  [5203] = {.count = 1, .reusable = false}, SHIFT(1991),
  [5205] = {.count = 1, .reusable = false}, SHIFT(1976),
  [5207] = {.count = 1, .reusable = false}, SHIFT(2011),
  [5209] = {.count = 1, .reusable = true}, SHIFT(2253),
  [5211] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5215] = {.count = 1, .reusable = false}, SHIFT(1997),
  [5217] = {.count = 1, .reusable = false}, SHIFT(2005),
  [5219] = {.count = 1, .reusable = true}, SHIFT(2743),
  [5221] = {.count = 1, .reusable = true}, SHIFT(3050),
  [5223] = {.count = 1, .reusable = true}, SHIFT(2676),
  [5225] = {.count = 1, .reusable = false}, SHIFT(3051),
  [5227] = {.count = 1, .reusable = false}, SHIFT(163),
  [5229] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5231] = {.count = 1, .reusable = false}, SHIFT(2000),
  [5233] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5235] = {.count = 1, .reusable = true}, SHIFT(787),
  [5237] = {.count = 1, .reusable = true}, SHIFT(168),
  [5239] = {.count = 1, .reusable = false}, SHIFT(2997),
  [5241] = {.count = 1, .reusable = true}, SHIFT(1217),
  [5243] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5245] = {.count = 1, .reusable = false}, SHIFT(2001),
  [5247] = {.count = 1, .reusable = true}, SHIFT(1208),
  [5249] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5251] = {.count = 1, .reusable = false}, SHIFT(2020),
  [5253] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5255] = {.count = 1, .reusable = false}, SHIFT(1987),
  [5257] = {.count = 1, .reusable = false}, SHIFT(3153),
  [5259] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5261] = {.count = 1, .reusable = true}, SHIFT(1221),
  [5263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(2103),
  [5266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(160),
  [5269] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90),
  [5271] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90),
  [5273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(2103),
  [5276] = {.count = 1, .reusable = false}, SHIFT(1985),
  [5278] = {.count = 1, .reusable = false}, SHIFT(1993),
  [5280] = {.count = 1, .reusable = true}, SHIFT(747),
  [5282] = {.count = 1, .reusable = true}, SHIFT(712),
  [5284] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [5286] = {.count = 1, .reusable = false}, SHIFT(3180),
  [5288] = {.count = 1, .reusable = false}, SHIFT(3022),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2234),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2675),
  [5294] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22),
  [5296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(163),
  [5299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2458),
  [5302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2020),
  [5305] = {.count = 1, .reusable = false}, SHIFT(2330),
  [5307] = {.count = 1, .reusable = false}, SHIFT(2423),
  [5309] = {.count = 1, .reusable = false}, SHIFT(2238),
  [5311] = {.count = 1, .reusable = false}, SHIFT(2025),
  [5313] = {.count = 1, .reusable = false}, SHIFT(2277),
  [5315] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5317] = {.count = 1, .reusable = false}, SHIFT(2022),
  [5319] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5322] = {.count = 1, .reusable = true}, SHIFT(19),
  [5324] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [5327] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5329] = {.count = 1, .reusable = false}, SHIFT(2021),
  [5331] = {.count = 1, .reusable = false}, SHIFT(2353),
  [5333] = {.count = 1, .reusable = false}, SHIFT(2015),
  [5335] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5339] = {.count = 1, .reusable = true}, SHIFT(722),
  [5341] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5343] = {.count = 1, .reusable = true}, SHIFT(3128),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2159),
  [5349] = {.count = 1, .reusable = true}, SHIFT(1734),
  [5351] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [5353] = {.count = 1, .reusable = true}, SHIFT(446),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5357] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5361] = {.count = 1, .reusable = true}, SHIFT(2158),
  [5363] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 122),
  [5365] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 115),
  [5367] = {.count = 1, .reusable = true}, SHIFT(337),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5371] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 102),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2862),
  [5375] = {.count = 1, .reusable = true}, SHIFT(169),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2143),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2030),
  [5383] = {.count = 1, .reusable = true}, SHIFT(3055),
  [5385] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 167),
  [5387] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5389] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5391] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 146),
  [5393] = {.count = 1, .reusable = true}, SHIFT(383),
  [5395] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5399] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2128),
  [5407] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 128),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5411] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5413] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 189),
  [5415] = {.count = 1, .reusable = false}, SHIFT(2051),
  [5417] = {.count = 1, .reusable = true}, SHIFT(1105),
  [5419] = {.count = 1, .reusable = true}, SHIFT(148),
  [5421] = {.count = 1, .reusable = false}, SHIFT(3187),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5425] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5429] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5431] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 186),
  [5433] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 145),
  [5435] = {.count = 1, .reusable = true}, SHIFT(491),
  [5437] = {.count = 1, .reusable = true}, SHIFT(3088),
  [5439] = {.count = 1, .reusable = true}, SHIFT(2984),
  [5441] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 185),
  [5443] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [5445] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 178),
  [5447] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5449] = {.count = 1, .reusable = true}, SHIFT(1960),
  [5451] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5453] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 177),
  [5455] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 93),
  [5457] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [5459] = {.count = 1, .reusable = false}, SHIFT(3021),
  [5461] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 168),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5465] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5471] = {.count = 1, .reusable = true}, SHIFT(1526),
  [5473] = {.count = 1, .reusable = true}, SHIFT(233),
  [5475] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1),
  [5477] = {.count = 1, .reusable = true}, SHIFT(1959),
  [5479] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1),
  [5481] = {.count = 1, .reusable = true}, SHIFT(947),
  [5483] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5485] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(951),
  [5488] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2051),
  [5492] = {.count = 1, .reusable = true}, SHIFT(937),
  [5494] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5496] = {.count = 1, .reusable = true}, SHIFT(945),
  [5498] = {.count = 1, .reusable = false}, SHIFT(2715),
  [5500] = {.count = 1, .reusable = true}, SHIFT(3097),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2714),
  [5504] = {.count = 1, .reusable = false}, SHIFT(3098),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5508] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3019),
  [5511] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5513] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(184),
  [5516] = {.count = 1, .reusable = true}, SHIFT(944),
  [5518] = {.count = 1, .reusable = true}, SHIFT(1925),
  [5520] = {.count = 1, .reusable = true}, SHIFT(755),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5524] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5526] = {.count = 1, .reusable = true}, SHIFT(936),
  [5528] = {.count = 1, .reusable = true}, SHIFT(943),
  [5530] = {.count = 1, .reusable = true}, SHIFT(1164),
  [5532] = {.count = 1, .reusable = false}, SHIFT(1858),
  [5534] = {.count = 1, .reusable = true}, SHIFT(2024),
  [5536] = {.count = 1, .reusable = true}, SHIFT(1967),
  [5538] = {.count = 1, .reusable = true}, SHIFT(942),
  [5540] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5542] = {.count = 1, .reusable = true}, SHIFT(934),
  [5544] = {.count = 1, .reusable = true}, SHIFT(1580),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5550] = {.count = 1, .reusable = true}, SHIFT(1086),
  [5552] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [5554] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5556] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5558] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5560] = {.count = 1, .reusable = true}, SHIFT(941),
  [5562] = {.count = 1, .reusable = true}, SHIFT(431),
  [5564] = {.count = 1, .reusable = true}, SHIFT(935),
  [5566] = {.count = 1, .reusable = true}, SHIFT(1649),
  [5568] = {.count = 1, .reusable = true}, SHIFT(2142),
  [5570] = {.count = 1, .reusable = true}, SHIFT(1699),
  [5572] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5574] = {.count = 1, .reusable = false}, SHIFT(1857),
  [5576] = {.count = 1, .reusable = true}, SHIFT(2033),
  [5578] = {.count = 1, .reusable = true}, SHIFT(1956),
  [5580] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5582] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5588] = {.count = 1, .reusable = true}, SHIFT(946),
  [5590] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 68),
  [5592] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5594] = {.count = 1, .reusable = true}, SHIFT(938),
  [5596] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5598] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5600] = {.count = 1, .reusable = false}, SHIFT(1859),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2032),
  [5604] = {.count = 1, .reusable = true}, SHIFT(1961),
  [5606] = {.count = 1, .reusable = true}, SHIFT(933),
  [5608] = {.count = 1, .reusable = true}, SHIFT(3019),
  [5610] = {.count = 1, .reusable = true}, SHIFT(567),
  [5612] = {.count = 1, .reusable = true}, SHIFT(184),
  [5614] = {.count = 1, .reusable = true}, SHIFT(939),
  [5616] = {.count = 1, .reusable = true}, SHIFT(3193),
  [5618] = {.count = 1, .reusable = true}, SHIFT(3199),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2115),
  [5624] = {.count = 1, .reusable = true}, SHIFT(1458),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5630] = {.count = 1, .reusable = true}, SHIFT(940),
  [5632] = {.count = 1, .reusable = true}, SHIFT(1564),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5636] = {.count = 1, .reusable = true}, SHIFT(537),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5642] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2190),
  [5645] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5647] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(233),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5652] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5664] = {.count = 1, .reusable = true}, SHIFT(1037),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5668] = {.count = 1, .reusable = true}, SHIFT(2231),
  [5670] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [5672] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 3),
  [5674] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 3),
  [5676] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [5678] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 121),
  [5680] = {.count = 1, .reusable = true}, SHIFT(14),
  [5682] = {.count = 1, .reusable = true}, SHIFT(683),
  [5684] = {.count = 1, .reusable = true}, SHIFT(1862),
  [5686] = {.count = 1, .reusable = true}, SHIFT(3045),
  [5688] = {.count = 1, .reusable = false}, SHIFT(1878),
  [5690] = {.count = 1, .reusable = false}, SHIFT(3184),
  [5692] = {.count = 1, .reusable = true}, SHIFT(1929),
  [5694] = {.count = 1, .reusable = false}, SHIFT(3178),
  [5696] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 124),
  [5698] = {.count = 1, .reusable = false}, SHIFT(1879),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2026),
  [5702] = {.count = 1, .reusable = true}, SHIFT(1945),
  [5704] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 181),
  [5706] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5708] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5710] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3),
  [5712] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3),
  [5714] = {.count = 1, .reusable = true}, SHIFT(699),
  [5716] = {.count = 1, .reusable = true}, SHIFT(461),
  [5718] = {.count = 1, .reusable = false}, SHIFT(2545),
  [5720] = {.count = 1, .reusable = false}, SHIFT(3140),
  [5722] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 174),
  [5724] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 31),
  [5726] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5730] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 170),
  [5732] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [5734] = {.count = 1, .reusable = false}, SHIFT(2533),
  [5736] = {.count = 1, .reusable = true}, SHIFT(788),
  [5738] = {.count = 1, .reusable = true}, SHIFT(1942),
  [5740] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 84),
  [5742] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [5744] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 85),
  [5746] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [5748] = {.count = 1, .reusable = true}, SHIFT(1566),
  [5750] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 150),
  [5752] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5754] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 181),
  [5756] = {.count = 1, .reusable = true}, SHIFT(682),
  [5758] = {.count = 1, .reusable = true}, SHIFT(1542),
  [5760] = {.count = 1, .reusable = false}, SHIFT(3049),
  [5762] = {.count = 1, .reusable = false}, SHIFT(2525),
  [5764] = {.count = 1, .reusable = true}, SHIFT(3132),
  [5766] = {.count = 1, .reusable = true}, SHIFT(3065),
  [5768] = {.count = 1, .reusable = false}, SHIFT(3072),
  [5770] = {.count = 1, .reusable = true}, SHIFT(1817),
  [5772] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5774] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 18),
  [5776] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [5778] = {.count = 1, .reusable = true}, SHIFT(693),
  [5780] = {.count = 1, .reusable = true}, SHIFT(1606),
  [5782] = {.count = 1, .reusable = true}, SHIFT(753),
  [5784] = {.count = 1, .reusable = true}, SHIFT(754),
  [5786] = {.count = 1, .reusable = true}, SHIFT(701),
  [5788] = {.count = 1, .reusable = true}, SHIFT(1928),
  [5790] = {.count = 1, .reusable = false}, SHIFT(3063),
  [5792] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5794] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [5796] = {.count = 1, .reusable = false}, SHIFT(3149),
  [5798] = {.count = 1, .reusable = true}, SHIFT(1753),
  [5800] = {.count = 1, .reusable = true}, SHIFT(1957),
  [5802] = {.count = 1, .reusable = true}, SHIFT(1166),
  [5804] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [5806] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 124),
  [5808] = {.count = 1, .reusable = true}, SHIFT(689),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2690),
  [5812] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5814] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5816] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5822] = {.count = 1, .reusable = true}, SHIFT(442),
  [5824] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 148),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5828] = {.count = 1, .reusable = true}, SHIFT(1755),
  [5830] = {.count = 1, .reusable = true}, SHIFT(1930),
  [5832] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 150),
  [5834] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 148),
  [5836] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 31),
  [5838] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [5840] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [5842] = {.count = 1, .reusable = true}, SHIFT(1764),
  [5844] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 174),
  [5846] = {.count = 1, .reusable = false}, SHIFT(3007),
  [5848] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(788),
  [5851] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 2),
  [5853] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 2),
  [5855] = {.count = 1, .reusable = true}, SHIFT(1819),
  [5857] = {.count = 1, .reusable = true}, SHIFT(550),
  [5859] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 121),
  [5861] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [5863] = {.count = 1, .reusable = false}, SHIFT(2511),
  [5865] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [5867] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 170),
  [5869] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1, .production_id = 96),
  [5871] = {.count = 1, .reusable = true}, SHIFT(1645),
  [5873] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [5875] = {.count = 1, .reusable = true}, SHIFT(705),
  [5877] = {.count = 1, .reusable = true}, SHIFT(1162),
  [5879] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 48),
  [5881] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 48),
  [5883] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5885] = {.count = 1, .reusable = true}, SHIFT(574),
  [5887] = {.count = 1, .reusable = true}, SHIFT(595),
  [5889] = {.count = 1, .reusable = true}, SHIFT(796),
  [5891] = {.count = 1, .reusable = false}, SHIFT(1864),
  [5893] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5895] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5897] = {.count = 1, .reusable = false}, SHIFT(417),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5901] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5905] = {.count = 1, .reusable = false}, SHIFT(2473),
  [5907] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [5909] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2455),
  [5912] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2455),
  [5915] = {.count = 1, .reusable = true}, SHIFT(1754),
  [5917] = {.count = 1, .reusable = false}, SHIFT(2634),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2945),
  [5921] = {.count = 1, .reusable = true}, SHIFT(1927),
  [5923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(166),
  [5926] = {.count = 1, .reusable = false}, SHIFT(418),
  [5928] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5930] = {.count = 1, .reusable = false}, SHIFT(2500),
  [5932] = {.count = 1, .reusable = true}, SHIFT(564),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5936] = {.count = 1, .reusable = false}, SHIFT(2453),
  [5938] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [5940] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [5942] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5946] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [5948] = {.count = 1, .reusable = false}, SHIFT(124),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5952] = {.count = 1, .reusable = false}, SHIFT(2549),
  [5954] = {.count = 1, .reusable = true}, SHIFT(573),
  [5956] = {.count = 1, .reusable = false}, SHIFT(1865),
  [5958] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5960] = {.count = 1, .reusable = false}, SHIFT(2516),
  [5962] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5964] = {.count = 1, .reusable = false}, SHIFT(2550),
  [5966] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5968] = {.count = 1, .reusable = false}, SHIFT(1613),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5972] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5974] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5976] = {.count = 1, .reusable = false}, SHIFT(2483),
  [5978] = {.count = 1, .reusable = false}, SHIFT(1611),
  [5980] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5982] = {.count = 1, .reusable = false}, SHIFT(965),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5988] = {.count = 1, .reusable = true}, SHIFT(570),
  [5990] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5994] = {.count = 1, .reusable = false}, SHIFT(2492),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5998] = {.count = 1, .reusable = false}, SHIFT(2493),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2242),
  [6002] = {.count = 1, .reusable = true}, SHIFT(2252),
  [6004] = {.count = 1, .reusable = false}, SHIFT(2448),
  [6006] = {.count = 1, .reusable = true}, SHIFT(2539),
  [6008] = {.count = 1, .reusable = false}, SHIFT(2539),
  [6010] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(155),
  [6013] = {.count = 1, .reusable = false}, SHIFT(1148),
  [6015] = {.count = 1, .reusable = true}, SHIFT(1964),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2289),
  [6021] = {.count = 1, .reusable = true}, SHIFT(563),
  [6023] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [6025] = {.count = 1, .reusable = true}, SHIFT(547),
  [6027] = {.count = 1, .reusable = true}, SHIFT(1946),
  [6029] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [6031] = {.count = 1, .reusable = false}, SHIFT(2554),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6035] = {.count = 1, .reusable = false}, SHIFT(1141),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2497),
  [6039] = {.count = 1, .reusable = false}, SHIFT(2497),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2498),
  [6043] = {.count = 1, .reusable = false}, SHIFT(2498),
  [6045] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [6047] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2516),
  [6050] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2516),
  [6053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(165),
  [6056] = {.count = 1, .reusable = true}, SHIFT(2288),
  [6058] = {.count = 1, .reusable = true}, SHIFT(575),
  [6060] = {.count = 1, .reusable = true}, SHIFT(2210),
  [6062] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2178),
  [6065] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6067] = {.count = 1, .reusable = false}, SHIFT(2633),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6071] = {.count = 1, .reusable = true}, SHIFT(3156),
  [6073] = {.count = 1, .reusable = true}, SHIFT(3119),
  [6075] = {.count = 1, .reusable = true}, SHIFT(174),
  [6077] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [6079] = {.count = 1, .reusable = false}, SHIFT(2697),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6083] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [6085] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [6087] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [6089] = {.count = 1, .reusable = false}, SHIFT(969),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2297),
  [6093] = {.count = 1, .reusable = true}, SHIFT(2300),
  [6095] = {.count = 1, .reusable = false}, SHIFT(2751),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6099] = {.count = 1, .reusable = true}, SHIFT(529),
  [6101] = {.count = 1, .reusable = false}, SHIFT(123),
  [6103] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 73),
  [6105] = {.count = 1, .reusable = true}, SHIFT(140),
  [6107] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6109] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1829),
  [6112] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6114] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 149),
  [6116] = {.count = 1, .reusable = true}, SHIFT(142),
  [6118] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6120] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 169),
  [6122] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 171),
  [6124] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 172),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6128] = {.count = 1, .reusable = true}, SHIFT(586),
  [6130] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 167),
  [6132] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 173),
  [6134] = {.count = 1, .reusable = true}, SHIFT(2673),
  [6136] = {.count = 1, .reusable = true}, SHIFT(2373),
  [6138] = {.count = 1, .reusable = true}, SHIFT(1951),
  [6140] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 168),
  [6142] = {.count = 1, .reusable = true}, SHIFT(1954),
  [6144] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 152),
  [6146] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 146),
  [6148] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 128),
  [6150] = {.count = 1, .reusable = true}, SHIFT(2037),
  [6152] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6154] = {.count = 1, .reusable = true}, SHIFT(588),
  [6156] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 151),
  [6158] = {.count = 1, .reusable = true}, SHIFT(684),
  [6160] = {.count = 1, .reusable = true}, SHIFT(1770),
  [6162] = {.count = 1, .reusable = true}, SHIFT(141),
  [6164] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6166] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 179),
  [6168] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 180),
  [6170] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 182),
  [6172] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 177),
  [6174] = {.count = 1, .reusable = true}, SHIFT(1948),
  [6176] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 187),
  [6178] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 147),
  [6180] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [6182] = {.count = 1, .reusable = true}, SHIFT(2441),
  [6184] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 47),
  [6186] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 73),
  [6188] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(725),
  [6191] = {.count = 1, .reusable = true}, SHIFT(713),
  [6193] = {.count = 1, .reusable = true}, SHIFT(1820),
  [6195] = {.count = 1, .reusable = true}, SHIFT(433),
  [6197] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [6199] = {.count = 1, .reusable = true}, SHIFT(432),
  [6201] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 79),
  [6203] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 102),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2398),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2397),
  [6209] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 120),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2396),
  [6213] = {.count = 1, .reusable = true}, SHIFT(1059),
  [6215] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1, .production_id = 118),
  [6217] = {.count = 1, .reusable = true}, SHIFT(1120),
  [6219] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [6221] = {.count = 1, .reusable = true}, SHIFT(1159),
  [6223] = {.count = 1, .reusable = true}, SHIFT(746),
  [6225] = {.count = 1, .reusable = true}, SHIFT(1921),
  [6227] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 123),
  [6229] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2509),
  [6232] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6234] = {.count = 1, .reusable = true}, SHIFT(1165),
  [6236] = {.count = 1, .reusable = true}, SHIFT(962),
  [6238] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6240] = {.count = 1, .reusable = true}, SHIFT(2504),
  [6242] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [6244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2547),
  [6247] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6249] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [6251] = {.count = 1, .reusable = true}, SHIFT(1691),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2323),
  [6255] = {.count = 1, .reusable = true}, SHIFT(709),
  [6257] = {.count = 1, .reusable = true}, SHIFT(1725),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6261] = {.count = 1, .reusable = true}, SHIFT(1640),
  [6263] = {.count = 1, .reusable = true}, SHIFT(1412),
  [6265] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(714),
  [6268] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(718),
  [6271] = {.count = 1, .reusable = true}, SHIFT(961),
  [6273] = {.count = 1, .reusable = true}, SHIFT(1137),
  [6275] = {.count = 1, .reusable = true}, SHIFT(1135),
  [6277] = {.count = 1, .reusable = true}, SHIFT(1728),
  [6279] = {.count = 1, .reusable = true}, SHIFT(970),
  [6281] = {.count = 1, .reusable = true}, SHIFT(704),
  [6283] = {.count = 1, .reusable = true}, SHIFT(1421),
  [6285] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [6287] = {.count = 1, .reusable = true}, SHIFT(440),
  [6289] = {.count = 1, .reusable = true}, SHIFT(1441),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2570),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2211),
  [6295] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [6297] = {.count = 1, .reusable = true}, SHIFT(960),
  [6299] = {.count = 1, .reusable = true}, SHIFT(526),
  [6301] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2886),
  [6304] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6306] = {.count = 1, .reusable = true}, SHIFT(1448),
  [6308] = {.count = 1, .reusable = true}, SHIFT(1453),
  [6310] = {.count = 1, .reusable = true}, SHIFT(2283),
  [6312] = {.count = 1, .reusable = true}, SHIFT(1456),
  [6314] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 91),
  [6316] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 89),
  [6318] = {.count = 1, .reusable = true}, SHIFT(1718),
  [6320] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [6322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1746),
  [6325] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23),
  [6327] = {.count = 1, .reusable = true}, SHIFT(1654),
  [6329] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 81),
  [6331] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 80),
  [6333] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 79),
  [6335] = {.count = 1, .reusable = true}, SHIFT(1646),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2322),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2284),
  [6341] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 73),
  [6343] = {.count = 1, .reusable = true}, SHIFT(680),
  [6345] = {.count = 1, .reusable = true}, SHIFT(3016),
  [6347] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 47),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2329),
  [6351] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [6353] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(774),
  [6356] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(786),
  [6359] = {.count = 1, .reusable = true}, SHIFT(1638),
  [6361] = {.count = 1, .reusable = true}, SHIFT(2303),
  [6363] = {.count = 1, .reusable = true}, SHIFT(1635),
  [6365] = {.count = 1, .reusable = true}, SHIFT(1742),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2045),
  [6369] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(771),
  [6372] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6374] = {.count = 1, .reusable = true}, SHIFT(2598),
  [6376] = {.count = 1, .reusable = true}, SHIFT(1815),
  [6378] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [6380] = {.count = 1, .reusable = true}, SHIFT(3070),
  [6382] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [6384] = {.count = 1, .reusable = true}, SHIFT(2368),
  [6386] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6388] = {.count = 1, .reusable = true}, SHIFT(1541),
  [6390] = {.count = 1, .reusable = true}, SHIFT(1115),
  [6392] = {.count = 1, .reusable = true}, SHIFT(2338),
  [6394] = {.count = 1, .reusable = true}, SHIFT(2324),
  [6396] = {.count = 1, .reusable = true}, SHIFT(1545),
  [6398] = {.count = 1, .reusable = true}, SHIFT(1736),
  [6400] = {.count = 1, .reusable = true}, SHIFT(2280),
  [6402] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6404] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6406] = {.count = 1, .reusable = true}, SHIFT(690),
  [6408] = {.count = 1, .reusable = true}, SHIFT(1520),
  [6410] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [6412] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(775),
  [6415] = {.count = 1, .reusable = true}, SHIFT(1732),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2443),
  [6419] = {.count = 1, .reusable = false}, SHIFT(2669),
  [6421] = {.count = 1, .reusable = false}, SHIFT(3035),
  [6423] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [6425] = {.count = 1, .reusable = true}, SHIFT(695),
  [6427] = {.count = 1, .reusable = true}, SHIFT(1087),
  [6429] = {.count = 1, .reusable = true}, SHIFT(688),
  [6431] = {.count = 1, .reusable = true}, SHIFT(3036),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2233),
  [6435] = {.count = 1, .reusable = true}, SHIFT(3041),
  [6437] = {.count = 1, .reusable = true}, SHIFT(426),
  [6439] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(798),
  [6442] = {.count = 1, .reusable = true}, SHIFT(1565),
  [6444] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6446] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [6448] = {.count = 1, .reusable = true}, SHIFT(1088),
  [6450] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1301),
  [6453] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [6455] = {.count = 1, .reusable = true}, SHIFT(1046),
  [6457] = {.count = 1, .reusable = true}, SHIFT(188),
  [6459] = {.count = 1, .reusable = true}, SHIFT(578),
  [6461] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [6463] = {.count = 1, .reusable = true}, SHIFT(13),
  [6465] = {.count = 1, .reusable = true}, SHIFT(167),
  [6467] = {.count = 1, .reusable = true}, SHIFT(44),
  [6469] = {.count = 1, .reusable = true}, SHIFT(2290),
  [6471] = {.count = 1, .reusable = true}, SHIFT(589),
  [6473] = {.count = 1, .reusable = true}, SHIFT(1513),
  [6475] = {.count = 1, .reusable = true}, SHIFT(31),
  [6477] = {.count = 1, .reusable = true}, SHIFT(1816),
  [6479] = {.count = 1, .reusable = false}, SHIFT(2177),
  [6481] = {.count = 1, .reusable = true}, SHIFT(476),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6485] = {.count = 1, .reusable = true}, SHIFT(2209),
  [6487] = {.count = 1, .reusable = true}, SHIFT(3206),
  [6489] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 137),
  [6491] = {.count = 1, .reusable = true}, SHIFT(2246),
  [6493] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2262),
  [6497] = {.count = 1, .reusable = true}, SHIFT(3109),
  [6499] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 41),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2248),
  [6503] = {.count = 1, .reusable = true}, SHIFT(3203),
  [6505] = {.count = 1, .reusable = true}, SHIFT(1818),
  [6507] = {.count = 1, .reusable = true}, SHIFT(1152),
  [6509] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 70),
  [6511] = {.count = 1, .reusable = true}, SHIFT(523),
  [6513] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 116),
  [6515] = {.count = 1, .reusable = true}, SHIFT(2669),
  [6517] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 114),
  [6519] = {.count = 1, .reusable = true}, SHIFT(1917),
  [6521] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 77),
  [6523] = {.count = 1, .reusable = true}, SHIFT(527),
  [6525] = {.count = 1, .reusable = true}, SHIFT(565),
  [6527] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 73),
  [6529] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 109),
  [6531] = {.count = 1, .reusable = true}, SHIFT(2173),
  [6533] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [6535] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6537] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 87),
  [6539] = {.count = 1, .reusable = true}, SHIFT(605),
  [6541] = {.count = 1, .reusable = true}, SHIFT(604),
  [6543] = {.count = 1, .reusable = true}, SHIFT(221),
  [6545] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 87),
  [6547] = {.count = 1, .reusable = true}, SHIFT(1659),
  [6549] = {.count = 1, .reusable = true}, SHIFT(555),
  [6551] = {.count = 1, .reusable = true}, SHIFT(1895),
  [6553] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6555] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 41),
  [6557] = {.count = 1, .reusable = true}, SHIFT(228),
  [6559] = {.count = 1, .reusable = true}, SHIFT(843),
  [6561] = {.count = 1, .reusable = false}, SHIFT(1408),
  [6563] = {.count = 1, .reusable = true}, SHIFT(904),
  [6565] = {.count = 1, .reusable = true}, SHIFT(422),
  [6567] = {.count = 1, .reusable = true}, SHIFT(1126),
  [6569] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6571] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6573] = {.count = 1, .reusable = true}, SHIFT(907),
  [6575] = {.count = 1, .reusable = true}, SHIFT(2395),
  [6577] = {.count = 1, .reusable = true}, SHIFT(223),
  [6579] = {.count = 1, .reusable = true}, SHIFT(207),
  [6581] = {.count = 1, .reusable = false}, SHIFT(3094),
  [6583] = {.count = 1, .reusable = true}, SHIFT(714),
  [6585] = {.count = 1, .reusable = true}, SHIFT(1149),
  [6587] = {.count = 1, .reusable = true}, SHIFT(736),
  [6589] = {.count = 1, .reusable = true}, SHIFT(1587),
  [6591] = {.count = 1, .reusable = true}, SHIFT(896),
  [6593] = {.count = 1, .reusable = true}, SHIFT(473),
  [6595] = {.count = 1, .reusable = true}, SHIFT(1507),
  [6597] = {.count = 1, .reusable = true}, SHIFT(890),
  [6599] = {.count = 1, .reusable = true}, SHIFT(785),
  [6601] = {.count = 1, .reusable = true}, SHIFT(780),
  [6603] = {.count = 1, .reusable = true}, SHIFT(213),
  [6605] = {.count = 1, .reusable = true}, SHIFT(191),
  [6607] = {.count = 1, .reusable = true}, SHIFT(674),
  [6609] = {.count = 1, .reusable = true}, SHIFT(219),
  [6611] = {.count = 1, .reusable = true}, SHIFT(222),
  [6613] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6615] = {.count = 1, .reusable = true}, SHIFT(2431),
  [6617] = {.count = 1, .reusable = true}, SHIFT(1655),
  [6619] = {.count = 1, .reusable = true}, SHIFT(430),
  [6621] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6623] = {.count = 1, .reusable = true}, SHIFT(2470),
  [6625] = {.count = 1, .reusable = true}, SHIFT(888),
  [6627] = {.count = 1, .reusable = true}, SHIFT(10),
  [6629] = {.count = 1, .reusable = true}, SHIFT(855),
  [6631] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6633] = {.count = 1, .reusable = true}, SHIFT(2365),
  [6635] = {.count = 1, .reusable = true}, SHIFT(717),
  [6637] = {.count = 1, .reusable = true}, SHIFT(205),
  [6639] = {.count = 1, .reusable = true}, SHIFT(786),
  [6641] = {.count = 1, .reusable = true}, SHIFT(902),
  [6643] = {.count = 1, .reusable = true}, SHIFT(1529),
  [6645] = {.count = 1, .reusable = true}, SHIFT(189),
  [6647] = {.count = 1, .reusable = true}, SHIFT(190),
  [6649] = {.count = 1, .reusable = true}, SHIFT(192),
  [6651] = {.count = 1, .reusable = true}, SHIFT(193),
  [6653] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [6655] = {.count = 1, .reusable = true}, SHIFT(2619),
  [6657] = {.count = 1, .reusable = true}, SHIFT(3035),
  [6659] = {.count = 1, .reusable = true}, SHIFT(813),
  [6661] = {.count = 1, .reusable = true}, SHIFT(255),
  [6663] = {.count = 1, .reusable = true}, SHIFT(1167),
  [6665] = {.count = 1, .reusable = true}, SHIFT(2225),
  [6667] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 77),
  [6669] = {.count = 1, .reusable = false}, SHIFT(3096),
  [6671] = {.count = 1, .reusable = true}, SHIFT(846),
  [6673] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [6675] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 77),
  [6677] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [6679] = {.count = 1, .reusable = true}, SHIFT(724),
  [6681] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6683] = {.count = 1, .reusable = true}, SHIFT(1525),
  [6685] = {.count = 1, .reusable = true}, SHIFT(3191),
  [6687] = {.count = 1, .reusable = true}, SHIFT(1650),
  [6689] = {.count = 1, .reusable = true}, SHIFT(1998),
  [6691] = {.count = 1, .reusable = true}, SHIFT(3100),
  [6693] = {.count = 1, .reusable = true}, SHIFT(812),
  [6695] = {.count = 1, .reusable = true}, SHIFT(910),
  [6697] = {.count = 1, .reusable = true}, SHIFT(2332),
  [6699] = {.count = 1, .reusable = true}, SHIFT(2374),
  [6701] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [6703] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6705] = {.count = 1, .reusable = true}, SHIFT(1934),
  [6707] = {.count = 1, .reusable = true}, SHIFT(733),
  [6709] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6711] = {.count = 1, .reusable = true}, SHIFT(3040),
  [6713] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6715] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6717] = {.count = 1, .reusable = true}, SHIFT(1490),
  [6719] = {.count = 1, .reusable = true}, SHIFT(1156),
  [6721] = {.count = 1, .reusable = true}, SHIFT(226),
  [6723] = {.count = 1, .reusable = true}, SHIFT(675),
  [6725] = {.count = 1, .reusable = true}, SHIFT(810),
  [6727] = {.count = 1, .reusable = true}, SHIFT(798),
  [6729] = {.count = 1, .reusable = true}, SHIFT(927),
  [6731] = {.count = 1, .reusable = true}, SHIFT(1661),
  [6733] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6735] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6737] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6739] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6741] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6743] = {.count = 1, .reusable = true}, SHIFT(3174),
  [6745] = {.count = 1, .reusable = true}, SHIFT(725),
  [6747] = {.count = 1, .reusable = true}, SHIFT(1922),
  [6749] = {.count = 1, .reusable = false}, SHIFT(1459),
  [6751] = {.count = 1, .reusable = true}, SHIFT(1751),
  [6753] = {.count = 1, .reusable = false}, SHIFT(1538),
  [6755] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6757] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6759] = {.count = 1, .reusable = false}, SHIFT(1185),
  [6761] = {.count = 1, .reusable = true}, SHIFT(772),
  [6763] = {.count = 1, .reusable = true}, SHIFT(718),
  [6765] = {.count = 1, .reusable = true}, SHIFT(2904),
  [6767] = {.count = 1, .reusable = true}, SHIFT(865),
  [6769] = {.count = 1, .reusable = true}, SHIFT(231),
  [6771] = {.count = 1, .reusable = true}, SHIFT(232),
  [6773] = {.count = 1, .reusable = true}, SHIFT(234),
  [6775] = {.count = 1, .reusable = true}, SHIFT(2232),
  [6777] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6779] = {.count = 1, .reusable = true}, SHIFT(179),
  [6781] = {.count = 1, .reusable = true}, SHIFT(229),
  [6783] = {.count = 1, .reusable = true}, SHIFT(215),
  [6785] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6787] = {.count = 1, .reusable = true}, SHIFT(1034),
  [6789] = {.count = 1, .reusable = true}, SHIFT(749),
  [6791] = {.count = 1, .reusable = true}, SHIFT(1996),
  [6793] = {.count = 1, .reusable = true}, SHIFT(662),
  [6795] = {.count = 1, .reusable = true}, SHIFT(1980),
  [6797] = {.count = 1, .reusable = true}, SHIFT(1747),
  [6799] = {.count = 1, .reusable = true}, SHIFT(710),
  [6801] = {.count = 1, .reusable = true}, SHIFT(3103),
  [6803] = {.count = 1, .reusable = true}, SHIFT(2612),
  [6805] = {.count = 1, .reusable = true}, SHIFT(752),
  [6807] = {.count = 1, .reusable = true}, SHIFT(134),
  [6809] = {.count = 1, .reusable = true}, SHIFT(773),
  [6811] = {.count = 1, .reusable = true}, SHIFT(3166),
  [6813] = {.count = 1, .reusable = true}, SHIFT(3190),
  [6815] = {.count = 1, .reusable = true}, SHIFT(1860),
  [6817] = {.count = 1, .reusable = true}, SHIFT(3085),
  [6819] = {.count = 1, .reusable = true}, SHIFT(805),
  [6821] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 77),
  [6823] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6825] = {.count = 1, .reusable = true}, SHIFT(758),
  [6827] = {.count = 1, .reusable = true}, SHIFT(759),
  [6829] = {.count = 1, .reusable = true}, SHIFT(1097),
  [6831] = {.count = 1, .reusable = true}, SHIFT(760),
  [6833] = {.count = 1, .reusable = true}, SHIFT(620),
  [6835] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6837] = {.count = 1, .reusable = true}, SHIFT(795),
  [6839] = {.count = 1, .reusable = true}, SHIFT(1619),
  [6841] = {.count = 1, .reusable = true}, SHIFT(822),
  [6843] = {.count = 1, .reusable = true}, SHIFT(1695),
  [6845] = {.count = 1, .reusable = true}, SHIFT(1050),
  [6847] = {.count = 1, .reusable = true}, SHIFT(889),
  [6849] = {.count = 1, .reusable = true}, SHIFT(252),
  [6851] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6853] = {.count = 1, .reusable = true}, SHIFT(792),
  [6855] = {.count = 1, .reusable = true}, SHIFT(1517),
  [6857] = {.count = 1, .reusable = true}, SHIFT(1988),
  [6859] = {.count = 1, .reusable = true}, SHIFT(1419),
  [6861] = {.count = 1, .reusable = true}, SHIFT(775),
  [6863] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [6865] = {.count = 1, .reusable = true}, SHIFT(2908),
  [6867] = {.count = 1, .reusable = true}, SHIFT(2096),
  [6869] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6871] = {.count = 1, .reusable = true}, SHIFT(1908),
  [6873] = {.count = 1, .reusable = true}, SHIFT(774),
  [6875] = {.count = 1, .reusable = true}, SHIFT(906),
  [6877] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6879] = {.count = 1, .reusable = true}, SHIFT(702),
  [6881] = {.count = 1, .reusable = true}, SHIFT(740),
  [6883] = {.count = 1, .reusable = true}, SHIFT(405),
  [6885] = {.count = 1, .reusable = true}, SHIFT(403),
  [6887] = {.count = 1, .reusable = true}, SHIFT(793),
  [6889] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6891] = {.count = 1, .reusable = true}, SHIFT(2012),
  [6893] = {.count = 1, .reusable = true}, SHIFT(811),
  [6895] = {.count = 1, .reusable = true}, SHIFT(242),
  [6897] = {.count = 1, .reusable = true}, SHIFT(1082),
  [6899] = {.count = 1, .reusable = true}, SHIFT(1084),
  [6901] = {.count = 1, .reusable = true}, SHIFT(767),
  [6903] = {.count = 1, .reusable = true}, SHIFT(872),
  [6905] = {.count = 1, .reusable = true}, SHIFT(771),
  [6907] = {.count = 1, .reusable = true}, SHIFT(1690),
  [6909] = {.count = 1, .reusable = true}, SHIFT(1567),
  [6911] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6913] = {.count = 1, .reusable = true}, SHIFT(768),
  [6915] = {.count = 1, .reusable = true}, SHIFT(873),
  [6917] = {.count = 1, .reusable = true}, SHIFT(769),
  [6919] = {.count = 1, .reusable = true}, SHIFT(3046),
  [6921] = {.count = 1, .reusable = true}, SHIFT(2002),
  [6923] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6925] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6927] = {.count = 1, .reusable = true}, SHIFT(2061),
  [6929] = {.count = 1, .reusable = true}, SHIFT(2590),
  [6931] = {.count = 1, .reusable = true}, SHIFT(3114),
  [6933] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6935] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [6937] = {.count = 1, .reusable = false}, SHIFT(3099),
  [6939] = {.count = 1, .reusable = true}, SHIFT(849),
  [6941] = {.count = 1, .reusable = true}, SHIFT(895),
  [6943] = {.count = 1, .reusable = true}, SHIFT(2255),
  [6945] = {.count = 1, .reusable = true}, SHIFT(856),
  [6947] = {.count = 1, .reusable = true}, SHIFT(905),
  [6949] = {.count = 1, .reusable = true}, SHIFT(2389),
  [6951] = {.count = 1, .reusable = true}, SHIFT(899),
  [6953] = {.count = 1, .reusable = true}, SHIFT(914),
  [6955] = {.count = 1, .reusable = true}, SHIFT(1608),
};

void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
  };
  return &language;
}
